#
# This directory contains data files needed for Ifeffit to work well.
#
# directories and files contained here are:
#
# startup.iff   ifeffit startup file, loaded upon initialization.
#               this is an ideal to put site-wide macro definitions
#
# config/       files describing the ifeffit build, especially useful
#               for building extensions to ifeffit after installation.
#
# cldata/       data file needed for the f1f2() calculations of the 
#               anomalous scattering coefficients based on the work of
#               Cromer-Libermann.

Welcome to IFEFFIT:  Interactive XAFS Analysis Library
Copyright (c) 2000-2003 Matt Newville, The University of Chicago

Ifeffit is free software. The majority of the software here is
distributed under a BSD-like license. Some of the code in this
distribution is distributed under the GNU Public License (GPL).  
See the file COPYING for details.

Overview
--------
Ifeffit provides a nearly-complete library of algorithms for XAFS
Analysis, and a simple-to-use interface to that library.  The library
builds on the Autobk and Feffit programs from the UWXAFS Package, and
adds considerable flexibility, graphics, and a command-based interface.
The library is designed to work inside other programming and scripting
languages, so that more complex programs (including GUIs) can be built
with the library.

More information about Ifeffit can be found at:
  http://cars9.uchicago.edu/ifeffit/

Installation
------------
Complete installation instructions are in the INSTALL file.

Ifeffit requires a working Fortran77 compiler.  If you're using a very old
linux system, there is a chance that the fortran compiler supplied with
your system is broken and needs to be re-installed.  I recommend using
gcc with the built-in g77 compiler or later.

Documentation
-------------
The documentation should be taken from the Ifeffit web site.  The latex
source for the Ifeffit reference manual and tutorial are included under 
the doc/ directory tree, but it is not expected that these source files 
can be converted into usable forms on all systems. 

If you're interested in contributing to the Ifeffit documentation,
contact the authors.

Contributing
------------
Ifeffit works well, but may have some bugs.  There is still plenty of work
to be done on improving the algorithms, fixing the documentation, and
making the system as user-friendly as possible.

Please keep these thoughts in mind when using Ifeffit, and let us know
what you think should be added, what is broken, and what is unclear.
Chances are if you can think of an improvement, it would help other
people too.

If you are interested in contributing, please let us know. There's a lot of
work that can be done on the core algorithms, the documentation, wrappers,
and examples.  If you know Perl or Python (or are willing to learn), there
is a wide range of work to do in implementing GUIs and other wrappers in
these languages.   If you know VisualBasic, AppleScript, or any other
language and are interested in building extensions for these languages, 
please let us know how we can help you do this. 

If you prefer to contribute in some other way contact us.

Additional Information
----------------------
More information can be found at the ifeffit web site
 http://cars9.uchicago.edu/ifeffit/

Thanks,

Matt Newville <newville@cars.uchicago.edu>
Consortium for Advanced Radiation Sources
University of Chicago
Chicago, IL

Last update Aug-25-2003

Wrappers to Ifeffit for Perl, Python, and Tcl
---------------------------------------------

For each language, the wrapper made here will give you access directly to
Ifeffit from within the scripting language itself.  This merges the power
of the scripting language and the functionality of Ifeffit.  From the
scripting language point-of-view, this is called an _extension_ to the
language.  From Ifeffit's point-of-view, this is called a _wrapper_. 

Building and Installation instructions are given in the README file
in each subdirectory. 

To build each wrapper, you will need a working installation of that
language.  The latest versions of these languages, and a wealth of 
information about them can be found at:
  Perl:     http://www.perl.com/
  Python:   http://www.python.org/
  Tcl:      http://www.scriptics.com/

For Perl, you'll need version 5.0003 or higher, and version 5.6 or higher
is recommended.  For Python, you'll need version 1.5.2 or higher, and
version 2.1 or higher is recommended. For Tcl, you'll need version 8.0 or
higher.

You will also need a working installation of Ifeffit.  That is, the Ifeffit
library __Must Be Installed__ before these wrappers can be built.

On some systems (notably linux), there are some problems with pre-built
fortran installations, especially when trying to make shared-objects, as
needs to be done for the extensions made here.   If you have problems, 
please consult the Fortran.Notes file in this directory.

Perl Notes
----------

Perl 5.6 made a substantial change from Perl 5.5 (aka 5.005) in how
extensions are made.  Because of this, the internal parts of the Ifeffit
perl wrapper are different for perl 5.6 (and later) and 5.5 (and earlier).

If you have perl 5.6 or 5.8 (as is recommended), follow the instructions 
in wrappers/perl.  For perl 5.003 to 5.5, follow the instructions in 
wrappers/perl_old.  

Note: The way programs USE Ifeffit.pm is not affected by this change!!

If you don't know which version of perl you have, type 'perl -v'.



Matt Newville <newville@cars.uchicago.edu>

This directory contains OLD build instructions for ifeffit on Mac OS X.

For most Mac OS X users, a binary installer is available. For OS X 10.2 and
higher, the main source build system will work, as long as the
prerequisites liare installed.

Prerequsites:
-------------
Getting ifeffit to run on MacOS X relies heavily on the Fink Project:
   http://fink.sourceforge.net/

You will need to download the Fink base system and some of its
Unix-like extensions.  The following 'Fink packages' are needed:

 pgplot f2c g77 readline xfree86-base xfree86-rootless

(I think this is a complete list, but please let me know if I'm
missing any).  'xfree86-server' can be used instead of '-rootless',
but will not let you run XDarwin and Aqua at the same time.  Fink
strongly encourages you to install everything under the '/sw'
directory.

You will also need to install the 'Developer Tools' from the MacOS
X 'Developer Disk'.

Configuration and Build:
------------------------

Again, this is of historical interest only.

Type './configure ; make'.

This simplified version of configure takes the following options:

   --prefix=PREFIX            base directory for installation 
   --arraysize=ARRAYSIZE      tiny,small,medium,large,huge    
   --pgplot_dir=PGPLOT_DIR    directory for PGPLOT            
   --xlibs=XLIBS              link directive for X            

Type './configure --help' to get a listing of the default values (as 
these will change depending on the system).

If you installed Fink to somewhere other than '/sw', you may need to 
set '--prefix=...'.  

You may need to edit some of the top few lines of the Makefile.  

If you have troubles in this 'make' step, you might want to check 
that the file '../lib/sys.h'  exists.



Installation:
-------------
Type 'sudo make install'.

Building Extensions:
--------------------
If python is installed (say, through Fink), then the python extension
can be built as:

   cd ../../wrappers/python
   sudo python setup.py install

This should be done after Ifeffit has been installed.  This will also
install the program gifeffit.


If perl is installed, the perl extension can be built as:
   cd ../../wrappers/perl
   perl Makefile.PL
   sudo make install

If perl/Tk is installed, this should abuild and install the athena program 
as well as the perl extension. 

Last update:  16-Dec-2002 MN

This is the Perl interface to the Ifeffit library.

To build and install this interface: 

 1. build and INSTALL the ifeffit library.  That is, the
    ifeffit library must be installed in its final resting 
    place for the perl extension to work properly.
   
    If you're building this from the standard distribution, a 
    Makefile.PL file should already be in this directory.  If 
    not (or if you are building this from the stand-alone perl
    distribution after the Ifeffit library has been installed)
    copy the Makefile.PL from the ifeffit directory:
     
     ~> cp /usr/local/share/ifeffit/Makefile.PL .
   
    (the exact location may be different, depending on how
     ifeffit was built and installed).

 2. build the Perl interface by typing 
     ~> perl Makefile.PL
     ~> make
  
    The Makefile.PL file should properly reflect your Ifeffit 
    installation, and should not require any tweaking.  If this 
    compilation fails, ask a local Perl expert or send email.

 3. test the Perl extension:
     ~> make test

    If the test fails (you'll see a bunch cryptic error messages), 
    first check the 'Fortran.Notes' in the main wrapper directory.  
    If that doesn't help, please let me know.

 4. install the perl extension:
     ~> make install
 
    You'll need write permissions to the normal Perl library, 
    which probably means you'll need to be root.

 5. The file 'ifeffit_shell.pl' is a friendly command-line interface 
    to the ifeffit library.  If the Perl Readline Module has been 
    installed, then command history and tab completion should work. 
    (If in doubt, install the GNU version of the Readline module). 
    
    You may want to install this file as 'ifeffit' somewhere in your 
    path to use instead of the standard, less-featured C version.  You
    may also want to copy (and possibly edit) the two 'run-time
    configuration' files: 
      ~> cp dot.ifeffitrc        $HOME/.ifeffitrc
      ~> cp dot.ifeffit_macros   $HOME/.ifeffit_macros

    Documentation for the Perl Module can be found by typing 
      ~> perldoc Ifeffit
    
    additional documentation about the command-line program can be 
    found by typing 'help' at the command prompt.


Matt Newville <newville@cars.uchicago.edu>

This is the Python interface to the Ifeffit library.  It assumes
that you have python 1.5.2 (or later) installed on your system.

Installation instructions:

 Type 'python setup.py install' as root.

Detailed Instructions:

 1. build and INSTALL the ifeffit library.  The ifeffit library
    must be installed for the python extension to work properly. 

    If you're building this from the standard distribution, a
    site_install.py file should already be in this directory.  
 
    If not (or if you are building this after the Ifeffit library 
    has been installed) copy this files from the ifeffit directory: 
       cp /usr/local/share/ifeffit/config/site_install.py .
   
    (the exact location may be different, depending on how
     ifeffit was built and installed).
   
    Normally, you should not need to alter site_install.py, but 
    if you run into trouble, you may want to look at this file
    for hints of how it thinks Ifeffit is installed on your system.

 2. type 'python setup.py build'
    this will build the python extension for your system.  

 3. type 'python setup.py install' (do this as root) to install.

 4. If python has been installed with Tkinter capabilities (see notes
    on installing python), then gifeffit, the graphical user interface
    will be installed with the above installation.  Since gifeffit
    requires the additional Pmw widgets, these will also be installed 
    if needed.

Matt Newville <newville@cars.uchicago.edu>

======================================
==  ifeffit command-line executable ==
======================================

The files in this directory create the executable program ifeffit, the
primary command shell to the Ifeffit library.  This program uses the GNU
ReadLine package, so that command editing is quite good, with the arrow
keys working to scroll through previous commands, tab completion (hitting
the tab key tries to complete partially typed words), and emacs bindings
for moving around the command line, including:
   Control-a   move to beginning of line
   Control-e   move to end-of-line
   Control-k   cut line from cursor to end-of-line to 'buffer'
   Control-y   paste buffer at cursor position.

To start the program, type 'ifeffit'.  You'll get a command prompt at which
you can type ifeffit commands.  A limited number of Unix shell commands
(ls, more, cd, pwd) are also supported, and '!' can be used to escape to
the Unix shell.

For the first word on a command line, tab-completion will expand a limited
number of commands (ifeffit as well as shell commands).  Type 'help' at the
command prompt for a complete list of commands that will complete.  Hitting
tab on the second word will complete a file in the current directory.

== Startup file ==

If found, ifeffit will load a file called  .ifeffit in your home directory
on startup.  This is simply an ifeffit command file allowing pre-defined
macros and customization, as if you had typed  
  load '/home/.../.ifeffit'
 
each time you launched the program.

== History file ==

ifeffit will save the command you type to the file .ifeffit_hist in your
home directory.  This file will be loaded on startup, so that the up-arrow
will go through your previous ifeffit session.  The history file is limited
to 500 lines, and is written when you type 'exit' or 'quit'.  If you exit
the program with Control-d, the session will not be saved.


== Command line Options ==

A list of ifeffit command files can be loaded by listing them on the
command line.   For example,

 > ifeffit File1.iff File2.iff

will load File1.iff and then File2.iff before giving the command prompt.
The startup file (if found) will be loaded before any files listed on the
command-line, so macros and definitions in your startup file can be used.

To run files in 'batch mode' so that you immediately exit back to the Unix
shell, use the -x switch:
 > ifeffit -x File1.iff File2.iff

This will load File1.iff and then File2.iff and exit.

The loading of command-line files is not saved to the history file.


======================================

--Matt Newville <newville@cars.uchicago.edu>

This is the Tcl interface to the Ifeffit library.

To build and install this interface: 

 1. build and INSTALL the ifeffit library.  That is, the
    ifeffit library must be installed in its final resting 
    place for the tcl extension to work properly.

    If you're building this from the standard distribution, a 
    TclSetup.in file should already be in this directory.  If 
    not (or if you are building this from the stand-alone perl
    distribution after the Ifeffit library has been installed)
    copy the TclSetup.in from the ifeffit directory:
     
     ~> cp /usr/local/share/ifeffit/TclSetup.in .
   
    (the exact location may be different, depending on how
     ifeffit was built and installed).


 2. type 'sh Build'.  
    this will simply do 
      ~> cat TclSetup.in Makefile.in > Makefile
      ~> make

    If this fails, you may want to edit the Makefile to properly 
    reflect your system's setup.

 3. test the Tcl extension:
     ~> tcl test.tcl

    If the test fails (you'll see a bunch cryptic error messages), 
    first check the 'Fortran.Notes' in the main wrapper directory.  
    If that doesn't help, please let me know.

 4. I do not know enough about tcl to know how to properly install
    a third-party extension in 'the standard way'.  If you do, please
    let me know.

Matt Newville <newville@cars.uchicago.edu>

# pstopng:   
# using pstoimg from latex2html
# and netpbm 9.12

/usr/local/bin/pstoimg -type png -crop abls -white -out _tmp_x.png $1.ps 
pngtopnm _tmp_x.png > _tmp_x.pnm
pnmrotate -90 _tmp_x.pnm  > _tmp_y.pnm
pnmtopng _tmp_y.pnm > $1.png
rm _tmp_*


pstopng  plot_arrows

IFEFFIT Examples

This directory contains some simple examples of using Ifeffit for
general data analysis and especially XAFS analysis.  The examples
are organized by category and complexity, and broken into small
ifeffit scripts (all with an extension '.iff') each of which can
be run individually from the system command-line as

  ~> ifeffit help.iff

or from within the Ifeffit environment as

  ~> ifeffit

  Ifeffit> load help.iff
  
Each script contains some documentation of its own.  A brief 
description of the scripts follows:
 
  help.iff  
     Print information about these examples, test that Ifeffit
     loads, runs, and can print to the screen.

  Anomalous/calc_f1f2.iff
     calculate f' and f'' for Cu, using energy points from an
     external data file 

  Lytle/Lytle.iff
     read datafile downloaded from Farrel Lytle database, convert 
     motor steps to energy, and plot XAFS.

  Plotting/text-strings.iff
     use of text strings in plotting, especially commonly used
     greek-character constructs for XAFS spectra.

  Pre_Edge/pre.iff
     simple example of pre-edge subtraction of XAFS spectra
 
  Spline/autobk.iff
    simple example of autobk-like background subtraction of XAFS spectra

  Macros
    This directory contains several useful little macros

     Macros.iff  collection of generally useful macros, most of 
                 them reasonably well annotated
     quit.iff    simple little macro to allow 'q' to mean 'quit'
  

DO.iff
M1.if

W.iff
ave.xmu
iff.out
tmp.iff
xafs.dat


  Data_Processing
GG.xmu
a.dat
a.xmu
b.chi
cu.chi
cu10k.dat
ifeffit.sav
interpolote.iff
sro.chi
tmp.dat
write_exa.iff
x.sav
xmu.dat
y.sav

   FF2CHI/
A-ff2chi.iff
B-x.inp
B-x.log
B-x.prm
B.iff
Debye.iff
F-fit.inp
Feffit.iff
G.iff
H.iff
a.inp
cu_chi.dat
feffcu03.dat
my_feffit.log
save_reff.iff
test.iff
test2.iff
test_terp.iff
tmp_out.log


Minimize:
Do_fits.pl
amps.dat
centers.dat
fit_xrd.iff
noise.dat
sigmas.dat
test.dat
xrd.dat
xrd.dat.fit

#
# This shows a simple example of running the diffkk program.
# 
# The input file is diffkk.inp.
# Outputs are written to  
#    test.out     ascii column
#    diffkk.log   summary
#    diffkk.sav   ifeffit save file of all input, output, work arrays
#

       subroutine iff_chieps(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c given a chi(k) spectrum, estimate it's uncertainty
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fft.h'
       save
     
       character*(*) str
       character*256  name1, chiarr, xk_arr, winarr, winnam, defkey(2)
       character      tmppre*24, cmdstr*256
       parameter (tmppre='for0internal0use0only000')
       integer  nsig1, jchi, jwin, ndfkey, jdot
       integer  istrln, k, i, ier
       integer  get_array
       logical  lpre
       double precision xkmin, xkmax, xkw, rwgt1, rwgt2, xsigr, xsigk
       double precision arr_w(maxpts), arr_c(maxpts), arr_k(maxpts)
       double precision dmarr(maxpts), xk, t
       double precision dk1, dk2, getsca, sumsqr, wtmp
       integer npts_w, npts_c, npts_k, jxar, iff_eval, iff_eval_dp
       external istrln, sumsqr, getsca, iff_eval, iff_eval_dp
       external get_array

       rwgt1  = 15.d0
       rwgt2  = 25.d0
       xkmin  = getsca('kmin',1)
       xkmax  = getsca('kmax',1)
       xkw    = getsca('kweight',1)
       dk1    = getsca('dk1',1)
       dk2    = getsca('dk2',1)
       name1  = undef
       call gettxt('kwindow', winnam)
       call gettxt('altwindow',winarr)
       call bkeys(str, mkeys, keys, values, nkeys)
       ndfkey    = 1
       defkey(1) = 'chi'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then 
             name1 = values(i)
             call lower(name1)
          elseif ((keys(i).eq.'rwgt1')) then
             ier = iff_eval_dp(values(i), rwgt1)
          elseif ((keys(i).eq.'rwgt2')) then
             ier = iff_eval_dp(values(i), rwgt2)
          elseif ((keys(i).eq.'kmax')) then
             ier = iff_eval_dp(values(i), xkmax)
          elseif ((keys(i).eq.'kmin')) then
             ier = iff_eval_dp(values(i), xkmin)
          elseif (keys(i).eq.'kwindow') then
             winnam = values(i)
             call lower(winnam)
          elseif (keys(i).eq.'altwindow') then
             winarr = values(i)
             call lower(winarr)
          elseif (keys(i).eq.'kweight') then
             ier = iff_eval_dp(values(i),xkw)
          elseif (keys(i).eq.'dk1') then
             ier = iff_eval_dp(values(i),dk1)
          elseif (keys(i).eq.'dk2') then
             ier = iff_eval_dp(values(i),dk2)
          elseif (keys(i).eq.'dk') then
             ier = iff_eval_dp(values(i),dk2)
             dk1 = dk2
          elseif (keys(i).eq.'chi') then
             chiarr = values(i)
             call lower(chiarr)
          elseif (keys(i).eq.'k') then
             xk_arr = values(i)
             call lower(xk_arr)
          else
             call warn(1,
     $            ' *** chi_noise: unknown key: '//keys(i)(1:k))
          end if
 100   continue 
c
c get/resolve chi(k) array name
c    check that name1 exists.  
c    otherwise, get it from chiarr, if available
c    otherwise, give up.
       if (name1.eq.undef) then
          jdot = index(xk_arr,'.')
          if (jdot.ne.0) name1 = xk_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(chiarr,'.')
          if (jdot.ne.0) name1 = chiarr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' chi_noise: can''t determine group name')
          return             
       endif
       call fixnam(name1,1)
       call lower(name1)

       jxar  = iff_eval(xk_arr, name1, arr_k, npts_k)
       jchi  = iff_eval(chiarr, name1, arr_c, npts_c)
       jwin  = iff_eval(winarr, name1, arr_w, npts_w)
cc       print*, ' chi_noise: ', jxar, jchi, jwin

c if the x-array has been given, the real/imag/window data should 
c be re-interpolated onto an even x-grid starting at x=0.
       if (jxar.ge.1) then
          if (jchi.ge.1)
     $         call zgrid_array(arr_k, npts_k, arr_c, npts_c, qgrid)
          if (jwin.ge.1)
     $         call zgrid_array(arr_k, npts_k, arr_w, npts_w, qgrid)
       endif

       if (jchi.le.0) then
          call warn(2, ' chi_noise: no chi(k) data array?')
          return
       end if
c
c get window function if it wasn't alreary specified
       if (jwin.le.0) then
          do 350 i = 1, maxpts
             arr_w(i) = zero
 350      continue
          call window(winnam,dk1,dk2,xkmin,xkmax,qgrid,maxpts,arr_w)
       end if
c
c estimate of measurement uncertainty for fit:
c    assuming the measurement uncertainty to be white noise, and
c    that the signal dies off appreciably at reasonably large r,
c    the noise is given by the high r components of the signal. 
c    sigdtr is estimated as the rms part of the signal at high r. 
c    we most need the noise in the real and/or imaginary parts
c    of chi(r). the temp array below contains both real and 
c    imaginary parts, so its rms is too big by the sqrt(2). 
c

       do 400 i = 1, maxpts
          dmarr(i) = zero
 400   continue 

       call fitfft(arr_c, maxpts, maxfft, wfftc, qgrid,
     $      arr_w, xkw, dmarr, zero, 1, 0, rwgt1, rwgt2,
     $      nsig1,tmparr)

c  find sigma_k, the measurement uncertainty for the k-space data,
c  using the formula:
c
c                                 /      2 pi * w             \
c    (sigma_k)^2 = (sigma_r)^2 * | --------------------------  |
c                                 \ qgrid*( kmax^w - kmin^w)  /
c
c      where  w = (2 * kweight + 1).
c
       xsigr  = sqrt( sumsqr(tmparr, nsig1) / nsig1)
       wtmp   = 2 * xkw  + one
       xsigk  = xsigr * sqrt( 2 * pi * wtmp /
     $      (qgrid * (xkmax**wtmp - xkmin**wtmp )))

       call setsca('kmin',      xkmin)
       call setsca('kmax',      xkmax)
       call setsca('kweight',   xkw)
       call setsca('dk1',       dk1)
       call setsca('dk2',       dk2)
       call settxt('group',     name1)
       call setsca('epsilon_k', xsigk)
       call setsca('epsilon_r', xsigr)

cc
cc now, estimate kmax_suggest for data based on noise level.
cc 
cc this filters chi(k) using rmin=0,rmax=6, then sets kmax_suggest
cc to the largest k value for which | chi(q) | > epsilon_k
cc
cc data is stored temporarily in the group with prefix=tmppre
cc which is then erased.

       call set_array('chi', tmppre, arr_c,npts_c,1)
c fftf
       cmdstr  = 'real = '// tmppre//'.chi'
       call iff_fft('fftf',cmdstr)

c fftr       
       write(cmdstr,'(5a)')  'real = ', tmppre,
     $      '.chir_re,imag=',tmppre,'.chir_im,rmin=0,rmax=6'
       call iff_fft('fftr',cmdstr)
c get |chiq|       
       npts_c = get_array('chiq_mag',tmppre,0,arr_c)
       xkmax  = xkmin
       lpre   = .true.
       do 900 i = 1, npts_c
          xk = (i-1)*qgrid
          if (xk.ge.xkmin) then
             t = arr_c(i)/((tiny+xk)**xkw)
             if (t.ge.xsigk) then
                if (lpre) xkmax = xk
                lpre = .true.
             else
                lpre = .false.
             endif
          endif
 900   continue 
       call setsca('kmax_suggest', xkmax)

       cmdstr = '@group= '//tmppre
       call iff_erase(cmdstr)

       return
       end
c 

       subroutine setsys(system,vaxflg,dosflg,macflg,unxflg)
c simple way of setting flags, describing the operating system used.
c rather than setting all flags by hand, this uses a single string
c and ensures that only one flag is on
       character*(*) system, sys*3
       logical       vaxflg,dosflg,macflg,unxflg
       vaxflg = .false.
       unxflg = .false.
       dosflg = .false.
       macflg = .false.
       call triml(system)
       call smcase(system,'a')
       sys = system(:3)
       if ((sys.eq.'vax').or.(sys.eq.'vms')) then
          vaxflg = .true.
          system = sys
       elseif (sys.eq.'mac') then
          macflg = .true.
          system = sys
       elseif (sys.eq.'dos') then
          dosflg = .true.
          system = sys
       else
          system = 'unix'
          unxflg = .true.
       endif
       return
       end

       subroutine pgend 
       return
       end

       subroutine pgclos 
       return
       end

       integer function pgopen(i)
       integer i
       pgopen = 0
       return
       end

       subroutine  pgqid(i)
       integer i
       i = 0
       return
       end
c
       subroutine pgslct(i)
       integer i
       return
       end
c
       subroutine  pgbeg(i, file, j, k)
       integer i,j, k
       character*(*) file
       print*, ' pgplot not installed'
       return
       end
c
       subroutine pgqinf(type, arg, i)
       integer i
       character*(*) type, arg
       i = 0
       return
       end
c
       subroutine pgpage
       return
       end
c
       subroutine  pgbbuf 
       return
       end
c
       subroutine pgask(flag)
       logical flag
       return
       end
c
       subroutine pgeras
       return
       end
c
       subroutine pgsls(i)
       integer i
       return
       end
c
       subroutine pgsch(x)
       real x
       return
       end
c
       subroutine pgscf(i)
       integer i
       return
       end
c
       subroutine pgslw(i)
       integer i
       return
       end
c
       subroutine pgvstd
       return
       end
c
       subroutine pgpt1(x1,x2,i)
       real x1,x2
       integer i
       return
       end
c
       subroutine pgrnge(x1,x2,x3,x4)
       real x1,x2,x3,x4
       return
       end
c
       subroutine pgsci(i)
       integer i
       return
       end
c
       subroutine pgswin(x1,x2,x3,x4)
       real x1,x2,x3,x4
       return
       end
c
       subroutine pgbox(s1,x1,i1,s2,x2,i2)
       integer i1, i2
       character*(*) s1, s2
       real x1, x2
       return
       end
c
       subroutine pgmtxt(s1, x1, x2, x3, s2)
       character*(*) s1, s2
       real x1, x2, x3
       return
       end
c
       subroutine pgline(i1,x1,x2)
       integer i1
       real x1(*), x2(*)
       return
       end
c
       subroutine pgpt(i1,x1,x2,i2)
       integer i1, i2
       real x1(*), x2(*)
       return
       end
c
       subroutine pgtext(x1, x2, s1)
       character*(*) s1
       real x1, x2
       return
       end
c
       subroutine pgebuf
       return
       end
c
       subroutine pgscrn(i1,s1,i2)
       character*(*) s1
       integer i1, i2
       return
       end
c
       subroutine pgscr(i,r,g,b)
       integer i
       real r, g, b
       return
       end
c
       integer function pgcurs(x,y,c)
       real x,y
       character*(*) c
       pgcurs = 1
       x = 0
       y = 0
       c = 'a'
       return
       end
c      
       subroutine  pgsah(i,x,y)
       real x,y
       integer i
       return
       end
       subroutine  pgarro(x,y,u,v)
       real x,y,u,v
       return
       end

       integer function pgband(m,n,x1,y1,x,y,c)
       real x1,y1,x,y
       character*(*) c
       integer m,n
       pgband = 1
       x = x1
       y = y1
       c = 'a'
       m = 0
       return
       end
       
       subroutine pgqndt(i)
       integer i
       return
       end

       subroutine pgqdt(i,s1,i2,s2,i3,i4)
       integer i, i2, i3, i4
       character s1*(*), s2*(*)
       return
       end

       subroutine pgerry(n,x,y1,y2,t)
       integer i
       real x(*), y1(*), y2(*), t
       return
       end
       subroutine pgerrx(n,x,y1,y2,t)
       integer i
       real x(*), y1(*), y2(*), t
       return
       end

       subroutine iff_spline(str)
c
c purpose: ifeffit: xafs background removal -- driver for spline
c
c arguments:
c      key     command name to perform (spline)         [in]
c      str     command line to performd                 [in]
c
c notes:
c   1. driver for spline
c   2. if pre-edge appears to have not been done, it will be
c      done here
c
c requires: istrln, getsca, gettxt, setsca, settxt, bkeys,
c           echo, lower, str2dp, str2lg, spline, preedg
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'spline.h'
       save

       character*(*) str
       character*256 xmuarr, en_arr, name1, kstarr, cstarr, winnam*32
       character*256 bkgarr, ksparr, chiarr, outstr, tmps2
       double precision toler, xkmin, xkmax, xkw, dk1, dk2
       double precision pre1, pre2, enor1, enor2, getsca
       double precision xknots, splstf, de_min, cnorm(3), po, ps
       double precision arr_e(maxpts), arr_x(maxpts)
       double precision arr_cs(maxpts), arr_ks(maxpts)
       double precision a_bkg(maxpts), a_xk(maxpts), a_chi(maxpts)
       integer          npts_e, npts_x,  npts_ks, npts_cs, nnorm
       parameter (de_min=1.d-5)
       integer jen, jxmu,  ier, nknots, le, lx, l1, jdot, nclmp
       integer jbkg, jchi,  i, k, istrln, jksp, jcst, jkst
       logical fnorm, fixstd, do_std, vary_e0, do_pre, is_kev
       logical find_step, find_e0, do_spl
       logical           lclmp1, lclmp2
       double precision  xclmp1, xclmp2, r1stx
       character*64  defkey(3)
       integer       ndfkey, npts_k, iterp
       integer  iff_eval, iff_eval_dp, iff_eval_in, sort_xy
       external iff_eval, iff_eval_dp, iff_eval_in, sort_xy
       external  getsca, istrln
c
       call iff_sync
       
       lclmp1  = .false.
       lclmp2  = .false.
       nclmp   = 5
       iterp   = 2
       find_step = .true.
       vary_e0 = .true.
       find_e0 = .false.
       fnorm   = .false.
       fixstd  = .false.
       do_std  = .false.
       do_pre  = .true.
       do_spl  = .true.
       is_kev  = .false.
c      
c get default values for pre-edge parameters from current scalar values
       splstf = 1.d-4
cc       splstf = getsca('spl_stiff',1)
       e0    = getsca('e0',1)
       rbkg  = getsca('rbkg',1)
       r1stx = 2.d0
       toler = getsca('toler',1)
       xkmin = getsca('kmin_spl',1)
       xkmax = getsca('kmax_spl',1)
       xkw   = getsca('kweight_spl',1)
       dk1   = getsca('dk1_spl',1)
       dk2   = getsca('dk2_spl',1)
       pre1  = getsca('pre1',1)
       pre2  = getsca('pre2',1)
       enor1 = getsca('norm1',1)
       enor2 = getsca('norm2',1)
       nnorm = 3
       iprint = int(getsca('&print_level',0))

       winnam = ' '
       name1  = undef
       en_arr = undef
       xmuarr = undef
       kstarr = undef
       cstarr = undef
       call gettxt('kwindow',    winnam)
c
       xknots = zero
c
       call bkeys(str, mkeys, keys, values, nkeys)
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
       ndfkey    = 2
       defkey(1) = 'energy'
       defkey(2) = 'xmu'
c
       do 100 i = 1, nkeys
          k = istrln( keys(i))
c          if (iprint.gt.3)  print*, '>iff_spline|',keys(i)(1:k),
c     $         '|',values(i)(1:20),'|'
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then
             name1 = values(i)
          elseif ((keys(i).eq.'ee').or.(keys(i).eq.'e0'))  then
             ier = iff_eval_dp(values(i),e0)
             find_e0 = .false.
             vary_e0 = .false.             
          elseif (keys(i).eq.'rbkg') then
             ier = iff_eval_dp(values(i),rbkg)
          elseif (keys(i).eq.'r1st') then
             ier = iff_eval_dp(values(i),r1stx)
          elseif (keys(i).eq.'toler') then
             ier = iff_eval_dp(values(i),toler)
          elseif (keys(i).eq.'edge_step') then
             ier = iff_eval_dp(values(i),step)
             find_step = .false.
          elseif (keys(i).eq.'nknots') then
             ier = iff_eval_dp(values(i),xknots)
          elseif (keys(i).eq.'vary_e0') then
             call str2lg(values(i),vary_e0,ier)
          elseif (keys(i).eq.'spl_stiff') then
             ier = iff_eval_dp(values(i),splstf)
          elseif (keys(i).eq.'find_step') then
             call str2lg(values(i),find_step,ier)
          elseif (keys(i).eq.'find_e0') then
             call str2lg(values(i),find_e0,ier)
          elseif (keys(i).eq.'do_pre') then
             call str2lg(values(i),do_pre, ier)
          elseif (keys(i).eq.'do_spl') then
             call str2lg(values(i),do_spl, ier)
          elseif (keys(i).eq.'is_kev') then
             call str2lg(values(i),is_kev, ier)
          elseif (keys(i).eq.'fnorm') then
             call str2lg(values(i),fnorm,ier)
          elseif (keys(i).eq.'fixstd') then
             call str2lg(values(i),fixstd,ier)
          elseif (keys(i).eq.'kmin') then
             ier = iff_eval_dp(values(i),xkmin)
          elseif (keys(i).eq.'kmax') then
             ier = iff_eval_dp(values(i),xkmax)
          elseif (keys(i).eq.'kwindow') then
             winnam = values(i)
             call lower (winnam)
          elseif (keys(i).eq.'kweight') then
             ier = iff_eval_dp(values(i),xkw)
          elseif (keys(i).eq.'dk1') then
             ier = iff_eval_dp(values(i),dk1)
          elseif (keys(i).eq.'dk2') then
             ier = iff_eval_dp(values(i),dk2)
          elseif (keys(i).eq.'dk') then
             ier = iff_eval_dp(values(i),dk1)
             dk2 = dk1
          elseif (keys(i).eq.'pre1') then
             ier = iff_eval_dp(values(i),pre1)
          elseif (keys(i).eq.'pre2') then
             ier = iff_eval_dp(values(i),pre2)
          elseif (keys(i).eq.'norm1') then
             ier = iff_eval_dp(values(i),enor1)
          elseif (keys(i).eq.'norm2') then
             ier = iff_eval_dp(values(i),enor2)
          elseif (keys(i).eq.'norm_order') then
             ier = iff_eval_in(values(i), nnorm)
          elseif (keys(i).eq.'interp') then
             iterp = 2
          elseif (keys(i).eq.'nclamp') then
             ier = iff_eval_in(values(i), nclmp)
          elseif (keys(i).eq.'clamp1') then
             lclmp1 = .true.
             call str2dp(values(i),xclmp1, ier)
          elseif (keys(i).eq.'clamp2') then
             lclmp2 = .true.
             call str2dp(values(i),xclmp2, ier)
          elseif (keys(i).eq.'energy') then
             en_arr = values(i)
             call lower(en_arr)
          elseif (keys(i).eq.'xmu') then
             xmuarr = values(i)
             call lower(xmuarr)
          elseif (keys(i)(1:7).eq.'chi_std') then
             cstarr = values(i)
             call lower(cstarr)
          elseif (keys(i)(1:5).eq.'k_std') then
             kstarr = values(i)
             call lower(kstarr)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** spline: unknown keyword " '//messg)
          end if
 100   continue
       do_std = ((cstarr.ne.undef).and.(kstarr.ne.undef))
       nknots = int(xknots)

c get/resolve array names
c    check that name1 exists.
c    otherwise, get it from xmuarr, if available
c    otherwise, give up.
cc       print*, ' spline : name1 = ', name1(1:40)
       if (name1.eq.undef) then
          jdot = index(xmuarr,'.')
          if (jdot.ne.0) name1 = xmuarr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(en_arr,'.')
          if (jdot.ne.0) name1 = en_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' spline: can''t determine group name')
          return             
       endif
       call fixnam(name1,1)
       call lower(name1)
       jdot = istrln(name1)

c input array names: energy, xmu -- both required
       jen   = iff_eval(en_arr, name1, arr_e, npts_e)
       jxmu  = iff_eval(xmuarr, name1, arr_x, npts_x)
       jkst  = iff_eval(kstarr, name1, arr_ks, npts_ks)
       jcst  = iff_eval(cstarr, name1, arr_cs, npts_cs)
c
cc       print*, 'spline ', jen, jxmu, jkst, jcst
       if (jen.le.0) then
          call warn(2, ' spline: no energy array?')
          return
       elseif(jxmu.le.0) then
          call warn(2, ' spline: no xmu array?')
          return
       elseif(npts_e.ne.npts_x) then
          call warn(2, ' spline: energy and xmu are different length?')
          return
       end if
c
c  if needed, call pre_edge for pre_edge subtraction
c
       if ((e0.le.arr_e(1)).or.(e0.ge.arr_e(npts_e))) find_e0 = .true.

c require that endat be monotonically increasing: if not, sort it
       ier =  sort_xy(arr_e, arr_x, npts_e, tiny)
       if (ier .eq. 1) then 
          call warn(1, ' spline:   energy data appears out of order')
cc          print*, 'npts_e = ', npts_e
       endif
c if obvious, or explicitly stated, switch KeV to eV:
       if (is_kev .or.
     $      ((arr_e(1).le.90).and.(arr_e(npts_e).le.90))) then
          call warn(1, ' spline:   energy data appears to be in keV')
          call kev2ev(arr_e, npts_e)
       endif
cc       print*, ' find_e0 vary_e0 = ', find_e0, vary_e0,  do_pre, e0
       if (do_pre .or. (abs(step).le.tiny) .or. find_e0) then
          le = max(1, istrln(en_arr))
          lx = max(1, istrln(xmuarr))
          l1 = max(1, istrln(name1))
          call setsca('e0', e0 )
          call setsca('pre1', pre1 )
          call setsca('pre2', pre2 )
          call setsca('norm1', enor1 )
          call setsca('norm2', enor2 )
          tmpstr = ', group = '//name1(1:l1)
cc          print*, ' find_e0 in pre_edge: ', find_e0, e0
          l1 = istrln(tmpstr)
          if (find_e0) then
             tmps2 = ', find_e0=true'
          else 
             write(tmps2,'(a,f10.3)') ', e0 =',e0
          endif
          tmpstr = tmpstr(1:l1)//tmps2
          l1 = istrln(tmpstr)
          if (abs(step).ge.tiny) then
             write(tmps2,'(a,f14.5)') ', edge_step =', step
             tmpstr = tmpstr(1:l1)//tmps2
          endif
          l1 = istrln(tmpstr)
          outstr = 'energy='//en_arr(1:le)//', xmu='
     $         //xmuarr(1:lx)//tmpstr(1:l1)
          l1 = istrln(outstr)
          write(tmps2,'(a,f13.4,a,f13.4,a,f13.4,a,f13.4,a,i3)') 
     $    ', pre1=', pre1,',pre2=',pre2,
     $    ',norm1=',enor1,',norm2=',enor2, ',norm_order=',nnorm
          lx = istrln(tmps2)
          outstr = outstr(1:l1)//tmps2(1:lx)
          if (iprint.gt.7) then
             call echo(' SPLINE: sending pre_edge:')
             call echo('    :  '//outstr)
          end if
          call iff_pre_edge(outstr)
       end if
c
c k and chi arrays for standard --
       if (do_std) then
          if (jkst.le.0) then
             call warn(2, ' spline: could not find k_std array?')
             return
          end if
          if (jcst.le.0) then
             call warn(2, ' spline: could not find chi_std array?')
             return
          end if
       end if

c  now the real call to spline
       call spline(arr_e, arr_x, npts_e, arr_ks, arr_cs, npts_ks,
     $      e0, rbkg, r1stx,toler, nknots, xkmin, xkmax,xkw,dk1,dk2,
     $      winnam, find_step, fnorm, enor1, enor2, pre1,pre2, step,
     $      lclmp1, xclmp1, lclmp2, xclmp2, nclmp,
     $      cnorm, fixstd, do_std, vary_e0, splstf, do_spl,
     $      a_bkg, npts_k, a_xk, a_chi)
c
c output array names:  bkg, k, chi
       call set_array('bkg', name1, a_bkg, npts_e, 1)
       call set_array('k',   name1, a_xk,  npts_k, 1)
       call set_array('chi', name1, a_chi, npts_k, 1)
c  
c
       po = getsca('pre_offset',1)
       ps = getsca('pre_slope',1)

       do 200 i = 1, npts_e
          tmparr(i) = (arr_x(i) - po - ps * arr_e(i))/step
 200   continue 
       call set_array('norm', name1, tmparr, npts_e, 1)

       xknots = nknots
       call setsca('nknots',      xknots)
       call setsca('rbkg',        rbkg )
       call setsca('e0',          e0 )
       call setsca('kweight_spl', xkw)
       call setsca('kmin_spl',    xkmin )
       call setsca('kmax_spl',    xkmax )
       call setsca('dk1_spl',     dk1   )
       call setsca('dk2_spl',     dk2   )
       call setsca('toler',       toler )
       call setsca('edge_step',   step )
       call setsca('norm_c0',    cnorm(1))
       call setsca('norm_c1',    cnorm(2))
       call setsca('norm_c2',    cnorm(3))
       return
c end  subroutine iff_spline
       end

      subroutine outasc(filnam, title, doc, ndoc,
     $      xd, mcol, mdata, ncol, ndata)
c
c write column data to ascii file
c inputs (no outputs):
c   filnam    file name to write data to
c   title     string to use as label for columns
c   doc       array of document lines
c   mdoc      dimension of doc
c   xd        (mcol,mdata) matrix of data
c   mcol      dimension of xd
c   mdata     dimension of xd
c   ncol      number of columns to actually write
c   ndata     number of data points to actually write
       implicit none
       integer  ilen, istrln, i, iounit, ierr, mcol, mdata
       integer  ndoc, mxl, ncol, ndata, iexist, j, ic
       double precision    xd(mcol,mdata)
       character*(*) filnam, title, lines*20
       character*(*) doc(ndoc)
       character     fmt*18, cmt*2, cmtd*2, contc*5
       parameter(mxl = 78, cmtd = '# ', contc = '  +  ')
       parameter(lines = '--------------------')
       external istrln 
c
c decide comment character
       cmt = cmtd
       ic  = istrln(cmt)
c open data file
c if file name is ' ' or '*', write to standard output (unit 6)
       iounit = 6
       if ((filnam.ne.' ').and.(filnam.ne.'*')) then
          iounit = 0
          call openfl(iounit, filnam, 'unknown', iexist, ierr)
          if ((ierr.lt.0).or.(iexist.lt.0)) go to 990
       endif
c write documents
       do 200 i = 1, ndoc
          call triml(doc(i))
          ilen = istrln(doc(i))
          if (ilen.gt.mxl) then
             write(iounit,820) cmt,doc(i)(1:mxl)
             write(iounit,820) cmt//contc,doc(i)(mxl+1:ilen)
          else if (ilen.ge.1) then
             write(iounit,820) cmt,doc(i)(1:ilen)
          end if
 200   continue
c  write line of minus signs and column label
       write(iounit,820) cmt(1:ic), lines//lines
       ilen = max(1,istrln(title))
       write(iounit,820) cmt,title(1:ilen)
c determine format
       write(fmt,850) ncol
c write out column data
       do 400 i = 1, ndata
          write(iounit,fmt) (xd(j,i), j= 1,ncol)
 400   continue
c  close data file and return
       close(iounit)
       return
 820   format(2a)
 830   format(a,40('-'))
 850   format('(',i2,'(g15.7))')
 990   continue
       fmt  = 'outasc: error opening file '//filnam
       ilen = istrln(fmt)
       call messag(fmt(:ilen))
       stop
c end subroutine outasc
       end

       subroutine iff_path(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c define path parameters for a given path
c a path defintion consists of the following parameters:
c   index    -- path pointer, defaults to next available integer
c   $file    -- name of feff.dat / feff.bin, index
c   $label   -- text string
c   path.k   -- array for k when  using path.amp / path.pha
c   path.amp -- array for explicit amplitude factor
c   path.pha -- array for explicit phase shift
c   s02      -- scalar amplitude factor
c   e0       -- scalar e0 shift
c   ei       -- scalar ei shift
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fefdat.h'
       include 'pthpar.h'
       save
       
       character*(*)  str
       character*256  tmpfff, tmplab
       character*2048 parstr(mpthpr)
       character*64   defkey(3)
       double precision  getsca, xiup, xip
       integer    icode(micode), jcode(micode)
       integer   irec, istrln, i, j, k, ier, ilen, lv
       integer   ndfkey, ifeff, inpath, idpath, iupath
       integer   iff_eval_dp, iff_eval_in, encod
       logical   force_read
       external  getsca, iff_eval_dp, iff_eval_in, istrln, encod
c special indices for path parameters:
c jpnull = no path param; jppath , jplabl for "path" & "label"
c rest are the numerical path params, ranging from 1 to mpthpr

cc       print *, 'PATH ', str(1:70)
       call gettxt('feff_file',  tmpfff)
       xiup   = getsca('path_index',1)
       iupath = max(0,min(int(xiup),max_pathindex))
       do 10 i = 1, mpthpr
          parstr(i) = undef
 10    continue
       tmplab = ' '
       force_read = .false.
c  interpret keyword/value pairs for setting options
       call bkeys(str, mkeys, keys, values, nkeys)
cc       print*, 'bkeys sees ', nkeys, ' pairs '
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'id', 'feff'
       ndfkey    =  2
       defkey(1) = 'index'
       defkey(2) = 'feff'
       irec      =  0
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          lv = istrln(values(i))
cc          print*, 'arg: ', keys(i)(:k), ' -> ', values(i)(:lv)
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'feff').or.(keys(i).eq.'file'))  then 
             if (values(i).ne.undef) then
                parstr(jfppth) = values(i)
             endif
          elseif (keys(i).eq.'label') then 
             tmplab = values(i)
          elseif (keys(i).eq.'index') then 
             iupath = -1
             ier    = iff_eval_in(values(i), j)
             if ((ier.eq.0).and.(j.gt.0).and.
     $            (j.le.max_pathindex)) then
                xip    = j  * one
                iupath = j
                call setsca('path_index', xip)
             endif
c  key for feff.bin
          elseif ((keys(i).eq.'key').or.(keys(i).eq.'record')) then 
             ier = iff_eval_in(values(i), j)
             if ((ier.eq.0).and.(j.ge.0)) irec = j
          elseif ((keys(i).eq.'s02').or.
     $            (keys(i).eq.'amp')) then 
             parstr(jfps02) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'e0') then 
             parstr(jfpe0)  = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'ei') then 
             parstr(jfpei)  = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'delr') then 
             parstr(jfpdr)  = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'degen') then 
             parstr(jfpdeg)  = '('//values(i)(:lv)//')'
          elseif ((keys(i).eq.'sigma2').or.
     $            (keys(i).eq.'sig2')) then 
             parstr(jfpss2) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'third') then 
             parstr(jfp3rd) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'fourth') then 
             parstr(jfp4th) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'dphase') then 
             parstr(jfppha) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'k_array') then 
             parstr(jfpkar) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'phase_array') then 
             parstr(jfppar) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'amp_array') then 
             parstr(jfpaar) = '('//values(i)(:lv)//')'
          elseif (keys(i).eq.'force_read') then 
             call str2lg(values(i),force_read,ier)
          else
             k = istrln( keys(i))
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** path: unknown keyword " '//messg)
          end if
 100   continue 
c
c a user path index must be given
       if (iupath.le.0) then
          call warn(2,'  path: no valid path index given')
          return
       end if
c
c decide what internal path to use for this user path index
c
c     iupath  user path index      user-chosen index
c     inpath  internal path index  which set of path params to use           
c     ifeff   feff path index      which feff file to use
c     idpath  data path index      which internal path is this for this
c                                  data set, when summing over paths
c  idpath is the key, giving the rest using pointers:
c     inpath = jdtpth(idpath) 
c     iuser  = jdtusr(idpath)
c     ifeff  = jpthff(inpath)
c
c  so first, get idpath:
       idpath = 0
 200   continue 
       idpath = idpath + 1
       if (idpath.gt.mpaths) then
          call warn(2, ' path -- too many paths for a data set')
          return
       elseif (jdtusr(idpath).eq.0) then
          jdtusr(idpath) =  iupath
       elseif (jdtusr(idpath).ne.iupath) then
          go to 200
       end if
c
c now get inpath so that jdtpth(idpath) = inpath
c      inpthx stores the current maximum path index
       if (jdtpth(idpath).eq.0) then
          inpthx  = inpthx + 1
          jdtpth(idpath)= inpthx
       end if
       inpath = jdtpth(idpath)

c 
c but wait, there's more: get jfeff, if we know it. 
c  encod and store math formula for each path param
c
c   assign a feff path to the internal path:
c-- ifeff set here          so that jpthff(inpath) = ifeff
       if (parstr(jfppth).ne.undef) then
          tmpfff = parstr(jfppth)
          do 1640 ifeff = 1, mfffil
             if ( (feffil(ifeff) .eq. tmpfff).and.
     $            (iffrec(ifeff) .eq. irec)) go to 1700
             if (  feffil(ifeff) .eq. blank ) go to 1700
 1640     continue
c 1680     continue
c          itfeff        = itfeff  + 1
c          ifeff         = itfeff
 1700     continue
          jpthff(inpath)= ifeff
          jusedg(inpath)= 1
          feffil(ifeff) = tmpfff
          iffrec(ifeff) = irec
          if (force_read) lffred(ifeff) = .false.
       end if
c        print*, 'PATH: iupath, idpath | inpath, iuser, ifeff ',
c      $      iupath, idpath, jdtpth(idpath) ,
c      $      jdtusr(idpath),  jpthff(inpath)

c
c OK, so now we set all the parameters
       pthlab(inpath) = tmplab
c path id not set until the path is actually read....
       do 2800 i = 1, mpthpr
          if ((i.ne.jfppth).and.(parstr(i).ne.undef)) then
cc             call rmquot(parstr(i))
c             print*, 'path set param: ', i, '-> ', 
c     $            parstr(i)(:istrln(parstr(i)))             

             ier = encod(parstr(i), jcode, icode)
             if (iprint.ge.8) call rpndmp(jcode)
             do 2700 j  = 1, micode
                icdpar(j,i,inpath) = icode(j)
 2700        continue 
          end if
 2800  continue 
c
       return
       end

       integer function clcalc(iz, path, npts, energy, fp, fpp)
c      cromer-libermann calculation of anomalous scattering factors 
c arguments:
c   iz      atomic number of element                       [in]
c   path    path to cromer-libermann files                 [in]
c   npts    number of elements in energy array             [in]
c   energy  array of energies at which to calculate f'/f'' [in]
c   fp      real part of anomalous scattering   (f')       [out]
c   fpp     imag part of anomalous scattering   (f'')      [out]
c
c notes: 
c   1  energy array is in eV
c   2  this code is based on, and modified from the cowan-brennan 
c      routines.  data statements were simplified and rearranged, 
c      code was cleaned up to be more in keeping with f77 standard
c
c  matthew newville oct 1996
c  matthew newville oct 2000
       implicit none
       integer  iz, npts, iread
       integer  i, j, k, nxpts, norb, nparm(24)
       character*(*)     path
       double precision  energy(*), fp(*), fpp(*)
       double precision  bena(24),  xnrg(24,11),  xsc(24,11)
       double precision  corr, ener, f1, f2
       integer rcldat
       external rcldat
       clcalc = 0
c  initialize the trivial parts of xnrg:
c  (non-trivial parts are given in the data statements above)
       iread = rcldat(path,iz,norb,corr,nparm,bena,xnrg,xsc)
c
c    rcldat returns 0 on success
       if (iread.eq.0) then
c calculate fp and fpp for each energy point
          do 200 i = 1, npts
             ener = energy(i) / 1000
             call cromer(iz,ener,nparm,norb,bena,xnrg,xsc,f1,f2)
             fp(i)  = f1 - corr
             fpp(i) = f2
 200      continue 
       end if
       return 
       end
cc
       integer function rcldat(path,iz,norb,corr,nparms,bena,xnrg,xsc)
       implicit none
       character*(*) path, pth*256, file*256, line*256
       character*32 words(8)
       integer istrln, nxtmp, npack
       integer  iz, norb, nparms(24), lun, ilen, iread, nwords
       integer  i, ier1, ier2, ier3,ier4, ier5, ier6, j
       double precision corr, bena(24), xnrg(24,11), xsc(24,11)
       double precision relcor, kpcor, xtmp(19)
       double precision xnrd1, xnrd2, xnrd3, xnrd4, xnrd5, zero
       parameter (xnrd1  = 80.d0, xnrd2 = 26.7d0, xnrd3 = 8.9d0)
       parameter (xnrd4  = 3.0d0, xnrd5 = 1.0d0, zero  = 0.d0)
       parameter (npack  = 8)
       external iread, istrln

       norb = 0
       corr = zero
       do 30 i = 1, 24
          bena(i)   = zero
          nparms(i) = 0
          do 25 j = 1, 11
             xsc(i,j)  = zero
             xnrg(i,j) = zero
 25       continue 
 30    continue 
       rcldat = 1
       pth = path
       call triml(pth)
       ilen = istrln(path)
       write(file,'(a,i2.2,a)') path(:ilen),iz,'.dat'
       lun = 10
       open(unit=lun,file=file, status='old', err=700)
c
c read ignored title line
       ilen = iread(lun,line)
       call triml(line)
       if ((line(1:1).ne.'#').or.(index(line,'PAD').eq.0)) goto 700
c
c read iz, norb, relcor, kpcor
       ilen = iread(lun,line)
       if (ilen.le.0) goto 700
       nwords = 4
       call bwords(line,nwords,words)
       call str2in(words(1),iz,    ier1)
       call str2in(words(2),norb,  ier2)
       call str2dp(words(3),relcor,ier3)
       call str2dp(words(4),kpcor, ier4)
       corr = relcor - kpcor
       if ( (ier1.ne.0).or.(ier2.ne.0).or.
     $      (ier3.ne.0).or.(ier4.ne.0)) goto 700
c
c read PADified data : note careful reading of integer nparms!
       nxtmp = 19
       do 200 i = 1, norb
          xnrg(i,1) = xnrd1
          xnrg(i,2) = xnrd2
          xnrg(i,3) = xnrd3
          xnrg(i,4) = xnrd4
          xnrg(i,5) = xnrd5
          call rdpadd(lun,npack,xtmp,nxtmp)
          nparms(i) = int(xtmp(1) + 0.1)
          bena(i)   = xtmp(2)
          xnrg(i,6) = xtmp(3)   
          xnrg(i,7) = xtmp(4)   
          xnrg(i,8) = xtmp(5)   
          xnrg(i,9) = xtmp(6)   
          xnrg(i,10)= xtmp(7)   
          xnrg(i,11)= xtmp(8)   
          xsc(i,1)  = xtmp(9)   
          xsc(i,2)  = xtmp(10)  
          xsc(i,3)  = xtmp(11)  
          xsc(i,4)  = xtmp(12)  
          xsc(i,5)  = xtmp(13)  
          xsc(i,6)  = xtmp(14)  
          xsc(i,7)  = xtmp(15)  
          xsc(i,8)  = xtmp(16)  
          xsc(i,9)  = xtmp(17)  
          xsc(i,10) = xtmp(18)  
          xsc(i,11) = xtmp(19)  
 200   continue 
       close(lun)
       rcldat = 0
       return
 700   continue  
       close(lun)
       rcldat = -1       
       return
       end
       subroutine cromer(iz,ener,nparms,norb,benaz,xnrg,xsc,f1,f2)
c modified from cowan-brennan routines      matt newville oct 1996
c this routine reads data for f' and f" according to an
c algorithm by cromer and lieberman, given to fuoss.
c converted to direct access file by brennan
c converted to internal data 3-may-1993 smb
       implicit none
       integer        iz, irb, ipr, icount,i0,inxs, norb, nparms(24)
       double precision  benaz(24), xnrg(24,11), xsc(24,11)
       double precision  ener, f1, f2, zero, fourpi
       double precision  f1orb, f2orb, en_s(11), xs_s(11), aknint
       double precision  xlnnrg(11),xln_xs(11),en_int(5), xs_int(5)
       double precision  xsedga, f1corr, xlne, energa, bena, xsb 
       double precision  var, au, kev2ry, fscinv, tiny, tinlog 
       double precision  finepi, sigma0, sigma1, sigma2, sigma3, gauss
       parameter (zero=0, fourpi=12.56637061435917d0, tiny =  1.d-13)
       parameter (au = 2.80022d+7 ,kev2ry = 0.0272113834d0) 
c finepi = 1/(4*alpha*pi**2)
       parameter (finepi = 3.47116243d0, fscinv =137.036d0 ) 
       common /gaus/ xsb,bena,xs_int, energa, xsedga,icount
       external sigma0,sigma1,sigma2,sigma3
       save
c      executable code
c ener is in kev
       xlne   = log(ener)
       energa = ener /  kev2ry
       f1     = zero
       f2     = zero
       tinlog = log(tiny)
      
c      main loop through the orbitals
       do 400 irb=1,norb
          icount= 6
          f1orb = zero
          f1corr= zero
          f2orb = zero
          xsb   = zero
          bena  = benaz(irb)
          if (nparms(irb) .eq. 11) xsedga = xsc(irb,11)/ au
         
c      also copy subset into second array
          do 110 ipr=6,10
             xs_int(ipr-5) = xsc(irb,ipr)/ au
             en_int(ipr-5) = xnrg(irb,ipr)
 110       continue 
          
c   the sorting routine messes up subsequent calls with same energy
c   so copy to second array before sorting.
          do 150 ipr=1,nparms(irb)
             xs_s(ipr) = xsc(irb,ipr)
             en_s(ipr) = xnrg(irb,ipr)
 150       continue 
          call sort(nparms(irb),en_s,xs_s)
          call sort(5,en_int,xs_int)
c      convert to log of energy,xsect
          do 190 ipr=1,nparms(irb)
             xlnnrg(ipr) = log(en_s(ipr))
             xln_xs(ipr) = log(max(tiny,xs_s(ipr)))
             if (xln_xs(ipr).le.tinlog) xln_xs(ipr) = zero
 190      continue 
c
          if (bena .le. energa) then
             do 250 i0 = 1, nparms(irb)
                if (abs(xln_xs(i0)) .ge. tiny ) go to 255
 250         continue
 255         continue
             inxs = nparms(irb) - i0 + 1
             xsb  = exp(aknint(xlne,inxs,xlnnrg(i0),xln_xs(i0)))/au
             f2orb= fscinv * energa * xsb / fourpi
             var  = energa-bena
             if (abs(var). le. tiny) var = 1
             f1corr = - finepi * xsb * energa * log((energa+bena)/var)
          end if
c
          if((bena.gt.energa).and.(nparms(irb).eq.11)) then
             f1orb  = gauss(sigma3) 
             f1corr = finepi * xsedga * bena**2 * log((-bena+energa)
     $            /(-bena-energa)) / energa 
          else
             if (nparms(irb).eq.11)   then
                f1orb = gauss(sigma0)
             elseif ((nparms(irb).eq.10).and.
     $               (iz.ge.79).and.(irb.eq.1)) then
                f1orb = gauss(sigma1)
             else 
                f1orb = gauss(sigma2)
             end if
          end if
          f1 = f1 + f1orb * 2 * finepi + f1corr
          f2 = f2 + f2orb
 400   continue 
c      this is the end of the loop over orbits
     
c      
c      note: the jensen correction to f' was subsequently shown to be incorrect
c      (see l. kissel and r.h. pratt, acta cryst. a46, 170 (1990))
c      and that the relativistic correction that ludwig used is also
c      wrong.  this section retained as comments for historical reasons.
c      
c      jensen_cor = -0.5*float(iz)
c      1			*(energa/fscinv**2)**2
c      
c      subtract relcor ala ludwig and change back to real*4
c      
c      f1 = sumf1+jensen_cor-relcor(iz)
c      
c      kissel and pratt give better corrections.  the relativistic correction
c      that ludwig used is (5/3)(e_tot/mc^2).  kissel and pratt say that this
c      should be simply (e_tot/mc^2), but their correction (kpcor) apparently
c      takes this into account.  so we can use the old relcor and simply add
c      the (energy independent) kpcor term:
c      
       return
       end
       double precision function sigma0( x)
       implicit none
       double precision  x, xsb, bena, xs_int(5)
       double precision  energa, d_prod, xsedga, tiny
       parameter(tiny=1.d-30)
       integer icount
       common /gaus/ xsb, bena, xs_int, energa, xsedga, icount
       save
c      executable code
       icount = icount-1
       sigma0 = xs_int(icount)* bena/(x*x)
       d_prod = (energa*x)**2 - bena**2
       if(abs( d_prod) .gt. tiny)
     $      sigma0 =bena * ( sigma0 * bena - xsb* energa**2)/ d_prod
       return
       end
c***********************************************************************
       double precision function sigma1( x)
       implicit none
       double precision  x, xsb, bena, xs_int(5)
       double precision  energa, xsedga, half
       parameter (half = 0.5d0)
       integer icount
       common /gaus/ xsb, bena, xs_int,
     $      energa, xsedga, icount
       save
c      executable code
       icount = icount-1
       sigma1 = half* bena**3* xs_int( icount)
     $ /( sqrt(x)*( energa**2* x**2- bena**2* x))
       return
       end
c***********************************************************************
       double precision function sigma2(x)
       implicit none
       double precision x, zero, tiny, p1, denom, eps
       double precision xsb, bena, xs_int(5), energa, xsedga
       integer icount
       common /gaus/ xsb, bena, xs_int, energa, xsedga,icount
       parameter (zero = 0, tiny = 1.d-18, eps = 1.d-5, p1 = 1.001d0)
       save
       icount=icount-1
c     code modified by chris t. chantler, may 12-1992
c     code modified by matt newville  oct 1996 
       if ((abs(x).lt.tiny).or.(energa.lt.tiny)) then
          sigma2= zero
       elseif (abs(xs_int(icount)-xsb).lt.tiny) then
          sigma2=-2*xs_int(icount)*bena/x**3
       else
          denom= x**3*energa**2-bena**2/ x
          if (abs(denom).lt.eps) then
cc chantler:        sigma2=-2*xs_int(icount)*bena/x**3
             denom= x**3*(energa*p1)**2-bena**2/ x
cc             print*, ' weird point at e =  ', energa * 27.21d0
          end if
          sigma2= 2*(xs_int(icount)*(bena/x)**3/x-
     $         bena* xsb* energa**2)/ denom
       endif
       return
       end
c***********************************************************************
       double precision function sigma3( x)
       implicit none
       double precision  x, xsb, bena, xs_int(5), energa, xsedga
       integer icount
       common /gaus/ xsb,bena,xs_int, energa, xsedga,icount
       save
c      executable code
       icount = icount-1
       sigma3 = bena**3*( xs_int( icount)
     $      - xsedga* x**2)/( x**2*( x**2* energa**2- bena**2))
       return
       end
c***********************************************************************
       subroutine lgndr (index,dbb,dcc)
       implicit none
       integer index, ip
       double precision  dbb, dcc, const, d_x(2), d_a(3)
       double precision half,zero,one
       parameter(half = 0.5d0, zero = 0d0, one = 1d0)
       data d_x(1), d_x(2) /.04691007703067d0, .23076534494716d0/
       data d_a(1), d_a(2) /.11846344252810d0, .23931433524968d0/
       data d_a(3)         /.28444444444444d0/

c      executable code
c      warning! this routine has been stripped so it is only useful
c      with abs$cromer in this set of routines.
       dcc = half
       const=zero
       ip= index
c      ip limited to 1,2,3
       if ( ip .gt. 3) then
          ip   = 6 - ip
          const= -one
       end if
       dbb = d_a(ip)
       if( ip .eq. 3) return
       dcc= -const+ sign( d_x(ip), const)
       return
       end
c***********************************************************************
       double precision function gauss (sigma)
       implicit none
       integer i
       double precision  b, c, sigma, zero
       parameter (zero  = 0.d0)
       external sigma
       gauss = zero
       do 10 i=1,5
          call lgndr( i, b, c)
          gauss = gauss + b * sigma(c)
 10    continue 
       return
       end
c*************************************************************
c***********************************************
c      bubble sort.  largest becomes last
       subroutine sort (n,a,b)
       implicit none
       integer i, n, j
       double precision  a(*), b(*), x, y
       
       do 11 i=1,n-1
          do 10 j=i+1,n
             if(a(j).lt.a(i)) then
        	x=a(j)
        	y=a(i)
        	a(i)=x
        	a(j)=y
        	x=b(j)
        	y=b(i)
        	b(i)=x
        	b(j)=y
             end if
 10       continue 
 11    continue 
       return
       end
c      aitken repeated interpolation
c      xlne   = abscissa at which interpolation is desired
c      xlnnrg = vector of n values of abscissa
c      xln_xs = vector of n values of ordinate
c      t      = temporary storage vector of 4*(m+1) locations)
       double precision function aknint( xlne, n, xlnnrg, xln_xs)
       implicit none
       integer n, i, ii, j
       double precision  t(20), xlne, xlnnrg(n), xln_xs( n)
c      executable code
       if(n .le. 2) then
          write(*,'(a)') ' aknint:  too few points, funct=y(1)'
          aknint = xln_xs(1)
          return
       end if
       if (xlnnrg(2) .gt. xlnnrg(1)) then
          do 10 i = 1, n
             if (xlnnrg(i) .ge. xlne) go to 30
 10       continue 
       else
          do 20 i = 1, n
             if (xlnnrg(i) .le. xlne) go to 30
 20       continue 
       end if
 30    continue 
       ii = min(n-2, max(1, i-1))
       do 40 i= ii, ii+2
          t(i-ii+1) = xln_xs(i)
          t(i-ii+4) = xlnnrg(i)- xlne
 40    continue 
       
       do 70 i=1,2
          do 60 j=i+1,3
             t(j) = ( t(i)*t(j+3)-t(j)*t(i+3))
     $            /( xlnnrg( j + ii - 1)- xlnnrg( i + ii - 1))
 60       continue 
 70    continue 
       aknint= t(3)
       return
       end

       subroutine xfsout(chiq,chiqr,format,vax,filchi,filrsp,filenv,
     $      cmpchi,chiflg,rspflg,envflg,irecl,
     $      iexist,skychi,skyrsp,skyenv,cmt, ndocx,
     $      qwind, qweigh, rwind, rweigh,
     $      wfftc, mfft, rlast, qoutlo, qouthi, pcflg, qfeff, phafef,
     $      mfeff, qgrid, ndoc, doc)
c
c      given chi(k) and a whole lot of input parameters, this will
c      write output files with chi(k), chi(r), and backtransformed
c      chi(k).  for peculiar historical reasons, i will use the
c      convention that env and p refer to the two arrays for
c      backtransformed chi(k), and chi and q to the two arrays
c      for unfiltered chi(k).  the letter k is taken to be ambiguous
c      here (and a fortran integer) so it will be completely avoided.
c
c      copyright 1993 university of washington         matt newville
c
c  inputs:
c    chiq     array of unfiltered chi(k) data, on grid
c               such that chiq(1) = chi(k=0.)
c    filchi   name of output raw-k-space file to write
c    filrsp   name of output r-space file to write
c    filenv   name of output filtered-k-space file to write
c    format   format of output files (uwxafs of ascii)
c    vax      logical flag for writing binary data in vax format
c    chiflg   logical flag for writing raw-k-space data
c    rspflg   logical flag for writing r-space data
c    envflg   logical flag for writing filtered-k-space data
c    ndoc     number of document lines to write out
c    doc      documents to write out
c    qoutlo   lowest value in raw-k-space to write out data
c    qouthi   highest value in raw-k-space to write out data
c    qgrid    k-grid spacing for writing out data and fft
c    qweigh   k-weight to use for fft
c    qwin1    window parameter #1 for  k->r  ft
c    qwin2    window parameter #2 for  k->r  ft
c    wfftc    work array for fft (initialized with cffti using mfft )
c    mfft     number of points to use in fft ( .le.2048 )
c    rlast    highest r value to write out
c    iexist   integer flag for rewriting data to a uwexafs file
c  outputs:
c    skychi   output skey of chi(k) file (raw-k-space)
c    skyrsp   output skey of chi(r) file (r-space)
c    skyenv   output skey of env(p) file (filtered-k-space)
c
c    note mfft must be less than or equal to 2048
c
ccc       implicit none
       integer  maxpts, i, nqout, nqouth, nqoutl, nkyout, nrout,ndocx
       double precision qouthi, qoutlo, qsmall, qgrid
       double precision rsmall, rgrid, rlast
       integer  nfft, iexist, ndoc,  mfft, mfeff
       double precision  zero, pi
       parameter (maxpts = 2048, mxmpts=2048)
       parameter (zero = 0.d0,  pi = 3.141592653589793d0)
       character*128 filchi, filrsp, filenv, cmt*2
       character*100 doc(*)
       character*5   skychi, skyrsp, skyenv, format*10, type*10
       double precision  chiq(mfft), chiqr(mfft), wfftc(4*mfft+15)
       double precision  rwind(mfft), qwind(mfft), rweigh, qweigh
       double precision  xdata(maxpts), yreal(maxpts), yimag(maxpts)
       double precision  yphas(maxpts), yampl(maxpts)
       double precision  qfeff(mfeff), phafef(mfeff)
       complex*16        cchiq(mxmpts), cchir(mxmpts), coni
       parameter  (coni = (0.d0,1.d0))
       logical      vax, chiflg, rspflg, envflg, cmpchi, pcflg
c
c   initialize
       do 20 i = 1, maxpts
          xdata(i) = zero
          yreal(i) = zero
          yimag(i) = zero
          yampl(i) = zero
          yphas(i) = zero
          cchiq(i) = cmplx(zero, zero)
          cchir(i) = cmplx(zero, zero)
 20    continue

c check that mfft .le. maxpts
       nfft = maxpts
       rgrid  = pi / ( nfft * qgrid)
       rsmall = rgrid / 100.0
       qsmall = qgrid / 100.0
       nqoutl   = int( (qoutlo + qsmall) / qgrid )
       if (nqoutl.lt.0) nqoutl = 0
       nqouth   = int( (qouthi + qsmall) / qgrid )
       nqout  = nqouth - nqoutl + 1
       nrout  = int( (rlast + rsmall) / rgrid )
c
c   construct chi(k) on q range [qoutlo, qouthi]
       do 200 i = 1, nqout
          xdata(i) = qoutlo + (i-1)*qgrid
          yreal(i) = chiq(nqoutl + i)
 200   continue
c
c  k - space
       if (chiflg) then
          type   = 'chi'
          if (cmpchi) then
             call smcase(format,'u')
             if (format(1:2).ne.'uw') type   = 'env'
             do 240 i = 1, nqout
                yimag(i) = chiqr(nqoutl + i)
 240         continue
          end if
          nkyout = 0
c   write out chi(q) on q range [qoutlo, qouthi]
cc          print*, 'xfsout: outdat chi: ', filchi(1:20), ':'
          call outdat(type, format, filchi, vax,
     $         cmt, skychi, nkyout, irecl, ndoc, ndocx, doc,
     $         nqout, xdata, yreal, yimag, yampl, yphas, iexist)
          do 320 i = 1, nqout + 10
             xdata(i) = zero
             yreal(i) = zero
             yimag(i) = zero
             yampl(i) = zero
             yphas(i) = zero
 320       continue
       end if
c
c  construct chi(r)
c  construct complex chi(k)
c  take fft of complex chi(k) to get cchir
       if (rspflg.or.envflg) then
          if (pcflg) then
             ipos = 1
             do 400 i = 1, nfft
                q = (i-1) * qgrid
                call lintrp(qfeff, phafef, mfeff, q, ipos,  pha)
                cchiq(i) = cmplx(chiq(i), zero) * exp(-coni * pha)
 400         continue
          else
             do 430 i = 1, nfft
                cchiq(i) = cmplx(chiq(i), zero)
 430         continue
          end if
c          do ix = 20, 30
c             print*, nfft, ix, ix*qgrid, qwind(ix), cchiq(ix)
c          end do
          call xafsft(nfft, cchiq, qwind, qgrid, qweigh,
     $         wfftc, 1, cchir)
       end if
c
c write chi(r) on r range [0.,rlast]
       if (rspflg) then
          do 500 i = 1, nrout
             xdata(i) = (i-1)*rgrid
             yreal(i) = dble ( cchir(i))
             yimag(i) = dimag( cchir(i))
             yampl(i) = zero
             yphas(i) = zero
 500      continue
          type   = 'rsp'
          nkyout = 0
cc          print*, 'xfsout: outdat rsp: ', filrsp(1:20), ':'
          call outdat(type, format, filrsp, vax,
     $         cmt, skyrsp, nkyout, irecl, ndoc, ndocx, doc,
     $         nrout, xdata, yreal, yimag, yampl, yphas, iexist)
       end if
c
c construct env(k) on q range [qoutlo, qouthi]
       if (envflg) then
c  take back-fft of complex chir to get crhiq
          call xafsft(nfft, cchir, rwind, rgrid, rweigh, wfftc,
     $         -1, cchiq)
          do 800 i = 1, nqout
             xdata(i) = qoutlo + (i-1)*qgrid
             yreal(i) = dble ( cchiq(i+nqoutl))
             yimag(i) = dimag( cchiq(i+nqoutl))
             yampl(i) = zero
             yphas(i) = zero
 800      continue
          type   = 'env'
          nkyout = 0
cc          print*, 'xfsout: outdat env: ', filenv(1:20), ':'
          call outdat(type, format, filenv, vax,
     $         cmt, skyenv, nkyout, irecl, ndoc, ndocx, doc,
     $         nqout, xdata, yreal, yimag, yampl, yphas, iexist)
       end if
       return
c     end subroutine xfsout
       end

       subroutine autout
c
c  matt:  add preout to write pre-edge subtracted xmu and bkg
c   data outputs for autobk:
c   uses the routine outdat to write to uwexafs
c   or column files, as given by frmout.
c
c   copyright 1992  university of washington :          matt newville
c--------------------------------------------------------------------
       include 'autobk.h'
c--------------------------------------------------------------------
c local variables
       integer  istrln, ix, i, it, ixf
       integer  iskxm, iskth, ndoc, jnew, nkyout, ipos, iexist
       double precision  e0, qlast, q1st
       double precision  rmin, energ, q, rlast, outstp
       double precision  tmp1(maxpts), tmp2(maxpts), tmp3(maxpts)
       double precision  enout(maxpts), tmp4(maxpts)
       character*128 outdoc(maxdoc)
       character*128  outksp, outrsp, outbkg, outpre
       character*10  skyksp, skyrsp, skybkg, skypre, ftype
       logical   chiksp
       data      chiksp , iexist , rmin/.true., 1 , zero /
c--------------------------------------------------------------------
cc       print*,'entered autout'
c  get some preliminary stuff
       it     = 1
       rlast  = 10.d0
       e0     = ee + e0shft
       qlast  = qgrid * (int(sqrt((emax - e0)*etok) / qgrid ) - 1 )
       nqpts  = int ( qlast / qgrid )
       q1st   = min(qgrid,qmin)
       mftfit  = 2048
       call cffti(mftfit, wfftc)

c
c  determine output format
        if (frmout.eq.' ') then
           if (frminp.eq.' ')  frminp = 'ascii'
           frmout = frminp
        end if 
       call smcase(frmout, 'a')
c----output file names: iodot was found in autinp
       if (frmout(1:2).eq.'uw') then
          outksp = chif(1:iodot)//'.chi'
          outbkg = chif(1:iodot)//'.bkg'
          outrsp = chif(1:iodot)//'.rsp'
          outpre = chif(1:iodot)//'.xmu'
       else
          outpre = chif(1:iodot)//'e.xmu'
          outbkg = chif(1:iodot)//'e.bkg'
          outksp = chif(1:iodot)//'k.chi'
          outrsp = chif(1:iodot)//'r.chi'
       end if
       ix = max(1, istrln(outksp))
       do 80 i = 1, maxpts
          tmp1(i) = zero  
          tmp2(i) = zero  
          tmp3(i) = zero  
          tmp4(i) = zero  
 80    continue
       if (eshout) then
          do 90 i = 1, maxpts
             enout(i) = energy(i) - e0
 90       continue 
       else
          do 95 i = 1, maxpts
             enout(i) = energy(i)
 95       continue 
       end if
c  write documentaion for data and background
       write(outdoc(1), 9000) 'data  : ', commnt(1:65)
       iskxm = max(1, istrln(skeyxm))
       iskth = max(1, istrln(skeyth))
       ixf   = min(74, max(1, istrln(xmuf)))
       write(outdoc(2), 9005) skeyxm(1:iskxm), xmuf(1:ixf)
       if (theory) then
          it  = min(74, max(1, istrln(theorf)))
          write(outdoc(3), 9010) skeyth(1:iskth), theorf(1:it)
       else
          outdoc(3) = '    using simple minimization '
       end if
c pre-edge info
       write(outdoc(4), 9020)  e0, predg1, predg2, step
c fourier window type
       if (iwindo.eq.1) then
          write(outdoc(5), 9030)  qmin, qmax, qweigh,
     $         '; hanning fraction =', windo1
       elseif (iwindo.eq.2) then
          write(outdoc(5), 9030)  qmin, qmax, qweigh,
     $         '; gaussian dk      =', windo1
       elseif (iwindo.eq.3) then
          write(outdoc(5), 9030)  qmin, qmax, qweigh,
     $         '; lorentzian dk    =', windo1
       elseif (iwindo.eq.4) then
          write(outdoc(5), 9035)  qmin, qmax, qweigh,
     $         '; parzen dk1, dk2  =', windo1, windo2
       elseif (iwindo.eq.5) then
          write(outdoc(5), 9035)  qmin, qmax, qweigh,
     $         '; welch  dk1, dk2  =', windo1, windo2
       else
          write(outdoc(5), 9035)  qmin, qmax, qweigh,
     $         '; sills  dk1, dk2  =', windo1, windo2
       end if
c
       if (theory) then
          write(outdoc(6), 9040) rmin,rbkg,rbkg,r1st,nsplin
       else
          write(outdoc(6), 9045) rmin,rbkg,nsplin
       end if
c--add previous document at end
       ndoc   = 6
       jnew   = 0
150    continue 
         jnew  = jnew + 1
         if (jnew.gt.maxdoc) go to 155
         call triml(xmudoc(jnew))
         if ( (ndoc.lt.19).and.(xmudoc(jnew).ne.' ') )  then
            ndoc  = ndoc + 1
            outdoc(ndoc) = xmudoc(jnew)
            go to 150
         end if
155    continue
c       print*,' outdoc(5)(1:20)=',outdoc(5)(1:20)
c----write out pre-edge subtracted xmu(e) (if preout = t)
       outstp = one
       if (preout) then
          if (nrmout) outstp = step
          outdoc(2)(1:3) = 'xmu'
          ftype = 'xmu'
          do 300 i = 1, nxmu
             tmp1(i) = xmudat(i) / outstp
 300      continue
          call outdat( ftype, frmout, outpre, vaxflg, asccmt, skypre,
     $         nkyout, irecl, ndoc, mdocxx, outdoc,  nxmu , enout,
     $         tmp1,  tmp2,  tmp3, tmp4, iexist)
          if (skypre.ne.' ') then
            call echo('           pre-edge subtracted xmu(e)'//
     $            ' written to: '// outpre(1:ix) )
          else
            call echo('           pre-edge subtracted xmu(e)'//
     $            ' already in: '// outpre(1:ix) )
          end if
          outdoc(2)(1:3) = 'chi'
       end if
c----write out chi(k) and chi(r) for data :
       skyrsp = ' '
       skyksp = ' '
       call chiout(chiq, outksp, outrsp, frmout, vaxflg, 
     $      chiksp, chirsp, irecl, ndoc, outdoc, q1st, 
     $      qlast, qgrid, qweigh, windo, wfftc, mftfit, 
     $      rlast, asccmt, mdocxx, iexist, skyksp, skyrsp)
       if (skyksp.ne.' ') then
          call echo('           chi(k) for data written to: '//
     $         outksp(1:ix) )
       else
          call echo('           chi(k) for data already in: '//
     $         outksp(1:ix) )
       end if
       if (skyrsp.ne.' ') then
          call echo('           chi(R) for data written to: '//
     $         outrsp(1:ix) )
       elseif (chirsp) then
          call echo('           chi(R) for data already in: '//
     $         outrsp(1:ix) )
       end if
c----write out background(e)
       if (bkgxmu) then
          write(outdoc(1), 9000) 'bckgrd: ', commnt(1:65)
          outdoc(2)(1:3) = 'bkg'
          ftype = 'xmu'
c
c  decide if pre-edge should be undone or not
          if (preout) then
             do 400 i = 1, nxmu
                tmp1(i) = spline(i) / outstp
 400         continue
          else
             do 405 i = 1, nxmu
                tmp1(i) = spline(i) + bpre + slopre*energy(i)
 405         continue
          endif
          call outdat( ftype, frmout, outbkg, vaxflg, asccmt, skybkg, 
     $         nkyout, irecl,  ndoc, mdocxx, outdoc,  nxmu , enout,
     $         tmp1,  tmp2,  tmp3, tmp4, iexist)
          if (skybkg.ne.' ') then
            call echo('           background(e) written to: '//
     $                  outbkg(1:ix) )
          else
            call echo('           background(e) already in: '//
     $                  outbkg(1:ix) )
          end if
       end if
c----write out background(k)
       if (bkgchi) then
          write(outdoc(1), 9000) 'bckgrd: ', commnt(1:65)
          do 480 i = 1, nxmu
             energ = energy(i) - e0
             if (energ.lt.0) then
                tmp3(i)  = - sqrt( - etok*energ)
             else
                tmp3(i)  =   sqrt(   etok*energ)
             end if
480       continue
c   write background(k) to temporary file, write it  out
          ipos = 1
           do 500 i = 1, nqpts+10
             q = (i-1)*qgrid  
             if ((q.ge.q1st).and.(q.le.qlast)) then
                call lintrp(tmp3, spline, nxmu, q, ipos, tmp4(i) )
             else
                tmp4(i) = zero
             end if  
500       continue
c                               file name
          if (frmout(1:2).ne.'uw') then
             outksp = chif(1:iodot)//'k.bkg'
             outrsp = chif(1:iodot)//'r.bkg'
          end if
          skyksp = ' '
          call chiout(tmp4, outksp, outrsp, frmout, vaxflg, 
     $         bkgchi, bkgrsp, irecl, ndoc, outdoc, q1st, 
     $         qlast, qgrid, qweigh, windo, wfftc, mftfit, 
     $      rlast, asccmt, mdocxx, iexist, skyksp, skyrsp)
          if (skyksp.ne.' ') then
            call echo('           background(k) written to: '//
     $                  outksp(1:ix) )
          else
            call echo('           background(k) already in: '//
     $                  outksp(1:ix) )
          end if
       end if
c----documents for theoretical standard
       if ( theory.and.(thersp.or.thechi)) then
          write(outdoc(1), 9000) 'theory: ', commnt(1:65)
          write(outdoc(2), 9100)  skeyxm(1:iskxm), xmuf(1:ixf)
          write(outdoc(3), 9110)  skeyth(1:iskth), theorf(1:it)
          write(outdoc(4), 9120)  rbkg, r1st, theamp
c--   add previous document at end
         ndoc   = 4
         jnew   = 0
610      continue 
           jnew  = jnew + 1
           if (jnew.gt.maxdoc) go to 615 
           call triml(thedoc(jnew))
           if ( (ndoc.lt.19).and.(thedoc(jnew).ne.' ') )  then
              ndoc  = ndoc + 1
              outdoc(ndoc) = thedoc(jnew)
              go to 610
           end if
615      continue
         if (ndoc.le.19) then 
            do 620 i = ndoc, 19
              outdoc(i) = ' '
620         continue
         end if
c----evaluate chi(k) for theory
         do 700 i = 1, maxpts
             q       = i*qgrid
             tmp3(i) = theamp*thiq(i)
             tmp4(i) = zero 
700      continue
c----write out chi(k) and chi(r) for theory
c                               file name
          if (frmout(1:2).ne.'uw') then 
             outksp = chif(1:iodot)//'k.stn'
             outrsp = chif(1:iodot)//'r.stn'
          end if
          skyksp = ' '
          skyrsp = ' '
          call chiout(tmp3, outksp, outrsp, frmout, vaxflg,
     $         thechi, thersp, irecl, ndoc, outdoc, q1st,
     $         qlast, qgrid, qweigh,  windo,  wfftc, mftfit, 
     $         rlast, asccmt, mdocxx, iexist, skyksp, skyrsp)
          if (skyksp.ne.' ') then
            call echo('           chi(k) for theory written to: '//
     $                  outksp(1:ix) )
          else
            call echo('           chi(k) for theory already in: '//
     $                  outksp(1:ix) )
          end if
          if (skyrsp.ne.' ') then
            call echo('           chi(R) for theory written to: '//
     $                  outrsp(1:ix) )
          elseif (thersp) then
            call echo('           chi(R) for theory already in: '//
     $                  outrsp(1:ix) )
          end if
       end if
c----all done
       call echo('   ----------------------------------'//
     $            '----------------------------------')
       return
c format statements
 9000  format(2a)
 9005  format('chi: from skey ',a,' of ',a)
 9010  format('    using skey ',a,' of ',a)
 9020  format(' e0 =',f9.2,'; pre-edge range =[', 2f8.1,
     $      ']; edge step =', f7.3 )
 9030  format(' k range =[',2f6.2,']; k weight =',f6.2,a20,f5.3)
 9035  format(' k range=[',2f6.2,']; k weight=',f6.2,a20,2f6.2)
 9040  format(' bkg r =[',2f6.2,']; 1st shell r =[',2f6.2,']; ',
     $         i3, ' knots in spline')
 9045  format(' bkg r =[',2f6.2,'];  ',i3,' knots in spline')

 9100  format('chi: from skey ',a,' of ',a)
 9110  format('    using skey ',a,' of ',a)
 9120  format('1st shell fit range=[',2f6.2,'] =>  amp-scale =',f8.5)

c end subroutine autout
       end

       subroutine iff_correl(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c
c purpose: turn two-variable correlation to Program Variable
c 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'feffit.h'
       save
       character*(*)  str
       character*128    xvar, yvar, out, defkey(3)*64
       double precision xn, xcmin, getsca
       logical   lprint, lxall, lyall, lsave
       integer   ier, i, k, istrln, ndfkey, jx, jy, lx, ly
       external  istrln, getsca
c
c get default values for pre-edge parameters from current scalar values
       lprint = .false.
       lsave  = .true.
       call iff_sync
       call bkeys(str, mkeys, keys, values, nkeys)
       xvar = ' '
       yvar = ' '
       out  = undef
       xcmin= getsca('correl_min',1)
       
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'x', 'y'
       ndfkey    = 2
       defkey(1) = 'x'
       defkey(2) = 'y'
       do 100 i = 1, nkeys
cc          print*,i, keys(i)
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'x') then
             xvar = values(i)
             call lower(xvar)
          elseif (keys(i).eq.'y') then
             yvar = values(i)
             call lower(yvar)
          elseif (keys(i).eq.'out') then
             out = values(i)
             call lower(out)
          elseif (keys(i).eq.'min') then
             call str2dp(values(i), xcmin, ier)
          elseif (keys(i).eq.'print') then
             call str2lg( values(i), lprint, ier)
          elseif (keys(i).eq.'save') then
             call str2lg( values(i), lsave, ier)
          elseif (keys(i).eq.'no_save') then
             call str2lg( values(i), lsave, ier)
             lsave = .not.lsave
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** correl: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names

       lx  = istrln(xvar)
       ly  = istrln(yvar)
       lxall = xvar.eq.'@all'
       lyall = yvar.eq.'@all'
cc       print*, 'correl ', xvar(1:lx), ' and ', yvar(1:ly)
cc       print*, ' save/print ',lsave,lprint
       jx = 0
       jy = 0
       
       do 150 i = 1, nvarys
          if (scanam(i).eq.xvar(1:lx)) jx = i
          if (scanam(i).eq.yvar(1:ly)) jy = i
 150   continue 

       if (nvarys.le.1) then
          call warn(2,' *** correl: too few variables!')
       else
          if (lxall.and.lyall) then
             do 240 jx = 1, nvarys
                xvar = scanam(jx)
                lx   = istrln(xvar)
                do 230 jy = 1, jx-1
                   yvar = scanam(jy)
                   ly   = istrln(yvar)
                   write(out,'(4a)') 'correl_',xvar(1:lx),
     $                  '_', yvar(1:ly)
                   call iff_correl_s(jx,jy,out,xcmin,lprint,lsave)
 230            continue 
 240         continue 
          elseif (lxall) then
             ly  = istrln(yvar)
             do 280 jx = 1, nvarys
                xvar = scanam(jx)
                lx   = istrln(xvar)
                write(out,'(4a)') 'correl_',xvar(1:lx),
     $               '_', yvar(1:ly)
                if (jx.ne.jy)
     $               call iff_correl_s(jx,jy,out,xcmin,lprint,lsave)
 280         continue 
          elseif (lyall) then
             lx  = istrln(xvar)
             do 290 jy = 1, nvarys
                yvar = scanam(jy)
                ly   = istrln(yvar)
                write(out,'(4a)') 'correl_',xvar(1:lx),
     $               '_', yvar(1:ly)
                if (jx.ne.jy)
     $               call iff_correl_s(jx,jy,out,xcmin,lprint,lsave)
 290         continue 
          else
             if ((jx.le.0).or.(jy.le.0)) then
                if (jx.le.0) then
                   messg = xvar(1:lx)//' is not a fitting variable'
                   call warn(1,' *** correl: '//messg)
                elseif (jy.le.0) then
                   messg = yvar(1:ly)//' is not a fitting variable'
                   call warn(1,' *** correl: '//messg)
                endif
             else
                if (out.eq.undef) then
                   lx  = istrln(xvar)
                   ly  = istrln(yvar)
                   write(out,'(4a)') 'correl_',xvar(1:lx),
     $                  '_', yvar(1:ly)
                endif
             endif
             call iff_correl_s(jx,jy,out,xcmin,lprint,lsave)
          endif 
       endif
       return
c end  subroutine iff_correl
       end
       subroutine iff_correl_s(jx,jy,out,xmin,lprint,lsave)

       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'feffit.h'
       save
       character*(*)  out
       double precision xn, xmin
       logical lprint, lsave
       integer jx,jy, il, istrln
       external istrln

       xn = correl(jx,jy)
       if (abs(xn) .gt. abs(xmin)) then
          if (lsave) call setsca(out,xn)        
          if (lprint) then
             il = istrln(out)
             write(messg,99) out(1:il), xn
             call echo(messg)
          endif
       endif
 99    format(2x,a,' =',f12.6)
       return
       end

      integer function nxtunt(iunit)
c  return next available unit number, greater than or equal to iunit.
c  will not return unit number less than 1, or equal to 5 or 6.
      integer iunit
      logical open

      nxtunt = max(1, iunit)
 10   continue
      inquire (unit=nxtunt, opened=open)
      if (open) then
          nxtunt = nxtunt + 1
          if ((nxtunt.eq.5).or.(nxtunt.eq.6)) nxtunt = 7
          goto 10
      endif
      return
c  end integer function nxtunt
      end

       subroutine autint
c
c  initialize arrays in common blocks for autobk
c-----------------------------------------------------------------------
       include 'autobk.h'
       integer   i
c common block char
c note :  versn initialized in main program (easier maintainence)
       xmuf    = ' '
       skeyxm  = ' '
       theorf  = ' '
       skeyth  = ' '
       chif    = ' '
       commnt  = ' '
       asccmt  = '# '
       if (vaxflg) asccmt = '##'
       frminp  = ' '
       frmout  = ' '
       do 40 i = 1, maxdoc
          xmudoc(i) = ' '
          thedoc(i) = ' '
 40    continue
c
c common block data
       nxmu    = maxpts
       imucol  = 2
       mdocxx  = 0
       iodot   = 1
       ntheor  = maxpts
       nsplin  = 0
       nkeyxm  = 0
       nkeyth  = 0
       do 100 i = 1, maxpts
          energy(i) = zero
          xmudat(i) = zero
          spline(i) = zero
          chiq(i)   = zero
          thiq(i)   = zero
          windo(i)   = zero
 100   continue     
       do 120 i = 1, mtknot
          eknot(i) = zero
 120   continue     
c
c common block edge
       eefind  = .true.
       stfind  = .true.
       ee      = zero
       predg1  =  -50.
       predg2  = -200.
       slopre  = zero
       bpre    = zero
       enor1   = 100. 
       enor2   = 300. 
       step    = zero
       nnorm   = 3
       nterp   = 1
c
c common block fft
       winstr  = 'hanning'
       iwindo  = 0
       nqpts   = 0
       nrpts   = 0
       qweigh  = one
       qmin    = zero
       qmax    = zero
       windo1  = zero
       windo2  = zero
       rbkg    = one
       r1st    = rbkg + 2 * one
c
c common block ino
c note :  vaxflg initialized in main program (easier maintainence)
       preout  = .false.
       nrmout  = .true.
       eshout  = .false.
       bkgxmu  = .true.
       bkgchi  = .false.
       bkgrsp  = .false.
       thechi  = .false.
       thersp  = .false.
       chirsp  = .false.
       gvknot  = .false.
       iprint  = 0
c
c common block fit
       theory  = .false.
       thefix  = .false.
       eevary  = .true.
       funnrm  = .false.
       final   = .false.
       nrbkg   = 0
       nr1st   = 0
       emin    = zero
       emax    = zero
       e0shft  = zero
       theamp  = one
       thessq  = one
       usrtol  = one
       spstep  = one
c
       return
c  end subroutine autint
       end

c#{dkcom.f:
       implicit none
       integer    mpts,mdoc,mtitle,mvarys, npts,ndoc,ntitle
       integer    iencol,imucol,iatz, npad, numvar
       parameter (mpts = 2**14, mdoc = 20, mtitle = 10, mvarys=8)
       double precision egrid, e0, elow, ehigh, ewidth
       double precision epad,  xvarys(mvarys)
       double precision energy(mpts), expdat(mpts)
       double precision f2cl(mpts), f1cl(mpts)
       character*100    doc(mdoc), title(mtitle), versn*6
       character*100    inpfil, xmufil, outfil, label
       logical  active, isfeff, f2tof1
       integer  ne0, nelo, nehi, ne0ish, ne0dif, iprint
       common /dfkdat/  energy, expdat, f2cl, f1cl, xvarys,
     $      egrid, e0, elow, ehigh, ewidth, epad,
     $      npad,  npts, ndoc, ntitle, iencol, 
     $      imucol, ne0, nelo, nehi, ne0ish, ne0dif, iprint,
     $      iatz, numvar, active, isfeff, f2tof1
       common /dfkchr/  doc, title, label, inpfil, xmufil, outfil,
     $      versn
       save
c#dkcom.f}

      double precision function xx (j)
      include 'const.h'
      integer j
c     x grid point at index j, x = log(r), r=exp(x)
      xx = -c88 + c05*(j-1)
      return
      end

      double precision function rr(j)
      double precision xx
      integer j
      external xx
c     r grid point at index j
      rr = exp (xx(j))
      return
      end

      function ii(r)
c     index of grid point immediately below postion r
      include 'const.h'
      double precision r
      ii = (log(r) + c88) / c05 + 1
      return
      end

      subroutine filrec(string,filnam,skey,nkey)
c
c      takes a character string and reads from it a filename, and an
c  skey and/or nkey for a record. blanks, commas, or equal signs can
c  separate the inputs on the command line.
c
      character*100  temp, words(3)
      character*(*)  string ,   filnam , skey
c
      nkey = 0
      skey = ' '
      nwords = 3
      call bwords(string,nwords,words)
c---- first word is filename
      filnam = words(1)
      nwords = nwords - 1
c---- second word is nkey or skey
      temp   = words(2)
c---- determine if second//third word is nkey/skey
c     skeys are exactly 5 characters long,
c     nkeys are never more than 3 characters long
 50   continue
      nwords = nwords - 1
      call triml(temp)
      ilen = istrln(temp)
      if(ilen.eq.5) then
         skey = temp
         call upper(skey)
      elseif(ilen.eq.4) then
         call fstop('error reading skey or nkey from '//temp)
      else
         call str2in(temp, nkey, ierr)
      end if
c---- the third word, if it exists
      if (nwords.eq.1) then
         temp = words(3)
         call triml(temp)
         go to 50
      end if
 1000 return
c     end subroutine filrec
      end


       subroutine fixstr(string,str,ilen,words,wrdsor,mwords,nwords)
c  simple preparation of string for reading of keywords
       integer       ilen, mwords, nwords, i, lenp1
       integer       iexcla, iperct, ihash, ieolc, istrln
       character*(*) string, str, words(mwords), wrdsor(mwords)
c
c  fix-up string: untab, left-justify, make a lower-case version
       nwords = 0
       call untab(string)
       str   = string
       call triml(str)
       call smcase( str, 'case')
c  remove comments from str:
c   '!', '#', and '%' are end of line comments
c   '*' is a complete comment line if in col 1
       lenp1  = len(str) + 1
       iexcla = index(str,'!')
       if (iexcla.eq.0)  iexcla = lenp1
       iperct = index(str,'%')
       if (iperct.eq.0)  iperct = lenp1
       ihash  = index(str,'#')
       if (ihash.eq.0)  ihash = lenp1
       ieolc  = min(iperct,iexcla,ihash) - 1
       if ((ieolc.lt.1).or.(str(1:1).eq.'*')) ieolc = 1
       str    = str(1:ieolc)
       ilen   = max(1, istrln(str))
       if (ilen.le.2)  return
c  break string into words (up to mwords)
c  words is in lower case,   wrdsor is in original case
       do 120 i = 1, mwords
          words(i)   =  ' '
          wrdsor(i) =  ' '
 120   continue
       nwords = mwords
       call bwords(str   , nwords, words)
       call bwords(string, nwords, wrdsor)
c end  subroutine fixstr
       return
       end
      integer function nxtunt(iunit)
c  return next available unit number, greater than or equal to iunit.
c  will not return unit number less than 1, or equal to 5 or 6.
      integer iunit
      logical open

      nxtunt = max(1, iunit)
 10   continue
      inquire (unit=nxtunt, opened=open)
      if (open) then
          nxtunt = nxtunt + 1
          if ((nxtunt.eq.5).or.(nxtunt.eq.6)) nxtunt = 7
          goto 10
      endif
      return
c  end integer function nxtunt
      end
      logical function iscomm(str)
c true if str is a comment line or blank line, false otherwise
      character*(*) str
      iscomm = ((str.eq.' ') .or. (index('*%#',str(1:1)).ne.0))
      return
      end

       subroutine iff_sync
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  fix integer code arrays icdsca and icdarr from encod so that:
c     1.  all variables come first
c     2.  all true constants come next (well, most ...)
c     3.  all other math expressions are ordered so that each
c         depends on only its predecessors.  this allows
c         single-pass, ordered decoding.
c
c arguments
c notes:
c  2. elements   1      -> nvar          of icdsca are variables
c     elements  nvar+1  -> nconst +nvar  of icdsca are constants
c  3. the parameters mxval and mcode should be >= maxval, micode.
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'pthpar.h'
       include 'feffit.h'
       save
       integer  iv, i, iv1, it1, icd, itmp, ix, k, j
       integer  nplast, nlast, npnext_max, npnext_swap
       integer  nxtmp, npmax
       parameter (npnext_max = maxheap_array - 3*maxsize_array)
cc       parameter (npnext_swap= maxheap_array -20*maxsize_array)
       logical  lswitch
c count number of scalars and arrays in use
c
cc         print*, 'top of sync'

c      
       nxscal = 0
       nxarr  = 0
c minimum npnext at which arrays will be reshuffled in order to
c eliminate erased arrays
       npnext_swap = maxheap_array * 6.5/8.0
       do 110 i = 1, maxsca
          if (scanam(i).ne.blank)  nxscal = i
 110   continue
       do 150 iv = 1, nxscal
          if (scanam(iv).eq.blank) then
             itmp = iv + 1
             call sswap(scanam(itmp), scanam(iv))
             call sswap(scafrm(itmp), scafrm(iv))
             call xswap(scalar(itmp), scalar(iv))
             call iaswap(icdsca(1,itmp), icdsca(1,iv), micode)
c now swap all references to these in the other icodes
             iv1 = jscale + iv
             it1 = jscale + itmp
             call icswap(iv1, it1)
          end if
 150   continue
c
c  count scalars again
       do 160 i = 1, maxsca
          if (scanam(i).ne.blank)  nxscal = i
 160   continue
c
       call setsca('&n_scalars', nxscal*1.d0)

       if (npnext.gt.npnext_max) then
          call echo(' *** warning: running low on space for arrays')
          call warn(1, ' ***          please clean up arrays ')
       endif

       do 830 i = 1, maxarr-1
          if ((narray(i).le.1).and.(arrnam(i).ne.undef_array))
     $         arrnam(i) = blank
          if (arrnam(i).ne.blank)  nxarr = i
 830   continue
      
cc get rid of empty arrays
       nxtmp = 0
       if (npnext .ge. npnext_swap) then
          do 250 iv = 1, nxarr
             if ((arrnam(iv).eq.blank).and.(narray(iv).le.0)) then
                do 240 itmp = iv+1, nxarr
                   if (arrnam(itmp).ne.blank) then
cc                   print*, ' swapping blank array at ' ,iv , 
cc     $                     ' with array at ', itmp, icdarr(1,iv)
                      nxtmp = nxtmp + 1
                      call sswap(arrnam(itmp), arrnam(iv))
                      call sswap(arrfrm(itmp), arrfrm(iv))
                      call xswap(arrmax(itmp), arrmax(iv))
                      call xswap(arrmin(itmp), arrmin(iv))
                      call iswap(narray(itmp), narray(iv))
                      call iswap(nparr(itmp), nparr(iv))
                      call iaswap(icdarr(1,itmp), icdarr(1,iv), micode)
                      call icswap(itmp, iv)
                      goto 242
                   endif
 240            continue 
 242            continue 
             end if
 250      continue
cc          print*, ' swapped arrays ', npnext, npnext_swap, nxarr, nxtmp
       endif
c
c  count arrays again
       nxarr  = 0
       nplast = 1
       do 860 i = 1, maxarr-1
          if (arrnam(i).ne.blank)  then 
             nxarr = i
             nplast= max(nplast,nparr(i))
             if (nplast.eq.nparr(i)) nlast = i
          endif
 860   continue
c       do i = 1, 25
c          print*, i, array(i)
c       enddo
       call setsca('&n_arrays', nxarr*1.d0)
       call setsca('&heap_used', npnext*1.d0/maxheap_array)

c------ 
c Step #0  put fitting variables first:  simple swap in place
       
       if (iprint.ge.17) then
          call echo(' lining up variables')
       endif
       itmp = 0
       do 1100 iv = 1, nxscal
c is_a_variable =   (icdsca(1,iv).eq.-1) 
          if (icdsca(1,iv).eq.-1) then
             itmp = itmp + 1
c if itmp .ne. iv, swap these two places (names, value, icodes)
             if (itmp.ne.iv) then
                call sswap(scanam(itmp), scanam(iv))
                call sswap(scafrm(itmp), scafrm(iv))
                call xswap(scalar(itmp), scalar(iv))
                call iaswap(icdsca(1,itmp), icdsca(1,iv), micode)
c now swap all references to these in the other icodes
                iv1 = jscale + iv
                it1 = jscale + itmp
                call icswap(iv1, it1)
             end if
          end if
 1100  continue
       nvarys =itmp
       call setsca('&n_guess', nvarys*1.d0)

c Step #1: put constant scalars second
c (an expression is constant unless its icode contains
c  a number between 1 and jconst:  'sqrt(5/2)' is a constant )
c   note 1: a 'set' scalar has the self-referential definition
c             icdsca(1,iv) = iv+jscale 
c           and should be treated as a constant
c   note 2: deep magic occurs when a "constant" is overwritten
c           by an ifeffit function.  A notable example is when
c           ff2chi and feffit overwrite 'reff' and 'degen'
c
       itmp = nvarys
       do 1300 iv = nvarys + 1, nxscal
          lswitch = icdsca(1,iv).ne.0
          if (icdsca(1,iv).ne.(iv+jscale)) then
             do 1230 i = 1, micode
                if (((icdsca(i,iv) .ge. 1) .and.
     $               (icdsca(i,iv) .lt. jconst))) lswitch =.false.
                if (icdsca(i,iv).eq.0) go to 1235
 1230        continue
 1235        continue
          end if
          if (lswitch) then
             itmp = itmp + 1
c if itmp .ne. iv, swap these two places (names, value, icodes)
             if (itmp.ne.iv) then
cc                print*, 'A swapping scalars  ' ,scanam(itmp)(1:30),
cc     $               scanam(iv)(1:30)
                call sswap(scanam(itmp), scanam(iv))
                call sswap(scafrm(itmp), scafrm(iv))
                call xswap(scalar(itmp), scalar(iv))
                call iaswap(icdsca(1,itmp), icdsca(1,iv), micode)
c now swap all references to these in the other icodes
                iv1 = jscale + iv
                it1 = jscale + itmp
                call icswap(iv1, it1)
             end if
          end if
 1300  continue
       nconst  = itmp - nvarys
       call setsca('&n_scalars_set', nconst*1.d0)
       call setsca('&n_scalars_def', (nxscal-nvarys-nconst)*1.d0)

c Step #3  put the math expressions in order
c          a simple switch-in-place, with recovery
       do 1600  ix = nconst + nvarys + 1, nxscal
          do 1580 iv = nconst + nvarys +1, nxscal
             lswitch = .false.
             do 1510 i = 1, micode
                icd = icdsca(i,iv)
                if ( icd.eq.0 ) go to 1520
                if ( (icd.gt.iv+jscale).and.
     $               (icd.lt.jconst))  lswitch  = .true.
 1510         continue
 1520         continue
c if itmp .gt. iv, swap these two places (names, value, icodes)
             if (lswitch) then
                itmp = itmp + 1
                if ((itmp.gt.iv).and.(itmp.le.nxscal)) then
cc                   print*, 'XX swapping scalars  ' ,scanam(itmp)(1:30),
cc     $                  scanam(iv)(1:30)
                   call sswap(scanam(itmp), scanam(iv))
                   call sswap(scafrm(itmp), scafrm(iv))
                   call xswap(scalar(itmp), scalar(iv))
                   call iaswap(icdsca(1,itmp), icdsca(1,iv), micode)
c now swap all references to these in the other icodes
                   iv1 = jscale + iv
                   it1 = jscale + itmp
                   call icswap(iv1, it1)
                end if
             end if
 1580      continue
 1600   continue

c
c Step #4: move constant arrays to top of pile
c         constant arrays have icdarr(1,in) = in, icdarr(2,in) = 0
       itmp = 0
ccc       if (npnext .ge. npnext_swap) then
       if (npnext .ge. 1) then
          do 2500 iv = 1, nxarr
             lswitch = (icdarr(1,iv).eq.iv) .and. (icdarr(2,iv).eq.0)
c      c          print*, 'SYNC:array iv ',iv,arrnam(iv)(1:30)
c      c          print*, 'SYNC: ', nparr(iv), narray(iv),
c      c     $         icdarr(1,iv),icdarr(2,iv)
             if (lswitch) then
                itmp = itmp + 1
c      if itmp .ne. iv, swap these two places (names, value, icodes)
                if (itmp.ne.iv) then
cc                   print*, ' swapping constant array at ' ,iv ,
cc     $                  ' with array at ', itmp, icdarr(1,iv)
                   call sswap(arrnam(itmp), arrnam(iv))
                   call sswap(arrfrm(itmp), arrfrm(iv))
                   call xswap(arrmax(itmp), arrmax(iv))
                   call xswap(arrmin(itmp), arrmin(iv))
                   call iswap(narray(itmp), narray(iv))
                   call iswap(nparr(itmp),  nparr(iv))
                   call iaswap(icdarr(1,itmp), icdarr(1,iv), micode)
c      now swap all references to these in the other icodes
                   call icswap(itmp, iv)
                end if
             end if
 2500     continue
       endif
       ncarr = itmp
       call setsca('&n_arrays_set', ncarr*1.d0)
       call setsca('&n_arrays_def', (nxarr-ncarr)*1.d0)
cc
c       print*,  'sync : ncarr nxarr = ', ncarr, nxarr, itmp
c
c Step #5  put the math expressions in order
c          a simple switch-in-place, with recovery
       do 3600  ix = ncarr + 1, nxarr
          do 3580 iv = ncarr +1, nxarr
             lswitch = .false.
             do 3510 i = 1, micode
                icd = icdarr(i,iv)
                if ( (icd.eq.0).or.(icd.eq.iv))  go to 3520
                if ( (icd.gt.iv).and.(icd.lt.jscale))
     $               lswitch  = .true.
 3510        continue
 3520        continue
c     c if itmp .gt. iv, swap these two places (names, value, icodes)
             if (lswitch) then
                itmp = itmp + 1
                if ((itmp.gt.iv).and.(itmp.le.nxarr)) then
c                   print*, ' swapping arrays ', iv, itmp
c                   print*, itmp, narray(itmp), arrnam(itmp)(1:20)
c                   print*, iv,   narray(iv),   arrnam(iv)(1:20)

                   call sswap(arrnam(itmp), arrnam(iv))
                   call sswap(arrfrm(itmp), arrfrm(iv))
                   call xswap(arrmax(itmp), arrmax(iv))
                   call xswap(arrmin(itmp), arrmin(iv))
                   call iswap(narray(itmp), narray(iv))
                   call iswap(nparr(itmp),  nparr(iv))
                   call iaswap(icdarr(1,itmp), icdarr(1,iv), micode)
c     now swap all references to these in the other icodes
                   call icswap(itmp, iv)
                   call fixarr(itmp,arrnam(itmp),narray(itmp), 0)
                   call fixarr(iv  ,arrnam(iv),  narray(iv),   0)
                end if
             end if
 3580     continue
 3600  continue
c   
c count string variables
       itmp = 0
       do 4300 i = 1, maxtxt
          if ((txtnam(i).ne.blank).and.(text(i).ne.blank)) itmp = itmp+1
 4300  continue 
       call setsca('&n_strings', itmp*1.d0)
 
c       
c re-evaluate all the ifeffit variables from the newly sorted values
       call synvar
c end subroutine iff_sync
       end
       subroutine synvar
c   revaluate all variables, assumed to be in order from sync
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'feffit.h'
       save
       integer i, ntmp, iu

cc       do 500 iu =  1,2
          do 10 i = 1, maxpts
             tmparr(i) = 0
 10       continue 
          do 200 i = nvarys + 1, nxscal 
             if (icdsca(1,i) .gt. 0) then
                tmparr(1)  = scalar(i)
                if (icdsca(1,i).ne.(i+jscale)) then
                   ntmp = 0
                   call decod(icdsca(1,i),micode, consts, scalar,
     $                  array, narray, nparr,
     $               maxsize_array, maxarr, ntmp, tmparr)
                   scalar(i) = tmparr(1)
                end if
             endif
 200      continue
          do 300 i = ncarr+1, nxarr
             if (icdarr(1,i) .gt. 0) then
                ntmp = 0
                call decod(icdarr(1,i),micode, consts, scalar,
     $               array, narray, nparr,
     $               maxsize_array, maxarr,  ntmp, tmparr)
                call set_array_index(i,tmparr,ntmp)
             end if
 300      continue
 500   continue 
       return
       end
       subroutine icswap(inew, iold)
c switch occurance of inew and iold  in all encoded expressions
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'pthpar.h'
       include 'feffit.h'
       save
       integer inew, iold, ip, j, i
c
c scalars
       do 240 j = 1, maxsca
          do 220 i = 1, micode
             if (icdsca(i,j).eq.inew)  then
                icdsca(i,j) = iold
             elseif (icdsca(i,j).eq.iold)  then
                icdsca(i,j) = inew
             elseif (icdsca(i,j).eq.0)  then
                go to 230
             end if
 220      continue
 230      continue 
 240   continue
c arrays
       do 340 j = 1, maxarr-1
          do 320 i = 1, micode
             if (icdarr(i,j).eq.inew)  then
                icdarr(i,j) = iold
             elseif (icdarr(i,j).eq.iold)  then
                icdarr(i,j) = inew
             elseif (icdarr(i,j).eq.0)  then
                go to 330
             end if
 320      continue
 330      continue
 340   continue
c path parameters
       do 560 ip = 1, mpaths
          do 540 j = 1, mpthpr
             do 520 i = 1, micode
                if (icdpar(i,j,ip).eq.inew)  then
                   icdpar(i,j,ip) = iold
                elseif (icdpar(i,j,ip).eq.iold)  then
                   icdpar(i,j,ip) = inew
                elseif (icdpar(i,j,ip).eq.0)  then
                   go to 530
                end if
 520         continue
 530         continue
 540      continue
 560   continue
       return
       end
       subroutine sswap(s1, s2)
c  swap 2 strings
       character*512 s, s1*(*), s2*(*)
       s  = s1
       s1 = s2
       s2 = s
       return
       end
       subroutine xswap(x1, x2)
c  swap 2 dp constants
       double precision x, x1, x2
       x  = x1
       x1 = x2
       x2 = x
       return
       end
       subroutine iswap(i1, i2)
c  swap 2 integers
       integer  i, i1, i2
       i  = i1
       i1 = i2
       i2 = i
       return
       end
       subroutine iaswap(i1, i2, n)
c  swap 2 integer arrays, of length n
       integer i1(*), i2(*), i, j, n
       do 10 j = 1, n
          i     = i1(j)
          i1(j) = i2(j)
          i2(j) = i
 10    continue 
       return
       end
c       subroutine xaswap(array, narray, nparr, i1, i2, n)
cc  swap 2 dp arrays, of length n
c       double precision  x1(*), x2(*), x
c       integer j, n
c       do 10 j = 1, n
c          x     = x1(j)
c          x1(j) = x2(j)
c          x2(j) = x
c 10    continue 
c       return
c       end

       subroutine dkinp
c read inputs for diffkk program from 'diffkk.inp'
c
       include "dkcom.f"
       integer  i, mfil, maxwrd,nwords, iwrds
       parameter(maxwrd = 30, mfil = 10)
       character*70   words(maxwrd), wrdsor(maxwrd), keywrd
       character*70   prompt*20,key*3,stat*10, string,str,comfil(mfil)
       integer   istrln,icom(mfil), nfil, iinp, ier, iex, ilen, nline
       external   istrln
c     initialization
c initialize  stuff in common
       active = .false.
       isfeff = .true.
       f2tof1 = .true.
       inpfil = 'diffkk.inp'
       xmufil = 'xmu.dat'
       outfil = 'dk.out'
       iatz   = -1
       iprint = 0
       imucol = 2
       iencol = 1
       egrid  = 1
       elow   = 200
       ehigh  = 500
       ewidth = -1.0
c note: pre1/pre2 will be set in f2fit according 
c       to whether data is from feff or not
       epad   = 5
       npad   = 20
       ntitle = 0
       label =' e         f1         f2         f1_cl         f2_cl'
       do 10 i = 1, mtitle
          title(i) = ' '
 10    continue 
c initialize  local stuff
       prompt = 'f'
       stat   = 'old'
       nline  = 0 
       nfil   = 0
       ier    = 0
       iex    = 0
       iinp   = 1
       do 20 i = 1, mfil
          icom(i)   = 0
 20    continue

       call get_inpfile('diffkk.inp',inpfil, ier)
       call openfl(iinp,  inpfil, stat, iex, ier)
       if (iex.lt.0)  then 
          ilen = istrln( inpfil)
          call messag( ' '// inpfil(:ilen)// ' not found')
          stop
          return
       endif
       if ((iex.lt.0).or.(ier.ne.0)) go to 1990
c
c  read in next line
 100   continue
       keywrd = ' '
       key    = ' '
       call getcom(prompt, iinp, string, comfil, icom, mfil, nfil)
       nline  = nline + 1
c      
       call fixstr(string,str,ilen,words,wrdsor,maxwrd,nwords)
       if ((ilen.le.2).or.(str.eq.'getcom_eof')) go to 100
       if ((words(1).eq.'end').or.(str.eq.'getcom_end')) go to 1000
       if (str.eq.'getcom_error') go to 1990
c      parse current set of keywords from line
 150   continue
       keywrd  = words(1)
       key     = keywrd(1:3)
       iwrds   = 2
c      inpfil,outfil,imucol,egrid,iatz
       if (keywrd.eq.'title') then 
          ntitle  = ntitle + 1
          call strclp(string,wrdsor(1),wrdsor(2),title(ntitle))
          iwrds = maxwrd + 1
       else if (key.eq.'out') then
          outfil = wrdsor(2)
       else if (key.eq.'xmu') then
          xmufil = wrdsor(2)
       else if (keywrd.eq.'isfeff') then
          call str2lg(words(2),isfeff,ier)
       else if (keywrd.eq.'f2_to_f1') then
          call str2lg(words(2),f2tof1,ier)
       else if (keywrd.eq.'f1_to_f2') then
          call str2lg(words(2),f2tof1,ier)
          f2tof1 = .not.f2tof1
       else if (keywrd.eq.'iz') then
          call str2in(words(2),iatz,ier)
       else if (keywrd.eq.'mucol') then
          call str2in(words(2),imucol,ier)
       else if (keywrd.eq.'encol') then
          call str2in(words(2),iencol,ier)
       else if (keywrd.eq.'egrid') then
          call str2dp(words(2),egrid,ier)
       else if (keywrd.eq.'e0') then
          call str2dp(words(2),e0,ier)
       else if (keywrd.eq.'ewidth') then
          call str2dp(words(2),ewidth,ier)

       else if (keywrd.eq.'elow') then
          call str2dp(words(2),elow,ier)
       else if (keywrd.eq.'ehigh') then
          call str2dp(words(2),ehigh,ier)
       else if (keywrd.eq.'epad') then
          call str2dp(words(2),epad,ier)
       else if (keywrd.eq.'npad') then
          call str2in(words(2),npad,ier)
       else if (key.eq.'iz') then
          call str2at(words(2),iatz)
       else if (key.eq.'iprint') then
          call str2at(words(2),iprint)
       end if
       if (nwords.gt.iwrds) then
          do 450 i = 1, nwords
             words(i)  = words(i+iwrds)
             wrdsor(i) = wrdsor(i+iwrds)
 450      continue
          nwords = nwords - iwrds
          go to 150
       end if
       go to 100
       
 1000  continue 
       return
 1990  continue 
       call messag(' weird, fatal error trying to open file.')
       stop
       end

      subroutine autinp(iinp, ilog, first, domore, dorun)
c
c  read inputs for the autobk program.
c  the input parameters are read using keywords from the input
c  given by iounit. the xmu data file is opened, the pre-edge
c  is removed, and the standard chi data (if used) is read. the
c  routine inpdat is used for all data files, allowing either
c  uwexafs or ascii column data.
c
c  notes
c   1.   the case as the word "case" at the top of the routine sets
c     the case of all character strings in this routine. be careful
c     when editing this file.
c
c   copyright 1992  university of washington :          matt newville
c-----------------------------------------------------------------------
       include 'autobk.h'
c-----------------------------------------------------------------------
c local variables
       integer     mfil, iinp, nline, ilen, istrln, nwords
       integer   ilog, idot, maxwrd
       parameter   (mfil = 10, maxwrd = 20)
       integer     i, iwrds, i2, ix, i3, jinit
       integer     ierr, ier, iw, is, iii, ii, iargc
       character*128 str, string, strdat, messg, logfil, stat*10
       character*128 keywrd, words(maxwrd), wrdsor(maxwrd), key*3
       logical      domore, dorun, errskp, first, exist
       external     istrln, iargc
c---------------------------------------------------------------------
c  initialize local variables
       domore =   .false.
       dorun  =   .false.
       jinit  =   1
       nline  =   1
c
c  if first time through, find a version of the input file
c  and open it:                 check upper and lower case
       if (first) then
          jinit  = -1
          exist  =  .false.
          ier    =  0
          stat   =  'old'
          call get_inpfile('autobk.inp',string,ier)

cc          if (macflg) then
c#mac
c#  the following code can be used with the LS Fortran Compiler
c#  thanks to boyan boyanov for this code
cc             open(unit=iinp,file=*,status='old',iostat=ier)
cc             if (ier.ne.0) then
cc                call AlertBox('File selection was canceled!')
cc                go to 1010
cc             end if
cc             call f_setvolume(jvrefnum(iinp))
cc             call f_creator('ttxt')
cccc this resets fname to the name of the opened file. this may be useful
cccc for computing output file names, etc.
cc             inquire(unit=iinp,name=string,iostat=ier)
cc             if (ier.ne.0) string='autobk.inp'
c#mac
cc          end if

c now open log file 
          stat   =  'unknown'
          logfil =  'autobk.log'
          if (string.ne.'autobk.inp') then
             call triml(string)
             idot  = max(1,istrln(string))
             if (index(string(1:idot),'.').ne.0) then 
 15             continue
                if (index(string(idot:idot),'.').eq.0) then
                   idot = idot - 1
                   go to 15
                end if
             end if
             logfil = string(1:idot) //'log'
          end if
          open(unit=ilog, file=logfil, status=stat, err=1020)
          write(ilog,'(2x,2a)') ' ----------------------- automatic',
     $            ' background removal-----------------------'
          ilen = max(1, istrln(versn))
          write(ilog,'(2x,a)') versn(1:ilen) 
c initialize wfftc array if this the first time through.
c this array will remain unchanged throughout the running
c of the program. note that mftfit = 1024 implies that
c k cannot be larger than 51.2 A^-1, and that the spacing
c between points in r-space will be 0.061A
c
cc          mftfit  = 1024
          mftfit  = 2048
          call cffti(mftfit, wfftc)
          first  =  .false.
       end if
c
c 
c-----------------------------------------------------------------------
c      read inputs from command file with keywords
c-----------------------------------------------------------------------
c                        autobk.inp has already been opened as unit #1
 180   format(a)
 200   continue
          errskp = .false.  
          str    = ' '
          keywrd = ' '
          key    = ' '
          call getcom(jinit,string)
          call fixstr(string,str,ilen,words,wrdsor,maxwrd,nwords)
          if (ilen.lt.2) go to 200
          nline  = nline + 1
c
c  if line of minus signs is read, suspend reading of input file
c     until next data set
          if ((str.eq.'getcom_end').or.(str(2:5).eq.'----')) go to 500
          if (str.eq.'getcom_nofile') go to 1000
          if (str.eq.'getcom_error')  go to 1030
c 
c  interpret current words 
 300      continue
          if (nwords.le.0) go to 200
          keywrd = words(1)
          key    = keywrd(1:3)
          iwrds  = 2
c
c----read keywrd and get the right value
          if ( (key.eq.'tit').or.(key.eq.'com') ) then
             call triml(wrdsor(2))
             if (wrdsor(2).ne.' ') then
                i2 = max(1, istrln(wrdsor(2)))
                ix = index( string,wrdsor(2)(:i2) )
                commnt = string(ix:)
             end if
             go to 200
          elseif ( (keywrd.eq.'data').or.(keywrd.eq.'xmu') ) then
             i2 = max(1, istrln(wrdsor(2)))
             errskp = .true.
             if (nwords.ge.3) then
                i3 = max(1, istrln(wrdsor(3)))
                strdat = wrdsor(2)(:i2+2)//wrdsor(3)(:i3)
                call filrec(strdat, xmuf, skeyxm, nkeyxm)
             else
                xmuf   = wrdsor(2)
                nkeyxm = 0
                skeyxm = ' '
             end if
             dorun = .true.
          elseif( (keywrd(1:4).eq.'theo')
     $            .or.(keywrd(1:4).eq.'stan') ) then
             i2 = max(1, istrln(wrdsor(2)))
             errskp = .true.
             theory = .true.
             if (nwords.ge.3) then
                i3 = max(1, istrln(wrdsor(3)))
                strdat = wrdsor(2)(:i2+2)//wrdsor(3)(:i3)
                call filrec(strdat, theorf, skeyth, nkeyth)
             else
                theorf = wrdsor(2)
                nkeyth = 0
                skeyth = ' '
              end if
           elseif ((key.eq.'out').or.(keywrd.eq.'chi')) then
              chif   = words(2)
           elseif ((keywrd.eq.'form').or.(keywrd(1:5).eq.'forma')) then
              frminp = words(2)
              frmout = frminp
           elseif (keywrd.eq.'formin') then
              frminp = words(2)
           elseif (keywrd.eq.'formout')  then
              frmout = words(2)
c  --energy values
           elseif((key.eq.'ee').or.(key.eq.'e0')) then
              call str2dp(words(2),  ee, ierr)
              eefind = .false.
           elseif ((key.eq.'eef').or.(key.eq.'e0f')) then
              call str2dp(words(2),  ee, ierr)
              eevary = .false.
              eefind = .false.
           elseif (keywrd.eq.'fixe0') then
              call str2lg(words(2),  eevary, ier)
              eevary = .not.eevary
           elseif ((keywrd.eq.'thefix').or.(keywrd.eq.'fixthe')) then
              call str2lg(words(2),  thefix, ier)
           elseif (keywrd.eq.'fixamp') then
              call str2lg(words(2),  thefix, ier)
           elseif ((keywrd.eq.'predg1').or.(keywrd.eq.'pre1')) then
              call str2dp(words(2),  predg1, ierr)
           elseif ((keywrd.eq.'predg2').or.(keywrd.eq.'pre2')) then
              call str2dp(words(2),  predg2, ierr)
           elseif (keywrd.eq.'nterp') then
              call str2in(words(2),  nterp, ierr)
           elseif (keywrd.eq.'nnorm') then
              call str2in(words(2),  nnorm, ierr)
           elseif (keywrd.eq.'nor1') then
              call str2dp(words(2),  enor1, ierr)
           elseif (keywrd.eq.'nor2') then
              call str2dp(words(2),  enor2, ierr)
           elseif ((key.eq.'ste').or.(key.eq.'edg')) then
              call str2dp(words(2),  step, ierr)
              stfind = .false.
           elseif (keywrd(1:4).eq.'emin') then
              call str2dp(words(2),  emin, ierr)
           elseif (keywrd(1:4).eq.'emax') then
              call str2dp(words(2),  emax, ierr)
           elseif ((key.eq.'kmi').or.(key.eq.'qmi')) then
              call str2dp(words(2),  qmin, ierr)
              emin = qmin**2 / etok
           elseif ((key.eq.'kma').or.(key.eq.'qma')) then
              call str2dp(words(2),  qmax, ierr)
              emax = qmax**2 / etok
           elseif (keywrd(1:5).eq.'mucol') then
              call str2in(words(2),  imucol, ierr)
c
c-fourier transform
           elseif ((key(1:2).eq.'kw').or.(key(1:2).eq.'qw')
     $             .or.(key.eq.'w')) then
              call str2dp(words(2),  qweigh, ierr)
           elseif ((key.eq.'dk1').or.(key.eq.'dq1') ) then
              call str2dp(words(2),  windo1, ierr)
           elseif ((key.eq.'dk2').or.(key.eq.'dq2') ) then
              call str2dp(words(2),  windo2, ierr)
           elseif ((key.eq.'dk').or.(key.eq.'dq') ) then
              call str2dp(words(2),  windo1, ierr)
              windo2 = windo1
           elseif (key.eq.'han') then
              call str2dp(words(2),  windo1, ierr)
              iwindo = 1
              winstr   = 'hanning'
           elseif (key.eq.'win')  then
              if (words(2)(1:3).eq.'han') then
                 winstr   = 'hanning'
                 iwindo = 1
              elseif (words(2)(1:3).eq.'gau') then
                 winstr   = 'gaussian'
                 iwindo = 2
              elseif (words(2)(1:3).eq.'kai') then
                 winstr   = 'kaiser'
                 iwindo = 3
              elseif (words(2)(1:3).eq.'par') then
                 winstr   = 'parzen'
                 iwindo = 4
              elseif (words(2)(1:3).eq.'wel') then
                 winstr   = 'welch'
                 iwindo = 5
              end if
           elseif (keywrd(1:4).eq.'iwin')  then 
              call str2in(words(2),  iwindo, ierr)
           elseif ( (key.eq.'rma').or.(key.eq.'rbk') ) then
              call str2dp(words(2),  rbkg, ierr)
           elseif (key(1:2).eq.'r1') then
              call str2dp(words(2),  r1st, ierr)
c - -fourier transform, 
c - -fit, normalization flags              
           elseif (keywrd.eq.'nknots') then
              call str2in(words(2),  nsplin, ierr)
              gvknot = .true.
           elseif ((keywrd.eq.'norm').or.
     $             (keywrd(1:4).eq.'nor ')) then
              if (words(2)(1:3).eq.'fun')   funnrm = .true.
              if (words(2)(1:3).eq.'bkg')   funnrm = .true.
              if (words(2)(1:3).eq.'ste')   funnrm = .false.
              if (words(2)(1:3).eq.'edg')   funnrm = .false.
              if (words(2)(1:3).eq.'num')   funnrm = .false.
              iwrds = 3
c - -output flags
           elseif (keywrd.eq.'toler')  then 
              call str2dp(words(2),  usrtol, ierr)
           elseif ((keywrd.eq.'stiff').or.(keywrd.eq.'spstep')) then
              call str2dp(words(2),  spstep, ierr)
           elseif (keywrd.eq.'iprint')  then 
              call str2in(words(2),  iprint, ierr)
           elseif ((keywrd.eq.'preedge_out').or.
     $             (keywrd.eq.'preout')) then
              call str2lg(words(2),  preout, ier)
              nrmout = preout
           elseif ((keywrd.eq.'norm_out').or.
     $             (keywrd.eq.'nrmout')) then
              call str2lg(words(2),  nrmout, ier)
           elseif ((keywrd.eq.'eshift_out').or.
     $             (keywrd.eq.'eshout')) then 
              call str2lg(words(2),  eshout, ier)
           elseif ((keywrd.eq.'bkgout').or.(keywrd.eq.'bkgxmu')) then
              call str2lg(words(2),  bkgxmu, ier)
           elseif ((keywrd.eq.'bkgksp').or.(keywrd.eq.'bkgchi')) then
              call str2lg(words(2),  bkgchi, ier)
           elseif (keywrd.eq.'bkgrsp') then
              call str2lg(words(2),  bkgrsp, ier)
           elseif ((keywrd.eq.'theksp').or.(keywrd.eq.'thechi')) then
              call str2lg(words(2),  thechi, ier)
           elseif (keywrd.eq.'thersp') then
              call str2lg(words(2),  thersp, ier)
           elseif((keywrd.eq.'chirsp').or.(keywrd.eq.'datrsp')) then
              call str2lg(words(2),  chirsp, ier)
           elseif (key.eq.'all')  then
              call str2lg(words(2),  chirsp, ier)
              bkgxmu = chirsp
              bkgchi = chirsp
              thechi = chirsp
              thersp = chirsp
c comment char for ascii column data files
           elseif ((keywrd.eq.'comment_char').or.
     $             (keywrd.eq.'asccmt')) then
             asccmt  = words(2)(1:2)
c hardwire number of doc lines for ascii column data files
          elseif ((keywrd.eq.'doc_lines').or.
     $            (keywrd.eq.'mdocxx')) then
             call str2in(words(2), mdocxx, ierr )
c-- if the word wasn't recognized as a keyword, skip it and go on
           elseif (.not.errskp) then
              iw = max( 1, istrln(keywrd) )
              is = max( 1, istrln(string) )
              write(messg,'(3a)') 'warning: unknown keyword  < ',
     $             keywrd(1:iw),' > '
              iii   = max(1, istrln(messg))
              call echo( '   '//messg(1:iii))
              messg = '    " '//string(1:is)//' "'
              iii   = max(1, istrln(messg))
              call echo(messg(:iii))
              iwrds = 1
          end if
          if (nwords.gt.iwrds) then
             do 450 i = 1, nwords
                words(i) = words(i+iwrds)
 450         continue
             nwords = nwords - iwrds
             go to 300
          end if
          go to 200
c-----------------------------------------------------------------------
c  done reading the input file:
c  if we got to this line without setting domore to true, then
c  we read no input file name, so we'll return and stop the run
 500    continue
        domore = (str.ne.'getcom_end')  
c
        if (dorun) then
           string = 'autobk: '//xmuf
           ii = max(1, istrln(string))
           call echo('   '//string(1:ii)  )
           string = '        '// commnt
           ii = max(1, istrln(string))
           call echo('   '//string(1:ii)  )
c  output file names: find last '.', and 
c  save position 1 before '.'  in iodot
           if (chif.eq.' ') chif = xmuf
           call triml(chif)
           iodot  = max(1,istrln(chif)) 
           if (index(chif(1:iodot),'.').ne.0) then 
 623          continue
              iodot = iodot - 1
              if (index(chif(iodot+1:iodot+1),'.').eq.0) go to 623
           end if
           chif = chif(1:iodot)//'.chi'
        end if
c normal exit
        return
c-----------------------------------------------------------------------
c end subroutine autinp
 1000  continue
       call fstop(' autobk error: could not find autobk.inp')
 1010  continue
       call fstop(' autobk error: error opening autobk.inp')
 1020  continue
       call fstop(' autobk error: error opening autobk.log')
 1030  continue
       call fstop(' autobk: error reading autobk.inp')
       end

       program diffkk 
c 
c  generate f' and f'' near x-ray resonances for an atom, including 
c  fine-structure due to solid-state effects (ie, xafs/dafs). 
c
c algorithm summary:
c 1 the brennan-cowan implementation of the cromer-libermann (cl) 
c   calculation is used as a starting set of a causal f' and f''. 
c   modifications were made to the bc code, mostly to make it easier 
c   to use, more closely f77 conforming, and smaller.  this data is
c   convolved with a lorenztian, typically with a width of a few ev.
c
c 2 an externally supplied file containing the xafs mu(e) is used to 
c   improve f''.  special support for xmu.dat files from feff is 
c   provided, or the external file can contain *measured* mu(e) for
c   the system of interest.  a simple matching procedure is done to 
c   make the supplied mu(e) match the f'' from cl.  
c
c 3 a differential kramers-kronig transform is used to convert the 
c   changes in f'' (ie f''_supplied - f''_cl) into the changes in  f' 
c   (ie f' - f'_cl).   the kk transform is done using a maclaurin 
c   series method, as suggested in the literature. 
c
c  the result is a causal pair of f' and f'' that reflect the 
c  presence of the atoms neighboring the central atom.
c
c  --  Further notes on the algorithms used and instructions for  --
c  --  program use are given in the program documentation.        --
c
c  copyright 1997,...,2003  matt newville
c  
c  acknowledgements: julie cross, chuck bouldin, john rehr, and
c            bruce ravel contributed to the design of this code.  
c            the best ideas were theirs.  all mistakes are mine. 
c  
c  1.21 using ifeffit atomic data for core-width if ewidth=0 on input
c  
       include 'dkcom.f'
       include '../lib/ifeffit.inc'
       integer  i, ncol, mcol, ierr, ilen
       parameter (mcol = 6)
       double precision  df1(mpts), df2(mpts)
       double precision  o1(mpts), o2(mpts),  atz
       double precision  pre_s1, pre_s2, pre_o1, pre_o2, pre_e1, pre_e2
       character*128     str
       integer  istrln, guess_iz
       external istrln, guess_iz

       versn = '1.3'
       ncol  = mcol
       ndoc  = mdoc
       npts  = mpts
c print version number
       i = ifeffit(' ')
       write(str,'(3a)') ' --  diffkk version ', versn, '--'
       ilen = istrln(str)
       call messag(str(1:ilen))
c read diffk.inp 
       call dkinp
c read mu(e) data, convert to f''(e) on an even energy grid
       write(str,'(2a)')  ' Reading experimental data: ',
     $      xmufil
       ilen = istrln(str)
       call messag(str(1:ilen))

       write(str,'(3a)')  'read_data(file=',
     $      xmufil(1:istrln(xmufil)),',group=dat,type=raw)'
       i = ifeffit(str)
       i = iffgetstr('column_label',str)
       if (str(1:13).eq.'--undefined--') then
          call messag( '  diffkk: fatal error.')
          goto 999
       endif
c
       

       write(str,'(a,i1)')  'set dat.energy = dat.',iencol
       if (iencol .ge.10) then
          write(str,'(a,i2)')  'set dat.energy = dat.',iencol          
       endif
       i = ifeffit(str)
       write(str,'(a,i1)')  'set dat.expdat = dat.',imucol
       if (imucol .ge.10) then
          write(str,'(a,i2)')  'set dat.expdat = dat.',imucol          
       endif
       i    = ifeffit(str)
       i    = iffgetarr('dat.energy', energy)
       npts = iffgetarr('dat.expdat', expdat)

       if (iatz .le.2)  then
          iatz = guess_iz(energy, expdat, npts, e0)
       end if

       i = iffputsca('e0',  e0)
       i = iffputsca('egrid',  egrid)
       i = iffputsca('elow',  elow)
       i = iffputsca('ehigh',  ehigh)
       i = ifeffit('set ework1 = floor(dat.energy)')
       i = ifeffit('set ework2 = ceil(dat.energy)')
       i = ifeffit('set eout1  = floor(dat.energy) - elow')
       i = ifeffit('set eout2  = ceil(dat.energy) + ehigh')

       i = ifeffit('set w.energy = range(ework1,ework2,egrid)')
       i = ifeffit('set o.e1     = range(eout1,ework1-egrid,egrid)')
       i = ifeffit('set o.e2     = range(ework2+egrid,eout2,egrid)')
       i = ifeffit('set o.energy = range(eout1,eout2,egrid)')

       i = ifeffit('set w.expdat = linterp(dat.energy,'//
     $      'dat.expdat,w.energy)')
       if (f2tof1) then 
cc          i  = ifeffit('set w.expdat = w.expdat * '//
cc     $         'w.energy/(max(1,e0))')
       endif
       npts = iffgetarr('w.energy', energy)
       npts = iffgetarr('w.expdat', expdat)

cc       print*,' npts =', npts
c
c generate initial tables of f' f'' on the same energy grid
       atz= iatz * 1.d0
       i = iffputsca('iz', atz)

       i = ifeffit('f1f2(energy=o.e1, z=iz)')

       i = ifeffit('set wid = core_width')
       if (ewidth.gt.0.d0) i = iffputsca('wid', ewidth)

       i =  ifeffit('f1f2(energy=w.energy, z=iz,width=wid)')
c       i=ifeffit('pre_edge(w.energy, w.f2, e0=e0)')
c       i=ifeffit('set cl_step = edge_step')
c       i=ifeffit('set cl_0 = pre_slope*floor(w.energy)+pre_offset')
c
c       i=ifeffit('pre_edge(w.energy, w.expdat, e0=e0)')
c
c       i=ifeffit('set dt_step = edge_step')
c       i=ifeffit('set dt_0 = pre_slope*floor(w.energy)+pre_offset')
c
c       i=ifeffit('set w.expscal = (cl_0-dt_0)+'//
c     $      ' w.expdat*cl_step/dt_step')

       i=ifeffit('set w.expscal =w.expdat')
       print*, ' hello expdat is simple! ' 
c

       npts = iffgetarr('w.expscal', expdat)

       i=ifeffit('f1f2(energy=o.e1, z=iz,width=wid)')
       i=ifeffit('set o.f1_low = o.f1')
       i=ifeffit('set o.f2_low = o.f2')
       
       i = ifeffit('f1f2(energy=o.e2, z=iz,width=wid)')
       i=ifeffit('set o.f1_high = o.f1')
       i=ifeffit('set o.f2_high = o.f2')


c broaden f1cl and f2cl
       i=iffgetarr('w.f1', f1cl)
       i=iffgetarr('w.f2', f2cl)
       i=ifeffit('set w.f1_cl = w.f1')
       i=ifeffit('set w.f2_cl = w.f2')
c
c align/shift/scale improved f''  to tabulated f''(df2 = expdat - f2cl)
       call chrdmp(' Matching experimental data to Cromer-Libermann ')
       if (f2tof1) then 
          call messag(' f'''' ')
       else
          call messag(' f'' ')
       end if

c$$$       call dkfit
c$$$       call dkfcn(npts,numvar,xvarys,df2,ierr)
          
       
       do 20 i = 1, npts
          df2(i) = -f2cl(i) +  expdat(i)
c     f(i) = -f2cl(i) + x(2) + x(3) * fx
c     $            + e * (x(4) + x(5)  * e )
 20      continue 

c do kk transform of delta f''  -> delta f'
       call messag(' Doing difference Kramers-Kronig transform')
       if (f2tof1) then
          call kkmclr(npts, energy, df2, df1)
       else
          call kkmclf(npts, energy, df2, df1)
       endif
c add delta f' to initial f', delta f''  to initial f''
       do 100 i = 1, npts
          o1(i)  = df1(i) + f1cl(i)
          o2(i)  = df2(i) + f2cl(i)
 100   continue 
       i = iffputarr('w.f1', npts, o1)
       i = iffputarr('w.f2', npts, o2)
c
c construct output on wider range
       i = ifeffit('set o.f1_cl = '//
     $      'join(join(o.f1_low, w.f1_cl),o.f1_high)')
       i = ifeffit('set o.f1 = '//
     $      'join(join(o.f1_low, w.f1),o.f1_high)')

       i = ifeffit('set o.f2_cl = '//
     $      'join(join(o.f2_low, w.f2_cl),o.f2_high)')
       i = ifeffit('set o.f2 = '//
     $      'join(join(o.f2_low, w.f2),o.f2_high)')


c play with docs (put user titles at top,
c      keep as many old doc lines as fit)
       i = iffputstr('doc', title(1))

       if (active)  then
          call messag(' ')
          call messag('  Ready to write out data file:')
          call askstr('** output file name',outfil)
       end if

       write(str,'(3a)')  'write_data(file=',
     $      outfil(1:istrln(outfil)),
     $      ',o.energy,o.f1,o.f2,o.f1_cl,o.f2_cl,$doc)'

       i =  ifeffit(str)
       i =  ifeffit('save diffkk.sav')
       call messag(' writing summary to diffkk.log')
       call dklog
       call messag(' -- diffkk done -- ')
 999   continue 
       end

       subroutine chipth(ampfef, phafef, qfeff, xlamb, realp, nfxpts,
     $      reffin,  nkpar, akpts, aamp,apha, mchiq,chiqr,chiqi)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  evaluate the theoretical chi(k) for a scattering path given 
c  information from feff arrays  (ampfef .. degen) and xafs path 
c  parameters  (s02 .. apha) 
c
c input:
c    ampfef   amplitude from feff for the path
c    phafef   phase shift from feff (w/o 2*k*r term) for the path
c    qfeff    k-values from feff for the other feff arrays
c    xlamb    mean-free-path from feff
c    realp    real part of p (momentum) from feff
c    nfxpts   number of data points in the feff arrays
c    reff     half path length for the path
c    nkpar    # of k-points for k, phase, and array path parameters
c    akpts    array of k-points for array path parameters
c    aamp     array of amplitude-points for array path parameters
c    apha     array of phase-points for array path parameters
c    mchiq    array dimension for chiqr and chiqi
c output:
c    chiqr    real  \   part of complex chi(k) for this path
c    chiqi    imag  /   with all path parameters applied
c **note measured chi(k) data corresponds to  chiqi **
c
c in param() (from pthpar.h):
c    degen    path degeneracy (# of equivalent paths)
c    s02      constant multiplicitive amplitude factor for the path
c    e0shft   e0 shift to use for the path
c    e0imag   imaginary e0 shift / broadening for the path
c    delpha   constant phase shift (delta phase )
c    deltar   delta r to add to reff for the path
c    sigma2   debye-waller factor for the path
c    third    third cumulant for the path
c    fourth   fourth cumulant for the path
c
c------------------------------------------------------------------
       implicit none
       include 'consts.h'
       include 'pthpar.h'
       integer     izero, ipos, i, nfxpts, nqdata, mchiq, nqffmx
       integer     nkpar, nkpos
       complex*16        coni, cp, cp2, cphshf, cdwf, cargu, cchi, ciei
       double precision  akpts(*), aamp(*), apha(*), tmpa, tmpp
       double precision  pparams(10)
       double precision  chiqr(mchiq), chiqi(mchiq)
       double precision  e0eff, s02r2n, degen, reffin, reff
       double precision  s02, e0shft, e0imag, delpha, deltar, sigma2
       double precision  first, fourth, r2m2,  energy, q, third
       double precision  small,  half, expmax, expmin
       double precision  rep, xlam, cxlam, pha, amp, car, x3rd, x4th
       double precision  ampfef(nfxpts), phafef(nfxpts), qpos
       double precision  qfeff(nfxpts), xlamb(nfxpts),  realp(nfxpts)
       logical  le0big, iskpar
       parameter (coni = (0.d0, 1.d0) )
       parameter (small=1.d-6, half =0.5d0)
       parameter (expmax= 85.d0, expmin = -expmax)
c------------------------------------------------------------------
       degen  = param(jfpdeg)
       s02    = param(jfps02)
       e0shft = param(jfpe0)
       e0imag = param(jfpei)
       delpha = param(jfppha)
       deltar = param(jfpdr)
       sigma2 = param(jfpss2)
       third  = param(jfp3rd)
       fourth = param(jfp4th)

c  combine path parameters and feff data to get theory chi
c  note: feff writes out the feffnnnn.dat files such that
c    phase = 2*q*r + phase_shifts. additional phase shifts and
c    all amplitude reduction terms use p, the complex momentum.
c    q is used only to reproduce chi(k) from feff
       nqffmx = int((qfeff(nfxpts) + 1.d0) / qgrid) + 1
       nqdata = min(nqffmx, mchiq)
c       print*, 'chipth: nqffmx, nqdata, nqvals, mchiq'
c       print*,  nqffmx, mchiq, nqdata

c tranquada correction
       reff   = max(small, reffin)
       first  = deltar - 2 * sigma2 / reff
       r2m2   =  1 / (reff + deltar)**2
       le0big = (abs(e0shft).ge.small)
       iskpar = nkpar.gt.0
cc       print*, ' CHIPTH ', nkpar, iskpar
c ipos is a place holder for the routine lintrp
c izero stores the index of the q = 0. location.
       ipos   = 1
       nkpos  = 1
       izero  = 0
c store some multiplications/divisions before the main loopa
       e0eff  = e0shft * etok
       ciei   = coni * e0imag * etok
       s02r2n = degen * s02 * r2m2
       x4th   = fourth / 3
       x3rd   = 2 * (third / 3)

c the official xafs calculation loop:
       do 500 i = 1, nqdata
c  e0-shift the value of q
          q   = (i - 1) * qgrid
          if (le0big) then
             energy = q*q - e0eff
             q      = sign(one,energy) * sqrt(abs(energy))
          end if
c  q = zero is special, and will be dealt with below
          if (abs(q).le.small) then
             izero = i
          else
c  cubic spline interpolatation of 
c  amplitude, phase, realp and xlamb of feff chi
             call hunt(qfeff,nfxpts,q,ipos)
             qpos = 0
             if (abs(qfeff(ipos+1) - qfeff(ipos)).gt.small) then
                qpos = (q-qfeff(ipos))/(qfeff(ipos+1)-qfeff(ipos))
             endif
             pha = phafef(ipos) + qpos*(phafef(ipos+1) -phafef(ipos))
             amp = ampfef(ipos) + qpos*(ampfef(ipos+1) -ampfef(ipos))
             rep = realp(ipos)  + qpos*( realp(ipos+1) - realp(ipos))
             xlam= xlamb(ipos)  + qpos*( xlamb(ipos+1) - xlamb(ipos))
c  k-dependent path parameters
             if (iskpar) then
                call hunt(akpts,nkpar,q,nkpos)
                nkpos = min(nkpar-1,max(1,nkpos))
                qpos = 0
                if (abs(akpts(nkpos+1) - akpts(nkpos)).gt.small) then
                   qpos = (q - akpts(nkpos))/
     $                  (akpts(nkpos+1)-akpts(nkpos))
                endif
                tmpa = aamp(nkpos) + qpos*(aamp(nkpos+1) -aamp(nkpos))
                tmpp = apha(nkpos) + qpos*(apha(nkpos+1) -apha(nkpos))
                amp  = amp * tmpa
                pha  = pha + tmpp
             endif
c  evaluate complex momemtum
             cp2    =  (rep + coni/xlam)**2 + ciei
             cp     =  sqrt(cp2)
c  mean free path, complex debye-waller factor and phase shift
             cxlam  =  -2*reff* dimag(cp)
             cdwf   =  -2*cp2 * (sigma2 -  cp2 * x4th)
             cphshf =   2*cp  * (first  -  cp2 * x3rd) + delpha
c  create complex chi, first checking that the exponential won't crash
             cargu  =  cxlam + cdwf + coni*(2*q*reff + pha + cphshf)
             car    =  max(expmin, min(expmax, dble(cargu)))
             cchi   =  (amp * s02r2n / abs(q)) *
     $                     exp(dcmplx(car, dimag(cargu)))
c  save real and imag chi for this value of q
             chiqi(i) = dimag(cchi)
             chiqr(i) = -dble(cchi)
          end if
 500   continue
c  fill in guess for data at q = zero if needed
       if (izero.eq.1)  then
          chiqr(1) = 2*chiqr(2) - chiqr(3)
          chiqi(1) = 2*chiqi(2) - chiqi(3)
       elseif (izero.ge.2) then
          chiqr(izero) = (chiqr(izero-1) + chiqr(izero+1)) * half
          chiqi(izero) = (chiqi(izero-1) + chiqi(izero+1)) * half
       end if
       return
c end subroutine chipth
       end

      subroutine iff_plot_init(index)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c initialize common blocks for plotting in ifeffit
c       
       implicit none
       include 'consts.h'
       include 'ifplot.h'
       save
       character*64  pltdev, dstr*128, d1str*16, desc
       integer index, j, k, pgopen, ii, ndevx, inter, i
       integer tlen, dlen , istrln
       external  pgopen, istrln

cc       print*, 'iff_plot_init: index = ', index
       
       if ((index.eq.99) .and.(icurdev.gt.0)) call pgclos
       nplot  = 0
       do 90 j = 1, 4
          xlim(j)  = 0
          tlim(j)  = 0
          limits(j) = .false.
 90    continue 
       igrid     = 1
       inplot    = 0
       nplabs    = 0
       ipgwin(4) = 0
       ipgwin(3) = 0
       ipgwin(2) = 0
       ipgwin(1) = 0
       icurwin   = 1
       do 100 j = 1, mplabs
          pltlab(j) = undef
          xplabs(j) = 0
          yplabs(j) = 0
 100   continue 
       npmark    = 0
       do 105 j = 1, mpmark
          imarker(j) = -13000
          xmarks(j)  = 0
          ymarks(j)  = 0
          mrkcol(j)  = 0
 105   continue 

       do 130 j = 1, mpdevs
          ipgdev(j) = -1
          pgdevs(j) = ' '
 130   continue 
       call gettxt('plot_device',pltdev)

       do 240 j = 1, maxplt
          icol(j)   = j
          isty(j)   = 1
          pltsty(j) = undef
          pltkey(j) = ''
          do 220 k = 1, maxpts
             plot_x(k,j) = 0
             plot_y(k,j) = 0
 220      continue 
 240   continue 

       call settxt('plot_file', ' ')
       do 265 j = 1, mctabl
          pltcol(j) = undef
 265   continue 
c
       pltcol(0)      = 'white'
       pltcol(mcolbg) = 'white'
       pltcol(mcolfg) = 'black'
       pltcol(mcolgr) = '#CCBEE0'
       pltcol( 1) =  'blue'
       pltcol( 2) =  'red'
       pltcol( 3) =  'darkgreen'
       pltcol( 4) =  'black'
       pltcol( 5) =  'magenta'
       pltcol( 6) =  'maroon'
       pltcol( 7) =  'yellow'
       pltcol( 8) =  'orange'
       pltcol( 9) =  'purple'
       pltcol(10) =  'grey77'
       do 285 j = 1, 8
          pltsty(j) = 'solid'
 285   continue 

       ilnwid =  2
       ilnsty =  1
       ichrfn =  1
       axisiz =  1.5
       txtsiz =  1.5
       mkrsiz =  1.5
       
c  stuff for "real reset and starting plot device"
       if (index.eq.0)  then
          ii = 16
          ndevx = 0
          call pgqndt(ndevx)
          dstr = ' '
          k    = 1
          do 800 i = 1, ndevx
             call pgqdt(i,d1str,tlen,desc,dlen,inter)
             call triml(d1str)
             j    = istrln(d1str)
             dstr = dstr(1:k)//' '//d1str(2:j) 
             k    = istrln(dstr)
 800      continue 
          call triml (dstr)
          call settxt('plot_devices', dstr)

          call pgqinf('DEV/TYPE', pgdevs(1), ii)
          ipgdev(1) = pgopen(pltdev)
          icurdev   = ipgdev(1)
       else if (index.eq.-1) then
          icurdev = -1
       end if
c       
       return
       end

       subroutine fefinp(mpts, mfil, mtitle, mleg,
     $      title, feffil,  iffrec, degflg, degpth,
     $      refpth, rwgpth, ratpth, theamp,
     $      thepha, qfeff, cphase, sphase,
     $      realp,  xlamb, nlgpth,  izpth, iptpth)
c
c    read path information from feff files:
c    readse either feffnnnn.dat files (feff5 or higher) or the
c    ascii feff.bin files from feff702
c
c    copyright 1996        matt newville
       implicit none
       integer   mpts, mfil, mtitle, mleg, mdocx, npack
       double precision degpth(mfil), refpth(mfil), rwgpth(mfil)
       double precision ratpth(3, 0:mleg, mfil), qfeff(mpts, mfil)
       double precision theamp(mpts, mfil), thepha(mpts, mfil)
       double precision cphase(mpts, mfil), sphase(mpts, mfil)
       double precision realp( mpts, mfil), xlamb( mpts, mfil)
       integer  nlgpth(mfil), iffrec(mfil)
       integer  izpth(0:mleg, mfil), iptpth(0:mleg, mfil)
       character*128 title(mtitle, mfil), feffil(mfil)

       integer   mlegx, mptsx, mwords, j, nleg, itmp, nepts,i
       integer   nwords,l0,ndoc,npot, ilen, ipth, istrln
       integer   nunit, iex, npts, ierr, ntitle, iunit
       parameter (mlegx = 10, mptsx= 100, mwords = 30, mdocx=10)
       character*64  filnam*128, stat*10, str*128, words(mwords)
       character*128 doc(mdocx), messg
       logical          degflg, exist
       integer          izpot(0:mlegx)
       complex*16       phc(mptsx), ck(mptsx), coni, cchi
       double precision xk(mptsx), achi(mptsx), phchi(mptsx)
       double precision beta(mlegx), rf2b, rnrmav
       double precision eps, phff, phffo, xlam, reff, bohr, zero
       parameter (zero = 0.d0, eps = 1.d-12, bohr = 0.529 177 249d0)
       parameter (coni = (0.d0,1.d0))
       parameter (stat = 'old')
       external   istrln
       npack = 8
c  feff.dat data extraction
c  loop to get data from at most maxpth paths
       ipth = 0
  50   continue
       ipth = ipth + 1
c   skip unused paths
       if ((ipth.le.mfil).and.(feffil(ipth).ne.' ')) then
c   get next file name from feffil, check that it exists
          exist  = .false.
          filnam = feffil(ipth)
          call triml (filnam)
          ilen = max(1, istrln(filnam))
          inquire ( file = filnam,  exist = exist)
c  failed to find this file: stop with warning message
          if (.not.exist) call finmsg(1001,filnam, ' ',0)
c  read data from file
          if (iffrec(ipth).eq.0) then
c feff5-style feffnnnn.dat file
             call echo( '        '//filnam(1:ilen))
ccc             print*, 'FEFINP:  call rdffdt '
             call rdffdt(filnam,mtitle,mleg,mpts,ntitle,
     $            nlgpth(ipth), npts,title(1,ipth),
     $            refpth(ipth), rwgpth(ipth),
     $            degpth(ipth), ratpth(1,0,ipth),
     $            iptpth(0,ipth), izpth(0,ipth),
     $            qfeff(1,ipth), theamp(1,ipth),
     $            thepha(1,ipth), cphase(1,ipth), sphase(1,ipth),
     $            xlamb(1,ipth), realp(1,ipth))
cc             print*, '    ', refpth(ipth), degpth(ipth), ipth
cc             print*, 'FEFINP q  ', qfeff(1,ipth), qfeff(2,ipth),
cc     $            qfeff(3,ipth)
             if (.not.degflg) degpth(ipth) = 1
          elseif (iffrec(ipth).ne.0) then
c feff7-style feff.bin
             iunit = 0
             call openfl(iunit,filnam,stat,iex,ierr)
             if ((iex.lt.0).or.(ierr.lt.0))
     $            call finmsg(1003,filnam, ' ',0)
c read top of feff.bin for all the records from this file
             call rdfb1(filnam,iunit,mdocx,mlegx,mptsx, npack,
     $            ndoc, npot,
     $            npts, rnrmav, l0, doc,izpot,phc,ck,xk)
c skip to next record within this file
 120         continue
             read(iunit,'(a)',end=500) str
             call sclean(str)
             call triml(str)
             if (str(1:2).ne.'##')   go to 120
             nwords = 1
             call bwords(str(3:),nwords,words)
             call str2in(words(1) , itmp, ierr)
c  skip this record (and go to next) if this isn't the record we want
             if (itmp.ne.iffrec(ipth)) go to 120
c we found the right record:  read in path information
             ilen = istrln(filnam)
             write(messg,'(a,1x,a,1x,i5)')
     $            filnam(1:ilen), ',', iffrec(ipth)
             ilen = istrln(messg)
             call echo( '              '//messg(1:ilen))
             rwgpth(ipth) = rnrmav
             do 145 i = 1, ndoc
                title(i,ipth) =  doc(i)
 145         continue
             nwords = mwords
             call bwords(str(3:),nwords,words)
             call str2in(words(2), nleg, ierr)
             nlgpth(ipth) = nleg
             call str2dp(words(3), degpth(ipth), ierr)
             call str2in(words(4), nepts, ierr)
             call str2dp(words(5), refpth(ipth), ierr)
             reff  = refpth(ipth) / bohr
             do 170 j = 1, nleg
                call str2in(words(6+j),i,ierr)
                iptpth(j,ipth) = i
                izpth(j,ipth) = izpot(i)
 170         continue
             iptpth(0,ipth) = 0
             izpth(0,ipth)  = izpot(0)
             call rdpadr(iunit,npack,ratpth(1,1,ipth),3*nleg)
             do 190 i = 0, nleg
                do 185 j = 1, 3
                   ratpth(j,i,ipth) = ratpth(j,i,ipth) * bohr
 185            continue
 190         continue
c  note that we really don't care about beta, eta, ri arrays, so we'll
c  just skip them here:
             call rdpadr(iunit,npack,beta,nleg)
             call rdpadr(iunit,npack,beta,nleg)
             call rdpadr(iunit,npack,beta,nleg)
c but we really want these arrays (amplitude and phase)
             call rdpadr(iunit,npack,achi,nepts)
             call rdpadr(iunit,npack,phchi,nepts)
             do 230 j = nepts+1, mptsx
                achi(j)  = zero
                phchi(j) = zero
 230         continue
c now convert this into same info as in feff.dat file
             npts = min(mptsx,npts,mpts)
             phffo = zero
             rf2b  =  reff*reff*bohr
             do 300 i = 1, npts
                cchi = achi(i) * exp (coni*phchi(i))
                if (abs(dimag(ck(i))) .gt. eps) then
                   xlam= 1/dimag(ck(i))
                else
                   xlam = 1.d10
                end if
                if (abs(cchi).ge.eps) then
                   phff = atan2 (dimag(cchi), dble(cchi))
                else
                   phff = zero
                end if
c  remove 2 pi jumps in phases
                call pijump (phff, phffo)
                phffo  = phff
c  save values to arrays
                qfeff(i,ipth) = xk(i) / bohr
                realp(i,ipth) = dble ( ck(i) / bohr )
                xlamb(i,ipth) = xlam  * bohr
                thepha(i,ipth)= phff
                theamp(i,ipth)= abs(cchi*xk(i)*exp(2*reff/xlam))*rf2b
 300         continue
c
c fill in the rest of qfeff so that it is monotonically increasing
             do 350  i = npts+1, mpts
                if(qfeff(i,ipth).lt.qfeff(i-1,ipth)) then
                   qfeff(i,ipth) = 2*qfeff(i-1,ipth)-qfeff(i-2,ipth)
                   theamp(i,ipth)= zero
                end if
 350         continue
c
c if the next {feffil,iffrec} set has the same file name,
c read the next record
             if ((ipth.lt.mfil) .and.
     $            (feffil(ipth+1).eq.feffil(ipth))) then
                ipth = ipth + 1
                go to  120
             end if
 500         continue
             close(iunit)
c  done reading feff.bin entry
          end if
          go to 50
c
       end if
       return
 998   format(a1,a)
 999   format(a)
c end subroutine fefinp
       end

       subroutine wrtprm(iout, ifmt, mlen, name, i1, x1, x2)
c simple dump of named parameters to (unit=iout) with choice of formats
c     ifmt=0  ->   " name  =   x1  % +/- % x2 "
c     ifmt=1  ->   " name  i1  x1  % +/- % x2 "
       character name*(*)
       double precision   x1, x2, ten, order, tiny
       parameter (ten = 10.d0,  tiny = 1.d-8)
       integer   ilen, istrln, iout, ifmt, mlen, i1
       external  istrln
       ilen    = max(mlen,  istrln(name))
       order   = dabs(log(tiny + abs(x1) ) )
       if ((order.gt.ten).and.(ifmt.eq.0)) then
          write(iout,250) name(1:ilen),    x1, x2
       elseif ((order.gt.ten).and.(ifmt.eq.1)) then
          write(iout,200) name(1:ilen),i1, x1, x2
       elseif ((order.le.ten).and.(ifmt.eq.0)) then
          write(iout,150) name(1:ilen),    x1, x2
       elseif ((order.le.ten).and.(ifmt.eq.1)) then
          write(iout,100) name(1:ilen),i1, x1, x2
       end if
 100   format(3x,a,' ',i4,' ',f14.7,'  % +/- %', f14.7)
 150   format(3x,a,' = ',     f14.7,'  % +/- %', f14.7)
 200   format(3x,a,' ',i4,' ',e14.5,'  % +/- %', e14.5)
 250   format(3x,a,' = ',     e14.5,'  % +/- %', e14.5)
       return
       end

       program autobk
c
c  autobk   version 2.92b  07-Dec-2000
c
c  author   Matthew Newville,  The University of Chicago
c  e-mail   newville@cars.uchicago.edu
c  post     GSECARS, Bldg 434A
c           APS, Argonne National Laboratory
c           Argonne, IL 64309 USA
c  voice    (630) 252-0431
c  fax      (630) 252-0443
c
c further information on this code is available at
c      http://cars.uchicago.edu/~newville/autobk/
c
c --- copyright 1998,1999  matt newville
c --- copyright 1995  matt newville, university of washington
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c  autobk removes the background of x-ray-absorption fine-structure
c  data.  a spline function is used to approximate the background. 
c  the spline is chosen so that the resulting chi is optimized at 
c  low-r. the optimization minimizes the difference between the
c  data and a standard chi(r) at low-r.  the standard is used to
c  estimate the leakage form the first shell into the low-r region,
c  and since this leakage is a small portion of the first shell, the
c  standard does not need to be an extremely accurate estimate of
c  the true first shell.  the standard chi should be a chi for which
c  the background is trusted, and can be either a theoretical
c  calculation or an experimental standard.  if no standard chi is
c  specified, the low-r components of chi(r) will be minimized. 
c
c major revisions (for a complete revision record, contact matt) :
c
        include 'autobk.h'
c------------------------------------------------------------------
c   local variables
       character system*10
       logical   first, domore, dorun
       integer   iinpf, ilogf, ilen, istrln
       external  istrln
       data      first, domore, dorun /.true.,.true.,.true./ 
       data      iinpf, ilogf / 2, 4/ 
       data system /'unix'/
c system options:  'unix','vax','dos','mac'
       call setsys(system,vaxflg,dosflg,macflg,unxflg)
       call sca_init
       call echo_init
       call open_echofile('autobk.run')
       call fstop_init('autobk.err')
c      version & date
       ilen   = max(1,istrln(system))
       versn  = '   autobk:  2.941  10-Jan-2004 '
       ilen   = istrln(versn)
       call echo(versn(1:ilen))
c------------------------------------------------------------------
c loop for each different running of program
 100   continue
c     initialize variables in common blocks, open files
       call autint
c     read input file 
       call autinp(iinpf, ilogf, first, domore, dorun)
       if (dorun) then
c      read in data, subtract pre-edge, reset fitting ranges, etc
          call autdat
c      do nonlinear least-square fittings for background, and
c      possibily e0 and amplitude of theory.
          call autnls
c      write out results to log file
          call autlog(ilogf)
c      write out data results to data files
          call autout
       end if
c      continue on to next data set
       if (domore) go to 100
c----------------------------------------------------------------
c  finished: close files, and give happy ending message
       close(iinpf)
       close(ilogf)
       call echo( '   autobk is finished.')
       call echo( '                     have a nice day.')
       call close_echofile()
c  end main program autobk
       end

       subroutine rdffdt(ffname,mtitle,mleg,mpts, ntitle, nleg, npts,
     $      title, reff, rwignr, degen, xyz, ipot, iz,
     $      qf,amplit,phase,cphase,sphase,xlamb,realp)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  read a feffnnnn.dat file
       implicit none
       integer  i, ier1, ier2, ier3, ier4, ix, ileg, nwords
       integer      mtitle, mleg, mpts, ntitle, nleg, npts, istrln
       character*(*) ffname, title(mtitle), filnam*128
       integer       ipot(0:mleg), iz(0:mleg)
       double precision  reff, rwignr, degen, xyz(3,0:mleg)
       double precision  qf(*), amplit(*), phase(*)
       double precision  cphase(*), sphase(*)
       double precision  xlamb(*), realp(*), zero, xlmin

       character*40 stat*5, line*90, words(16), messg*80
       integer  iunit, iex, ierr
       parameter (zero = 0, xlmin = 1.d-8)
       double precision cdel, afeff,phfeff, redfac, xk, xlmda,  preal
       external istrln
       data  stat /'old'/

       iunit = 0
       xk    = zero
       filnam = ffname
       call openfl(iunit, filnam , stat, iex, ierr)
       if ((iex.lt.0).or.(ierr.lt.0))
     $      call warn(3, ' error reading file: '//filnam)
c  read top of feff.dat, keeping first mtitle comment lines
       ntitle = 0
 150   continue
       ntitle = ntitle + 1
       read(iunit,999) line
       call sclean(line)
       call triml(line)
       if (line(3:6) .eq. '----')  goto 200
       if (ntitle.le.mtitle) title(ntitle) = line
       go to 150
 200   continue
c   read and save reff and degen: feff version 5.03 and higher
       read(iunit,999) line
       call sclean(line)
       nwords = 4
       call bwords(line(2:), nwords, words)
       call str2in(words(1), nleg,   ier1)
       if (nleg .gt. mleg) then
          write(messg,'(2x,a,i2)')
     $         'too many legs in path. current limit is', mleg
          call echo(messg)
          call warn(2,'   '//filnam)
       end if
       call str2dp(words(2), degen,  ier2)
       call str2dp(words(3), reff,   ier3)
       call str2dp(words(4), rwignr, ier4)
       if ( (ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0).or.
     $      (ier4.ne.0) )   then
          call warn(3, '   bad data in feffnnnn.dat file: '//filnam)
       end if
c   skip label and read and save path coordinates information
       read(iunit,999) line
       call sclean(line)
       nwords = 5
       do 300  ileg = 0, nleg - 1
          read(iunit,999) line
          call sclean(line)
          call bwords(line(2:), nwords, words)
          do 270 ix = 1, 3
             call str2dp( words(ix), xyz(ix,ileg),ierr )
 270      continue
          call str2in( words(4), ipot(ileg), ierr )
          call str2in( words(5), iz(ileg), ierr )
 300   continue
c      fill in last coordinate = first coordinate
       do 350  ix = 1, 3
          xyz(ix,nleg) = xyz(ix,0)
 350   continue
       iz(nleg)   = iz(0)
       ipot(nleg) = ipot(0)
c
c  skip one line then
c  read in q, amplit, phase, and real and imag parts of p
       read(iunit,999) line
       call sclean(line)
       nwords  = 7
       do 500 i = 1, mpts + 1
c
c          read(iunit,*, end = 505) xk, cdel, afeff, phfeff,
c     $        redfac, xlmda, preal

          if (i.gt.mpts) then
             call echo('  not enough memory for feff file: '//filnam)
             write(messg,'(2x,a,i3,a)') 'results above k = ',
     $            int(xk), ' will not be reliable'
             call warn(3, messg)
          end if

          read(iunit,999,end=505) line
          call sclean(line)
          if (istrln(line).ge.1)  then 
             call bwords(line, nwords, words)
             if (nwords .lt. 7) then
                call echo(' invalid feff file: '//filnam)
                go to 505
             end if
             call str2dp(words(1), qf(i),     ier1)
             call str2dp(words(2), cphase(i), ier1)
             call str2dp(words(3), amplit(i), ier1)
             call str2dp(words(4), sphase(i), ier1)
             call str2dp(words(5), redfac,    ier1)
             call str2dp(words(6), xlmda,     ier1)
             call str2dp(words(7), realp(i),  ier1)
             
             amplit(i) = amplit(i) * redfac
             xlamb(i)  = max(xlmin, xlmda)
          end if
 500   continue
 505   continue
       npts = i - 1
       close(iunit)
c
c  make sure no 2pi jumps in phase
       phase(1)  = cphase(1) + sphase(1)
       do 800  i = 2, npts
          call pijump ( cphase(i), cphase(i-1))
          call pijump ( sphase(i), sphase(i-1))
          phase(i)  = cphase(i) + sphase(i)
 800   continue
c
c  check that qf is monotonically increasing, filling in the high k
c  points if needed (feff provides monotonically increasing data, so the
c  first npts of qf are ok -- we just want to fill in the rest
c  of the points for later extrapolations)
       do 850  i = npts,  mpts
          if (qf(i).lt.qf(i-1)) then
             qf(i)=2*qf(i-1)-qf(i-2)
             amplit(i) = zero
             cphase(i) = zero
             sphase(i) = zero
             phase(i)  = zero
             realp(i)  = zero
             xlamb(i)  = 1.d10
          end if
 850   continue
c      done
       return
 999   format(a)
c end subroutine rdffdt
       end
       subroutine rdfb1(ffname,iunit,mtitle,mleg,mpts,npack,
     $      ntitle,npot,npts,rnrmav,l0,title,izpot,phc,ck,xk)
c
c  read top of feff.bin
       implicit none
       integer npot, npts, mtitle, mleg, mpts, iunit, ivers
       character*(*) ffname, filnam*128, title(mtitle), baddat*256
       integer izpot(0:mleg), l0, ntext,i, ntitle,ier1, ier2, ier3
       integer mptsx
       parameter(mptsx= 128)
       complex*16       phc(*), ck(*)
       double precision xk(*), ere(mptsx), rnrmav 
       integer  mwords, ierr, nwords, npack
       character*128 str
       parameter (mwords = 20 )
       character*30 words(mwords)
       if (npack.le.3) npack  = 8
       filnam = ffname
       baddat  = '   bad data in feff.bin file: '//filnam
 10    format(a)
c first line identifies file (only)
       read(iunit,10) str
       call sclean(str)
       if ((str(1:10).ne.'#_feff.bin'))  call echo(baddat)
       ivers = 1
ccc       if (str(1:14).eq.'#_feff.bin fil')   ivers = 1
       if (str(1:14).eq.'#_feff.bin v02')   ivers = 2
       
c second line contains ntitle, npot, npts
       read(iunit,10) str
       call sclean(str)
       if ((str(1:2).ne.'#_'))  call echo(baddat)
       nwords = 3
       call bwords(str(3:),nwords,words)
       if (nwords.ne.3)     call echo(baddat)
       call str2in(words(1), ntext, ier1)
       call str2in(words(2), npot,  ier2)
       call str2in(words(3), npts,  ier3)
       if ((ier1.ne.0).or.(ier2.ne.0).or.(ier3.ne.0))
     $      call echo(baddat)
c title lines
       ntitle = min(ntext,mtitle)
       do 20  i = 1, ntext
          read(iunit,10) str
          call sclean(str)
          if (str(1:2).ne.'#"')  call echo(baddat)
          if (i.le.ntitle) title(i) = str(3:)
 20    continue
c line with several numbers, only rnrmav and l0 are needed for exafs
       read(iunit,10) str
       call sclean(str)
       if (str(1:2).ne.'#&')   call echo(baddat)
       nwords = 8
       call bwords(str(3:),nwords,words)
       if (ivers.eq.1) then 
           if (nwords.ne.8)   call echo(baddat)
           call str2dp(words(3), rnrmav, ier1)
           call str2in(words(8), l0, ier2)
           if ((ier1.ne.0).or.(ier2.ne.0))  call echo(baddat)
        elseif (ivers.eq.2) then 
           if (nwords.ne.5)   call echo(baddat)
           call str2dp(words(2), rnrmav, ierr)
           call str2in(words(5), l0, ier2)
           if ((ier1.ne.0).or.(ier2.ne.0))  call echo(baddat)
        end if
c read pot labels and atomic numbers
       read(iunit,10) str 
       call sclean(str)
       if (str(1:2).ne.'#@')   call echo(baddat)
       nwords = min(mwords, 2 * npot + 2 )
       call bwords(str(3:), nwords, words)
       if (nwords.ne.(2 + 2*npot))  call echo(baddat)
       do 30 i = 0, npot
          call str2in(words(2+npot+i),izpot(i),ier1)
          if (ier1.ne.0)    call echo(baddat)
 30    continue 
c
c read packed arrays 
       call rdpadc(iunit,npack,phc, npts)
       call rdpadr(iunit,npack,ere, npts)
       call rdpadc(iunit,npack,ck,  npts)
       call rdpadr(iunit,npack,xk,  npts)
c done
       return
       end

       subroutine iff_set(key,str,wrthis)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: set program variables for ifeffit:
c          scalars, arrays,  strings, string arrays
c arguments:
c      key     command to perform (def, set, guess)     [in]
c      str     command line for ifeffit                 [in]
c
c notes:
c   1. needed changes:
c         a) add string arrays (for titles lines, plot labels, ???)
c         b) support guess
c
c requires:  everything in ifeffit
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'echo.h'
       save
       character*(*)  key, str, prefix*256,  tmpnam*64
       character*2048 formula, bxvals(mkeys)
       integer  iofarr, iofsca, istrln, ilen, iltmp
       integer  icode(micode) , jcode(micode), encod, i_sync
       integer  i, j, k, ntmp, idot, ier, ik, isset, isgues, ix
       integer xafs_path, iup, ret
       double precision tmp2(maxpts), tmpx, getsca
       logical  isarr, isnum, istext, s_is_n, trivial
       logical  isvnam, wrthis,lkeep, ic_is_arr
       external iofarr, iofsca, istrln, isnum
       external isvnam, ic_is_arr, encod, getsca, xafs_path

c find the right thing to evaluate:
c  1. is it something that takes a string value, or a numeric value?
c  2. if numeric, is it an array or a scalar?
c      if not, assume it will be an array, -- we'll check later
c      look for an array with the same name, or the first empty array
c       print*, 'iff_set ', key(1:3), mac_define(1)
       call gettxt('group', prefix)
       call bkeys(str, mkeys, keys, bxvals, nkeys)
c  GUESS / SET / DEF
       if (int(getsca('&sync_level',0)).ge.6)  call iff_sync
       isgues =  0
       isset  =  0
       if (key.eq.'guess') isgues = 1
       if (key.eq.'set')   isset  = 1
       ix = 0
c
 100   continue 
       ix      = ix + 1
       if (ix.gt.nkeys) return
       ntmp   = maxsize_array
       ilen   = istrln(bxvals(ix))
       s_is_n =  isnum(bxvals(ix)(1:ilen))
ccc    formula= '('//bxvals(ix)(1:ilen)//')'
       formula=  bxvals(ix)(1:ilen)

       tmpnam = keys(ix)
       iltmp  = istrln(tmpnam)

cc       print*, ' iff_set: ', tmpnam(:iltmp), ' -> ', formula(1:ilen)

       if ((iltmp.le.0).or.(tmpnam.eq.undef)) then 
          call echo(' Warning -- command ignored (typo?):')
          call warn(1,'     -> '//keys(ix)(1:ik))
          go to 100
       endif
       istext = tmpnam(1:1).eq.'$'
c if the value is undefined, then the string was almost certainly 
c a typo that got misinterpreted by getlin to be "set gibberish"
       if (bxvals(ix).eq.undef) then
          ik = istrln(keys(ix))
          call echo(' Warning -- command ignored (typo?):')
          call warn(1,'     -> '//keys(ix)(1:ik))
          wrthis = .false.
          go to 100
       end if
c
c    is the value defined?
c    is this a text variable?
       if (istext) then
          if (.not.isvnam(tmpnam,3)) then
             ik = istrln(tmpnam)
             call warn(1,' Invalid text string name: '//
     $            tmpnam(1:ik) )
             go to 100
          end if
          if (tmpnam.eq.'$&build') then
             call warn(2,' can''t reset value of $&build')
             go to 100
          endif
cc          call str_eval(bxvals(ix), messg)
cc          print*, ' messg = ', messg(1:20)
          call settxt(tmpnam(2:),bxvals(ix))
          return
c    check for immutable values, like pi:
       elseif (tmpnam.eq.'pi') then
          call warn(2,' can''t reset value of pi')
          go to 100
       elseif (tmpnam.eq.'etok') then
          call warn(2,' can''t reset value of etok')
          go to 100
c    this is a numeric variable (scalar or array and maybe "guess"ed)
       else
c
c   first, check that it's not a macro or command name
          do 280 i = 1 , mckeys
             if (ckeys(i).eq.tmpnam) then 
                ik = istrln(tmpnam)
                call warn(2,' Invalid variable name: '//
     $               tmpnam(1:ik) // '  is a command name')
                go to 100
             end if
 280      continue 
          do 290 i = 1 , macmax
             if (macnam(i).eq.tmpnam) then 
                ik = istrln(tmpnam)
                call warn(2,' Invalid variable name: '//
     $               tmpnam(1:ik) // '  is a macro name')
                go to 100
             end if
 290      continue 
          if (.not.isvnam(tmpnam,-1)) then
             ik = istrln(tmpnam)
             call warn(2,' Invalid variable name: '//
     $            tmpnam(1:ik) )
             go to 100
          end if
c    so encod and decod the array
cc          print*, 'iff_set-> encode for ',s_is_n,' ',formula(1:50)
          if (s_is_n) then
cc             print*, ' call str2dp ', bxvals(ix)(1:ilen) 
             call str2dp(bxvals(ix)(1:ilen),tmparr(1), ier)
             tmparr(2) = zero 
             isarr     = .false.
             trivial   = .true.
             idot      = 0
          else
             trivial   = .false.
cc             print*, ' - encod : ', formula(1:40)
             ier = encod(formula, jcode, icode)
             if (ier.ne.0)  goto 700
             if (iprint.ge.1) call rpndmp(jcode)
             tmparr(1) = zero
             tmparr(2) = zero
cc             print*, ' - decod'
             call decod(icode, micode, consts, scalar, array,
     $            narray, nparr, maxsize_array, maxarr, ntmp, tmparr)
cc             print*, 'iff_set: ntmp = ', ntmp
c    now check whether this should have really been a scalar
c    that is, does the array refer to other arrays??
             isarr = ic_is_arr(icode,micode).and.(ntmp .gt. 1)
             isarr = isarr.and.(isgues.eq.0)
             idot = index(tmpnam,'.')
cc             print*, ' isarr ', ic_is_arr(icode,micode), ntmp
          endif
cc          print*, 'iff_set: isarr, isset = ', isarr, isset
c    this is an array
          if (isarr) then
cc             print*, ' - set_array ', ntmp
             call set_array(tmpnam, prefix, tmparr, ntmp, 1)
             k    = iofarr(tmpnam,prefix,0,0)
             if (k.lt.0) then 
                call echo(' *** error: could not find variable')
                tmpstr = ' *** trying to define '//tmpnam
                call warn(2,tmpstr)
                return
             else if (k.eq.0) then
                call warn(3,' *** error: out of memory')
                return
             endif
             arrfrm(k) = ' '
c
c  here (and only here) do we 'save the formula' of an array
             if (isset.eq.0) then
                arrfrm(k) = formula
                do 440 j = 1, micode
                   icdarr(j,k) = icode(j)
 440            continue
             endif
c             print*, ' saving formula for ', k, ' -> ', tmpnam(1:40)
c             print*, ' == ', arrfrm(k)(1:40)
c             call rpndmp(jcode)
c             call rpndmp(icdarr(1,k))
             call fixarr(k,tmpnam,ntmp,isset)
c 
c  this is a scalar
          else
             idot = index(tmpnam,'.')
cc             print* ,' value is a scalar ', idot, tmpnam
             if (idot.ne.0) then
                k  = istrln(tmpnam)
                ik = istrln(formula)
cc                call rpndmp(icode)
                
                call echo(' ** cannot set scalar value to array **')
                call warn(2,'   '//tmpnam(1:k)//' = '//formula(1:ik))
                return
             end if
c    look up str in list of scalar names
             k = iofsca(tmpnam, 1)
             scanam(k) = tmpnam
             scafrm(k) = ' '
             scalar(k) = tmparr(1)
c    is this a 'set' or 'guess' or is it a 'def'
             if ((isgues.eq.1).or.(isset.eq.1)) then 
                do 460 j = 2, micode
                   icdsca(j,k) = 0
 460            continue
                icdsca(1,k) = k + jscale
                if (isgues.eq.1) icdsca(1,k) = -1
             else
c determine if this is a trivial definition 'z = 22.'
c or even sqrt(4/7), which is to say: no named Program Variables,
c     just constant numbers and operators.
                if (.not.trivial) then 
cc                   print*, ' non trivial scalar'
                   scafrm(k) = formula
                   tmpx      = zero
                   call str2dp(formula,tmpx,ier)
                   if (tmpx .ne. zero) then
                      trivial =
     $                     (abs(tmpx - tmparr(1))/tmpx .le. 1.d-6)
                   elseif(ier.eq.-999) then 
                      trivial = .true.
                      do 470 j = 1, micode
                         if (((icode(j) .ge. 1) .and.
     $                    (icode(j) .lt. jconst))) trivial =.false.
                         if ( (icode(j).eq.jdebye).or.
     $                        (icode(j).eq.jeins)) trivial =.false.
                         if (icode(j).eq.0) go to 475
 470                  continue
 475                  continue
                   endif
                endif
                if (trivial) then
                   scafrm(k) = ' '
                   do 492 j = 1, micode
                      icdsca(j,k) = 0
 492               continue
                   icdsca(1,k) = k + jscale
                   if (isgues.eq.1) icdsca(1,k) = -1
                else
cc                   print*, 'save formula'
                   do 490 j = 1, micode
                      icdsca(j,k) = icode(j)
 490               continue
                endif
             end if
          end if
c finally, check for special system vars
          if (tmpnam.eq.'&screen_echo') then
             i_echo = int(tmparr(1))
          elseif (tmpnam.eq.'path_index') then
             iup = int(tmparr(1))
             call synvar
             if (iup .gt. 0) ret = xafs_path(iup,tmparr,tmp2,tmpx)
          endif
       end if
 700   continue 
       if (ix.lt.nkeys) go to 100
c  end subroutine iff_set
       if (int(getsca('&sync_level',0)).ge.2)  call iff_sync
       return
       end

       subroutine  iff_macro_def(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c define a macro:
c  returns 0 if macro definition is done, 1 if it's still expecting more lines
c  also uses mac_define array for control
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       save

       integer   nwords, i, j, jmac, jtmp, istrln, mwordx, immac
       parameter (mwordx = 12)
       character*(*) str , line*256
       character*64  words(mwordx), op*3
       double precision getsca, x
       external istrln, getsca
       data op / '{"'''/
       nwords = mwordx
       line   = str
c
c if mac_define(1) is 1, then we're reading lines for a defined macro
       if (mac_define(1).ge.1) then
          immac = mac_define(4)
          call sclean(line)
          call triml(line)
          if (mac_define(1).eq.1) then
             mcdesc(immac) =  undef
             if (index(op,line(1:1)).ne.0) then
                call undels(line)
                mcdesc(immac) = line
                line = ' '
             end if
cc             print*, ' macro ', macnam(immac)(1:20)
cc             print*, ' descr ', mcdesc(immac)(1:45)
          end if
          mac_define(1) = mac_define(1) + 1
          jtmp = mac_define(2)
          jmac = mac_define(3)
          if (line.ne.' ')  then
             if (line(1:9).eq.'end macro') then
                imcptr(jtmp)  = -1
                mac_define(1) = -1
                return 
             else
                macstr(jmac) = line
                imcptr(jtmp) = jmac
c      find next available line
                jtmp = jmac
 50             continue
                jmac = jmac + 1
                if (jmac.ge.mcline)  then
                   mac_define(1) = -1
                   return 
                end if
                if (imcptr(jmac).ne.0) go to 50
             end if
          end if
          mac_define(2) = jtmp
          mac_define(3) = jmac
          return 
       endif
c
c if mac_define(1) = 0, then we're setting up the macro _name_ line
c

       call bwords(line,nwords,words)
c  find next blank macro space, and erase any macro with the same name
       do 300 i = 1, macmax
          if (macnam(i).eq.' ') go to 350
c  for each macro i:  macnam(i) = macro name, imacro(i) = 1st macro line
c  then, starting at j = imacro(i), macstr(j) = next macro line,
c  and the next  j = imcptr(j).
c
c  add syntax check: that macro name cannot = other command name!
          if (macnam(i).eq.words(1)) then
             j        = imacro(i)
 200         continue
             jtmp     = imcptr(j)
             macstr(j)= undef
             imcptr(j)= 0
             if (jtmp.gt.0) then
                j = jtmp
                go to 200
             end if
             go to 350
          end if
 300   continue
       i    = i - 1
 350   continue
       jmac = i
c save macro name 
       macnam(jmac) = words(1)
cc       print*, ' mac: ', jmac, ' name = ', macnam(jmac)(:20)
       mac_define(4) = jmac
c get macro arguments
       if (nwords.ge.2) then
          tmpstr = line
          call strclp(tmpstr,words(1),words(2),line)
          nwords = mwordx
          call gtarg(line,blank,blank,1,nwords,words)
cc          print* ,  'args of ', line(1:70)
          do 380 i = 1, nwords
cc             print* , i, ' -> ', words(i)
             mcargd(jmac,i) = words(i) 
             call rmquot(mcargd(jmac, i) )
             call rmdels(mcargd(jmac, i) ,'{','}')
 380      continue 
       end if
c      
c ok, now we're ready to start the new macro       
c  get index of the first line for this macro in the macro array
       jtmp = 0
 450   continue
       jtmp = jtmp + 1
       if (jtmp.gt.mcline)    return
       if (imcptr(jtmp).ne.0) go to 450
       imacro(jmac) = jtmp
c
c jtmp stores "previous index", jmac the "current index".
c if the current line (macstr(jmac)) isn't "end macro",
c then imcptr(jtmp) = jmac.   otherwise imcptr(jtmp) = -1
       jtmp = macmax
       jmac = imacro(jmac)
c set mac_define(1) to  1 to flag that we're waiting
c for more macro lines
       x = getsca('&screen_echo',0)
       if ((x.gt.0.5) .and.  (ioinp.le.0))
     $      call echo('   enter macro lines, ending with "end macro"')
       mac_define(1) = 1
       mac_define(2) = jtmp
       mac_define(3) = jmac
       return 
c end routine iff_macro_def
       end


       subroutine iff_macro_do(indmac, str, ipflag,wrthis)
c execute a macro, including recursive macro calls
c (this exits when _all_ macros have processed)
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       character*(*)   str, arg*2, key*128
       character*2048  com, argu, val 
       logical  wrthis, isamac
       integer istrln, i, j, iffcmd_exec, nword, indmac, ifeffit
       integer isarg, ilen, ipflag, italo, jmac

       external istrln, iffcmd_exec, ifeffit, isamac
       save
c initialization
cc       print*, 'iff_macro_do: indmac, ipflag= ', indmac, ipflag
       ilen   = istrln(str)
       
       iprint   = ipflag
       mac_exec = 1
       imac     = imacro(indmac)
       
       if (nmacro.lt.0)     nmacro = 0
       if (nmac_stop.lt.0)  nmac_stop = 0
       nmacro   = nmacro + 1
       call iff_set_macargs(indmac,str)

 100   continue
       if (nmacro.gt.mcdeep)  then
          call warn(2,'too many macros')
          return
       elseif (nmacro.le.0) then
          return
       endif
       italo  = -99
       com    = undef
       if ((imac.gt.0).and.(imac.le.mcline)) then 
          italo = imcptr(imac)
          com = macstr(imac)
       endif
c insert current macro argument values
 180   format(a,i1)
       do 200 i = 1, mmcarg
          write(arg,180) '$',i
 190      continue 
          isarg = index(com,arg)
          if (isarg.ne.0) then
             ilen = istrln(mcargs(nmacro,i))
             com  = com(1:isarg-1)//mcargs(nmacro,i)(1:ilen)
     $            //com(isarg+2:)
             go to 190
          end if 
 200   continue 
c  get keyword/argument from command line
       call iff_getline(com, key, val, argu, ilen)
       if ((key.eq.'def').and.(argu.eq.' ')
     $      .and.(ilen.ge.0)) ilen = 0

       if (ilen.gt.0) then
c determine if this is a call to another macro
          if (isamac(key,jmac)) then
             imac_save(nmacro)= imcptr(imac)
             nmacro           = nmacro + 1
             imac             = imacro(jmac)
             call iff_set_macargs(jmac,argu)       
             go to 100
          else
             italo = iffcmd_exec(key,argu,wrthis)
             italo = 0
             if (italo.eq.1) then
                call iff_done
                stop
             endif
          endif
       endif

c get index of next macro line
       if (imac.ge.0) then
          imac = imcptr(imac) 
       elseif (imac.eq.-1)  then
          nmacro  = nmacro - 1
          if (nmacro.le.nmac_stop) return
          imac  = imac_save(nmacro)
       endif
       go to 100
c done
       mac_exec = 0
       return 
       end

       subroutine gtarg(str,s1,s2,iblank,nwords, words)
c
c   breaks string into arguments =  words are separated by one or
c   more whitespace, unless "protected" by quotes, braces, or parens. 
c   the protecting characters are stripped off
c
c     args        i/o      description
c     ----        ---      -----------
c     s            i       char*(*) string to be broken up
c     s1           i       open  delimiters to preserve on output
c     s2           i       close delimiters to preserve on output
c     iblank       i       flag for whether to break words on whitespace
c                          (1 yes, 0 comma-only)       
c     nwords      i/o      input:  maximum number of words to get
c                          output: number of words found
c     words(nwords) o      char*(*) words(nwords)
c                          contains words found.  words(j), where j is
c                          greater then nwords found, are undefined on
c                          output.

       integer  i, ibeg, ilen, istrln, icount, iblank
       character*(*) str, s1, s2, words(nwords)
       character s, blank, comma, op*6, cl*6, st1, st2
       logical   comfnd, delims, isquot, border
       parameter (blank = ' ', comma = ',')
       external istrln
       data op, cl / '[{"((''',  ']}"))'''/

       delims = (s1.ne.blank).or.(s2.ne.blank)
       mwords = nwords
       nwords = 0
       call untab (str)
       call triml (str)
       ilen   = istrln (str) + 1
       str    = str//' '
c  check for blank string
       if (ilen .eq. 1) return
       ibeg   = 1
       iprot  = 0
       comfnd = .true.
       isquot = .false.
       i = 0
 100   continue 
       i  = i + 1
       s  = str(i:i)
       if (nwords .ge. mwords)  return
c
c
       border =(s.eq.comma).or.((iblank.eq.1).and.(s.eq.blank))
c if the string is protected, march on til end of protection
       if (index(op,s).ge.1) then
          comfnd = .false.
          ibeg   = i 
          iprot  = index(op,s)
          icount = 0
          if (iprot.gt.0) then
             icount = 1
             st1    = op(iprot:iprot)
             st2    = cl(iprot:iprot)
             isquot = st1.eq.st2
          endif
 120      continue 
          i = i + 1
          s  = str(i:i)
          if (isquot) then 
             if (s.eq.st1) icount = 0
          else
             if (s.eq.st1) icount = icount + 1 
             if (s.eq.st2) icount = icount - 1
          end if
          if ((i.le.ilen).and.(icount.ge.1)) go to 120
          nwords = nwords + 1
          words (nwords) = str (ibeg: i)
cc          print*, ':: nwords ', nwords, ' = ', str(ibeg:i)
          
c  if 'protected delimiters' was not used, strip off first and
c  last characters
          if (.not.delims) words(nwords) = str(ibeg+1:i-1)
          go to 100
c
c if not a comma or blank, we have a word: continue til next blank or comma
c
       elseif (.not.border) then
          comfnd = .false.
          ibeg  = i
 160      continue 
          i = i + 1
          s  = str(i:i) 
          if ((i.le.ilen).and.(s.ne.comma).and.(s.ne.blank)) go to 160
          nwords = nwords + 1
          words (nwords) = str (ibeg: i-1)
          go to 100
c
c keep track of double commas -- count as a blank word
c
       elseif (s.eq.comma) then
          if (comfnd) then
             nwords = nwords + 1
             words (nwords) = blank
          endif
          comfnd = .true.
       end if
       if (i.le.ilen) go to 100
c
       return
c end subroutine gtarg
       end

       subroutine iff_set_macargs(indmac,str)
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       character*(*) str, words(mmcarg)*64
       integer i, ilen, istrln, nword, indmac

cc get macro arguments
       nword  = mmcarg
       do 50 i = 1, mmcarg
          words(i) = ' '
 50    continue
       call gtarg(str,blank,blank,1,nword,words)
cc       if (iprint.ge.8)  print*,  'macro args: ', str(1:30)
       do 60 i = 1, mmcarg
ccc          print* , i, ' -> ', words(i)
          mcargs(nmacro,i) = words(i) 
          if (words(i).eq. ' ') then
             mcargs(nmacro,i) = mcargd(indmac,i)
          else
             mcargs(nmacro,i) = words(i)
          end if
          call rmquot(mcargs(nmacro,i) )
          call rmdels(mcargs(nmacro,i) ,'{','}')
          if ((iprint.ge.8).and.(words(i).ne.' ')) then
             ilen = istrln(mcargs(nmacro,i))
cc             print*, 'macro arg ', i, ':',mcargs(nmacro,i)(:ilen), ':'
          end if
 60    continue 
       return
       end

       subroutine autnls
c
c   this prepares for and calls the canned subroutine lmdif1
c   which will solve the unconstrained non-linear least squares
c   fitting problem. lmdif1 uses a levenberg-marquardt algorithm,
c   and requires an external subprogram to evaluate the function
c   to minimize. the subroutine autfun is used to evaluate this
c   function.
c   the function allows the ordinates of the breakpoints of
c   the spline to vary such that when the optimal b-spline (as
c   discussed in de boor) is put through these breakpoints, and
c   the chi(r) is found using this spline as the background is
c   optimized at low-r.
c
c   copyright 1992  university of washington :          matt newville
c------------------------------------------------------------------
       include 'autobk.h'
c------------------------------------------------------------------
       integer   lenwrk, loop, lminfo, isplin, iup, ilo
       integer   iwork(mtknot), ifft, nemin, nemax, nofx, ne0
       integer   i, nr, ndoc, iend, im, istrln, ntest
       parameter(lenwrk = 2*maxpts*mtknot + 20*mtknot + 2*maxpts   )
       character*128  messg , doc(maxdoc),  type*10,  file*40
       double precision work(lenwrk),  fvect(2*maxpts), varys(mtknot)
       double precision esplin(mtknot), bscoef(mtknot)
       double precision etmp(maxpts), small, anorm(3), toler, tolfac
       double precision sumsqr
       double precision e0, delq, efromq, qmn, qmx, qknot
       double precision e0tst, qmntst, qmxtst, edfmin
       parameter (small  = 1.d-10, tolfac = 1.d-4, edfmin= 100.d0)
       external autfun, nofx, istrln, sumsqr
c-----------------------------------------------------------------------
c----initialization for fitting:
c   -the starting value for the fitting tolerance (1e-5) is empirical.
c    the user will be allowed to change it, if necessary, with usertl.
c    (right now usertl is set to 1).
c   -the fitting is done in single precision. round off is a worry, but
c    i have not been able to get the variables to change enough with the
c    double precision version of lmdif1. this should still be explored.
c-----------------------------------------------------------------------
       toler  = usrtol * tolfac
       e0     = ee + e0shft
       ifft  =  1
       loop   = 0
 100   continue
       lminfo = 0
       loop   = loop + 1
       if (loop.gt.5) then
          call echo('   autobk warning: completed 5'// 
     $         ' fitting loops without a stable result.')
          call echo('                   something may be wrong'//
     $         ' with the fitting,')
          call echo('                   and the background may'//
     $         ' not be reliable.')
          go to 800
       end if
c----start fitting:
       do 120 i = 1, nxmu
          spline(i) = xmudat(i)
 120   continue 
       e0    = ee  + e0shft
c   move emin and emax if e0-shifted
       emin  = emin + e0shft
       emax  = emax + e0shft
       if (emax.le.emin) emax = energy(nxmu)
       nemin = nofx(emin,energy,nxmu)
       nemax = nofx(emax,energy,nxmu)
       emin  = energy(nemin)
       emax  = energy(nemax)
c  evaluate energies for the spline variables:
c  - emin and emax are not relative to the edge
c  - energy contains the input energy values, not relative to the edge.
       qmin   = sqrt(etok* abs(emin - e0 ) )
       if (e0.le.emin)    qmin   = zero
       qmax   = sqrt(etok* (emax - e0 ) )
c     
c drpair is the spacing between pairs of independent points in r-space 
       if (.not.gvknot)
     $      nsplin = 2 * int ( rbkg * ( qmax - qmin ) / pi )  +  1 
       nsplin = min(mtknot-5, max(5,nsplin))
c     
c  initialize energy values through which the first guess for the
c  spline must go (evenly spaced in q), and get the initial value
c  for the spline value at this point. we'll also get the initial
c  guesses for the variables (the b-spline coefficients) from this
c  initial spline.
c
       delq = (qmax-qmin)/(nsplin - 1)
       do 300 i = 1, nsplin
           efromq    = e0 + ( qmin + (i-1) * delq) **2 / etok
           isplin    = nofx(efromq,energy,nxmu)
           esplin(i) = energy(isplin)
           iup       = min(nxmu, isplin + 5)
           ilo       = max(1,    isplin - 5)
           bscoef(i) = (2*spline(isplin) + spline(iup) + spline(ilo))/4
300    continue
       esplin(nsplin) = one + esplin(nsplin)
c the first and last korder knots in the b-spline are nearly degenerate at
c the endpoints. spstep sets the spacing between these points.  the 
c default is one -- this may help eliminate "spikes" at the endpoints.
c since each knot represents a place where a derivative can break,
c  having all four of these at one place allows a complete break from 
c at this point. by moving a few of the knots just off the ends, the 
c spline is a little bit stiffer at the endpoints.
       do 310 i = 1, korder
           eknot(i)        = esplin(1)      - spstep * (korder-i-1)
           eknot(nsplin+i) = esplin(nsplin) + spstep * i
310    continue
       qmn       = sqrt( etok* abs(esplin(1) - e0) )
       if (e0.lt.esplin(1))  qmn = zero
       qmx = sqrt( etok* (esplin(nsplin) - e0) )
       do 320 i = korder+1, nsplin
           qknot    = (i-korder)*(qmx - qmn)/(nsplin-korder+1)
           eknot(i) = esplin(1) + qknot**2/etok
320    continue

c
c    determine the knots for the spline:
c    knots are points at which the spline has extra freedom.
cc       ntknot = nsplin + korder
       if ( (korder.lt.3).or.(nsplin.lt.korder) ) then
          call echo('           autobk error: not enough'//
     $                      ' freedom to create spline.')
          call echo('                   change fitting range, or'//
     $                      ' order of spline')
          call fstop(' not enough data to make spline')
       end if
c  the b-spline coefficients will be the variables in the fit, 
c  the above estimates for the elements of bscoef are good enough 
c  especially when the spline values are smoothed for the initial 
c  guesses in the fit, as below.
       varys(1) = (3*bscoef(1) + bscoef(2))/ 4
       varys(nsplin) = (3*bscoef(nsplin) + bscoef(nsplin-1))/ 4
       do 380 i = 2, nsplin-1
          varys(i) =  (bscoef(i-1) + 2*bscoef(i) + bscoef(i+1) )/4 
 380   continue
       nvarys = nsplin
c set up window function
       call window(winstr,windo1,windo2,qmin,qmax,qgrid,maxpts,windo)
c  if a theory file is used, do its fft now
c  and add another variable if e0 is to be shifted
       if (theory) then 
          if (eevary) then
             nvarys        = nvarys + 1
             varys(nvarys) = e0shft
          end if
          nr     = nrpts
cc          print*, ' theory : ', mftfit
          call fitfft(thiq, maxpts, mftfit, wfftc, qgrid,
     $         windo, qweigh, spline, one, ifft, zero, r1st,
     $         nrpts, thifit)

          thessq = max(small, sumsqr(thifit(nrbkg),nr1st))
          if (nr.ne.nrpts)  then
             call echo('  autnls error: fitfft is broken' )
             write(messg,'(a,2i5)') 'nr, nrpts = ', nr, nrpts
             call echo('          '//messg(:40))
             call fstop(' call matt!! autobk fitfft is broken')
          end if
       end if
c 
c  initialize fvect and work arrays for lmdif1
       mfit  = nrbkg
       do 400 i =1, mfit
          fvect(i) = zero
 400   continue
       do 410 i =1, lenwrk
          work(i) = zero
 410   continue
       do 420 i =1, mtknot
          iwork(i) = 0
 420   continue
c     
c  lmdif1 to do levenberg-marquardt nonlinear least squares
       if (eevary) then
          call echo('   autobk: fitting background and e0'//
     $         ' over the low-r range')
       else
          call echo('   autobk: fitting background'//
     $         ' over the low-r range')
       end if
       if (iprint.ge.2) then 
          iend = 0
cc          print*, ' call autfun: ', mfit, nvarys, iend
cc          print*, varys(1), fvect(1), varys(3), fvect(3)
          call autfun(mfit, nvarys, varys, fvect, iend)
          type   = 'xmu'
          file   = 'spline0.dat'
          doc(1) = ' autobk: initial spline v. e : before fitting'
 500      format (1x,a,i4)
 501      format (1x,a)
 502      format (1x,i5.2,e14.6,e14.6,1x,i5.2,e14.6,e14.6)
 503      format (1x,i5.2,e14.6,e14.6)
 504      format (1x,a,f14.6)
          write (doc(2), 500) ' number of variables = ', nsplin
          write (doc(3), 504) ' spline_step (spstep)= ', spstep
          write (doc(4), 501) ' index, esplin, ysplin, '//
     $                        ' index, esplin, ysplin '
          ndoc   = 4
          do 550 i = 1, nsplin, 2
             if (i.lt.maxdoc)  ndoc = ndoc + 1
             if ((i.le.maxdoc).and.(i.eq.nsplin)) then
                write (doc(ndoc), 503) i , esplin(i)  , varys(i)  
             elseif (i.le.maxdoc) then
                write (doc(ndoc), 502) i  , esplin(i)  , varys(i)  ,
     $                                i+1, esplin(i+1), varys(i+1)
             end if
 550      continue 
          call outcol(type, file, asccmt, ndoc, mdocxx, doc, nxmu,
     $         energy, spline, xmudat, chiq, thiq) 
       end if
       
c
c the real fit!
       call lmdif1 (autfun, mfit, nvarys, varys, fvect,
     $      toler, lminfo,  iwork,  work, lenwrk)

       call autfun(mfit, nvarys, varys, fvect, iend)
       if ( (lminfo.ge.1).and.(lminfo.le.3) ) then
          messg = 'fitting is finished.'
          im = max(1, istrln(messg))
          call echo ('                   '//messg(:im) )
       else
          messg = 'lmdif finished with an error ! '
          im = max(1, istrln(messg))
          call echo ('                   '//messg(:im) )
          write(messg, '( a, i5)' ) 'error code lminfo = ',lminfo
          im = max(1, istrln(messg))
          call echo ('                   '//messg(:im) )
          call echo ('            call matt')
       end if
c
       if (iprint.ge.2) then 
          file   = 'spline.dat'
          doc(1) = ' autobk: final spline v. e : before fitting'
          ndoc   = 4
          do 580 i = 1, nsplin, 2
             if (i.lt.maxdoc)  ndoc = ndoc + 1
             if ((i.le.maxdoc).and.(i.eq.nsplin)) then
                write (doc(ndoc), 503) i , esplin(i)  , varys(i)  
             elseif (i.le.maxdoc) then
                write (doc(ndoc), 502) i  , esplin(i)  , varys(i)  ,
     $                                i+1, esplin(i+1), varys(i+1)
             end if
 580      continue 
          call outcol(type, file, asccmt, ndoc, mdocxx, doc, nxmu,
     $         energy, spline, xmudat, chiq, thiq) 
       end if


c  even though the fit was good, if an energy shift was done, the
c  q values used to determine the number and location of the spline
c  points were wrong, and so the fit must be re-done. this will be
c  repeated up to 5 times, or until e0 is stable to within 0.5 ev.
       e0tst   = ee + e0shft
       qmntst  = sqrt(etok* abs(emin - e0tst ) )
       qmxtst  = sqrt(etok* abs(emax - e0tst ) )
       if (e0tst.le.emin)    qmntst   = zero
       ntest   = 2 * int ( rbkg * abs(qmxtst - qmntst) / pi)  + 1 
       if (gvknot) ntest = nsplin
       ntest   = min(mtknot-5, max(5,ntest))
       if (eevary.and.(ntest.ne.nsplin) ) then
          call echo('   autobk warning: because the'//
     $                ' energy origin was shifted in ')
          call echo('                   in the fit, kmin'//
     $                ' and kmax have been redefined')
          call echo('                   so that the number'//
     $                ' of knots in the spline has')
          call echo('                   changed. the fit '//
     $                ' will be done again.')
          go to 100
       end if
c------------------------------------------------------------------
c  finished with fit
 800   continue
c
c  now that we have the spline as good as we can get it, let's get an 
c  improved estimate of the edge-step. we should have it pretty close 
c  to one, but now we do a parabolic extrapolation of the background 
c  spline to the edge energy value. this should cover up most 
c  difficulties in getting the edge step from a linear extrapolation
c  of the absorption data itself.
       if (stfind.and.(.not.funnrm)) then
          enor1  = e0 + enor1
          enor2  = e0 + enor2
          if (enor2.gt.energy(nxmu))   enor2 = energy(nxmu) 
          if (enor1.gt.energy(nxmu))   enor1 = enor2 /2
          nnorm = 3
          if (abs(enor2 - enor1).le.edfmin) nnorm = 2
          call polyft(enor1, enor2, energy, spline,nxmu,nnorm,cnorm)
          ne0  = nofx(e0, energy, nxmu)
          step = cnorm(1) + cnorm(2)*energy(ne0)
          if (nnorm.eq.3) step = step + cnorm(3)*energy(ne0)**2
          cnorm(1) = cnorm(1) + bpre 
          cnorm(2) = cnorm(2) + slopre
       end if
c
c  now redo function evaluation with the final values for everything.
       do 930 i = 1, nxmu
          spline(i) = xmudat(i)
 930   continue
       do 940 i = 1, maxpts
          chiq(i) = zero
 940   continue
       final = .true.
       call autfun(mfit, nvarys, varys, fvect, iend)
c     
       return
c end subroutine autnls
       end

       subroutine autdat
c
c  this routine reads all input data files for the progam autobk.
c  the xmu data file is opened, the pre-edge is removed, and the 
c  standard chi data (if used) is read. the routine inpdat is 
c  used for all data files, allowing either uwexafs binary or 
c  ascii column data to be used.
c
c   copyright 1992  university of washington :          matt newville
c-----------------------------------------------------------------------
       include 'autobk.h'
c local variables
       character    ftype*5, frmthe*10
       double precision qtemp (maxpts), chitmp(maxpts), small 
       double precision q, rgrid, rsmall, rtemp
       double precision dummy1(maxpts), dummy2(maxpts)
       double precision dummy3(maxpts), xmuraw(maxpts)
       parameter (small  = 1.d-10)
       integer  ndocln, i, nxx, ipos, nemin, nemax, nofx
c--------------------------------------------------
       if (xmuf.eq. ' ') then 
          call echo('   autobk error: no input xmu data'//
     $                ' file name given.')
          call fstop(' no xmu data')
       end if
c 
c  get xmu data, do pre-edge and normalization, and store the
c  modified xmu values in xmudat.
       ndocln = maxdoc
       nxmu   = maxpts
       ftype  = 'xmu'
       irecl  = 512
       call inpdat( ftype, frminp,   xmuf, vaxflg, skeyxm, 
     $      nkeyxm, irecl, ndocln, xmudoc,   nxmu, energy,
     $      xmuraw, dummy1, dummy2, dummy3)

cc       print*, ' irecl = ', irecl, nxmu, energy(1)
c
c simple kludge to allow columnd 3,4,5 to be used as xmuraw:
       if ((imucol.ge.3).and.(imucol.le.5)) then
          if (imucol.eq.3) then
             do  22 i = 1, nxmu
                xmuraw(i) = dummy1(i)
 22          continue 
          elseif (imucol.eq.4) then
             do  23 i = 1, nxmu
                xmuraw(i) = dummy2(i)
 23          continue 
          elseif (imucol.eq.5) then
             do  24 i = 1, nxmu
                xmuraw(i) = dummy3(i)
 24          continue 
          endif
       endif
c
c remove pre-edge, get edge step
       nnorm = 2
       call preedg(eefind, stfind, nxmu, energy, xmuraw, ee,
     $      predg1, predg2, enor1, enor2, nnorm, 
     $      step, slopre, bpre,cnorm)
       step = max(step, small)
       if (funnrm) step = one
c set background equal to xmu 
       do 50 i = 1, nxmu
          xmudat(i) = xmuraw(i) - slopre * energy(i) - bpre
          spline(i) = xmudat(i)
 50    continue
c
c  get theory from a 'chi' file
c  if theory is not given thiq is filled with 0.0
       ntheor = 1
       qtemp(1) = zero
       if (theory) then
          ndocln = maxdoc
          ntheor = maxpts
          ftype  =  'chi'
c           frmthe = frminp
          frmthe = ' '
          call inpdat(ftype,  frmthe, theorf, vaxflg, skeyth, 
     $         nkeyth, irecl, ndocln, thedoc, ntheor,  qtemp,
     $         chitmp, dummy1, dummy2, dummy3)
       end if
       nxx  = min(maxpts, 10 + int (qtemp(ntheor) / qgrid))
       ipos = 1
       do 200 i = 1, nxx
          q = i*qgrid
          if ( (q.lt.qtemp(1)).or.(q.ge.qtemp(ntheor)) ) then
              thiq(i) = zero
          else
              call lintrp ( qtemp, chitmp, ntheor, q, ipos, thiq(i) )
          end if
 200   continue
c-----------------------------------------------------------------------
c  move emin and emax to values on the energy grid
       emin = emin + ee
       emax = emax + ee
       if (emax.le.emin) emax = energy(nxmu)
       nemin = nofx(emin,energy,nxmu)
       nemax = nofx(emax,energy,nxmu)
       emin  = energy(nemin)
       emax  = energy(nemax)
c-----------------------------------------------------------------------
c  put r values on rgrid, get npts numbers
       if (r1st.le.rbkg) r1st = rbkg + 2.0
       rgrid  = pi / (qgrid * mftfit)
       rsmall = rgrid / 100.0
       rbkg   = rgrid * int( (rbkg + rsmall) / rgrid ) 
       r1st   = rgrid * int( (r1st + rsmall) / rgrid ) 
       if (rbkg.gt.r1st) then
            rtemp = rbkg
            rbkg  = r1st
            r1st  = rtemp
       end if
       nrbkg  = 2 * int((rbkg + rsmall)/rgrid) + 2
       nrpts  = 2 * int((r1st + rsmall)/rgrid) + 2
       nr1st  = nrpts - nrbkg

       if (nxmu.le.4) then
          call echo('   autobk error: data file empty, or not'//
     $         ' enough data points')
          call echo('      the data file may need # signs for'//
     $         ' comment lines.')
          call fstop(' bad data file')
       end if

c done
       return
c end subroutine autdat
       end

      subroutine in2col(active,filnam,mdoc,mpts,
     $      ix1,ix2, doc,ndoc,x1,x2,npts,isfeff)
c
c open and reads two columns from a multi-column data file.
c arguments:
c   filnam file name containing data           (in)
c   mdoc   max number of document lines to get (in)
c   mpts   max number of data elements to get  (in)
c   ix1    column to read array x1 from        (in)
c   ix2    column to read array x2 from        (in)
c   doc    array of document lines             (out)
c   ndoc   number of doc lines returned        (out)
c   x1     first array                         (out)
c   x2     second array                        (out)
c   npts   number of data points               (out)
c
       implicit none
       integer   ilen , istrln, j, i, maxwrd, ndoc, npts, iounit
       integer   iexist, ierr, nwords, idoc, id, mdoc,mpts,ncol
       integer   ix1, ix2, ixmax, ixmin
       parameter(maxwrd = 10)
       double precision   x1(mpts),x2(mpts), zero
       parameter(zero = 0)
       logical       isdat, ffhead, adddoc, comm, isfeff, active
       character*(*) filnam, doc(mdoc), commnt*4, ffstr*5,ffend*2
       character*30  words(maxwrd), str*100, file*100
       external      istrln, isdat
       data          commnt, iounit, adddoc /'#*%!', 0, .true./
       data          ffhead, ffstr,  ffend  /.false.,' feff','@#'/

       ncol = 3
       if (active) isfeff = .false.
c
       ixmax = max(ix1,ix2)
       ixmin = min(ix1,ix2)
       if (.not.active.and.
     $      (ixmin.le.0).or.(ixmax.gt.maxwrd)) go to 880
 10    format(a)
       file = filnam
 20    continue 
       ilen = istrln(file)
       if (ilen.le.0)  go to 890
c  open data file
       call openfl(iounit, file, 'old', iexist, ierr)
       if ((iexist.lt.0).or.(ierr.lt.0)) then
          if (.not.active) go to 900
          call messag(' couldn''t find file '//file(:ilen))
          call askstr(' type a new file name (or N to abort)',
     $         file)
          str = file
          call smcase(str,'n')
          if (str.eq.'n')  go to 999
          go to 20
       end if
c  initialize buffers
       do 80 j = 1, mdoc
          doc(j) = ' '
  80   continue
       do 90 j = 1, mpts
          x1(j) = zero
          x2(j) = zero
  90   continue
       do 100 i = 1, maxwrd
          words(i) = ' '
 100   continue
       idoc = 0
       id   = 0
c
c  get documents from header: up to ndoc
 200   continue
          print*, ' line 200', comm, ffhead
          comm = .false.
          read(iounit, 10, end = 920, err = 930) str
          call triml (str)
c  remove leading comments (followed by optional blanks) from str 
          if ( index(commnt, str(1:1)).ne.0 )  then
             comm     = .true.
             str(1:1) = ' '
             call triml(str)
          end if
c  if str is '----', stop adding lines to doc
          if (str(2:4) .eq. '---')  adddoc  = .false.
c  if the str is all numbers and we're not reading a 
c  feff header or a commented out lins, then this is data!
          if ((.not.(comm.or.ffhead)).and.(isdat(str))) goto 410
c  save str in doc if there's room
          ilen = istrln(str)
          if (adddoc .and. (idoc .lt. ndoc) .and. ilen.gt.0)  then
             idoc = idoc + 1
             doc(idoc) = str
          endif
c test for whether reading feff headers (lines may not be commented out,
c but will have '   feff ' in latter part of the first line, and the 
c magic '@#' characters just before numbers -- zany zabinsky!)
          if (idoc.eq.1)  then
             call smcase(str,'a')
             ffhead = (index(str(55:),ffstr).ne.0)
             isfeff = ffhead
             ix2 = 2
             if (ffhead) ix2 = 4
             if (active) then
                str = 'n'
                if (ffhead)  str = 'y'
                call askstr('** is this a feff xmu.dat file?',str)
                call smcase(str,'y')
                ffhead = (str.eq.'y') 
                isfeff = ffhead
                call messag(' ')
                call messag(' What columns are energy and mu(E) in?:')
                if (ffhead) then 
                   ix2 = 4
                call messag(' (Feff puts mu in column 4,'//
     $                  ' mu0 in column 5)')
                end if
 320            continue 
                call askint('** column for energy ',ix1)
                call askint('** column for mu ',ix2)
                ixmax = max(ix1,ix2)
                ixmin = min(ix1,ix2)
                if ((ixmin.le.0).or.(ixmax.gt.maxwrd)) then
                   call messag( '   something''s wrong with '//
     $                  'those values, try again ...')
                   go to 320
                end if
             end if
          end if
c  end first column check if feff xmu / getting of column numbers
          if (ffhead) ffhead = (str(ilen-1:).ne.ffend)
          print*, ' at  goto 200',  active
       
       goto 200
c      
c  read numerical data


cc       print*, ' line 400'
 400   continue
          read(iounit, 10, end = 500, err = 980) str
 410      continue 
          call triml (str)
          if (istrln(str).le.0) go to 400
          if (id.ge.mpts) go to 500
          id = id + 1
          nwords = maxwrd
          call untab(str)
          call bwords(str,nwords,words)
          if (nwords.le.1)      goto 940
          if (nwords.lt.ixmax)  goto 950
          if (id.eq.1) ncol = nwords
          if (ncol.ne.nwords)   goto 960
          call str2dp(words(ix1), x1(id), ierr) 
          if (ierr.ne.0)        goto 990
          call str2dp(words(ix2), x2(id), ierr) 
          if (ierr.ne.0)       goto 990
       goto 400
 500   continue
       npts = id 
       if (idoc.le.0) then
          ndoc   =  1
          doc(1) = 'in2col: no document line found'
       else
          ndoc = idoc
       end if
c      close data file and return
       close(iounit)
cc       print*, 'in2col done'
       return
c      error handling
 880   call messag( ' in2col:  selected columns out of range')
       go to 999
 890   call messag( ' in2col:  no file name given')
       go to 999
 900   call messag( ' in2col: could not find file')
       go to 990
 920   call messag( ' in2col: error reading document lines')
       go to 990
 930   call messag( ' in2col: unexpected end-of-file while '//
     $      'reading titles')
       go to 990
 940   call messag( ' in2col: too few columns of numbers !')
       go to 990
 950   call messag( ' in2col: fewer columns found than requested')
       go to 990
 960   call messag( ' in2col: number of columns changed !')
       go to 990
c      error at reading numerical data
 980   call messag( ' in2col: error reading numerical data.')
 990   call messag( ' in2col: error with file '//file(1:ilen) )
       close(iounit)
 999   continue 
       stop
c end subroutine in2col
       end

       subroutine fitdat
c
c      this routine reads the input data files for feffit.
c
c    - if given, each data file will be opened and the chi(k)
c      data and documentation will be read with the routine inpdat.
c    - all the numbers for qmin, qmax, rmin, rmax, etc. are also
c      set here, using defaults from the values in the data files.
c    - as the data is read in, it is interpolated here onto a evenly
c      spaced k grid ( with dk = qgrid = 0.05).
c    - if backgound removal is requested, the number of knots in the
c      spline will be found and set here, rmin will be used as rbkg,
c      and the fit will be done on r=[0,rmax]. the variables for the
c      spline coeffs will be added to the end of the variable list,
c      so that the first nvuser variables will be those explicitly
c      "guess"ed, and the rest (numvar-nvuser) will be those implicitly
c      guessed by asking for background removal.
c    * the feffnnnn.dat files will be read in fefinp.
c
c      copyright 1993 university of washington         matt newville
c
c----------------------------------------------------------------------
c  common blocks for feffit
       include 'fitcom.h'

       character*10  ftype, frmtmp, strtmp*128
       character*100 docb(maxdoc)
       double precision qtemp(maxpts), chitmp(maxpts), rrmmax
       double precision qbtemp(maxpts), bkgtmp(maxpts), qrange
       double precision tmp1(maxpts), tmp2(maxpts), tmp3(maxpts)
       double precision drinfo(mdata) , xlog2, percnt, two, rsmall
       double precision drmin, q, qsmall, xexpo, dr_1k
       double precision dqmin, xqmax, xqmin
       integer       mftmin, id, ilen, istrln, isky, ist, ndocb
       integer       nexpo, nrmin, nrmax,  ntmp, ii, iv, imsg, ireclb
       integer       nbkgf, ipos, iposb, i,  nq1st, nqmin, nqmax
       parameter(xlog2 = 0.69314718056d0, percnt = 1.d-2, two = 2.d0)
       parameter(xqmin = 20.d0, xqmax = 35.d0)
c-----------------------------------------------------------------------
c   drmin is used as the spacing in r-space to use in the fit,
       drmin  = pi/( qgrid * mftfit)
c----------------------------------------------------------------------
c  open data files and get chi data
       do 500 id = 1, ndata
          ftype     = 'chi'
          nchi(id)  = maxpts
          irecl(id) = 512
          q1st(id)  = qgrid
          qlast(id) = 30.
          if (datain(id)) then
             ndoc(id) = maxdoc - 1
             call inpdat(ftype, frminp, chifil(id), vaxflg, skey(id),
     $            nkey(id), irecl(id), ndoc(id), doc(1,id), nchi(id),
     $            qtemp, chitmp, tmp1, tmp2, tmp3)
c
c  write output message that this file was successfully read
             ilen = max(1, istrln( chifil(id)))
             call smcase(frminp, 'a')
             messg = chifil(id)(1:ilen)
             strtmp = ' '
             if (frminp(1:2).eq.'uw') then
                if (skey(id).ne.' ') then
                   isky  = max(1, istrln(skey(id)))
                   if (nkey(id).ne.0) then
                      strtmp = ' , '//skey(id)(1:isky)
                   else
                      write (strtmp, 9010) nkey(id), skey(id)(1:isky)
                   endif
                elseif (nkey(id).ne.0) then
                   write (strtmp, 9015) nkey(id)
                endif
             endif
             ist = istrln(strtmp)
             if (ist.ge.1) call append(messg, ' '//strtmp(:ist) ,ilen)
             call echo( '        '//messg(1:ilen))
c
c  if a bkg(k) file was specified, subtract this from the chi(k) data
             if (bkgdat(id)) then
                ndocb = maxdoc - 1
                ftype      = 'chi'
                nbkgf      = maxpts
                ireclb     = irecl(id)
                frmtmp     = ' '
                call inpdat(ftype, frmtmp, bkgfil(id), vaxflg,
     $               skeyb(id), nkeyb(id), ireclb, ndocb, docb(1),
     $               nbkgf, qbtemp, bkgtmp, tmp1, tmp2, tmp3)
c
c  write output message that this file was successfully read
                ilen = max(1, istrln( bkgfil(id)))
                call smcase(frmtmp, 'a')
                messg = bkgfil(id)(1:ilen)
                strtmp = ' '
                if (frmtmp(1:2).eq.'uw') then
                   if (skeyb(id).ne.' ') then
                      isky  = max(1, istrln(skeyb(id)))
                      if (nkeyb(id).ne.0) then
                         strtmp = ' , '//skeyb(id)(1:isky)
                      else
                         write(strtmp,9010) nkeyb(id),
     $                        skeyb(id)(1:isky)
                      endif
                   elseif (nkeyb(id).ne.0) then
                      write(strtmp, 9015) nkeyb(id)
                   endif
                endif
                ist = istrln(strtmp)
                if (ist.ge.1)
     $               call append(messg,' '//strtmp(:ist),ilen)
                call echo( '              '//messg(1:ilen))
             end if
c  put chi data into single array, chiq, on qgrid spacing,
c  starting at q = qgrid : linear interpolation
             ipos      = 1
             iposb     = 1
             q1st(id)  = max(qgrid, qtemp(1))
             qlast(id) = qtemp(nchi(id))
             if ((q1st(id).ge.xqmin).or.(qlast(id).ge.xqmax)) then
                imsg = -1
                if (chkdat)  imsg = 1
                call finmsg(3010,' ',' ',imsg)
             end if
             do 150 i = 1, maxpts
                q = (i-1)*qgrid
                if ( (q.lt.q1st(id)).or.(q.gt.qlast(id))) then
                   chiq(i,id) = zero
                else
                   call qintrp( qtemp, chitmp, nchi(id), q,
     $                  ipos, chiq(i,id))
                   if (bkgdat(id)) then
                      call qintrp( qbtemp, bkgtmp, nbkgf, q,
     $                     iposb, bkgq(i,id))
                      chiq(i,id) = chiq(i,id) - bkgq(i,id)
                   end if
                end if
 150         continue
          end if
c
c  recover from incomplete inputs
          if (((outfil(id).eq.' ').or.(outfil(id).eq.'xxfitxx'))
     $        .and.(chifil(id).ne.' ')) outfil(id) = chifil(id)
c
c
c miscellaneous fiddling with input numbers:
c     find maximum path index
c     put q1st, qmin, qmax on qgrid, etc.
c     calculate number of points in various ranges
c-- put q1st, qmin, qmax on qgrid, get nqpts
          qsmall    = qgrid * percnt
c q1st
          nq1st     = int( (q1st(id) + qsmall) / qgrid)
          q1st(id)  = qgrid * nq1st
c qmin : make sure it is on the data range and larger than qgrid
          nqmin     = max(1, int( (qmin(id) + qsmall) / qgrid))
          qmin(id)  = max(qgrid * nqmin, q1st(id))
c qmax : truncate nqmax
          nqmax     = int( (qmax(id) + qsmall) / qgrid)
          qmax(id)  = qgrid * nqmax
          if (qmax(id).le.qmin(id))  then
             qmax(id) = qlast(id)
          else
             qmax(id) = min(qmax(id), qlast(id))
          end if
c nqpts, nqfit
          nqpts(id) = nqmax - nqmin + 1
          nqfit(id) = int( ( qlast(id) + qsmall + two) / qgrid )
cc          print*, ' mid fitdat:  '
cc          print*, q1st(1),qmin(1),qmax(1), qlast(1), nqpts(1), nqfit(1)
c
c-- r values (mostly in next loop)
          if (rmax(id).le.rmin(id))    rmax(id)  = rmin(id)
c
c define drinfo as spacing between independent points in r-space
c and keep smallest drinfo found so far
          drinfo(id) = pi / ( qmax(id) - qmin(id) )
          drmin      =  min(drmin, drinfo(id))
c
c done with this data set, for now
 500   continue
c----------------------------------------------------------------------
c  get mftfit (number of points for fit in fft range)
       rsmall = rgrid * 0.01d0
       do 700  id  = 1, ndata
          nrmin     = int( (rmin(id) + rsmall) / rgrid )  + 1
          nrmax     = int( (rmax(id) + rsmall) / rgrid )
          if (nrmax.le.nrmin) nrmax = nrmin + 1
          nrpts(id) = nrmax - nrmin + 1
          rmax(id)  = rgrid * nrmax
          rmin(id)  = rgrid * nrmin
          if (bkgfit(id)) then
             rbkg(id) = rgrid * nrmin
             rmin(id) = zero
          end if
          xinfo(id) = two * (one + ((rmax(id)-rmin(id)) / drinfo(id)))
c
c  if bkg removal is requested, figure out how many spline knots to
c  use, where to put them, and add these knots to the variable list.
          if (bkgfit(id)) then
c
c-bkg how many splines
             nbkg(id) = 1 + 2 * int( rbkg(id) / drinfo(id) )
             nbkg(id) = min(mtknot-korder-1, max(korder+1, nbkg(id)))
c-bkg where to put knots
             do 600 i = 1, korder
                qknot(i,id)          = qmin(id) - (korder-i) * qgrid
                qknot(nbkg(id)+i,id) = qmax(id) + (i-1) * qgrid
 600         continue
             qrange = qmax(id) - qmin(id)
             ntmp   = nbkg(id) - korder + 1
             do 620 i = korder+1, nbkg(id)
                qknot(i, id) = qmin(id) + (i-korder)*qrange/ntmp
 620         continue
c-bkg add spline coefs to the variable list, initialize to zero
             do 640  ii = 1, maxval
                if  (vnames(ii).eq.' ') go to 650
 640         continue
 650         continue
             iv = ii - 1
             do 680  i = 1, nbkg(id)
                numvar  = numvar + 1
                iv      = iv + 1
                if (numvar.gt.mvarys) call finmsg(3020,' ',' ',mvarys)
                if (iv.gt.maxval)     call finmsg(3040,' ',' ',maxval)
                xguess(numvar)= zero
                write(vnames(iv), 660)  '_bkg_#',id,'_',i
 660            format (a,i2.2,a,i2.2)
                icdval(1,iv)   = -1
 680         continue
          endif
c
c  figure out amount of information for this data set, and add to total
c  note: if rmin=0. we're doing bkg subtraction - there is only
c        one piece of information at r=0. at r > 0, the information
c        comes in pairs.
          xnidp  = xnidp + xinfo(id)
c
c finally, make the qwindo and rwindo (ie, the fft widnows)
c  for this data set.
c
cc          print*, ' call window'
          call window(sqwin(id), qwin1(id),
     $         qwin2(id), qmin(id), qmax(id), qgrid,
     $         maxpts, qwindo(1,id) )

          call window(srwin(id), rwin1(id),
     $         rwin2(id), rmin(id), rmax(id), rgrid,
     $         maxpts, rwindo(1,id) )
c
 700   continue
       if (xinfo(1).lt.two) xinfo(1) = two
       if (xnidp.lt.two)    xnidp    = two
       inform  = int(xnidp)
c
       xexpo  = log ( float (mftfit)) / xlog2
       nexpo  = min(11, max(8, nint(xexpo)) )
c
c make sure rlast is smaller than 10pi = pi/2/qgrid
       rrmmax = (pi/two) / qgrid
       if (rlast.gt.rrmmax) rlast = rrmmax

       call cffti(mftfit, wfftc)

cc       print*, ' end  of fitdat:  '
cc       print*, mftfit
cc       print*, ' q/r grid ', qgrid, rgrid
cc       print*, q1st(1), qmin(1), qmax(1), qlast(1), nqpts(1)
       return
c end subroutine fitdat
 9010  format (a, ' , ', i4, ' (', a,')' )
 9015  format (a, ' , ', i4 )
       end

       subroutine fiterr(fcn,nfit,nvar,mfit,mvar,fbest,ftemp,fjac,
     $      alpha,jprint,istep,x,delta,correl,ierror,iflag)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c     error analysis for a fit using the minpack routines
c
c     given a subroutine, *fcn*, to generate a fitting function
c     with *nfit* evaluations from a set of *nvar* variables,
c     with best-fit values *x* and residuals *fbest* determined,
c     this will return the uncertainties in *x* to *delta*, and
c     the correlations between the variables in *correl*.
c
c  arguments:
c     fcn     name of subroutine to generate fitting function,    [in]
c             with call statement as for minpack routines :
c                   call fcn(nfit,nvar,x,f,ier)
c     nfit    number of function evaluations for call to fcn      [in]
c     nvar    number of variables                                 [in]
c     mfit    dimension of arrays for function evaluations        [in]
c     mvar    dimension of arrays for variables                   [in]
c     fbest   array of fit residual for best fit         (mfit)   [in]
c     ftemp   array of fit residuals for constructing    (mfit) [work]
c             jacobian. on output, this is equal to fbest.
c     fjac    array of finite difference jacobian   (mfit,mvar) [work]
c     alpha   curvature and covariance matrix       (mvar,mvar) [work]
c     jprint  integer print flag for debug messages               [in]
c     istep   maximum number of loops in error evaluation         [in]
c     x       array of best fit values for variables     (mvar)   [in]
c     delta   array of uncertainties for the variables   (mvar)  [out]
c     correl  array of two-variable correlations    (mvar,mvar)  [out]
c     ierror  integer flag that is non-zero if error bars        [out]
c             cannot be estimated because the curvature
c             matrix cannot be inverted, so that one or
c             more of the variables do not affect the fit.
c     iflag   integer array whose elements are 1 if the   (mvar) [out]
c             corresponding variable is suspected of
c             causing the failure of the inversion of the
c             curvature matrix. these may be null variables.
c
c  required external subprograms:
c     fcn,  gaussj 
c
c     the algorithm here is to construct and invert the nvar x nvar
c     curvature matrix  alpha, whose elements are found by summing
c     over the elements of the jacobian matrix, fjac:
c        fjac(i,j) = dfvect(i) / dx(j)   (i = 1, nfit; j = 1, nvar)
c     where fvect is the residual array for the fit and dx is a small
c     change in one variable away from the best-fit solution. then
c        alpha(j,k) = alpha(k,j)
c                   = sum_(i=1)^nfit (fjac(i,j) * fjac(i,k))
c
c     the inverse of alpha gives the curvature matrix, whose diagonal
c     elements are used as the uncertainties and whose off-diagonal
c     elements give the correlations between variables.
c--------------------------------------------------------------------
       implicit none
       integer  mfit,mvar,nfit,nvar,i,k,j,iloop,istep, istepx
       integer  iflag(mvar), ierror, jprint, ier
       double precision  fbest(mfit), ftemp(mfit), fjac(mfit,mvar)
       double precision  x(mvar), correl(mvar,mvar), alpha(mvar,mvar)
       double precision  delta(mvar), delx, sum, tempx
       double precision  eps, epsdef, tiny, zero
       character messg*64
       parameter (zero   = 0.d0, epsdef = 1.d-3, tiny= 1.d-12)
       external  fcn, gaussj
c
       if (jprint.ge.1)  call echo( '>>>> fiterr start')
       istepx= min(5,max(1, istep))
       ier   = 0
       ierror= 0
       iloop = 0

       do 3 j = 1, nvar
          delta(j) = zero
 3     continue 
 10    continue
       iloop = iloop  + 1
c
c     construct jacobian using the best possible guess for the
c     relative error in each variable to evaluate the derivatives.
c     if not available, use 1% of the value for the variable.
       do 50 j = 1, nvar
          tempx = x(j)
          if (iloop .eq. 1)   then
             delx = max( tiny, epsdef * abs(tempx) )
          else
             delx = max(tiny, abs(delta(j)))/2.d0
          endif
          x(j)  = tempx + delx
          if (jprint.ge.1) then
             write(messg,'(1x,a,3g14.7)') '  >> ',tempx,delta(j),delx
             call echo(messg)
          end if
          if (jprint.ge.4)  call echo( '>>>> call fcn' )
          call fcn(nfit, nvar, x, ftemp, ier)
          if (ier .lt. 0) then
             if (jprint.ge.1)  call echo( '>>>> fcn died')
             go to 65
          end if
          do 30 i = 1, nfit
             fjac(i,j) = ( fbest(i) - ftemp(i)) / delx
 30       continue
          x(j)  = tempx
 50    continue
 65    continue
c
c   re-evaluate best-fit to restore any common block stuff
       call fcn(nfit,nvar,x,ftemp,ier)
c
c     collect the symmetric curvature matrix, store in alpha
       if (jprint.ge.2)  then
          call echo( '   curvature matrix:  j , k , alpha(j,k)')
       end if
       do 180 j = 1, nvar
          do 160 k = 1, j
             sum  = zero
             do 140 i = 1, nfit
                sum = sum  + fjac(i,j) * fjac(i,k)
 140         continue
             alpha(j,k) = sum
             if (k.ne.j) alpha(k,j) = sum
             if (jprint.ge.2)  then
                write(messg,'(8x,2i3,g14.7)')  j , k , alpha(j,k)
                call echo(messg)
             end if
 160      continue
 180   continue
c
c     in case alpha cannot be inverted, flag those variables with
c     small diagonal components of alpha - these are the likely
c     null variables that caused the matrix inversion to fail.
       do 250 i = 1, nvar
          iflag(i) = 0
          if (abs(alpha(i,i)).le. tiny)  iflag(i) = 1
 250   continue
c  invert curvature (alpha) to give covariance matrix.  gaussj does
c  gauss-jordan elimination in-place, and dies with garbage in alpha
c  if the matrix is singular.
       if (jprint.ge.1) call echo(' fiterr-> call gaussj')
       call  gaussj(alpha,nvar,mvar,ier)
       if (jprint.ge.1) call echo(' fiterr-> gaussj returned')
       if (ier.ne.0) then
          ierror = 1
          if (jprint.ge.1) then
             call warn(2,'   FITERR:  cannot invert curvature matrix!')
          end if
          return
       end if
c
c     alpha now contains the covariance matrix, and is easily
c     converted into delta, the uncertainty for each variable,
c     and correl, the two-variable correlation matrix.
       if (jprint.ge.1)  then
          call echo(' fiterr done with loop:  j , delta(j)' )
       end if
       do 360 i = 1, nvar
          delta(i) = max(tiny, sqrt( abs( alpha(i,i)) ))
          if (jprint.ge.1) then
             write (messg,'(1x,i3,g15.7)') i, delta(i)
             call echo(messg)
          end if
          do 330 j = 1, i
             correl(j,i) =  alpha(j,i) / (delta(i) * delta(j))
             correl(i,j) = correl(j,i)
 330      continue
 360   continue
c
c     try it a second time with better estimates for the values
c     of deltax for the derivatives to get the jacobian matrix.
       if ( iloop .lt. istepx )  go to 10
c
c     finished
       if (jprint.ge.1)  call echo( '>>>> fiterr done')
       return
c     end routine fiterr
       end

      subroutine filrec(string,filnam,skey,nkey)
c
c      takes a character string and reads from it a filename, and an
c  skey and/or nkey for a record. blanks, commas, or equal signs can
c  separate the inputs on the command line.
c
      character*128  temp, words(3)
      character*(*)  string ,   filnam , skey
c
      nkey = 0
      skey = ' '
      nwords = 3
      call bwords(string,nwords,words)
c---- first word is filename
      filnam = words(1)
      nwords = nwords - 1
c---- second word is nkey or skey
      temp   = words(2)
c---- determine if second//third word is nkey/skey
c     skeys are exactly 5 characters long,
c     nkeys are never more than 3 characters long
 50   continue
      nwords = nwords - 1
      call triml(temp)
      ilen = istrln(temp)
      if(ilen.eq.5) then
         skey = temp
         call upper(skey)
      elseif(ilen.eq.4) then
         call fstop('error reading skey or nkey from '//temp)
      else
         call str2in(temp, nkey, ierr)
      end if
c---- the third word, if it exists
      if (nwords.eq.1) then
         temp = words(3)
         call triml(temp)
         go to 50
      end if
 1000 return
c     end subroutine filrec
      end

       subroutine iff_rddata(str)
c 
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: read data arrays from external file
c
c arguments:
c      str     command line for ifeffit                 [in]
c
c notes:
c   1. currently supports only ascii column files
c   2. supports several file "types" (xmu,chi,etc) used to name
c      the read-in arrays.
c   3. to add: read array names from the label lines:
c           #------
c           #  energy  xmu  bkg 
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       save
       integer    mwords, nt_max, maxbuf, jxline
       parameter (mwords = 128, nt_max = 64, maxbuf=2**17)
       integer    mpts, lun, npts, nwords, nwords1, ndata, in_titles
       integer    narrs, ier, iex, i, j, k, idot, ilen, ilpre, in
       character*(*)  str, stat*10, predef*10, comchr*1, cchars*5
       character*256  pre, file, type, form, tmpnam, del*1
       character*2048 line, labstr, label*256, labnam*16
       character*32   words(mwords), suffix, defkey(3)*64
       double precision buffer(maxbuf), sindex(maxpts),xx
       integer    ndfkey, llen, lslen, nlabs, iofarr, istrln, ntitle
       integer    isort, newlen,  nlabel_out,mlabel_len
       logical    isvnam,  istitl, iscomm, iscomm2, isdat
       logical    save_titles, do_sort, isnum
       parameter (stat = 'old',predef = 'my')
       integer   iff_eval_in, iread
       external  iff_eval_in, isnum
       external  istrln, isvnam, iofarr, isdat, iread
c

       pre    = ' '
       file   = ' '
       labstr = ' '
       label  = ' '
       form   = 'ascii'
       type   = 'label'
       save_titles = .true.
       do_sort= .false.
       isort  = -1
       in_titles = 0
       nlabel_out = 0
       mlabel_len = len(label)-2
       call gettxt('commentchar', comchr)
       call settxt('column_label',  blank)
       call settxt('column_label1', blank)
       call settxt('column_label2', blank)
       call settxt('column_label3', blank)
       call settxt('column_label4', blank)
       call settxt('column_label5', blank)
       call settxt('column_label6', blank)
       call settxt('column_label7', blank)
       call settxt('column_label8', blank)
       call settxt('column_label9', blank)
       call settxt('column_label10', blank)
       mpts = maxpts
       narrs  = 0
       npts   = 0
       ndata  = 0
       jxline = 0

c  interpret any and all keyword/value pairs for setting options
       call bkeys(str, mkeys, keys, values, nkeys)

c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
       ndfkey    = 1
       defkey(1) = 'file'
       do 10 i = 1, nkeys
          if ((values(i).eq.undef).and.(i.eq.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then
                pre = values(i)
                call lower(pre)
                if (.not.(isvnam(pre, 1) ))   call fixnam(pre,1)
                ilpre = istrln(pre)
           elseif (keys(i).eq.'file') then 
             file = values(i)
          elseif (keys(i).eq.'type') then 
             type   = values(i)
          elseif (keys(i).eq.'label') then 
             labstr = values(i)
             call lower(labstr)
             type   = 'user'
          elseif (keys(i).eq.'format') then 
             form = values(i)
          elseif (keys(i).eq.'sort') then 
             call str2in(values(i),isort,ier) 
             do_sort = .true.
          elseif (keys(i).eq.'no_sort') then 
             isort = 0
             do_sort = .false.
          elseif (keys(i).eq.'commentchar') then 
             comchr = values(i)(1:1)
          elseif (keys(i).eq.'notitles') then 
             call str2lg(values(i),save_titles,ier) 
             save_titles = .not.save_titles
          elseif (keys(i).eq.'titles') then 
             call str2lg(values(i),save_titles,ier) 
          elseif (keys(i).eq.'title_lines') then 
             call str2in(values(i),in_titles,ier) 
          elseif (keys(i).eq.'narrays') then 
             ier = iff_eval_in(values(i), narrs)
          else
             if (i.eq.1) then
                file = keys(i)
             else
                k = istrln( keys(i))
                messg = keys(i)(1:k)//' " will be ignored'
                call warn(1,
     $               ' *** read_data: unknown keyword " '//messg)
             end if
          end if
 10    continue 
c
c now that the needed program variables are known, the strategy is:
c   1. open file, with error checking
c   2. determine # of arrays to read
c   3. assign names and positions for arrays to be read
c   4. read arrays from file
c   5. assign number of points for each array
c
c  open file
       if (form.ne.'ascii')  then
          messg = 'unsupported file format!!'
          call warn(2,' *** read_data: '//messg)
          return
       end if
       if (file.ne.' ') then
          iex = 0
          ier = 0
          lun = -1
          call openfl(lun, file, stat, iex, ier)
          if ((ier.lt.0).or.(iex.lt.0)) then
             call echo(' *** read_data: error opening file ')
             ilen = istrln(file)
             messg =   ' ***    '//file(1:ilen)
             call warn(3,messg)
             if (lun.gt.0) close(lun)
             return
          end if
c set prefix from file name 
          if (pre.eq.' ') then 
             idot = index(file,'.')
             if (idot.eq.0) then
                pre = file
             else
                pre = file(1:idot-1)
             end if
             if (pre.eq.' ') pre = predef
             call lower(pre)
             if (.not.(isvnam(pre, 1) ))   call fixnam(pre,1)
             ilpre = istrln(pre)
          end if
       else
          call warn(2,' *** read_data: no file name given!!')
          if (lun.gt.0) close (lun)
          return
       end if
c
c read file, ignoring title lines at top of file.
c  -  when we read the first row of numerical data, count the 
c     number of columns and assign names and positions to vectors
       nwords = mwords
       ntitle = 0
       cchars = ';#%'//comchr
       istitl = .true.
       iscomm  = .true.
       iscomm2 = .true.
       
c
c
c title lines
 100   continue
       ilen = iread(lun,  line)
       if (ilen .lt. 0) goto 2900
       jxline = jxline + 1
       tmpnam = line(1:64)
       nwords = 1
       call triml(tmpnam)
       call lower(tmpnam)
       call bwords(tmpnam, nwords, words)

       iscomm2 = (line(1:1).ne.' ').and.(index(cchars,line(1:1)).ne.0)
       call str2dp(words(1), xx, ier)
       iscomm = ier.ne.0
cc       print*, words(1), iscomm, iscomm2
c      c       .not.isnum(words(1))

c       if (iscomm.neqv.iscomm2) then
c          call warn(3, ' *** read_data: uncertain about comment')
c          write(messg, '(3x,a)') line(1:40)
c          call warn(3,messg)
c          print*,  iscomm, words(1)
c       endif

       if ((ilen.le.0).or.(line.eq.' ')
     $      .or.(jxline.le.in_titles)) goto 100
c check for label line
       if  (line(3:7).eq.'-----')  istitl = .false.
       if ((line(3:7).eq.'-----').and.(type.eq.'label')) then
          ilen = iread(lun, line)
          if (ilen .lt. 0) goto 700
          jxline = jxline + 1
          if (iscomm) line = line(2:)
          call triml(line)
          call lower(line)
          nwords  = mwords
          call bwords(line, nwords, words)
          llen  = 1
          do 130 i = 1, nwords
             j      = index(words(i),'.')
             suffix = words(i)(j+1:)
             lslen  = istrln(suffix)
             labstr = labstr(1:llen)//blank//suffix(1:lslen)
             llen   = istrln(labstr)
 130      continue 
c nlab:  number of labels read in
          nlabs = nwords
          goto 200
       end if
c
c read titles into temporarily-named arrays (they'll be renamed 
c according to group below)
 145   format ('$',a,'_title_',i2.2)
       if (iscomm) then
          if (save_titles.and.istitl.and.(ntitle.lt.nt_max)) then
             line   = line(2:)
             ntitle = ntitle + 1
             write(tmpstr, 145) pre(1:ilpre), ntitle
             call settxt(tmpstr,   line)
          endif
          goto 100
       elseif (isdat(line)) then
          nwords = mwords
          call bwords(line, nwords, words)
          goto 210
       else
          goto 100
       end if 
c
c
c  read numerical data
 200   continue
       ilen = iread(lun, line)
       if (ilen .lt. 0) goto 700
       jxline = jxline + 1
       iscomm = (line(1:1).ne.' ').and.(index(cchars,line(1:1)).ne.0)
       if (iscomm.or.(ilen.le.0).or.(line.eq.' ')) goto 200
 210   continue
       nwords = mwords
       call bwords(line, nwords, words)
c  here we have the first real row of numerical data. 
c  save number of arrays to use
       npts = npts + 1
       if (npts.eq.1) then
          nwords1 = nwords
          if (narrs.eq.0) narrs = nwords
          if ((type.ne.'label').and.(type.ne.'user')) then
             do 250 in = 1, narrs
                call file_type_names(type,in,suffix)
                lslen  = istrln(suffix)
                labstr = labstr(1:llen)//blank//suffix(1:lslen)
                llen   = istrln(labstr)                
 250         continue
          endif
       endif
       if (nwords.ne.nwords1) then
          write(messg, '(3x,a,i5)') ' *** read_data: inconsistent '//
     $         'number of columns at line  ',  jxline
          call warn(1,messg)
       endif
cc       print*,  jxline, nwords, '   : ', line(1:30)
       do 580 i = 1, nwords
          ndata = ndata + 1
          if (ndata .lt. maxbuf) then
             call str2dp(words(i), buffer(ndata), ier)
             if (ier.ne.0) then
                if (lun.gt.0) close (lun)
                call echo(' *** read_data: non numeric data in file!')
                write(messg, '(3x,a,i5)') ' *** read_data: at line  ',
     $               jxline
                call echo(messg)
                write(messg, '(3x,a)') line(1:ilen)
                call warn(3,messg)
                return
             endif
          end if
 580   continue 
       if (j.ge.maxbuf) then
          write(messg, '(3x,a)')
     $         ' *** read_data: file larger than buffer size'
          call warn(3,messg)
          return
       else
          goto 200
       endif
 700   continue 
c
c  done reading numerical data
       if (narrs.le.0) goto 2900
       npts = ndata/narrs
       if (npts .gt. maxsize_array) then 
          npts = maxsize_array
          write(messg, '(3x,2a,i6,a)') 'warning: file has more ',
     $         'data points than maximum array size (',
     $         maxsize_array,')'
          call echo(messg)
          write(messg, '(12x,a)') 'arrays will be truncated.'//
     $         ' some data will be lost.'
          call warn(3,messg)
       endif
c
c now we're done reading the data.
c sort data by a specified column
       do 1010 i = 1, npts
          sindex(i) = i
 1010  continue 
       if (do_sort) then
cc          print*, ' do sort ', isort
          if ((isort.le.0).or.(isort.gt.narrs)) isort = 1
          do 1020 i = 1, npts
             tmparr(i) = buffer(isort + (i-1) * narrs)
 1020     continue 
          if (npts .ge. 2) then
             call sort2(npts, tmparr,sindex)
          endif
       endif
c
c put data into arrays and construct output label line
       nlabs = mwords
       del   = '.'
       if (npts .eq. 1) del = '_'
       do 1400 i = 1, mwords
          words(i) = ' '
 1400  continue 
       call bwords(labstr, nlabs, words)
       llen  = 1
       label = ' '
       do 1600 i = 1, narrs
          suffix = words(i)
          if (.not.(isvnam(suffix, 1) ))  then
             call fixnam(suffix,2)
             if (suffix .eq. undef) suffix = ' '
          end if
c avoid repeated arrays: since we're sure that the indarrs are different, 
c       and renaming according to them (without using iff_rename), we 
c       have to be on the look-out for this case.
          do 1530 j = 1, i-1
             if (suffix.eq.words(j)) suffix = ' '
 1530     continue 
          if (suffix.eq. ' ') write(suffix,'(i3)') i
          call triml(suffix)
          tmpnam = pre(1:ilpre)//del//suffix
          lslen = istrln(suffix)
          newlen= llen + lslen + 1
          if (newlen.ge. mlabel_len)  then
             nlabel_out = nlabel_out + 1
             if (nlabel_out.ge.10) then 
                write(labnam,2002) 'column_label', nlabel_out
             else
                write(labnam,2001) 'column_label', nlabel_out
             endif
             call settxt(labnam,label)
             label = ''
             llen  = 1
          endif 
          label = label(1:llen)//blank//suffix(1:lslen)
          llen  = istrln(label)
          do 1550 j = 1, npts
             tmparr(j) = buffer(i +  (int(sindex(j))-1) * narrs)
 1550     continue 
          if (npts .gt. 1) then
             call set_array(suffix, pre, tmparr, npts, 1)
          else
             call setsca(tmpnam,tmparr(1))
          endif

 1600  continue 
c
 2001  format(a12,i1.1)
 2002  format(a12,i2.2)
c
       if (llen .ge.1) then
          nlabel_out = nlabel_out + 1
          if (nlabel_out.ge.10) then 
             write(labnam,2002) 'column_label', nlabel_out
          else
             write(labnam,2001) 'column_label', nlabel_out
          endif
          call settxt(labnam,label)
          label = ''
       endif
          
c finally set all the program variables
       call setsca('&n_arrays_read',  narrs*1.d0)
       call settxt('group',    pre)
       call settxt('filename', file)
       call settxt('commentchar', comchr)
       tmparr(1) = nlabel_out
       call setsca('ncolumn_label', tmparr(1))
       call gettxt('column_label1', label)
       call settxt('column_label', label)
c close unit if still opened
 2900  continue 
       if (lun.gt.0) close(lun)
       call iff_sync
       return
c  end subroutine iff_rddata
       end

       subroutine iff_minimize(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c interface for general  function fitting
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'feffit.h'
       save
       character*(*) str
       character*32  defkey(1)
       character*256     fitarr, x_arr, errarr, name1
       double precision  xfmin, xfmax, toler, toldef
       parameter (toldef = 1.d-7)
       integer     lenwrk, lenfvc, nerstp, get_array
       parameter(lenwrk = 2*maxpts*mvarys + 20*mvarys + 2*maxpts)
       parameter(lenfvc = 2*maxpts)
       double precision   work(lenwrk), fvect(lenfvc), ftemp(lenfvc)
       double precision   fjac(lenfvc, mvarys)
       double precision   alpha(mvarys, mvarys), varys(mvarys)
       double precision   sumsqr, chired, tmp
       integer    iwork(mvarys), ibadx(mvarys), jprint, mfx
       integer    k, i, ier, ndfkey, lminfo, istrln , ilen
       integer    ixa, nxa, nofx, nfdata, imac_tmp
       logical    setx1, setx2, isamac
       integer    iff_eval_dp, iff_eval
       external   iff_eval_dp, iff_eval, sumsqr, isamac
       external   genfun, get_array, istrln, nofx
 

       restraint(1,1)   = undef
       nrestraint(1)    = 0
       fit_macro = undef
       fit_m_arg = ' '
       ifit_mac  = -1
       nerstp = 1
       jprint = 0
       toler  = zero
       usewgt = .false.
       errarr = 'fit_weight'
       x_arr  = undef
       setx1  = .false.
       setx2  = .false.
       xfmin  = zero
       xfmax  = zero

       
c  interpret any and all keyword/value pairs for setting options
       call bkeys(str, mkeys, keys, values, nkeys)
       ndfkey    =  1
       defkey(1) = 'array'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'array')) then
             fitarr = values(i)
          elseif ((keys(i).eq.'ordinate').or.(keys(i).eq.'x')) then
             x_arr  = values(i)
          elseif ((keys(i).eq.'uncertainty')) then
             errarr = values(i)
             usewgt = .true.
          elseif ((keys(i).eq.'xmax')) then
             ier = iff_eval_dp(values(i), xfmax)
             setx2  = .true.
          elseif ((keys(i).eq.'xmin')) then
             ier = iff_eval_dp(values(i), xfmin)
             setx1  = .true.
          elseif ((keys(i).eq.'toler')) then
             ier = iff_eval_dp(values(i), toler)
          elseif (keys(i).eq.'macro') then
             fit_macro = values(i)
          elseif ((keys(i).eq.'macro_arg')) then
             fit_m_arg = values(i)
          elseif (keys(i).eq.'restraint')  then
             if ((values(i).ne.'').and.(values(i).ne.undef)) then
                nrestraint(1)   = nrestraint(1) + 1
                restraint(nrestraint(1),1) = values(i)
             endif
          else
             call warn(1,' *** minimize: unknown key: '//keys(i)(1:k))
          end if
 100   continue
c
       call gettxt('group', name1)
       nfdata = get_array(fitarr, name1, 0, tmparr)
       if (nfdata.le.0) then
          call warn(2, ' minimize : no function to minimize?')
          return
       end if
       cfmin_pre = name1
       cfmin_arr = fitarr
       cfmin_err = ''
       iferr     = get_array(errarr, name1, 0, tmparr)
       if (iferr .gt. 0)  cfmin_err = errarr
       ifitx1 = 1
       ifitx2 = nfdata
c
c  if x array is given use it for number of fit points,
c  and look at setx1 / setx2 for user-limited fit range
       if ((x_arr.ne.undef)) then 
          ixa = iff_eval(x_arr,  name1, tmparr,nxa)
          if (ixa.ne.0) then
             if (setx1) ifitx1 = nofx(xfmin, tmparr, nxa)
             if (setx2) ifitx2 = nofx(xfmax, tmparr, nxa)
          else 
             call echo( ' minimize : cannot find ordinate function')
             call warn(1, '            for setting fit bounds')
          end if
       end if
       mfit = ifitx2 - ifitx1 + 1 + nrestraint(1)
cc       print*, 'MIN ifitx1,2,mfit = ', ifitx1, ifitx2, mfit
c
c setup and call lmdif
cc       print*, ' nvarys = ', nvarys, mfit, ifitx1, ifitx2
       if (toler .le. zero) toler = toldef
       do 200 i =1, nvarys
          varys(i) = scalar(i)
 200   continue
       do 210 i =1, mfit
          fvect(i) = zero
 210   continue
       do 220 i =1, lenwrk
          work(i) = zero
 220   continue
       do 240 i =1, mvarys
          iwork(i)  = 0
 240   continue
c
c
c determine dependencies
c note that we call iff_sync and then re-determine ifvar!!
       call iff_sync
       ifvar = get_array(fitarr, name1, 0,tmparr)
c
c  check if fit_macro call will work
       if (fit_macro.ne.undef) then
          ifit_mac = 0
          nmacxx_save =  nmacro
          nmacro = 0
          if (.not.(isamac(fit_macro,ifit_mac))) then
             tmpstr = '  fitting macro not found: '//fit_macro
             call warn(1,tmpstr)
             fit_macro = undef
             ifit_mac  = 0
          endif
c save current macro state for later
          if (ifit_mac.gt.0) then
             nmac_stop = nmacro
             imac_tmp = imac
          endif
       endif

       if (nvarys.gt.0)  then
          final = .false.
          itera = 0
          call setsca('&fit_iteration', zero)
          call chrdmp(' minimize: fitting ... ')
          call lmdif1 (genfun, mfit, nvarys, varys, fvect,
     $         toler, lminfo, iwork, work, lenwrk)

          call lm_err(lminfo,toler)
cc            if ((lminfo.ne.0).and.(lminfo.ne.4).and.(lminfo.ne.5)) then
          if (lminfo.ne.0) then 
             call chrdmp(' estimating uncertainties ... ')
             call fiterr(genfun, mfit, nvarys, lenfvc, mvarys, fvect,
     $            ftemp, fjac, alpha, jprint, nerstp, varys,
     $            delta, correl, ier, ibadx)

             if (ier.eq.0) then 
                call echo('done.')
             else 
                call echo('finished with warnings')
                call echo('  error bars not estimated. some '//
     $               'variable(s) may not affect the fit')
                call echo('  check these variables:')
                do 480 i = 1, nvarys
                   if (ibadx(i).gt.0) then
                      ilen = istrln(scanam(i))
                      call warn(1,'        '//scanam(i)(:ilen))
                   end if
 480            continue
             endif

          else
             call warn(1,' no uncertainties estimated!')
          end if
       else
          call warn(1,' minimize:  no variables defined.')
       end if
c save arrays to Program Variables
       final = .true.
       call genfun(mfit, nvarys, varys, fvect, lminfo)
       mfx    = mfit - nrestraint(1)
       chisqr = sumsqr(fvect, mfx)
       chired = chisqr / max(0.1d0, dble(mfx - nvarys))
       call setsca('chi_square',  chisqr)
       call setsca('chi_reduced', chired)
       tmp = nvarys * one
       call setsca('n_varys',     tmp)

       if (.not.usewgt) then
          do 500 i = 1, nvarys
             delta(i) = sqrt(abs(chired)) * delta(i)
             ilen = istrln(scanam(i))
             messg = 'delta_' // scanam(i)(1:ilen)
             call setsca(messg, delta(i))
 500      continue 
       endif

       if (ifit_mac.gt.0) then
          nmac_stop = 0
          imac      = imac_tmp
       endif
       return
       end

        subroutine engrpn(icode)
c
c  copyright 1993  university of washington      matt newville
c
c      convert english encoded math code to reverse polish code
c
c      this seems to work fairly well when part of encod, but has
c      some difficulty if the input icode is not completely
c      full of parentheses. the code is not extremely well-tested.
c      it is also a bit repetitve.
c
c strategy:
c    first assign class of operation to each argument in icode.
c    then try to convert all unary minus signs to their correct
c    one-component operator.  next, two component function are
c    put after their two arguments. one component operators are
c    then put after thier argument. finally, all parenthese and
c    commas are dropped.
c---------------------------------------------------------------------
       implicit none

       integer   ileft, iright, icomma, ineg, iy2x
       integer   iadd, isub, imul, idiv, maxlen
       parameter(ileft= -6, iright= -7, icomma= -8, ineg= -20,
     $      iy2x= -54, iadd= -50, isub= -51, imul= -52, idiv= -53)
       parameter(maxlen=1024)
       integer   icode(maxlen),  itemp(maxlen) , idone(maxlen)
       integer   iclass(maxlen), icltmp(maxlen), idtemp(maxlen)
       integer   iclo(6), i, ic, ichi, icn, id, j, j0, k, ksave
       integer   ibfr, istack
       logical   opera
c---------------------------------------------------------------------
c-- initialize itemp, and assign class to objects and operators
c
       do 10 j = 1, maxlen
           i = icode(j)
           if (i.eq.0)                      iclass(j) = 0
           if (i.gt.0)                      iclass(j) = 1
           if ((i.le.-10).and.(i.ge.-49))   iclass(j) = 2
           if ((i.eq.iadd) .or.(i.le.isub)) iclass(j) = 3
           if ((i.eq.imul) .or.(i.le.idiv)) iclass(j) = 4
           if (i.eq.iy2x)                   iclass(j) = 5
           if (i.le.-80)                    iclass(j) = 6
           if (i.eq.ileft)                  iclass(j) = 7
           if (i.eq.iright)                 iclass(j) = 8
           if (i.eq.icomma)                 iclass(j) = 9
           itemp(j) = icode(j)
           icltmp(j) = iclass(j)
  10    continue
c---------------------------------------------------------------------
c-- convert unary minus and plus signs to unitary operators
c-- plus signs are easy: simply remove the plus sign.
c-- minus signs are hard: find next operator on this level,
c-- and convert  "- x1" to  "neg ( x1 )", which will then be
c-- converted down below to "x1 neg".
       do 500 j0 = 1, maxlen
          j = j0
 100      continue
          i  = itemp(j)
          ic = icltmp(j)
          if(ic.eq.0) go to 510
          ibfr = 0
          if (j.gt.1)      ibfr = iclass(j-1)
c-- unary plus sign
          if ( ((j.eq.1).or.(ibfr.eq.7).or.(ibfr.eq.4).or.(ibfr.eq.5)
     $         .or.(ibfr.eq.9))    .and.(i.eq.iadd)  )  then
             do 120  k = j, maxlen-1
                icode(k)  = itemp(k+1)
                iclass(k) = icltmp(k+1)
 120         continue
             icode(maxlen)  = 0
             iclass(maxlen) = 0
             do 130  k = j, maxlen
                itemp(k)  = icode(k)
                icltmp(k) = iclass(k)
 130         continue
             go to 100
c-- unary minus sign
c--  change minus sign to unary operator
c--     if next object is (, then we're done.
c--     otherwise, ... - x ... -> ... neg ( x ) ...
          elseif ( ((j.eq.1).or.(ibfr.eq.7).or.(ibfr.eq.9).or.
     $            (ibfr.eq.4).or.(ibfr.eq.5)).and.(i.eq.isub)) then
c  replace '-' with 'neg'
             icode(j)  = ineg
             iclass(j) = 2
c neg number : find next +-,) or end of line, and insert parentheses.
             if (iclass(j+1).eq.1) then
                icn   =  icltmp(j+1)
                opera = (icn.eq.9).or.(icn.eq.8).or.(icn.eq.0)
     $               .or.(icn.eq.3)
c
                if (.not.opera) then
                   istack = 0
                   k      = j
 140               continue
                   k = k + 1
                   if (k.ge.maxlen) go to 150
                   icn   =  icltmp(k)
                   opera =  (icn.eq.9).or.(icn.eq.8).or.(icn.eq.0)
     $                  .or.(icn.eq.3)
                   if ( (istack.eq.0) .and.opera) go to 150
                   if (icn.eq.7) istack = istack + 1
                   if (icn.eq.8) istack = istack - 1
                   go to 140
 150               continue
                   ksave = k -1
c  insert left paren
                   icode(j+1)  = ileft
                   iclass(j+1) = 7
c  bump everything after left paren up by 1
                   do 170  k = j+2, ksave + 1
                      icode(k)  = itemp(k-1)
                      iclass(k) = icltmp(k-1)
 170               continue
c  insert right paren
                   icode(ksave+2)  = iright
                   iclass(ksave+2) = 8
c  bump everything after right paren up by 2
                   do 180  k = ksave+3, maxlen-2
                      icode(k)  = itemp(k-2)
                      iclass(k) = icltmp(k-2)
 180               continue
                end if
c
c neg unary operator : need to find end of argument of operator.
c       then change '-' -> neg and insert parens.
             elseif (((iclass(j+1).eq.2).or.(iclass(j+1).eq.6))
     $               .and.(iclass(j+2).eq.7)) then
c  find end of argument
                istack = 1
                do 200 k = j+3, maxlen
                   if (icltmp(k).eq.7) istack = istack + 1
                   if (icltmp(k).eq.8) istack = istack - 1
                   if (istack.eq.0) go to 220
 200            continue
 220            continue
                ksave = k
c  insert left paren
                icode(j+1)  = ileft
                iclass(j+1) = 7
c  bump everything after left paren up by 1
                do 250  k = j+2, ksave + 1
                   icode(k)  = itemp(k-1)
                   iclass(k) = icltmp(k-1)
 250            continue
c  insert right paren
                icode(ksave+2)  = iright
                iclass(ksave+2) = 8
c  bump everything after right paren up by 2
                do 280  k = ksave+3, maxlen-2
                   icode(k)  = itemp(k-2)
                   iclass(k) = icltmp(k-2)
 280            continue
             end if
             do 380 k = 1, maxlen
                itemp(k) = icode(k)
                icltmp(k) = iclass(k)
 380         continue
             j = j - 1
             if (j.eq.0) j = 1
             go to 100
          end if
c reset itemp and icltmp and go back to beginning
 500   continue
 510   continue
c
       do 600 i = 1, maxlen
          icode(i) = itemp(i)
          iclass(i) = icltmp(i)
 600   continue
c---------------------------------------------------------------------
c-- convert class 5 operators (^ only):
c   x1 ^ x2  -> x1 x2 ^
c    if operator is '^', and is not already followed by ',)+-*/^',
c    then find next place with stack=0 (that is on the current level),
c    that contains an ',)+-*/^'
       ichi = 5
       iclo(1) =  9
       iclo(2) =  8
       iclo(3) =  0
       iclo(4) =  3
       iclo(5) =  4
       iclo(6) =  5
       call class(icode, iclass, ichi, iclo)
c---------------------------------------------------------------------
c-- convert class 4 operators (* and / only):
c   x1 * x2  -> x1 x2 *
c    if operator is '*/', and is not already followed by ',)+-*/',
c    then find next place with stack=0 (that is on the current level),
c    that contains an ',)+-*/'
c  undo iclo(6) = '^' to a repeat of iclo(3) = 0
       ichi    =  4
       iclo(6) =  0
       call class(icode, iclass, ichi, iclo)
c---------------------------------------------------------------------
c-- convert class 3 operators (+ and - only):
c   x1 + x2  -> x1 x2 +
c    if operator is '+-', and is not already followed by ',)+-',
c    then find next place with stack=0 (that is on the current level),
c    that contains an ',)+-'
c  undo iclo(5) = '*/' to a repeat of iclo(3) = 0
       ichi    =  3
       iclo(5) =  0
       call class(icode, iclass, ichi, iclo)
c
       do 900 i = 1, maxlen
          itemp(i) = icode(i)
          icltmp(i) = iclass(i)
 900   continue
c
c---------------------------------------------------------------------
c-- convert class 2 and class 6 operators.
c   all unary operators and special functions have the syntax:
c        f(x1, x2, x3, ...) -> (x1, x2, x3, ...) f
       do 6900 j = 1, maxlen
          idone(j) = 0
          idtemp(j) = 0
 6900  continue
       do 8000 j0 = 1, maxlen - 1
          j  =  j0
 7000     continue
          i  =  itemp(j)
          ic =  icltmp(j)
          id =  idtemp(j)
          if(ic.eq.0) go to 8010
          if ( (id.eq.0).and.
     $         ( (ic.eq.2).or.(ic.eq.6)).and.(iclass(j+1).eq.7)) then
             istack = 1
             do 7200 k = j+2, maxlen
                if (icltmp(k).eq.7) istack = istack + 1
                if (icltmp(k).eq.8) istack = istack - 1
                if (istack.eq.0) go to 7300
 7200        continue
 7300        continue
             ksave = k
             icode(ksave)   = itemp(j)
             iclass(ksave)  = icltmp(j)
             idone(ksave)   = 1
             do 7500  k = j, ksave-1
                icode(k)  = itemp(k+1)
                iclass(k) = icltmp(k+1)
                idone(k)  = idtemp(k+1)
 7500        continue
c     reset itemp and start over again at the same place
             icode(maxlen-1) = 0
             icode(maxlen)   = 0
             idone(maxlen-1) = 0
             idone(maxlen)   = 0
             do 7800 k = 1, maxlen
                itemp(k)  = icode(k)
                icltmp(k) = iclass(k)
                idtemp(k) = idone(k)
 7800        continue
             go to 7000
          end if
 8000  continue
 8010  continue
c---------------------------------------------------------------------
c-- finally, remove all parentheses and commas for icode
       j = 0
       k = 0
       do 8900 i = 1, maxlen
          itemp(i)  = icode(i)
          icltmp(i) = iclass(i)
          icode(i)  = 0
          iclass(i) = 0
 8900  continue
 9000  continue
       j = j + 1
       if (j.gt.maxlen) go to 9100
       ic = icltmp(j)
       if (ic.eq.0) go to 9100
       if ( (ic.ne.7).and.(ic.ne.8).and.(ic.ne.9)) then
          k = k + 1
          icode(k)  = itemp(j)
          iclass(k) = icltmp(j)
       end if
       go to 9000
9100   continue
       return
c end subroutine engrpn
       end
       subroutine parins(strin, ilen , sopt1, sopt2)
c
c  copyright 1993  university of washington      matt newville
c
c  insert parentheses in a string for a fortran math expression
c  to give the normal math precedence :
c          "sopt1" is more important than "sopt2"
c  this gets kind of ugly but appears to never fail.
c--------------------------------------------------------------------
       implicit none

       integer     mstack,i, ilen, j, istart, istack, iopt, ioptst
       parameter ( mstack = 32)
       character*(*) strin, sopt1, sopt2
       character*2048 string, dummy, str1*1, operas*4, digits*10
       logical       paren(mstack)
       integer       idiff, jstk, i1, i2, io, ieon, nbrstr
       integer       iopen(mstack),  istrln
       parameter ( operas  =  '*/+-')
       parameter ( digits  = '0123456789')
       external      istrln, nbrstr
c insert a leading blank, initialize stack control and parentheses
       iopt = 0
       dummy = ' '
       dummy(2:ilen+1 ) = strin(1:ilen)
       string = dummy
       istart = 1
       istack = 1
       do 50 i = 1, mstack
          iopen(i)  = 1
          paren(i)  = .false.
 50    continue
 100   continue
       ilen = istrln(string) + 2
       ieon = istart - 1
       do 200 i = istart, ilen
c get current character
c check for exponentiation or parens, update stack index
c and insert parens if they aren't there already
c  note that numbers (found with nbrstr) are skipped over
         str1 = string(i:i)
          if (i.le.ieon) go to 199
          if (index( digits, str1 ).ne.0 ) then
             ieon = i + nbrstr(string(i:))
          elseif (index(sopt1,str1).ne.0) then
             iopt = i
             paren(istack) = .true.
          elseif (str1.eq.'(') then
             istack = istack + 1
             if (istack.gt.mstack) istack = mstack
             iopen(istack) = i
          elseif (str1.eq.')') then
             istack = istack - 1
             if (istack.lt.1) istack = 1
          elseif (index(sopt2, str1 ).ne.0 ) then
             ioptst = i - iopt
             if ( paren(istack)) then
                paren(istack) = .false.
c     normal case: find a far away operation
                if (ioptst.gt.1) then
                   istart = i + 2
                   io = iopen(istack)
                   idiff = i - io
                   if (idiff.gt.1) then
                      dummy = ' '
                      dummy = string(1:io)//'('//
     $                        string(io+1 :i-1)//')'//string(i:)
                      string = dummy
                   end if
c     non-normal case: operation immediately after '^'
                else
                   jstk = 0
                   do 170 j = i + 1, ilen - 2
                      str1 = string(j:j)
                      if (str1.eq.'(') then
                         jstk = jstk + 1
                      elseif (str1.eq.')') then
                         jstk = jstk - 1
                      elseif ( (jstk.eq.0) .and.
     $                        (index(operas,str1).ne.0)) then
                         go to 180
                      end if
 170               continue
 180               continue
                   dummy = ' '
                   dummy = string(:i-1)//'('//string(i: j-1)
     $                  //')'//string(j:)
                   string = dummy
                end if
                go to 100
             else
                iopen(istack) = i
             end if
          end if
 199      continue
 200   continue
c     if needed, insert a last set of parens at the end
       if ( paren(1).and.(iopen(1).ne.1)) then
          i1 = iopen(istack)
          i2 = istrln(string) + 1
          dummy  = ' '
          dummy  = string(1:i1)//'('//
     $         string(i1+1:i2-1)//')'//string(i2:)
          string = dummy
       end if
       call triml(string)
       strin = string
       ilen  = istrln(string)
300    continue
       return
c end soubroutine parins
       end
      subroutine parens(string)
c
c  copyright 1993  university of washington      matt newville
c  insert parentheses in a string for a fortran math expression
c  to give the normal math precedence :
c   ^   before   *,/,+,-          and  *,/    before   +,-
c  also:  ** is replaced by ^
c
c  this calls parins, which does the real work of inserting parens.
c--------------------------------------------------------------------
       implicit none
       character*(*) string,  strtmp*2048
       integer       i, ilen, istrln
       external      istrln
c
c  first replace '**' with '^ '
       strtmp = string
       ilen = max(2, istrln(strtmp))
       do 10 i = 1, ilen-1
          if (strtmp(i:i+1).eq.'**') then
             strtmp(i:i+1) = '^ '
          end if
 10    continue
       call unblnk(strtmp)
       ilen = istrln(strtmp)
       if ((strtmp.ne.' ').and.(ilen.gt.0)) then
c
c then put parentheses in to make sure that exponentiation is
c done before multiplication, division, addition, or subtraction.
          if (index(strtmp,'^').ne.0)
     $         call parins(strtmp,ilen,'^','*/+-')
c
c then put parentheses in to make sure that multiplication and
c division are done before addition and subtraction.
          if ((index(strtmp,'*').ne.0).or.(index(strtmp,'/').ne.0))
     $         call parins(strtmp,ilen,'*/','+-')
c
c   put new string into output and return
       endif
       string = strtmp
       return
c end subroutine parens
       end
        subroutine class(icode, iclass, ichi, iclo)
c
c    copyright 1993  university of washington   matt newville
c
c    this is a subroutine of engrpn. operators are moved around
c    to convert english math to reverse polish.
c    if operator is of class icin, and is not already followed by
c    an operator with class in iclo,  then find next place with
c    stack=0 (that is on the current level), that contains an
c    operator with class in iclo
c---------------------------------------------------------------------
        implicit none
       integer i, maxlen, j0, ksave, ic, icn, j, k, istack
       parameter(maxlen =1024)
       integer icode(maxlen),  iclass(maxlen), ichi , iclo(6)
       integer itemp(maxlen),  icltmp(maxlen)
       logical opera
       do 100 i = 1, maxlen
          itemp(i)  = icode(i)
          icltmp(i) = iclass(i)
  100  continue
       do 2000 j0 = 1, maxlen - 1
          j  =  j0
  500     continue
          ic =  icltmp(j)
          if (ic.eq.0) go to 2010
          if (ic.eq.ichi) then
             icn   =  icltmp(j+1)
             opera = .false.
             do 550 i = 1, 6
                if  ( icn.eq.iclo(i)) opera = .true.
 550         continue
             if (.not.opera) then
                istack = 0
                k      = j
 600            continue
                   k = k + 1
                   if (k.ge.maxlen) go to 700
                   icn   =  icltmp(k)
                   opera = .false.
                   do 650 i = 1, 6
                      if  ( icn.eq.iclo(i)) opera = .true.
 650               continue
                   if ( (istack.eq.0) .and. opera) go to 700
                    if (icn.eq.7) istack = istack + 1
                   if (icn.eq.8) istack = istack - 1
                   go to 600
 700            continue
                ksave = k -1
                icode(ksave)   = itemp(j)
                iclass(ksave)  = icltmp(j)
                do 1000  k = j, ksave-1
                   icode(k)  = itemp(k+1)
                   iclass(k) = icltmp(k+1)
1000            continue
c     reset itemp and start over again at the same place
                icode(maxlen-1) = 0
                icode(maxlen)   = 0
                do 1200 k = 1, maxlen
                   itemp(k) = icode(k)
                   icltmp(k) = iclass(k)
1200            continue
                go to 500
             end if
          end if
2000   continue
2010   continue
c finish it up
       do 3000 i = 1, maxlen
          icode(i) = itemp(i)
          iclass(i) = icltmp(i)
3000   continue
c
      return
c end subroutine class
      end

       subroutine fefsrt( mfiles, mpaths, feffil, iffrec, jpthff)
c
c  this sorts the list of feff files so that feff.bin files (which
c  contain multiple paths) can  be read once, and in order, no matter
c  what the user-selected order was.
c  matt newville 1997
       integer mfiles, mpaths
       integer iffrec(mfiles), jpthff(mpaths)
       character*(*)  feffil(mfiles)

       integer  maxpth, maxfil
       parameter (maxpth = 2048, maxfil = 2048)
       integer jsave(maxfil), jffpth(maxfil)
       integer jfftmp(maxfil), ifftmp(maxfil)
       character*128 tmpfil(maxfil)
       if (mfiles.gt.maxfil)
     $      call fstop( ' increase maxfil in fefsrt')
       if (mpaths.gt.maxpth)
     $      call fstop( ' increase maxpth in fefsrt')
       naxpth = min(mpaths,maxpth)
c  there are a lot of path indices here, and they get confusing.
c  here's a menu:
c     iuser   "user path index"      what the user wrote in feffit.inp
c     inpath  "internal path index"  which set of path params to use
c     ifeff   "feff path index"      which feff file to use
c     idpath  "data path index"      which internal path is this for this
c                                    data set, when summing over paths
c  idpath is the key, and gives the rest using pointers in common blocks:
c     inpath = jdtpth(idpath,idata)
c     iuser  = jdtusr(idpath,idata)
c     ifeff  = jpthff(inpath)

       do 20 i = 1, naxpth
          jsave(i) = jpthff(i)
 20    continue
       do 25 i = 1, maxfil
          tmpfil(i) = ' '
          jfftmp(i) = 0
          ifftmp(i) = 0
 25    continue
c construct jffpth array {pointing  backwards from jpthff:
c     ifeff  = jpthff(inpath)
c     inpath = jffpth(ifeff)   }
       itmp  = 0
       do 50 i = 1, mfiles
          jffpth(i) = 0
          do 30 j = 1, mpaths
             if (jpthff(j).eq.i)  then
                jffpth(i) = j
                go to 32
             end if
 30       continue
 32       continue
          if ((feffil(i).ne. ' ').and.(iffrec(i).eq.0)) then
             itmp = itmp+1
             tmpfil(itmp) = feffil(i)
             ifftmp(itmp) = 0
             jfftmp(itmp) = jffpth(i)
             feffil(i)    = ' '
          end if
 50    continue
c
c group paths by file name:
       do 100 i = 1, mfiles
          if ((feffil(i).ne. ' ').and.(iffrec(i).ne.0)) then
             itmp = itmp+1
             i1   = itmp
             tmpfil(itmp) = feffil(i)
             ifftmp(itmp) = iffrec(i)
             jfftmp(itmp) = jffpth(i)
             do 90 j = min(mfiles,i+1), mfiles
                if (feffil(j).eq.feffil(i)) then
                   itmp = itmp+1
                   tmpfil(itmp) = feffil(j)
                   ifftmp(itmp) = iffrec(j)
                   jfftmp(itmp) = jffpth(j)
                   feffil(j)    = ' '
                end if
 90          continue
             feffil(i) = ' '
c sort entries with same path names:  elements i1 to itmp:
             if (i1.lt.itmp) then
                n = itmp - i1 + 1
                call sort2i(n,ifftmp(i1),jfftmp(i1))
             end if
          end if
 100   continue
c replace original arrays with new, sorted values
       do 500 i = 1, mfiles
          feffil(i) = tmpfil(i)
          iffrec(i) = ifftmp(i)
 500   continue
       do 700 i = 1,naxpth
          if (jsave(i).ne.0) jpthff(i) = jsave(jfftmp(jsave(i)))
 700   continue

       return
       end

       subroutine genfun(mf, nx, xv, fv, iend)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose:  generic function for lmdif1 minimization 
c
c arguments:
c      mf       number of points in ffit                [in]
c      nx       number of points in xv                  [in]
c      xv       vector of variables                     [in]
c      fv       output vector to be minimized           [out]
c      iend     information tag                         [out]
c
       implicit none
       include 'consts.h'
       include 'arrays.h'
       include 'feffit.h'
       include 'keywrd.h'
c local variables
       integer   nx, mf, iend, i, j, iter, nf1, ne1, get_array
       integer   ier, iff_eval_dp, mfx
       double precision  xv(nx), fv(mf), epsmin, getsca, tmpval
       double precision  fitarr(maxpts)
       parameter (epsmin = 1.d-9)
       external getsca, get_array, iff_eval_dp
       save
       if (nx.ne.nvarys) iend = 1
       if (mf.ne.mfit)   iend = 2
       do 20 i =1, nx
          scalar(i) = xv(i)
 20    continue
c
c synchronize variables and their dependencies
       call synvar
c
c look up function to minimize
       nf1 = get_array(cfmin_arr, cfmin_pre, 0, fitarr)
       ne1 = get_array(cfmin_err, cfmin_pre, 0, tmparr)
cc       print*, ' genfun = ', nf1, ne1, ':', cfmin_arr(1:40), '/',
cc     $      cfmin_err(1:40)
cc       print*, ' mf     = ', mf, ifitx1, ifitx2, usewgt,ne1
cc       print*, ' tmparr = ', tmparr(1), tmparr(2),tmparr(3)

       mfx = mf - nrestraint(1)
       if (usewgt.and.(ne1.gt.0)) then
          do 50 i = 1, mfx 
             j = ifitx1 - 1 + i 
             fv(i) = fitarr(j) / max(epsmin, tmparr(j))
 50       continue
       else
          do 70 i = 1, mfx
             j = ifitx1 - 1 + i 
             fv(i) = fitarr(j)
 70       continue
       end if
       if (nrestraint(1) .ge. 1) then
          do 90 i =  1, nrestraint(1) 
             if ((restraint(i,1).ne.'').and.
     $            (restraint(i,1).ne.undef)) then
                ier       = iff_eval_dp(restraint(i,1),tmpval)
                fv(mfx+i) = tmpval
             endif
 90       continue 
       endif

c
c execute user-defined macro
       iter  =  int(getsca('&fit_iteration',0))
       if ((iter.gt.itera) .and. (ifit_mac.gt.0)) then
          itera = iter
          call iff_macro_do(ifit_mac, fit_m_arg, 0,.false.)
       endif
       return
c end subroutine genfun
       end

      subroutine besjn (x, jl, nl)

c-----------------------------------------------------------------------
c
c     purpose:  to calculate the spherical bessel functions jl and nl
c               for l = 0 to 30 (no offset)
c
c     arguments:
c       x = argument of jl and nl
c       jl = jl bessel function (abramowitz conventions)
c       nl = nl bessel function (abramowitz yl conventions)
c            Note that this array nl = abramowitz yl.
c       jl and nl must be dimensioned 
c            complex*16 jl(ltot+2), nl(ltot+2), with ltot defined in 
c            dim.h.
c
c     notes:  jl and nl should be calculated at least to 10 place
c             accuracy for the range 0<x<100 according to spot
c             checks with tables
c
c     error messages written with PRINT statement.
c
c     first coded by r. c. albers on 14 dec 82
c
c     version 3
c
c     last modified: 27 jan 83 by r. c. albers
c     dimension of jl,nl changed from 31 to 26  (10 aug 89) j. rehr
c     modified again, siz, June 1992
c
c-----------------------------------------------------------------------

       implicit double precision (a-h, o-z)
       include 'dim.h'
       
       complex*16 x
       complex*16 jl(ltot+2), nl(ltot+2)
       complex*16 cjl(ltot+2), sjl(ltot+2), cnl(ltot+2), snl(ltot+2)
       
       complex*16 xjl,xnl,asx,acx
       complex*16 xi,xi2,xi3,xi4,xi5,xi6,xi7,xi8,xi9,xi10,xi11
       double precision xcut, xcut1, xcut2
       
       parameter (xcut = 1.d0, xcut1 = 7.51d0, xcut2 = 5.01d0)

      if (dble(x) .le. 0)  call fstop(' at besjn: '//
     $      'Re(x) is <=0')

      lmaxp1 = ltot+2

      if (dble(x) .lt. xcut)  then
c        case Re(x) < 1, just use series expansion
         do 10 il = 1,lmaxp1
            l = il-1
            ifl = 0
            call bjnser (x,l,xjl,xnl,ifl)
            jl(il) = xjl
            nl(il) = xnl
   10    continue

      elseif (dble(x) .lt. xcut1)  then

c        case 1 <= Re(x) < 7.5

         call bjnser (x,lmaxp1-1,xjl,xnl,1)
         jl(lmaxp1) = xjl

         call bjnser (x,lmaxp1-2,xjl,xnl,1)
         jl(lmaxp1-1) = xjl

         if (dble(x) .lt. xcut2)  then
c           Re(x) < 5
            call bjnser (x,0,xjl,xnl,2)
            nl(1) = xnl
            call bjnser (x,1,xjl,xnl,2)
            nl(2) = xnl
         else
c           Re(x) >= 5
            asx = sin(x)
            acx = cos(x)
            xi = 1 / x
            xi2 = xi*xi
            nl(1) = -acx*xi
            nl(2) = -acx*xi2 - asx*xi
         endif

c        Use recursion relation 10.1.19 to get nl and jl
         do 50 lp1 = 3, lmaxp1
            tlxp1 = 2*lp1 -3
            nl(lp1) = tlxp1 * nl(lp1-1) / x  -  nl(lp1-2)
   50    continue

         do 60 lx = 3,lmaxp1
            lp1 = lmaxp1+1-lx
            l = lp1-1
            tlxp3 = 2*l + 3
            jl(lp1) = tlxp3 * jl(lp1+1) / x  -  jl(lp1+2)
   60    continue

      else
c        case Re(x) > 7.5
c        Use AS 10.1.8 and 10.1.9, sjl=P, qjl=Q, note that AS formulae
c        use cos (z - n*pi/2), etc., so cos and sin terms get a bit
c        scrambled (mod 4) here, since n is integer.  These are hard-
c        coded into the terms below.
         xi = 1 / x
         xi2  = xi*xi
         xi3  = xi*xi2
         xi4  = xi*xi3
         xi5  = xi*xi4
         xi6  = xi*xi5
         xi7  = xi*xi6
         xi8  = xi*xi7
         xi9  = xi*xi8
         xi10 = xi*xi9
         xi11 = xi*xi10

         sjl(1) = xi
         sjl(2) = xi2
         sjl(3) = 3.d0*xi3 - xi
         sjl(4) = 15.d0*xi4 - 6.d0*xi2
         sjl(5) = 105.d0*xi5 - 45.d0*xi3 + xi
         sjl(6) = 945.d0*xi6 - 420.d0*xi4 + 15.d0*xi2
         sjl(7) = 10395.d0*xi7 - 4725.d0*xi5 + 210.d0*xi3 - xi
         sjl(8) = 135135.d0*xi8 - 62370.d0*xi6 + 3150.d0*xi4 -
     $        28.d0*xi2
         sjl(9) = 2027025.d0*xi9 - 945945.d0*xi7 + 51975.d0*xi5 -
     1        630.d0*xi3 + xi
         sjl(10) = 34459425.d0*xi10 - 16216200.d0*xi8 + 
     1        945945.d0*xi6 - 13860.d0*xi4 + 45.d0*xi2
         sjl(11) = 654729075.d0*xi11 - 310134825.d0*xi9 + 
     1        18918900.d0*xi7 - 315315.d0*xi5 + 1485.d0*xi3 - xi

         cjl(1) = 0
         cjl(2) = -xi
         cjl(3) = -3.d0*xi2
         cjl(4) = -15.d0*xi3 + xi
         cjl(5) = -105.d0*xi4 + 10.d0*xi2
         cjl(6) = -945.d0*xi5 + 105.d0*xi3 - xi
         cjl(7) = -10395.d0*xi6 + 1260.d0*xi4 - 21.d0*xi2
         cjl(8) = -135135.d0*xi7 + 17325.d0*xi5 - 378.d0*xi3 + xi
         cjl(9) = -2027025.d0*xi8 + 270270.d0*xi6 - 6930.d0*xi4 +
     $        36.d0*xi2
         cjl(10) = -34459425.d0*xi9 + 4729725.d0*xi7 - 135135.d0*xi5 +
     1        990.d0*xi3 - xi
         cjl(11) = -654729075.d0*xi10 + 91891800.d0*xi8 - 
     1        2837835.d0*xi6 + 25740.d0*xi4 - 55.d0*xi2
         do 80 ie = 1,11
            snl(ie) = cjl(ie)
            cnl(ie) = -sjl(ie)
   80    continue
         do 90 lp1 = 12,lmaxp1
            tlxp1    = 2*lp1-3
            sjl(lp1) = tlxp1*xi*sjl(lp1-1)-sjl(lp1-2)
            cjl(lp1) = tlxp1*xi*cjl(lp1-1)-cjl(lp1-2)
            snl(lp1) = tlxp1*xi*snl(lp1-1)-snl(lp1-2)
            cnl(lp1) = tlxp1*xi*cnl(lp1-1)-cnl(lp1-2)
   90    continue
         asx = sin(x)
         acx = cos(x)
         do 110 lp1 = 1,lmaxp1
            jl(lp1) = asx*sjl(lp1)+acx*cjl(lp1)
            nl(lp1) = asx*snl(lp1)+acx*cnl(lp1)
  110    continue
      endif

      return
      end

       subroutine window(swin, dx1, dx2, xmin, xmax, xgrid, mpts, wa)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: create a window array for ffts 
c         (used to smooth out data and maintain peak separation).
c arguments:
c      swin:  window type (see notes below)             [in]
c      mpts:  dimension of wa                           [in]
c      dx1:   window parameters (see notes below)       [in]
c      dx2:   window parameters (see notes below)       [in]
c      xmin:  window range (see notes below)            [in]
c      xmax:  window range (see notes below)            [in]
c      xgrid: array grid, used to evaluate wa           [in]
c      wa:    array containing window function         [out]
c
c    notes: 9 window functions are supported.  many windows rise from
c    0 at x1 to 1 at x2, stay at 1 until x3 and drop to 0 at x4.
c    x1,...,x4 depend on window _type_ (iwin) and parameters
c    (dx1,dx2,xmin,xmax).  the gaussian window extends over the whole
c    input range and never equal 0.  the array is on an even grid
c    beginning at zero: wa(i) = wa(x=(i-1)*xgrid).
c
c  windows types are ( if swin = " ",  iwin will be set to 0).
c   iwin (swin)
c    0 (han):  hanning window sills (default):
c        x1 = xmin - dx1/2 ,   x2 = xmin + dx1/2
c        x3 = xmax - dx2/2 ,   x4 = xmax + dx2/2
c        the hanning function goes as cos^2 and sin^2.
c    1 (fha): hanning window fraction:
c        x1 = xmin ,   x2 = xmin + dx1*(xmax-xmin)/2
c        x4 = xmax,    x3 = xmax - dx1*(xmax-xmin)/2
c        the function goes as cos^2 and sin^2. dx1 is the
c        hanning fraction: the fraction of the x range over
c        which the windop is not 1. (dx1 = 1 will
c        give a full hanning fraction, with x2 = x3)
c    2 (gau): gaussian window
c        window(x) = exp( -dx1*(x - dx2)**2 )
c    3 (kai): Kaiser-Bessel window:
c       x1 = xmin ,   x4 = xmax,    x2,x3 not used
c       this function is similar to a Gaussian and goes to 0 at x1
c       and x4 for kbe = 5.44. Sometimes you will get a better resolution
c       in r-space for kbe = 2.72 (when the function isn't zero at 
c       x1 and x4. See the articel 'Digital Filter' by J.F. Kaiser in
c       'System Analysis by Digital Computers' edited by F.F. Kuo
c       and J.F. Kaiser, (New York; Wiley) 1966
c    4 (par): parzen window:
c        x1 = xmin - dx1/2 ,   x2 = xmin + dx1/2
c        x3 = xmax - dx2/2 ,   x4 = xmax + dx2/2
c        the window is linear between x1 and x2 and x3 and x4
c    5 (wel): welch window:
c        x1 = xmin - dx1/2 ,   x2 = xmin + dx1/2
c        x3 = xmax - dx2/2 ,   x4 = xmax + dx2/2
c        the window is parabolic between x1 and x2 and x3 and x4.
c    6 (sin): sine window:
c        x1 = xmin - dx1 ,   x4 = xmin + dx1
c        x2 and x3 =not used
c        this function is a sine that goes to 0 at x1 and x4
c        and is applied over the entire window range
c
c  for more information, see documentation for ifeffit
c
       implicit none
       integer mpts, iw, i, istrln
       character*(*) swin, s*32
       double precision   wa(mpts), halfpi, zero, one, half, eps
       double precision  x, x1, x2, x3, x4, xmin,xmax, xgrid, dx1, dx2
       double precision del1, del2, del12, del22
       double precision bessi0, bki0, bkav, bkde, bkde2, bkx, bkxx, bkom
       external bessi0, istrln
       parameter (halfpi= 1.570796326795d0, eps= 1.4d-5)
       parameter ( zero=0.d0, one=1.d0, half= 0.5d0) 
c determine window type
       s  = swin
       call triml(s)
       call lower(s)
       i  = istrln(s)
       iw = 0
       if     (s(1:3) .eq. 'fha') then
          iw = 1
       elseif (s(1:3) .eq. 'gau') then
          iw = 2
       elseif (s(1:3) .eq. 'kai') then
          iw = 3
       elseif (s(1:3) .eq. 'par') then
          iw = 4
       elseif (s(1:3) .eq. 'wel') then
          iw = 5
       elseif (s(1:3) .eq. 'sin') then
          iw = 6
       endif
c
       del1 = dx1
       del12= dx1 * half
       del2 = dx2
       del22= dx1 * half
       x1 = xmin
       x2 = 0
       x3 = 0
       x4 = xmax
c  set x1..x4 based on window type
c   hanning sills, parzen, and welch:
       x1 = xmin - del12
       x2 = xmin + del12  + (eps * xgrid) 
       x3 = xmax - del22  - (eps * xgrid)
       x4 = xmax + del22
cc       print*, 'U: iw, x1,x2,x3,x4',  iw, x1,x2,x3,x4
c   hanning fraction
       if (iw.eq.1) then
cc          print*, 'U: iw, x1,x2,x3,x4',  iw, x1,x2,x3,x4
          if (del12.lt.zero)  del12 = zero
          if (del12.gt.half)  del12 = half
          x2 = x1 + eps * xgrid + del12*(xmax-xmin)
          x3 = x4 - eps * xgrid - del12*(xmax-xmin) 
cc          print*, 'E: del12, del22, xgrid,eps=',del12, del12, xgrid, eps
cc          print*, 'E: x1, x2, x3, x4  = ', x1, x2, x3, x4
c   gaussian:
       elseif (iw.eq.2) then
          del1 = max(del1, eps)
c   sine
       elseif (iw.eq.6)  then
          x1 = xmin - del1
          x4 = xmax + del2
       end if
cc       print*, ' window ', xmin,xmax,del1,del2
cc       print*, ' window ', x1, x2, x3, x4, iw
c 
c now make the window array
c    hanning (fraction or sills)
       if (iw.le.1) then
          do 10 i=1,mpts
             x = (i-1)*xgrid
             if ((x.ge.x1).and.(x.le.x2)) then
                wa(i) = sin(halfpi*(x-x1) / (x2-x1)) ** 2
             elseif ((x.ge.x3).and.(x.le.x4)) then
                wa(i) = cos(halfpi*(x-x3) / (x4-x3)) ** 2
             elseif ((x.lt.x3).and.(x.gt.x2)) then
                wa(i) = one
             else
                wa(i) = zero
             endif
 10       continue
c    gaussian
       else if (iw.eq.2) then
          do 20 i = 1, mpts
             wa(i) =  exp( -(((i-1)*xgrid - del2)**2)/(2*del1*del1))
 20       continue
c     Kaiser-Bessel window
       elseif (iw.eq.3) then
          bki0  = bessi0(del1)
          bkav  = (x4+x1) * half
          bkde  = (x4-x1) * half 
          bkde2 = bkde * bkde
          bkom  = del1 / bkde
          do 30 i = 1, mpts
             wa(i) = zero
             x     = (i-1)*xgrid
             bkx   = x - bkav
             bkxx  = bkde2 - bkx*bkx
             if (bkxx.gt.0) then
                wa(i) = bessi0( bkom * sqrt(bkxx) ) / bki0
             endif
 30       continue 
c    parzen
       elseif (iw.eq.4) then
          do 40 i=1,mpts
             x = (i-1)*xgrid
             if ((x.ge.x1).and.(x.le.x2)) then
                wa(i) =  (x-x1) / (x2 - x1)
             elseif ((x.ge.x3).and.(x.le.x4)) then
                wa(i) = one - (x-x3) / (x4-x3)
             elseif ((x.lt.x3).and.(x.gt.x2)) then
                wa(i) = one
             else
                wa(i) = zero
             endif
 40       continue
c    welch
       elseif (iw.eq.5) then
          do 50 i=1, mpts
             x = (i-1)*xgrid
             if ((x.ge.x1).and.(x.le.x2)) then
                wa(i) = one - ((x-x2) / (x2-x1)) ** 2
             elseif ((x.ge.x3).and.(x.le.x4)) then
                wa(i) = one - ((x-x3) / (x4-x3)) ** 2
             elseif ((x.lt.x3).and.(x.gt.x2)) then
                wa(i) = one
             else
                wa(i) = zero
             endif
 50       continue
c    sine
       elseif (iw.eq.6) then
          do 60 i = 1, mpts
             x = (i-1)*xgrid
             if ((x.ge.x1).and.(x.le.x4))
     $            wa(i) = sin( 2* halfpi*(x4-x) / (x4-x1))
 60       continue
c    gaussian#2
       elseif (iw.eq.7) then
          do 70 i = 1, mpts
             x = (i-1)*xgrid
             wa(i) =  exp( -(del1 * (x - del2)**2 ))
 70       continue
       end if
       return
c end subroutine window
       end

       subroutine sigms (tk, theta, rs, nleg, rat, iz, sig2)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  the following routines calculate the debye-waller factor for a
c  path based on the temperature, debye temperature, average
c  norman radius, atoms in the path, and their positions.
c  these routines come courtesy of jj rehr and si zabinsky.
c  i changed them a bit.   matt n
c-------------------------------------------------------------------
c
c  from s i zabinsky.
c  inputs:
c       tk      temperature in degrees k
c       theta   debye temp in degrees k
c       rs      average wigner seitz or norman radius in bohr
c                     averaged over entire problem:
c                     (4pi/3)*rs**3 = sum( (4pi/3)rnrm**3 ) / n
c                     (sum is over all atoms in the problem)
c       nleg    nlegs in path
c       rat     positions of each atom in path (in bohr)
c       iz      atomic number of each atom in path
c output:
c       sig2    debye waller factor
c  notes:
c     all units of distance in this routine are angstroms
c     there are nleg atoms including the central atom.
c     index 0 and index nleg both refer to central atom.
       implicit none
       integer   i, j, nlegx, nleg
       double precision  tk, theta, zero, two, rs, dist
       double precision  rij, rimjm, rijm, rimj, riim, rjjm
       double precision  ridotj, cimj, cosijm, cij, cimjm
       double precision  sig2,sig2ij, cijm
       parameter (nlegx = 7, zero = 0., two = 2.)
       double precision rat(3,0:nlegx)
       integer iz(0:nlegx)
c
       sig2   = zero
       do 800 i  = 1, nleg
         do 800 j = i, nleg
c
c  calculate r_i-r_i-1 and r_j-r_j-1 and the rest of the
c  distances, and get the partial cosine term:
c       cosine(i,j) = r_i.r_j / ((r_i - r_i-1) * (r_j - r_j-1))
           rij    = dist ( rat(1,i)  , rat(1,j)   )
           rimjm  = dist ( rat(1,i-1), rat(1,j-1))
           rijm   = dist ( rat(1,i)  , rat(1,j-1))
           rimj   = dist ( rat(1,i-1), rat(1,j)   )
           riim   = dist ( rat(1,i)  , rat(1,i-1))
           rjjm   = dist ( rat(1,j)  , rat(1,j-1))
           ridotj = (rat(1,i)-rat(1,i-1)) * (rat(1,j)-rat(1,j-1))
     $            + (rat(2,i)-rat(2,i-1)) * (rat(2,j)-rat(2,j-1))
     $            + (rat(3,i)-rat(3,i-1)) * (rat(3,j)-rat(3,j-1))
           cosijm = ridotj / (riim * rjjm)
c
c  call corrfn to get the correlations between atom pairs
           call corrfn (rij  , theta, tk, iz(i)  , iz(j)  , rs, cij)
           call corrfn (rimjm, theta, tk, iz(i-1), iz(j-1), rs, cimjm)
           call corrfn (rijm , theta, tk, iz(i)  , iz(j-1), rs, cijm)
           call corrfn (rimj , theta, tk, iz(i-1), iz(j)  , rs, cimj)
c
c  combine outputs of corrfn to give the debye-waller factor for
c    this atom pair.   !!! note: don't double count (i.eq.j) terms !!!
           sig2ij = ( cij + cimjm - cijm - cimj ) * cosijm / two
           if (j.eq.i) sig2ij = sig2ij / two
           sig2 = sig2 + sig2ij
 800   continue
       return
c  end subroutine sigms
       end
       subroutine corrfn(rij, theta, tk, iz1, iz2, rs, cij)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  subroutine calculates correlation function
c  c(ri, rj) = <xi xj> in the debye approximation
c
c            = (1/n)sum_k exp(ik.(ri-rj)) (1/sqrt(mi*mj))*
c                              (hbar/2w_k)*coth(beta hbar w_k/2)
c
c            = (3kt/mu w_d**2) * sqrt(mu**2/mi*mj) * int
c  where :
c       x        k_d*r (distance parameter)  r distance in angstroms
c       theta    debye temp in degrees k
c       tk       temperature in degrees k
c       temper   theta / tk = hbar omegad/kt
c       k_d      debye wave number = (6*pi**2 n/v)
c       n/v      free electron number density = 1/(4pi/3rs**3)
c       rs       wigner seitz or norman radius in bohr
c       ami      atomic mass at sites i in amu
c       amj      atomic mass at sites j in amu
c       int      int_0^1 (temper/x) dw sin(wx)coth(w*temper/2)
c
c  solution by numerical integration
c
c  parameters pi, bohr, con
c  con=hbar**2/kb*amu)*10**20   in ang**2 units
c  hbar=1.0549x10**-34 amu=1.65979x10-27kg kb=1.3807x10-23
       implicit none
       double precision rij, theta, tk, rs, cij
       double precision pi,one,athird,bohr,con,x,temper
       double precision ami,amj,xkd,xinteg,eps,atwts

       integer  iz1,iz2,nx
       parameter (pi = 3.14159 26535 89793 23846 26433d0)
       parameter (one = 1.d0, athird = 0.333333333333333d0)
       parameter (bohr = 0.529 177 249d0)
       parameter (con = 48.559d0)
       common /xtemp/ x, temper
       external atwts
c
c  theta in degrees k, t temperature in degrees k
       ami    = atwts(iz1)
       amj    = atwts(iz2)
       temper = theta / tk
       xkd    = (9*pi/2.d0)**(athird) / (rs * bohr)
       x      = xkd * rij
c  call numerical integration
       call bingrt (xinteg, eps, nx)
       cij  = (3.d0/2.d0) * xinteg * con / (theta* sqrt(ami*amj))
       return
c  end subroutine corrfn
       end
       double precision function debfun(w)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  debfun = (sin(w*x)/x) * coth(w*temper/2)
       implicit none
       double precision wmin, argmax,x ,temper, w, emwt
       double precision  argu
       parameter (wmin = 1.d-20, argmax = 50.d0)
       common /xtemp/ x, temper

c  allow t = 0 without bombing
       debfun = 2 / temper
       if (w.gt.wmin) then
          debfun  = w
          if (x.gt.0) debfun = sin(w*x) / x
          emwt = 0
          argu = w*temper
          if (argu.lt.argmax) emwt = exp(-argu)
          debfun = debfun * (1 + emwt) / (1 - emwt)
       end if
       return
c  end function debfun
       end
       subroutine bingrt (b, eps, n)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  subroutine calculates integrals between [0,1]  b = int_0^1 f(z) dz
c  by trapezoidal rule and binary refinement  (romberg integration)
c  coded by j rehr (10 feb 92)   see, e.g., numerical recipes
c  for discussion and a much fancier version
c-----------------------------------------------
c     del=dz  itn=2**n tol=1.e-5
c     starting values
c      implicit double precision (a-h,o-z)
c     error is approximately 2**(-2n) ~ 10**(-.6n)
c     so nmax=10 implies an error of 1.e-6
c
       implicit none
       double precision debfun, zero,one,two,three,four,tol
       double precision b, eps, zi,del, sum, bn, bo,bnp1
       integer n, itn,i, nmax
       parameter(nmax = 10, tol = 1.d-5)
       parameter(zero=0.d0, one=1.d0, two=2.d0)
       parameter(three=3.d0, four=4.d0)
       external debfun
c
       n   = 0
       itn = 1
       del = one
       bn  = (debfun(zero) + debfun(one)) / two
       bo  = bn
 10    continue
c  nth iteration
c  b_n+1=(b_n)/2+deln*sum_0^2**n f([2n-1]deln)
         n   = n + 1
         if (n.gt.nmax) go to 40
         del = del / two
         sum = zero
         do 20 i= 1, itn
            zi  = (two * i - 1) * del
            sum = sum + debfun(zi)
 20      continue
c     bnp1=b_n+1 is current value of integral
c     cancel leading error terms b=[4b-bn]/3
c     note: this is the first term in the neville table - remaining
c           errors were found too small to justify the added code
         bnp1= ( bn / two ) + del * sum
         b   = (four * bnp1 - bn) / three
         eps = dabs( (b - bo) / b)
         if (eps.lt.tol) goto 60
         bn  = bnp1
         bo  = b
         itn = itn * 2
       goto 10
  40   continue
       return
 60    continue
       return
c end subroutine bingrt
       end
       double precision function atwts (iz)
c
c  returns atomic weight from atom number (iz)
c
       double precision atmass(103)
       data atmass /
     1   1.0079, 4.0026, 6.941,  9.0122, 10.81,   12.01,
     2   14.007, 15.999, 18.998, 20.18,  22.9898, 24.305,
     3   26.982, 28.086, 30.974, 32.064, 35.453,  39.948,
     4   39.09,  40.08,  44.956, 47.90,  50.942,  52.00,
     5   54.938, 55.85,  58.93,  58.71,  63.55,   65.38,
     6   69.72,  72.59,  74.922, 78.96,  79.91,   83.80,
     7   85.47,  87.62,  88.91,  91.22,  92.91,   95.94,
     8   98.91,  101.07, 102.90, 106.40, 107.87,  112.40,
     9   114.82, 118.69, 121.75, 127.60, 126.90,  131.30,
     x   132.91, 137.34, 138.91, 140.12, 140.91,  144.24,
     1   145,    150.35, 151.96, 157.25, 158.92,  162.50,
     2   164.93, 167.26, 168.93, 173.04, 174.97,  178.49,
     3   180.95, 183.85, 186.2,  190.20, 192.22,  195.09,
     4   196.97, 200.59, 204.37, 207.19, 208.98,  210,
     5   210,    222,    223,    226,    227,     232.04,
     6   231,    238.03, 237.05, 244,    243,     247,
     7   247,    251,    254,    257,    256,     254,
     8   257/
       atwts = atmass(iz)
       return
c  end function atwts
       end
       double precision function dist (r0, r1)
c      find distance between cartesian points r0 and r1
       double precision r0(3), r1(3)
       dist = 0
       do 10  i = 1, 3
          dist = dist + (r0(i) - r1(i))**2
 10    continue
       dist = sqrt(dist)
       return
c  end function dist
       end

      subroutine iff_feffit(str)
c
c given a list of paths and data, fit sum of paths to data
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fft.h'
       include 'fefdat.h'
       include 'pthpar.h'
       include 'feffit.h'
       save

       double precision  toldef, epsmin, p01
       parameter (toldef = 1.d-7, epsmin = 1.d-8, p01 = 1.d-2)
       integer   lenwrk,  lenfvc
       parameter(lenwrk = 2*maxpts*mvarys + 20*mvarys + 2*maxpts)
       parameter(lenfvc = 2*maxpts)

       logical  do_pha, do_mag, do_re, isnum, dofit, do_bkg
       character*256 str*(*), pref
       character*256 name1(mdata), nam_chi(mdata), nam_x(mdata)
       character*256 re_arr, xk_arr, winarr, winnam, fit_sp, fit_mode
       character*1024 list, cmdstr

       integer  idata, jchi, ier, illen, jk,  ilen, jwin, n1, n2
       integer  istrln, k, i, jprint, nerstp, idx, ntmp, iup
       integer  nkpts,  np, u2ipth, lminfo, nfit1, j1, j0, j2
       integer  iwork(mvarys), ibadx(mvarys), ipos, jxk, ntchi, isp
       integer  ipath_tmp(max_pathindex)
       integer  get_array, imac_tmp, j, jqw, ntbkg
       logical  iftmac, isasca, isamac, uniq_dat
       double precision  xkmin, xkmax, dk1, dk2, xkw, getsca,q, chired
       double precision  xrmin, xrmax, toler, xolow, xohigh, tmp
       double precision  work(lenwrk), fvect(lenfvc), ftemp(lenfvc)
       double precision  fjac(lenfvc, mvarys), tmpchi(maxpts)
       double precision  alpha(mvarys, mvarys), varys(mvarys), small
       double precision  qbkg1, qbkg2, bvalue,xspl(mtknot), qx
       double precision  xkdat(maxpts), xcdat(maxpts), xwdat(maxpts)
       double precision  tmparr2(maxpts)
       double precision  wtmp, stmp, sumsqr, xidat, eps_k, eps_r
       double precision  qw_tmp(mqwfs), sum2chi(mdata)
       character*128     restr_tmp(max_restraint)
       integer  nrest_tmp
       integer  iff_eval, iff_eval_dp, iff_eval_in, nqw

       external iff_eval, iff_eval_dp, iff_eval_in, bvalue
       external istrln, u2ipth, isnum,  fitfun, getsca, sumsqr
       external isasca, isamac, get_array

       toler = zero
c
       fit_macro = undef
       fit_m_arg = ' '
       ifit_mac  = -1
       nerstp= 1
       j0    = 0
       jprint= 0
       xrmin = getsca('rmin',1)
       xrmax = getsca('rmax',1)
       xkmin = getsca('kmin',1)
       xkmax = getsca('kmax',1)
       xkw   = getsca('kweight',1)
       dk1   = getsca('dk1',1)
       dk2   = getsca('dk2',1)
       xidat = getsca('data_set',1)
       idata = int(xidat)
       if (idata.le.0) idata = 1
       xidat = getsca('data_total',1)
       nfdats= int(xidat)
       eps_k = zero
       eps_r = zero
       xk_arr= undef
       winarr= undef
       pref  = undef
       call gettxt('kwindow', winnam)
       call gettxt('fit_space',fit_sp)
       fit_mode = 'ri'
ccc       call gettxt('fit_mode',fit_mode)

c  interpret any and all keyword/value pairs for setting options
       call bkeys(str, mkeys, keys, values, nkeys)
       np     =  0
       illen  =  1
       list   =  ' '
       do_re  = .false.
       do_mag = .false.
       do_pha = .false.
       do_bkg = .false.
          
       nqw = 0
       qw_tmp(1) = getsca('kweight',1)
       do 10 i = 2, mqwfs
          qw_tmp(i) = zero
 10    continue 
       nrest_tmp = 0
       
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then 
             pref  = values(i)
             call smcase(pref,'a')
          elseif (keys(i).eq.'data_set') then 
             ier   = iff_eval_dp(values(i), xidat)
             idata = int(xidat)
             name1(idata) = undef
             call setsca('data_set', xidat)
             nfit(idata) = 0
          elseif (keys(i).eq.'data_total') then 
             ier = iff_eval_dp(values(i), xidat)
             nfdats = int(xidat)
             call setsca('data_total', xidat)
          elseif (keys(i).eq.'macro') then
             fit_macro = values(i)
          elseif ((keys(i).eq.'macro_arg')) then
             fit_m_arg = values(i)
          elseif (keys(i)(1:9).eq.'restraint') then
             nrest_tmp = nrest_tmp+1
             if (idata.le.0)  idata = 0
             if (nrest_tmp.gt.max_restraint) then
                call echo(" *** feffit:: too many restraints")
                call echo("     restraint will be ignored:")
                call warn(1,"      " // values(i))
                values(i) = ''
             endif
             if((values(i).ne.'').and.(values(i).ne.undef)) then
                restr_tmp(nrest_tmp) = values(i)
cc                print*, ' Feffit restraint : ', idata
cc                print*,  nrest_tmp, values(i)(:60)
             endif
          elseif ((keys(i).eq.'rmin')) then
             ier = iff_eval_dp(values(i), xrmin)
          elseif ((keys(i).eq.'rmax')) then
             ier = iff_eval_dp(values(i), xrmax)
          elseif ((keys(i).eq.'kmax')) then
             ier = iff_eval_dp(values(i), xkmax)
          elseif ((keys(i).eq.'kmin')) then
             ier = iff_eval_dp(values(i), xkmin)
          elseif ((keys(i).eq.'error_step')) then
             ier = iff_eval_in(values(i), nerstp)
          elseif ((keys(i).eq.'error_print')) then
             ier = iff_eval_in(values(i), jprint)
          elseif (keys(i).eq.'kwindow') then
             winnam = values(i)
          elseif (keys(i).eq.'altwindow') then
             winarr = values(i)
             call lower(winarr)
          elseif (keys(i).eq.'kweight') then
             nqw = nqw + 1
             ier = iff_eval_dp(values(i), xkw)
             if ((nqw.ge.1).and.(nqw.le.mqwfs)) then
                qw_tmp(nqw) = xkw
             endif
          elseif (keys(i).eq.'dk1') then
             ier = iff_eval_dp(values(i), dk1)
          elseif (keys(i).eq.'dk2') then
             ier = iff_eval_dp(values(i), dk2)
          elseif (keys(i).eq.'dk') then
             ier = iff_eval_dp(values(i), dk1)
             dk2 = dk1
          elseif (keys(i).eq.'chi') then
             re_arr = values(i)
             call lower(re_arr)
          elseif (keys(i).eq.'k') then
             xk_arr = values(i)
             call lower(xk_arr)
          elseif ((keys(i).eq.'epsilon_k')) then
             ier = iff_eval_dp(values(i), eps_k)
          elseif ((keys(i).eq.'epsilon_r')) then
             ier = iff_eval_dp(values(i), eps_r)
          elseif ((keys(i).eq.'fit_space')) then
             fit_sp = values(i)
          elseif ((keys(i).eq.'fit_mode')) then
             fit_mode = values(i)
          elseif ((keys(i).eq.'do_real')) then
             call str2lg(values(i), do_re, ier)
          elseif ((keys(i).eq.'no_real')) then
             call str2lg(values(i), do_re, ier)
             do_re = .not. do_re
          elseif ((keys(i).eq.'do_mag')) then
             call str2lg(values(i), do_mag, ier)
          elseif ((keys(i).eq.'no_mag')) then
             call str2lg(values(i), do_mag, ier)
             do_mag = .not. do_mag
          elseif ((keys(i).eq.'do_phase')) then
             call str2lg(values(i), do_pha, ier)
          elseif ((keys(i).eq.'no_phase')) then
             call str2lg(values(i), do_pha, ier)
             do_pha = .not. do_pha
          elseif ((keys(i).eq.'do_all')) then
             call str2lg(values(i), do_re, ier)
             do_mag = do_re
             do_pha = do_re
          elseif ((keys(i).eq.'do_bkg')) then
             call str2lg(values(i), do_bkg, ier)
          elseif ((keys(i).eq.'toler')) then
             ier = iff_eval_dp(values(i), toler)
c
c path list:
          elseif (values(i).eq.undef) then
             call str2il(keys(i), max_pathindex, np, ipath_tmp,ier)
             if (ier .eq. 0) then
                jk    = istrln(keys(i))
                list  = list(1:illen)//keys(i)(1:jk)//','
                illen = illen+jk+1
             else
                call echo(' *** feffit: error generating path list')
                call warn(2, keys(i)(1:k))
             end if
          else
             call warn(1,' *** feffit: unknown key: '//keys(i)(1:k))
          end if
 100   continue 
c===================================================================
c  done reading input params
       idata  = max(1, min(mdata, idata))
       nfdats = max(1, min(mdata, nfdats))
       dofit  = (idata.ge.nfdats)
       bkgfit(idata) = do_bkg
cc       print*, ' feffit: ', idata, bkgfit(idata)

cc       print*, ' __ feffit __ : idata, nfdats = ', idata, nfdats
c===================================================================
c for this data set:
c    resolve chi(k) name, get index of chi data
c    set fft / fit params 
c    get eps_k and eps_r from iff_chieps (unless given explicitly!)
c    set path list

       name1(idata) = pref
       if (name1(idata) .eq. undef) name1(idata) = 'feffit'
       
       jchi  = get_array(re_arr, name1(idata), 0, xcdat)
       if (jchi.le.0) then
          call warn(2, ' feffit: no chi(k) data array?')
          return
       end if
c save name of re_arr for later
       nam_chi(idata) = re_arr
       nam_x(idata)   = undef
       call prenam(name1(idata),nam_chi(idata))
cc       print*, 'XXXX idata ', idata, nam_chi(idata)(1:30)
c
c if k-data is given, shift/interpolate input data onto 
c fit k-grid: chi(1) = chi(k=0).

       if (xk_arr.ne.undef) then
          ipos = 0
          jxk  = get_array(xk_arr, name1(idata), 0, xkdat)
          nam_x(idata) = xk_arr
          call prenam(name1(idata),nam_x(idata))
          if (jxk.gt.0) then
             nkpts = min(jxk, jchi)
             ntchi = int(1 + xkdat(jxk)/qgrid)
             do 130 i = 1, ntchi
                q = (i-1) * qgrid
                call lintrp(xkdat, xcdat, nkpts, q,ipos,tmpchi(i))
 130         continue
          else
             call warn(2, ' feffit: bad k-data array?')
             return
          endif
       else
          nkpts = jchi
          ntchi = jchi
          do 150 i = 1, ntchi
             tmpchi(i) =  xcdat(i)
 150      continue 
       endif
c save this chi(k) data to the appropriate array for fitfun,
c accumulate sum-of-squares for later uniqueness check
       sum2chi(idata) = zero
       do 170 i = 1, ntchi
          chiq(i,idata) = tmpchi(i)
          sum2chi(idata) = sum2chi(idata) + tmpchi(i)*tmpchi(i)
 170   continue 
       do 175 i = ntchi+1,maxpts
          chiq(i,idata) = zero
 175   continue 

c support for refining bkg(k) with EXAFS parameters
       if (bkgfit(idata)) then
          rbkg_f(idata) = xrmin
          xrmin       = zero
       endif
c
c  check if fit_macro call will work
       if (fit_macro.ne.undef) then
          ifit_mac = 0
          iftmac = isamac(fit_macro,ifit_mac)
          if (.not.iftmac) then
             cmdstr = '  fitting macro not found: '//fit_macro
             call warn(1,cmdstr)
             fit_macro = undef
             ifit_mac  = 0
          endif
          if (ifit_mac.gt.0) then
             nmac_stop = nmacro
             imac_tmp = imac
          endif
       endif
c
c  set up fft/fit parameters, initialize window functions
       small      = rgrid * p01
       n1         = int( (xrmin + small) / rgrid )  + 1
       n2         = int( (xrmax + small) / rgrid )
       if (n2.le.n1) n2 = n1 + 1
       nrpts(idata)  = n2 - n1 + 1
       rmax(idata)   = rgrid * n2
       rmin(idata)   = rgrid * n1
       dq1(idata)    = dk1
       dq2(idata)    = dk2
       small         = qgrid * p01
       n1            = int( (xkmin + small) / qgrid )  + 1
       n2            = int( (xkmax + small) / qgrid )
       if (n2.le.n1) n2 = n1 + 1
       nqpts(idata)  = n2 - n1 + 1
       qmax(idata)   = qgrid * n2
       qmin(idata)   = qgrid * n1
       nqfit(idata)  = int((qmax(idata) + 5*dq2(idata))/qgrid)

       xinfo(idata)  = 2 * ((rmax(idata)-rmin(idata))*
     $      (qmax(idata)-qmin(idata))) /pi
       if (bkgfit(idata)) then
          qbkg1       = max(zero,qgrid*n1 - dk1)
          qbkg2       = min(qgrid*n2 + dk2,  qgrid*nkpts)
          if (qbkg2 .le. (qbkg1 + 5*qgrid)) then
             qbkg2    = qbkg1 + 5 * qgrid
          endif
          ntbkg  = 1 + 2*int(rbkg_f(idata)*(qbkg2-qbkg1)/pi)
          ntbkg  = min(mtknot-korder-1,max(korder+1,ntbkg))
          nbkg(idata) = ntbkg
c-bkg where to put knots
          do 220 i = 1, korder
             qknot(i,idata)       =  qbkg1 - qgrid * (korder-i)
             qknot(ntbkg+i,idata) =  qbkg2 + qgrid * (i-1)
 220      continue
          ntmp   = ntbkg - korder + 1
          do 240 i = korder+1, ntbkg
             qknot(i, idata) = qbkg1 +(i-korder)*(qbkg2-qbkg1)/ntmp
 240      continue

c-bkg add spline coefs to the variable list, initialize to zero
          do 260  i = 1, ntbkg
             cmdstr = ' '
             write(cmdstr, 265)  'bkg',idata,'_',i,'  = 0.0'
             call iff_set('guess',cmdstr,1)
 260      continue
 265      format (a3,i2.2,a1,i2.2,a7)
          nvarys = nvarys + ntbkg
       else
          do 280  i = 1, ntbkg
 275         format (a3,i2.2,a1,i2.2)
             write(cmdstr, 275)  'bkg',idata,'_',i
             if (isasca(cmdstr)) then
                qx = getsca(cmdstr,0)
 285            format (a3,i2.2,a1,i2.2,a3,g15.9)
                write(cmdstr, 285)  'bkg',idata,'_',i,' = ',qx
                call iff_set('set', cmdstr,0)
             endif
 280      continue
       end if
c
c  which space is this fit in? 
       ifft(idata)   = 1
       if (fit_sp(1:1) .eq.'k') ifft(idata) = 0
       if (fit_sp(1:1) .eq.'q') ifft(idata) = 2

       modeft(idata)   = 0
       if (fit_mode(1:2) .eq.'ri') modeft(idata) = 0
       if (fit_mode(1:2) .eq.'rm') modeft(idata) = 1


cc       print*, ' Feffit ', fit_sp, ifft(idata), idata
c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c-c
c
c set k-weight, including multiple k-weights
       if (nqw.le.0) nqw = 1
       nqwfs(idata) = nqw
       do 295 i = 1, mqwfs
          qwfs(i,idata) = qw_tmp(i)
 295   continue 
       qweigh(idata) = qwfs(1,idata)

c loop over k-weights to set weight of fit
       do 450 jqw = nqw, 1, -1
          xkw = qwfs(jqw,idata)
c    determine eps_k/eps_r for this k-weight
c    call 'chieps ('chi_noise' command) to get eps_k / eps_r
          if ((eps_k .le. epsmin).and.(eps_r .le. epsmin)) then 
             ilen = istrln(nam_chi(idata))
 405         format('  chi=',a,',kmin=',f12.3,',kmax=',f12.3,
     $            ',kweight=',f12.3,',dk1=',f12.3,',dk2=',f12.3)
             write(cmdstr, 405) nam_chi(idata)(1:ilen),
     $            xkmin, xkmax,xkw,dk1,dk2
             if (nam_x(idata) .ne. undef) then
                j0 = istrln(cmdstr)
                j2 = istrln(nam_x(idata))
                cmdstr = cmdstr(:j0)//', k='//nam_x(idata)(:j2)
             endif
             call iff_chieps(cmdstr)
             sigdtk  = getsca('epsilon_k',1)
             sigdtr  = getsca('epsilon_r',1)
          elseif (eps_k .gt. epsmin) then 
             sigdtk  = eps_k
             wtmp    = 2 * xkw  + one
             sigdtr  = eps_k /  sqrt( 2 * pi * wtmp /
     $            (qgrid * (xkmax**wtmp - xkmin**wtmp )))
          elseif (eps_r .gt. epsmin) then 
             sigdtr  = eps_r
             wtmp    = 2 * xkw  + one
             sigdtk  = eps_r *  sqrt( 2 * pi * wtmp /
     $            (qgrid * (xkmax**wtmp - xkmin**wtmp )))
          end if
          call setsca('epsilon_k', sigdtk)
          call setsca('epsilon_r', sigdtr)

c set number of fit points, data-set weight, and
c a few other misc stuff based on which fit space is used
          rweigh(idata) = one
c r-space fit
          if (ifft(idata).eq.1) then
             xolow      = rmin(idata)
             xohigh     = rmax(idata)
             nfit(idata)   = 2 * max (1, nrpts(idata))
             weight(jqw,idata) = sigdtr * sigdtr 
          else
c q/k-space fit
             xolow      = qmin(idata)
             xohigh     = qmax(idata)
             nfit(idata)   = 2 * max (1, nqpts(idata))
             weight(jqw,idata) = sigdtk * sigdtk 
c q-space fit
             if (ifft(idata).eq.2) then
                wtmp       = 2 * rweigh(idata)  + one
                stmp       = sqrt ( pi * wtmp /
     $               (rgrid * (xrmax**wtmp - xrmin**wtmp )))
                sigdtq     = sigdtr / stmp
                weight(jqw,idata) = sigdtq * sigdtq 
             endif
          endif
          weight(jqw,idata) =  sqrt(nfit(idata) * weight(jqw,idata)
     $         /xinfo(idata))
          if (weight(jqw,idata).le.zero) weight(jqw,idata) = one
cc          print*, 'FIT WEIGHT: ', jqw, idata , weight(jqw,idata)
 450   continue 
c
c set k-window 
       if (winarr.eq.undef)  then
          call window(winnam,dk1,dk2,xkmin,xkmax,qgrid,maxpts,
     $         qwindo(1,idata))
       else
          jwin = get_array(winarr, name1(idata), 0,xwdat)
          if (jwin.le.0) then
             call warn(2,' feffit: no window array? looking for '
     $            //winarr)
             return
          end if
          if (xk_arr.ne.undef) then
             ipos = 0
             ntchi = int( 1 + xkdat(jxk)/qgrid )
             do 470 i = 1, ntchi
                q = (i-1) * qgrid
                call lintrp(xkdat, xwdat, maxpts,
     $               q, ipos, qwindo(i,idata))
 470         continue
          else
             ntchi = jwin
             do 480 i = 1, ntchi
                qwindo(i,idata) =  xwdat(i)
 480         continue 
          endif
       end if
c set r-window 
       call window('hann',zero,zero,xrmin,xrmax,rgrid,maxpts,
     $         rwindo(1,idata))

c convert list of path indices to iup array
       call str2il(list(1:illen), max_pathindex, np,
     $      ipath_tmp, ier)

       do i = 1, mpaths
          iulist(i,idata) = 0
       enddo
       iup= 0
       do i = 1, np
          if (u2ipth(ipath_tmp(i)).ge.1) then
             iup=iup+1
             iulist(iup,idata) = ipath_tmp(i)
          endif
       enddo
cc       print *, 'iulist ', idata, iup, np
cc       do i = 1, iup
cc          print*, iulist(i,idata)
cc       enddo
cc       print*,' idata ', idata, nrest_tmp
       nrestraint(idata) = nrest_tmp
       do 570 i = 1, nrest_tmp
          restraint(i,idata) = restr_tmp(i)
 570   continue 
cc       print*,' idata / nrestraint ', idata, idx, nrest_tmp

c===================================================================
c if not doing fit (multiple data-set fit), bail out now:
       if (.not.dofit)  then
          call echo('  feffit: not fitting until all data '//
     $         'sets defined')
          return
       end if

c everything below assumes we're really, really doing a fit
c
c read the needed feff arrays
       call fefinp
c


c   set up fit arrays
c   sync variables
c   check # of variables  and # fit points
c   call lmdif1 and fiterr
       write(cmdstr, '(1x,a,i3,a)')  ' feffit fitting ',
     $         nfdats, ' data sets'
       call echo(cmdstr)
       mfit = 0

       
       do 580 idx = 1, nfdats
          mfit = mfit + (nfit(idx) + nrestraint(idx))* nqwfs(idx)
 580   continue 
       mfit = min(mfit, lenfvc)
cc       print*, '  Feffit ', mfit, idx, nfit(idx), nqwfs(idx), nfdats,
cc     $      nrestraint(idx)
cc       if (nrestraint(idx) .ge.1) then
cc          print*, '  Feffit using restraints:',nrestraint(idx)
cc       endif
c===================================================================
c  set up arrays for non-linear fit with lmdif / fitfun
c===================================================================
c
       if (nfit(idata).le.4) then
          call echo('   feffit: too few fit data points: ')
          if (ifft(idata).eq.1) then
             write(cmdstr, 625)  '  Fit R range = [',xolow,
     $            ' : ', xohigh, ']'
          else
             write(cmdstr, 625)  '  Fit k range = [',xolow,
     $            ' : ', xohigh, ']'
          endif
 625      format (a,f8.3,a,f8.3,a)
          call warn(2,cmdstr)
          return
       endif
       if (nvarys.gt.nfit(idata)) then
          call warn(1,' *** feffit: fewer fit data points '//
     $         'than variables! fit may not work.')
       endif


c synchronize the math expressions, set up fit variables
       call iff_sync
       if (toler .le. zero) toler = toldef
       do 700 i =1, nvarys
          varys(i) = scalar(i)
 700   continue
       do 710 i =1, mfit
          fvect(i) = zero
 710   continue
       do 720 i =1, lenwrk
          work(i) = zero
 720   continue
       do 740 i =1, mvarys
          iwork(i)  = 0
 740   continue
c      
c  the real fit
       if (nvarys.gt.0)  then
          final = .false.
          itera = 0
          call setsca('&fit_iteration', zero)
          call chrdmp('  fitting ... ')

          call fitfun(mfit, nvarys, varys, fvect, lminfo)

          call lmdif1 (fitfun, mfit, nvarys, varys, fvect,
     $         toler, lminfo, iwork, work, lenwrk)

          call lm_err(lminfo,toler)
cc          if ((lminfo.ne.0).and.(lminfo.ne.4).and.(lminfo.ne.5)) then
          if (lminfo.ne.0) then
             call chrdmp('  estimating uncertainties ... ')
             call fiterr(fitfun, mfit, nvarys, lenfvc, mvarys, fvect,
     $            ftemp, fjac, alpha, jprint, nerstp, varys,
     $            delta, correl, ier, ibadx)
             if (ier.eq.0) then 
                call echo('done.')
             else 
                call echo('finished with warnings')
                call echo('  error bars not estimated. some '//
     $               'variable(s) may not')
                call echo('  affect the fit. Check these variables:')
                do 880 i = 1, nvarys
                   if (ibadx(i).gt.0) then
                      ilen = istrln(scanam(i))
                      call echo('        '//scanam(i)(:ilen))
                   end if
 880            continue
                call set_status(1)
             endif
          else
             call warn(1,' no uncertainties estimated!')
          end if
       else
          call warn(1,' feffit:  no variables defined.')
       endif
c 
c save scalars to Program Variables
       final = .true.
       call synvar
       call fitfun(mfit, nvarys, varys, fvect, lminfo)
       chisqr = sumsqr(fvect, mfit)

c add total number of independent points
c  avoid double counting by inspecting chi(k) names and sum-of-(chi*chi):
c  sure, this can be fooled by adding 1.e-8 to chi(k=0), but....
       xnidp  = xinfo(1)
       do 920 i = 2, nfdats
          uniq_dat  = .true.
          do 910 j = 1, i-1
             if ( (nam_chi(i).eq.nam_chi(j) .or.
     $            (sum2chi(i).eq.sum2chi(j))))
     $            uniq_dat = .false.
 910      continue 
          if (uniq_dat)  xnidp = xnidp + xinfo(i)
 920   continue 

       chired = chisqr / max(0.1d0, (xnidp - nvarys))
       call setsca('chi_square',  chisqr)
       call setsca('chi_reduced', chired)
       call setsca('r_factor',    rfact_total)
       call setsca('n_idp', xnidp)

       call setsca('kweight', qwfs(1,idata))
       call setsca('kmin',   xkmin)
       call setsca('kmax',   xkmax)
       call setsca('dk1',    dk1)
       call setsca('dk2',    dk2)
       call setsca('rmin',   xrmin)
       call setsca('rmax',   xrmax)

       tmp = nvarys * one
       call setsca('n_varys', tmp)
      
       do 960 i = 1, nvarys
          delta(i) = sqrt(abs(chired)) * delta(i)
          ilen = istrln(scanam(i))
          messg = 'delta_' // scanam(i)(1:ilen)
          call setsca(messg, delta(i))
 960  continue 
c
c  fit with a macro is done, so reset stopping point
c  and previous macro pointer 
       if (ifit_mac.gt.0) then
          nmac_stop = 0
          imac      = imac_tmp
       endif
c

c save arrays to Program Variables for each data set
c
       do 3000 idata = 1, nfdats
c          print*, 'FEFFIT ', idata, ' | ' ,
c     $         name1(idata)(1:20), ' | ', nam_chi(idata)(1:20) 

c NOTE:
c  thiq(i,data) holds the fit residual, so we'll need to 
c  add back the data chi(k) here, and possibly the bkg(k) 

c--k
cc        call set_array('resid', name1(idata), thiq(1,idata), nkpts,1)
          do 2200 i = 1, nkpts
             tmparr(i)   = qgrid * (i - 1)
             thiq(i,idata)  = thiq(i,idata)+chiq(i,idata)
 2200     continue 
          call set_array('k',   name1(idata), tmparr, nkpts, 1)
          call set_array('chi', name1(idata), thiq(1,idata), nkpts,1)
c 
c--background chi(k)
          if (bkgfit(idata)) then
             do 2310 isp = 1, nbkg(idata)
                write(cmdstr, 2325)  'bkg',idata,'_',isp
                xspl(isp) = getsca(cmdstr,0)
 2310        continue
 2325        format (a,i2.2,a,i2.2)
             do 2330 i = 1, nkpts
                qx = qgrid*(i-1)
                tmparr(i) =  bvalue(qknot(1,idata), 
     $               xspl,nbkg(idata),korder,qx,0)
                thiq(i, idata) = thiq(i, idata) - tmparr(i)
 2330        continue 
             call set_array('kbkg', name1(idata), tmparr, nkpts, 1)
          endif 
ccc--chi , which does NOT include the background!
ccc      call set_array('chi', name1(idata), thiq(1,idata), nkpts,1)

c--chi_real
          if (do_re) then
             call set_array('chi_real', name1(idata),
     $            thiqr(1,idata), nkpts, 1)
          end if
c--chi_mag
          if (do_mag) then
             do 2240 i = 1, nkpts
                tmparr(i) = sqrt(
     $               thiqr(i,idata)**2 + thiq(i,idata)**2 )
 2240        continue 
             call set_array('chi_mag', name1(idata), tmparr,nkpts,1)
          end if
c--chi_phase
          if (do_pha) then
             do 2280 i = 1, nkpts
                tmparr(i) = atan2( thiq(i,idata), thiqr(i,idata))
                if (i.gt.1)  call pijump(tmparr(i), tmparr(i-1))
 2280        continue 
             call set_array('chi_phase', name1(idata), tmparr,nkpts,1)
          end if
c      
c      construct r-space data of data and fit
c-data
cc          print*, ' NEAR done: nam_chi = ', nam_chi(idata)(1:40)
cc          print*,  ' name1: ', name1(idata)(1:40)
          j1 = istrln(nam_chi(idata))
          cmdstr  = 'real='// nam_chi(idata)(1:j1)
          if (nam_x(idata) .ne. undef) then
             j0 = istrln(cmdstr)
             j2 = istrln(nam_x(idata))
             cmdstr = cmdstr(:j0)//', k='//nam_x(idata)(:j2)
          endif
          call iff_fft('fftf',cmdstr)
c-fit
          nam_chi(idata) = 'chi'
          call prenam(name1(idata),nam_chi(idata))
          j1 = istrln(nam_chi(idata))
          cmdstr  = 'real = '// nam_chi(idata)(1:j1)
          call iff_fft('fftf',cmdstr)
 3000  continue 

c  guess what?   we're done!
       return
       end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
       subroutine setsca(name, value)
c
c purpose:  set value of a named scalar variable to a real number,
c           avoiding calls to encod/decod
c
c arguments:
c      name     name of text variable to set            [in]
c      value    real value of scalar variable           [in]
c
c notes:
c    1.  if the name is not found in the current table
c        (arrnam array in common block), it will be added to table.
c
c requires:  ifeffit.h, lower
       implicit none
       include 'consts.h'
       include 'arrays.h'
       include 'encod.h'
       save
       character*(*) name, tmpnam*64
       integer  inam, ival, k, istrln
       double precision value, val
       external istrln
c
       val = value
       tmpnam = name
       k   = istrln(tmpnam)
       call lower(tmpnam(1:k))
cc       print*, 'SETSCA ', tmpnam(1:k), ' -> ', val
c look up str in list of scalar names
       do 10 inam = 1, maxsca
          if ( (scanam(inam).eq.' ').or.
     $         (scanam(inam).eq.tmpnam) ) go to 12
 10    continue
 12    continue
c
       if (val.eq.zero) then
          ival = 1
       else
          do 50 ival = 2, mconst
             if ( (consts(ival).eq.val).or.
     $            (consts(ival).eq.zero) ) go to 52
 50       continue
 52       continue
          consts(ival) = val
       end if
c set scalar name, value, and update consts array
       scalar(inam) = val
       scanam(inam) = name
       scafrm(inam) = blank
c simple encoding for assignment of constant value
       icdsca(1,inam) = jconst + ival
       icdsca(2,inam) = 0
c end  subroutine fast_setsca
       return
       end

       subroutine settxt(name, value)
c
c purpose:  set value of a named text (scalar) variable
c
c arguments:
c      name     name of text variable to set            [in]
c      value    value of text variable                  [in]
c
c notes:
c    1.  if the name is not found in the current table
c        (txtnam array in common block), it will be added to table.
c
c requires:  ifeffit.h, lower, triml
c
c copyright 1997  matt newville
c
       implicit none
       include 'consts.h'
       include 'arrays.h'
       save

       character*(*) name, value, str*256, val*256, tmp*256
       integer  j, k, istrln
       external istrln

       str = name
       call triml(str)
c text strings may begin with a '$', following ifeffit syntax
       if (str(1:1).eq.'$')  str = str(2:)
       call lower(str)
       k   = istrln(str)
       val = value
       call triml(val)
c look up str in list of text scalar names
       do 10 j = 1, maxtxt
          tmp = txtnam(j)
          call triml(tmp)
          if ((tmp.eq.' ').or.(tmp.eq.str(1:k))) go to 12
 10    continue
 12    continue
c set scalar name, value
       txtnam(j) = str(1:k)
       text(j)   = val
c end  subroutine settxt
       return
       end
       double precision function getsca(name,iwarn)
c
c purpose: get value of a scalar variable, 
c          circumventing a big "decod" call
c
c arguments:
c      name     name of scalar to get                   [in] 
c
c notes:
c    1.  if the name is not found in the current table 
c        (scanam array in common block), it will be added to table
c        and initialized to zero.
c
c requires:  ifeffit.h, encod.h, setsca, lower
c
c  copyright (c) 1998  matt newville
c  
       implicit none
       include 'consts.h'
       include 'arrays.h'
       save

       character*(*) name, tmpnam*64
       integer  i, n, istrln, iwarn

       getsca = zero
       tmpnam = name
       call lower(tmpnam)
       i = 0
c loop through known scalar names
 10    continue 
       i = i + 1
c  is this an existing variable?
       if (scanam(i).eq.tmpnam) then
          getsca = scalar(i)
c       check whether this is fitting variable 
          if ((iwarn .ge. 1).and.(icdsca(1,i) .eq. -1 )) then 
             n = istrln(tmpnam)
             call echo(' Warning: the fitting variable '//tmpnam(1:n))
             call warn(1,'  is being read internally by ifeffit.')
             call warn(1,'  this may cause unstable results.')
          endif
c  is this a blank scalar name? if so, initialize to this one
       elseif(scanam(i).eq.' ') then
          call setsca(tmpnam,zero)
       elseif (i.le.maxsca) then
          go to 10
       end if
c end  function getsca
       return
       end

       subroutine  gettxt(name, value)
c
c purpose:  get value of a text variable, given it's name
c
c arguments:
c      name     name of text variable to get            [in]
c      value    value of text variable                  [out]
c
c notes:
c    1.  if the name is not found in the current table 
c        (txtnam array in common block), it will be added to table
c        and initialized to ' '.
c
c requires:  ifeffit.h, settxt, lower, triml
c
c  copyright (c) 1998  matt newville
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       save

       character*(*) name, value, str*256
       integer  i
       str   = name
       value = ' '
       call lower(str)
       call triml(str)
       if (str(1:1).eq.'$') str  = str(2:)
       i = 0
c loop through known text names
 10    continue 
       i = i + 1
c  is this an existing variable?
       if (txtnam(i).eq.str) then
          value = text(i)
c  is this a blank text name? if so, initialize to this one
       elseif(txtnam(i).eq.' ') then
          call settxt(str,' ')
       elseif (i.le.maxtxt) then
          go to 10
       end if
       call triml(value)
c end  function gettxt
       return
       end
       logical function isasca(name)
c      
c purpose: determine if a named  scalar exist

c arguments:
c      name     name of scalar to get                   [in] 
c
c  copyright (c) 2000  matt newville
c  
       implicit none
       include 'consts.h'
       include 'arrays.h'
       save

       character*(*) name, tmpnam*64
       integer  i
       tmpnam = name
       isasca = .false.
       call lower(tmpnam)
       i = 0
c loop through known scalar names
 10    continue 
       i = i + 1
c  is this an existing variable?
       if (scanam(i).eq.tmpnam) then
          isasca = .true.
       elseif (i.le.maxsca) then
          go to 10
       end if
c end  function isasca
       return
       end

       program use_if
       integer i
       include '/usr/local/share/ifeffit/config/ifeffit.inc'
c
       i = ifeffit(' ')
       i = ifeffit('read_data(../../data/cu.xmu, group=cu, type=xmu)')
       i = ifeffit('spline(cu.energy, cu.xmu, rbkg = 1.2)')
       i = ifeffit('plot(cu.k, cu.chi)')
c
       end    

       subroutine autfun(mf,nx,xv,ffit,iend)
c
c   evaluate a function for lmdif1, a non-linear least squares
c   levenburg-marquardt algorithm.
c
c   evaluate the difference between the fft of the theory and the
c   post-background-subtraction chi data for changing b-spline
c   coefficients.
c
c   xv(1) to xv(nsplin) are the b-spline coefficients
c
c   also allow e0 shift of the data and modification of
c   theory by overall amplitude and s02.

c
c   copyright 1992  university of washington :          matt newville
c
       include 'autobk.h'
       integer   ifft, nx, mf, iend, nvtmp, i
       integer   nqmin, nqmax, nmaxx, ipos
       double precision small, half, widmin, bvalue, sumsqr
       parameter (half = 0.5d0, small = 1.d-10, widmin = 0.5d0)
       parameter (ifft = 1)
       double precision xv(nx), ffit(mf), qtmp(maxpts), chie(maxpts)
       double precision chifit(maxpts), qtt, e0
       external  bvalue, sumsqr
c
       if (nx.ne.nvarys) iend = 1
       if (mf.ne.mfit)   iend = 2
       nvtmp  = nvarys
c
c  unwrap list of possible variables:
c     the last on the list from autnls is the first off
       if (theory.and.eevary) then
          e0shft = xv(nvtmp)
          nvtmp  = nvtmp - 1
       end if
       if (nvtmp.ne.nsplin) iend = 3
c
c  do e0 shifting to temporary q-array for interpolation,
c  evaluate the spline and normalize to get chie
c  normalize
       e0     = ee + e0shft
cc       print*, ' -------------------'
cc       print*, ' nvarys = ', nx, nvarys, mf
cc       print*, ' varys = ', xv(1), xv(2), xv(3), xv(4), xv(5)
       do 200 i = 1, nxmu
          qtmp(i)   =  sqrt(etok * abs(energy(i)-e0) )
          if (energy(i).lt.e0)   qtmp(i) = - qtmp(i)
          if ( (energy(i).le.emax).and.(energy(i).ge.emin) ) then
             spline(i) = bvalue(eknot,xv,nsplin,korder,energy(i),0)
             chie(i)   = ( xmudat(i) - spline(i) ) / step
             if (funnrm)
     $            chie(i)   = ( xmudat(i) /max(spline(i), small)) - one
          else
             chie(i)   = zero
          end if
 200   continue
c  get qmax and qmin from the energy values
       nqmin = int( sqrt( etok* abs(emin - e0) ) / qgrid )
       nqmax = int( sqrt( etok* abs(emax - e0) ) / qgrid )
       if ((emin.lt.e0).or.(nqmin.lt.1))     nqmin = 1
c  interpolate chiq to q grid, evaluate chiq, the data chi
       nmaxx  = min(maxpts, nqmax + 20)
       ipos   = 1
cc       print*, ' autfun ', nqmax, nmaxx, nqmin, emin, emax, nterp
       do 300 i = 1, nmaxx
          if ( (i.lt.nqmin).or.(i.gt.nqmax) ) then
             chiq(i) = zero
          else
             qtt = (i-1) * qgrid
             if (final) then 
                if (nterp.eq.1) then
                   call lintrp(qtmp, chie, nxmu, qtt, ipos, chiq(i))
                else 
                   call qintrp(qtmp, chie, nxmu, qtt, ipos, chiq(i))
                end if
             else
                call qintrp(qtmp, chie, nxmu, qtt, ipos, chiq(i) )
             end if
          end if
 300   continue
c get real and imaginary parts of the fft of data chiq
cc       print*, 'autfun qgrid = ', qgrid, r1st, ifft, nrbkg, theamp
       call fitfft(chiq, maxpts, mftfit, wfftc, qgrid,
     $      windo, qweigh, windo, one, ifft, zero, r1st,
     $      nrpts, chifit)
cc       print*, ' mpts: = ', mftfit, maxpts, nrpts
c     
c find amplitude scale for theory so that it matches the 
c data over the first shell.  this sets  theamp to the ratio 
c of the power-spectral-densities of the first shell xafs for 
c the theory and data chiq. 
       if (.not.thefix)  theamp = sumsqr(chifit(nrbkg),nr1st) /
     $                            thessq

c there are nrbkg points in the low-r region
c there are nr1st points in the first shell region
c there are nrpts points total
c add r-weighting to bkg removal. 
c note that rwgt is converted to integer, and that the real and 
c imaginary portions are weighted equally by using integer arithmetic.
cc       print*, chifit(1), chifit(7), chifit(17), chifit(22)
       do 550 i = 1, nrbkg
          ffit(i) = chifit(i) - thifit(i) * theamp
 550   continue
       return
c end subroutine autfun
       end

       double precision function eval(icode,mvals,micode,
     $      consts,mconst, vals,old,
     $      icloc,mloc,md,ixlcl, id, ieval)
c
c  evaluate integer codes of math expressions for "set" and "local"
c  valuess.  includes decision of whether the named value is global
c  ("set") or "local" to the data set.
c
c  notes:
c    1. the first m element of "i(1,i)" are i(1,i) to i(m,i).
c    2. the first element of the encoded integer arrays holds an
c       important clue about the nature of the math expression:
c        icode(1,i) = -1      variable
c        icode(1,i) =  0      unused
c        icode(1,i) >  0      user-defined function ("global")
c        icode(1,i) >  ixlcl  "local"
       integer  mconst, mvals, micode, mloc, md
       integer  ixlcl, ieval, jlcl, id
       double precision  consts(mconst), vals(mvals), old, decod
       integer  icode(micode, mvals), icloc(micode,mloc,md)
       external decod
       eval = old
       if (icode(1,ieval).gt.ixlcl) then
          jlcl = icode(1,ieval) - ixlcl
          eval = decod(icloc(1,jlcl,id), micode,consts,vals,old)
       elseif (icode(1,ieval).gt.0)  then
          eval = decod(icode(1,ieval),   micode,consts,vals,old)
       endif
       return
       end

       integer function iff_load(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c support "load file" syntax for ifeffit:
c    1. manage stack of files to read from
c    2. check for recursion  (is it already on the stack)
c    3. open file
c    4. execute each line (by sending to ifeffit)
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'echo.h'
       save
       integer   iex, ier, i, ifeffit, ilen, istrln, iread
       character str*(*), stat*10
       character*2048  line
       parameter (stat = 'old')
       external  ifeffit, istrln, iread
c
c increment stack -- check that we're not off the edge
       ier      = 0
       iff_load = 0
       nfiles   = nfiles + 1
cc       print*, 'LOAD: iff_load  ', nfiles
       if (nfiles .gt. mfiles) then
          call warn(2,'# ifeffit error: too many nested "include"s')
          write(messg, '(a,i3)') '# current limit is ', mfiles
          call echo(messg)
          call warn(2,'# file include will be ignored ')
          nfiles = nfiles - 1 
          iff_load = -1
          return
       end if
c  fix string to be file name
cc       print*, 'LOAD: string ', str
       call getfln(str, lfiles(nfiles), ier)
c  test for recursion:
       do 20 i = 1, nfiles - 1
          if (lfiles(nfiles) .eq. lfiles(i)) then
             call warn(3,
     $            '# ifeffit error: recursive include not allowed')
             iff_load = -1
             return
          end if
 20    continue
c  open file
cc       print*, 'call openfl nfiles =', nfiles, lfiles(nfiles)(1:30)
       call openfl(iunit(nfiles), lfiles(nfiles), stat, iex, ier)
       if ((ier.lt.0).or.(iex.lt.0)) then
          call echo(' *** load: error opening file (not found):')
          ilen = istrln(lfiles(nfiles))
          messg =   ' ***    '//lfiles(nfiles)(1:ilen)
          call warn(2,messg)
          go to 500
       end if
       ioinp = iunit(nfiles)
cc       print*, ' iff_load:: opened unit = ', ioinp, nfiles ,
cc     $      lfiles(nfiles)(1:30)
c  read first line, check if this is really a save file
       ilen = iread(iunit(nfiles), line)
       if (line(1:22).eq. '#:IFEFFIT SAVE File: v') then
          call iff_restore(lfiles(nfiles))
          go to 500
       endif
c  while loop:  read and execute
 100   continue 
       if (nfiles.gt.0) then
          if (ilen.gt.0) then
             iff_load = ifeffit(line)
             if (iff_load.eq.1)  return 
          endif
          ilen = iread(iunit(nfiles), line)
          if ((ilen.lt.0) .and. (nfiles.gt.0)) then
cc             print*, ' close file ', lfiles(nfiles)(1:40)
             close(iunit(nfiles))
             lfiles(nfiles) = ' '
             nfiles  = nfiles - 1
             ioinp   = 0
          endif
          go to 100
       end if
c  at end-of-file, pop stack.  continue with previous loads, or return
 500   continue
cc       print*, ' line 500 : ', nfiles
       if (nfiles.gt.0) then
          close(iunit(nfiles))
          lfiles(nfiles) = ' '
          nfiles  = nfiles - 1
          ioinp   = 0
       end if
cc       print*, ' nfiles is now ', nfiles
       if (nfiles.gt.0) then 
          ilen = iread(iunit(nfiles), line)
          go to 100
       endif

       do 900 i = 1, n_echo
          call echo_pop(tmpstr)
 900   continue 
       n_echo = 0
       call setsca('&echo_lines', zero)
       return
c  end subroutine iff_load
       end

       subroutine testrf(flnam, irecl, flform, ier)
c
c   test whether a data file can be interpreted as  uwxafs binary
c   data file or  ascii column data file.
c
c   uwxafs binary files use direct access binary files
c   with word size irecl, which is a machine dependent parameter
c
c ier = -1 : file not found
c ier = -2 : broken uwxafs file?
c ier = -3 : not uwxafs file, but can't find data.
c ier = -4 : looks like ascii, saw line  of minus signs,
c             but 2nd following line doesn't have data
c
c   copright 1994 university of washington   matt newville
c -----------------------------------------------------
      integer   i, irecl, iunit
      character*(*) flnam, flform, line*128
      integer*2    indx(4)
      logical    exist, opend, isdat, prevdt, lisdat
      external  isdat
c -----------------------------------------------------
      flform = 'none'
      ier    = -1
      iunit  = 7
 10   continue
      inquire(unit=iunit, opened = opend)
      if (opend) then
         if (iunit.gt.20) return
         iunit = iunit + 1
         go to 10
      endif
      inquire(file = flnam, exist = exist)
      if (.not.exist) return
      ier    = -2
c -----------------------------------------------------
c try reading file as a uwxafs binary file
c     which have patriotic magic numbers embedded in them
      indx(3) = 0
      indx(4) = 0
      open(iunit, file= flnam, recl = irecl, err = 20,
     $      access = 'direct', status = 'old' )
 20   continue
      read(iunit, rec=1, err = 25) (indx(i), i=1,4)
 25   continue
      if ((indx(3).eq.1776).and.(indx(4).eq.704)) then
         flform = 'uwxafs'
         ier  = 0
         go to 900
      end if
c -----------------------------------------------------
c try to read file as ascii data file
      close(iunit)
      open(iunit, file=flnam, status='old')
      prevdt = .false.
 200  continue
         ier  = -3
         read(iunit, '(a)', end = 900, err = 900) line
         call sclean (line)
         call triml (line)
         if (line(3:6) .eq. '----') then
            ier = -4
            read(iunit, '(a)', end = 900, err = 900) line
            call sclean (line)
            read(iunit, '(a)', end = 900, err = 900) line
            call sclean (line)
            lisdat = isdat(line)
            if (lisdat ) then
               flform = 'ascii'
               ier = 0
            end if
            go to 900
         end if
c if two lines in a row have all words being numbers, it is  data
         lisdat = isdat(line)
         if (lisdat.and.prevdt)  then
            flform = 'ascii'
            ier = 0
            go to 900
         end if
         prevdt = lisdat
         go to 200
c---------------------
 900  continue
      close(iunit)
      return
c end subroutine testrf
      end

      subroutine append(str1, str2, ilen)
c   append str2 to str1.
c   str1 and ilen are overwritten
c   str2 is not overwritten
      character*(*)  str1, str2, tmp*2048
      integer        ilen, istrln
      external       istrln
      ilen  = max(1, istrln(str1))
      tmp   = str1(1:ilen)//str2
      ilen  = min(istrln(tmp), len(str1))
      str1  = tmp(1:ilen)
      return
      end

       subroutine iff_done
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: write message and end ifeffit
c
c requires:  echo
c
c   Memory's images, once they are fixed in words, are erased.
c
       implicit none
       call iff_plot_init(99) 
cc       call echo('Ifeffit is finished.  have a nice day.')
c end iff_done
       end

       subroutine chiout(chiq, filksp, filrsp, format, vax, ksp, rsp,
     $      irecl, ndoc, doc, qlo, qhi, qgrid, qweigh, windo,
     $      wfftc, mfft, rlast, comm, mdocx, iexist, skychi, skyrsp)
c
c      this will write out chi(k) and chi(r) to output files
c
c      copyright 1993 university of washington         matt newville
c
c  inputs: 
c    chiq     array of chi(k) data, on with chiq(1) = chi(k=0.)
c    filksp   name of output k-space file to write
c    filrsp   name of output r-space file to write
c    format   format of output files (uwexafs of ascii)
c    vax      logical flag for writing binary data in vax format
c    ksp      logical flag for writing data to k-space
c    rsp      logical flag for writing data to r-space
c    ndoc     number of document lines to write out
c    doc      documents to write out
c    qlo      lowest value in k-space to write out data
c    qhi      highest value in k-space to write out data
c    qgrid    k- grid spacing for writing out data and fft
c    qweigh   k-weight to use for fft
c    windo    window array
c    windo2   window parameter #2
c    wfftc    work array for fft (initialized with cffti using mfft )
c    mfft     number of points to use in fft ( .le.2048 )
c    rlast    highest r value to write out  
c    iexist   integer flag for rewriting data to a uwexafs file
c  outputs:
c    skychi   output skey of chi(k) file
c    skyrsp   output skey of chi(r) file
c
c note mfft must be less than or equal to 2048
       implicit none
       integer   i, nfft, mdocx, maxpts, mfft,irecl
       double precision zero, pi
       parameter (maxpts = 4096)
       parameter (zero = 0.d0, pi = 3.14159 26535 89793d0  )
       character*(*) filksp, filrsp, format, doc, skychi, skyrsp
       character*(*) type*10, comm
       double precision chiq(*), wfftc(*), windo(*)
       double precision xdata(maxpts), yreal(maxpts), yimag(maxpts)
       double precision yphas(maxpts), yampl(maxpts)
       double precision qweigh, qgrid, qlo, qhi, rlast, rgrid
       double precision qsmall, rsmall
       integer   ndoc, nkyout, iexist, nrout, nqout, nqlo, nqhi
       complex*16       cchiq(maxpts), chir(maxpts)
       logical       vax, ksp, rsp
c
c   initialize, calculate assorted useful indices
        mdocx  = 0
        do 20 i = 1, maxpts
              xdata(i) = zero
              yreal(i) = zero
              yimag(i) = zero
              yampl(i) = zero
              yphas(i) = zero
              cchiq(i) = cmplx(zero, zero)
              chir(i)  = cmplx(zero, zero)
  20    continue
c check that mfft .le. maxpts
        nfft = mfft 
        if (nfft.gt.maxpts) nfft = maxpts
        rgrid  = pi / ( nfft * qgrid) 
        rsmall = rgrid / 100.0
        qsmall = qgrid / 100.0
        nqlo   = int( (qlo + qsmall) / qgrid ) 
        if (nqlo.lt.0) nqlo = 0
        nqhi   = int( (qhi + qsmall) / qgrid ) 
        nqout  = nqhi - nqlo + 1
        nrout  = int( (rlast + rsmall) / rgrid ) 
c
c   construct chi(k) on q range [qlo, qhi]
        do 300 i = 1, nqout
              xdata(i) = qlo + (i-1)*qgrid
              yreal(i) = chiq(nqlo + i)
              yimag(i) = zero
 300   continue
c
c  k - space
       if (ksp) then
           type   = 'chi'
           skychi = ' '
           nkyout = 0 
c   write out chi(k) on q range [qlo, qhi]
           call outdat(type, format, filksp, vax, comm, skychi, nkyout,
     $          irecl, ndoc, mdocx, doc, nqout, xdata,
     $          yreal, yimag, yampl, yphas, iexist)
       end if
c
c  r - space
c  
       if (rsp) then
c  construct complex chi(k)
           do 400 i = 1, nfft
                    cchiq(i) = cmplx(chiq(i), zero)
 400       continue
c  take fft of complex chi(k) to get chir
           call xafsft(nfft, cchiq, windo, qgrid, qweigh,
     $          wfftc, 1, chir)
           do 500 i = 1, nrout
                  xdata(i) = (i-1)*rgrid
                  yreal(i) = dble( chir(i) )
                  yimag(i) = dimag( chir(i) )
                  yampl(i) = zero
                  yphas(i) = zero
 500       continue
           type   = 'rsp'
           skyrsp = ' '
           nkyout = 0 
c  write out chi(r) on r range [0.,rlast]
           call outdat(type, format, filrsp, vax, comm, skyrsp, nkyout,
     $          irecl, ndoc, mdocx, doc, nrout, xdata,
     $          yreal, yimag, yampl, yphas, iexist)
       end if
c
       return
c  end subroutine chiout
       end

c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2001 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       subroutine w_fftf(x,nx,ier)
c wrapper for decod calling fftf
       include 'consts.h'
       include 'fft.h'
       double precision x(*)
       complex*16       xt(maxfft)
       integer          nx,ier, mfft
       mfft = maxfft
       do 10 i = 1, nx
          xt(i)  =  cmplx(x(i), zero)
 10    continue 
       do 12 i = nx+1, maxfft
          xt(i)  =  cmplx(zero,zero)
 12    continue 
       call cfftf(mfft,xt,wfftc)
       do 20 i = 1, nx
          x(i) = dble(xt(i))
 20    continue 
cc       print*, ' : : ', x(1), x(3), x(5)
       
       ier = 0
       return
       end
c
       subroutine w_fftr(x,nx,ier)
c wrapper for decod calling fftr
       include 'consts.h'
       include 'fft.h'
       double precision x(*)
       integer          nx,ier
       call cfftb(nx,x,wfftc)
       ier = 0
       return
       end
c
       subroutine w_kkf(x,nx,y,ny,ier)
c wrapper for decod calling kkmclf
       include 'consts.h'
       double precision x(*),y(*), out(maxpts)
       integer          nx,ny,ier
       call kkmclf(ny,y,x,out)
       do 10 i = 1, ny
          x(i) = out(i)
 10    continue 
       ier = 0
       return
       end
c
       subroutine w_kkr(x,nx,y,ny,ier)
c wrapper for decod calling kkmclr
       include 'consts.h'
       double precision x(*),y(*), out(maxpts)
       integer          nx,ny,ier
       call kkmclr(ny,y,x,out)
       do 10 i = 1, ny
          x(i) = out(i)
 10    continue 
       ier = 0
       return
       end
c
       subroutine kkmclr(npts, e, finp, fout)
c  reverse (f''->f') kk transform, using maclaurin series algorithm
c  arguments: 
c    npts   size of arrays to consider 
c    e      energy array *must be on an even grid*  [npts]  (in)
c    finp   f''    array                            [npts]  (in)
c    fout   f'     array                            [npts]  (out)
c m newville  jan 1997
       implicit none
       double precision  e(*), finp(*), fout(*)
       double precision  factor, ei2, de2, fopi, zero, tiny
       parameter(fopi = 1.273239544735163d0, zero = 0.d0, tiny=1.d-20)
       integer   npts, i, j, k, ioff, nptsk
       
       if (npts.ge.2) then 
          factor = - fopi * (e(npts) - e(1)) / (npts - 1)
          nptsk  = npts / 2
          do 100 i=1, npts
             fout(i) = zero
             ei2    = e(i) * e(i)
             ioff   = mod(i,2) - 1
             do 50 k = 1, nptsk
                j    = k + k + ioff
                de2  = e(j)*e(j) - ei2
                if (abs(de2).le.tiny) de2 = tiny
                fout(i) = fout(i) + e(j) * finp(j) / de2
 50          continue 
             fout(i) = factor * fout(i) 
 100      continue 
       end if
       return
c end subroutine kkmclr
       end
       subroutine kkmclf(npts, e, finp, fout)
c  forward (f'->f'') kk transform, using  mclaurin series algorithm
c  arguments: 
c    npts   size of arrays to consider 
c    e      energy array *must be on an even grid* [npts]  (in)
c    finp   f'     array                           [npts]  (in)
c    fout   f''    array                           [npts]  (out)
c  notes  fopi = 4/pi
       implicit none
       double precision  e(*), finp(*), fout(*)
       double precision  factor, ei2, de2, fopi, zero, tiny
       parameter(fopi = 1.273239544735163d0, zero = 0.d0, tiny=1.d-20)
       integer   npts, i, j, k, ioff, nptsk
       
       if (npts.ge.2) then 
          factor = fopi * (e(npts) - e(1)) / (npts - 1)
          nptsk  = npts / 2
          do 100 i=1, npts
             fout(i) = zero
             ei2     = e(i) * e(i)
             ioff    = mod(i,2) - 1
             do 50 k = 1, nptsk
                j    = k + k + ioff
                de2  = e(j)*e(j) - ei2
                if (abs(de2).le.tiny) de2 = tiny
                fout(i) = fout(i) + finp(j) / de2
 50          continue 
             fout(i) = factor * fout(i) * e(i)
 100      continue 
       end if
       return
c end subroutine kkmclf
       end

       subroutine fpinp
c read inputs for deltaf program from 'deltaf.inp'
c
       include "dkcom.f"
       integer  i, mfil, maxwrd,nwords, iwrds
       parameter(maxwrd = 30, mfil = 10)
       character*70   words(maxwrd), wrdsor(maxwrd), keywrd
       character*70   prompt*20,key*3,stat*10, string,str,comfil(mfil)
       integer   istrln,icom(mfil), nfil, iinp, ier, iex, ilen, nline
       external   istrln
c     initialization
c initialize  stuff in common
       active = .false.
       isfeff = .true.
       inpfil = 'deltaf.inp'
       xmufil = ' '
       outfil = 'df.out'
       iatz   = 8
       iprint = 0
       imucol = 2
       iencol = 1
       egrid  = 1
       elow   = 3000
       ehigh  = 5000
       ewidth = 1.5
c note: pre1/pre2 will be set in f2fit according 
c       to whether data is from feff or not
       epad   = 5
       npad   = 20
       ntitle = 0
       label =' e         fp         fpp'
       do 10 i = 1, mtitle
          title(i) = ' '
 10    continue 
c initialize  local stuff
       prompt = 'f'
       stat   = 'old'
       nline  = 0 
       nfil   = 0
       ier    = 0
       iex    = 0
       iinp   = 1
       do 20 i = 1, mfil
          icom(i)   = 0
 20    continue
c   input file: if file is found, open it for reading,
       call openfl(iinp,  inpfil, stat, iex, ier)
       if (iex.lt.0)  then 
          ilen = istrln(inpfil)
          call messag( ' '// inpfil(:ilen)// ' was not found'//
     $         ' --  let''s try this interactively')
          active = .true.
       endif
c
       if (active) then
          call askint(' > atomic number',iatz)
          call messag('   Please give the low- and high-energy range')
          call messag('   for the calculatin   in eV:')
          call askdp(' > elow        ',elow)
          ehigh  = 1000 + elow
          call askdp(' > ehigh       ',ehigh)
          call askdp(' > energy grid ',egrid)
          call messag('   Please give a width for broadening the '//
     $         'Cromer-Libermann calculation:')
          call askdp(' > ewidth      ',ewidth)
       else
c  read in next line
          if ((iex.lt.0).or.(ier.ne.0)) go to 1990
 100      continue
          keywrd = ' '
          key    = ' '
          call getcom(prompt, iinp, string, comfil, icom, mfil, nfil)
          nline  = nline + 1
c      
          call fixstr(string,str,ilen,words,wrdsor,maxwrd,nwords)
          if ((ilen.le.2).or.(str.eq.'getcom_eof')) go to 100
          if ((words(1).eq.'end').or.(str.eq.'getcom_end')) go to 1000
          if (str.eq.'getcom_error') go to 1990
c      parse current set of keywords from line
 150      continue
          keywrd  = words(1)
          key     = keywrd(1:3)
          iwrds   = 2
c      inpfil,outfil,imucol,egrid,iatz
          if (keywrd.eq.'title') then 
             ntitle  = ntitle + 1
             call strclp(string,wrdsor(1),wrdsor(2),title(ntitle))
             iwrds = maxwrd + 1
          else if (key.eq.'out') then
             outfil = wrdsor(2)
          else if (keywrd.eq.'iz') then
             call str2in(words(2),iatz,ier)
          else if (keywrd.eq.'ewidth') then
             call str2dp(words(2),ewidth,ier)
          else if (keywrd.eq.'egrid') then
             call str2dp(words(2),egrid,ier)
          else if (keywrd.eq.'elow') then
             call str2dp(words(2),elow,ier)
          else if (keywrd.eq.'ehigh') then
             call str2dp(words(2),ehigh,ier)
          end if
          if (nwords.gt.iwrds) then
             do 450 i = 1, nwords
                words(i)  = words(i+iwrds)
                wrdsor(i) = wrdsor(i+iwrds)
 450         continue
             nwords = nwords - iwrds
             go to 150
          end if
          go to 100
       end if
 1000  continue 
       close (iinp)
c get energy range       
       npts  = min (mpts, max (1, int(( ehigh - elow) / egrid)))
       do 1200 i = 1, npts
          energy(i)  = elow + egrid * i
 1200   continue 
       return
 1990  continue 
       call messag(' weird, fatal error trying to open file.')
       stop
       end

       subroutine iff_uncert(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c
c purpose: propogate errors in fitted parameters to defined parameters
c 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'feffit.h'
       save
       character*(*)  str
       character*128  xvar, yvar, out, pref, defkey(3)*64
       double precision xn, xcmin
       logical   lprint, lxall, lyall, lsave
       integer   ier, i, k, istrln, ndfkey, jx, jy, lx, ly
       external  istrln
c
cc       print*, ' error() ' 
       lprint = .false.
       lsave  = .true.
       call iff_sync
       call bkeys(str, mkeys, keys, values, nkeys)
       xvar = ' '
       pref = 'dx'
       out  = undef
       
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'x', 'y'
       ndfkey    = 0
       defkey(1) = undef
       do 100 i = 1, nkeys
cc          print*,i, keys(i)
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'prefix') then
             pref = values(i)
             call lower(pref)
          elseif (keys(i).eq.'min') then
             call str2dp(values(i), xcmin, ier)
          elseif (keys(i).eq.'print') then
             call str2lg( values(i), lprint, ier)
          elseif (keys(i).eq.'save') then
             call str2lg( values(i), lsave, ier)
          elseif (keys(i).eq.'no_save') then
             call str2lg( values(i), lsave, ier)
             lsave = .not.lsave
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** correl: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names
       jx = 0
       jy = 0
       
cc       print*, nvarys

       return
c end  subroutine iff_uncert
       end

       subroutine iff_show(string,islog)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  show values for ifeffit
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'echo.h'
       include 'feffit.h'
       include 'fefdat.h'
       include 'pthpar.h'
       save
       character*(*)  string, str*256, s*85, class*16
       integer  iw, i, j, k, istrln, ier, ifeffit, inpath, ip, id
       integer  islog, iex, iup
       integer ipths(mpaths), ilen, np, u2ipth, ndx, jshow
       logical isarr, istext, found
       double precision getsca
       external istrln,  ifeffit, u2ipth, getsca
       str = string


       if (str.eq.'@all') then
          str = '@scalars, @variables, @arrays, @strings, '//
     $         '@commands, @macros, @colors, @paths, @memory, @limits'
       endif

       if (int(getsca('&sync_level',0)).ge.2)  call iff_sync
       nkeys = mkeys
       do 5 i = 1, nkeys
          keys(i) = blank
 5     continue 
       call bwords(str, nkeys, keys)
       iw = 0
 200   continue
c          print*, 'show:: ', iw
          iw = iw + 1
          if (iw.gt.nkeys) then
             return
          endif
          k = istrln(keys(iw))
          s = keys(iw)(1:k)
          call lower(s)
          found  = .false.
          isarr  = (index(s,'.').ne.0)
          istext = (s(1:1).eq.'$')
          if (istext) s = s(2:)
          class  = 'scalar'
          if (istext) then
             class  = 'string'
          else if (isarr) then
             class = 'array'
          endif
          if (s.eq.'@colors') then 
             call  iff_color('show')
             found = .true.
          elseif (s.eq.'@linestyles') then 
             call  iff_pstyle('show')
             found = .true.
          elseif (s.eq.'@groups') then 
             found = .true.
             call ishgrp
          elseif (s.eq.'@arrays') then 
             found = .true.
             do 400 i = 1, maxarr-1
                if (arrnam(i).ne.blank) then
                   call isharr(i)
                   if (iprint.ge.16)
     $                  call rpndmp(icdarr(1,i))
                end if 
 400         continue 
          elseif (s.eq.'@scalars') then 
             found = .false.
             do 410 i = 1, maxsca
                if (scanam(i).ne.blank) then
                   call ishsca(scanam(i),scafrm(i), scalar(i))
                   if (iprint.ge.12)
     $                  call rpndmp(icdsca(1,i))
                   found = .true.
                end if
 410         continue 
          elseif (s.eq.'@system') then 
             found = .false.
             do 415 i = 1, maxsca
                if ((scanam(i).ne.blank) .and.
     $               (scanam(i)(1:1).eq.'&')) then
                   call ishsca(scanam(i),scafrm(i), scalar(i))
                   if (iprint.ge.12)
     $                  call rpndmp(icdsca(1,i))
                   found = .true.
                end if
 415         continue 
          elseif (s.eq.'@variables') then 
             found = .true.
             do 420 i = 1, nvarys
                if ((icdsca(1,i).eq.-1).and.(scanam(i).ne.blank))
     $               call ishvar(scanam(i), scalar(i), delta(i) )
 420         continue 
          elseif (s.eq.'@correlations') then 
             call iff_correl('x=@all,y=@all,print=yes,save=no,')
             found = .true.
             s     = blank
             nkeys = -1
          elseif (s.eq.'@strings') then 
             found = .true.
             do 430 i = 1, maxtxt
                if ((txtnam(i).ne.blank).and. (text(i).ne.blank))
     $               call ishtxt(txtnam(i),text(i))
 430         continue 
          elseif (s.eq.'@commands') then 
             found = .true.
             do 440 i = 1, mckeys
                if ( (ckeys(i).ne.undef).and.(ckeys(i).ne.blank))
     $               call ishcom(ckeys(i), chint(i))
 440         continue 
          elseif (s.eq.'@command') then 
             found = .false.
             class = 'command'
             iw  =  iw+1
             s = keys(iw)
             call lower(s)
             do 443 i = 1, mckeys
                if ( (ckeys(i).ne.undef).and.(ckeys(i).ne.blank)
     $               .and.(ckeys(i).eq.s))
     $               call ishcom(ckeys(i), chint(i))
 443         continue 

          elseif (s.eq.'@macros') then 
             found = .true.
             iw  =  iw+1
             s = keys(iw)
             call lower(s)
             jshow = 1
             if (s.eq.'full') jshow = 0
             do 450 i = 1, mckeys
                if ( (macnam(i).ne.undef).and.
     $               (macnam(i).ne.blank)) call ishmac(macnam(i),jshow)
 450         continue 
          elseif (s.eq.'@macro') then 
             found = .false.
             class = 'macro'
             iw  =  iw+1
             s = keys(iw)
             call lower(s)
             do 460 i = 1, macmax
                if ( (macnam(i).ne.undef).and.
     $               (macnam(i).ne.blank  ).and.
     $               (s.eq.macnam(i)    )) then 
                   call ishmac(macnam(i),0)
                   found = .true.
                end if 
 460         continue 
          elseif (s.eq.'@limits') then 
             call ishow_simple( '&maxpts')
             call ishow_simple( '&max_scalars')
             call ishow_simple( '&max_arrays')
             call ishow_simple( '&max_strings')
             call ishow_simple( '&max_paths')
             call ishow_simple( '&max_varys')
             call ishow_simple( '&max_data_sets')
             found = .true.
          elseif (s.eq.'@memory') then 
             call ishow_simple( '&heap_free')
             call ishow_simple( '&n_scalars')
             call ishow_simple( '&n_arrays')
             call ishow_simple( '&n_strings ')
             call ishow_simple( '&n_guess')
             call ishow_simple( '&n_scalars_set')
             call ishow_simple( '&n_scalars_def')
             call ishow_simple( '&n_arrays_set')
             call ishow_simple( '&n_arrays_def')
             found = .true.
          elseif (s.eq.'@args') then 
             found = .true.
             do 470 i = 1, mmcarg
                if (mcargs(nmacro,i).ne.blank) then
                   write(tmpstr,'(1x,a,i1,2a)') '$',i, ' = ',
     $                  mcargs(nmacro,i)
                   call echo(tmpstr)
                endif
 470         continue 
          elseif (s.eq.'@feffpaths') then 
             found = .true.
cc             print*, ' feff files in use '
             do 530 i = 1, mfffil
                if (feffil(i).ne.blank) then
                   k  = istrln(feffil(i))
                   tmpstr = feffil(i)(1:k)
                   if (.not.lffred(i)) then
                      tmpstr = feffil(i)(1:k)//' (not read yet)'
                   endif
                   call echo(tmpstr)
                endif
 530         continue 
          elseif (s.eq.'@paths') then 
             found = .true.
             do 610 ip = 1, mpaths
                call show_path(jdtusr(ip))
 610         continue 
          elseif (s.eq.'@path') then 
             found = .false.
             s    = blank
             ilen = 1
             class  = 'path'
             do 660 i = iw+1, nkeys
                k  = istrln(keys(i))
                s  = s(1:ilen)//keys(i)(1:k)//','
                ilen = ilen + k + 1
 660         continue 
             call str2il(s(1:ilen), mpaths,np,ipths,ier)
             do 680 ip = 1, np
                call show_path(ipths(ip))
                found = .true.
 680         continue 
             iw = nkeys
          elseif (s.eq.'@group') then 
             found = .false.
             class  = 'group'
             iw    = iw+1
             s     = keys(iw)
             do 710 i = 1, maxarr-1
                j = index(arrnam(i),'.')
                if ((arrnam(i).ne.blank) .and.
     $               (j.gt.0).and. (arrnam(i)(1:j-1).eq.s)) then
                   call isharr(i)
                   if (iprint.ge.12)
     $                  call rpndmp(icdarr(1,i))
                   found = .true.
                end if 
 710         continue             
          elseif (istext) then
             found = .false.
             do 760 i = 1, maxtxt
                if (s.eq.txtnam(i)) then
                   call ishtxt(txtnam(i),text(i))
                   found = .true.
                   go to 200
                end if
 760         continue 
          elseif (isarr) then
             found = .false.
             do 820 i = 1, maxarr-1
                if (s.eq.arrnam(i)) then
                   call isharr(i)
                   if (iprint.ge.12)
     $                  call rpndmp(icdarr(1,i))
                   found = .true.
                   go to 200
                end if
 820         continue 
          else
c check (in this order): commands, macros, scalars
             found = .false.
             do 940 i = 1, mckeys
                if (s.eq.ckeys(i)) then
                   call ishcom(ckeys(i), chint(i))
                   found = .true.
                   go to 200
                end if 
 940         continue 
             do 950 i = 1, macmax
                if (s.eq.macnam(i)) then 
                   call ishmac(macnam(i),0)
                   found = .true.
                   go to 200
                end if 
 950         continue 
             do 970 i = 1, maxsca
                if (s.eq.scanam(i)) then
                   call ishsca(scanam(i),scafrm(i), scalar(i))
                   found = .true.
                   if (iprint.ge.12)
     $                  call rpndmp(icdsca(1,i))
                   go to 200
                end if
 970         continue 
          end if
          if (.not.found) then
             call undels(s)
             ier = max(6,istrln(s))
             if (istext)  then
                s = '$'//s(1:ier)
                ier = ier + 1
             endif
             iex = max(7,istrln(class))
             call warn(1, blank//class(1:iex)//blank//
     $            s(:ier)//'  not found')
          end if
          go to 200
       end
c

       subroutine isharr(i)
c
c echo information about an array
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       character*256 s, outm, tmp*384
       integer npts, k, kf, istrln, i
       
       external istrln
       s  = arrnam(i)
       if (s.eq.blank) return
       if ( s.eq.undef_array ) then
cc          print*, 'WEIRD:: array ', i, ' is erased, not reclaimed.'
          return
       endif
 10    format(2a,i6,a,g11.4,a,g11.4,a)
 11    format(2a,i6,a,g11.4,a,g11.4,2a)

       k   = max(14, istrln(s))
       write(tmp,10) s(1:k), ' =',  narray(i), ' pts  [',
     $      arrmin(i), ':', arrmax(i), ']' 

       kf  = istrln(arrfrm(i))
       if ((arrfrm(i).ne.'').and.(arrfrm(i).ne.undef)
     $      .and.(kf.ge.1))  then
          write(tmp,11) s(1:k), ' =',  narray(i), ' pts  [',
     $         arrmin(i), ':', arrmax(i), '] := ' , arrfrm(i)(1:kf)
       endif
 	 outm = tmp
       call echo(outm)
c
c       if (iprint.ge.5) then
c          print*, '    array # ', i, ' points to ', nparr(i)
c       endif
c
       return
       end
c
       subroutine ishsca(s,f,x)
       character*(*) s, f, f1*256, messg*256
       double precision   x, small, xmin, zero
       logical  ax
       parameter (small = 1.d-8, xmin = 12.d0, zero=0.d0)
       integer k, kf, ltot, ilx, istrln
       external istrln
       k  = max(14, istrln(s))
       f1 = f
       call triml(f1)
       kf = istrln(f1)
       if (kf.ge.1)   f1 = ' := '//f1(1:kf)
       kf = istrln(f1)
	 ltot = k + kf
	 if (ltot.ge.230) kf = 230 - k
	 messg  = ' '
       if ((x.eq.zero).or.
     $      (abs(log(abs(x + small))).le.xmin)) then 
          write(messg,11)  s(1:k), ' = ', x, f1(1:kf)
       else
	    
          write(messg,12)  s(1:k), ' = ', x, f1(1:kf)
       end if
       call echo(messg)
 11    format (2a,f17.9,a)
 12    format (2a,g17.9,a)
       return
       end

       subroutine ishvar(s,x,dx)
       character*(*) s, messg*256
       double precision x, dx,  small, xmin
       logical  ax, adx
       parameter (small = 1.d-8, xmin = 12.d0)
       integer k, istrln
       external istrln
       k = max(14, istrln(s))
       ax  = abs(log( abs( x + small ))).le.xmin
       adx = abs(log( abs(dx + small ))).le.xmin
       if (ax.and.adx) then
          write(messg,11)  s(1:k), ' = ', x, ' +/- ', dx
       elseif(ax .and. (.not.adx)) then
          write(messg,12)  s(1:k), ' = ', x, ' +/- ', dx
       elseif ((.not.ax) .and. adx) then
          write(messg,13)  s(1:k), ' = ', x, ' +/- ', dx
       else
          write(messg,14)  s(1:k), ' = ', x, ' +/- ', dx
       endif
 11    format (2a,f15.8,a,f15.8)
 12    format (2a,f15.8,a,g15.8)
 13    format (2a,g15.8,a,f15.8)
 14    format (2a,g15.8,a,g15.8)
       call echo(messg)
       return
       end


       subroutine ishow_simple(s)
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       character*(*) s
       integer i, ilen, istrln
       ilen = istrln(s)
       do 10 i = 1, maxsca
          if (scanam(i).eq.s(1:ilen)) then
             call ishsca(scanam(i),scafrm(i), scalar(i))
          end if
 10    continue 
       return
       end

       subroutine ishtxt(s,t)
       character*(*) s, t , messg*256
       integer k, j, istrln
       external istrln
       k = max(13, istrln(s))
       j = max(2, istrln(t))
       write(messg,11)  s(1:k), ' = ', t(1:j)
       call echo(messg)
 11    format('$',3a)
       return
       end
c
       subroutine ishcom(s,t)
       character*(*) s, t , messg*256
       integer    k, j, istrln
       external istrln
       k = max(14, istrln(s))
       j = max(2, istrln(t))
       write(messg,11)  s(1:k), ': ', t(1:j)
       call echo(messg)
 11    format (3a)
       return
       end
c
       subroutine ishmac(str,idonly)
c
c  show contents of a macro
c  idonly = 1 to only show name, arg list, description
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       save

       character*(*) str 
       integer i, k, kk, j, istrln, idonly
       external istrln
       i = 0
 10    continue 
       i = i + 1
       if (i.gt.macmax) then
          tmpstr = str
          k      = istrln( tmpstr )
          call warn(1, ' macro '// tmpstr(1:k) //' not found')
          return
       endif
       if ((macnam(i).eq.undef).or.(macnam(i).eq.blank)) go to 10
       if (macnam(i).ne.str) go to 10
c  know we know that it's macro "i" we want
       tmpstr = macnam(i)
       k      = istrln( tmpstr )
       do 60 j = 1, mmcarg
          kk = istrln(mcargd(i,j))
          if (kk.ge.1) then
             if (j.gt.1) then 
                tmpstr = tmpstr(1:k)//', "'// mcargd(i,j)(1:kk)// '"'
             else
                tmpstr = tmpstr(1:k)//'  "'// mcargd(i,j)(1:kk)// '"'
             end if
          end if
          k = istrln(tmpstr)
 60    continue 
       call triml(tmpstr)
       k = istrln(tmpstr)
       call echo( ' macro '// tmpstr(1:k) )
       if ((mcdesc(i).ne.blank).and.(mcdesc(i).ne.undef)) then
          tmpstr = mcdesc(i)
          call triml(tmpstr)
          k = istrln(tmpstr)
          call echo( '   "'// tmpstr(1:k)//'"' )
       endif
c
c idonly = 1 if we only wanted name, arg list, description
       if (idonly.le.0) then
          imac = imacro(i)
 150      continue 
          if ((imac.gt.0).and.(imac.le.mcline)) then
             k = istrln( macstr(imac) )
             call echo( '     '// macstr(imac)(1:k)  )
             imac = imcptr(imac)
             go to 150
          end if
          call echo( ' end macro')
       endif
cc
cc  full dump
cc       if (iprint.eq.20) then 
cc          print*, 'MACROS: '
c          do i = 1, macmax
c             if (macnam(i) .ne.blank) then
c                print*, '  mac: ', macnam(i), imacro(i)
c             endif
c          enddo
c          do i = 1, mcline
c             if (macstr(i) .ne.undef) then
c                print*, ' ', i, imcptr(i), macstr(i)(1:70)
c             endif
c          enddo
cc       endif
cc
       return
       end
c
       subroutine ishgrp
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       character*256 s, sgrps(maxarr)
       integer is, i, j, ii, k, istrln
       external istrln
       save
       is    = 0
       do 80 i = 1, maxarr-1
          j = index(arrnam(i),'.')
          if (j.gt.0) s = arrnam(i)(1:j-1)
          if (is.gt.0) then 
             do 40 ii = 1, is
                if (s.eq. sgrps(ii)) goto 65
 40          continue 
          end if
          is = is + 1
          sgrps(is) = s
          k = max(1, istrln(s))
          write(messg,'(2x,a)') s(1:k)
          call echo(messg)
 65       continue             
 80    continue             
       return
       end
c       
       subroutine show_path(iup)
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'fefdat.h'
       include 'feffit.h'
       include 'pthpar.h'
       save
       integer  iup, inpath, u2ipth, jfeff, i, ret
       integer  ntmp, ilen,  istrln, xafs_path
       double precision tmp2(maxpts), getsca, xtmp, pdeg
       character*2 at_symbol
       external    at_symbol
       external istrln, u2ipth, getsca, xafs_path
       
       inpath = u2ipth(iup)
       if (inpath .le. 0) return

       jfeff  = jpthff(inpath)
c read feff files if necessary
       if (.not. lffred(jfeff)) then
          call fefinp
          if (int(getsca('&sync_level',0)).ge.3)  call iff_sync
       endif          

       xtmp = iup * 1.d0
       call setsca('path_index', xtmp)
       call synvar
c
       if (iup .le. 0) return
       ret  = xafs_path(iup,tmparr,tmp2,xtmp)
       if (ret.ne.1) return
cc       print*, '::: iup , jfeff ' , iup, inpath, jfeff, refpth(jfeff)

c
c      path degeneracy
       pdeg = param(jfpdeg)       
       if (icdpar(1,jfpdeg,inpath).eq.0) pdeg = degpth(jfeff)

       write(messg,'(1x,a,i5)') ' PATH ', iup
       call echo(messg)
       ret  = xafs_path(iup,tmparr,tmp2,xtmp)

       ilen = istrln(feffil(jfeff))
       write(messg,'(4x,2a)') 'feff   = ', feffil(jfeff)(1:ilen)
       call echo(messg)
c
       ilen = istrln(fpthid(jfeff))
       write(messg,'(4x,2a)') 'id     = ', fpthid(jfeff)(1:ilen)
       call echo(messg)

       ilen = istrln(pthlab(inpath))
       write(messg,'(4x,2a)') 'label  = ', pthlab(inpath)(1:ilen)
       call echo(messg)


c  evaluate the path parameters
       do 50 i = 1, mpthpr
          tmparr(1) = zero
          if (i.eq.jfps02)  tmparr(1) = one
          ntmp = 0
          if (iprint.ge.12)
     $         call rpndmp(icdpar(1,i,inpath))
          if (icdpar(1, i, inpath).ne.0) then
             call decod(icdpar(1, i, inpath), micode, 
     $            consts, scalar, array, narray, nparr, 
     $            maxsize_array, maxarr,  ntmp, tmparr)
          end if
          param(i) = tmparr(1)
 50    continue 
c note for degeneracy: 
c   the default is from feff.dat file, but it can be 
c   overridden as a path parameter.        
       xtmp = param(jfpdeg)       
cc       print*, ' xtmp ', xtmp
       if (icdpar(1,jfpdeg,inpath).eq.0) xtmp = degpth(jfeff)
       call write_double_param('r     ', 6, refpth(jfeff)+param(jfpdr))
       call write_double_param('degen ', 6, xtmp)
       call write_double_param('s02   ', 6, param(jfps02))
       call write_double_param('e0    ', 6, param(jfpe0))
       call write_double_param('dr    ', 6, param(jfpdr))
       call write_double_param('ss2   ', 6, param(jfpss2))
       if (icdpar(1,jfp3rd,inpath).ne.0) then
          call write_double_param('3rd   ', 6, param(jfp3rd))
       endif
       if (icdpar(1,jfp4th,inpath).ne.0) then
          call write_double_param('4th   ', 6, param(jfp4th))
       endif
       if (icdpar(1,jfpei ,inpath).ne.0) then
          call write_double_param('ei    ', 6, param(jfpei) )
       endif
       if (icdpar(1,jfppha,inpath).ne.0) then
          call write_double_param('dphase', 6, param(jfppha))
       endif
       return
       end
       subroutine write_double_param(s,n,f)
       character*(*) s
       double precision f
       integer  n
       include 'consts.h'
       include 'keywrd.h'
 10    format(4x,a,' =',f12.6)       
       write(messg,10) s(1:n), f 
       call echo(messg)
       return 
       end

       subroutine iff_test(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: ifeffit test function
c 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'spline.h'
       save
       character*(*)  str
       character*128  xarr, yarr, name1, defkey(3)*64
       double precision  arr_x(maxpts), arr_y(maxpts)
       logical   stfind, eefind
       integer   jen, jpre, jxmu, ier, i, k, istrln, jdot
       integer   ndfkey, npts_y, npts_x, sort_xy
       integer  iff_eval, jx,jy
       external iff_eval, sort_xy
       external istrln
c
c get default values for pre-edge parameters from current scalar values
       call iff_sync
       call bkeys(str, mkeys, keys, values, nkeys)

c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
       ndfkey    = 2
       defkey(1) = 'x'
       defkey(2) = 'y'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'group') then
             name1 = values(i)
          elseif (keys(i).eq.'x') then
             xarr = values(i)
             call lower(xarr)
          elseif (keys(i).eq.'y') then
             yarr = values(i)
             call lower(yarr)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1, ' *** test: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names
       if (name1.eq.undef) then
          jdot = index(xarr,'.')
          if (jdot.ne.0) name1 = xarr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(xarr,'.')
          if (jdot.ne.0) name1 = yarr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' test: can''t determine group name')
          return             
       endif
       call fixnam(name1,1)
       call lower(name1)
       jdot = istrln(name1)

       jx = iff_eval(xarr, name1, arr_x, npts_x)
       jy = iff_eval(yarr, name1, arr_y, npts_y)

       ier = sort_xy(arr_x, arr_y, npts_x,1.d-5)
       
c       do i = 1, npts_x
c          print*, i, arr_x(i), arr_y(i)
c       enddo

       return
c end  subroutine iff_test
       end

       double precision function bvalue ( t, bcoef, n, k, x, jderiv )
c
c  from  * a practical guide to splines *  by c. de boor
c  calls  interv
c
c  calculates value at x of jderiv-th derivative of spline from b-repr.
c  the spline is taken to be continuous from the right, except at the
c  rightmost knot, where it is taken to be continuous from the left.
c
c  from:   in%"netlibd@research.att.com"  9-aug-1992 13:11:48.46
c  subj:   re: subject: send bvalue from pppack
c  echo "anything free comes with no guarantee!"
c
c******  i n p u t ******
c  t, bcoef, n, k......forms the b-representation of the spline  f  to
c        be evaluated. specifically,
c  t.....knot sequence, of length  n+k, assumed nondecreasing.
c  bcoef.....b-coefficient sequence, of length  n .
c  n.....length of  bcoef  and dimension of spline(k,t),
c        a s s u m e d  positive .
c  k.....order of the spline .
c
c  w a r n i n g . . .   the restriction  k .le. kmax (=20)  is imposed
c        arbitrarily by the dimension statement for  aj, dl, dr  below,
c        but is  n o w h e r e  c h e c k e d  for.
c
c  x.....the point at which to evaluate .
c  jderiv.....integer giving the order of the derivative to be evaluated
c        a s s u m e d  to be zero or positive.
c
c******  o u t p u t  ******
c  bvalue.....the value of the (jderiv)-th derivative of  f  at  x .
c
c******  m e t h o d  ******
c     the nontrivial knot interval  (t(i),t(i+1))  containing  x  is lo-
c  cated with the aid of  interv . the  k  b-coeffs of  f  relevant for
c  this interval are then obtained from  bcoef (or taken to be zero if
c  not explicitly available) and are then differenced  jderiv  times to
c  obtain the b-coeffs of  (d**jderiv)f  relevant for that interval.
c  precisely, with  j = jderiv, we have from x.(12) of the text that
c
c     (d**j)f  =  sum ( bcoef(.,j)*b(.,k-j,t) )
c
c  where
c                   / bcoef(.),                     ,  j .eq. 0
c                   /
c    bcoef(.,j)  =  / bcoef(.,j-1) - bcoef(.-1,j-1)
c                   / ----------------------------- ,  j .gt. 0
c                   /    (t(.+k-j) - t(.))/(k-j)
c
c     then, we use repeatedly the fact that
c
c    sum ( a(.)*b(.,m,t)(x) )  =  sum ( a(.,x)*b(.,m-1,t)(x) )
c  with
c                 (x - t(.))*a(.) + (t(.+m-1) - x)*a(.-1)
c    a(.,x)  =    ---------------------------------------
c                 (x - t(.))      + (t(.+m-1) - x)
c
c  to write  (d**j)f(x)  eventually as a linear combination of b-splines
c  of order  1 , and the coefficient for  b(i,1,t)(x)  must then be the
c  desired number  (d**j)f(x). (see x.(17)-(19) of text).
c
       implicit none
       integer kmax
       parameter (kmax = 50)
       integer jderiv,k,n, i,ilo,imk,j,jc,jcmin,jcmax,jj,kmj,km1,mflag
       integer nmi,jdrvp1
       double precision bcoef(n),t(*),x
       double precision aj(kmax),dl(kmax),dr(kmax),fkmj
c       dimension t(n+k)
c  former fortran standard made it impossible to specify the length
c  of  t precisely without the introduction of otherwise superfluous
c  additional arguments.
       bvalue = 0.d0
       if (jderiv .ge. k)  return
c
c  *** find  i   s.t.   1 .le. i .lt. n+k   and   t(i) .lt. t(i+1)   and
c      t(i) .le. x .lt. t(i+1) . if no such i can be found,  x  lies
c      outside the support of  the spline  f , hence  bvalue = 0.
c      (the asymmetry in this choice of  i  makes  f  rightcontinuous,
c      except  at  t(n+k) where it is leftcontinuous.)
       call interv ( t, n+k, x, i, mflag )
       if (mflag .ne. 0)  return
c  *** if k = 1 (and jderiv = 0), bvalue = bcoef(i).
       km1 = k - 1
       if (km1 .le. 0)  then
          bvalue = bcoef(i)
          return
       end if
c
c  *** store the k b-spline coefficients relevant for the knot interval
c     (t(i),t(i+1)) in aj(1),...,aj(k) and compute dl(j) = x - t(i+1-j),
c     dr(j) = t(i+j) - x, j=1,...,k-1 . set any of the aj not obtainable
c     from input to zero. set any t.s not obtainable equal to t(1) or
c     to t(n+k) appropriately.
    1 jcmin = 1
      imk = i - k
      if (imk .lt. 0)  then
         jcmin = 1 - imk
         do 5 j=1,i
            dl(j) = x - t(i+1-j)
 5       continue 
         do 6 j=i,km1
            aj(k-j) = 0.d0
            dl(j) = dl(i)
 6       continue 
       else
          do 9 j=1,km1
             dl(j) = x - t(i+1-j)
 9        continue 
       end if
c
       jcmax = k
       nmi = n - i
       if (nmi .ge. 0) then
          do 19 j=1,km1
             dr(j) = t(i+j) - x
 19       continue 
       else 
          jcmax = k + nmi
          do 15 j=1,jcmax
             dr(j) = t(i+j) - x
 15       continue 
          do 16 j=jcmax,km1
             aj(j+1) = 0.d0
             dr(j) = dr(jcmax)
 16       continue 
       end if
c
       do 21 jc=jcmin,jcmax
          aj(jc) = bcoef(imk + jc)
 21    continue 
c
c               *** difference the coefficients  jderiv  times.
       if (jderiv .ne. 0) then
          do 24 j=1,jderiv
             kmj  = k-j
             fkmj = kmj
             ilo  = kmj
             do 23 jj=1,kmj
                aj(jj) = ((aj(jj+1) - aj(jj))/(dl(ilo) + dr(jj)))*fkmj
                ilo = ilo - 1
 23          continue 
 24       continue 
       end if
c
c  *** compute value at  x  in (t(i),t(i+1)) of jderiv-th derivative,
c     given its relevant b-spline coeffs in aj(1),...,aj(k-jderiv).
       if (jderiv .ne. km1)  then
          jdrvp1 = jderiv + 1
          do 34 j=jdrvp1,km1
             kmj = k-j
             ilo = kmj
             do 33 jj=1,kmj
                aj(jj) = (aj(jj+1)*dl(ilo) +
     $               aj(jj)*dr(jj))/(dl(ilo)+dr(jj))
                ilo = ilo - 1
 33          continue 
 34       continue 
       end if
       bvalue = aj(1)
c
       return
c  end funtion bvalue
       end
       subroutine interv ( xt, lxt, x, left, mflag )
c  from  * a practical guide to splines *  by c. de boor
c  computes  left = max( i :  xt(i) .lt. xt(lxt) .and.  xt(i) .le. x ).
c
c******  i n p u t  ******
c  xt.....a real sequence, of length  lxt , assumed to be nondecreasing
c  lxt.....number of terms in the sequence  xt .
c  x.....the point whose location with respect to the sequence  xt  is
c        to be determined.
c
c******  o u t p u t  ******
c  left, mflag.....both integers, whose value is
c
c   1     -1      if               x .lt.  xt(1)
c   i      0      if   xt(i)  .le. x .lt. xt(i+1)
c   i      0      if   xt(i)  .lt. x .eq. xt(i+1) .eq. xt(lxt)
c   i      1      if   xt(i)  .lt.        xt(i+1) .eq. xt(lxt) .lt. x
c
c        in particular,  mflag = 0  is the 'usual' case.  mflag .ne. 0
c        indicates that  x  lies outside the closed interval
c        xt(1) .le. y .le. xt(lxt) . the asymmetric treatment of the
c        intervals is due to the decision to make all pp functions cont-
c        inuous from the right, but, by returning  mflag = 0  even if
c        x = xt(lxt), there is the option of having the computed pp function
c        continuous from the left at  xt(lxt) .
c
c******  m e t h o d  ******
c  the program is designed to be efficient in the common situation that
c  it is called repeatedly, with  x  taken from an increasing or decrea-
c  sing sequence. this will happen, e.g., when a pp function is to be
c  graphed. the first guess for  left  is therefore taken to be the val-
c  ue returned at the previous call and stored in the  l o c a l  varia-
c  ble  ilo . a first check ascertains that  ilo .lt. lxt (this is nec-
c  essary since the present call may have nothing to do with the previ-
c  ous call). then, if  xt(ilo) .le. x .lt. xt(ilo+1), we set  left =
c  ilo  and are done after just three comparisons.
c     otherwise, we repeatedly double the difference  istep = ihi - ilo
c  while also moving  ilo  and  ihi  in the direction of  x , until
c                      xt(ilo) .le. x .lt. xt(ihi) ,
c  after which we use bisection to get, in addition, ilo+1 = ihi .
c  left = ilo  is then returned.
c
       implicit none
       integer left,lxt,mflag,   ihi,ilo,istep,middle
       double precision x,xt(lxt)
       save ilo
       data ilo /1/
c
       ihi = ilo + 1
       if (ihi .ge. lxt) then
          if (x .ge. xt(lxt))            go to 110
          if (lxt .le. 1)                go to 90
          ilo = lxt - 1
          ihi = lxt
c
       end if
 20    if (x .ge. xt(ihi))               go to 40
       if (x .ge. xt(ilo))               go to 100
c
c              **** now x .lt. xt(ilo) . decrease  ilo  to capture  x .
      istep = 1
   31    ihi = ilo
         ilo = ihi - istep
         if (ilo .le. 1)                go to 35
         if (x .ge. xt(ilo))            go to 50
         istep = istep*2
                                        go to 31
   35 ilo = 1
      if (x .lt. xt(1))                 go to 90
                                        go to 50
c              **** now x .ge. xt(ihi) . increase  ihi  to capture  x .
   40 istep = 1
   41    ilo = ihi
         ihi = ilo + istep
         if (ihi .ge. lxt)              go to 45
         if (x .lt. xt(ihi))            go to 50
         istep = istep*2
                                        go to 41
   45 if (x .ge. xt(lxt))               go to 110
      ihi = lxt
c
c           **** now xt(ilo) .le. x .lt. xt(ihi) . narrow the interval.
   50 middle = (ilo + ihi)/2
      if (middle .eq. ilo)              go to 100
c     note. it is assumed that middle = ilo in case ihi = ilo+1 .
      if (x .lt. xt(middle))            go to 53
         ilo = middle
                                        go to 50
   53    ihi = middle
                                        go to 50
c**** set output and return.
   90 mflag = -1
       left = 1
       return
 100   mflag = 0
       left = ilo
       return
 110   mflag = 1
       if (x .eq. xt(lxt)) mflag = 0
       left = lxt
 111   if (left .eq. 1)                  return
       left = left - 1
       if (xt(left) .lt. xt(lxt))       return
c  end subroutine interv
      end

       subroutine iff_fft(key,str)
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: ifeffit: xafs fourier transform -- driver for xafsft
c
c arguments:
c      key     command name to perform (fftf / fftr)    [in]
c      str     command line to performd                 [in]
c
c notes:
c   1. driver for xafsft, does both forward and back transforms
c   2. key names direction of fft
c   3. uses named scalars, strings, and arrays, as well as
c      key/value pairs from command string
c
c requires: istrln, getsca, gettxt, bkeys, lower, str2re,
c           echo, cffti, window, lintrp, xafsft, setsca, settxt
c
c   Despina can be reached in two ways: by ship or by camel.  The city
c   displays one face to the travel arriving overland and a different
c   one to him who arrives by sea.
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fft.h'
       include 'pthpar.h'
       include 'fefdat.h'
       save
       integer  nxpar, ifft
       parameter (nxpar = 11)
       character*(*) key, str, defkey(3)*64, tnam*256
       character*256 re_arr, im_arr, x_arr, pc_arr, winnam*32
       character*256 winarr, name1, wintyp, outtyp, myname*5
       character*10  forpar(nxpar), revpar(nxpar), params(nxpar)
       complex*16    cinp(maxfft), cout(maxfft), cmi
       parameter (cmi=(0d0,-1d0))

       double precision getsca, xmin, xmax, xw, dx1, dx2, xmout
       double precision xgrid, ygrid,xk
       double precision arr_x(maxpts), arr_r(maxpts), arr_i(maxpts)
       double precision arr_w(maxpts), arr_p(maxpts)
       double precision txx(maxpts), txr(maxpts), txi(maxpts)
       double precision txm(maxpts), txp(maxpts)
       integer  npts_x, npts_r, npts_i, npts_w, npts_p, jxar,nptsxx
       integer  jwin, jrea, jima, jpha, i, k, jdot, idwin
       integer  jout1, jout2, jout3, jout4, jout5
       integer  ier,  istrln, ndfkey, ipos, nyout, nxout
       integer  pc_path, jfeff, ilen
       integer  iff_eval, iff_eval_dp, iff_eval_in, u2ipth
       logical  xm_set , pc_caps
       character*16 pc_edge, path*256
       external iff_eval, iff_eval_dp, iff_eval_in
       external getsca, istrln, u2ipth

       data (forpar(i), i=1, nxpar) /'k', 'dk', 'dk1', 'dk2',
     $      'kmin', 'kmax', 'kweight', 'kwindow', 'win', 'rsp',
     $      'rmax_out'/

       data (revpar(i), i=1, nxpar) /'r', 'dr', 'dr1', 'dr2',
     $      'rmin', 'rmax', 'rweight', 'rwindow', 'rwin', 'qsp',
     $      'qmax_out'/
c
c initialize 
c set default program variables to use based on "key"
       call iff_sync
       if ( (key.eq.'fftr').or.(key.eq.'bft')) then
          ifft   = -1
          xgrid  = rgrid
          ygrid  = qgrid
          do 12 i = 1, nxpar
             params(i) = revpar(i)
 12       continue
       else
          ifft   = 1
          xgrid  = qgrid
          ygrid  = rgrid
          do 14 i = 1, nxpar
             params(i) = forpar(i)
 14       continue
       end if
c
c get default values of relevant program variables
c   scalars:
       xm_set = .false.
       myname = key
       dx1    = getsca(params(3),1)
       dx2    = getsca(params(4),1)
       if ((abs(dx1).le.tiny).and.(abs(dx2).le.tiny)) then
          dx1 = getsca(params(2),1)
          dx2 = dx1
       endif
       pc_path = 0
       pc_edge = blank
       pc_caps = .false.
       xmin   = getsca(params(5),1)
       xmax   = getsca(params(6),1)
       xw     = getsca(params(7),1)
       xmout  = getsca(params(11),1)
       outtyp = params(10)
       wintyp = params( 9)
c   strings:
       re_arr = undef
       im_arr = undef
       pc_arr = undef
       x_arr  = undef
       name1  = undef
       call gettxt(params(8), winnam)
       call gettxt('altwindow',winarr)
c parse command line
       call bkeys(str, mkeys, keys, values, nkeys)
       ndfkey    = 1
       defkey(1) = 'real'

       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then
             name1 = values(i)
          elseif (keys(i).eq.'altwindow') then
             winarr = values(i)
             call lower(winarr)
          elseif (keys(i).eq.'real') then
             re_arr = values(i)
             call lower(re_arr)
          elseif (keys(i).eq.'imag') then
             im_arr = values(i)
             call lower(im_arr)
          elseif (keys(i).eq.'phase_array') then
             pc_arr = values(i)
             call lower(pc_arr)
          elseif (keys(i).eq.'pc_edge') then
             pc_edge = values(i)
             pc_caps = .true.
          elseif (keys(i).eq.'pc_feff_path') then
             ier = iff_eval_in(values(i),pc_path)
          elseif (keys(i).eq.'pc_caps') then
             call str2lg(values(i), pc_caps, ier)
          elseif (keys(i).eq.'pc_full') then
             call str2lg(values(i), pc_caps, ier)
             pc_caps = .not.pc_caps
          elseif (keys(i).eq.params(1)) then
             x_arr = values(i)
             call lower(x_arr)
          elseif (keys(i).eq.params(2)) then
             ier = iff_eval_dp(values(i),dx1)
             dx2 = dx1
          elseif (keys(i).eq.params(3)) then
             ier = iff_eval_dp(values(i),dx1)
          elseif (keys(i).eq.params(4)) then
             ier = iff_eval_dp(values(i),dx2)
          elseif (keys(i).eq.params(5)) then
             ier = iff_eval_dp(values(i),xmin)
          elseif (keys(i).eq.params(6)) then
             ier = iff_eval_dp(values(i),xmax)
          elseif (keys(i).eq.params(7)) then
             ier = iff_eval_dp(values(i),xw)
          elseif (keys(i).eq.params(8)) then
             winnam = values(i)
             call lower(winnam)
          elseif (keys(i).eq.params(11)) then
             ier = iff_eval_dp(values(i),xmout)
             xm_set = .true.
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,
     $            ' *** '//myname//' : unknown keyword " '//messg)
          end if
 100   continue

c initialize fft work array (if not already done)
       if (.not.wftset) then
          call cffti(maxfft, wfftc)
          wftset = .true.
       end if
c
c get/resolve array names
c    if name1 not given, inherit from x_arr, re_arr, or im_arr.
       if (name1.eq.undef) then
          jdot = index(x_arr,'.')
          if (jdot.ne.0) name1 = x_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(re_arr,'.')
          if (jdot.ne.0) name1 = re_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(im_arr,'.')
          if (jdot.ne.0) name1 = im_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' '//myname//': can''t determine group name')
          return             
       endif
       call fixnam(name1, 1)
       call lower(name1)

c evaluate all of the possible arrays
       do 180 i = 1, maxpts
          arr_x(i) = zero
          arr_r(i) = zero
          arr_i(i) = zero
          arr_w(i) = zero
          arr_p(i) = zero
 180   continue

       jxar = iff_eval(x_arr,  name1, arr_x, npts_x)
       jrea = iff_eval(re_arr, name1, arr_r, npts_r)
       jima = iff_eval(im_arr, name1, arr_i, npts_i)
       jwin = iff_eval(winarr, name1, arr_w, npts_w)
       jpha = iff_eval(pc_arr, name1, arr_p, npts_p)
c
c for phase-corrections given a feff file:
       if (pc_path .gt. 0) then
          jpha = 999
          call fefinp
          jfeff = jpthff(u2ipth(pc_path))
          ipos  = 0
cc          print*, ' pc : path = ', pc_path, pc_caps
          if (pc_caps) then 
             do 220 i = 1, maxpts
                xk = (i-1) * xgrid
                call lintrp(qfeff(1,jfeff), thcaps(1,jfeff),
     $               mffpts, xk, ipos, arr_p(i))
 220         continue
          else
             do 223 i = 1, maxpts
                xk = (i-1) * xgrid
                call lintrp(qfeff(1,jfeff), thepha(1,jfeff),
     $               mffpts, xk, ipos, arr_p(i))
 223         continue
          endif
       else if((pc_edge .ne. blank) .and.
     $         (pc_edge .ne. undef) ) then
          jpha = 99
          nptsxx = npts_x
          if (jxar.lt.1) then 
             do 240 i = 1, maxpts
                arr_x(i) = (i-1) * xgrid
 240         continue
             nptsxx = maxpts
          endif
          call feff_table_array(pc_edge,'caps',nptsxx,arr_x, arr_p)
       endif
       npts_p = npts_x

cc       print*, ' im_arr = ', im_arr(1:20), jima, arr_i(1), arr_i(5)
c if the x-array has been given, the real/imag/window data should 
c be re-interpolated onto an even x-grid starting at x=0.
       if (jxar.ge.1) then
          if (jrea.ge.1)
     $         call zgrid_array(arr_x, npts_x, arr_r, npts_r, xgrid)
          if (jima.ge.1) 
     $         call zgrid_array(arr_x, npts_x, arr_i, npts_i, xgrid)
          if (jwin.ge.1)
     $         call zgrid_array(arr_x, npts_x, arr_w, npts_w, xgrid)
          if (jpha.ge.1)
     $         call zgrid_array(arr_x, npts_x, arr_p, npts_p, xgrid)
       endif
       if ((jima.le.0).and.(jrea.le.0)) then
          call warn(2, ' '//myname//': no real or imaginary array?')
          return
       endif
       nxout = max(npts_r, npts_i)
cc       print*, ' n  = ', nxout, npts_x, npts_r, npts_i
       if (npts_x.gt.0)  nxout = min(npts_x,nxout)
       if (npts_r.gt.0)  nxout = min(npts_r,nxout)
       if (npts_i.gt.0)  nxout = min(npts_i,nxout)
c
c now generate the complex function for the fft
       do 200 i = 1, maxfft
          cinp(i) = dcmplx(arr_r(i), arr_i(i))
          cout(i) = dcmplx(zero, zero)
 200   continue
c       do i = 1, 5
c          print*, i, cinp(i)
c       end do

c  apply phase-correction, if requested
       if (jpha.gt.0) then
          call echo('doing phase corrected fft')
          do 250 i = 1, maxfft
             cinp(i) = cinp(i) * exp(cmi * arr_p(i))
 250      continue
       end if
c
c get window function if it wasn't alreary specified
cc       print*, ' jwin ', jwin
       if (jwin.le.0) then
          call window(winnam,dx1,dx2,xmin,xmax,xgrid,maxpts,arr_w)
       end if
c
c do the actual fft
cc       print*, ' to  xafsft  '
       call xafsft(maxfft,cinp,arr_w,xgrid,xw,wfftc,ifft,cout)
c
c  default rmax_out = 10.d0 (unless set explicitly)
       nyout = maxpts / 2
       if ((xmout.eq.0).and.(.not.xm_set)) then
          xmout= 30.d0
          if (ifft.eq.1) xmout= 10.d0
       endif
       if (xmout.gt.0) nyout = 1 + (xmout / ygrid)

c output program variables: 
c
c window array
c   if an x-array has been supplied, interpolate the evenly-spaced
c   window array used in the FT onto the provided x-array
       if (jxar.ge.1) then
          do 300 i = 1, maxpts
             txx(i) = (i-1) * xgrid
 300      continue
          ipos = 0
          do 310 i = 1, npts_x
             call lintrp(txx, arr_w, maxpts, arr_x(i),
     $            ipos, tmparr(i))
 310      continue
          call set_array(wintyp, name1, tmparr, npts_x, 1)          
       else
          call set_array(wintyp, name1, arr_w, nxout, 1)
       endif
c
c generate dp arrays from complex FT data
       nyout = min(nyout,maxpts)
       do 600 i = 1, nyout
          txx(i) = ygrid * (i-1)
          txr(i) = dble(cout(i))
          txi(i) = dimag(cout(i))
          txm(i) = sqrt(txr(i)*txr(i) + txi(i)*txi(i))
          txp(i) = atan2(txi(i),txr(i))
          if (i.gt.1) call pijump( txp(i),txp(i-1) )
 600   continue 
c x
cc       print*,'fft: ', outtyp
       call file_type_names(outtyp ,1, tnam)
       call set_array(tnam, name1, txx, nyout, 1)
c mag
       call file_type_names(outtyp, 4, tnam)
cc       print*,'fft: ',  tnam(1:20), nyout
       call set_array(tnam, name1, txm, nyout, 1)
c phase
       call file_type_names(outtyp, 5, tnam)
       call set_array(tnam, name1, txp, nyout, 1)
c real
       call file_type_names(outtyp, 2, tnam)
       call set_array(tnam, name1, txr, nyout, 1)
c imag
       call file_type_names(outtyp, 3, tnam)
       call set_array(tnam, name1, txi, nyout, 1)
c scalars:
cc       print*, ' fft set ', params(3), dx1
       call setsca(params(3),  dx1)
       call setsca(params(4),  dx2)
       call setsca(params(5),  xmin)
       call setsca(params(6),  xmax)
       call setsca(params(7),  xw)
       call setsca(params(11), xmout)
       call settxt(params(8),  winnam)

       return
c end subroutine iff_fft
       end
       subroutine zgrid_array(x, nx, y, ny, xgrid)
c
c interpolate x/y arrays onto even x-grid starting a x=0             
c overwrites y array and ny
       implicit none
       include 'consts.h'
       integer nx, ny
       double precision x(*), y(*), ta(maxpts), xt, xgrid
       integer  nx1, nt, ipos, i

       nx1 = min(nx, ny)
       nt  = 1 + x(nx1) / xgrid
       nt  = min(nt, maxpts)
       ipos = 0
       do 10 i = 1, nt
          xt = (i-1) * xgrid
          call lintrp(x, y, nx, xt, ipos, ta(i))
 10    continue
       ny = nt
       do 20 i = 1, ny
          y(i) = ta(i)
 20    continue 
       do 30 i = ny + 1, maxpts
          y(i) = 0
 30    continue 
       return
       end

       subroutine fitinp
c
c  read inputs for feffit from feffit.inp
c  copyright 1993 university of washington          matt newville
c
c  read inputs from command file with keywords and a lot of elseifs.
c
       include 'fitcom.h'
c
       integer maxwrd, mfil, i, iinp, iex, ier, nwords, iwrds
       integer ilen, istrln, j, ierr, i2, iv, i3, jinit, ie
       integer nfil, jl, iuser, idpath, inpath, iffx, iunky
       parameter(maxwrd = 30, mfil = 10)
       character*2048 str, string, strdum, stat*10
       character*128 words(maxwrd), wrdsor(maxwrd) 
       character*32  wins(8)
       character     keywrd*128, key*3, prompt*20
       logical       errskp, path0, flag
       integer       itemp, itfeff, ifeff, ititle, idata, iparam
       integer       ilcl, jlcl,icom(mfil), ix
       external      istrln
c
c      initialization
       itemp  = 0
       itfeff = 0
       ititle = 0
       idata  = 1
       ilcl   = 0
       ix      = 0
       wins(1) =  'hanning'
       wins(2) =  'fhanning'
       wins(3) =  'gaussian window'
       wins(4) =  'kaiser-bessel'
       wins(5) =  'parzen'
       wins(6) =  'welch'
       wins(7) =  'sine'

       prompt = 'f'
       do 10 i = 1, mfil
          icom(i)   = 0
 10    continue
       nfil   = 0
       iunky  = 0
c   input file: if file is found, open it for reading,
       iinp = 1
       ier  = 0
       iex  = 0
       stat = 'old'
       call  get_inpfile('feffit.inp',inpfil,ier)
       call lower(inpfil)
       if (macflg) then
cc#mac
ccc use LS Fortran's '*' syntax and dialog boxes (thanks boyan!)
c          open(unit=iinp,file=*,status='old',iostat=ier)
c          if (ier.ne.0) then
c             call AlertBox('File selection was canceled!')
c             call finmsg(2001,string,' ',0)
c          end if
c          call f_setvolume(jvrefnum(iinp))
c          call f_creator('ttxt')
ccc   this resets fname to the name of the opened file.
ccc   useful for computing output file names, etc.
c           inquire(unit=iinp,name=inpfil,iostat=ier)
c           if (ier.ne.0) inpfil='feffit.inp'
cc#mac
       else
cc          call openfl(iinp, inpfil, stat, iex, ier)
cc          if (iex.lt.0) call finmsg(1001,inpfil,' ',0)
cc          if (ier.ne.0) call finmsg(1002,inpfil,' ',0)
       end if
c---------------------------------------------------------------------
c     read in next line
       jinit  = -1
       string = inpfil
 100   continue
          errskp = .false.
          path0  = .false.
          iparam = jpnull
          strdum = ' '
          keywrd = ' '
          key    = ' '
          call getcom(jinit,string)
          call fixstr(string,str,ilen,words,wrdsor,maxwrd,nwords)
          if (ilen.lt.2) go to 100
          if (str.eq.'getcom_end')  go to 4000
          if (str.eq.'getcom_error') call finmsg(1003,inpfil,' ',0)
          if (str.eq.'getcom_nofile')
     $         call finmsg(1001,inpfil,' ',0)
 150      continue
          keywrd  = words(1)
          key     = keywrd(1:3)
          iwrds   = 2
c     use keyword to get the right value
c--   data set index : ' next data set ' on its own line
          if ( (keywrd.eq.'next').and.(words(2).eq.'data')) then
             iwrds  = maxwrd + 1
c   first write out title lines from previous data set
             messg = '   titles:'
             ilen = istrln(messg)
             write(strdum,'(a,i4)') ' --> data set #',idata
             call append(messg,strdum,ilen)
             call echo( messg(1:ilen))
             do 225 j = 1, mtitle
                if (titles(j,idata) .ne. ' ' )
     $               call echo('      '//titles(j,idata)(1:65))
 225         continue
c    now increment idata, reset ititle, check that idata isn't too big
             idata  = idata  + 1
             ititle = 0
             if (idata.gt.mdata) call finmsg(2220,string,' ',mdata)
c
c     keywords for input/ouput
c--   title  ( on its own line)
          elseif (keywrd.eq.'title') then
             iwrds  = maxwrd + 1
             ititle = ititle + 1
             if ( (ititle.le.mtitle).and.(wrdsor(2).ne.' ')) then
                call strclp(string, wrdsor(1), wrdsor(2),
     $               titles(ititle, idata))
             end if
c--   end reading file : ignore everything in input file past this line
          elseif (( keywrd.eq.'end' ).or.( keywrd.eq.'quit')) then
             go to 4000
c--   file formats for inputs and outputs: defaults are uwxafs,
c     but can be changed to ascii column files with  formin = 'asc'
          elseif ((keywrd.eq.'form').or.(keywrd.eq.'format')) then
             frmout = words(2)
             frminp = frmout
          elseif (keywrd(1:7).eq.'formin') then
             frminp = words(2)
          elseif (keywrd(1:8).eq.'formout')  then
             frmout = words(2)
c comment char for ascii column data files
          elseif ((keywrd.eq.'comment').or.(keywrd.eq.'asccmt')) then
             asccmt  = words(2)
c hardwire number of doc lines for ascii column data files
          elseif (keywrd.eq.'mdocxx') then
             call str2in(words(2), mdocxx, ierr )
c--   input data file        note: for uwexafs files, strdum contains
c     the file name and record specifier (nkey or skey).
          elseif (keywrd.eq.'data')  then
             datain(idata) = .true.
             errskp        = .true.
             i2 = max(1, istrln(wrdsor(2)))
             if (nwords.ge.3) then
                i3 = max(5, istrln(wrdsor(3)))
                strdum = wrdsor(2)(:i2+2)//wrdsor(3)(:i3)
                call filrec(strdum, chifil(idata), skey(idata),
     $                      nkey(idata))
             else
                chifil(idata) = wrdsor(2)
                skey(idata)   = ' '
                nkey(idata)   = 0
             end if
c--   bkg(k) data file     note: for uwexafs files, strdum contains
c     the file name and record specifier (nkey or skey).
          elseif (keywrd(1:6).eq.'bkgfil')  then
             bkgdat(idata) = .true.
             errskp        = .true.
             i2 = max(1, istrln(wrdsor(2)))
             if (nwords.ge.3) then
                i3 = max(5, istrln(wrdsor(3)))
                strdum = wrdsor(2)(:i2+2)//wrdsor(3)(:i3)
                call filrec(strdum, bkgfil(idata), skeyb(idata),
     $                      nkeyb(idata))
             else
                bkgfil(idata) = wrdsor(2)
                skeyb(idata)   = ' '
                nkeyb(idata)   = 0
             end if
c--   output file
          elseif  (keywrd.eq.'out') then
             outfil(idata)   = wrdsor(2)
c--   print level to feffit.run file
          elseif (keywrd.eq.'iprint') then
             call str2in(words(2), iprint, ierr )
c--   flag for doing tranquada correction
          elseif (keywrd(1:5).eq.'tranq') then
             call str2dp(words(2), tranq, ierr )
c--   flag for not doing fit and writing output
          elseif (keywrd.eq.'norun') then
             call str2lg(words(2), noout, ierr )
             nofit = noout
c--   flag for not writing output
          elseif (keywrd.eq.'noout') then
             call str2lg(words(2), noout, ierr )
c--   flag for not doing fit
          elseif (keywrd.eq.'nofit') then
             call str2lg(words(2), nofit, ierr )
c--  flag for writing feffit.prm file
          elseif (keywrd.eq.'prmout') then
             call str2lg(words(2), prmout, ierr )
c--  flag for writing phase corrected FT
          elseif (keywrd.eq.'pcout') then
             call str2lg(words(2), pcout, ierr )
cc--  flag for using phase corrected FT in fit
c          elseif (keywrd.eq.'pcfit') then
c             call str2lg(words(2), pcfit, ierr )
c--   flag for fitting background spline to low-r components
          elseif (keywrd.eq.'bkg') then
             call str2lg(words(2), bkgfit(idata), ierr )
c--   flag for writing background spline to output data file
          elseif (keywrd.eq.'bkgout') then
             call str2lg(words(2), bkgout, ierr )
c--   flag for writing out data for all paths
          elseif ((keywrd.eq.'all').or.(keywrd.eq.'allout')) then
             call str2lg(words(2), allout, ierr )
c--   flag for writing out data in k space
          elseif ((keywrd.eq.'kfull').or.(keywrd.eq.'fullk')) then
             call str2lg(words(2), kspcmp, ierr )
c--   flag for writing out data in k space
          elseif (keywrd.eq.'kspout') then
             call str2lg(words(2), kspout, ierr )
c--   flag for writing out data in r space
          elseif (keywrd.eq.'rspout') then
             call str2lg(words(2), rspout, ierr )
c--   flag for writing out data in q space (backtransform)
          elseif ((keywrd.eq.'qspout').or.(keywrd.eq.'envout')) then
             call str2lg(words(2), qspout, ierr )
c--   flags for which space to fit in (default is ifft=1 for r-space)
          elseif (keywrd.eq.'kspfit') then
             call str2lg(words(2), flag, ierr)
             if (flag)  ifft(idata) = 0
          elseif (keywrd.eq.'rspfit') then
             call str2lg(words(2), flag, ierr )
             if (flag)  ifft(idata) = 1
          elseif (keywrd.eq.'qspfit') then
             call str2lg(words(2), flag, ierr)
             if (flag)  ifft(idata) = 2
          elseif (keywrd.eq.'fit_space') then
             if (words(2)(1:1).eq.'k') ifft(idata) = 0
             if (words(2)(1:1).eq.'r') ifft(idata) = 1
             if (words(2)(1:1).eq.'q') ifft(idata) = 2
c--   flag for not using degeneracies from feff
          elseif (keywrd.eq.'degen') then
             call str2lg(words(2), degflg, ierr )
          elseif (keywrd.eq.'nodegen') then
             call str2lg(words(2), degflg, ierr )
             degflg = .false.
c--   relative weights for different data sets
          elseif (keywrd.eq.'weight') then
             call str2dp(words(2), sigwgt(idata), ierr )
c--   error bars  measurement uncertainty (default is to specify
c          in k-space, but r-space is also allowed.)
          elseif ( (keywrd.eq.'sigdat').or.(key.eq.'eps')
     $      .or.(keywrd.eq.'sigk').or.(keywrd.eq.'epsk')) then
             call str2dp(words(2), sigdtk(idata), ierr )
          elseif ( (keywrd.eq.'sigr').or.(keywrd.eq.'epsr')) then
             call str2dp(words(2), sigdtr(idata), ierr )
c--   maximum correlation to report
          elseif (keywrd.eq.'cormin') then
             call str2dp(words(2), cormin, ierr )
          elseif (keywrd.eq.'rwght1') then
             call str2dp(words(2), rwght1, ierr )
          elseif (keywrd.eq.'rwght2') then
             call str2dp(words(2), rwght2, ierr )
c--  hack for playing with user tolerance
       elseif  (keywrd.eq.'toler') then
          call str2dp(words(2), usrtol, ierr )
c--  number of iterations to make when evaluating error bars
       elseif  (keywrd.eq.'nerstp') then
         call str2in(words(2), nerstp, ierr )
c     keywords for feff.dats
c--   maximum r to write for r-space data
          elseif (keywrd.eq.'rlast') then
             call str2dp(words(2), rlast, ierr )
c     keywords for fft stuff
c--   number of points in fft for fit         ( found from qmin, qmax)
c          elseif (keywrd.eq.'max_fft_fit') then
c             call str2in(words(2), mftfit, ierr )
cc--   number of points in fft for writing out data ( 2048)
c          elseif (keywrd.eq.'max_fft_out') then
c             call str2in(words(2), mftwrt, ierr )
c--   minimum r for fit range
          elseif (keywrd.eq.'rmin') then
             call str2dp(words(2), rmin(idata), ierr )
c--   maximum r for fit range
          elseif (keywrd.eq.'rmax') then
             call str2dp(words(2), rmax(idata), ierr )
c--   minimum k for fit range / fourier transform
          elseif ((keywrd.eq.'kmin').or.(keywrd.eq.'qmin')) then
             call str2dp(words(2), qmin(idata), ierr )
c--   maximum k for fit range / fourier transform
          elseif ((keywrd.eq.'kmax').or.(keywrd.eq.'qmax')) then
             call str2dp(words(2), qmax(idata), ierr )
c--   k weight for fourier transform
          elseif ((key(1:2).eq.'kw').or.(key(1:2).eq.'qw')
     $            .or.(key.eq.'w  ')) then
             call str2dp(words(2), qweigh(idata), ierr )
c--   window sill fourier transform window parameter(s)
          elseif (keywrd(1:4).eq.'win') then
             sqwin(idata) = words(2)
          elseif (keywrd(1:4).eq.'iwin') then
             call str2in(words(2), ix, ierr )
             sqwin(idata) = wins(ix+1)
             srwin(idata) = sqwin(idata)
c--   window sill fourier transform window parameter(s)
          elseif ((keywrd.eq.'iqwin').or.(keywrd.eq.'ikwin')) then
             call str2in(words(2), ix, ierr )
             sqwin(idata) = wins(ix+1)
c--   window sill fourier transform window parameter(s)
          elseif (keywrd.eq.'irwin') then
             call str2in(words(2), ix, ierr )
             srwin(idata) = wins(ix+1)
cc--   gaussian fourier window
c          elseif (keywrd.eq.'gauss')  then
c             call str2dp(words(2), qwin1(idata), ierr )
c             qwin2(idata) = qwin1(idata)
c             iqwin(idata) = 2
c             irwin(idata) = 2
cc--   hanning fraction window
c          elseif ((keywrd.eq.'fhan').or.(keywrd.eq.'hann')) then
c             call str2dp(words(2), qwin1(idata), ierr )
c             qwin2(idata) = qwin1(idata)
c             iqwin(idata) = 1
c             irwin(idata) = 1
c-- k-space window parameters
          elseif ((keywrd.eq.'dk2').or.(keywrd.eq.'dq2')) then
             call str2dp(words(2), qwin2(idata), ierr )
          elseif ((keywrd.eq.'dk1').or.(keywrd.eq.'dq1')) then
             call str2dp(words(2), qwin1(idata), ierr )
          elseif ((key.eq.'dk').or.(key.eq.'dq')) then
             call str2dp(words(2), qwin1(idata), ierr )
             qwin2(idata) = qwin1(idata)
c-- r-space window parameters
          elseif (key.eq.'dr2') then
             call str2dp(words(2), rwin2(idata), ierr )
          elseif (key.eq.'dr1') then
             call str2dp(words(2), rwin1(idata), ierr )
cc          elseif (key.eq.'dr') then
cc             call str2dp(words(2), rwin1(idata), ierr )
cc             rwin2(idata) = rwin1(idata)
c-- optical transform phase factors
c          elseif (keywrd.eq.'rpha') then
c             call str2dp(words(2), rphas(idata), ierr )
c          elseif (keywrd.eq.'qpha') then
c             call str2dp(words(2), qphas(idata), ierr )
c
c     keywords for values: "guess"es and "set"s
c     for variables and functions
c--   variable: definition and initial guess
c--   here we : - increase the number of variables
c--   - set the initial guess of the variable
c--   - find the right value to associate with the variable
c--   - set icdval(1,iv) = -1 (to mark value as a variable)
          elseif (keywrd.eq.'guess')   then
             iwrds  = maxwrd + 1
             numvar = numvar + 1
             nvuser = numvar
c     find if this value was already defined,
c     or find the next avialable slot
c*mn -- make a function to return iv :
c    iv = nofstr(words(2),vnames,maxval)
c    that returns iv , or 0 if unfound
cc             iv  = nofstr(words(2), vnames, maxval)
cc             if (iv.eq.0) call finmsg(2100,string,' ',maxval)

             do 300  iv = 1, maxval
                if  (vnames(iv).eq.' ')       go to 310
                if  (vnames(iv).eq.words(2))  go to 320
 300         continue
             call finmsg(2100,string,' ',maxval)
c     new variable  : store name of value, increment # of variables
 310         continue
             nmathx     = max(iv, nmathx)
             vnames(iv) = words(2)
             if (numvar.gt.mvarys) call finmsg(2130,string,' ',mvarys)
c     previously defined value :
c     make sure it's set as a variable, and get initial value
 320         continue
             if (icdval(1, iv).ge.1) then
                call echo( '  -- feffit warning:  '//
     $               'confusion about variables ')
                messg =   vnames(iv)
                ilen = max(1, istrln(messg))
                call echo( '       '//messg(1:ilen))
                call echo( '        was "guessed" after '//
     $               'being "set".  results may be unstable.')
             elseif (icdval(1, iv).lt.0) then
                call echo( '  -- feffit warning:  '//
     $               'this variable was "guessed" twice:')
                messg =   vnames(iv)
                ilen = max(1, istrln(messg))
                call echo( '       '//messg(1:ilen))
             endif
             icdval(1,iv)   = -1
             call str2dp(words(3), xguess(numvar), ierr )
             values(iv)     = xguess(numvar)
c
c--   functions: definition and integer array
c--   here we : - check if value has already been defined.
c--   - find the right value to associate with the variable
c--   - encode the icdval integer array
          elseif (keywrd.eq.'set') then
             iwrds  = maxwrd + 1
             do 550  iv = 1, maxval
                if ( (vnames(iv).eq.words(2)).or.
     $               (vnames(iv).eq.' '     )      ) go to 560
 550         continue
             call finmsg(2200,string,' ',maxval)
 560         continue
             nmathx     = max(iv, nmathx)
             vnames(iv) = words(2)
c     check that this user-defined function was not previously
c     assigned as a local user-defined function. at this point,
c     just stop if it was.
             if (icdval(1,iv).gt.ixlocl)
     $            call finmsg(2110,string,vnames(iv),iv)
             call strclp(str,words(2),words(3),strdum)
             if (icdval(1, iv).lt.0) then
                call echo( '  -- feffit warning:  '//
     $               'confusion about variables ')
                messg =   vnames(iv)
                ilen = max(1, istrln(messg))
                call echo( '       '//messg(1:ilen))
                call echo( '        was "set" after '//
     $               'being "guessed".  results may be unstable.')
                numvar = numvar - 1
             elseif (icdval(1, iv).gt.0) then
                call echo( '  -- feffit warning:  '//
     $               'this variable was "set" twice:')
                messg =   vnames(iv)
                ilen = max(1, istrln(messg))
                call echo( '       '//messg(1:ilen))
             endif
             ierr = istrln(str)
c             print*, 'UBER: fitinp: ilen = ', ierr, ' :: ', str(1:ierr)
c             ierr = istrln(strdum)
c             print*, 'UBER: fitinp: ilen = ', ierr, ' :: ',
c     $            strdum(1:ierr)
             ierr   = 0
             call encod(strdum, vnames, maxval, consts, mconst,
     $            icdval(1,iv), micode, ierr)
             if (ierr.gt.0) call finmsg(2500,string,strdum,0)
c--   local functions: definition and integer array
c--   here we : - check if value has already been defined.
c--   - find the right value to associate with the variable
c--   - encode the icdval integer array
          elseif (keywrd.eq.'local') then
             iwrds  = maxwrd + 1
             iv     = 0
 750         continue
             iv = iv + 1
             if (iv.gt.maxval) call finmsg(2200,string,' ',maxval)
             if ( (vnames(iv).ne.words(2)).and.
     $            (vnames(iv).ne.' ')) go to 750
ccc             do 750  iv = 1, maxval
ccc                if ( (vnames(iv).eq.words(2)).or.
ccc     $               (vnames(iv).eq.' '     )      ) go to 760
ccc 750         continue
ccc             call finmsg(2200,string,' ',maxval)
ccc 760         continue
             nmathx     = max(iv, nmathx)
             vnames(iv) = words(2)
             jlcl = icdval(1,iv) - ixlocl
             if (jlcl.le.0) then
                ilcl  = ilcl + 1
                if (ilcl.gt.mlocal) call finmsg(2105,string,' ',mlocal)
                jlcl  = ilcl
             else
                do 780 jl  = 1, mlocal
                   if ((jlcl.eq.jl)) go to 790
 780            continue
                call finmsg(2105,string,' ',mlocal)
 790            continue
                jlcl = jl
             endif
c
c     check that this local user-defined function was not previously
c     assigned as a global user-defined function. at this point,
c     just stop if it was.
             if ((icdval(1,iv).ne.0).and.(icdval(1,iv).lt.ixlocl))
     $            call finmsg(2110,string,vnames(iv),iv)
             call strclp(str,words(2),words(3),strdum)
             ierr   = 0
             call encod(strdum, vnames, maxval, consts, mconst,
     $            icdloc(1,jlcl,idata), micode, ierr)
             icdval(1,iv) = ixlocl + jlcl
             if (ierr.gt.0) call finmsg(2120,string,strdum,0)
c
c     path parameters
c--   feff file name
          elseif ((keywrd.eq.'path').or.(keywrd.eq.'feff'))  then
             iparam = jppath
c--   user identification label
          elseif (key.eq.'id ')       then
             iparam = jplabl
c--   constant amplitude factor
          elseif ( (keywrd.eq.'s02').or.(keywrd.eq.'amp').or.
     $            (keywrd.eq.'so2')) then
             iparam = jps02
c--   energy shift : real energy correction
          elseif ( (key.eq.'esh').or.(key.eq.'e0 ').or.
     $            (key.eq.'ee ').or.(key.eq.'e0s'))  then
             iparam = jpe0
c--   energy shift : imaginary energy correction
          elseif (key.eq.'ei ') then
             iparam = jpei
c--   energy shift : imaginary energy correction
          elseif ((keywrd.eq.'dphase').or.(keywrd.eq.'phase')) then
             dphflg = .true.
             iparam = jpdpha
c--   delta r , the first cumulant
          elseif ( (keywrd.eq.'dr').or.(keywrd.eq.'deltar').or.
     $             (keywrd.eq.'delr'))   then
             iparam = jpdelr
c--   sigma^2, the debye waller factor, the second cumulant
          elseif ((keywrd(1:4).eq.'sigm').or.(keywrd.eq.'ss2')) then
             iparam = jpsig2
c--   the third cumulant
          elseif ( (keywrd.eq.'3rd').or.(keywrd.eq.'third').or.
     $            (keywrd.eq.'cubic'))  then
             iparam = jp3rd
c--   the fourth cumulant
          elseif ( (keywrd.eq.'4th').or.(keywrd.eq.'fourth').or.
     $            (keywrd.eq.'quartic'))  then
             iparam = jp4th
c--   didn't find anything! a null word or something.
          elseif ((.not.errskp).and.(iparam.eq.jpnull) ) then
             call finmsg(2330,string,keywrd,0)
             iwrds  = maxwrd + 1
             iunky  = iunky + 1
             if (iunky.ge.5) call finmsg(2300,string,' ',0)
          end if
c  keywords all checked now.
c
c  now, if keyword is a path parameter, interpret it.
c  there are a lot of path indices here, and they get confusing. 
c  here's a menu:
c     iuser   "user path index"      what the user wrote in feffit.inp
c     inpath  "internal path index"  which set of path params to use           
c     ifeff   "feff path index"      which feff file to use
c     idpath  "data path index"      which internal path is this for this
c                                    data set, when summing over paths
c  idpath is the key, and gives the rest using pointers in common blocks:
c     inpath = jdtpth(idpath,idata) 
c     iuser  = jdtusr(idpath,idata)
c     ifeff  = jpthff(inpath)
c
c--   iuser set here, and character string extracted
          if ( (iparam.ne.jpnull).and.(nwords.gt.2)) then
             iwrds  = maxwrd + 1
             call str2in(words(2), iuser, ierr )
             if ((iuser.lt.0).or.(iuser.gt.10000))
     $            call finmsg(2200,str,' ',0)
             path0  = (iuser.eq.0)
             call strclp(string,wrdsor(2),wrdsor(3),strdum)
c     assign a data path to the user path:
c--   idpath set here so that jdtusr(idpath,idata) = iuser
             idpath = 0
             if (.not.path0) then
                do 900 idpath = 1, mdpths
                   if (jdtusr(idpath,idata).eq.iuser)   go to 940
                   if (jdtusr(idpath,idata).eq.0) then
                      jdtusr(idpath,idata) = iuser
                      go to 940
                   end if
 900            continue
                call finmsg(2140,string,chifil(idata),mdpths)
 940            continue
             end if
c
c   assign an internal path to the data path:
c-- inpath set here           so that jdtpth(idpath,idata) = inpath
             do 1340 inpath = 1, mpaths
                if (jdtpth(idpath,idata).eq.inpath)  go to 1400
                if (jdtpth(idpath,idata).eq.0)       go to 1380
 1340        continue
             call finmsg(2150,string,' ',mpaths)
 1380        continue
             itemp  = itemp + 1
             inpath = itemp
             jdtpth(idpath,idata) = inpath
 1400        continue
c
c   assign a feff path to the internal path:
c-- ifeff set here          so that jpthff(inpath) = ifeff
             if ( (iparam.eq.jppath).and.(.not.path0)) then
                iffx = 0
                if (nwords.ge.4) call str2in(wrdsor(4),iffx,ie)
                do 1640 ifeff = 1, mfffil
                   if ( (feffil(ifeff) .eq. wrdsor(3)).and.
     $                  (iffrec(ifeff) .eq. iffx)) go to 1700
                   if (  feffil(ifeff) .eq. ' '  ) go to 1680
 1640           continue
                call finmsg(2170,string,feffil(ifeff),mfffil)
 1680           continue
                itfeff         = itfeff  + 1
                ifeff          = itfeff
                feffil(ifeff)  = wrdsor(3)
                iffrec(ifeff)  = iffx
cc                print*, ' INP path !  ', ifeff, feffil(ifeff)

 1700           continue
                if (jpthff(inpath).ne.0) then
                   write(messg,'(2a,i5)')' -- feffit warning: ',
     $                  'overwriting the feff file for path ', iuser
                   ilen = max(1, istrln(messg))
                   call echo( '       '//messg(1:ilen))
                end if
cc                print*, ' itfeff = ', itfeff, ifeff, inpath
                jpthff(inpath) = ifeff
             elseif ((iparam.eq.jppath).and.path0 ) then
                jpthff(inpath) = -1
                call echo( '  -- feffit warning: giving a '//
     $               'feff file for path 0 has no meaning.')
             elseif((iparam.eq.jplabl).and.(.not.path0)) then
                pthlab(inpath) = strdum
             else
                if (icdpar(1,iparam,inpath).ne.0) then
                   write(messg,'(4a,i5)')' -- feffit warning: ',
     $              'redefining ', parnam(iparam),' of path ',iuser
                   ilen = max(1, istrln(messg))
                   call echo( '       '//messg(1:ilen))
                end if
                call smcase(strdum, 'case')
                ierr      = 0
                call encod(strdum, vnames, maxval, consts, mconst,
     $               icdpar(1,iparam,inpath), micode, ierr)
                if (ierr.gt.0) call finmsg(2120,string,strdum,0)
             end if
          end if
c     decide whether or not to read more inputs from the current string
          if (nwords.gt.iwrds) then
             do 3600 i = 1, nwords
                words(i)  = words(i+iwrds)
                wrdsor(i) = wrdsor(i+iwrds)
 3600        continue
             nwords = nwords - iwrds
             go to 150
          end if
          go to 100
 4000  continue
c  end of reading input file
c  close input file, and write out titles for last data set
       if (iinp.ne.5) close(iinp)
       ndata = idata
cc       print*, 'FITINP: ndata = ', ndata
       messg = '   titles:'
       ilen = istrln(messg)
       if (ndata.gt.1) then
          write(strdum,'(a,i4)') ' --> data set #',idata
          call append(messg,strdum,ilen)
       end if
       call echo( messg(1:ilen))
       do 5800 j = 1, mtitle
          if (titles(j,idata) .ne. ' ' )
     $         call echo('      '//titles(j,idata)(1:65))
 5800  continue
       return
c end subroutine fitinp
       end

      subroutine inouh (dps,dqs,drs,dq1s,dfls,dvs,zin,testi,
     $     nucs,nstopi,jc)
c
c initial values for the outward integration
c dps=large component;     dqs=small component;     drs=radial mesh
c dq1s=slope at the origin of dps or dqs;  dfls=power of the first term
c du=developpement limite;  dvs=potential at the first point
c zin=atomic number      testi=test of the precision
c finite nuclear size if nucs is non-zero
c nstopi controls the convergence  du developpement limite
c **********************************************************************
      implicit double precision (a-h,o-z)
      save
      include 'atom.h'
c
c dep,deq=derivatives of dps and dq; dd=energy/dvc;
c dvc=speed of light in a.u.;
c dsal=2.*dvc   dk=kappa quantum number
c dm=exponential step/720.
c **********************************************************************
cc      common /trois/ dpno(4,30), dqno(4,30)
      dimension dps(mepts), dqs(mepts), drs(mepts)
      do 10 i=1,10
      dps(i)=zero
   10 dqs(i)=zero
      if (nucs) 20,20,60
   20 dval=zin/dvc
      deva1=-dval
      deva2=dvs/dvc+dval/drs(1)-dd
      deva3=zero
      if (dk) 30,30,40
   30 dbe=(dk-dfls)/dval
      go to 50
   40 dbe=dval/(dk+dfls)
   50 dqs(10)=dq1s
      dps(10)=dbe*dq1s
      go to 90
 60   dval=dvs+zin*(3-drs(1)*drs(1)/(drs(nucs)*drs(nucs)))/
     $     (drs(nucs)+drs(nucs))
      deva1=zero
      deva2=(dval-3*zin/(drs(nucs)+drs(nucs)))/dvc-dd
      deva3=zin/(drs(nucs)*drs(nucs)*drs(nucs)*dsal)
      if (dk) 70,70,80
   70 dps(10)=dq1s
      go to 90
   80 dqs(10)=dq1s
   90 do 100 i=1,5
      dps(i)=dps(10)
      dqs(i)=dqs(10)
      dep(i)=dps(i)*dfls
  100 deq(i)=dqs(i)*dfls
      m=1
  110 dm=m+dfls
      dsum=dm*dm-dk*dk+deva1*deva1
      dqr=(dsal-deva2)*dqs(m+9)-deva3*dqs(m+7)
      dpr=deva2*dps(m+9)+deva3*dps(m+7)
      dval=((dm-dk)*dqr-deva1*dpr)/dsum
      dsum=((dm+dk)*dpr+deva1*dqr)/dsum
      j=-1
      do 130 i=1,5
      dpr=drs(i)**m
      dqr=dsum*dpr
      dpr=dval*dpr
      if (m.eq.1) go to 120
  120 dps(i)=dps(i)+dpr
      dqs(i)=dqs(i)+dqr
      if (abs(dpr/dps(i)).le.testi.and.abs(dqr/dqs(i)).le.testi) j=1
      dep(i)=dep(i)+dpr*dm
  130 deq(i)=deq(i)+dqr*dm
      if (j.eq.1) go to 140
      dps(m+10)=dval
      dqs(m+10)=dsum
      m=m+1
      if (m.le.20) go to 110
      nstopi=45
  140 do 150 i=1,4
      dpno(i,jc)=dps(i+9)
  150 dqno(i,jc)=dqs(i+9)
      return
      end

       subroutine fitout
c
c   chi(k), chi(r), and chi(q) for data, theory, correction to
c   background and the contribution to the total theory from
c   each path, and written out. most of the code here is for
c   writing documents.
c
c      copyright 1993 university of washington         matt newville
c----------------------------------------------------------------------
       include 'fitcom.h'

       integer   lenfvc, istrln,  juser, j,labl, ntitle
       integer   jofl, ipre, ilen, ixs, iexist, im, iend, mftsav
       integer   i, mfit, id, ibscf, jtmp, idoc, j0, nqdata
       integer   jfeff, jtitle, ix, inpath, idpath, ititle
       integer   jdd, nstart, jlen
       double precision reff, degen, rsmall
       parameter(lenfvc = mdata*maxpts)
       character*128 outksp, outrsp, outenv, outpre, tmpstr*256
       character*10  skyk, skyr, skyq, sdelim
       character*100 outdoc(maxdoc)
       double precision  xbest(mvarys), temp(lenfvc)
       double precision  par(mpthpr),  qhi, decod, bvalue
       integer     imxpre
       external   istrln, bvalue, decod
       parameter (qhi = 20.d0, j0 = 0)
       parameter ( sdelim = ',})/]\\' )
c imxpre is one less than longest file name prefix
       imxpre  = 64
cc       print*, ' This is Fitout ', vaxflg, dosflg
       if (vaxflg)  imxpre = 28
       if (dosflg)  imxpre =  7
       do 10 i = 1, maxdoc
          outdoc(i) = ' '
 10    continue
c
       rsmall  = rgrid * 0.01d0
       mfit    = 0

       do 50 id = 1, ndata
          nrpts(id) = int( (rmax(id) - rmin(id) + rsmall) /rgrid) + 1
          mfit      = mfit + 2 * nrpts(id)
  50   continue
       mfit = min(mfit, lenfvc)
c  call fitfun to evaluate final version of best fit
       ifxvar  = 0
       do 70 i = 1, numvar
          xbest(i) = xfinal(i)
 70    continue
       call fitfun(mfit, numvar, xbest, temp, iend)
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c  for each data set:
c       write out the data in k, r, and q space
c       write out the full model in k, r, and q space
c       write out the background in k, r, and q space
c       write out each path contribution in k, r, and q space
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
       id = 1
 100   continue
c   construct output file names
         ilen = min(imxpre, max(1, istrln(outfil(id))))
c     find the last occurance of '.' that is *after* any
c     subdirectory delimeter (stored in sdelim)
         ipre = ilen
 122     continue
            ipre  = ipre - 1
            if (ipre.le.0) go to 124
            if (index(sdelim, outfil(id)(ipre:ipre)).ne.0)  then
               ipre = ilen + 1
               go to 124
            end if
            if (outfil(id)(ipre:ipre).ne.'.')  go to 122
 124     continue
         ipre = ipre - 1
         if (ipre.le.0) ipre  = ilen
c
         if (frmout.eq.' ') frmout = frminp
         if (frmout.eq.' ') frmout = 'ascii'
         outpre = outfil(id)(1:ipre)
         call smcase(frmout, 'a')
         if (frmout(1:2).eq.'uw') then
            outksp = outpre(1:ipre)//'.chi'
            outrsp = outpre(1:ipre)//'.rsp'
            outenv = outpre(1:ipre)//'.env'
         else
            outksp = outpre(1:ipre)//'k.xxx'
            outrsp = outpre(1:ipre)//'r.xxx'
            outenv = outpre(1:ipre)//'q.xxx'
         end if
         jofl = max(1, istrln(outksp))
c   write a message
         if ((.not.kspout).and.(.not.rspout)
     $                    .and.(.not.qspout)) then
            messg = 'no output files written ! '
            im    =  max(1, istrln(messg))
            go to 8000
         else
            messg = '          '
            im    = 10
            if (kspout) call append(messg,' '//outksp(:jofl)//' ',im)
            if (rspout) call append(messg,' '//outrsp(:jofl)//' ',im)
            if (qspout) call append(messg,' '//outenv(:jofl)//' ',im)
         end if
         call echo('      '//messg(:im))
c
c construct rwindo for output fft
         call window(srwin(id), rwin1(id),
     $        rwin2(id), rmin(id), rmax(id), rgrid,
     $        maxpts, rwindo(1,id) )
c
c  output for data chi
         iexist = 1
         if (datain(id)) then
            if (frmout(1:2).ne.'uw') then
               outksp = outpre(1:ipre)//'k.dat'
               outrsp = outpre(1:ipre)//'r.dat'
               outenv = outpre(1:ipre)//'q.dat'
            end if
            qlast(id) = min(qhi, qlast(id))
            skyk = ' '
            skyr = ' '
            skyq = ' '
            call xfsout(chiq(1,id),thiqr(1,id),frmout,vaxflg,
     $           outksp,outrsp,outenv,.false.,kspout,rspout,qspout,
     $           irecl(id),iexist,skyk,skyr,skyq,asccmt,mdocxx,
     $           qwindo(1,id),qweigh(id),rwindo(1,id),rweigh(id),
     $           wfftc,mftfit,rlast,q1st(id),qlast(id),
     $           pcout, qfeff(1,jffphs(id)),thepha(1,jffphs(id)), 
     $           mffpts,qgrid,ndoc(id),doc(1,id))
c     write a echoe
            if ((skyk.eq.' ').and.(skyr.eq.' ')
     $                       .and.(skyq.eq.' ')) then
               messg = 'data not written to output files'
            else
               messg = 'data written to'
               if (skyk.ne.' ') call append(messg,' chi(k) ',im)
               if (skyr.ne.' ') call append(messg,' chi(r) ',im)
               if (skyq.ne.' ')
     $              call append(messg,' filtered chi(k)',im)
            end if
         else
            messg = 'no data to write to output files'
         end if
         im = max(1, istrln(messg))
         call echo('           '// messg(:im))
c------------------------------------------------------------------
c  output for full theory chi
c
c  output documents
         call triml(titles(1,id))
         outdoc(1) = 'feffit result: '//titles(1,id)
         write(tmpstr,9280) qmin(id), qmax(id), qweigh(id),
     $        qwin1(id), qwin2(id), sqwin(id)(:12)
         outdoc(2) = tmpstr
         write(tmpstr,9301) rmin(id), rmax(id), xinfo(id)
         outdoc(3) = tmpstr
         if (datain(id)) then
             ixs = max(1, istrln(skey(id)))
             ix  = min(52-ixs, max(1, istrln(chifil(id))))
             write(outdoc(4),9360) skey(id)(1:ixs),chifil(id)(1:ix)
         else
             write(outdoc(4),9380)
         end if
c  jtitle gives the index for the next doc line to fill
         jtitle = 5
         do 220 ititle = 1, mtitle
            jlen = min(100, istrln( titles(ititle,id)))
            if (jlen.gt.0) then
               outdoc(jtitle) = '{ '//titles(ititle,id)(1:jlen)
               jtitle = jtitle + 1
            end if
 220     continue
c  get the rest documents from the first feffnnnn.dat used.
         idoc  = jtitle
         do 280 idpath = 1, mdpths
            inpath = jdtpth(idpath,id)
            if (inpath.gt.0) then
               jfeff = jpthff(inpath)
               jtmp  = 1
 240           continue
               if ( (idoc.le.maxdoc) .and. (jtmp.le.mffttl)) then
                  outdoc(idoc) = fefttl(jtmp, jfeff)
                  idoc = idoc + 1
                  jtmp = jtmp + 1
                  go to 240
               end if
               go to 285
            end if
 280     continue
 285     continue
c
c documents complete, so write out data :
         if (frmout(1:2).ne.'uw') then
            outksp = outpre(1:ipre)//'k.fit'
            outrsp = outpre(1:ipre)//'r.fit'
            outenv = outpre(1:ipre)//'q.fit'
         end if
         skyk = ' '
         skyr = ' '
         skyq = ' '
         call xfsout(thiq(1,id),thiqr(1,id),frmout,vaxflg,
     $        outksp,outrsp,outenv,kspcmp,kspout,rspout,qspout,
     $        irecl(id),iexist,skyk,skyr,skyq,asccmt,mdocxx,
     $        qwindo(1,id),qweigh(id),rwindo(1,id),rweigh(id),
     $        wfftc,mftfit,rlast,q1st(id),qlast(id),
     $        pcout, qfeff(1,jffphs(id)),thepha(1,jffphs(id)), 
     $        mffpts,qgrid,idoc,outdoc)
c     write a message
         if ((skyk.eq.' ').and.(skyr.eq.' ')
     $                    .and.(skyq.eq.' ')) then
            messg = 'full theory not written to output files'
            im    = istrln(messg)
         else
            messg = 'full theory written to'
            if (skyk.ne.' ') call append(messg,' chi(k) ',im)
            if (skyr.ne.' ') call append(messg,' chi(r) ',im)
            if (skyq.ne.' ')
     $           call append(messg,' filtered chi(k)',im)
         end if
         call echo('           '//messg(:im))
c------------------------------------------------------------------
c  outputs for background
         if (bkgout.and.(bkgfit(id).or.bkgdat(id)) ) then
c     ibscf holds place in xvar list of where the spline coefs
c     for the current data set are kept.
            ibscf  = nvuser+1
            if (id.gt.1) then
               do 290 jdd = 2, id
                  ibscf = ibscf + nbkg(jdd-1)
 290           continue
            endif
            nqdata = min(maxpts, max(2, nqfit(id)) + 10)
            if (bkgfit(id)) then
               do 300 i = 1, nqdata
                  thiq(i, id) =  bvalue(qknot(1,id), xfinal(ibscf),
     $                 nbkg(id), korder, qgrid*(i-1),j0)
 300           continue
            else
               do 320 i = 1, nqdata
                  thiq(i, id) = zero
 320           continue
            end if
c     construct documents for background
            write(outdoc(1),9410) rbkg(id), nbkg(id)
c
c documents complete, so write out data :
            if (frmout(1:2).ne.'uw') then
               outksp = outpre(1:ipre)//'k.bkg'
               outrsp = outpre(1:ipre)//'r.bkg'
               outenv = outpre(1:ipre)//'q.bkg'
            end if
            skyk = ' '
            skyr = ' '
            skyq = ' '
            call xfsout(thiq(1,id),thiqr(1,id),frmout,vaxflg,
     $           outksp,outrsp,outenv,.false.,kspout,rspout,qspout,
     $           irecl(id),iexist,skyk,skyr,skyq,asccmt,mdocxx,
     $           qwindo(1,id),qweigh(id),rwindo(1,id),rweigh(id),
     $           wfftc,mftfit,rlast,q1st(id),qlast(id),
     $           pcout, qfeff(1,jffphs(id)),thepha(1,jffphs(id)), 
     $           mffpts,qgrid,idoc,outdoc)
c     write a message
            if ((skyk.eq.' ').and.(skyr.eq.' ')
     $           .and.(skyq.eq.' ')) then
               messg = 'background not written to output files'
               im = max(1, istrln(messg))
            else
               messg = 'background written to'
               if (skyk.ne.' ') call append(messg,' chi(k) ',im)
               if (skyr.ne.' ') call append(messg,' chi(r) ',im)
               if (skyq.ne.' ')
     $              call append(messg,' filtered chi(k)',im)
            end if
            call echo('           '//messg(:im))
         elseif((.not.bkgout).and.(bkgdat(id).or.bkgfit(id))) then
            messg = 'background not written to output files'
            im = max(1, istrln(messg))
            call echo('           '//messg(:im))
         end if
c------------------------------------------------------------------
c  outputs for individual paths
c  optional outputs
         if (.not.allout)  then
            messg = 'not writing out data for individual paths'
            im = max(1, istrln(messg))
            call echo('           '//messg(:im))
         else
c-- for each path.................
            iexist = 0
            nqdata = min(maxpts, max(2, nqfit(id)) + 10)
            do 1000 idpath = 1, mdpths
               inpath    = jdtpth(idpath,id)
               if (inpath.eq.0)    go to 990
               jfeff     = jpthff(inpath)
               reff      = refpth(jfeff)
               degen     = degpth(jfeff)
               ixpath    = jfeff
               consts(4) = reff
c  evaluate the non-variable values
c   in case they depend on reff, local values to data set, etc
               nstart = nconst + numvar + 1
               call setval(nstart,nmathx,icdval,maxval,micode,
     $            consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
c
c     evaluate the path parameters from the values and defaults
c    (these were found in fitfun before this routine was called)
               do 500 i = 1, mpthpr
                  par(i) = decod(icdpar(1, i, inpath), micode,
     $                 consts, values, defalt(i))
 500           continue
c  evaluate chi(k) for this path
               call chipth(theamp(1,jfeff), thepha(1,jfeff), 
     $ qfeff(1,jfeff),xlamb(1, jfeff), realp(1, jfeff), mffpts, 
     $ reff, degen, par(jps02), par(jpe0), par(jpei), par(jpdpha),
     $ par(jpdelr), par(jpsig2),par(jp3rd), par(jp4th), 
     $ tranq, rm2flg, nqdata, maxpts, thiqr(1,id), thiq(1,id))
c
c---- done evaluating theoretical chi for this path
c---  documents
               juser = jdtusr(idpath, id)
               ilen  = min(40, max(1, istrln( feffil(jfeff))))
               call triml(pthlab(inpath))
               labl = min(55, max(1, istrln( pthlab(inpath))))
               if (labl.le.0) then
                  if (iffrec(jfeff).eq.0) then
                     write(outdoc(1),9440) juser,feffil(jfeff)(1:ilen),
     $                    reff, degen, nlgpth(jfeff)
                  else
                     write(outdoc(1),9445) juser,feffil(jfeff)(1:ilen),
     $                iffrec(jfeff), reff, degen, nlgpth(jfeff)
                  end if
               else
                  write(outdoc(1),9460) juser,pthlab(inpath)(1:labl)
               end if
               write(outdoc(3), 9480) par(jpe0),par(jps02),
     $              par(jpdelr),par(jpsig2)
               if (dphflg) then
                  write(outdoc(4), 9540) par(jpei), par(jp3rd),
     $                 par(jp4th), par(jpdpha)
               else
                  write(outdoc(4), 9542) par(jpei), par(jp3rd),
     $                 par(jp4th)
               end if
               if (iffrec(jfeff).eq.0) then
                  write(outdoc(jtitle),9560) feffil(jfeff)(1:ilen)
               else
                  write(outdoc(jtitle),9565) feffil(jfeff)(1:ilen),
     $                 iffrec(jfeff)
               end if
               write(outdoc(jtitle + 1),9580) reff, degen
               ntitle  = jtitle + 2
c   write out path coordinates to titles
               do 600 i = 0, nlgpth(jfeff) - 1
                  j   = ntitle + i
                  if (i.eq.0) then
                     write(outdoc(j),9620) '>', ratpth(1,i,jfeff),
     $                    ratpth(2,i,jfeff), ratpth(3,i,jfeff),
     $                    iptpth(i,jfeff), izpth(i,jfeff)
                  else
                     write(outdoc(j),9640) '>', ratpth(1,i,jfeff),
     $                    ratpth(2,i,jfeff), ratpth(3,i,jfeff),
     $                    iptpth(i,jfeff), izpth(i,jfeff)
                  end if
 600           continue
c   fill in titles with those from feff file
               ntitle  = jtitle + 1 + nlgpth(jfeff)
               idoc    = maxdoc
               do 700 i = 1, mffttl
                  j   = ntitle + i
                  if(j.le.maxdoc)  outdoc(j) = fefttl (i, jfeff )
 700           continue
c     write data output for each path even if it is a repeat
               if (frmout(1:2).ne.'uw') then
                  if (juser.lt.1000) then
                     write(outksp(ipre+3:),740)  juser
                     write(outrsp(ipre+3:),740)  juser
                     write(outenv(ipre+3:),740)  juser
 740                 format (i3.3)
                  end if
               end if
               skyk = ' '
               skyr = ' '
               skyq = ' '
               call xfsout(thiq(1,id),thiqr(1,id),frmout,vaxflg,
     $              outksp,outrsp,outenv,kspcmp,kspout,rspout,qspout,
     $              irecl(id),iexist,skyk,skyr,skyq,asccmt,mdocxx,
     $              qwindo(1,id),qweigh(id),rwindo(1,id),rweigh(id),
     $              wfftc,mftfit,rlast,q1st(id),qlast(id),
     $              pcout, qfeff(1,jffphs(id)),thepha(1, jffphs(id)), 
     $              mffpts,qgrid,idoc,outdoc)
c     write a message
               if ((skyk.eq.' ').and.(skyr.eq.' ')
     $              .and.(skyq.eq.' ')) then
                  write(messg,9130)'path ',juser,' not written '
               else
                  write(messg,9130)'path ',juser,' written to '
                  if (skyk.ne.' ') call append(messg,' chi(k) ',im)
                  if (skyr.ne.' ') call append(messg,' chi(r) ',im)
                  if (skyq.ne.' ')
     $                 call append(messg,' filtered chi(k)',im)
               end if
               im = max(1, istrln(messg))
               call echo('           '//messg(:im))
 990           continue
 1000       continue
c-------  done looping through all the paths
c  repeat message saying which files were written
            messg = 'wrote files '
            im    = 10
            if (kspout) call append(messg,' '//outksp(:jofl)//' ',im)
            if (rspout) call append(messg,' '//outrsp(:jofl)//' ',im)
            if (qspout) call append(messg,' '//outenv(:jofl)//' ',im)
            call echo('        '//messg(:im))
c-------end
         end if
         id = id + 1
         if (id.le.ndata) go to 100
8000   continue
       return
c
c     formats
 9130  format(a,i5,a)
 9280  format ('k range = [',2f6.2,']; kw=',f4.1,
     $      '; dk1,dk2 =[',2f6.2,']; window=',a)
 9300  format ('r range = [',2f6.2,']; ',i3,
     $      ' independent points in data')
 9301  format ('r range = [',2f6.2,']; ',f6.2,
     $      ' independent points in data')
 9360  format ('fit to data: skey "',a,'" in file ', a)
 9380  format ('no data was used. feff files combined without fitting')
 9410  format('feffit background:  rbkg = ',f6.3, ' n_knots = ', i3)
 9440  format('> path',i6,': ',a,'; r=',f6.3,'; n=',f6.2,'; nlegs=',i3)
 9445  format('> path',i6,': ',a,',',i5,'; r=',f6.3,'; n=',f6.2,
     $      '; nlegs=',i3)
 9460  format('> path',i5,': ',a)
 9480  format('path  : e0 =',f8.4,'; amp =',f9.4,'; delr =',
     $      f9.5,'; sigma2 =',f10.6)
 9540  format('params: ei =',f8.4,'; 3rd =',f9.6,';  4th =',f9.6,
     $      '; dphase =',f10.6)
 9542  format('params: ei =',f8.4,'; 3rd =',f9.6,';  4th =',f9.6)
 9560  format('<<< feff data file used: ',a)
 9565  format('<<< feff data file used: ',a,',',i6)
 9580  format('path:   x         y         z   ipot iz ; r_eff =',
     $      f7.4,'; n_degen=',f6.2)
 9620  format(a,1x,f9.5,1x,f9.5,1x,f9.5,2x,i2,2x,i2,8x,'absorbing atom')
 9640  format(a,1x,f9.5,1x,f9.5,1x,f9.5,2x,i2,2x,i2)
c end subroutine fitout
       end

       subroutine getfln(strin, filnam, ierr)
c  strip off the matched delimeters from string, as if getting
c  a filename from "filename", etc.
       integer idel, iend, istrln, ierr
       character*(*) strin, filnam, tmp*144, ope*8, clo*8
       data ope, clo /'"{(<''[',  '"})>'']'/
c
       ierr  = 0
       tmp   = strin
       call triml(tmp)
       ilen  = istrln(tmp)
       idel  = index(ope,tmp(1:1))
       if (idel.ne.0) then
          iend = index(tmp(2:), clo(idel:idel) )
          if (iend.le.0) then
             ierr = -1
             iend = ilen
          end if
          filnam = tmp(2:iend)
       else
          iend = index(tmp,' ') - 1
          if (iend.le.0) iend  = istrln(tmp)
          filnam = tmp(1:iend)
       end if
       return
c end  subroutine getfln
       end

       subroutine dkfcn(m,n,x,f,iflag)
c fitting function to match data mu to CL f''
c used by lmdif1, called in routine dkfit
       include "dkcom.f"
       integer m,n,iflag, i, ipos
       double precision x(n),f(m), e, fx
c
       ipos = 1
       if (f2tof1) then 
          do 100 i = 1, npts
             e    = energy(i) + x(1)
             call lintrp(energy,expdat,npts,e,ipos,fx)
             f(i) = -f2cl(i) + x(2) + x(3) * fx + x(4) * e
c             f(i) = -f2cl(i) + x(2) + x(3) * fx
c     $            + e * (x(4) + x(5)  * e )
 100      continue 
       else
          do 200 i = 1, npts
             e    = energy(i) + x(1)
             call lintrp(energy,expdat,npts,e,ipos,fx)
             f(i) = -f1cl(i) + x(2) + x(3) * fx + x(4) * e

c             f(i) = -f1cl(i) + x(2) + x(3) * fx
c     $            + e * (x(4) + x(5)  * e )
 200      continue 
       endif
       print *, 'dkfcn ' , f2tof1, npts, x
       return
       end

       subroutine fitnls
c
c    this will call lmdif1, a routine from minpack, to solve the
c    unconstrained non-linear least squares fitting problem using
c    a levenberg-marquardt algorithm. the subroutine fitfun is
c    used to evaluate the function to be minimized in the least
c    squares sense.
c
c      copyright 1993 university of washington         matt newville
c
c    the outline of this routine is:
c    1.  an estimate of the measurement uncertainty is made by
c        using the high r components of the data (unless the user
c        has overwritten this value).
c    2.  the arrays for the call to lmdif1 are setup, and the call
c        to lmdif1 is made.
c    3.  after a successful fit has been found, the uncertainties
c        in the fit parameters are estimated by assuming that the
c        errors are normally distributed, so that the correlation
c        matrix is the inverse of the curvature of parameter space
c        around the solution.
c
c--------------------------------------------------------------------
       include 'fitcom.h'

       integer lenwrk,  lenfvc, istrln, im, ier, ierr, ilen, ione
       integer lminfo, iflag, nfirst, nr1, nr2, mfit, nsigd, ix
       integer nrwght, irun, iex, id, i, istop, nrmin,nrmax, ind, ixmode
       parameter(lenwrk = 2*maxpts*(mvarys + 1)  + 20*mvarys )
       parameter(lenfvc = mdata*maxpts , ione = 1)
       integer   iwork(mvarys),nptfit(mdata),ibadx(mvarys),nfit1,nsig1
       logical   datafl, feff
       double precision work(lenwrk), fvect(lenfvc), ftemp(lenfvc)
       double precision xvarys(mvarys), fjac(lenfvc, mvarys)
       double precision alpha(mvarys, mvarys), toler, tolfac
       double precision chirhi(maxpts), sumsqr
       double precision rsmall, stmp, wtmp, xolow, xohigh
       external fitfun, sumsqr, istrln

       datafl = .false.
       tolfac = 1.d-05
       lminfo = 0
       rsmall  = rgrid * 0.01d0
c-----------------------------------------------------------------
c for phase-shifted FT's, determine which feff path to take
c the phase shift from
       if (pcout) then
          do 40 id  = 1, ndata
             jffphs(id) = 0
             do 30 ind  = 1, mdpths
                if (jdtpth(ind,id).gt.0) then
                   jffphs(id) = jpthff( jdtpth(ind,id) )
                   if (jffphs(id).gt.0) go to 35
                end if
 30          continue 
 35          continue 
 40       continue 
       end if
       if (iprint.ge.2) then
          irun = 0
          call openfl(irun, 'feffit.debug','unknown', iex, ierr)
          if (ierr.lt.0) then
             call finmsg(1002,' ','feffit.run',0)
             iprint = 1
          else
             write(irun,*)'mftfit, rgrid =',mftfit,rgrid
          end if
       end if
c
c hack by matt : ifxvar temporarily holds irun (so iprint works in fitfun)
       ifxvar = irun
c
c set up/initialize a bunch of other stuff:
c   mfit   = number of point to use in fitting
c   nrwght = # of points to use for getting measurement uncertainty
       mfit    = 0
       nr1    = int ( (rwght1 + rsmall) / rgrid )
       nr2    = int ( (rwght2 + rsmall) / rgrid )
       nrwght = nr2 - nr1 + 1
       nsigd  = 2*nrwght
c
c for each data set:
c  1 call fitfft to apply window and weighting and to do fft
c    of the data, returning chifit over the given fit range.
c    if ifft=0, chifit contains real chi(k), with only window
c               applied, but no fft.
c    if ifft=1, chifit contains chi(r). this is the default
c    if ifft=2, chifit contains backtransformed chi(k).
c  2 calculate the measurement uncertainty by calling fitfft
c    (this time doing the fft even if the fit is in k-space),
c    returning chi(r) between 15 and 25 angstroms. if the fit
c    is done in r-space, the measurement uncertainty is taken
c    as the rms value of the high-r components of chi(r), which
c    will represent the random, white noise in the data. if the
c    fit is done in k-space, the uncertainty is found from the
c    r-space value according to (see thiel, livins, stern, and
c    lewis paper on pt-pop. the result is fairly straighforward
c    fourier analysis, done by p livins, checked algebraically and
c    numerically on samples of modelled noisy data by m newville.)
c
c                                 /         pi * w'            \
c    (sigma_k)^2 = (sigma_r)^2 * | --------------------------   |
c                                 \ qgrid*( kmax^w' - kmin^w') /
c
c      where  w' = (2 * kweight + 1).
c
       do 100 id = 1, ndata
          nrmin    = int ( (rmin(id) + rsmall) / rgrid )
          nrmax    = int ( (rmax(id) + rsmall) / rgrid )
          nrpts(id)= nrmax  - nrmin + 1
          if (ifft(id).eq.1) then
             nptfit(id) = 2 * max (1, nrpts(id))
          elseif (ifft(id).eq.2) then
             nptfit(id) = 2 * max (1, nqpts(id))
          else
             nptfit(id) =     max (1, nqpts(id))
          end if
          mfit   = mfit + nptfit(id)
          if (datain(id)) then
             datafl  = .true.
             if (mod(ifft(id), 2).eq.0) then
                xolow = qmin(id)
                xohigh= qmax(id)
             else
                xolow = rmin(id)
                xohigh= rmax(id)
             end if

             if (iprint.ge.2) then
                write(irun,*) ' id, ifft(id) =', id , ifft(id)
                write(irun,*) ' nrmin, nrmax = ',nrmin,nrmax
                write(irun,*) ' nrpts, nqpts = ',nrpts(id),nqpts(id)
                write(irun,*) ' qmin , qmax  = ',qmin(id),qmax(id)
                write(irun,*) ' sample of qwindo (i,q,qwindo):'                
                do ix = 20, 60,3
                   write(irun,*) ix, ix*qgrid, qwindo(ix,id)
                end do
                write(irun,*) '  calling fitfft... '
             endif
             ixmode = 0
             call fitfft(chiq(1,id), maxpts, mftfit, wfftc, qgrid,
     $            qwindo(1,id),qweigh(id),rwindo(1,id),rweigh(id),
     $            ifft(id), ixmode,xolow,xohigh,nfit1, chifit(1,id))
cc   thepha(1,jffphs(id)),mffpts, 
c
             if (iprint.ge.2) then
                write(irun,*) ' id, ifft(id) =', id , ifft(id)
                write(irun,*) ' nrmin, nrmax = ',nrmin,nrmax
                write(irun,*) ' nrpts, nqpts = ',nrpts(id),nqpts(id)
                write(irun,*) ' qmin , qmax  = ',qmin(id),qmax(id)
             endif
c
c estimate of measurement uncertainty for fit:
c    assuming the measurement uncertainty to be white noise, and
c    that the signal dies off appreciably at reasonably large r,
c    the noise is given by the high r components of the signal. 
c    sigdtr is estimated as the rms part of the signal at high r. 
c    we most need the noise in the real and/or imaginary parts
c    of chi(r). the temp array below contains both real and 
c    imaginary parts, so its rms is too big by the sqrt(2). 
c
             if ((sigdtr(id).le.zero).and.(sigdtk(id).le.zero)) then
                call fitfft(chiq(1,id), maxpts, mftfit, wfftc, qgrid,
     $               qwindo(1,id),qweigh(id), qwindo(1,id), rweigh(id),
     $               ione, ixmode, rwght1, rwght2, nsig1, chirhi)

ccc  pcfit, qfeff(1,jffphs(id)), thepha(1,jffphs(id)),mffpts, 
                sigdtr(id) = sqrt( sumsqr(chirhi, nsig1) / nsig1)
             endif
c  find sigdtk, the measurement uncertainty for the k-space data,
c  using the formula above
c  if sigdtk was given, the sigdtr is still zero, so
c  get it by inverting the above formula
             if ((sigdtk(id).le.zero).or.(sigdtr(id).le.zero)) then
                wtmp   = 2 * qweigh(id)  + one
c#mn mar-18-98 sqrt(2) seems needed, empirically at least
                stmp   = sqrt( 2 * pi * wtmp /
     $               (qgrid * (qmax(id)**wtmp - qmin(id)**wtmp )))
c                 stmp   = sqrt ( pi * wtmp /
c      $               (qgrid * (qmax(id)**wtmp - qmin(id)**wtmp )))
                if (sigdtr(id).le.zero) sigdtr(id) = sigdtk(id)/stmp
                if (sigdtk(id).le.zero) sigdtk(id) = sigdtr(id)*stmp
             end if
          endif
          sigdtk(id) = dabs( sigdtk(id))
          sigdtr(id) = dabs( sigdtr(id))
          if (sigdtk(id).le.zero) sigdtk(id) = one
          if (sigdtr(id).le.zero) sigdtr(id) = one
c  finally, get sigdtq, again using the above formula, this
c  time using the  r-weight and r-ranges of the r->q ft
          if (sigdtq(id).le.zero) then
             wtmp   = 2 * rweigh(id)  + one
             stmp   = sqrt ( pi * wtmp /
     $            (rgrid * (rmax(id)**wtmp - rmin(id)**wtmp )))
             sigdtq(id) = sigdtr(id) / stmp
          end if
c------------------------------------------------------------
c assign weighting to use in fit based on user chosen weight (sigwgt)
c and on data uncertainty for the space to fit in
c
          sigwgt(id) = dabs( sigwgt(id))
          if (sigwgt(id).le.zero) sigwgt(id) = one
          if (ifft(id).eq.0) then
             weight(id) = sigdtk(id) * sigdtk(id) / sigwgt(id)
          elseif (ifft(id).eq.1) then
             weight(id) = sigdtr(id) * sigdtr(id) / sigwgt(id)
          elseif (ifft(id).eq.2) then
             weight(id) = sigdtq(id) * sigdtq(id) / sigwgt(id)
          endif
 100   continue

c  do some simple error checking
       mfit = min(mfit, lenfvc)
       if (numvar.gt.mfit) then
          write(messg, '(a,i3,a,i3,a)' ) 'trying to use ', numvar,
     $         ' variables for ', mfit , ' measurements'
          call finmsg(3510,messg,' ',0)
       elseif (numvar.gt.xnidp) then
          call echo( '>WARNING:  more variables than'//
     $                 ' independent measurements in data!')
       elseif (numvar.eq.inform)  then
          call echo( '>WARNING:  equal number of variables'//
     $               ' and measurements in data!')
       end if
c
       if (iprint.ge.2) then
          write(irun,*) ' ndata, mfit, numvar=',ndata, mfit, numvar
          write(irun,*) ' xnidp              = ' , xnidp
          write(irun,*) ' -------------------------------------'
       endif
c initialization for fitting:
c  the default fitting tolerance (tolfac = 1.d-5) is empirical.
c  the user can set usrtol [default = 1]  with "toler" keyword.
       toler  = usrtol * tolfac
       chisqr = zero
       istop  = 0
c get weight for chi-square:
c     chi-square = sum{1 to mfit} [ del_chi(r) / sigma ]^2
c     but chi-square should be correctly normalized, as if the
c     sum was {1 to inform} (inform = # of independent points).
c     we already got most of this above, but now we include the
c     terms mfit and inform, so that the sum is correctly normalized
c     when we actually sum over mfit points instead of inform points
       do 280  id = 1, ndata
          weight(id) = sqrt ( nptfit(id) * weight(id) / xinfo(id))
          if (iprint.ge.2) then
             write(irun,*) ' sigdtk, sigdtr =',sigdtk(id),sigdtr(id)
             write(irun,*) ' nptfit, xinfo  =',nptfit(id),xinfo(id)
             write(irun,*) ' weight, sigwgt =',weight(id),sigwgt(id)
             write(irun,*) '---------------------------------------'
             write(irun,*) '  tolfac,usrtol = ',tolfac,usrtol
          endif
 280   continue
c
c initialize variables and fit arrays
       do 420 i =1, numvar
          xvarys(i) = xguess(i)
          xfinal(i) = xguess(i)
 420   continue
       do 440 i =1, mfit
          fvect(i) = zero
 440   continue
c
c print pre - fit message
       write(messg, '(a,f6.2,a,i3,a)' ) '        fitting ',xnidp,
     $      ' independent points with ', numvar, ' variables'
       im = istrln(messg)
       call echo(messg(:im))
c
c last chance to bail (no feff files, no data file, nofit requested)
       feff = .false.
       do 450 i = 1, mfffil
          if (feffil(i).ne.' ') feff = .true.
 450   continue
       noout = noout.or.((.not.feff).and.(.not.datafl))
       if ( nofit.or.(.not.datafl).or.
     $      (numvar.le.0).or.(.not.feff)) then
          if (nofit) then
             messg  = 'no fitting will be done, as requested.'
          elseif (.not.datafl) then
             messg = 'no fitting done. no data to fit!'
          elseif (numvar.le.0) then
             numvar = 0
             messg  = 'no fitting done. no variables defined!'
          elseif (.not.feff) then
             messg  = 'no fitting done. no feff files defined!'
          end if
          im = max(1, istrln(messg))
          call echo('        '//messg(:im))
          final = .true.
          call fitfun(mfit, numvar, xvarys, fvect, istop)
          chisqr = sumsqr(fvect, mfit)
cc          final = .false.
          go to 5000
       end if
c
c do the fitting:
cc       print*, ' FITNLS  ndata = ', ndata, ', nvarys= ', numvar
       call lmdif1 (fitfun, mfit, numvar, xvarys, fvect,
     $               toler, lminfo, iwork, work, lenwrk)
c
c print post-fit message
c   lminfo key is listed in the comments to lmdif and lmdif1
          call echo('           fitting is finished.')
       if (lminfo.eq.0)  call finmsg(3530,' ',' ',lminfo)
       if ( (lminfo.ge.4).and.(lminfo.le.7)) then
          call echo('           fit gave a warning message:')
          if (lminfo.eq.4) then
             call echo('      one or more '//
     $            'variables may not affect the fit.')
          elseif (lminfo.eq.5) then
             call echo('      too many fit '//
     $            'iterations.  try again with better')
             call echo('      better guesses or '//
     $            'a simpler problem.')
          elseif ((lminfo.eq.6).or.(lminfo.eq.7)) then
             call echo('      "toler" can probably be '//
     $            'increased without a loss of')
             write(messg, '(a,e13.5)' ) '      fit quality. '//
     $            'current value is:  toler = ', usrtol
             im = istrln(messg)
             call echo(messg(:im))
          endif
       end if
c-----------------------------------------------------------
c assign variables to final values and call fitfun one more time
       if (iprint.ge.2) then
          write(irun,*) 'fitnls before error bars: i, xfinal,dx'
          do 600 i =1, numvar
             write(irun,*) i, xfinal(i),xfinal(i) - xguess(i)
 600      continue
       endif
       iflag = 0
       final = .true.
       call fitfun(mfit, numvar, xvarys, fvect, iflag)
cc       final = .false.
c
c evaluate chi-square : note that fvect is properly
c     normalized by weight in fitfun
       nfirst = 1
       do 620 id = 1, ndata
          chi2dt(id)  = sumsqr(fvect(nfirst), nptfit(id))
          if (iprint.ge.2) then
             write(irun,*) 'nfirst, nptfit(id) =',nfirst,nptfit(id)
             write(irun,*) 'id, chi2dt(id)     =', id, chi2dt(id)
          end if
          nfirst      = nptfit(id)  + nfirst
 620   continue
       chisqr = sumsqr(fvect, mfit)
       if (iprint.ge.2) then
          write(irun,*) ' after fit : chisqr = ',  chisqr
          write(irun,*) '    i , fvect(i) '
          do 640 i = 1, mfit
             write(irun,*) i, fvect(i)
 640      continue
       endif
c
cc       print*, 'fitnls: iprint = ', iprint
c estimate the uncertainties in parameters
       call fiterr(fitfun, mfit, numvar, lenfvc, mvarys, fvect,
     $      ftemp, fjac, alpha, iprint, nerstp, xvarys,
     $      delta, correl, ier, ibadx)
c
c write final fit values to common block arrays
       do 840 i = 1, numvar
          xfinal(i) = xvarys(i)
 840   continue
       if (ier.eq.0) then
          call echo('           uncertainties estimated')
       else
          ierbar = -1
          call echo('>WARNING:  uncertainties can not'//
     $         ' be estimated.  one or more ')
          call echo('        variables did not'//
     $         ' affect the fit:')
          do 880 i = 1, numvar
             if (ibadx(i).gt.0) then
                ilen = max(1, istrln(vnames(i)))
                messg = '       >>  '//vnames(i)(1:ilen) //' <<'
                call echo(messg(:ilen+15))
             end if
 880      continue
       endif
c
 5000  continue
       if (iprint.ge.2) then
          close(irun)
          iprint = 0
       endif
       return
c
c end subroutine fitnls
       end

      subroutine messag(messg)
c  write message to  standard ouput with (1x,a) format
      character*(*) messg
      write(*,'(1x,a)')   messg
      return
c end subroutine messag
      end

       subroutine getcom(prompt, iuin, commnd, files, iunit,
     $                   mfiles, nfiles)
c
c   get next command line from unit iuin, or from a command file. 
c   some rudimentary error checking is done here.
c
c   prompt     string to display when expecting input      (in)
c   iuin        default unit to read from                  (in)
c   files      array of command files to use               (in/out)
c   mfiles     max number of command files to use          (in/out)
c   commnd     next command line to execute                (out)
c
       integer mwords, ii, ipro, mfiles, nfiles
       parameter (mwords = 3) 
       character*(*)  prompt, commnd, files(mfiles) 
       character*80   line, words(mwords), errmsg, prom, stat*7
       integer        iunit(mfiles), istrln, nwords
       external       istrln
       data     stat  /'old'/
c---------------------------------------------------------------------
       call triml(prompt)
       prom   = prompt
       ipro   = istrln(prom)
       if (ipro.le.1) then
          prom = ' '
          ipro = 1
       end if
       iu0    = iuin
       if (iu0.le.0) iu0 = 5
 30    format(1x,a, '>',$)
 40    format(a)
 100   continue
c  read command from prompt (standard input)
c  or from current input command lines from an external file
       line   = ' ' 
       commnd = ' '
       if ((nfiles.lt.0).or.(nfiles.gt.mfiles))  nfiles = 0
       if (nfiles.eq.0) then
          if ((iu0.eq.5).and.(ipro.gt.1)) then
             write(*, 30) prom(1:ipro)
          end if
          read (      iu0   ,40, err = 600, end = 600) line
       else
          read(iunit(nfiles),40, err =1000, end = 500) line
       end if
c
c     check if command line is 'load filename'.
c     if so, open that file, and put it in the files stack
       call triml(line)
       call untab(line)
       nwords = mwords
       words(1) = ' '
       words(2) = ' '
       call bwords(line, nwords, words)
       if ((line.eq.' ').or.(nwords.le.0)) go to 100
       call smcase(words(1),'a')
       if ( (words(1)(1:5).eq.'load ').or.
     $      (words(1)(1:8).eq.'include ').or.
     $      (words(1)(1:6).eq.'input '))   then
          if (words(2).eq.' ') then
             call messag( ' ##>     no file name given. syntax is'//
     $                    '   include  filename ')
             go to 100
          end if
          nfiles = nfiles + 1
          if (nfiles.gt.mfiles) go to 2000
          call getfln(words(2),files(nfiles), errmsg)
          do 400 i = 1, nfiles - 1
             if (files(nfiles).eq.files(i)) go to 3000
 400      continue 
          iunit(nfiles) = 0 
          call openfl(iunit(nfiles), files(nfiles), stat, iexist, ierr)
          if (iexist.lt.0) go to 2600
          if (ierr.lt.0)   go to 2800
          go to 100
       elseif ((words(1)(1:1).eq.'*').or.(words(1)(1:1).eq.'#')) then
          commnd = ' '
          go to 100
       else
          commnd = line
       end if
       return
c
c  end-of-file for command line file: drop nfiles by 1,
c  return to get another command line
 500   continue 
       close(iunit(nfiles)) 
       nfiles = nfiles - 1
       if (nfiles.lt.0) nfiles = 0
       if (ipro.gt.1) go to 100
       commnd = 'getcom_eof'
       return
c
 600   continue 
       commnd = 'getcom_end'
       return
c
c     warning and error messages 
 1000  continue 
       call messag(' ##> error reading from "include"d file: '  )
       errmsg = files(nfiles)
       ii     = max(1, istrln(errmsg))
       call messag(' ##> '//errmsg(1:ii) )
       go to 5000
 2000  continue 
       call messag(' ##> error: too many nested "include"d files: '  )
       write(errmsg, '(1x,a,i3)') ' ##>current limit is ', mfiles
       ii     = max(1, istrln(errmsg))
       call messag(' ##> '//errmsg(1:ii) )
       go to 5000
 2600  continue 
       call messag(' ##> error: can not find "include"d file: '  )
       errmsg = files(nfiles)
       ii     = max(1, istrln(errmsg))
       call messag(' ##> '//errmsg(1:ii) )
       go to 5000
 2800  continue  
       call messag(' ##> error: can not open "include"d file: '  )
       errmsg = files(nfiles)
       ii     = max(1, istrln(errmsg))
       call messag(' ##> '//errmsg(1:ii) )
       go to 5000
 3000  continue 
       call messag(' ##> error: recursive "include" of file:')
       errmsg = files(nfiles)
       ii     = max(1, istrln(errmsg))
       call messag(' ##> '//errmsg(1:ii) )
       go to 5000
c
 5000  continue
          commnd = 'getcom_error'
          return
c     
c end  subroutine getcom
       end
       subroutine fixstr(string,str,ilen,words,wrdsor,mwords,nwords)
c  simple preparation of string for reading of keywords
       integer       ilen, mwords, nwords, i, lenp1
       integer       iexcla, iperct, ihash, ieolc, istrln
       character*(*) string, str, words(mwords), wrdsor(mwords)
c
c  fix-up string: untab, left-justify, make a lower-case version
       nwords = 0
       call untab(string)
       str   = string
       call triml(str)
       call smcase( str, 'case')
c  remove comments from str:
c   '!', '#', and '%' are end of line comments
c   '*' is a complete comment line if in col 1
       lenp1  = len(str) + 1
       iexcla = index(str,'!')
       if (iexcla.eq.0)  iexcla = lenp1
       iperct = index(str,'%')
       if (iperct.eq.0)  iperct = lenp1
       ihash  = index(str,'#')
       if (ihash.eq.0)  ihash = lenp1
       ieolc  = min(iperct,iexcla,ihash) - 1
       if ((ieolc.lt.1).or.(str(1:1).eq.'*')) ieolc = 1
       str    = str(1:ieolc)
       ilen   = max(1, istrln(str))
       if (ilen.le.2)  return
c  break string into words (up to mwords)
c  words is in lower case,   wrdsor is in original case
       do 120 i = 1, mwords
          words(i)   =  ' '
          wrdsor(i) =  ' '
 120   continue
       nwords = mwords
       call bwords(str   , nwords, words)
       call bwords(string, nwords, wrdsor)
c end  subroutine fixstr
       return
       end
       subroutine askstr(ask, str)
c
c      prompt for and return a characer string.
c      see also the routines askint, and askval.
c  inputs: 
c    ask   character string for prompt
c    str   default string to show in prompt
c  outputs:
c    str   string read in 
c  copyright 1993 university of washington     matt newville         
      character*(*) ask , str
      character*80  query , answer
      integer   i , j, k, istrln
      external istrln
      query = ask
      call triml(query)
      call triml(str)
      i    = max(1, istrln(query)    ) 
      j    = max(1, istrln(str)      )
      k    = max(1, min(80, len(str))) 
 30   format (2x,a,' [', a, ']  >',$)
      write(*, 30  ) query(1:i), str(1:j)
      read (*, '(a)', err= 50) answer
      call triml(answer)
      if (istrln(answer).ge.1) str = answer(1:k)
 50   continue
      return
c end subroutine askstr
      end
      subroutine askdp(ask, val)
c  prompt for and return a double precision number
c  inputs:
c    ask   character string for prompt 
c    val   default dp number to show in prompt
c  outputs:
c    val   dp number read in 
c  copyright 1993 university of washington     matt newville         
      character*(*) ask, answer*30 , query*80
      integer       i, istrln
      double precision   val, tmp
      external      istrln
      query = ask
      i    =  max(1, istrln(query) )
 30   format( 2x,a,' [', g16.8, ']  >',$)
      write(*, 30) query(1:i), val
      read (*, '(a)', err = 50) answer
      if ( answer.ne.' ') then
         call str2dp(answer, tmp, ierr)
         if (ierr.eq. 0 )  val = tmp
      end if
 50   continue
      return
c end subroutine askdp
      end
       subroutine askint(ask, int)
c  prompt for and return an integer.
c  inputs:
c    ask   character string for prompt 
c    int   default integer to show in prompt
c  outputs:
c    int   integer read in 
c  copyright 1993 university of washington     matt newville         
       character*(*) ask, answer*30, query*80
       integer       i, istrln, int, itmp
       external      istrln
       query = ask
       call triml(query)
       i    =  max(1, istrln(query) )
 30    format( 2x,a,' [', i4, ']  >',$)
       write(*, 30) query(1:i), int
       read (*, '(a)', err = 50) answer
       call triml(answer) 
       if (istrln(answer).ge.1) then
          call str2in(answer, itmp, ierr)
          if (ierr.eq. 0 )  int = itmp
       end if
 50    continue
       return
c end subroutine askint
       end
      character*2 function atsym (iz)
      character*2 sym(103)
      common /atsyms/ sym
      save
      atsym = 'xx'
      if ((iz.le.103).and.(iz.gt.0)) atsym = sym(iz)
      call upper(atsym(1:1))
      return
      end
c
       integer function iatsym (symin)
       character*2 sym(103), symin
       common /atsyms/ sym
       save
       call smcase(symin,sym(1))
       do 10 iatsym = 1, 103
          if (symin.eq.sym(iatsym)) return
 10    continue 
       iatsym = 0
       return
       end
c
       block data prtabl
       character*2 sym(103)
       common /atsyms/ sym
       data sym / 'h' ,'he','li','be','b' ,'c' ,'n' ,'o' ,'f' ,'ne',
     $  'na','mg','al','si','p' ,'s' ,'cl','ar','k' ,'ca','sc','ti',
     $  'v' ,'cr','mn','fe','co','ni','cu','zn','ga','ge','as','se',
     $  'br','kr','rb','sr','y' ,'zr','nb','mo','tc','ru','rh','pd',
     $  'ag','cd','in','sn','sb','te','i' ,'xe','cs','ba','la','ce',
     $  'pr','nd','pm','sm','eu','gd','tb','dy','ho','er','tm','yb',
     $  'lu','hf','ta','w' ,'te','os','ir','pt','au','hg','tl','pb',
     $  'bi','po','at','rn','fr','ra','ac','th','pa','u' ,'np','pu',
     $  'am','cm','bk','cf','es','fm','md','no','lw'/
       end

c----------------------------------------------------------------------
c          input/output routines for data files
c               for the uwxafs programs
c
c   input/output routines for data files for the uwxafs programs
c
c   copyright 1992  university of washington, seattle, washington
c   written by      matthew newville
c                   department of physics, fm-15
c                   university of washington
c                   seattle, wa   usa 98195
c   phone           (206) 543-0435
c   e-mail          newville@u.washington.edu
c
c  these routines are the basic input/output routines for getting
c  numerical and document data from files into the uwxafs programs.
c  there are currently two data formats supported:
c
c 1. 'uw' :  a binary file format known as the uwxafs file handling
c            routines. this is very efficient way to store data, and
c            can store several (191) data sets in a single file. the
c            drawback is that the files are not extremely portable.
c
c 2. 'asc':  these are column files in a format that is fairly easy
c            for anything to deal with. the files have several lines
c            of documents. if the first character of the document is
c            '#' this character will be removed. after the documents
c            is a line with minus signs for characters(3:6), then an
c            ignored line (for column labels), and then the data. up
c            to five columns are used. the expected order is:
c                  x, real(y), imag(y), ampl(y), phase(y).
c            if any column representing y is zero, the appropriate
c            value will be calculated and returned. the files in this
c            format hold only one data set, and use more memory than
c            the uwxafs files, but are portable and convenient.
c
c  other file types can be added without too much difficulty.
c  the routines listed here are:
c      inpdat : retrieve data and documents from a file
c      inpcol : retrieve data and documents from an ascii file
c      inpuwx : retrieve data and documents from a uwxafs file
c      outdat : write data and documents to a file
c      outcol : write data and documents to an ascii file
c      outuwx : write data and documents to a uwxafs file
c
c  note: the fortran input/output unit number 11 is used for all
c        unit numbers in these routines. conflicts between these
c        routines will not happen, but conflicts may arise if
c        unit = 11 indicates an open file in a calling subprogram.
c----------------------------------------------------------------------
       subroutine inpdat(filtyp, format, filnam, vax, skey, nkey,
     $      irecl, ndoc, doc, ndata, xdata, yreal, yimag, yampl, yphas)
c
c   copyright 1992  university of washington :          matt newville
c
c    retrieve data and documents from a file acording
c    to the format specified by 'format'.
c inputs:
c   filtyp    file type to open. if may be ' '
c   format    file format (uwxafs, ascii, column)
c   filnam    file name
c   vax       logical flag for being on a vax machine (binary file)
c   skey      symbolic key for record in uwxafs file
c   ndata     maximum number of elements in data arrays
c   nkey      numeric key for record in uwxafs file
c   ndoc      maximum number of document lines to get
c               note:   ndoc cannot be less than or equal to zero!
c outputs:
c   skey      symbolic key of record in uwxafs file
c   ndoc      number of document lines returned
c   doc       array of document lines
c   ndata     number of elements in data arrays
c   xdata     array of x values of data
c   yreal     array of real part of y data values
c   yimag     array of imaginary part of y data values
c   yampl     array of amplitude part of y data values
c   yphas     array of phase part of y data values
c---------------------------------------------------------------------
       implicit none
       character*(*)  filtyp, format, skey, filnam, doc(*)
       character*10   type, symkey, form, formin, errmsg*128
       double precision  xdata(*), yreal(*), yimag(*)
       double precision  yampl(*), yphas(*)
       logical    vax
       integer    irecl, ndatmx, ndocmx, ier, ilen, istrln
       integer    ndata, ndoc, nkey
       external istrln
       data      ndocmx, ndatmx  /19, 4096/
c---------------------------------------------------------------------
c some initializations
       if ((irecl.le.0).or.(irecl.ge.2048)) irecl = 512
       type = filtyp
       call triml(type)
       call upper(type)
       symkey = skey
       call triml(symkey)
       call upper(symkey)
c
c determine format of the input file
       formin = format
       call triml(formin)
       call smcase(formin, 'a')
       call testrf(filnam, irecl, form, ier)
       call smcase(form, 'a')
       if (ier.eq.-1) then
          call echo('  inpdat error: file not found  ')
       elseif (ier.eq.-2) then
          call echo('  inpdat error: unknown file format = '//formin)
       elseif (ier.eq.-3) then
          call echo('  inpdat error: poorly formatted ascii data?  ')
       elseif (ier.eq.-4) then
          call echo('  inpdat error: no data in ascii format file? ')
       end if
       if (ier.ne.0) then
          errmsg =    '    for file ' // filnam
          ilen   = istrln(errmsg)
          call fstop(errmsg(1:ilen) )
       endif
       if ((formin.ne.' ').and.(formin(1:2).ne.form(1:2))) then
          call echo('  inpdat warning: the requested format was'//
     $         ' incorrect!')
          call echo('  form    = '//form(1:5)  )
          call echo('  formin  = '//formin(1:5)  )
       end if
c  now call the appropriate routine to get the data,
c  according to the format.
       ndata = max(1, min(ndata, ndatmx) )
       ndoc  = max(1, min(ndoc , ndocmx) )
cc       print*, 'inpout: ', form(1:2)
       if (form(1:2).eq.'uw') then
          ndoc = ndocmx
          call inpuwx(type, filnam, skey, nkey, irecl, ndoc, doc,
     $         ndata, xdata, yreal, yimag, yampl, yphas )
       elseif ((form(1:2).eq.'co').or.(form(1:2).eq.'as')) then
          call inpcol(filnam, ndoc, doc,
     $         ndata, xdata, yreal, yimag, yampl, yphas )
          skey   = 'ascii'
          call upper(skey)
       else
          call echo('  inpdat error: unknown file format = '// form)
          ilen   = min(54, max(1, istrln(filnam)))
          errmsg = '                for file ' // filnam(1:ilen)
          call fstop( errmsg(1:ilen+26) )
       end if
       filtyp = type
       format = form
c
       return
c end subroutine inpdat
       end
       subroutine inpcol(filnam, ndoc, doc, ndata,
     $                   xdata, yreal, yimag, yampl, yphas)
c
c   copyright 1992  university of washington :       matt newville
c
c   open and get all information from a column file. document
c   lines are read until a line of '----', then a label line is
c   skipped and the column data are read in.  the data is read
c   and stored in the following order:
c                xdata  yreal  yimag  yampl  yphas
c inputs:
c   filnam    file name containing data
c   ndoc      maximum number of document lines to get
c   ndata     maximum number of elements in data arrays
c outputs:
c   ndoc      number of document lines returned
c   doc       array of document lines
c   ndata     number of elements in data arrays
c   xdata     array of x values of data
c   yreal     array of real part of y data values
c   yimag     array of imaginary part of y data values
c   yampl     array of amplitude part of y data values
c   yphas     array of phase part of y data values
c---------------------------------------------------------------------
       implicit none
       integer   ilen , istrln, j, i, mxword, ndoc, ndata, iounit
       integer   iexist, ierr, nwords, idoc, id
       double precision  zero 
       parameter( zero = 0.d0, mxword = 5)
       double precision  xdata(*), yreal(*), yimag(*)
       double precision  xinp(mxword), yampl(*), yphas(*)
       logical   isdat
       character*(*) filnam, doc(*)
       character*32  words(mxword), line*128, status*10, file*128
       external      istrln, isdat
c---------------------------------------------------------------------
 10    format(a)
       file = filnam
       ilen = istrln(file)
       if (ilen.le.0)  then
           call fstop( ' inpcol:  no file name given')
       end if
c  initialize buffers
       do 80 j = 1, ndoc
          doc(j) = ' '
  80   continue
       do 100 i = 1, mxword
          words(i) = '0.'
          xinp(i)  = zero
 100   continue
       do 120 j = 1, ndata
          xdata(j) = zero
          yreal(j) = zero
          yimag(j) = zero
          yampl(j) = zero
          yphas(j) = zero
 120   continue
c  open data file
      iounit = 7
      status ='old'
      call openfl(iounit, filnam, status, iexist, ierr)
      if ((iexist.lt.0).or.(ierr.lt.0)) go to 900
c
c  get documents from header: up to ndoc
c       read file header, save as document lines,
c       remove leading '#' and '%' both of which are
c       known to be extraneous comment characters.
       nwords = 5
       idoc = 0
       id   = 1
 200   continue
          read(iounit, 10, end = 950, err = 960) line
          call sclean(line)
          call triml (line)
c  if line is '----', read one more line, go read numerical data
          if (line(3:6) .eq. '----')  then
             read(iounit, 10, end = 950, err = 960) line
             call sclean(line)
             goto 400
          end if
c  remove leading '#' or '%' from line
          if ( (line(1:1).eq.'#').or.(line(1:1).eq.'%') ) then
             line(1:1) = ' '
             call triml(line)
c  if the line is all numbers, then this is data!
          elseif (isdat(line)) then
             goto 410
          end if
c  save line in doc if there's room
          if ((idoc .lt. ndoc) .and. (istrln(line).gt.0) ) then
             idoc = idoc + 1
             doc(idoc) = line
          endif
          goto 200
c
c  read numerical data
 400   continue
          nwords = 5
          read(iounit, 10, end = 600, err = 980) line
          call sclean(line)
 410      continue
          call untab(line)
          call bwords(line,nwords,words)
          if (nwords.le.1) goto 600
          do 450 i = 1, nwords
              call str2dp(words(i), xinp(i), ierr)
              if (ierr.ne.0) goto 600
 450      continue
          xdata(id) = xinp(1)
          yreal(id) = xinp(2)
          yimag(id) = xinp(3)
          yampl(id) = xinp(4)
          yphas(id) = xinp(5)
          if (id.ge.ndata) go to 610
          id = id + 1
          goto 400
 600   continue
       id    = id - 1
       if (id.lt.1) go to 950
 610   continue
       ndata = id
       if (idoc.le.0) then
          ndoc =  1
          doc(1) = 'inpdat: no document line found'
       else
          ndoc = idoc
       end if
c  make sure that all columns are filled:
c   if yampl and yphas are both zero, compute them from yreal, yimag
c   if yreal and yimag are both zero, compute them from yampl, yphas
       do 800 i = 1, ndata
          if ( ( (yampl(i).eq.zero).and.(yphas(i).eq.zero) ) .and.
     $         ( (yreal(i).ne.zero).or. (yimag(i).ne.zero) ) ) then
            yampl(i) = sqrt( yreal(i)**2 + yimag(i)**2 )
            yphas(i) = atan2( yimag(i), yreal(i) )
             if (i.gt.1) call pijump( yphas(i), yphas(i-1) )

          elseif ( (yreal(i).eq.zero).and.(yimag(i).eq.zero)
     $        .and.(yampl(i).ne.zero)   ) then
            yreal(i) = yampl(i) * cos ( yphas(i) )
            yimag(i) = yampl(i) * sin ( yphas(i) )

          end if
 800   continue
c          print*, ' inpout:'
c       do i = 1, 4
c          print*, xdata(i), yreal(i)
c       end do
c  close data file and return
       close(iounit)
       return
c error handling
c  open file - error
 900   continue
         call echo(' inpcol: error opening file '//file(1:ilen) )
         go to 990
c  end or error at reading documents
 950   continue
 960   continue
         call echo( ' inpcol: error reading file '//file(1:ilen) )
         call echo('         during reading of documents.')
         go to 990
c  error at reading numerical data
 980   continue
         call echo( ' inpcol: error reading file '//file(1:ilen) )
         call echo('         during reading of numerical data.')

 990     continue
         close(iounit)
         stop
c end error handling
c end subroutine inpcol
       end
       subroutine inpuwx(ftypin, filein, skey, nkey, irecl, ndoc,
     $           documt, ndata, xdata, yreal, yimag, yampl, yphas )
c
c   copyright 1992  university of washington :          matt newville
c
c     open and get all information from a uwxafs file
c
c inputs:
c   ftypin   file type to open, checked for compatibility, may be ' '
c   filein   file name containing data
c   skey     symbolic key for record in data file (only one of these)
c   nkey     numeric key for record in data file  (two is needed    )
c   ndoc     maximum number of document lines to get
c outputs:
c   skey      symbolic key of record in uwxafs file
c   ndoc      number of document lines returned
c   docu      array of document lines
c   ndata     number of elements in data arrays
c   xdata     array of x values of data
c   yreal     array of real part of y data values
c   yimag     array of imaginary part of y data values
c   yampl     array of amplitude part of y data values
c   yphas     array of phase part of y data values
c
c notes:
c  1   the full 'noabort' error checking is done for the calls to
c      the uwxafs routines, which means that marginally useful
c      error messages will be given when one of the uwxafs
c      filehandling routines dies.
c
c  2    currently, the following file types are supported:
c           xmu,  chi,  rsp,  env,  rspep, rip
c
c  3    uwxafs file handling routines only do single precision.
c       this routine can be made implicit double precision if the
c       array buffer is maintained as single precision:
c           implicit double precision(a-h,o-z)
c           real           buffer(maxpts)
c---------------------------------------------------------------------
       implicit none
       integer maxpts, ilen, i, ndata, iounit, irecl, istrln
       integer ier, nie, nkey, ndocln, ndoc, ndsent, nbuff, maxdoc
       double precision zero
       parameter( maxpts = 2048, zero = 0.d0 , maxdoc=20)
       character*(*)  ftypin, skey, filein, documt(*)
       character*10   type, ftype, safefl*8, abrtfl*8
       character*128  filnam, messg
       character*100  docbuf(maxdoc)

       double precision xdata(*), yreal(*), yimag(*)
       double precision yampl(*), yphas(*)
       real           buffer(maxpts)
       external   istrln
c---------------------------------------------------------------------
c initialize
 10    format(a)
 20    format(2x,2a)
 30    format(2x,a,i3)
       safefl = ' '
       abrtfl = 'noabort'
       call upper(abrtfl)

       ftype = ftypin
       filnam= filein

       call upper(skey)
       call triml(skey)
       call triml(ftype)
       call triml(filnam)
       ilen = max(1, istrln(filnam))
c note: uwxafs requires ftype to be upper case.
       call upper (ftype)
        do 100 i = 1,ndata
            xdata(i)  = zero
            yreal(i)  = zero
            yimag(i)  = zero
            yampl(i)  = zero
            yphas(i)  = zero
100    continue
       do 110 i = 1, maxpts
            buffer(i) = zero
110    continue
c  call uwxafs file handling routines:
c : open data file
       iounit = 11
       call openrf(iounit, filnam, abrtfl, safefl, ftype, irecl, ier)
       if (ier.ne.0) then
          messg = 'inpuwx: error opening file '
          call echo(messg//filnam(:ilen))
          write (messg, '(9x,a,i4)') 'openrf error code ',ier
          call fstop(messg)
       end if
c : check file type
       call gftype(iounit, type, ier)
       if (ier.ne.0) then
          messg = 'inpuwx: error getting file type for '
          call echo(messg//filnam(:ilen))
          write(messg, '(9x,a,i4)') 'gftype error code ',ier
          call fstop(messg)
       end if
       call upper(type)

       if (ftype.eq.' ') then
           ftype = type
       elseif (ftype.ne.type) then
          messg = 'inpuwx: incorrect file type for '
          call echo(messg//filnam(:ilen))
          messg = '     file type for this file is '
          call echo(messg//type)
          messg = '     file type requested was '
          call fstop(messg//ftype)
       endif
       ftypin = ftype

c : find out how many records there are in the file
       call gnie (iounit, nie, ier)
       if (nie.le.0) then
          messg = 'inpuwx:  no data records in '
          call fstop(messg//filnam(:ilen) )
       end if
c : get skey if it wasn't given as input
       if (skey.eq.' ') then
           call gskey(iounit, nkey, skey, ier)
           if (ier.ne.0) then
              messg = 'inpuwx: error getting skey for '
              call echo(messg//filnam(:ilen))
              write (messg, '(9x,a,i4)') 'gskey error code ',ier
              call fstop(messg)
           end if
           if (skey.eq.' ') then
             write (messg, '(1x,2a,i4)') 'inpuwx: found no skey ',
     $                                  'for nkey =',nkey
             call echo(messg)
             call fstop('        in file = '//filnam(:ilen))
           end if
       end if

c : get nkey if it wasn't given as input
       if (nkey.eq.0) then
           call gnkey(iounit, skey, nkey, ier)
           if (ier.ne.0) then
              messg = 'inpuwx: error getting nkey for '
              call echo(messg//filnam(:ilen))
              write (messg, '(9x,a,i4)') 'gnkey error code ',ier
              call fstop(messg)
           end if
       end if
c
c : get documents : up to ndoc
c   first check how many document lines there are
       call gdlen(iounit, nkey, ndocln, ier)
       if (ier.ne.0) then
          messg = 'inpuwx: error getting document length for '
          call echo(messg//filnam(:ilen))
          write (messg, '(9x,a,i4)') 'gdlen error code ',ier
          call fstop(messg)
       end if
       if (ndoc.gt.ndocln) ndoc = ndocln
c   then get the documents
       call getdoc(iounit, docbuf, ndoc, skey, nkey, ndsent, ier)
       do 300 i = 1, ndsent
          documt(i) = docbuf(i)
 300   continue 
       if (ier.eq.6) then
          messg = 'inpuwx error: reading file '
          call echo(messg//filnam(:ilen) )
          messg = '  no skey or nkey given to specify record, '
          call echo(messg)
          messg = '  or an incorrect skey or nkey given '
          call fstop(messg)
       elseif (ier.ne.0) then
          messg = 'inpuwx: error getting documents for '
          call echo(messg//filnam(:ilen))
          write (messg, '(9x,a,i4)') 'getdoc error code ',ier
          call fstop(messg)
       end if
       ndoc = ndsent

c : get data
       call getrec(iounit, buffer, maxpts, skey, nkey, nbuff, ier)
       if (ier.ne.0) then
          messg = 'inpuwx: error getting data for '
          call echo(messg//filnam(:ilen))
          write (messg, '(9x,a,i4)') 'getrec error code ',ier
          call fstop(messg)
       end if

c : close file
       call closrf(iounit,ier)
       if (ier.ne.0) then
          messg = 'inpuwx: error closing data file '
          call echo(messg//filnam(:ilen))
          write (messg, '(9x,a,i4)') 'closrf error code ',ier
          call fstop(messg)
       end if
c-----------------------------------------------------------------
c finished with uwxafs routines, so now sort the data into
c xdata, re(y), imag(y), ampl(y), phase(y) according to file type
c
c convert ftype to the case of this routine.
c   'case' controls the the case of this routine
       call smcase (ftype, 'case')
c- xmu: nbuff energy, then nbuff y-values
       if (ftype.eq.'xmu') then
            ndata   = nbuff/2
            do 400 i = 1, ndata
               xdata(i) = buffer(i)
               yreal(i) = buffer(ndata + i)
               yampl(i) = yreal(i)
400         continue
c-  chi: xmin, deltax, chi(kmin + i*deltak)
       elseif (ftype.eq.'chi') then
            ndata   = nbuff - 2
            do 500 i = 1, ndata
               xdata(i) = buffer(1) + (i-1)*buffer(2)
               yreal(i) = buffer(2 + i)
               yampl(i) = yreal(i)
500         continue
c-  env,rspep: kmin, deltak, phase, amplitude pairs (kmin + i*deltak)
       elseif ( (ftype.eq.'env').or.(ftype.eq.'rspep')  ) then
            ndata   = (nbuff - 1) / 2
            do 600 i = 1, ndata
               xdata(i) = buffer(1) +(i-1)*buffer(2)
               yphas(i) = buffer(2*i+1)
               yampl(i) = buffer(2*i+2)
               yreal(i) = yampl(i) * cos ( yphas(i) )
               yimag(i) = yampl(i) * sin ( yphas(i) )
600         continue
c  rsp, rip: kmin, deltak, real, imaginary pairs (kmin + i*deltak)
       elseif ( (ftype.eq.'rsp').or.(ftype.eq.'rip')  ) then
            ndata   = (nbuff - 1) / 2
            do 700 i = 1, ndata
               xdata(i) = buffer(1) +(i-1)*buffer(2)
               yreal(i) = buffer(2*i+1)
               yimag(i) = buffer(2*i+2)
               yampl(i) = sqrt( yreal(i)**2 + yimag(i)**2 )
               yphas(i) = atan2( yimag(i), yreal(i) )
                 if (i.gt.1) call pijump( yphas(i), yphas(i-1) )
700         continue
       else
          messg = 'inpuwx: unrecognized file type for '
          call echo(messg//filnam(:ilen))
          messg = '        file type for this file is '
          call fstop(messg//ftype)
       end if
       return
c end subroutine inpuwx
       end
       subroutine outdat(filtyp, format, filnam, vax,
     $     comm, skey, nkey, irecl, ndoc, ndocx, doc, 
     $     ndata, xdata, yreal, yimag, yampl, yphas, iexist)
c
c   copyright 1992  university of washington :          matt newville
c
c    write data and documents to a file acording to the
c    format specified
c inputs:
c   filtyp    file type to open, may be ' '.
c   format    file format (uwxafs, ascii, column)
c   filnam    file name
c   vax       logical flag for being on a vax machine (binary file)
c   comm      comment character for ascii output files
c   ndoc      number of document lines to write
c   ndocx     if non-zero, ndocx  document lines will be written
c               to ascii files, even if "blank" lines are needed.
c   doc       array of document lines
c   ndata     number of elements in data arrays
c   xdata     array of x values of data
c   yreal     array of real part of y data values
c   yimag     array of imaginary part of y data values
c   yampl     array of amplitude part of y data values
c   yphas     array of phase part of y data values
c   iexist    flag for whether to write redundant data to uwxafs file
c             iexist = 1 : do not write redundant data
c             iexist = 0 : do write redundant data
c outputs:
c   skey      symbolic key for record in uwxafs file
c   nkey      numeric key for record in uwxafs file
c   ndoc      number of document lines written
c
c---------------------------------------------------------------------
       implicit none
       integer ndoc, ndocx, ndata, iexist, ilen, nkey, idoc, irecl
       character*(*)  filtyp, format, filnam, skey, doc(*), comm
       character*32   type, form
       double precision xdata(*), yreal(*), yimag(*)
       double precision yampl(*), yphas(*)
       logical        vax
c---------------------------------------------------------------------
       if ((irecl.le.0).or.(irecl.ge.2048)) irecl = 512
c
       idoc = ndoc
       skey = ' '
       form = format
       type = filtyp
       call upper(type)
       call triml(type)
       call triml(form)
c convert form to the case of this routine.
c   'case' controls the the case of this routine
cc       call testrf(filnam, irecl, form, ier)
       call smcase (form, 'a')
c
       if (form(1:2).eq.'uw') then
          if ( (idoc.le.0).or.(idoc.gt.19) )  idoc = 19
          call outuwx(type, filnam, skey, nkey, irecl, idoc, doc,
     $         ndata, xdata, yreal, yimag, yampl, yphas, iexist)
       elseif ( (form(1:3).eq.'col').or.(form(1:3).eq.'asc') ) then
          call outcol(type, filnam, comm, idoc, ndocx, doc,
     $         ndata, xdata, yreal, yimag, yampl, yphas)
          skey = 'ascii'
       else
          call fstop('outdat: unknown file format = '//form)
       end if
c
       return
c end subroutine outdat
       end
       subroutine outcol(filtyp, filnam, comm, ndoc, ndocx, doc, ndata,
     $                  xdata, yreal, yimag, yampl, yphas)
c
c   copyright 1992  university of washington :          matt newville
c
c  open and write all information to a column file. document lines are
c  written, followed by a line of '----', then a label line, and then
c  the data are written.  the file type tells what to use for the label
c  and how many columns to write. it may be left blank.
c
c inputs:
c   filtyp    file type to write (may be ' ' : used for label only)
c   filnam    file name to write (' ' and '*' mean write to unit 6)
c   comm      comment character to specify title lines (up to char*2)
c   ndoc      maximum number of document lines to write
c   doc       array of document lines
c   ndocx     if non-zero, exactly ndocx doc lines will be written
c   ndata     number of elements in data arrays
c   xdata     array of x values of data
c   yreal     array of real part of y data values
c   yimag     array of imaginary part of y data values
c   yampl     array of amplitude part of y data values
c   yphas     array of phase part of y data values
c outputs:
c   ndoc      number of document lines written
c---------------------------------------------------------------------
       implicit none
       integer ndoc, ndocx, ndata, ilen, nkey, idoc, jdoc, i, istrln
       integer mxl, mxlp1, ixmsg, ierr, iexist, iounit, imsg
       double precision zero, xdata(*), yreal(*), yimag(*)
       double precision yampl(*), yphas(*)
       parameter (zero = 0.d0, mxl   = 76)
       character*(*)  filtyp, filnam, doc(*), comm
       character*80   filout, errmsg
       character*35   xmutit, chitit, lines, blank
       character*42   envt1, envt2*32, rspt1, rspt2*32, xyt1,xyt2*32
       character*10   type, status, cmt*2, cmtdef*2,contc*5
       parameter (cmtdef = '# ', contc = '  +  ')
       parameter (lines  ='-----------------------------------')
       parameter (blank  ='    empty comment line')
       parameter (xmutit ='    energy          xmu')
       parameter (chitit ='    k              chi(k)')
       parameter (envt1  ='    k          real[chi(k)]   imag[chi(k)]')
       parameter (envt2  ='   ampl[chi(k)]   phase[chi(k)]')
       parameter (rspt1  ='    r          real[chi(r)]   imag[chi(r)]')
       parameter (rspt2  ='   ampl[chi(r)]   phase[chi(r)]')
       parameter (xyt1   ='    x          real[y(x)]     imag[y(x)]')
       parameter (xyt2   ='   ampl[y(x)]     phase[y(x)]')
       external istrln
c---------------------------------------------------------------------
 20    format(2a)
 30    format(3a)
       type   = filtyp
       call triml(type)
c convert type to the case of this routine.
       call smcase(type, 'a')
       filout = filnam
       call triml(filout)
       if (ndata.le.0) ndata = 2
       if ((ndocx.gt.0).and.(ndocx.lt.ndoc))  ndoc = ndocx
c decide comment character
       cmt  = comm
       if ((cmt.eq.'  ').or.(istrln(cmt).le.0)) cmt = cmtdef
c open data file
c     if file name is ' ' or '*', write to standard output (unit 6)
       iounit = 6
       if ((filout.ne.' ').and.(filout.ne.'*')) then
          iounit = 0
          status ='unknown'
          call openfl(iounit, filout, status, iexist, ierr)
          if ((ierr.lt.0).or.(iexist.lt.0)) go to 990
       endif
c
c write documents
       jdoc  = 0
       mxlp1 = mxl + 1
       do 200 idoc = 1, ndoc
          call triml(doc(idoc))
          ilen = istrln(doc(idoc))
          if (ilen.ge.1) then
             jdoc = jdoc + 1
             if (ilen.gt.mxl) then
                write(iounit, 20) cmt,doc(idoc)(1:mxl)
                write(iounit, 30) cmt,contc,doc(idoc)(mxlp1:ilen)
             else
                write(iounit, 20) cmt,doc(idoc)(1:ilen)
             end if
          elseif (ndocx.gt.0) then
             jdoc = jdoc + 1
             write(iounit, 20) cmt, blank
          end if
 200   continue
       if (ndocx.gt.ndoc) then
          do 210 idoc = ndoc+1,ndocx
             jdoc = jdoc + 1
             write(iounit, 20) cmt, blank
 210      continue
       endif
       ndoc = jdoc
c
c  write line of minus signs and column label
       write(iounit, 30) cmt,lines,lines
       if (type.eq.'xmu') then
          write(iounit, 20) cmt,xmutit
       elseif (type.eq.'chi') then
          write(iounit, 20) cmt,chitit
       elseif (type.eq.'env') then
          write(iounit, 30) cmt,envt1,envt2
       elseif (type.eq.'rsp') then
          write(iounit, 30) cmt,rspt1,rspt2
       else
          write(iounit, 30) cmt,xyt1,xyt2
       end if
c
c  write data: some file types only write out a few columns
       if ( (type.eq.'xmu').or.(type.eq.'chi') ) then
          do 400 i = 1, ndata
             if ((yreal(i).eq.zero).and.(yampl(i).ne.zero))
     $            yreal(i) = yampl(i) * cos(yphas(i))
             write(iounit, 520) xdata(i), yreal(i)
 400      continue
       else
          do 450 i = 1, ndata
c make sure that all of re(y), im(y), amp(y), and phase(y) are known
             if ( ((yampl(i).eq.zero).and.(yphas(i).eq.zero)) .and.
     $            ((yreal(i).ne.zero).or. (yimag(i).ne.zero)) ) then
                yampl(i) = sqrt( yreal(i)**2 + yimag(i)**2 )
                yphas(i) = atan2( yimag(i), yreal(i) )
                if (i.gt.1) call pijump( yphas(i), yphas(i-1) )
             elseif ((yreal(i).eq.zero).and.(yimag(i).eq.zero)
     $               .and.(yampl(i).ne.zero) ) then
                yreal(i) = yampl(i) * cos ( yphas(i) )
                yimag(i) = yampl(i) * sin ( yphas(i) )
             end if
             write(iounit, 550) xdata(i), yreal(i), yimag(i),
     $                          yampl(i), yphas(i)
 450      continue
       end if
 520   format(2x,e13.7,3x,e13.7)
 550   format(2x,e13.7,2x,e13.7,2x,e13.7,2x,e13.7,2x,e13.7)
c
c  close data file and return
       close(iounit)
       return
 990   continue
       ilen   = max(1, istrln(filnam))
       errmsg = 'outcol: error opening file '//filnam(:ilen)
       imsg   = istrln(errmsg)
       call fstop(errmsg(:imsg))
c end subroutine outcol
       end
       subroutine outuwx(ftypin, filein, skey, nkey, irecl, ndoc, doc,
     $           ndata, xdata, yreal, yimag, yampl, yphas, iexist)
c
c     write out data and documents to a uwxafs file
c
c inputs:
c   ftypin    file type to write to, may be ' ' if filnam exists.
c   filein    file name to write to
c   skey      symbolic key of record in uwxafs file
c   ndoc      number of document lines returned
c   doc       array of document lines
c   ndata     number of elements in data arrays
c   xdata     array of x values of data
c   yreal     array of real part of y data values
c   yimag     array of imaginary part of y data values
c   yampl     array of amplitude part of y data values
c   yphas     array of phase part of y data values
c   iexist    flag for whether to write redundant data to file
c               iexist = 1 : do not write redundant data
c               iexist = 0 : do write redundant data
c
c   copyright 1992  university of washington :          matt newville
c-----------------------------------------------------------------------
       implicit none
       integer maxpts, maxdoc, nkey, irecl, ndoc, iexist, ndata,idoc
       integer ierr, iounit, ier, i, nbuff, imsg, istrln, ilen
       double precision zero
       parameter(maxpts = 2048, maxdoc = 19, zero = 0.d0)
       character*(*)  filein, ftypin, doc(*), skey
       character*10   skyout, ftype, type, filnam*128, messg*128
       character*100  docout(maxdoc), abrtfl*8, safefl*8
       double precision xdata(*), yreal(*), yimag(*)
       double precision yampl(*), yphas(*)
       real           buffer(maxpts)
c-----------------------------------------------------------------------
c initialize
 10    format(a)
       safefl = ' '
       abrtfl = 'noabort'
       call upper(abrtfl)
       skyout = ' '
       type   = ' '
       filnam = filein
       call triml(filnam)
       ilen   = max(1, istrln(filnam))
       ftype  = ftypin
       call upper(ftype)
       do 60 i = 1, maxdoc
          docout(i) = ' '
 60    continue
c output documents
       idoc = 0
 80    continue
          idoc  = idoc + 1
          if ((idoc.ge.maxdoc).or.(idoc.gt.ndoc)) then
             idoc  = idoc - 1
             go to 100
          end if
          docout(idoc) = doc(idoc)
          call triml(docout(idoc))
          go to 80
100    continue
ccccc       ndoc = idoc
c  open data file to check file type
       iounit = 11
       call openrf(iounit, filnam, abrtfl, safefl, ftype, irecl, ier)
       if (ier.ne.0) then
          messg = 'outuwx: error opening file '//filnam(:ilen)
          imsg  = max(1, istrln(messg))
          call echo(messg(:imsg))
          write(messg, '(9x,a,i3)' ) 'openrf error code ',ier
          call fstop(messg)
       end if

c  check file type
       call gftype(iounit, type, ier)
       call upper(type)
c  if file type was not given, close and the re-open data file
c           with file type just found, so we can write to file
       if (ftype.eq.' ')  then
           ftype = type
           call closrf(iounit,ier)
           call openrf(iounit, filnam, abrtfl, safefl, ftype,irecl,ier)
c  if file type was given but it was wrong, stop
       elseif (ftype.ne.type) then
          messg = 'outuwx: incorrect file type for '
          call echo(messg//filnam(:ilen))
          messg = '        file type for this file is '
          call echo(messg//type)
          messg = '        file type requested was '
          call fstop(messg//ftype)
       endif
c
c  make sure that all of re(y), im(y), amp(y), and phase(y) are known
       do 300 i = 1, ndata
          if ( ( (yampl(i).eq.zero).and.(yphas(i).eq.zero) ) .and.
     $         ( (yreal(i).ne.zero).or. (yimag(i).ne.zero) ) ) then
            yampl(i) = sqrt( yreal(i)**2 + yimag(i)**2 )
            yphas(i) = atan2( yimag(i), yreal(i) )
             if (i.gt.1) call pijump( yphas(i), yphas(i-1) )

          elseif ( (yreal(i).eq.zero).and.(yimag(i).eq.zero)
     $        .and.(yampl(i).ne.zero)   ) then
            yreal(i) = yampl(i) * cos ( yphas(i) )
            yimag(i) = yampl(i) * sin ( yphas(i) )

          end if
300    continue
c
c  put data into a single buffer according to data type
c convert ftype to the case of this routine.
c   'case' controls the the case of this routine
       call smcase(ftype, 'case')
c  usually buffer(1) and buffer(2) are xdata(1) and xdata(2) -xdata(1)
       buffer(1) = xdata(1)
       buffer(2) = xdata(2) - xdata(1)
c   xmu: nbuff energy, then nbuff y-values
       if (ftype.eq.'xmu') then
            nbuff    = 2*ndata
            do 400 i = 1, ndata
               buffer(i)         = xdata(i)
               buffer(ndata + i) = yreal(i)
400         continue
c   chi: kmin, deltak, chi(kmin + i*deltak)
       elseif (ftype.eq.'chi') then
            nbuff     = ndata + 2
            do 500 i  = 1, ndata
               buffer(2 + i)     = yreal(i)
500         continue
c   env: kmin, deltak, phase, amplitude pairs (kmin + i*deltak)
       elseif ( (ftype.eq.'env').or.(ftype.eq.'rspep') ) then
            nbuff     = 2* (ndata + 1)
            do 600 i  = 1, ndata
               buffer(2*i+1)     = yphas(i)
               buffer(2*i+2)     = yampl(i)
600         continue
c   rsp: kmin, deltak, real, imaginary pairs (kmin + i*deltak)
       elseif ( (ftype.eq.'rsp').or.(ftype.eq.'rip') ) then
            nbuff     = 2* (ndata + 1)
            do 700 i = 1, ndata
               buffer(2*i+1)     = yreal(i)
               buffer(2*i+2)     = yimag(i)
700         continue
c   other data types not yet supported
       else
          call fstop('outuwx: not able to decipher ftype ='//ftype)
       end if
c
c  generate skyout for data with hash
       call hash(buffer, nbuff, docout, idoc, skyout)

c  check if this record is already in the file,
c    and decide whether or not to write data and
c    documentation for the record to the file

       call gnkey(iounit, skyout, nkey, ier)
       if ( (iexist.eq.1).and.(nkey.ne.0) ) then
          skey = ' '
       else
          call putrec(iounit, buffer, nbuff, skyout, 0, ier)
          call putdoc(iounit, docout, idoc,  skyout, 0, ier)
          skey = skyout
       end if

       ftypin = ftype
c  close file and leave
       call closrf(iounit, ierr)
       return
c end subroutine outuwx
       end

       subroutine testrf(flnam, irecl, flform, ier)
c
c   test whether a data file can be interpreted as  uwxafs binary
c   data file or  ascii column data file.
c
c   uwxafs binary files use direct access binary files
c   with word size irecl, which is a machine dependent parameter
c
c ier = -1 : file not found
c ier = -2 : broken uwxafs file?
c ier = -3 : not uwxafs file, but can't find data.
c ier = -4 : looks like ascii, saw line  of minus signs,
c             but 2nd following line doesn't have data
c
c   copright 1994 university of washington   matt newville
c -----------------------------------------------------
      integer   i, irecl, iunit
      character*(*) flnam, flform, line*128
      integer*2    indx(4)
      logical    exist, opend, isdat, prevdt, lisdat
      external  isdat
c -----------------------------------------------------
      flform = 'none'
      ier    = -1
      iunit  = 7
 10   continue
      inquire(unit=iunit, opened = opend)
      if (opend) then
         if (iunit.gt.20) return
         iunit = iunit + 1
         go to 10
      endif
      inquire(file = flnam, exist = exist)
      if (.not.exist) return
      ier    = -2
c -----------------------------------------------------
c try reading file as a uwxafs binary file
c     which have patriotic magic numbers embedded in them
       if ((irecl.le.16).or.(irecl.ge.2048)) irecl = 512

 70    continue 
       indx(3) = 0
       indx(4) = 0
       open(iunit, file= flnam, recl = irecl, err = 80,
     $      access = 'direct', status = 'old' )
 80    continue
       read(iunit, rec=1, err = 85) (indx(i), i=1,4)
 85    continue
       if ((indx(3).eq.1776).and.(indx(4).eq.704)) then
          flform = 'uwxafs'
          ier  = 0
          go to 900
       else 
          irecl = irecl / 2
          if (irecl .gt. 32) then
             close(iunit)
             go to 70
          endif
       end if

c -----------------------------------------------------
c try to read file as ascii data file
      close(iunit)
      open(iunit, file=flnam, status='old')
      prevdt = .false.
 200  continue
         ier  = -3
         read(iunit, '(a)', end = 900, err = 900) line
         call sclean (line)
         call triml (line)
         if (line(3:6) .eq. '----') then
            ier = -4
            read(iunit, '(a)', end = 900, err = 900) line
            call sclean (line)
            read(iunit, '(a)', end = 900, err = 900) line
            call sclean (line)
            lisdat = isdat(line)
            if (lisdat ) then
               flform = 'ascii'
               ier = 0
            end if
            go to 900
         end if
c if two lines in a row have all words being numbers, it is  data
         lisdat = isdat(line)
         if (lisdat.and.prevdt)  then
            flform = 'ascii'
            ier = 0
            go to 900
         end if
         prevdt = lisdat
         go to 200
c---------------------
 900  continue
      close(iunit)
      return
c end subroutine testrf
      end

       subroutine fitprm
c
c      compute uncertainties in all values described by an
c      encoded math expression, held in integer code icdval,
c      as generated by encod and ordered by fixicd.
c
c     copyright 1995 university of washington         matt newville
c--------------------------------------------------------------------
       include 'fitcom.h'

       integer i, j, k, idp, iex, ierr, ilen, istrln
       integer nstart, id, idpath, inpath, jfeff, juser,n, idot
       character outstr*128, fil*128, stat*10
       double precision  tiny, scale, oldval, two, decod, eval
       double precision  dvdx(maxval,mvarys),   dpdx(mpthpr,mvarys)
       double precision  par(mpthpr), dpar(mpthpr), rfave, reff
       double precision  redchi, sum, dx, pold, thous, xnu, degen
       parameter (tiny = 1.0d-10, two = 2.d0)
       parameter (thous = 0.001d0)
       external  eval, istrln, decod
       data      stat, idp / 'unknown', 0/
c
       fil = 'feffit.prm'
       if (inpfil.ne.'feffit.inp') then
          call triml(inpfil)
          idot  = max(1,istrln(inpfil))
          if (index(inpfil(1:idot),'.').ne.0) then
 15          continue
             if (index(inpfil(idot:idot),'.').eq.0) then
                idot = idot - 1
                go to 15
             end if
          end if
          fil = inpfil(1:idot) //'prm'
       end if

c
       redchi =  chisqr
       xnu    = xnidp - numvar
       if (xnu.gt.0)     redchi =  chisqr / xnu
       scale = sqrt(dabs(redchi))
       call openfl(idp, fil, stat, iex, ierr)
       if (ierr.lt.0) call finmsg(1001,fil,' ',0)
       do 10 i = 1, nmathx
          delval(i) = zero
 10    continue
c
c  write preliminary message
       ilen   = max(1, istrln(versn))
       write(idp,9005) versn(1:ilen)
       write(idp,9002) '==================================='//
     $            '==================================='
c  list input data sets, titles for each
c  also, compute average r-factor
       if (ndata.eq.0) then
          write(idp,9003) 'no input data files.'
       else
          if (ndata.eq.1) then
             write(idp,9003) 'input data file:'
          else
             write(idp,9003) 'input data files:'
          endif
          rfave  = zero
          do 30 n = 1, ndata
             rfave = rfave + rfactr(n)
             if (ndata.gt.1)  write(idp,9009) '-> data set ',n
             if (datain(n)) then
                ilen = max(1, istrln(chifil(n)))
                outstr = 'input data chi file = '
     $               //chifil(n)(:ilen)//', skey = '//skey(n)
             else
                outstr = ' no input data file given'
             endif
             ilen = istrln(outstr)
             write(idp,9005) outstr(1:ilen)
c##<bkg
             if (bkgdat(n)) then
                ilen = max(1, istrln(bkgfil(n)))
                outstr = 'used bkg(k) from file = '
     $               //bkgfil(n)(:ilen)//', skey = '//skeyb(n)
                ilen = istrln(outstr)
                write(idp,9005) outstr(1:ilen)
             end if
             if (bkgfit(n)) then
                write(idp,9005) '  fitted background spline to data'
                write(idp,9905) '  with rbkg = ', rbkg(n),
     $               '  and n_knots = ',nbkg(n)
             end if
c##bkg>
 30       continue
          rfave = rfave / ndata
       end if
c then write down goodness of fit statistics
       if (ndata.gt.1)
     $      write(idp,9055) 'number of data sets           = ',ndata
       write(idp,9060) 'independent points in data    = ',xnidp
       write(idp,9055) 'number of variables in fit    = ',numvar
       write(idp,9060) 'degrees of freedom in fit     = ',xnidp -numvar
       write(idp,9035) 'r-factor of fit               = ',rfave
       if (chisqr.lt. 999 999) then
          write(idp,9035) 'chi-square                    = ',chisqr
       else
          write(idp,9036) 'chi-square                    = ',chisqr
       end if
       redchi =  chisqr
       if (xnu.gt.0) then
          redchi =  chisqr / xnu
          if (redchi.lt. 999 999) then
           write(idp,9035) 'reduced chi-square            = ',redchi
          else
           write(idp,9036) 'reduced chi-square            = ',redchi
          end if
       elseif (xnu.eq.0) then
          write(idp,9005) 'questionable fit: all independent ',
     $         'points were used in fit!'
       else
          write(idp,9005) 'invalid fit: more variables than',
     $         ' independent points !'
       end if
       write(idp,9003) ' '


c first, do best-fit and uncertainties in variables.
c pretty simple, but don't forget to rescale by redchi!
       if (numvar.le.0) write(idp,9003) '------ No Variables '

       write(idp,9002) '  uncertainties in variables and "set" values:'
       if (numvar.ge.1) then
          write(idp,9002)  '---- variables: '
          do 50 i = 1, numvar
             values(i) = xfinal(i)
             delval(i) = scale * delta(i)
             call wrtprm(idp, 0, 20, vnames(i), 0, values(i), delval(i))
 50       continue
       end if
c
c second, do the obvious constants, which have dval = zero.
       if (nconst.ge.1) then
          write(idp,9002)  '---- some obvious constants: '
          do 80 i = numvar+1, nconst+numvar
             delval(i)   = zero
             oldval    = values(i)
             values(i) = decod(icdval(1,i),micode,consts,values,oldval)
             call wrtprm(idp, 0, 20, vnames(i), 0, values(i), delval(i))
 80       continue
       end if
       nstart = nconst + numvar + 1
c
cc       print*, '##fitprm:  2'
c--------------------------------------------------------------
c here's the tricky part:
c     for the rest, we have to calculate derivatives of the
c     values with respect to the previous values.
c     this is done for each data set, with path = path 1
c     then we calculate the uncertainties in the path
c     parameters themselves.
       id        = 1
       idpath    = 1
       inpath    = jdtpth(idpath,id)
       if (inpath.le.0) go to 1000
       jfeff     = jpthff(inpath)
       ixpath    = jfeff
       if (jfeff.le.0) go to 1000
       consts(4) = refpth(jfeff)
       consts(5) = degpth(jfeff)
       if (numvar.ge.1) then
          do 200 j = 1, numvar
             dx        = max( tiny , delval(j) )
             values(j) = xfinal(j) - dx / two
             call setval(nstart,nmathx,icdval,maxval,micode,consts,
     $            mconst,values,icdloc,mlocal,mdata,ixlocl,id)
             values(j) = xfinal(j) + dx /two
             do 160 i = nstart, nmathx
                oldval    = values(i)
                values(i) = eval(icdval, maxval, micode, consts,
     $               mconst, values, oldval, icdloc,
     $               mlocal, mdata,  ixlocl,  id, i )
                dvdx(i,j) = (values(i) - oldval ) / dx
 160         continue
             values(j) = xfinal(j)
             call setval(nstart,nmathx,icdval,maxval,micode,consts,
     $            mconst,values,icdloc,mlocal,mdata,ixlocl,id)
 200      continue
       end if
c    now collect sum of squares of derivatives
c    to give delval of the set values.
       do 500 i = nstart, nmathx
          sum = zero
          if (numvar.ge.1) then
             do 480 j = 1, numvar
                sum = sum + (delval(j) * dvdx(i,j))**2
                if (j.lt.numvar) then
                   do 460 k = j+1, numvar
                      sum = sum + two  * delval(j)  * delval(k)
     $                     * dvdx(i,j) * dvdx(i,k)  * correl(j,k)
 460               continue
                end if
 480         continue
          end if
          delval(i) = sqrt(dabs ( sum ) )
 500   continue
c
c write 'em out
       write(idp,9002)  '---- more complicated set values: '
       do 900 i = nstart, nmathx
          call wrtprm(idp, 0, 20, vnames(i), 0, values(i), delval(i))
 900   continue
c
c now the path parameters
 1000  continue
       do 5000 id = 1, ndata
          if (ndata.gt.1)  write(idp,9009) ' ---------- data set ',id
          do 4000 idpath = 1, mdpths
             inpath    = jdtpth(idpath,id)
             if (inpath.eq.0)    go to 3990
             juser     =  jdtusr(idpath,id)
             write(idp,9009) '--- path: ', juser
             jfeff     = jpthff(inpath)
             if (jfeff.eq.0)     go to 3990
             reff      = refpth(jfeff)
             if (reff.le.thous)  go to 3990
             degen     = degpth(jfeff)
             ixpath    = jfeff
             consts(4) = reff
             consts(5) = degen
             if (numvar.ge.1) then
                do 1500 j = 1, numvar
                   dx        = max( tiny , delval(j) )
                   values(j) = xfinal(j) - dx / two
                   call setval(nstart,nmathx,icdval,maxval,micode,
     $        consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
                   do 1250 i = 1, mpthpr
                      par(i) = decod(icdpar(1, i, inpath), micode,
     $                     consts, values, defalt(i))
 1250              continue
                   values(j) = xfinal(j) + dx /two
                   call setval(nstart,nmathx,icdval,maxval,micode,
     $        consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
                   do 1350 i = 1, mpthpr
                      pold   = par(i)
                      par(i) = decod(icdpar(1, i, inpath), micode,
     $                     consts, values, defalt(i))
                      dpdx(i,j) = (par(i) - pold ) / dx
 1350              continue
                   values(j) = xfinal(j)
                   call setval(nstart,nmathx,icdval,maxval,micode,
     $        consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
                   do 1450 i = 1, mpthpr
                      par(i) = decod(icdpar(1, i, inpath), micode,
     $                     consts, values, defalt(i))
 1450              continue
 1500           continue
             else
                   call setval(nstart,nmathx,icdval,maxval,micode,
     $        consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
                do 1800 i = 1, mpthpr
                   par(i) = decod(icdpar(1, i, inpath), micode,
     $                  consts, values, defalt(i))
 1800           continue
             end if
c    now collect sum of squares of derivatives
c    to give delval of the path parameters
             do 2500 i = 1, mpthpr
                sum = zero
                if ((numvar.ge.1).and.(icdpar(1,1,inpath).ne.0)) then
                   do 2400 j = 1, numvar
                      sum = sum + (delval(j) * dpdx(i,j))**2
                      if (j.lt.numvar) then
                         do 2300 k = j+1, numvar
                            sum = sum + two * delval(j) * delval(k)
     $                          * dpdx(i,j) * dpdx(i,k) * correl(j,k)
 2300                    continue
                      end if
 2400              continue
                end if
                dpar(i) = sqrt(dabs ( sum ) )
 2500        continue
c print out
             do 3000 i = 1, mpthpr
                if (icdpar(1, i, inpath).ne.0) then
                   call wrtprm(idp,1,10,parnam(i),juser,par(i),dpar(i))
                end if
 3000        continue
 3990        continue
 4000     continue
 5000  continue
 8000  continue
       close(idp)

 9002  format(1x,'%', a)
 9003  format(1x,'% ', a)
 9005  format(1x,'%   ', a)
 9009  format(1x,'% ',a,i5)

 9035  format(5x,a,f14.6)
 9036  format(5x,a,e14.6)
 9055  format(5x,a,2x,i5)
 9060  format(5x,a,f11.3)

 9905  format(1x,'%   ', a,f6.3,1x,a,i3)
       return
c     end routine fitprm
       end

c Copyright Notice: FEFF6 is copyright protected software and users must
c obtain a license from the University of Washington Office of
c Technology Transfer for its use; see section V of FEFF document.

c Main Authors of FEFF5: please contact us concerning problems.
c A. L. Ankudinov, alex@phys.washington.edu      (206) 543 0435
c S. I. Zabinsky, zabinsky@phys.washington.edu   (206) 543 0435
c J. J. Rehr,     jjr@phys.washington.edu        (206) 543 8593
c R. C. Albers,   rca@nidhug.lanl.gov            (505) 665 0417

c Citations: Please cite at least one of the following articles if 
c FEFF is used in published work: 
c    1) Multiple scattering
c       J.J. Rehr and R.C. Albers, Phys. Rev. B41, 8139 (1990).
c       J.J. Rehr, S.I. Zabinsky and R.C. Albers, 
c          Phys. Rev. Let. 69, 3397 (1992).
c    2) General reference
c       J.J. Rehr, J. Mustre de Leon, S.I. Zabinsky, and R.C. Albers,
c          J. Am. Chem. Soc. 113, 5135 (1991).
c    3) Technical reference
c       J. Mustre de Leon, J.J. Rehr, S.I.  Zabinsky, and R.C. Albers,
c          Phys. Rev. B44, 4146 (1991).

       subroutine iff_log(string)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  turn logging on/off for ifeffit
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'echo.h'
       save
       character*(*)  string, str*256, defkey(2)*64
       double precision getsca , dec
       integer   iex, ier, iec, k, i, il, istrln, ndfkey
       logical   dopen, dclos
       external  istrln, getsca
       iec   = int( getsca('&screen_echo',0) )
cc       print*,'  log():  screen_echo = ' , iec, i_echo
       dopen = .false.
       dclos = .false.
       str   = string
       call bkeys(str, mkeys, keys, values, nkeys)
c
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
        ndfkey    = 1
        defkey(1) = '_un_'
        do 100 i = 1, nkeys
           k = istrln( keys(i))
           if ((values(i).eq.undef).and.(i.le.ndfkey)) then
              values(i) = keys(i)
              keys(i)   = defkey(i)
           end if
           if (keys(i).eq.'file') then 
              echo_file = values(i)
              dopen   = .true.
           elseif (keys(i).eq.'close') then
              dclos = .true.
           elseif (keys(i).eq.'_un_') then
              if (values(i).eq.'close') then
                 dclos = .true.
              else
                 echo_file = values(i)
                 dopen   = .true.
              endif
           else
              echo_file = values(1)
              dopen = .true.          
           endif
 100    continue 
c
cc        print*, ' log(): dec = ' , i_echo
c  if needed, open the log file
        il = istrln(echo_file)
        if (dclos .and. (lun_echo .ge. 1)) then 
           close(lun_echo)
cc           print*, ' closed log file ', echo_file(1:il)
           lun_echo  = -1
           echo_file = ' '
           dopen     = .false.
           i_echo = i_echo - 2
        endif
        if (dopen) then
           if (lun_echo.ge.1) then
              close(lun_echo)
              lun_echo = -1
           endif
           lun_echo = 1
           call triml(echo_file)
           call openfl(lun_echo, echo_file, 'unknown', iex, ier)
cc           print*, ' opened log file ', echo_file(1:il)
           i_echo = i_echo + 2
        end if
c
c determine what screen echo level was requested:
        dec   = i_echo * one
        call setsca('&screen_echo', dec)
        return
        end        

      subroutine iff_plot(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: main plotting routine for ifeffit: uses pgplot
c
c arguments:
c      str     command line for ifeffit                 [in]
c
c notes:
c   1. use pgplot calls to make simple 2d plots of vectors
c
c requires:  everything in ifeffit and pgplot
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save
       integer  pgopen,  i, j, k, istrln, jc, inewp, ieras
       integer  itmp, idum, mpts, ipd, ix1, ix2, nofxsp, ier
c note the mixed precision: pgplot uses single precision
       real  tlo, thi,  xpltmp, ypltmp, ynkey, xnkey, scale_key
       real  xxkey(2), yykey(2), xx(2), yy(2)
       double precision xxarr(maxpts), dxarr(maxpts)
       double precision prange_min, getsca
       real  xkey_x0, xkey_y0, xkey_yd, xkey_y1, xkey_yy
       parameter (prange_min = 1.d-8)
       character*128  xfunc, yfunc, plotf, pltdev, pltfil
       character*128  xlabel, ylabel, plabel, ptitle, name1
       character*32   tmpcol, tmpsty, pkey*32, dxfunc, dyfunc
       character*(*) str, xboxs*10, yboxs*10
       character*64  defkey(3)
       integer   idfkey, ndfkey, ii, nx1, ny1, isarr, ikey, ilkey
       logical   newdev, doplot, show_key, err_bx, err_by
       logical   xinp,yinp
       integer   iff_eval, iff_eval_re, iff_eval_in
       external  iff_eval, iff_eval_re, iff_eval_in
       external  pgopen, nofxsp, istrln, getsca
c
cc       print*, '>>> ifplot : ', str(1:60)
cc       print*, '>>> ifplot nplot = ' , nplot
c
       if (icurdev.eq.-1) call iff_plot_init(0)
       doplot = .true.
       err_bx = .false.
       err_by = .false.
       xinp   = .false.
       yinp   = .false.
       xpltmp = 0
       ypltmp = 0
       pkey   = ''
       plabel = undef
       xfunc  = undef
       yfunc  = undef
       call gettxt('plot_device',pltdev)
       call triml(pltdev)
       if ((pltdev.eq.undef).or.(pltdev.eq.' ')) pltdev = ' '
       call gettxt('plot_file',  pltfil)
       call gettxt('plot_xlabel', xlabel)
       call gettxt('plot_ylabel', ylabel)
       call gettxt('plot_title', ptitle)
       xkey_x0 = real(getsca('&plot_key_x',0))
       xkey_y0 = real(getsca('&plot_key_y0',0))
       xkey_yd = real(getsca('&plot_key_dy',0))
cc       xkey_y1 = getsca('plot_key_y1',0)
cc       call gettxt('plot_style', tmpsty)
       tmpsty = undef
       tmpcol = undef
       call gettxt('group', name1)
       newdev = .false.
c
       call bkeys(str, mkeys, keys, values, nkeys)
c
       do 50 i = 1, nkeys
          if (keys(i).eq.'reset') then
             call iff_plot_init(1)
             return
          elseif (keys(i).eq.'erase') then
             values(i) = '1'
          elseif ((keys(i).eq.'new').or.
     $            (keys(i).eq.'clear_text')) then
             nplabs = 0
             do 30 j = 1, mplabs
                pltlab(j) = undef
                pltkey(j) = ''
                xplabs(j) = 0
                yplabs(j) = 0
 30          continue
          endif
 50    continue
       jc = 0
c
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'x', 'y'
       idfkey    = 1
       ndfkey    = 2
       defkey(1) = '__x'
       defkey(2) = '__y'
c
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.
     $            (idfkey.le.ndfkey).and.(i.le.5)) then
             values(i) = keys(i)
             keys(i)   = defkey(idfkey)
             idfkey    = idfkey + 1
          end if
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then
             name1 = values(i)
             call smcase(name1,'a')
          elseif (keys(i).eq.'new')   then
             call pgeras
             nplot   = 0
             nplabs  = 0
             npmark  = 0
             nparro  = 0
             do 70 j = 1, 4
                xlim(j)  = 0
                tlim(j)  = 0
                limits(j) = .false.
 70          continue
          elseif (keys(i).eq.'x') then
             xfunc = values(i)
             xinp  = .true.
             call lower(xfunc)
          elseif (keys(i).eq.'y') then
             yfunc = values(i)
             yinp  = .true.
             call lower(yfunc)
          elseif (keys(i).eq.'__x') then
             xfunc = values(i)
             call lower(xfunc)
          elseif (keys(i).eq.'__y') then
             yfunc = values(i)
             call lower(yfunc)
          elseif (keys(i).eq.'dy') then
             dyfunc = values(i)
             call lower(dyfunc)
             err_by  = .true.
          elseif (keys(i).eq.'dx') then
             dxfunc = values(i)
             call lower(dxfunc)
             err_bx  = .true.
          elseif (keys(i).eq.'file') then
             pltfil = values(i)
          elseif (keys(i).eq.'device') then
             pltdev = values(i)
             newdev = .true.
          elseif (keys(i).eq.'erase') then
             call pgeras
             nplot  = 0
             nplabs = 0
             doplot = .false.
          elseif ((keys(i).eq.'xlabel').or.(keys(i).eq.'xtitle')) then
             xlabel = values(i)
          elseif ((keys(i).eq.'ylabel').or.(keys(i).eq.'ytitle')) then
             ylabel = values(i)
          elseif (keys(i).eq.'title') then
             ptitle = values(i)
          elseif (keys(i).eq.'text') then
             plabel = values(i)
             call sclean(plabel)
          elseif (keys(i).eq.'text_x') then
             ier = iff_eval_re( values(i), xpltmp)
          elseif (keys(i).eq.'text_y') then
             ier = iff_eval_re( values(i), ypltmp)
          elseif (keys(i).eq.'grid') then
             igrid = 1
          elseif (keys(i).eq.'nogrid') then
             igrid = 0
          elseif (keys(i).eq.'gridcolor') then
             pltcol(mcolgr) = values(i)
          elseif ((keys(i).eq.'bg').or.(keys(i).eq.'background')) then
             pltcol(mcolbg) = values(i)
          elseif ((keys(i).eq.'fg').or.(keys(i).eq.'foreground')) then
             pltcol(mcolfg) = values(i)
          elseif (keys(i).eq.'color') then
             tmpcol = values(i)
          elseif (keys(i).eq.'style') then
             tmpsty = values(i)
          elseif (keys(i).eq.'width') then
             ier = iff_eval_in(values(i), ilnwid)
          elseif (keys(i).eq.'key') then
             pkey = values(i)
          elseif (keys(i).eq.'linewidth') then
             ier = iff_eval_in(values(i), ilnwid)
          elseif (keys(i).eq.'outlinestyle') then
             ier = iff_eval_in(values(i), ilnsty)
          elseif (keys(i).eq.'charfont') then
             ier = iff_eval_in(values(i), ichrfn)
c
c axisiz   size of characters in axis labels and title
c txtsiz   size of characters in text strings and legend
c mkrsiz   size of points and other plotting markers
c
          elseif (keys(i).eq.'charsize') then
             ier    = iff_eval_re(values(i), axisiz)
             mkrsiz = axisiz
             txtsiz = axisiz
          elseif (keys(i).eq.'labelsize') then
             ier = iff_eval_re(values(i), axisiz)
          elseif (keys(i).eq.'textsize') then
             ier = iff_eval_re(values(i), txtsiz)
          elseif (keys(i).eq.'markersize') then
             ier = iff_eval_re(values(i), mkrsiz)
c
          elseif (keys(i).eq.'key_x') then
             ier = iff_eval_re(values(i), xkey_x0)
             call setsca('&plot_key_x', xkey_x0*1.d0)
          elseif (keys(i).eq.'key_y0') then
             ier = iff_eval_re(values(i), xkey_y0)
             call setsca('&plot_key_y0',xkey_y0*1.d0)
          elseif (keys(i).eq.'key_dy') then
             ier = iff_eval_re(values(i), xkey_yd)
             call setsca('&plot_key_dy', xkey_yd*1.d0)

c
          elseif (keys(i).eq.'xmin') then
             ier = iff_eval_re(values(i), xlim(1))
             limits(1)  = .true.
          elseif (keys(i).eq.'xmax') then
             ier = iff_eval_re(values(i), xlim(2))
             limits(2)  = .true.
          elseif (keys(i).eq.'ymin') then
             ier = iff_eval_re(values(i), xlim(3))
             limits(3)  = .true.
          elseif (keys(i).eq.'ymax') then
             ier = iff_eval_re(values(i), xlim(4))
             limits(4)  = .true.
          elseif ((keys(i).eq.'new').or.(keys(i).eq.'reset')) then
             continue
          elseif (k.ge.1) then
             messg = keys(i)(1:k)//'" will be ignored'
             call warn(1,' ** plot -- unknown keyword "'//messg)
          end if
 99       continue
 100   continue
c
c
       if (.not.(xinp.or.yinp)) then
          if ((nplot.eq.0) .and.
     $         (xfunc.eq.undef).and.(yfunc.eq.undef)) then
             call warn(2,' ** plot warning: nothing to plot')
             return
          else if (yfunc .eq. undef) then
             yfunc = xfunc
             xfunc = '_implicit_'
          endif
       else if (.not.xinp.and.yinp) then
             xfunc = '_implicit_'
       endif
cc       print*, ' plot: ', xinp, yinp, xfunc, yfunc

c if we have x- and y-array expressions, so let's generate these arrays
       if (doplot)  then
          if (nplot.ge.maxplt) then
             call warn(1,' ** plot -- '//
     $            ' at maximum number of plot traces')
          end if
          if ((xfunc.ne.undef).and.(yfunc.ne.undef)) then
             nplot = min(nplot + 1, maxplt)
cc             print*, ' increment nplot to  ', nplot
c
             isarr = iff_eval(yfunc,name1, xxarr,ny1)
             if (isarr.gt.0) then
                pllims(3,nplot) = xxarr(1)
                pllims(4,nplot) = xxarr(1)
                do 220 i = 1, ny1
                   plot_y(i,nplot) = xxarr(i)
                   pllims(3,nplot) = min(pllims(3,nplot),
     $                  real(xxarr(i)))
                   pllims(4,nplot) = max(pllims(4,nplot),
     $                  real(xxarr(i)))
 220            continue
                errby(nplot) = .false.
                if (err_by) then
                   errby(nplot) = .true.
                   isarr =iff_eval(dyfunc,name1,dxarr,ny1)
                   do 230 i = 1, ny1
                      plot_dy1(i,nplot) = xxarr(i) - dxarr(i)
                      plot_dy2(i,nplot) = xxarr(i) + dxarr(i)
                      pllims(3,nplot) = min(pllims(3,nplot),
     $                     real(xxarr(i)-dxarr(i)))
                      pllims(4,nplot) = max(pllims(4,nplot),
     $                     real(xxarr(i)+dxarr(i)))
 230               continue
                endif
             endif

c  if yfunc given, but xfunc is not, use previous x array or, 
c  if first trace to be plotted, simple index for x
             if (xfunc .eq. '_implicit_') then
                if (nplot .eq. 1) then
                   nx1 = ny1
                   do 250 i = 1, nx1
                      xxarr(i) = i
 250               continue
                else
                   nx1 = nplpts(nplot-1)
                   do 260 i = 1, nx1
                      xxarr(i) = plot_x(i,nplot-1)
 260               continue
                endif
                isarr = 999
             else
                isarr =iff_eval(xfunc,name1,xxarr,nx1)
             endif
             if (isarr.gt.0) then
                pllims(1,nplot) = xxarr(1)
                pllims(2,nplot) = xxarr(1)
                do 270 i = 1, nx1
                   plot_x(i,nplot) = xxarr(i)
                   pllims(1,nplot) = min(pllims(1,nplot),
     $                  real(xxarr(i)))
                   pllims(2,nplot) = max(pllims(2,nplot),
     $                  real(xxarr(i)))
 270            continue
                errbx(nplot) = .false.
                if (err_bx) then
                   isarr =iff_eval(dxfunc,name1,dxarr,nx1)
                   errbx(nplot) = .true.
                   do 280 i = 1, nx1
                      plot_dx1(i,nplot) = xxarr(i) - dxarr(i)
                      plot_dx2(i,nplot) = xxarr(i) + dxarr(i)
                      pllims(1,nplot) = min(pllims(1,nplot),
     $                     real(xxarr(i)-dxarr(i)))
                      pllims(2,nplot) = max(pllims(2,nplot),
     $                     real(xxarr(i)+dxarr(i)))
 280               continue
                endif
             endif
          endif
       endif
c
       if (nplot.eq.0) return
cc          call echo(' ** plot warning: nothing to plot')

       nplpts(nplot) = min(nx1, ny1)
       if (nplpts(nplot).le.1) then
          if (nx1.le.1) then
             call warn(2,' ** plot error: no data in x array ')
          elseif (ny1.le.1) then
             call warn(2,' ** plot error: no data in y array ')
          end if
          return
       end if
c
c determine plot limits:  my goodness, this is ugly.
c
c   first, find the real limits of the data from the arrays
       tlim(1) = pllims(1,1)
       tlim(2) = pllims(2,1)
       tlim(3) = pllims(3,1)
       tlim(4) = pllims(4,1)
       do 440 i = 2, nplot
          tlim(1) = min(tlim(1), pllims(1,i))
          tlim(2) = max(tlim(2), pllims(2,i))
          tlim(3) = min(tlim(3), pllims(3,i))
          tlim(4) = max(tlim(4), pllims(4,i))
 440   continue
       if (abs(tlim(2)-tlim(1)).le.prange_min)
     $      tlim(2) = tlim(2) + prange_min

       if (abs(tlim(4)-tlim(3)).le.prange_min)
     $      tlim(4) = tlim(4) + prange_min
c
c  let the user-selected limits override those we just found
       if (limits(1))  tlim(1) = xlim(1)
       if (limits(2))  tlim(2) = xlim(2)
c
c   and if limits(1) or limits(2)  (xmin or xmax) were set, use the
c   truncated data range to select a new set of tlim(3) & tlim(4)!
       if (limits(1).or.limits(2)) then
cc          print*, 'limits:  ', limits(1), limits(2)
cc          print*, tlim(1), tlim(2),  tlim(3), tlim(4), nplpts(1)
          ix1  = nofxsp(tlim(1), plot_x(1,1), nplpts(1))
          ix2  = nofxsp(tlim(2), plot_x(1,1), nplpts(1))
          ix1  = max(1, ix1)
          ix2  = min(nplpts(1), ix2)
cc          print*, ' ix1, ix2, nplot = ', ix1, ix2, nplot
          tlim(3) = plot_y(ix1, 1)
          tlim(4) = plot_y(ix1, 1)
          do 490 i  = 1, nplot
             ix1  = max(1,        nofxsp(tlim(1),plot_x(1,i),nplpts(i)))
             ix2  = min(nplpts(i),nofxsp(tlim(2),plot_x(1,i),nplpts(i)))
             do 470 j = ix1, ix2
                tlim(3) = min(tlim(3), plot_y(j,i))
                tlim(4) = max(tlim(4), plot_y(j,i))
 470         continue
 490      continue
       end if
c or, if they were  expliticly set, use those
       if (limits(3))  tlim(3) = xlim(3)
       if (limits(4))  tlim(4) = xlim(4)
c
c OK, now we really, really have the plot limits in tlim.  whew.
c
c plot text
       if (plabel .ne. undef) then
          nplabs = nplabs + 1
          pltlab(nplabs) = plabel
          xplabs(nplabs) = xpltmp
          yplabs(nplabs) = ypltmp
       end if
c
c plot key (legend)
       call sclean(pkey)
       ilkey = istrln(pkey)
       if ( (pkey .ne. undef).and.(pkey.ne.'').and.
     $      (pkey.ne.' ').and.(ilkey.ge.1)) then
          pltkey(nplot) = pkey
c       else
c          pltkey(nplot) = ''
       end if

c
c
c now execute the plot
c||||||
c|| pgplot-specific code
c||||||
c work over device and output file
       ipd   = max(1, istrln(pltdev))
       plotf = pltdev(1:ipd)
       if ( (pltdev(2:4).eq.'gif').or.
     $      (pltdev(2:4).eq.'png').or.
     $      (pltdev(2:4).eq.'cps').or.
     $      (pltdev(2:4).eq.'vps').or.
     $      (pltdev(2:5).eq.'vcps').or.
     $      (pltdev(2:5).eq.'tpng').or.
     $      (pltdev(2:3).eq.'ps')) then
          if (pltfil.eq.' ')  pltfil = 'ifeffit.'//pltdev(2:)
          itmp  = max(1, istrln(pltfil))
          plotf = pltfil(1:itmp)//pltdev(1:ipd)
       end if
c
c if opening a new device:
c       print*, 'iff_plot: nplot, curdev', nplot, icurdev
c       print*, 'iff_plot: newdev: ', newdev, plotf(:16),
c     $      ":", pltdev(:10),":"
c       do i = 1, mpdevs
c          print*, i, ipgdev(i), pgdevs(i)
c       enddo
cc       print*, 'PLOT newdev? ', newdev
       if (newdev) then
          ipgdev(2) = pgopen(plotf)
          icurdev   = ipgdev(2)
          call pgslct(ipgdev(2))
       else
          pltdev = ' '
          plotf  = ' '
       endif
       if (icurdev .le. 0) then
          call warn(2,' ** plot error: cannot open device:'//plotf)
          return
       end if
          
cc       print*, 'PLOT: pgpage'
       call pgpage
       call pgbbuf
       call pgask(.false.)
cc       print*, 'PLOT: raise plot'
       call iff_plotraise(1)
c set style for the most recent plot
       if (doplot) then
          if (tmpsty.ne.undef) then
             call  set_plsty(tmpsty, isty(nplot), pltsty(nplot))
          endif
c set color for the most recent plot
c icol selects the default colors for different devices
          do 520 j = 0, mctabl
             if (pltcol(j).ne.undef) call setcol(j,pltcol(j))
 520      continue

          if (tmpcol.ne.undef)  then
             call setcol(nplot, tmpcol)
             pltcol(nplot) = tmpcol
             icol(nplot)   = nplot
          endif
cc          print*,  'nplot, icol = ', nplot, icol(nplot), tmpcol
       end if
cc       if (iprint .ge. 18) then
cc          print*, 'nplot, isty, icol= ',nplot,isty(nplot),icol(nplot)
cc       end if
c "erase" the screen to fill with background color.
       call pgeras
c fill the viewport in a different color.
cc       print*, ' mcolbg = ',mcolbg
       call pgsci(mcolbg)
c set char height, width, and font
       call pgsls(ilnsty)
       call pgsch(axisiz)
       call pgscf(ichrfn)
       call pgslw(ilnwid)
       call pgvstd
       if (.not.(limits(1).or.limits(2))) then
          call pgrnge(tlim(1), tlim(2),tlo,thi)
          tlim(1) = tlo
          tlim(2) = thi
       end if
       if (.not.(limits(3).or.limits(4))) then
          call pgrnge(tlim(3), tlim(4),tlo,thi)
          tlim(3) = tlo
          tlim(4) = thi
       end if
cc       call pgswin(tlim(1), tlim(2), tlim(3), tlim(4))
c
c fill the viewport in a different color.
cc       print*, ' mcolbg = ',mcolbg
cc       call pgsci(mcolbg)
       call pgswin(tlim(1), tlim(2), tlim(3), tlim(4))

c make a colored grid
       if (igrid.eq.1)  then
          xboxs = 'g'
          call pgsci(mcolgr)
          call pgbox(xboxs, 0.0, 0, xboxs, 0.0, 0)
       end if
c
c make the main box and labels in color 1
       call pgsci(mcolfg)
       xboxs = 'bcnst1'
       yboxs = 'bcnst1'
       call pgbox(xboxs, 0.0, 0, yboxs, 0.0, 0)
       call pgmtxt('l', 3.0, 0.5, 0.5, ylabel)
       call pgmtxt('b', 3.0, 0.5, 0.5, xlabel)
       call pgmtxt('t', 0.5, 0.5, 0.5, ptitle)
c
c plot the graph.
       call pgslw(ilnwid)
       ikey = -1
       do 700 i = 1, nplot
          show_key = .false.
          mpts = nplpts(i)
          call pgsci(icol(i))
          call pgsch(mkrsiz)
          idum = isty(i)
cc
cc legend setting, with a few parameters still hardwired in!
          if (istrln(pltkey(i)).ge.1) then
             show_key = .true.
             ikey     = ikey+1
             xxkey(1) = tlim(1)+ abs(tlim(2) - tlim(1))*(xkey_x0-.05)
             xxkey(2) = tlim(1)+ abs(tlim(2) - tlim(1))*(xkey_x0-.02)
             xnkey    = tlim(1)+ abs(tlim(2) - tlim(1))*(xkey_x0)
             xkey_yy = xkey_y0- ikey*xkey_yd

             yykey(1) = tlim(3)+ abs(tlim(4) - tlim(3))*(xkey_yy)
             yykey(2) = yykey(1)
             ynkey    = tlim(3)+ abs(tlim(4) - tlim(3))*(xkey_yy-0.02)
            
          endif
c  plot according to current style
c    lines -- solid, dashed, dotted.
          if ((idum.ge.1) .and. (idum.le.4)) then
             call pgsls(isty(i))
             call pgline(mpts,plot_x(1,i), plot_y(1, i))
             if (show_key) call pgline(2,xxkey, yykey)
c
c    line + points: solid line  and a point of some style
          elseif (idum.ge.5) then
             itmp = 1
             call pgsls(itmp)
             call pgline(mpts,plot_x(1,i), plot_y(1,i))
             if (show_key) call pgline(2,xxkey, yykey)
             itmp = idum - 5
             call pgpt(mpts,plot_x(1,i), plot_y(1,i),itmp)
             if (show_key) call pgpt(2,xxkey, yykey,itmp)
c    points only:
          elseif (idum.le.0) then
             itmp = -idum
             call pgpt(mpts,plot_x(1,i), plot_y(1,i), itmp)
             if (show_key) call pgpt(2,xxkey, yykey,itmp)
          end if
c
c error bars:
          if (errby(i)) then
             call pgerry(mpts,plot_x(1,i),
     $            plot_dy1(1,i),plot_dy2(1,i),3.0)
          endif
          if (errbx(i)) then
             call pgerrx(mpts,plot_dx1(1,i),
     $            plot_dx2(1,i),plot_y(1,i),3.0)
          endif
c legend key: same size as axis labels
          if (istrln(pltkey(i)).ge.1) then
             call pgsch(txtsiz)
             call pgtext(xnkey,ynkey,pltkey(i))
          endif
 700   continue
c text labels
       call pgsci(mcolfg)
       call pgsch(txtsiz)
       do 800 i = 1, nplabs
          if (pltlab(i).ne. undef) then
             call pgtext(xplabs(i), yplabs(i), pltlab(i) )
          end if
 800   continue
c markers
       call pgsch(mkrsiz)
       do 820 i = 1, npmark
          if (imarker(i) .ge. -1000) then
             call pgsci(mrkcol(i))
             call pgpt1(xmarks(i), ymarks(i), imarker(i))
          endif
 820   continue
       call pgsci(mcolfg)
c arrow
       do 830 i = 1, nparro
          xxkey(1) = xarros(i,1)
          yykey(1) = xarros(i,2)
          xxkey(2) = xarros(i,3)
          yykey(2) = xarros(i,4)
          call pgsls(1)
          call pgsci(int(xarros(i,8)))
          if (iarrow(i) .eq. -1) then
             call pgline(2,xxkey,yykey)
          else
             call pgsch(xarros(i,7))
             call pgsah(iarrow(i),xarros(i,5),xarros(i,6))
             call pgarro(xxkey(1),yykey(1),xxkey(2),yykey(2))
          end if
 830   continue

c
c  empty plot buffer
       call pgebuf
c  overwrite plot variables
       call settxt('group',       name1)
       call settxt('plot_device', pltdev)
       call settxt('plot_file',   pltfil)
       call settxt('plot_xlabel', xlabel)
       call settxt('plot_ylabel', ylabel)
       call settxt('plot_title',  ptitle)
cc
cc if this was a hardcopy-plot, close device and hand control
cc back to default plot device
       if (icurdev .gt. 1) then
          ix1 = istrln(pltfil)
          call echo(' wrote plot file ' // pltfil(:ix1))
          call pgclos
          call pgslct(ipgdev(1))
          pgdevs(2) = ' '
          ipgdev(2) = -1
          icurdev   =  1
          plotf     =  ' '
       end if
c end subroutine iff_plot
       return
       end

       subroutine kkmclf(npts, e, finp, fout)
c  forward (f'->f'') kk transform, using  mclaurin series algorithm
c  arguments: 
c    npts   size of arrays to consider 
c    e      energy array *must be on an even grid* [npts]  (in)
c    finp   f'     array                           [npts]  (in)
c    fout   f''    array                           [npts]  (out)
c  notes  fopi = 4/pi
       implicit none
       double precision  e(*), finp(*), fout(*)
       double precision  factor, ei2, de2, fopi, zero, tiny
       parameter(fopi = 1.273239544735163d0, zero = 0.d0, tiny=1.d-20)
       integer   npts, i, j, k, ioff, nptsk
       
       if (npts.ge.2) then 
          factor = fopi * (e(npts) - e(1)) / (npts - 1)
          nptsk  = npts / 2
          do 100 i=1, npts
             fout(i) = zero
             ei2     = e(i) * e(i)
             ioff    = mod(i,2) - 1
             do 50 k = 1, nptsk
                j    = k + k + ioff
                de2  = e(j)*e(j) - ei2
                if (abs(de2).le.tiny) de2 = tiny
                fout(i) = fout(i) + finp(j) / de2
 50          continue 
             fout(i) = factor * fout(i) * e(i)
 100      continue 
       end if
       return
c end subroutine kkmclf
       end

       subroutine fitck2
c
c  this routine is part of feffit: does some  checking of math
c    expressions for path parameters for the "reasonableness"
c    of their initial values,  so that deltar is not 100.0, etc.
c  note: this needs to be called *after* the feff.dat info is read
c
c      copyright 1993 university of washington         matt newville
c----------------------------------------------------------------
       include 'fitcom.h'
       double precision  par, pmax(mpthpr), small, decod
       parameter (small = 1.d-3)
       character*20  setchr
       integer nstart, id, ipath, i, il, inpath, jfeff, juser
       external decod
c  these are the magnitudes of the upper limits for "reasonable"
c  initial values -- they're pretty darn big
       pmax(jps02)  = 1.d6
       pmax(jpe0)   = 2.d1
       pmax(jpdelr) = 5.d-1
       pmax(jpsig2) = 3.d-1
       pmax(jpei)   = 2.d1
       pmax(jpdpha) = 1.d2
       pmax(jp3rd)  = 2.d-1
       pmax(jp4th)  = 1.d-1
       pmax(9)      = 1.d0
       pmax(10)     = 1.d0
c----------------------------------------------------------------------
c  evaluate the non-variable values
c       print*, ' fitck2!!'
       nstart = nconst + numvar + 1
       do 1000 id  = 1, ndata
c    first all the "set values"
          call setval(nstart,nmathx,icdval,maxval,micode,
     $      consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
c  now test the values of the path parameters for sane guesses
c  also does error checking of whether all the path info is there, so
c  that such checks aren't needed in fitfun/fitout
          do 950 ipath = 1, mdpths
             inpath = jdtpth(ipath, id)
             if (inpath.gt.0) then
                jfeff  = jpthff(inpath)
cc                print*, ' JFEFF  = ', jfeff, inpath, ipath, id
                if (jfeff.le.0) then
                   call echo(' jfeff < 0 ')
                   jdtpth(ipath,id) = -1
                   go to 940
                end if
                juser  = jdtusr(ipath, id)
                if (refpth(jfeff).le.small) then
                   jdtpth(ipath,id) = -1
                   jpthff(inpath)   = -1
                   go to 940
                end if
                consts(4) =  refpth(jfeff)
                do 920 i = 1, mpthpr
                   par = abs(decod(icdpar(1, i, inpath),
     $                  micode, consts, values, defalt(i)))
                   if (par.gt.pmax(i)) then
                      write (messg,'(a,i3)') 'for path ',juser
                      if (ndata.gt.1) then
                         write (setchr,'(a,i3)') ' of data set ',id
                         call append(messg,setchr,il)
                      endif
cc                      print*, ' parnam: ', i,  parnam(i), par
                      call finmsg(3300,parnam(i),messg,-1)
                   end if
 920            continue
             endif
 940         continue
 950      continue
 1000  continue


       return
c  end subroutine fitck2
       end

       subroutine conv_lor(gamma, mpts, x, y, step, yout)
c
c  broaden an array with a lorentzian of width gamma
c  typically used for broadening an energy-dependent array
c 
c  arguments:
c    gamma   lorenztian width (in eV)                [in]
c    mpts    size of x,y arrays                      [in]
c    x       array of x (energy)  values             [in]
c    y       array of y (ordinate values to broaden  [in]
c    step    step size (can be zero, see note)       [in]
c    yout    broadened array y(x)                    [out]
c
c  note:
c    for the convolution to work properly, the y(x) data 
c    needs to be on an even x-grid.  this is done here, so 
c    that input data does not need to be on an even grid. 
c  
c    if step is non-zero, that will be used as the grid spacing
c    if step is zero, the grid spacing will be found from the
c    data itself, as the smallest spacing in the input x array.
c    
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1999--2001 Matthew Newville, The University of Chicago
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, or the authors appear in advertising or 
c endorsement of works derived from this software without specific 
c prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none
       include 'maxpts.h'
       integer npts, i, j, mpts, ipos, nx1
       double precision x(*), y(*), yout(*), step, st, xt
       double precision gamma, sum, factr, zero,  small
       double precision tmpy, dx, gami, ytmp(maxpts)
       double precision xtmp(maxpts), tmp(maxpts)
       parameter  (zero = 0.d0, small = 1.d-9)

       st   = step
       npts = min(maxpts,mpts)
       if (npts.le.2)  return
       gami = 4.d0/(gamma*gamma)
c
c if step is too small (ie, zero) determine it from data
       if (st.le.small)  then
	  st = abs(x(2) - x(1))
          do 100 i = 3, npts
	    xt = abs(x(i) - x(i-1))
            if (xt.ge.small) st = min(st,xt)
 100     continue
       end if
c make sure step size / npts is OK....
 105   continue 
       nx1   = 1 + int( (x(npts) - x(1) + small)  / st)
       if (nx1.gt.maxpts) then
          st = st + st
          goto 105
       endif

c linearly interpolate onto even x grid
       ipos  = 1
       do 200 i = 1, nx1
          xtmp(i) = (i-1) * st + x(1)
          call lintrp(x, y, npts, xtmp(i), ipos, ytmp(i))
 200   continue 
c
c convolve
       do 500 i = 1, nx1
          sum  = zero
          tmpy = zero
          do 400 j = 1, nx1
             dx    = xtmp(j) - xtmp(i)
             factr = 1 / ( 1 + dx * dx  * gami)
             sum   = sum  + factr
             tmpy  = tmpy + ytmp(j) *  factr
 400      continue 
          tmp(i) = tmpy / max(small, sum)
 500   continue 
c
c put result back on input x-array
       ipos = 0
       do 700 i = 1, npts
          call lintrp(xtmp, tmp, nx1, x(i), ipos, yout(i))
 700   continue 
c
       return
       end

       subroutine conv_gau(gamma, mpts, x, y, step, yout)
c
c  broaden an array with a gaussian of width gamma
c  typically used for broadening an energy-dependent array
c 
c  arguments:
c    gamma   lorenztian width (in eV)                [in]
c    mpts    size of x,y arrays                      [in]
c    x       array of x (energy)  values             [in]
c    y       array of y (ordinate values to broaden  [in]
c    step    step size (can be zero, see note)       [in]
c    yout    broadened array y(x)                    [out]
c
c  note:
c    for the convolution to work properly, the y(x) data 
c    needs to be on an even x-grid.  this is done here, so 
c    that input data does not need to be on an even grid. 
c  
c    if step is non-zero, that will be used as the grid spacing
c    if step is zero, the grid spacing will be found from the
c    data itself, as the smallest spacing in the input x array.
c    
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1999--2001 Matthew Newville, The University of Chicago
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, or the authors appear in advertising or 
c endorsement of works derived from this software without specific 
c prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none 
       include 'maxpts.h'
       integer npts, i, j, mpts, ipos, nx1
       double precision x(*), y(*), yout(*), step, st, xt
       double precision gamma, sum, factr, zero,  small
       double precision tmpy, dx, gami, ytmp(maxpts)
       double precision xtmp(maxpts), tmp(maxpts)
       parameter  (zero = 0.d0, small = 1.d-12)

       st   = step
       npts = min(maxpts,mpts)
       if (npts.le.2)  return
       gami = 1.d0/(2*gamma*gamma)
c
c if step is too small (ie, zero) determine it from data
       if (st.le.small)  then
	  st = abs(x(2) - x(1))
          do 100 i = 3, npts
	    xt = abs(x(i) - x(i-1))
            if (xt.ge.small) st = min(st,xt)
 100     continue
       end if
c make sure step size / npts is OK....
 105   continue 
       nx1   = 1 + int( (x(npts) - x(1) + small)  / st)
       if (nx1.gt.maxpts) then
          st = st + st
          goto 105
       endif
c
c linearly interpolate onto even x grid
       ipos  = 1
       do 200 i = 1, nx1
          xtmp(i) = (i-1) * st + x(1)
          call lintrp(x, y, npts, xtmp(i), ipos, ytmp(i))
 200   continue 
c
c convolve
       do 500 i = 1, nx1
          sum  = zero
          tmpy = zero
          do 400 j = 1, nx1
             dx    = xtmp(j) - xtmp(i)
             factr = exp(-gami*dx*dx)
             sum   = sum  + factr
             tmpy  = tmpy + ytmp(j) *  factr
 400      continue 
          tmp(i) = tmpy / max(small, sum)
 500   continue 
c
c put result back on input x-array
       ipos = 0
       do 700 i = 1, npts
          call lintrp(xtmp, tmp, nx1, x(i), ipos, yout(i))
 700   continue 
c
       return
       end
    
       subroutine do_gauss(x,mpts,cen,wid,out)
c
c  simple calculation of true gaussian function on input
c  array x
c    gauss(x,cen,wid) = 1/[wid*sqrt(2pi)] * exp[-(x-cen)^2/(2*wid^2)]
c 
c  arguments:
c    x       array of x values             [in]
c    mpts    size of x,y arrays            [in]
c    cen     centroid of gaussian          [in]
c    wid   width of gaussian             [in]
c    out     array of output values        [out]
c    
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1999--2001 Matthew Newville, The University of Chicago
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, or the authors appear in advertising or 
c endorsement of works derived from this software without specific 
c prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none 
       include 'maxpts.h'
       integer npts, i, j, mpts
       double precision x(*), out(*), cen, wid
       double precision one,small,scale, escal, s2pi
       parameter (one  = 1.d0, small = 1.d-12)
c s2pi = 1 / sqrt(2*pi)
       parameter (s2pi = 0.3989422804014327d0)

c
       wid   =  max(small, wid)
       scale =  s2pi/ wid 
       escal = -one / (2 * wid * wid)
       do 100 i = 1, mpts
          out(i) = scale * exp(escal*(x(i) - cen)*(x(i) - cen))
 100   continue 
c
       return
       end
     
       subroutine do_loren(x,mpts,cen,wid,out)
c
c  simple calculation of true lorenztian function on input
c  array x
c    loren(x,cen,wid) = wid/(2*pi) * [ (x-cen)^2 + (wid/2)^2]^(-1)
c 
c  arguments:
c    x       array of x values             [in]
c    mpts    size of x,y arrays            [in]
c    cen     centroid of lorentzian        [in]
c    wid     width of lorentzian           [in]
c    out     array of output values        [out]
c    
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1999--2001 Matthew Newville, The University of Chicago
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, or the authors appear in advertising or 
c endorsement of works derived from this software without specific 
c prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none 
       include 'maxpts.h'
       integer npts, i, j, mpts
       double precision x(*), out(*), cen, wid
       double precision four, small,scale, wid2, pi, pi2
       parameter (four = 4.d0, small = 1.d-12)
       parameter (pi   = 3.141592653589793d0)
       parameter (pi2  = 2.d0 * pi)
c
c    loren(x,cen,wid) = wid/(2*pi) * [ (x-cen)^2 + (wid/2)^2]^(-1)

       wid   = max(small, wid)
       scale = wid / pi2
       wid2  = wid * wid / four
       do 100 i = 1, mpts
          out(i) = scale / ((x(i)-cen)*(x(i)-cen) + wid2)
 100   continue 
c
       return
       end
     
       subroutine do_pvoight(x,mpts,cen,fwhm,frac,out)
c
c  simple calculation of pseudo-voight as weighted sum
c  of lorenztian and gaussian functions
c   voight(x,cen,wid,frac) = frac *loren(x,cen,wid) +
c                           (1-frac)*gauss(x,cen,wid)
c 
c  arguments:
c    x       array of x values             [in]
c    mpts    size of x,y arrays            [in]
c    cen     centroid of loren/gauss       [in]
c    wid     width of loren/gauss          [in]
c    frac    fraction for lorentzian       [in]
c    out     array of output values        [out]
c    
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1999--2001 Matthew Newville, The University of Chicago
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, or the authors appear in advertising or 
c endorsement of works derived from this software without specific 
c prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
       implicit none 
       include 'maxpts.h'
       integer npts, i, j, mpts
       double precision x(*), out(*), cen, fwhm, frac
       double precision  tmp(maxpts), sig, conv
c   conv = 1/ (2 * sqrt(2*log(2)))
       parameter (conv = 0.424660900144d0)
       
       sig = fwhm * conv
       call do_loren(x,mpts,cen,fwhm,out)
       call do_gauss(x,mpts,cen,sig,tmp)
       do 100 i = 1, mpts
          out(i) = frac*out(i) + (1-frac)*tmp(i)
 100   continue 
c
       return
       end
     

       program ifftest1
c
c      basic testsuite of ifeffit functionality
       integer ifeffit, iffgetsca, iffputsca, iffgetarr
       integer i, j, ntest, ret, npts, npts2, nkeys
       parameter (mkeys=12)
       character*128 str1,  values(mkeys)
       character*64  keys(mkeys)

       double precision x, xarr(2048)
       external ifeffit, iffgetsca, iffputsca, iffgetarr

       print*, '==  IFEFFIT test suite: Fortran version == '
cc test 1:  load library
       j = 1
       print*, '=Test ',j,': load library'
       ret = ifeffit(' ')
       if (ret.ne.0) goto 500
       print*, '=Passed Test #', j
cc
cc test 2: 
       j = j+1 
       print*, '=Test ',j,': basic data types (scalar, array, string):'
c 2a: iffgetsca
       ret = ifeffit(' set x = 1.234')
       if (ret.ne.0) goto 500
       ret = iffgetsca('x',x)
       if (abs(x - 1.234d0).ge.1.d-7) goto 500
       print*, '    get scalar from ifeffit with iffgetsca OK'
c 2b: iffputsca
       x = 3.68d-2
       ret = iffputsca('yvar', x)
       if (ret.ne.0) goto 500
       ret = iffgetsca('yvar',x)
       if (abs(x - 3.68d-2).ge.1.d-7) goto 500
       print*, '    put scalar into ifeffit with iffputsca OK'
c 2c: iffgetarr
       ret = ifeffit(' set my.arr  = indarr(100)')
       ret = ifeffit(' set my.arr2 = sqrt(my.arr)')
       if (ret.ne.0) goto 500
       npts = iffgetarr('my.arr',xarr)
       if (npts.ne.100) goto 520
       if (abs(xarr(1) - 1.d0).ge.1.d-7) goto 500
       if (abs(xarr(2) - 2.d0).ge.1.d-7) goto 500
       if (abs(xarr(10) - 10.d0).ge.1.d-7) goto 500
       print*, '    get array  from ifeffit with iffgetarr OK'
c 2d: strings
       ret = ifeffit(' set $str = "i am a string"')
       ret = iffgetstr('str',str1)
ccc       print*, ' ret = ', ret, str1(1:13)
       if (str1(1:13).ne.'i am a string') goto 500
       print*, '    get string from ifeffit with iffgetstr OK'
       print*, '=Passed Test #', j

cc
cc test 3: 
       j = j+1 
       print*, '=Test ',j,': basic data manipulation'
       ret = ifeffit(' set x   = 5.0')
       ret = ifeffit(' def phi = (sqrt(x)-1) /2 ')
       ret = iffgetsca('phi',x)
       if (abs(x - 0.618033989).ge.1.d-7) goto 510

       ret = ifeffit(' set x = 4.0')
       ret = iffgetsca('phi',x)
       if (abs(x - 0.5).ge.1.d-7) goto 510

       print*, '    scalar manipulation  OK'

       ret  = ifeffit(' set my.arr  = indarr(100)')
       ret  = ifeffit(' def my.arr2 = sqrt(my.arr)')
       npts = iffgetarr('my.arr2',xarr)
       if (npts.ne.100) goto 520
       if (abs(xarr(2)   - sqrt(2.d0)).ge.1.d-7) goto 510
       if (abs(xarr(64)  -       8.d0).ge.1.d-7) goto 510

       ret  = ifeffit(' def my.arr2 = my.arr / 3.')
       npts = iffgetarr('my.arr2',xarr)
       if (npts.ne.100) goto 520
       if (abs(xarr(3)   -  1.d0).ge.1.d-7) goto 510
       if (abs(xarr(60)  - 20.d0).ge.1.d-7) goto 510

       print*, '    array manipulation  OK'
       print*, '=Passed Test #', j
cc
cc test 4: 
       j = j+1 
       print*, '=Test ',j,': datafile read/write'
       ret = ifeffit('read_data(file=cu.xmu, group=cu,'//
     $               'label="energy xmu")')
       npts  = iffgetarr('cu.energy',xarr)
       npts2 = iffgetarr('cu.xmu',xarr)
       if ((npts.ne.612) .or. (npts2.ne.612)) goto 520
       print*, '    read arrays from cu.xmu OK'

       ret = ifeffit('write_data(file=cu_out.xmu, cu.energy, '//
     $               'cu.xmu, $cu_title*)')
       if (ret.ne.0) goto 500
       print*, '    wrote cu_out.xmu OK'
       ret = ifeffit('read_data(file=cu_out.xmu, group=cu_out,'//
     $               'label="energy xmu")')
       npts  = iffgetarr('cu.energy',xarr)
       if ((npts.ne.612) .or. (npts2.ne.612)) goto 520
       print*, '    was able to re-read cu_out.xmu OK'
       print*, '=Passed Test #', j
cc
cc test 5: 
       j = j+1 
       print*, '=Test ',j,': commandline basics and macros'
       ret = ifeffit (' set (a = ')
       if (ret.ne.-1) goto 500
       ret = ifeffit (' 13)')
       if (ret.ne.0) goto 500
       ret = iffgetsca('a',x)
       if (abs(x - 13.d0).ge.1.d-7) goto 510
       print*, '    can do continuation line OK'
       ret = ifeffit (' macro xx ')
       if (ret.ne.-2) goto 500
       ret = ifeffit (' y_xx = 10.2 ')
       if (ret.ne.-2) goto 500
       ret = ifeffit (' end macro ')
       if (ret.ne.0) goto 500
       print*, '    can define a macro OK'
       ret = ifeffit (' set y_xx = 9 ')
       ret = ifeffit (' xx ')
       ret = iffgetsca('y_xx',x)
       if (abs(x - 10.2d0).ge.1.d-7) goto 510
       print*, '    can execute a macro OK'
cc
cc test 6: 
       j = j+1 
       print*, '=Test ',j, ': information retrieval' 
       print*, ' -->  "show @arrays": '
       ret = ifeffit (' show @arrays')
       if (ret.ne.0) goto 500

       print*, ' -->  "show @groups": '
       ret = ifeffit (' show @groups')
       if (ret.ne.0) goto 500
       print*, ' -->  "show @group=cu": '
       ret = ifeffit (' show @group=cu')
       if (ret.ne.0) goto 500       
       print*, ' -->  "show @scalars":'
       ret = ifeffit (' show @scalars')
       if (ret.ne.0) goto 500       
       
       print*, '=Passed Test #', j

cc
cc test 6: 
       j = j+1 
       print*, '=Test ', j,' : background subtraction '
       ret = ifeffit('spline(cu.energy, cu.xmu,rbkg=1.0,kweight=1)')
       if (ret.ne.0) goto 500
       ret = iffgetsca('rbkg',x)
       print*, ' rbkg ', x
       if (abs(x - 1.d0).ge.1.d-1) goto 510
       ret = iffgetsca('e0',x)
       print*, ' e0 ', x
       if (abs(x - 8977.d0).ge.3.d0) goto 510
       ret = iffgetsca('edge_step',x)
       print*, ' edge_step ', x
       if (abs(x - 2.12d0).ge.1.d-1) goto 510
c  check array sizes
       npts = iffgetarr('cu.bkg',xarr)
       if (npts.lt.400)  goto 520
       npts2 = iffgetarr('cu.xmu',xarr)
       if (npts2.ne.npts)  goto 520
c
       npts = iffgetarr('cu.k',xarr)
       if (npts.lt.400)  goto 520
       npts2 = iffgetarr('cu.chi',xarr)
       if (npts2.ne.npts)  goto 520
       ret  = ifeffit('show @arrays')
       print*, '    can do background subtraction OK'


c parse test

       str1 = 'x =13.214, File = B.dat, Verbose,'//
     $      ' sig = sqrt(A + min(b,c)) '
       
       nkeys = 9
       call bkeys(str1, mkeys, keys, values, nkeys)

       print*, '=Parse Test: parge arg list:'
       print*, ' arg = ', str1
       print*, 'nkeys = ', nkeys
       do i =1, nkeys
          print*, i, keys(i)(1:30)
          print*, values(i)(1:70)
       enddo

cc test : 
       j = j+1 
       print*, '=Final Test: can quit ifeffit'
       ret = ifeffit('quit')
       if (ret.ne.1) goto 500     
       print*, '=Passed Test #', j         
       print*, '==All Tests Passed.'
       go to 700
 500   continue 
       print*, '*** error: bad return value from ifeffit() ', ret
       goto 600
 510   continue
       print*, '*** error: bad numerical value '
       goto 600 
 520   continue 
       print*, '*** error: wrong number of points for array'
       goto 600 
 600   continue 
       print*, '==Failed Test # ', j
 700   continue
       end

       subroutine iff_diffkk(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: do a differential Kramers-Kronig transform
c arguments:
c      str     command line to performd                 [in]
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'spline.h'
       save
       character*(*)     str
       character*256     path, defkey(3)*64
       character*256     en_arr, f2_arr, name1
       double precision  a_e(maxpts), tmpx(maxpts)
       double precision  a_f1(maxpts), a_f2(maxpts)
       double precision  ewid, estep
       logical   do_f1, do_f2
       integer   jen, jf,  ier, i, k, istrln, ilen
       integer   ndfkey, npts, iret, iz, jdot
       integer  iff_eval, iff_eval_dp, iff_eval_in
       integer  clcalc
       external iff_eval, iff_eval_dp, iff_eval_in
       external istrln, clcalc
c
       call iff_sync
       call gettxt('&install_dir', path)
       call warn(2, ' WARNING: diffkk is not working correctly ')

       estep = one
       do_f1 = .true.
       do_f2 = .false.
       ilen  = istrln(path)
       path  = path(1:ilen)//'/cldata/'
       ilen  = istrln(path) 
       iz    = 1
       name1 = undef
       do i = 1, maxpts
          a_e(i)  = zero
          a_f1(i) = zero
          a_f2(i) = zero
       enddo 
       ewid = zero

       call bkeys(str, mkeys, keys, values, nkeys)

       ndfkey    = 2
       defkey(1) = 'iz'
       defkey(2) = 'energy'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'iz').or.(keys(i).eq.'z'))  then
             ier = iff_eval_in(values(i),iz)
          elseif (keys(i).eq.'group') then
             name1 = values(i)
          elseif (keys(i).eq.'width') then
             call str2dp(values(i),ewid, ier)
          elseif (keys(i).eq.'do_f1') then
             call str2lg(values(i),do_f1, ier)
          elseif (keys(i).eq.'do_f2') then
             call str2lg(values(i),do_f2, ier)
          elseif (keys(i).eq.'energy') then
             en_arr = values(i)
             call lower(en_arr)
          elseif (keys(i).eq.'f2') then
             f2_arr = values(i)
             call lower(f2_arr)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** diffkk: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names
       if (name1.eq.undef) then
          jdot = index(en_arr,'.')
          if (jdot.ne.0) name1 = en_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' diffkk: can''t determine group name')
          return             
       endif
       call fixnam(name1,1)
       call lower(name1)
       jdot = istrln(name1)
       jen  = iff_eval(en_arr, name1, a_e,  npts)
       jen  = iff_eval(f2_arr, name1, a_f2, npts)
       if ((npts.ge.1) .and. (iz.ge.4)) then 
cc          iret = clcalc(iz, path, npts, a_e, a_f1, a_f2)
          call kkmclr(npts, a_e, a_f2, a_f1)
       endif
c
c  make array of f1
       if (do_f1) then 
          if (ewid.gt.zero) then
             call conv_lor(ewid, npts, a_e, a_f1,estep,tmpx)
             call set_array('f1', name1, tmpx, npts, 1)
          else
             call set_array('f1', name1, a_f1, npts, 1)
          endif
       endif
c
c  make array of f2
       if (do_f2) then 
          if (ewid.gt.zero) then
             call conv_lor(ewid, npts, a_e, a_f2,estep,tmpx)
             call set_array('f2', name1, tmpx, npts, 1)
          else
             call set_array('f2', name1, a_f2, npts, 1)
          endif
       endif
c
c
       return
c end  subroutine diffkk
       end

       subroutine sort2(n, ra, rb)
c heap sort real array ra of length n to ascending order,
c and make the corresponding rearrangement to rb.
       implicit none
       integer n, l, ir, i, j
       double precision ra(*), rb(*), xa, xb
       l  = n / 2 + 1
       ir = n
c heap creation phase
c index l is decremented from its initial value down to 1
 10    continue
       if (l.gt.1) then
          l  = l - 1
          xa = ra(l)
          xb = rb(l)
c heap selection phase
c index ir is decremented from its initial value to to 1
       else
          xa = ra(ir)
          xb = rb(ir)
          ra(ir) = ra(1)
          rb(ir) = rb(1)
          ir = ir - 1
          if (ir.eq.1) then
             ra(1) = xa
             rb(1) = xb
             go to 50
          end if
       end if
c sift down xa
       i = l
       j = l + l
 20    continue
       if (j.le.ir) then
c found better low element
          if ((j.lt.ir).and.(ra(j).lt.ra(j+1))) j = j + 1
c demote xa
          if (xa.lt.ra(j)) then
             ra(i) = ra(j)
             rb(i) = rb(j)
             i = j
             j = j + j
          else
             j = ir + 1
          end if
c ends the sift-down
          go to 20
       end if
c restore xa and xb
       ra(i) = xa
       rb(i) = xb
       go to 10
c      return
 50    continue

       return
c  end subroutine sort2
       end
       integer function sort_xy(e, x, n, delta)
c
c check and sort a pair of energy/xmu data to 
c ensure that energy is monotonically increasing
c
c returns 0 for data that needs no sort or rearrangement
c         1 if sorting or rearrangement were needed

       implicit none
       double precision e(*), x(*), de, delta, dm
       integer n, i, k, j
       logical sort, near

       near = .false.
       sort = .false.
cc       print*, ' in sort_xy '
c first, look for problems
       do 10 i =  1, n-1
          de = e(i+1)-e(i)
          if (de.lt.0)    sort = .true.
 10    continue 
c
cc       print*, ' in sort_xy ', sort, near

c if needed, sort
       if (sort) call sort2(n, e, x)
c
c if needed, handle coincident x points
c by slightly incrementing values
       do 100 i =  1, n-1
          de = e(i+1)-e(i)
          if (abs(de).lt.delta) then
             near = .true.
             dm   = delta*10.d0
             if (i .eq. n-1.and.i.ge.2) then
                dm = max(delta,(e(i)-e(i-1))*0.01d0)
             else
                dm = max(delta,(e(i+2)-e(i))*0.01d0)
             endif
             e(i+1) =  e(i) + dm
cc             print*, ' moving energy point ', i, e(i+1)
          endif
 100    continue 
       sort_xy = 0
       if (sort.or.near) sort_xy = 1
       return 
       end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
       integer function iofarr(name,group,npts,icreat)
c
c  return index of array
c  arguments:
c     name    array name (giving only a suffix is allowed)    [in/out]
c     group   group name (' ' allowed -> default looked up)   [in]
c     npts    size of array (used as input only for creation) [in/out]
c     icreat  integer create flag: 0=no create, 1=create OK   [in]
c  returns:
c     iofarr  index of array
c             < 0  :  not found and couldn't create it
c             = 0  : out of range  (ie, too many names defined)
       implicit none
       include 'consts.h'
       include 'arrays.h'
       save

       character*(*) name, group, pre*256
       integer  ioflist, icreat, jcreat, npts, iof
       double precision xpnext
       external ioflist
c
       pre    = group
       if ((pre.eq.'').or.(pre.eq.' ')) call gettxt('group', pre)
       call prenam(pre,name)
       iof    = maxarr
       jcreat = 0
       if (name.ne.' ') then
          iof = ioflist(name,arrnam,maxarr-1,icreat,jcreat)
          if ((icreat.eq.1).and.(jcreat.eq.0).and.(iof.ge.1)) then
cc             print*, ' iofarr: ', name(1:20), ' :',narray(iof),
cc     $            npts, jcreat
             if ((narray(iof).gt.0).and.(narray(iof).lt.npts)) then
                call erase_array(iof,.true.)
                iof = ioflist(name,arrnam,maxarr-1,icreat,jcreat)
             endif
          end if
          if ((jcreat.eq.1).and.(iof.ge.1)) then
cc             print*, ' iofarr create array: ', iof, npts, npnext
             nparr(iof)  = npnext
             narray(iof) = npts
             npnext      = (1+((nparr(iof) + narray(iof))/2))*2
             npnext      = min(maxheap_array-200, max(1, npnext))
             xpnext      = (maxheap_array - npnext)*1.0
             call setsca('&heap_free', xpnext)
             call fixarr(iof, name, npts, 1)
cc             print*, ' end iofarr= ', iof,nparr(iof), npnext
          endif
       end if
       iofarr = iof
       return
       end

       integer function iofsca(name,icreat)
c
c  return index of scalar
c  arguments:
c     name    scalar name                                   [in]
c     icreat  integer create flag: 0=no create, 1=create OK [in]
c  returns:
c     iofsca  index of scalar
c             < 0  :  not found and couldn't create it
c                     (-iofsca would be next available slot)
c             = 0  : out of range  (ie, too many names defined)
       implicit none
       include 'consts.h'
       include 'arrays.h'
       save
       integer  ioflist, icreat, jcreat
       character*(*) name
       external  ioflist

       jcreat = 0
       iofsca = ioflist(name,scanam,maxsca,icreat,jcreat)
       if (jcreat.eq.1) call setsca(name, zero)
       return
       end

       integer function iofstr(name,icreat)
c
c  return index of string variable
c  arguments:
c     name    string name                                   [in]
c     icreat  integer create flag: 0=no create, 1=create OK [in]
c  returns:
c     iofstr  index of string
c             < 0  :  not found and couldn't create it
c                     (-iofstr would be next available slot)
c             = 0  : out of range  (ie, too many names defined)
       implicit none
       include 'consts.h'
       include 'arrays.h'
       save

       integer  ioflist, icreat, jcreat
       character*(*) name, str*256
       external  ioflist

       jcreat = 0
       str    = name
       if (str(1:1).eq.'$')  str = str(2:)
       iofstr = ioflist(str,txtnam,maxtxt,icreat,jcreat)
       if (jcreat.eq.1) call settxt(str, ' ')

       return
       end
       integer function ioflist(name,carray,mxca,icreat,jcreat)
c
c  return index of scalar string in a list of strings
c  arguments:
c     name    scalar name                                   [in]
c     carray  array of name                                 [in]
c     max     dimension of carray                           [in]
c     icreat  integer create flag: 0=no create, 1=create OK [in]
c     jcreat  integer create flag: 1= creation needed       [out]
c  returns:
c     iostr  index of scalar
c             < 0  :  not found and couldn't create it
c                     (-iofsca would be next available slot)
c             = 0  : out of range  (ie, too many names defined)
       integer  istrln, j, i, icreat, iempty, mxca, jcreat
       character*(*) name, carray(mxca)
       external istrln

       j      = max(1, istrln(name))
       jcreat = 0
       iempty = 0
       i      = 0
 10    continue
       i = i + 1
c if we're out-of-range, return the -1 * index of first empty slot
       if (i.ge.mxca) then
          i = -iempty
c if we find an empty slot and are creating, use this one
       elseif ((carray(i).eq.' ').and.(icreat.eq.1) ) then
          carray(i) = name(1:j)
          jcreat    = 1
c if we find the first empty slot and are *not* creating,
c save this slot and keep going
       elseif ((carray(i).eq.' ').and.(icreat.ne.1)
     $         .and.(iempty.eq.0)) then
          iempty = i
          go to 10
c if the name doesn't match, keep going
       elseif (carray(i).ne.name(1:j)) then
          go to 10
       end if
c if name matched, then we end up here:
       ioflist = i
       return
       end
       logical function isvnam(str,itype)
c
c determine if string can be a valid variable name
c  arguments:
c    str    string to check         [in]
c    itype  type of name to check   [in]
c           -1  array or scalar
c            0  full array name
c            1  scalar / array prefix
c            2  string after $ / array suffix
c            3  string (including $)
c
       character*(*) str
       character bslash, squote, dollar, dot, invalid*32, digits*10
       integer   ilen, i, j1, istrln, itype, idot, jdot, ic1
       parameter (invalid = '!@#$%^*+=-/<>`,;"|()[]{}')
       parameter (digits  = '0123456789', dollar = '$', dot = '.')
       external  istrln
       j1     = 1
       ilen   = istrln(str)
       squote = ''''
       bslash = '\\ '
       isvnam = ((index(str(:ilen),squote) .eq. 0) .and.
     $           (index(str(:ilen),bslash) .eq. 0) )
       if (.not.isvnam) return
       idot   = index(str,dot)
cc       print*, ' -- in isvnam: itype = ', itype, ' : ',str(1:40)
       ic1 = ichar(str(1:1))
c either array or scalar:  . cannot be first or last char
       if (itype.eq.-1) then
          isvnam = (idot .ne. 1) .and. (idot .ne. ilen)
c full array names must have a dot (we'll count them below)
       elseif (itype.eq.0) then
          isvnam = (idot .gt. 1) .and. (idot .lt. ilen)
c scalars/prefixed must not begin with a digit
       elseif (itype.le.1) then
          isvnam = (index(digits, str(1:1)) .eq. 0)
c strings must begin with a dollar sign
       elseif (itype.eq.3) then
          isvnam = (str(1:1) .eq. dollar)
          j1   = 2
       end if
c  make sure there are no invalid characters in the name
       if (isvnam) then
          jdot   = 0
          isvnam = .false.
          do 10 i = j1, ilen
             if (index(invalid,str(i:i)) .ne. 0) return
             if (str(i:i).eq.dot) jdot = jdot + 1
 10       continue
c  array names must have 1 '.' -- rest must have 0 '.'.
          isvnam  = jdot.eq.0
          if (itype.eq.0) then
             isvnam  = jdot.eq.1
          elseif (itype.eq.-1) then
             isvnam  = jdot.le.1
          end if
       end if

       return
       end
       subroutine fixnam(str,itype)
c
c  repair bad variable name
c  arguments:
c    str    string to check         [str]
c    itype  type of name to check   [in]
c           -1  array or scalar
c            0  full array name
c            1  scalar / array prefix
c            2  string after $ / array suffix
c            3  string (including $)
c
       include 'consts.h'
       character*(*) str, s*1, s2*2
       character bslash, squote, dollar, dot, invalid*32, digits*10
       integer   ilen, i, istrln, itype
       parameter (invalid = '!@#$%^*+=-/<>`,;"|()[]{}')
       parameter (digits  = '0123456789', dollar = '$', dot = '.')
       external  istrln
       squote = ''''
       bslash = '\\ '
c check that first character is correct
       ilen= istrln(str)
       if (ilen.le.0) then
          s = '_'
          ilen = 1
       endif
       s   = str(1:1)
       if ( (itype.eq.1).and.(index(digits, s) .ne. 0) ) then
          str  = '_'//str(1:ilen)
          ilen = ilen + 1
       elseif ((itype.eq.3).and.(s.ne.dollar)) then
          str  = '$'//str(1:ilen)
          ilen = ilen + 1
       end if
c check rest of characters
       i = 0
 10    continue
       i = i + 1
       s = str(i:i)
       if( ((s.eq.squote) .or. (s.eq.dot) .or.
     $      (s.eq.bslash) .or. (s.eq.blank) .or.
     $      (index(invalid,s).ne.0) ) ) then
          str(i:i) = '_'
       end if
       if (i.lt.ilen) go to 10

c       ilen= istrln(str)
c       print*, ' ilen ', ilen, str(1:20)
c       do 20 i = 1, ilen-1
c          print*, '... ', i, str(i:i+1)
c          if (str(i:i+1).eq.'__') then
c             str(i:i+1) = '_&'
c          endif
c 20    continue

cc strip off leading '_'
c 20    continue
c       if ((str(1:1).eq. '_').and.(index(digits, str(2:2)).eq.0)) then
c          str = str(2:)
c          go to 20
c       endif
c       ilen = istrln(str)
cc strip off trailing '_'
c 30    continue
c       if (str(ilen:ilen).eq. '_')  then
c          str = str(1:ilen-1)
c          ilen = ilen - 1
c          go to 30
c       endif
c make sure we end with a valid, but clearly bad file name
c       if (str .eq.' ') str = undef

       return
       end
       subroutine fixarr(in, name, npts, iconst)
c
c  set max and min values, name, and npts for an array
c     in the ifeffit array "structure"
c arguments:
c   in      index in array lists  (cannot be zero)   [in]
c   name    name to give to this array (if unnamed)  [in]
c   npts    number of points to add                  [in]
c   iconst  integer flag: 1 for 'constant array',    [in]
c                         0 otherwise
       implicit none
       include 'consts.h'
       include 'arrays.h'
       include 'encod.h'
       save
       integer   npts, in, j, iconst
       character*(*) name, group*64
       double precision  ax
c
       if ((in.gt.0).and.(in.le.maxarr)) then
          narray(in) = npts
          if ((arrnam(in).eq.' ').and.(name.ne.' ')) then
             call gettxt('group', group)
             arrnam(in) = name
             call prenam(group,arrnam(in))
          end if
c  set max and min values
cc        print*, ' fixarr: ', in, nparr(in), npts 
          arrmax(in) =  array(nparr(in))
          arrmin(in) =  array(nparr(in))
          do 20 j = 1, npts
             ax = array(nparr(in)+j-1)
             if (arrmin(in).gt.ax) arrmin(in) = ax
             if (arrmax(in).lt.ax) arrmax(in) = ax
 20       continue
c set icdarr (for 'constant arrays')
          if ((iconst.eq.1).or. (icdarr(1,in) .eq. 0)) then
             icdarr(1,in) = in
             icdarr(2,in) = 0
          end if
       end if
       return
c  end subroutine fixarr
       end
       subroutine file_type_names(type,icol,name)
       character*(*) type, name
       integer  icol
 50    format(i3)
       write(name,50)    icol
       if ((type.eq.'xmu').and.(icol.eq.1))  name = 'energy'
       if ((type.eq.'xmu').and.(icol.eq.2))  name = 'xmu'
       if ((type.eq.'pre-edge').and.(icol.eq.1))  name = 'energy'
       if ((type.eq.'pre-edge').and.(icol.eq.2))  name = 'pre'

       if ((type.eq.'chi').and.(icol.eq.-1)) name = 'win'
       if ((type.eq.'chi').and.(icol.eq.1))  name = 'k'
       if ((type.eq.'chi').and.(icol.eq.2))  name = 'chi'

       if ((type.eq.'rsp').and.(icol.eq.-1)) name = 'rwin'
       if ((type.eq.'rsp').and.(icol.eq.1))  name = 'r'
       if ((type.eq.'rsp').and.(icol.eq.2))  name = 'chir_re'
       if ((type.eq.'rsp').and.(icol.eq.3))  name = 'chir_im'
       if ((type.eq.'rsp').and.(icol.eq.4))  name = 'chir_mag'
       if ((type.eq.'rsp').and.(icol.eq.5))  name = 'chir_pha'

       if ((type.eq.'chi_std').and.(icol.eq.1)) name = 'k_std'
       if ((type.eq.'chi_std').and.(icol.eq.2)) name = 'chi_std'

       if ((type.eq.'qsp').and.(icol.eq.-1)) name = 'win'
       if ((type.eq.'qsp').and.(icol.eq.1))  name = 'q'
       if ((type.eq.'qsp').and.(icol.eq.2))  name = 'chiq_re'
       if ((type.eq.'qsp').and.(icol.eq.3))  name = 'chiq_im'
       if ((type.eq.'qsp').and.(icol.eq.4))  name = 'chiq_mag'
       if ((type.eq.'qsp').and.(icol.eq.5))  name = 'chiq_pha'

       if ((type.eq.'xmu.dat').and.(icol.eq.1))  name = 'energy'
       if ((type.eq.'xmu.dat').and.(icol.eq.2))  name = 'e_wrt0'
       if ((type.eq.'xmu.dat').and.(icol.eq.3))  name = 'k'
       if ((type.eq.'xmu.dat').and.(icol.eq.4))  name = 'mu'
       if ((type.eq.'xmu.dat').and.(icol.eq.5))  name = 'mu0'
       if ((type.eq.'xmu.dat').and.(icol.eq.6))  name = 'chi'

       if ((type.eq.'chi.dat').and.(icol.eq.1))  name = 'k'
       if ((type.eq.'chi.dat').and.(icol.eq.2))  name = 'chi'
       if ((type.eq.'chi.dat').and.(icol.eq.3))  name = 'mag'
       if ((type.eq.'chi.dat').and.(icol.eq.4))  name = 'phase'

       if ((type.eq.'feff').and.(icol.eq.1))  name = 'k'
       if ((type.eq.'feff').and.(icol.eq.2))  name = 'cphase'
       if ((type.eq.'feff').and.(icol.eq.3))  name = 'mag'
       if ((type.eq.'feff').and.(icol.eq.4))  name = 'phase'
       if ((type.eq.'feff').and.(icol.eq.5))  name = 'redfactor'
       if ((type.eq.'feff').and.(icol.eq.6))  name = 'lambda'
       if ((type.eq.'feff').and.(icol.eq.7))  name = 'realp'
       if ((type.eq.'feff.dat').and.(icol.eq.1))  name = 'k'
       if ((type.eq.'feff.dat').and.(icol.eq.2))  name = 'cphase'
       if ((type.eq.'feff.dat').and.(icol.eq.3))  name = 'mag'
       if ((type.eq.'feff.dat').and.(icol.eq.4))  name = 'phase'
       if ((type.eq.'feff.dat').and.(icol.eq.5))  name = 'redfactor'
       if ((type.eq.'feff.dat').and.(icol.eq.6))  name = 'lambda'
       if ((type.eq.'feff.dat').and.(icol.eq.7))  name = 'realp'
       return
       end

       subroutine glob(str, arr, marray, out, mout, nout)
c
c  support a simple (dos-like) glob mechanism: list matches to '*'
c  str will select a set of elements in array.
c  so if str does not contain '*', it is expected to be an element
c  and is returned itself.
c
c  otherwise, all elements of array that match the pattern are
c  put into the out array.
c
       implicit none
       integer  marray, mout, nout
       character*(*) str, arr(marray), out(mout)
       character*256 str1, str2
       logical    match
       integer  istar, itlen, lstr1, lstr2, istr1, istr2, j
       integer  istrln, intxt
       external istrln

       istar = index(str, '*')
       nout  = 0
       istr1 = 0
       istr2 = 0
       match = .false.
       itlen = istrln(str)
       if (istar.eq.0) then
          out(1) = str
          nout   = 1
       else
          str1  = str(1:istar-1)
          str2  = str(istar+1:itlen)
          lstr1 = istrln(str1)
          lstr2 = istrln(str2)
          do 100 j = 1, marray
             intxt = istrln(arr(j))
             if (intxt.ge.1) then
                match = .true.
                if (lstr1.ge.1) then
                   match = (arr(j)(:lstr1).eq.str1(:lstr1)).and.match
                endif
                if (lstr2.ge.1) then
                   match = (arr(j)(intxt-lstr2+1:intxt)
     $                  .eq. str2(:lstr2)).and.match
                endif
                if (match) then
                   nout = nout + 1
                   out(nout) = arr(j)
                endif
             endif
 100      continue
       endif
cc       print*, ' glob found ', nout ,' matches'
       return
       end
       subroutine prenam(group,suff)
c
c  give an un-grouped array name  a group name
c
c  suff    array name (suffix)         [in/out]
c  group   array group name (prefix)   [in]
c
c  if suff does not already have a prefix, and really is 
c  a variable name (does not contain '(', ')', ',', or '.'
c  or 'indarr'),  then the group name is prepended on output
c
c  if suff already has a prefix, it remains unchanged (well, 
c  it is trimmed and converted to lower case)
c  
       character*(*)  group, suff
       character*256  g, a
       logical   isvnam
       integer   ig, istrln
       external  isvnam
       a = suff
       call lower(a)
       call triml(a)

       g = group
       call lower(g)
       call triml(g)
       ig  = istrln(g)
       if (g.eq.' ')  g = 'my'
       if (.not.isvnam(g,1)) then
          call warn(1,
     $         ' *** Warning: invalid group name  -- '//g(1:ig))
          call fixnam(g,1)
          ig = istrln(g)
          call warn(1,'              replaced with -- '//g(1:ig))
       end if
       if ( (index(a,'.').eq.0) .and. (index(a,'indarr').eq.0) .and.
     $      (index(a,'(').eq.0) .and. (index(a,')').eq.0) .and.
     $      (index(a,',').eq.0) )  then
          a = g(1:ig)//'.'//a
       endif

       suff = a
       return
       end
c
       subroutine set_array(name, group, arr, npts, jcreat)
c
c put an array into global register
c this is a simple wrapper around iofarr and set_array_index
c
       include 'consts.h'
       include 'arrays.h'
       character*(*) name, group, vnam*256
       double precision arr(*)
       integer  npts, jcreat, ia, nof, i, iofarr
       external iofarr
       vnam = name
       ia   = iofarr(vnam, group, npts, jcreat)
       call set_array_index(ia,arr,npts)
       return
       end

       subroutine set_array_index(index, arr, npts)
c
c low level write to array data (overwrite array in
c global register, assuming index is known and correct)
c
c should be used with care (iff_sync only?), but will check
c for, and automatically recover from changing array sizes:
c    npts of existing array goes to 1: -> erase array
c    npts of existing array increases: -> erase and re-set 
c 
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       double precision arr(*)
       integer  index, npts, ia, i, icode(micode)
       integer  iofarr, istrln, icreat, j
       character*256 tmpfrm
       external  iofarr, istrln
       ia   = index
       if (npts .ne. narray(ia) ) then
          if (npts.le.1) then 
             tmpstr = '*** warning: erasing null array '
     $            //arrnam(ia)
             i = istrln(tmpstr)
             call warn(1, tmpstr)
             call erase_array(ia,.true.)
             return
          else if (npts .gt. narray(ia) ) then
             tmpfrm  = arrfrm(ia) 
             tmpstr  = arrnam(ia) 
             do 10 j = 1, micode
                icode(j) = icdarr(j,ia) 
 10          continue
             call erase_array(ia,.true.)
             ia = iofarr(tmpstr,blank,npts,icreat)
             arrfrm(ia)  = tmpfrm
             arrnam(ia)  = tmpstr
             do 20 j = 1, micode
                icdarr(j,ia) = icode(j)
 20          continue
          endif
       endif
       do 100 i = 1, npts
          array(nparr(ia)+i-1) = arr(i)
 100   continue
c do not force to be a constant array!
       call fixarr(ia, arrnam(ia), npts, 0)
       return
       end
c
       integer function get_array(name, group, jcreat, arr)
c
c get an array from global register
c returns npts of array, and array itself in last parameter 
c
       include 'consts.h'
       include 'arrays.h'
       character*(*) name, group, vnam*256
       double precision arr(*)
       integer  npts, jcreat, ia, nof, i, iofarr
       external iofarr

       get_array = 0
       vnam      = name
       npts      = 0
       ia        = iofarr(vnam, group, npts, jcreat)
       if (ia .gt.0) then
          get_array = narray(ia)
          do 100 i = 1, narray(ia)
             arr(i) = array(nparr(ia)+i-1)
 100      continue
       endif
       return
       end
       integer function get_array_index(index, arr)
c
c get an array from global register by internal index
c assumes that iofarr() has been run or a stored valued
c from iofarr() is reliable.
c
       include 'consts.h'
       include 'arrays.h'
       double precision arr(*)
       integer  index, i

       get_array_index = 0
       if (index .gt.0) then
          get_array_index = narray(index)
          do 100 i = 1, narray(index)
             arr(i) = array(nparr(index)+i-1)
 100      continue
       endif
       return
       end

       logical function isdat(string)
c  tests if string contains numerical data
c    returns true if the first (up to eight) words in string can
c    all be numbers. requires at least two words, and tests only
c    the first eight columns
       integer nwords, mwords, i
       parameter (mwords = 8)
       character*(30)  string*(*), words(mwords), line*(256)
       logical isnum
       external isnum
c
       isdat = .false.
       do 10 i = 1, mwords
          words(i) = 'no'
 10    continue
c
       nwords = mwords
       line   = string
       call triml(line)
       call untab(line)
       call bwords(line, nwords, words)
       if (nwords.ge.2) then
          isdat = .true.
          do 50 i = 1, nwords
             if (.not. ( isnum( words(i) ) ) ) isdat = .false.
 50       continue
       end if
c
       return
       end

       subroutine fixicd(icdval, maxval, micode, jconst, jxlocl,
     $               vnames, xval, nvar, nconst, ntotal,io2n)
c
c  fix integer code arrays from encod so that :
c     1.  all variables come first
c     2.  all true constants come next (well, most ...)
c     3.  all other math expressions are ordered so that each
c         depends on only its predecessors.  this allows
c         single-pass, ordered decoding.
c
c arguments
c   icdval  integer array codes from encod (micode, maxval)  (in/out)
c   maxval  dimension of icdval, vnames, xval                (in)
c   micode  dimension of icdval                              (in)
c   jconst  integer placeholder for constants (from encod)   (in)
c   jxlocl  integer placeholder for locals                   (in)
c   vnames  array of variable names                          (in/out)
c   xval    array of variables values/initial guesses        (in/out)
c   nvar    number of variables                              (out)
c   nconst  number of constants                              (out)
c   ntotal  total number of named parameters                 (out)
c   io2n    map    io2n(iold) = inew                         (out)
c notes:
c  1. jxlocl > jconst !!   jconst = 2000, jxlocl = 5000 at this writing.
c  2. elements   1      -> nvar          of icdval are variables
c     elements  nvar+1  -> nconst +nvar  of icdval are constants
c  3. the parameters mxval and mcode should be >= maxval, micode.
c  4. jfake1 and jfake2 are for the "fake constants" (like reff)
c     hardwired in feffit/encod to be held in the constant array,
c     even though their values are continually overwritten.  I don't
c     want to include them in the  "true constants" list here.
c
       integer  mxval , mcode, micode, maxval, jconst, jxlocl
       integer  icdval(micode, maxval), io2n(maxval), nvar, nconst
       double precision      xval(maxval),     zero
       character*(*)   vnames(maxval)
       parameter (mxval = 2048, mcode = 256, zero = 0.d0)
       integer    jfake1 ,  jfake2
       parameter (jfake1 = 4, jfake2 = 8)
       character*64 vnew(mxval), vorig(mxval)
       integer  icdnew(mcode, mxval), iold(mxval), inew(mxval)
       integer  io, in, ntotal, icd, ncandv, jv
       integer  iv, ivold, ivnew, itmp, i
       integer   jdebye, jeins, jeins2
       parameter(jdebye=-120, jeins =-121, jeins2=-122)

       double precision  xnew(mxval), xxtmp
c      
       do 80 i = 1, maxval
          vnew(i) = ' '
          vorig(i)= vnames(i)
          xnew(i) = zero
          if (vnames(i).ne.' ')  ntotal = i
 80    continue
c
c reorder #1:  put variables 1st
      ivnew = 0
      do 100 iv = 1, ntotal
         if (icdval(1,iv).eq.-1) then
            ivnew        = ivnew + 1
            vnew(ivnew)  = vnames(iv)
            xnew(ivnew)  = xval(iv)
            inew(iv)     = ivnew
            iold(ivnew)  = iv
         end if
 100  continue
      nvar = ivnew
c
c reorder #2: put  constants 2nd
c   if                    1  <= icdval(i) <= jconst
c   or if    jfake1 + jconst <= icdval(i) <= jfake2 jconst
c   then its not a constant
      do 150 iv = 1, ntotal
         if ( (icdval(1,iv).ne.-1).and.
     $        (icdval(1,iv).le.jxlocl) ) then
            icd = 0
            do 130 i = 1, micode
               if (icdval(i,iv).eq.0) go to 135
               if ( (icdval(i,iv).eq.jdebye) .or.
     $              (icdval(i,iv).eq.jeins)  .or.
     $              (icdval(i,iv).eq.jeins2) ) icd = icd + 1
               if ( (icdval(i,iv).ge.1).and.
     $              (icdval(i,iv).lt.jconst) )  icd = icd + 1
               if ( (icdval(i,iv).ge.(jfake1+jconst)).and.
     $              (icdval(i,iv).le.(jfake2+jconst)) ) icd = icd + 1
 130        continue
 135        continue
            if (icd.eq.0) then
               ivnew       = ivnew + 1
               vnew(ivnew) = vnames(iv)
               xnew(ivnew) = xval(iv)
               inew(iv)    = ivnew
               iold(ivnew) = iv
            endif
         end if
 150  continue
      ncandv  = ivnew
      nconst  = ivnew - nvar
c
c reorder #3:  now put "local variables", all of which are marked with
c  an initial element larger that jxlocl that is much greater than
c  jconst (jxlocl = 5000, jconst = 2000  at this writing)
      do 240 iv = 1, ntotal
         if (icdval(1,iv).gt.jxlocl) then
            ivnew       = ivnew + 1
            vnew(ivnew) = vnames(iv)
            xnew(ivnew) = xval(iv)
            inew(iv)    = ivnew
            iold(ivnew) = iv
         endif
 240  continue
c
c add all the other math expressions to the new arrays.
c without worrying about order
      do 400 iv = 1, ntotal
         icd = 0
         do 360 i = 1, micode
            if (icdval(i,iv).eq.0) go to 370
            if ((icdval(i,iv).ge.1).and.
     $           (icdval(i,iv).lt.jconst ) )  then
               icd = icd + 1
               go to 370
            end if
            if ( (icdval(i,iv).eq.jdebye) .or.
     $           (icdval(i,iv).eq.jeins)  .or.
     $           (icdval(i,iv).eq.jeins2) ) then
               icd = icd + 1
               go to 370
            end if

            if ((icdval(i,iv).ge.(jfake1+jconst)).and.
     $          (icdval(i,iv).le.(jfake2+jconst)) ) then
               icd = icd + 1
               go to 370
            end if
 360     continue
 370     continue
         if (icd.ne.0) then
            ivnew        = ivnew + 1
            vnew(ivnew)  = vnames(iv)
            xnew(ivnew)  = xval(iv)
            inew(iv)     = ivnew
            iold(ivnew)  = iv
         endif
 400  continue
c
c       print*, ' new variable order: ', ntotal, nconst, nvar
c       do i = 1, ntotal
c          print*, i, ' ',vnew(i)(1:20)
c       enddo
c now replace all occurances of iv with inew(iv) (= ivnew) in icdval.
      do 540 iv = 1, ntotal
         ivold = iold(iv)
         do 520 i = 1, micode
            if ((icdval(i,ivold).ge.1).and.
     $           (icdval(i,ivold).lt.jconst ) ) then
               icdnew(i,iv) = inew(icdval(i,ivold))
            else
               icdnew(i,iv) = icdval(i,ivold)
            endif
 520    continue
 540  continue
      do 600 iv = 1, maxval
         vnames(iv) = vnew(iv)
         xval(iv)   = xnew(iv)
         xnew(iv)   = zero
         vnew(iv)   = ' '
         iold(iv)   = 0
         inew(iv)   = 0
         do 580 i = 1, micode
            icdval(i,iv) = icdnew(i,iv)
 580     continue
 600  continue
c
c finally, put the math expressions in order
c a simple switch-in-place, with recovery
      do 900 iv = ncandv+1, ntotal
         itmp = ncandv
         do 750 i = 1, micode
            icd = icdval(i,iv)
            if (icd.eq.0) go to 760
            if ((icd.ge.ncandv).and.
     $           (icd.lt.jconst))  itmp = max(icd,itmp)
 750     continue
 760     continue
         if (itmp.gt.iv) then
            ivold = iv
            ivnew  = itmp
            do 780 i = 1, micode
               icdnew(i,1)     = icdval(i,ivnew)
               icdval(i,ivnew) = icdval(i,ivold)
               icdval(i,ivold) = icdnew(i,1)
 780        continue
            vnew(1)       = vnames(ivnew)
            vnames(ivnew) = vnames(ivold)
            vnames(ivold) = vnew(1)
            xxtmp         = xval(ivnew)
            xval(ivnew)   = xval(ivold)
            xval(ivold)   = xxtmp
            do 850 jv = ncandv+1, ntotal
               do 820 i = 1, micode
                  if (icdval(i,jv).eq.0) go to 830
                  if (icdval(i,jv).eq.ivold) then
                     icdval(i,jv) =  ivnew
                  elseif (icdval(i,jv).eq.ivnew) then
                     icdval(i,jv) =  ivold
                  endif
 820           continue
 830           continue
 850        continue
         end if
 900  continue
c
c now re-map old to new and return
      do 1000 io = 1, ntotal
         do 980 in = 1, ntotal
            if (vorig(io).eq.vnames(in)) then
               io2n(io) = in
               go to 990
            endif
 980     continue
 990     continue
 1000 continue
c
      return
c end subroutine fixicd
      end

       integer function ifeffit(string)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose:    main ifeffit function.
c             parse and send string as a command to one of 
c             the ifeffit subroutines
c arguments:  string    command line for ifeffit            [in]
c returns:    0   success 
c            -2   in the middle of defining a macro
c            -1   get another line
c             1   normal exit
c            >1   failure of some sort
c
c notes:      see documentation for further discussion
c
c copyright (c) 1998  matt newville
c
c   Leaving there and proceeding for three days towards the east, you
c   reach Diomira, a city with sixty silver domes, bronze statues of
c   all the gods, streets paved with lead, a crystal theater, a golden
c   cock that crows each morning on a tower.  All these beauties will
c   already be familiar to the visitor, who has seen them also in
c   other cities.  But the special quality of this city for the man
c   who arrives there on a September evening, when the days are
c   growing shorter and the multicolored lamps are lighted all at once
c   at the doors of the food stalls and from a terrace a woman's voice
c   cries ooh!, is that he feels envy toward those who now believe
c   they have once before lived an evening identical to this and who
c   think they were happy, that time.
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'echo.h'
       save
       double precision getsca
       character*2048 line, argu, string*(*), val, key*128
       integer        ilen, ik1, ik2, init, istrln, jmac, iff_load
       integer        iffcmd_exec
       logical        wrthis, isamac
       external istrln, getsca, isamac, iff_load, iffcmd_exec
       data init /1/
c
c init>0 means to initialize 
c  initial string may be used to alter behavior:
c   &quiet :   suppress all screen echo's, even startup message
c 
       if (init .gt. 0) then
          init  = 0
          ilen  = 0
          jmac  = 0
          argu  = string
          call iff_init
          call echo_init
          call iff_plot_init(-1)
          call iff_config
          call triml(argu)
          if (argu(1:6) .eq. '&quiet') then
             call setsca( '&screen_echo',  zero)
             i_echo = 0
          endif
c
       end if
       line   = string
       argu   = ' '
       wrthis = .true.
cc       print*, 'str = ', line(1:40)
c
c  get next command line
c    getline converts blank lines and comment lines to "def", 
c    so we check here that there really is an argument to 
c    avoid repeated trivial processing
       ifeffit = -1
       call iff_getline(line, key, val, argu, ilen)
       ik1 = istrln(key)
       ik2 = istrln(argu)
cc       print*, ' =>', key(1:ik1), ' <', argu(1:ik2),'> ', ilen
       if ((key.eq.'def').and.(argu.eq.' ').and.
     $      (ilen.ge.0)) ilen = 0
c
c  if we're in the middle of a macro definition ...
       if (mac_define(1).ge.1) then
          call iff_macro_def(line)
cc          print*, ' setting ifeffit from ', ifeffit, ' to -2'
          ifeffit = -2
          call triml(line)
          call lower(line)
          if (line(1:9).eq.'end macro') then
             ifeffit = 0
             mac_define(1) = -1
          endif
          return
       endif
c
c  if ilen < 0, the line will be continued to the next line: 
cc       print*, ' ilen = ', ilen
       if (ilen.eq.0) ifeffit = 0
       if (ilen.le.0) return
       ifeffit = 3
       iprint= int(getsca('&print_level',0))
c
c=== execute ifeffit commands based on keyword ===c
c

c
c first check for meta-commands that cannot occur within macros
c

cc       print*, 'IFF key = ', key(1:30), jmac, isamac(key,jmac)
c  execute a macro
       if (isamac(key,jmac)) then
cc          print*, ' jmac= ', isamac(key,jmac), jmac
          call iff_macro_do(jmac, argu, iprint,wrthis)
          wrthis = .false.
          key  = ' '
          argu = ' '

c  define a macro  (more precisly, __begin__ a macro definition)
       else
          ifeffit = iffcmd_exec(key,argu,wrthis)
       endif
c===  write history ===
c  and  information about argument line
       if (histry.and.wrthis)  then
          write(val, '(1x,4a)') key(1:ik1),' (',argu(1:ik2),')'
          if (iprint.ge.19)        call echo(val)
          ilen = istrln(val)          
          write(iohist, '(a)') val(1:ilen)
       endif
c  clean up used line -- we're done
       line = '                                                   '//
     $      '                                                     '//
     $      '                                                     '//
     $      '                                                     '//
     $      '                                                     '
     
       call sclean(line)
cc       print*, 'ifeffit ret ', ifeffit
       if ((ifeffit.ne.-2).and.(ifeffit.ne.1)) ifeffit = 0

c end function ifeffit
       return
       end


       integer function iffcmd_exec(key,argu,wrthis)
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'echo.h'
       save

       character*2048 argu, key*128
       logical  wrthis

       integer  ilen, istrln, iff_load
       external istrln, iff_load

ccc       print*, ' iffcmd ', key(1:20)
       iffcmd_exec = 0
       if (key .eq. 'macro') then
          call iff_macro_def(argu)
          iffcmd_exec = -2
          wrthis = .false.
c  quit is a special case
       elseif ((key .eq. 'quit').or.(key .eq. 'exit')) then
          call iff_done
          iffcmd_exec = 1
          return
c  load: read a set of command lines from a file
       elseif (key .eq. 'load')  then
          iffcmd_exec = iff_load(argu)
          if (iffcmd_exec.eq.1) return
          wrthis = .false.             
       elseif (key .eq. 'history')  then
          call iff_history(argu)
          wrthis = .false.

c  data i/o commands
       elseif (key .eq. '__test') then
          call iff_test(argu)
       elseif (key .eq. 'read_data') then
          call iff_rddata(argu)
       elseif (key .eq. 'write_data') then
          call iff_wrdata(argu)
       elseif (key .eq. 'save') then
          call iff_save(argu)
       elseif (key .eq. 'restore') then
          call iff_restore(argu) 
c  set/show arrays and scalars
       elseif (key .eq. 'log') then
          call iff_log(argu)
       elseif (key .eq. 'show') then
          call iff_show(argu,0)
       elseif (key .eq. 'print') then
          call iff_print(argu)
       elseif (key .eq. 'echo') then
          call iff_echo(argu,0)
       elseif (key .eq. 'pause') then
          call iff_echo(argu,1)
       elseif ((key .eq. 'def').or.(key .eq. 'define').or.
     $         (key .eq. 'set').or.(key .eq. 'guess')) then
          call iff_set(key,argu,wrthis)
       elseif (key .eq. 'unguess') then
          call iff_unguess(argu)
       elseif (key .eq. 'erase') then
          call iff_erase(argu)
       elseif ((key .eq. 'rename')) then
          call iff_rename(argu)
c  data manipulation commands
       elseif ((key .eq. 'pre_edge')) then
          call iff_pre_edge(argu)
       elseif ((key .eq. 'bkg_cl')) then
          call iff_bkg_cl(argu)
       elseif ((key .eq. 'spline').or.(key .eq. 'autobk')) then
          call iff_spline(argu)
       elseif (key .eq. 'random') then
          call iff_random(argu)
       elseif ((key .eq. 'fft').or.(key .eq. 'fftf').or.
     $         (key .eq. 'bft').or.(key .eq. 'fftr')) then
          call iff_fft(key,argu)
       elseif (key .eq. 'window')  then
          call iff_window(argu)
       elseif (key .eq. 'path')  then
          call iff_path(argu)
       elseif (key .eq. 'get_path')  then
          call iff_getpath(argu)
       elseif (key .eq. 'ff2chi')  then
          call iff_ff2chi(argu)
       elseif (key .eq. 'feffit')  then
          call iff_feffit(argu)
       elseif (key .eq. 'chi_noise')  then
          call iff_chieps(argu)
       elseif (key .eq. 'f1f2')  then
          call iff_f1f2(argu)
       elseif (key .eq. 'diffkk')  then
          call iff_diffkk(argu)
       elseif (key .eq. 'minimize')  then
          call iff_minimize(argu)
       elseif (key .eq. 'correl')  then
          call iff_correl(argu)
       elseif (key .eq. 'error')  then
          call iff_uncert(argu)
       elseif (key .eq. 'sync')  then
          call iff_sync
       elseif (key .eq. 'reset') then
          call iff_init
          call echo_init
          call iff_plot_init(1)
          call iff_config
c
c  plotting commands
       elseif ((key .eq. 'plot').or.
     $         (key .eq. 'overplot').or.(key.eq.'replot'))  then
          call iff_plot(argu)
       elseif (key .eq. 'newplot') then
          call iff_plot('new=1, '//argu)
       elseif (key .eq. 'plot_marker') then
          call iff_plotmarker(argu)
       elseif (key .eq. 'plot_text') then
          call iff_plottext(argu)
       elseif (key .eq. 'plot_arrow') then
          call iff_plotarrow(argu)
       elseif (key .eq. 'zoom') then
          call iff_zoom(argu)
       elseif (key .eq. 'cursor') then
          call iff_cursor(argu)
       elseif (key .eq. 'color') then
          call iff_color(argu)
       elseif (key .eq. 'linestyle') then
          call iff_pstyle(argu)
c  comment is used to write argu to history file only as a comment
       elseif (key .eq. 'comment') then
          if (histry) then
             call rmquot(argu)
             ilen = istrln(argu)
             write(iohist, '(1x,2a)') '# '//argu(1:ilen)
          end if
          wrthis = .false.
       else
          ilen = istrln(key)
          call warn(1,'unknown command: '//key(1:ilen))
       endif
       return 
       end

      subroutine cabort(messg, abortf)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c  conditional abort;  if abortf is .true.
c
      character*(*) messg
      logical abortf
      call echo(messg)
      if (abortf)  then
         call warn(3,'* uwxafs data file handling abort *')
         return
      endif
      return
c end subroutine cabort
      end
      subroutine putrec(iounit,array,nw,skey,nkey,ier)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c        put data record to a random access data file
c
c         iounit : i/o unit no(integer,input)
c         array  : data to be put(any type,input)
c         nw     : no of words in array(integer,input)
c         skey   : symbolic key for the record(character,input)
c         nkey   : numeric key for the record(integer,input)
c         ier    : error code(integer,output)
c           1 - unit not declared
c           2 - nw .lt. 0
c           3 - file protection violated
c           4 - skey is blank
c           5 - rewrite interlock not cleared
c           6 - record length is different for rewrite
c           7 - nkey does not exist
c           8 - index full
c
c         skey must be given always and nkey should be zero for new record
c         non zero nkey means rewrite. - nw should be equal to current one
c
      implicit integer(a-z)
c
      parameter (indxl=191, nu=2, iword = 128 )
c
      character*(*) skey
      character*80 fname(nu),ctmp
      character*2048 cindx(nu)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt,modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
      real array(nw)
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('putrec: unit not declared',abortf)
        ier=1
        return
      endif
c
      if(nw.lt.0) then
        call cabort('putrec:  no data to write',abortf)
        ier=2
        return
      endif
c
      if(modify(u)) then
        call cabort('putrec: '//fname(u)//
     $                    ' has no write permission',abortf)
        ier=3
        return
      endif
c
      if(skey.eq.' ') then
        call cabort('putrec:  skey not given',abortf)
        ier=4
        return
      endif
c
      last=indx(2,0,u)
      if(nkey.ne.0) then
c        rewrite
        if(.not.rewrt) then
          call cabort('putrec:  rewrite interlock not cleared',abortf)
          ier=5
          return
        endif
        rewrt=.false.
c          rewrite
        if(nkey.gt.last) then
          call cabort('putrec: old nkey does not exist',abortf)
          ier=7
          return
        endif
        if(nw.ne.indx(2,nkey,u)) then
          call cabort('putrec: old/new record length dont match',abortf)
          ier=6
          return
        endif
        pru=indx(1,nkey,u)
c
c        new record
      else
        if(last.ge.indxl) then
          call cabort('putrec: index full',abortf)
          ier=8
          return
        endif
        pru=indx(1,0,u)
      endif
c
      nblk  = (nw + iword - 1)/iword
      do 10 i = 1 , nblk
        l = min(i*iword, nw)
        write(iounit, rec=i+pru-1)(array(j),j=(i-1)*iword+1,l)
   10 continue
c
c          new index for rewrite
      if(nkey.ne.0) then
        call echo('putrec:  symbolic key overwritten'//
     $              cindx(u)(nkey*10+1:nkey*10+10))
        cindx(u)(nkey*10+1:nkey*10+10)=skey
      else
c          new index for new record
        cindx(u)(last*10+11:last*10+20)=skey
        indx(1,last+1,u)=indx(1,0,u)
        indx(2,last+1,u)=nw
      endif
c          new no of entries and eof block no
      indx(1,0,u)=indx(1,0,u)+nblk
      indx(2,0,u)=last+1
      ier=0
c      check duplicate key
      ctmp=skey
      ntmp=nkey
  100 continue
      do 500 n=1,last
      if(ctmp.ne.cindx(u)(n*10+1:n*10+10)) go to 500
      if(n.ne.ntmp) go to 510
  500 continue
c         no duplicate key
      go to 600
c      put an asterisk, if one is not there already
  510 continue
      do 520 i=6,10
        if(cindx(u)(n*10+i:n*10+i).eq.'*') go to 520
        cindx(u)(n*10+i:n*10+i)='*'
c      check again if new skey is duplicate
        ctmp=cindx(u)(n*10+1:n*10+10)
        ntmp=n
        go to 100
  520 continue
      call cabort('putrec:  same skey occured five times',abortf)
  600 continue
      if(safe) then
        call wrindx(iounit)
      else
        modify(u)=.true.
      endif
      return
c end subroutine putrec
      end
      subroutine putdoc(iounit,doc,nl,skey,nkey,ier)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c        put documentation lines to a random access data file
c          iounit  : fortran i/o unit no(integer,input)
c          doc     : document lines(character,input)
c          nl      : no of lines to be written(integer,input)
c          skey    : symbolic key associated with the record(char,in)
c          nkey    : numeric key associated with the record(integer,in)
c          ier     : error code (integer,output)
c            1 - unit not declared
c            2 - nl .le. 0
c            3 -
c            4 - skey not given
c            5 - rewrite interlock not cleared
c            6 - skey not found
c          if doc='doc' , internal buffer is used
c          symbolic key must be given
c          for new record, nkey should be zero.
c
      implicit integer(a-z)
c
      parameter (indxl=191, nu=2 )
c
      character*(*) skey
      character*80 fname(nu), doctmp*100
      character*2048 cindx(nu)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt,modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
      parameter(maxl=20, maxchr=100 )
      character*(maxchr) dbuf(maxl)
      common /uwdbuf/ dbuf
      save /uwdbuf/
c
      character*(*) doc(*)
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('putdoc: unit not declared',abortf)
        ier=1
        return
      endif
c
c convert form to the case of this routine.
c   'case' controls the the case of this routine
      doctmp = doc(1)
      call smcase(doctmp, 'case')
c
      if ((nl.le.0).and.(doctmp.ne.'doc')) then
        call cabort('putdoc: no documents to write',abortf)
        ier=2
        return
      endif
c
      if(skey.eq.' ') then
        call cabort('putdoc: skey must be given',abortf)
        ier=4
        return
      endif
c
      last=indx(2,0,u)
c
      if(nkey.ne.0) then
c          existing record
        if(.not.rewrt) then
          call cabort('putdoc: rewrite interlock not cleared',abortf)
          ier=5
          return
        endif
        rewrt=.false.
        iord=nkey
      else
c        new record
        call gnkey(iounit,skey,iord,ier)
        if(iord.eq.0) then
          call cabort('putdoc: skey not found',abortf)
          ier=6
          return
        endif
      endif
c
c        write at the end, always
      pru=indx(1,0,u)
      if (doctmp.eq.'doc') then
c        write internal buffer
        indx(4,iord,u)=nldoc
        nblk=(nldoc+4)/5
        do 10 i=1,nblk
            lblk=min(i*5,nldoc)
            write(iounit, rec=pru+i-1) (dbuf(j),j=i*5-4,lblk)
   10   continue
      else
c        write doc
        indx(4,iord,u)=nl
        nblk=(nl+4)/5
        do 20 i=1,nblk
            lblk=min(i*5,nl)
            write(iounit, rec=pru+i-1)(doc(j),j=i*5-4,lblk)
   20   continue
      endif
c        adjust index
      indx(3,iord,u)=pru
      indx(1,0,u)=pru+nblk
c        if (safe) write out new index
      if(safe) then
        call wrindx(iounit)
      else
c        otherwise, mark it
c        new index will be written when closrf is called
        modify(u)=.true.
      endif
      ier=0
      return
c end subroutine putdoc
      end
       subroutine openrf(iounit,lfn,aflag,sflag,ftype,irecl,ier)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c    openrf uses direct access binary files with word size  irecl.
c    irecl = 128 on vax, 512 otherwise?
c
c      structure of random data file
c
c       block size=512 byte=128 word
c
c       block 1-3 : indx(4,0:indxl,u)
c       block 4-7 : cindx(u)*2048
c
c       first data block is 8
c
c       indx(1,0,u) address of eof (non exisiting)
c       indx(2,0,u)=no of entries
c       indx(3,0,u)=1776  for identification
c       indx(4,0,u)=704   same purpose
c
c       indx(1,n,u)=address of data n
c       indx(2,n,u)=no of words for data n
c       indx(3,n,u)=address of doc n
c       indx(4,n,u)=no of lines for doc n
c
c       cindx(u)(1:10)=ftype
c       cindx(u)(n*10+1:n*10+10)=skey for nkey n
c---------------------------
      implicit integer(a-z)
      parameter (indxl = 191, nu = 2)
      character*(*) ftype,lfn,aflag,sflag
      character*80 fname(nu),fn, aflg*10, sflg*10
      character*2048 cindx(nu)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt,exist
      logical clor, modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
ccc      data unit,nldoc/nu*0,0/
ccc      data abortf,safe/.true.,.false./
c
        clor =.false.
c   find out the case of this routine.
c   'case' controls the the case of this routine
       sflg  = sflag
       aflg  = aflag
       call smcase(aflg, 'case')
       call smcase(sflg, 'case')
c
      abortf = (aflg.ne.'noabort')
      safe   = safe.or.(sflg.eq.'safe')
c
c      if lfn is blank, lfn=for0un where un is fortran i/o no
      if(lfn.eq.' ') then
        fn = 'for0'
        write(fn(5:6),1,err=9999)iounit
    1   format(i2.2)
      else
        fn=lfn
      endif
      inquire (file=fn,exist=exist)
c
      call gunit(iounit,u)
      if(u.eq.0) then
c      assign iounit no to unit(n), a table
        do 100 n=1,nu
          if(unit(n).eq.0) then
            unit(n)=iounit
            u=n
            fname(u)=fn
            go to 110
          endif
 100     continue
c
        call cabort('openrf: max no of files exceeded',abortf)
        ier=1
        return
 110    continue
c
      else
        call echo('openrf: unit reopened')
      endif
c
      if(ftype.eq.' ') then
c      no modify permit
        modify(u)=.true.
      else
        modify(u)=.false.
      endif
c
      if(exist) then
c          file exists
        if(.not.modify(u)) then
c          can modify the file
          open(iounit, file=fn, recl=irecl, access='direct',
     $         status='old', iostat=iosb, err=9999)
        else
c          cannot modify the file
          open(iounit, file=fn, recl=irecl, access='direct',
     $                            status='old')
cccccc        $         ,readonly)
        endif
c          read in existing index
        do 10 i=1,3
          read(iounit,rec=i)((indx(k,l,u),k=1,4),l=i*64-64,i*64-1)
   10   continue
        do 20 i=1,4
          read(iounit,rec=i+3)cindx(u)(i*512-511:i*512)
   20   continue
c
        if(indx(3,0,u).ne.1776 .or. indx(4,0,u).ne.704) then
          call cabort('openrf: wrong file',abortf)
          ier=4
          return
        endif
        ier=0
c
        if(ftype.ne.' '.and.ftype.ne.cindx(u)(1:10))then
          call cabort('openrf: wrong file type',abortf)
          ier=3
          return
        endif
        return
c
c          new file
c
      else
        if(ftype.eq.' ') then
          call cabort('openrf: ftype needed for file creation',abortf)
          ier=5
          return
        endif
c          create a new file
        open(iounit,file=fn,recl=irecl,access='direct',
     x       status='new')
        cindx(u)=ftype
c          index initialization
        do 30 i=1,indxl
           do 30 j=1,4
              indx(j,i,u)=0
   30   continue
        indx(1,0,u)=8
        indx(2,0,u)=0
        indx(3,0,u)=1776
        indx(4,0,u)=704
        ier=0
        go to 99
      endif
c
      entry wrindx(iounit)
c          write out index
      call gunit(iounit,u)
   99 continue
      do 101 i=1,3
        write(iounit,rec=i,err=9999)
     $        ((indx(j,k,u),j=1,4),k=i*64-64,i*64-1)
  101 continue
      do 111 i=1,4
        write(iounit,rec=i+3,err=9999)cindx(u)(i*512-511:i*512)
  111 continue
        if(clor) go to 77
 9998 return
 9999 ier=iosb
      go to 9998
c
      entry closrf(iounit,ier)
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('openrf: unit not declared',abortf)
        ier=1
        return
      endif
c         reset i/o unit table
      unit(u)=0
      ier=0
c            if modified, rewrite index
         clor=.false.
      if(modify(u)) then
         clor=.true.
         go to 99
      endif
 77   continue
      close(iounit)
      clor=.false.
      return
c
      entry rwrtrf(iounit,ier)
c          rewrite interlock.  safeguard.
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('openrf: unit not declared',abortf)
        ier=1
        return
      endif
c
      rewrt=.true.
      return
c end subroutine openrf
      end
      block data uwbdat
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling 
c
c    block data statements for uwxafs 
c
      implicit integer(a-z)
      parameter (indxl = 191, nu = 2)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt
      logical modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      save /uwdata/
      data unit,nldoc/nu*0,0/
      data abortf,safe/.true.,.false./
c end block data
      end          
      subroutine getrec(iounit,array,nw,skey,nkey,ntw,ier)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c        get data record from a data file
c          iounit : i/o unit number (integer,input)
c          array  : array to receive data (any type,output)
c          nw     : maximum no of words to receive(integer,input)
c          skey   : symbolic key of data record to get(character,input)
c          nkey   : numeric key of data record to get(integer,input)
c          ntw    : actual no of words received(integer,output)
c          ier    : error code(integer,output)
c            1 - unit not declared
c            2 - nw .lt. 0
c            3 - nkey .gt. indxl .or. .lt. 0
c            4 - nkey not on file
c            5 - two keys do not match
c            6 - skey not on file
c          either nkey(with skey=' ') or skey(with nkey=0) may be
c          given.  if both are given, they should match.
c
      implicit integer(a-z)
c
      parameter (indxl=191, nu=2, iword=128 )
c
      character*(*) skey
      character*80 fname(nu)
      character*2048 cindx(nu)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt,modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
      real array(nw)
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('getrec: iounit not declared',abortf)
        ier=1
        return
      endif
c
      if(nw.le.0) then
        call cabort('getrec: no data to get',abortf)
        ier=2
        return
      endif
c
      last=indx(2,0,u)
      if(nkey.ne.0) then
        if(nkey.lt.0.or.nkey.gt.indxl) then
          call cabort('getrec: nkey out of bounds',abortf)
          ier=3
          return
        elseif(nkey.gt.last) then
          call cabort('getrec: nkey does not exist',abortf)
          ier=4
          return
        elseif((skey.ne.' ').and.(skey.ne.cindx(u)(nkey*10+1:
     $      nkey*10+10))) then
          call cabort('getrec: skey mismatch',abortf)
          ier=5
          return
        endif
      iord=nkey
c
c        skey is given
c
      else
        call gnkey(iounit,skey,iord,iii)
        if(iord.eq.0) then
          call cabort('getrec: skey not found',abortf)
          ier=6
          return
        endif
      endif
c
      pru=indx(1,iord,u)
      ntw=indx(2,iord,u)
      if(ntw.gt.nw) then
        ntw=nw
        call echo('getrec: field shorter than data')
      endif
c
c        iword is no of words in a block
      nblk  = ( ntw + iword - 1) / iword
      do 10 i = 1, nblk
        l = min(i*iword, ntw)
        read(iounit,rec=pru+i-1)(array(j),j=(i-1)*iword+1,l)
   10 continue
      ier=0
      return
c end subroutine getrec
      end
      subroutine getdoc(iounit,doc,nl,skey,nkey,ntl,ier)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c      get documentation lines from data file
c
c      input parameters
c        iounit : i/o unit number (integer,input)
c        doc    : document array (character,in-out)
c        nl     : no of lines to get (integer,input)
c        skey   : symbolic key of record (character,input)
c        nkey   : numeric key of record (integer,input)
c        ntc    : number of lines actually got(integer,output)
c        ier    : error code (integer,output)
c               1 - unit not declared
c               2 - nl negative or zero
c               3 - nkey .gt. indxl .or. nkey .lt. 1
c               4 - nkey is not on file
c               5 - skey and nkey don't match
c               6 - skey is not on file
c
c       if skey is blank, nkey is used. if nkey is 0, skey is used.
c       if both are given, they should match.
c
c       if doc is equal to 'doc' then data are transferred
c       to internal buffer.  nl is ignored in this case.
c       see routines getline, addline and prntdoc for
c         the manipulation of this buffer
c
      implicit integer(a-z)
      parameter (indxl = 191, nu = 2 )
c
      character*80   fname(nu), doctmp*100
      character*2048 cindx(nu)
      integer*2      indx(4,0:indxl,nu)
      logical        abortf, safe, rewrt, modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
      parameter (maxl=20, maxchr=100 )
      character*(maxchr) dbuf(maxl)
      common /uwdbuf/ dbuf
      save   /uwdbuf/
c
      character*(*) skey,doc(*)
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('getdoc: unit not declared',abortf)
        ier=1
        return
      endif
c
c convert form to the case of this routine.
c   'case' controls the the case of this routine
      doctmp = doc(1)
      call smcase(doctmp, 'case')
c
      if ((nl.le.0).and.(doctmp.ne.'doc')) then
        call cabort('getdoc: no document lines to get',abortf)
        ier=2
        return
      endif
c
      if(nkey.ne.0) then
        if(nkey.lt.0.or.nkey.gt.indxl) then
          call cabort('getdoc: nkey out of bounds',abortf)
          ier=3
          return
        elseif(indx(1,nkey,u).eq.0) then
          call cabort('getdoc: nkey does not exist',abortf)
          ier=4
          return
        elseif(skey.ne.' '.and.
     $      skey.ne.cindx(u)(nkey*10+1:nkey*10+10)) then
          call cabort('getdoc: skey mismatch',abortf)
          ier=5
          return
        endif
        iord=nkey
c      skey is not given
      else
        call gnkey(iounit,skey,iord,ier)
        if(iord.eq.0) then
          call cabort('getdoc: skey not found',abortf)
          ier=6
          return
        endif
      endif
c
      pru=indx(3,iord,u)
c
c      to document buffer
      if (doctmp.eq.'doc') then
        nldoc=indx(4,iord,u)
        nblk=(nldoc+4)/5
        ntl=nldoc
        do 10 i=1,nblk
          read(iounit,rec=pru+i-1) (dbuf(j),j=i*5-4,i*5)
   10   continue
c      to doc
      else
        ntl=indx(4,iord,u)
        ntl=min(ntl,nl)
        nblk=(ntl+4)/5
        do 20 i=1,nblk
          lblk=min(i*5,ntl)
          read(iounit,rec=pru+i-1) (doc(j),j=i*5-4,lblk)
   20   continue
      endif
      ier=0
      return
c end subroutine getdoc
      end
      subroutine hash(array, narray, doc, ndoc, skey)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c  generate 5 character string composed of alphanumerics
c
c   since this routine is not called too often, execution speed
c   is not as important as getting a reasonably pseudo-random skey.
c ***   note:  random numbers done as in numerical recipes
c-----------------------------------------------------------------------
       parameter(maxpts = 4096)
       parameter(imod =  6655, imul = 936, iadd = 1399)
       parameter(jmod = 14406, jmul = 967, jadd = 3041)
       parameter(kmod =  7875, kmul = 211, kadd = 1663)
       parameter(lmod =  6075, lmul = 106, ladd = 1283)
       parameter(ihalf= 3333, imost= 5555, jhalf= 7201, jthrd= 4821)
c
       double precision work(maxpts), sum(4), zero
       double precision pi, gold, goldm1, e1, aver, part
       parameter(zero = 0.d0, pi = 3.141592653589793d0 )
       parameter(e1= 2.7182818280)
       parameter(gold = 1.618033989d0, goldm1 = 0.618033989d0)
       character*(*)    doc(*)
       character*(5)    skey
       real             array(*)
       integer          ikey(5), iran(131)
       logical          loop
c
c initialize
       nwork  = 2*narray
       skey   = 'skey0'
       if (narray.le.0)   return
       ichr0  = ichar('0')
       ichra  = ichar('a')
       do 15 i = 1, 5
           ikey(i) = 0
 15    continue
       do 18 i = 1, 4
           sum(i)  = zero
 18    continue

c get measure of the magnitude of the data two different ways
c        ihalf ~= imod/2 , so that roughly half the values
c                          are used to make the partial sum
       aver  = 1.d-1
       part  = 2.d-1
       do 30 i = 1, narray
          aver  = abs( dble(array(i)) / narray ) + aver
          irndm = mod(imul*(i + narray)  + iadd, imod)
          if ( (i.gt.2) .and. (irndm.gt.ihalf) ) then
             part = abs( dble(array(i)) / narray ) + part
             if (irndm.gt.imost) then
                 part = abs( dble(array(i-2)) / narray ) + part
              else
                 part = abs( dble(array(i-1)) / narray ) + part
              end if
          end if
30     continue

c create work array such that all values of work are of the order 1.
c  - most values are scaled to one of the two different measures of
c    magnitude from above.
c  - a few values get scaled to be on the order of 1 without reference
c    to these values (should prevent against two arrays differing only
c    by a constant factor from having the same skey)
c  - couldn't resist the golden mean and fine structure constant.

       if (abs(aver).le.1.d-3) aver = 1.d-2
       if (abs(part).le.1.d-3) part = 1.d-2
       do 150 i = 1, narray
          loop           = .true.
          work(i)        = abs( dble(array(i)) / aver )
          work(i+narray) = abs( dble(array(i)) / part )
          j              = i*kmul + kadd + narray
          jrndm          = mod(jmul*j  + jadd, jmod)
          if ( jrndm.lt.jthrd ) then
              work(i) = work(i) * pi
          elseif ( jrndm.gt.jhalf ) then
              j              =  mod(i*j + jrndm, narray - 1 ) + 1
              work(i+narray) = abs( dble(array(i)+array(j)) / e1)
100           continue
                if(loop.and.(work(i+narray).le.(0.0072974d0))) then
                   work(i+narray) = work(i+narray) * gold
                   loop = .false.
                   go to 100
                elseif(loop.and.(work(i+narray).ge.( 137.036d0))) then
                   work(i+narray) = work(i+narray) * goldm1
                   loop = .false.
                   go to 100
                endif
          end if
150     continue
c
c generate iran: a list of 131 pseudo-random integers that
c                do not depend on the data at all
       do 200 i = 1, 131
            j       = i*imul + iadd
            jtmp    = mod(jmul*j    + jadd, jmod) + 1
            ktmp    = mod(kmul*jtmp + kadd, kmod) + 3
            iran(i) = mod(lmul*ktmp + ladd, lmod) + 7
200    continue
c
c collect 4 different sums from the work array:
c   each value in the work array is multiplied by a pseudo-randomly
c   selected integer between 20 and 120, and 4 different sums are made.
c   since each value in work() is on the order of 1, each of the sums
c   should be of the order 100*narray. with narray being something
c   between 100 and 1000, each of the different sums will be a random
c   number on the order of 50 000. this value mod 36 should be a good
c   random number.
c
       do 500 i = 1, nwork
c       get some random numbers, and make them bigger than 50
          i1 = mod (i * imul + iadd, imod ) + 53
          i2 = mod (i * jmul + jadd, jmod ) + 67
          i3 = mod (i * kmul + kadd, kmod ) + 31
          i4 = mod (i * lmul + ladd, lmod ) + 79

c       use these to make random numbers between [1, 130 ]
          j1 = mod( jmul*i1 + kadd, 109) + 3
          j2 = mod( kmul*i2 + ladd, 119) + 5
          j3 = mod( lmul*i3 + iadd, 111) + 7
          j4 = mod( imul*i4 + jadd, 123) + 1

c       use these for the iran array of random numbers to get a set
c                                   of numbers between [20 and 150]
          k1 = mod( jmul*( i4 + iran(j1)) + kadd,  73 ) + 43
          k2 = mod( kmul*( i2 + iran(j2)) + ladd, 111 ) + 37
          k3 = mod( lmul*( i1 + iran(j3)) + iadd,  91 ) + 29
          k4 = mod( imul*( i3 + iran(j4)) + jadd, 121 ) + 19

c       do "randomly weighted" sum of work array
          sum(1) = sum(1) + work(i) * k1
          sum(2) = sum(2) + work(i) * k2
          sum(3) = sum(3) + work(i) * k3
          sum(4) = sum(4) + work(i) * k4
500    continue

c turn the sums to integers between 1 and 36 for ikey(1) - ikey(4)
       do 900 i = 1, 4
 880      continue
          if (abs(sum(i)).ge.100 000 000) then
              sum(i) = sum(i) / gold
              go to 880
          end if
          isum  = int( sum(i) )
          ikey(i) = mod(isum, 36)
 900   continue

c ikey(5) : sum from document array
       isum = 0
       im   = mod(iran(16) * ndoc + iran(61), 353)  + 27
       ia   = mod(iran(77) * ndoc + iran(52), 347)  + 19

       do 2000 i = 1, ndoc
          call triml( doc(i) )
          jlen = max(1, istrln( doc(i)))
          do 1800 j = 1, jlen
             kseed = mod( (j + 2*i) * imul  + jadd , 127) + 1
             k     = mod( iran(kseed) * im  + ia   ,  13) + 3
             isum  = isum + k * ichar( doc(i)(j:j) )
1800      continue
2000   continue
       ikey(5) = mod(isum, 36)
c
c map integers 1 to 36 to numerals and letters
c   ascii assumed but not required. the numerals must be
c   ordered 0 - 9 and the letters must be ordered a - z.
       do 4000 i = 1, 5
         if (ikey(i).le.9) then
            ikey(i) = ikey(i) + ichr0
         else
            ikey(i) = ikey(i) - 10 + ichra
          end if
4000   continue

c write skey from ikey
       do 5000 i = 1, 5
          skey(i:i) = char( ikey(i) )
5000   continue
       call upper(skey)
       return
c end subroutine hash
       end
      subroutine gunit(iounit,u)
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c        match unit no with iounit no
c          iounit : fortran i/o unit no(integer,input)
c          u      : corresponding index(1,2.. upto nu, in order of
c                   call to openrf routine)(integer,output)
c            relation   unit(u)=iounit
      implicit integer(a-z)
c
      parameter (indxl=191, nu=2 )
c
      character*80 fname(nu)
      character*2048 cindx(nu)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt,modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
      u=0
      do 10 n=1,nu
          if(unit(n).eq.iounit)  then
              u = n
              go to 20
          end if
   10 continue
   20 continue
      return
c end subroutine gunit
      end
      subroutine rfmisc
c
c        copyright university of washington 1981
c        part of uwxafs binary (rdf) file handling
c
c  miscellaneous routines for handling uwexafs files.  most of
c  the entries here are to find out what's inside a file.
c        copyright university of washington 1981
c
      implicit integer(a-z)
c
      parameter (indxl=191, nu=2)
c
      character*(*) skey,ftype,lfn
      character*80 fname(nu)
      character*2048 cindx(nu)
      integer*2 indx(4,0:indxl,nu)
      logical abortf,safe,rewrt,modify(nu)
c
      common /uwdata/ unit(nu),modify,abortf,safe,rewrt,nldoc,indx
      common /uwdocs/ cindx,fname
c
      save /uwdata/,/uwdocs/
c
      entry gskey(iounit,nkey,skey,ier)
c
c          get symbolic key from a numeric key
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gskey: unit not declared',abortf)
        ier=1
        return
      endif
      if(nkey.lt.0.or.nkey.gt.indxl) then
        call cabort('gskey:  nkey out of range',abortf)
        ier=2
        return
      endif
c          if nkey does not exist, skey=' '
      skey=cindx(u)(nkey*10+1:nkey*10+10)
      ier=0
      return
c
      entry gnkey(iounit,skey,nkey,ier)
c
c          get a numeric key from a symbolic key
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gnkey:  unit not declared',abortf)
        ier=1
        return
      endif
c
      last=indx(2,0,u)
      do 300 n=1,last
        if(skey.eq.cindx(u)(n*10+1:n*10+10)) go to 310
  300 continue
c        skey not found
      nkey=0
      return
c
  310 continue
      nkey=n
      ier=0
      return
c
      entry gftype(iounit,ftype,ier)
c
c      get file-type from a i/o unit no
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gftype:  iounit not declared',abortf)
        ier=1
        return
      endif
c
      ftype=cindx(u)(1:10)
      ier=0
      return
c
      entry glfn(iounit,lfn,ier)
c
c        get filename from   i/o unit no
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gfln: iounit not declared',abortf)
        ier=1
        return
      endif
c
      lfn=fname(u)
      ier=0
      return
c
      entry gflen(iounit,flen,ier)
c
c         get the length of a file from i/o unit no
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gflen: iounit not declared',abortf)
        ier=1
        return
      endif
c
      flen=indx(1,0,u)-1
      return
c
      entry gnie(iounit,nie,ier)
c
c          get number of entries from i/o unit no
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gnie: iounit not declared ',abortf)
        ier=1
        return
      endif
c
      nie=indx(2,0,u)
      ier=0
      return
c
      entry grlen(iounit,nkey,rlen,ier)
c
c         get the length of a data record (in words) from a numeric key
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('grlen: iounit not declared ',abortf)
        ier=1
        return
      endif
c
      if(nkey.lt.0.or.nkey.gt.indxl) then
        call cabort('grlen: nkey out of range',abortf)
        ier=2
        return
      endif
c
      rlen=indx(2,nkey,u)
      ier=0
      return
c
      entry gdlen(iounit,nkey,dlen,ier)
c
c       get the length of document (in lines) from a numeric key
c
      call gunit(iounit,u)
      if(u.eq.0) then
        call cabort('gdlen: unit not declared',abortf)
        ier=1
        return
      endif
c
      if(nkey.lt.0.or.nkey.gt.indxl) then
        call cabort('gdlen: nkey out of range',abortf)
        ier=2
        return
      endif
c
      dlen=indx(4,nkey,u)
      ier=0
      return
c
c end subroutine rfmisc
      end

      subroutine messag(messg)
c
c  write message to  standard ouput with (1x,a) format
c
      character*(*) messg
      write(*,10)   messg
 10   format(1x,a)
      return
c end subroutine messag
      end

      integer function nbrstr(string)
c
c  find a number in a string
c  given a string that is known to begin with a digit or sign.
c  return the position of the end of the number.
c  nbrstr : position of end of number
      integer   istrln, i, ilen, iback
      character*(*)  string
      character*1    digit*10, plus, minus, d, e, decml, s, sp
      logical     lexp, ldecml
      data digit  /'1234567890'/
      data minus,plus,d,e,decml /'-','+','d','e','.'/
c------
      ldecml = .false.
      lexp   = .false.
      ilen   = istrln(string)
      nbrstr = ilen
      if (ilen.gt.1) then
         iback  = 1
c find end of number :  digits are always ok.
c stop at second d, e, decml, or sign that's not preceded by (d,e)
         do 200 i = 2, ilen
            sp = string(i-1:i-1)
            s  = string(i:i)
            if (index(digit,s).eq.0) then
               if ( (((s.ne.plus).and.(s.ne.minus).and.(s.ne.d)
     $                 .and.(s.ne.e).and.(s.ne.decml)))
     $          .or.((lexp.and.((s.eq.d).or.(s.eq.e))))
     $          .or.((ldecml.and.(s.eq.decml)))
     $          .or.((((s.eq.plus).or.(s.eq.minus)).and.
     $                (sp.ne.d).and.(sp.ne.e))) )     go to 210
               lexp   = lexp.or.(s.eq.d).or.(s.eq.e)
               ldecml = ldecml.or.(s.eq.decml)
            end if
 200     continue
         iback = 0
 210     continue
         nbrstr = i - 1 - iback
      end if
      return
c  end function nbrstr
      end

       subroutine iff_window(str)
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2002 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: ifeffit: generate xafs fourier transform window
c
c arguments:
c      str     command line to performd                 [in]
c
c requires: istrln, getsca, gettxt, bkeys, lower, str2re,
c           echo, cffti, window, lintrp, xafsft, setsca, settxt
c
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fft.h'
       save
       integer  nxpar, ifft
       parameter (nxpar = 11)
       character*(*) str, defkey(3)*64, tnam*256
       character*256 x_arr, winnam*32
       character*256 name1, wintyp, outtyp, myname*5
       character*10  params(nxpar)

       double precision getsca, xmin, xmax, xw, dx1, dx2, xmout
       double precision xgrid
       double precision arr_x(maxpts), arr_w(maxpts), txx(maxpts)
       integer  npts_x, npts_r, npts_i, npts_w, npts_p, jxar,nptsxx
       integer  jwin, jrea, jima, jpha, i, k, jdot, idwin
       integer  ier,  istrln, ndfkey, ipos, nxout
       integer  iff_eval, iff_eval_dp, iff_eval_in
       logical  xm_set 
       external iff_eval, iff_eval_dp, iff_eval_in
       external getsca, istrln

       data (params(i), i=1, nxpar) /'k', 'dk', 'dk1', 'dk2',
     $      'kmin', 'kmax', 'kweight', 'kwindow', 'win', 'rsp',
     $      'rmax_out'/
c
c initialize 
c set default program variables to use based on "key"
       call iff_sync
       xgrid  = qgrid

c
c get default values of relevant program variables
c   scalars:
       xm_set = .false.
       myname = 'window'
       dx1    = getsca(params(3),1)
       dx2    = getsca(params(4),1)
       if ((abs(dx1).le.tiny).and.(abs(dx2).le.tiny)) then
          dx1 = getsca(params(2),1)
          dx2 = dx1
       endif
       xmin   = getsca(params(5),1)
       xmax   = getsca(params(6),1)
       xw     = getsca(params(7),1)
       xmout  = getsca(params(11),1)
       outtyp = params(10)
       wintyp = params( 9)
c   strings:
       x_arr  = undef
       name1  = undef
c parse command line
       call bkeys(str, mkeys, keys, values, nkeys)
       ndfkey    = 1
       defkey(1) = params(1)

       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then
             name1 = values(i)
          elseif (keys(i).eq.params(1)) then
             x_arr = values(i)
             call lower(x_arr)
          elseif (keys(i).eq.params(2)) then
             ier = iff_eval_dp(values(i),dx1)
             dx2 = dx1
          elseif (keys(i).eq.params(3)) then
             ier = iff_eval_dp(values(i),dx1)
          elseif (keys(i).eq.params(4)) then
             ier = iff_eval_dp(values(i),dx2)
          elseif (keys(i).eq.params(5)) then
             ier = iff_eval_dp(values(i),xmin)
          elseif (keys(i).eq.params(6)) then
             ier = iff_eval_dp(values(i),xmax)
          elseif (keys(i).eq.params(7)) then
             ier = iff_eval_dp(values(i),xw)
          elseif (keys(i).eq.params(8)) then
             winnam = values(i)
             call lower(winnam)
          elseif (keys(i).eq.params(11)) then
             ier = iff_eval_dp(values(i),xmout)
             xm_set = .true.
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,
     $            ' *** '//myname//' : unknown keyword " '//messg)
          end if
 100   continue

c

c get/resolve array names
c    if name1 not given, inherit from x_arr, re_arr, or im_arr.
       if (name1.eq.undef) then
          jdot = index(x_arr,'.')
          if (jdot.ne.0) name1 = x_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' '//myname//': can''t determine group name')
          return             
       endif
       call fixnam(name1, 1)
       call lower(name1)

       do 180 i = 1, maxpts
          arr_x(i) = zero
          arr_w(i) = zero
 180   continue
c evaluate the x array
       jxar = iff_eval(x_arr,  name1, arr_x, npts_x)
       if (jxar.le.0) then
          call warn(2, ' '//myname//': no x array?')
          return
       endif

c get window function 
       call window(winnam,dx1,dx2,xmin,xmax,xgrid,maxpts,arr_w)

c window array
c   if an x-array has been supplied, interpolate the evenly-spaced
c   window array used in the FT onto the provided x-array
       if (jxar.ge.1) then
          do 300 i = 1, maxpts
             txx(i) = (i-1) * xgrid
 300      continue
          ipos = 0
          do 310 i = 1, npts_x
             call lintrp(txx, arr_w, maxpts, arr_x(i),
     $            ipos, tmparr(i))
 310      continue
          call set_array(wintyp, name1, tmparr, npts_x, 1)          
       endif
c
c scalars:
       call setsca(params(3),  dx1)
       call setsca(params(4),  dx2)
       call setsca(params(5),  xmin)
       call setsca(params(6),  xmax)
       call setsca(params(7),  xw)
       call setsca(params(11), xmout)
       call settxt(params(8),  winnam)
       return
c end subroutine iff_fft
       end

       subroutine xafsft(mpts, chip, wa, xgrid, xwgh, wfftc,jfft,chiq)
c
c  xafs fourier transform. includes k-weighting, an arbitrary window
c  function, and mapping from FT conjugates (k,2R) to (k,R), with
c  rational normalization
c
c  fft routines cfftf/b (from fftpack) are used in subroutine xfft.
c
c  arrays wa and wfftc must be initialized before this routine:
c      wfftc  must be initialized by "cffti".
c      wa     is probably initialized by "window".
c  arguments
c    mpts     dimension of arrays chip and wa                  [in]
c    chip     complex array of input data, on uniform grid     [in]
c             chip(1) = chi(x=0.), zero-padding expected.
c    wa       real array of window function                    [in]
c    xgrid    grid spacing for chip                            [in]
c    xwgh     x-weight                                         [in]
c    wfftc    work array for fft                               [in]
c    jfft     integer controlling functionality                [in]
c               1   forward transform (k->r)
c               0   no transform (returns windowed data)
c              -1   reverse transform (r->k)
c    chiq     complex fourier transform of chip               [out]
c
c  copyright 1997   matthew newville
c--------------------------------------------------------------------
       implicit none
       integer  i, mpts, jfft, ixwgh
       double precision  wfftc(*), wa(*), xwgh, dx, xgrid
       double precision  sqrtpi, eps7, eps4
       complex*16  chip(*), chiq(*), cnorm
       parameter(sqrtpi = 0.5641895835d0, eps7=1.d-7, eps4=1.d-4)

c                sqrtpi = 1 / sqrt(pi)
c complex normalization constant, for the transform from r to k in
c    xafs, the xgrid is assumed to be the grid in r *not* in 2r.
c    to normalize correctly, cnorm must be multiplied by 2.
c    note that if we're not doing fft, we don't want to normalize
       cnorm = xgrid * sqrtpi * (1.d0,0.d0)
       if (jfft.lt.0) cnorm = 2 * cnorm
       if (jfft.eq.0) cnorm = (1.d0,0.d0)
c make chiq as  k-weighted and windowed chip
c   if xwgh is really an integer, do only the integer exponentiation
       ixwgh = int(xwgh)
       if (ixwgh.eq.0) then 
          do 40 i = 1, mpts
             chiq(i) = (0,0)
             if (wa(i) .gt. eps7) chiq(i) = cnorm * chip(i) * wa(i)
 40       continue
       else 
          do 50 i = 1, mpts
             chiq(i) = (0,0)
             if (wa(i) .gt. eps7) chiq(i) = cnorm * chip(i) * wa(i)
     $            * ((i-1) * xgrid)**ixwgh
 50       continue
       end if
c   do fp exponentiation only if it will be noticeable
       dx = xwgh - ixwgh
       if (dx .gt. eps4) then
          do 60 i = 1, mpts
             if (wa(i).gt.eps7) chiq(i) = chiq(i) * ((i-1)*xgrid)**dx
 60       continue
       end if
c do fft on modified array, chiq (fft is done in place):
c    jfft > 0:  cfftf, k->r, forward fft
c    jfft < 0:  cfftb, r->k, reverse fft
c    jfft = 0:  no fft, chiq returned as is (ie, after weighting)
       if (jfft.gt.0) call cfftf(mpts,chiq,wfftc)
       if (jfft.lt.0) call cfftb(mpts,chiq,wfftc)
       return
c  end subroutine xafsft
       end

c
c The Mersenne Twister Algorithm, taken and adapted from MT19937.f:
c Copyright (C) 1997 Makoto Matsumoto and Takuji Nishimura.
c
c the distribution functions by Matt Newville, looking at sources
c from Python 2.3.3 random.py and Numerical Recipes
c
c A C-program for MT19937: Real number version
c   genrand() generates one pseudorandom real number (double)
c which is uniformly distributed on [0,1]-interval, for each
c call. sgenrand(seed) set initial values to the working area
c of 624 words. Before genrand(), sgenrand(seed) must be
c called once. (seed is any 32-bit integer except for 0).
c Integer generator is obtained by modifying two lines.
c   Coded by Takuji Nishimura, considering the suggestions by
c Topher Cooper and Marc Rieffel in July-Aug. 1997.
c
c This library is free software; you can redistribute it and/or
c modify it under the terms of the GNU Library General Public
c License as published by the Free Software Foundation; either
c version 2 of the License, or (at your option) any later
c version.
c This library is distributed in the hope that it will be useful,
c but WITHOUT ANY WARRANTY; without even the implied warranty of
c MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
c See the GNU Library General Public License for more details.
c You should have received a copy of the GNU Library General
c Public License along with this library; if not, write to the
c Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
c 02111-1307  USA
c
c Copyright (C) 1997 Makoto Matsumoto and Takuji Nishimura.
c When you use this, send an email to: matumoto@math.keio.ac.jp
c with an appropriate reference to your work.
c
c***********************************************************************
c Fortran translation by Hiroshi Takano.  Jan. 13, 1999.
c
c   genrand()      -> double precision function grnd()
c   sgenrand(seed) -> subroutine sgrnd(seed)
c                     integer seed
c
c This program uses the following non-standard intrinsics.
c   ishft(i,n): If n>0, shifts bits in i by n positions to left.
c               If n<0, shifts bits in i by n positions to right.
c   iand (i,j): Performs logical AND on corresponding bits of i and j.
c   ior  (i,j): Performs inclusive OR on corresponding bits of i and j.
c   ieor (i,j): Performs exclusive OR on corresponding bits of i and j.
c
c***********************************************************************
cc this main() outputs first 1000 generated numbers
c       program main
cc      
c       implicit none
c       integer no, j, k
cc      
c       parameter(no=10000)
c       double precision r(0:7), randmt
c       external randmt
cc
cc      any nonzero integer can be used as a seed
c       call seed_randmt(32054)
c       do 1000 j=0,no-1
c          r(mod(j,8))=randmt()
c          if(mod(j,8).eq.7) then
c             write(*,'(8(f8.6,'' ''))') (r(k),k=0,7)
c        else if(j.eq.no-1) then
c           write(*,'(8(f8.6,'' ''))') (r(k),k=0,mod(no-1,8))
c        endif
c 1000 continue
cc
c      stop
c      end
c***********************************************************************
       subroutine seed_randmt(seed)
c
       implicit none
       integer n, seed
       parameter(n =  624)
       integer mt(0:n-1), mti
c      the array for the state vector
       common /randmt_block/mti,mt
       save   /randmt_block/
c
c      setting initial seeds to mt[N] using
c      the generator Line 25 of Table 1 in
c      [KNUTH 1981, The Art of Computer Programming
c         Vol. 2 (2nd Ed.), pp102]

       if (seed .eq. 0) seed = 4357
       mt(0)= iand(seed,-1)
       do 10 mti=1,n-1
          mt(mti) = iand(69069 * mt(mti-1),-1)
 10    continue
cc       print*, ' seed random numbers to ', seed
c
       return
       end
c***********************************************************************
       double precision function randmt()
c      
       implicit none
       integer n,n1,m,mata,kk
       integer umask,lmask,tmaskb,tmaskc
c
c period parameters
       parameter(n     =  624)
       parameter(n1    =  n+1)
       parameter(m     =  397)
       parameter(mata  = -1727483681) ! constant vector a
c       parameter(umask = -2147483648) ! most significant w-r bits
       parameter(lmask =  2147483647) ! least significant r bits
       parameter(tmaskb= -1658038656) ! tempering parameters
       parameter(tmaskc= -272236544)
       double precision scale, scalem1
       parameter(scale = 2.0d0**32, scalem1=2.0d0**32-1.0d0)
c      
       integer mt(0:n-1),mti
c      the array for the state vector
       common /randmt_block/ mti,mt
       save   /randmt_block/
       data   mti/n1/
c                     mti==n+1 means mt[n] is not initialized
c
       integer mag01(0:1),y
       data mag01/0, mata/
       data y/0/
       save mag01,y
c                        mag01(x) = x * mata for x=0,1
c      
       umask = -lmask - 1
       if(mti.ge.n) then
          if (mti.eq.n1) call seed_randmt(4357)
c  generate n words at one time
          do 100 kk=0,n-m-1
             y=ior(iand(mt(kk),umask),iand(mt(kk+1),lmask))
             mt(kk)=ieor(ieor(mt(kk+m),ishft(y,-1)),mag01(iand(y,1)))
 100      continue
          do 200 kk=n-m,n-2
             y=ior(iand(mt(kk),umask),iand(mt(kk+1),lmask))
             mt(kk)=ieor(ieor(mt(kk+(m-n)),ishft(y,-1)),
     $            mag01(iand(y,1)))
 200      continue
          y=ior(iand(mt(n-1),umask),iand(mt(0),lmask))
          mt(n-1)=ieor(ieor(mt(m-1),ishft(y,-1)),mag01(iand(y,1)))
          mti = 0
       endif
c      
       y=mt(mti)
       mti=mti+1
       y=ieor(y,ishft(y,-11))
       y=ieor(y,iand(ishft(y,7),tmaskb))
       y=ieor(y,iand(ishft(y,15),tmaskc))
       y=ieor(y,ishft(y,-18))
c      
       if(y.lt.0) then
          randmt=(dble(y)+scale)/(scalem1)
       else
          randmt=dble(y)/(scalem1)
       endif
c      
       return
       end
ccc
ccc
ccc generate gaussian distribution of random numbers
       double precision function gauss_rand()
c
       implicit none
       double precision gauss_save, rnorm, r1, r2
       double precision randmt, f 
       external         randmt
       logical  toggle
       save     toggle, gauss_save
       data     toggle /.false./
c      
       if (toggle) then
          gauss_rand = gauss_save 
       else
 10       continue 
          r1    = 2 * randmt() - 1
          r2    = 2 * randmt() - 1
          rnorm = r1*r1 + r2*r2
          if (rnorm.ge.1.or.rnorm.eq.0) go to 10
          f = sqrt(-2 * log(rnorm)/rnorm) 
          gauss_save = r1 * f
          gauss_rand = r2 * f
       endif
       toggle = .not.toggle
       return
c end real function gauss_rand
       end

ccc
ccc generate normal distribution of random numbers
       double precision function normal_rand()
c
       implicit none
       double precision rnorm_save,  r1, r2
       double precision randmt, z, half, magic_nv
       parameter (half = 0.5d0)
c                 magic_nv = 4*exp(-0.5)/sqrt(2)
       parameter (magic_nv = 1.715527769921414d0)
       external         randmt
c      
 10    continue 
       r1  = randmt()
       r2  = 1 - randmt()
       z   = magic_nv*(r1-half)/r2
       if (z*z.gt.-4*log(r2)) goto 10
       
       normal_rand = z
       return
c end real function normal_rand
       end

      subroutine dirac (nqns,nqls,nks,imax,de,dfls,dq1s,jc)
c
c solution of the dirac equation
c nqns=principal quantum number; nqls=orbital quantum number
c nks=kappa quantum number;  imax=the last tabulated point of the
c wave function; de=energy;   dfls=power of the first term of the
c developpement limite; dq1s=slope at the origin of dp or dq
c **********************************************************************
      implicit double precision (a-h,o-z)
      save
      include 'atom.h'

cc      common /dira/ dv(251), dr(251), dp(251), dq(251), dpas, test,
cc     1              z, nstop, nes, np, nuc
c
c dv=potential in a.u. and negative;  dr=radial mesh
c dp=large component;    dq=small component;    dpas=exponential step;
c nes=number of attempts to adjust the energy
c z=atomic number; nstop controls the numeric integration
c test=precision obtained in the energies; np=maximum number of points
c finite nuclear size if nuc is non-zero
c **********************************************************************
cc      common /ps1/ dep(5), deq(5), db, dvc, dsal, dk, dm
c
c dep,deq=derivatives of op and dq;  db=energie/dvc;
c dvc=speed of light in a.u.; dsal=2.*dvc;  dk=kappa quantum number
c dm=exponential step/720., dkoef=1./720.
c **********************************************************************
cc      common /trois/ dpno(4,30), dqno(4,30)
      data dkoef /.1388888888888888d-2/
      nstop=0
      dvc=alpinv
      dsal=dvc+dvc
      imm=0
      ies=0
      dk=nks
      lll=(nqls*(nqls+1))/2
      nd=0
      noeud=nqns-nqls
      if (lll.ne.0) go to 10
      elim=-z*z/(1.5d0*nqns*nqns)
      go to 40
   10 elim=dv(1)+lll/(dr(1)*dr(1))
      do 20 i=2,np
      val=dv(i)+lll/(dr(i)*dr(i))
      if (val.le.elim) elim=val
   20 continue
      if (elim) 40,30,30
   30 nstop=17
c 2*v+l*(l+1)/r**2 is everywhere positive
c **********************************************************************
      return
   40 if (de.le.elim) de=elim*half
   50 if (imm.eq.1) go to 80
      do 60 i=7,np,2
      imat=np+1-i
      if ((dv(imat)+lll/(dr(imat)*dr(imat))-de).le.zero) go to 70
   60 continue
   70 if (imat.gt.5) go to 80
      de=de*half
      if (de.lt.-test.and.nd.le.noeud) go to 50
      nstop=28
c 2*v+l*(l+1)/r**2-2*e is everywhere positive
c **********************************************************************
      return
c initial value for the outward integration
c **********************************************************************
   80 db=de/dvc
      call inouh (dp,dq,dr,dq1s,dfls,dv(1),z,test,nuc,nstop,jc)
      if (nstop) 310,90,310
c     nstop=45
c the expansion at the origin does not converge
c **********************************************************************
   90 nd=1
      do 110 i=1,5
      dval=dr(i)**dfls
      if (i.eq.1) go to 100
      if (dp(i-1).eq.zero) go to 100
      if ((dp(i)/dp(i-1)).gt.zero) go to 100
      nd=nd+1
  100 dp(i)=dp(i)*dval
      dq(i)=dq(i)*dval
      dep(i)=dep(i)*dval
  110 deq(i)=deq(i)*dval
      k=-1+2*(noeud-2*(noeud/2))
      if ((dp(1)*k).gt.zero) go to 130
  120 nstop=53
c error in the expansion at the origin
c **********************************************************************
      return
  130 if ((k*nks*dq(1)).lt.zero) go to 120
      dm=dpas*dkoef
c outward integration
c **********************************************************************
      do 140 i=6,imat
      dp(i)=dp(i-1)
      dq(i)=dq(i-1)
      call inth (dp(i),dq(i),dv(i),dr(i))
      if (dp(i-1).eq.zero) go to 140
      if ((dp(i)/dp(i-1)).gt.zero) go to 140
      nd=nd+1
      if (nd.gt.noeud) go to 150
  140 continue
      if (nd.eq.noeud) go to 160
      de=0.8d0*de
      if (de.lt.-test) go to 50
      nstop=206
c the number of nodes is too small
c **********************************************************************
      return
  150 de=1.2d0*de
      if (de.gt.elim) go to 50
      nstop=210
c the number of nodes is too big
c **********************************************************************
      return
c initial values for the inward integration
c **********************************************************************
  160 dqm=dq(imat)
      dpm=dp(imat)
      if (imm.eq.1) go to 180
      do 170 i=1,np,2
      imax=np+1-i
      if(((dv(imax)-de)*dr(imax)*dr(imax)).le.300.0d0) go to 180
  170 continue
  180 dd=sqrt(-de*(2+db/dvc))
      dpq=-dd/(dsal+db)
      dm=-dm
      do 190 i=1,5
      j=imax+1-i
      dp(j)=exp(-dd*dr(j))
      dep(i)=-dd*dp(j)*dr(j)
      dq(j)=dpq*dp(j)
  190 deq(i)=dpq*dep(i)
      m=imax-5
c inward integration
c***********************************************************************
      do 200 i=imat,m
      j=m+imat-i
      dp(j)=dp(j+1)
      dq(j)=dq(j+1)
  200 call inth (dp(j),dq(j),dv(j),dr(j))
c joining of the large components
c **********************************************************************
      dval=dpm/dp(imat)
      if (dval.gt.zero) go to 210
      nstop=312
c error in the sign of the large component
c **********************************************************************
      return
  210 do 220 i=imat,imax
      dp(i)=dp(i)*dval
  220 dq(i)=dq(i)*dval
c calculation of the norm
c **********************************************************************
      dsum=3*dr(1)*(dp(1)**2+dq(1)**2)/(dpas*(dfls+dfls+1))
      do 230 i=3,imax,2
  230 dsum=dsum+dr(i)*(dp(i)**2+dq(i)**2)+4.0*dr(i-1)*(dp(i-1)**2 +
     $        dq(i-1)**2)+dr(i-2)*(dp(i-2)**2+dq(i-2)**2)

      dsum=dpas*(dsum+dr(imat)*(dqm*dqm-dq(imat)*dq(imat)))*third
c modification of the energy
c **********************************************************************
      dbe=dp(imat)*(dqm-dq(imat))*dvc/dsum
      imm=0
      val=abs(dbe/de)
      if (val.le.test) go to 260
  240 dval=de+dbe
      if (dval.lt.zero) go to 250
      dbe=dbe*half
      val=val*half
      if (val.gt.test) go to 240
      nstop=345
c energie nulle
c **********************************************************************
      return
  250 de=dval
      if (val.le.0.1d0) imm=1
      ies=ies+1
      if (ies.le.nes) go to 50
      nstop=362
c number of iterations too big
c **********************************************************************
      return
  260 dsum=sqrt(dsum)
      dq1s=dq1s/dsum
      do 270 i=1,imax
      dp(i)=dp(i)/dsum
  270 dq(i)=dq(i)/dsum
      do 280 i=1,4
      dpno(i,jc)=dpno(i,jc)/dsum
  280 dqno(i,jc)=dqno(i,jc)/dsum
      if (imax.eq.np) go to 300
      j=imax+1
      do 290 i=j,np
      dp(i)=zero
  290 dq(i)=zero
  300 nstop=0
  310 return
      end

       subroutine iff_save(string)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  save session to a  PAD save file
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       save
       integer       max_groups, igr
       parameter (max_groups=256)
       integer        i, k, istrln,  ndfkey, ilen, inn, get_array
       integer        npack, iex, ier, lun, isn, isf, iff_eval_in
       integer        j,jl
       character*256  defkey(2)*64, file, s2, string*(*), build
       character*256  groups(max_groups)
       character*10   stat, spad*20, vers
       logical s_str, s_sca, s_arr, s_sys, s_psc, dsave
       double precision getsca
       parameter (stat = 'unknown' , vers = '1.02')
       external istrln, iff_eval_in, get_array, getsca

       if (int(getsca('&sync_level',0)).ge.1)  call iff_sync
       file  = 'ifeffit.sav'
       call  gettxt('&build', build)
       npack = 8
       s_str = .true.
       s_sca = .true.
       s_arr = .true.
       s_psc = .false.
       s_sys = .false.
       igr   = 0
       do 10 i = 1, max_groups
          groups(i) = undef
 10    continue 
c  interpret any and all keyword/value pairs for setting options
       call bkeys(string, mkeys, keys, values, nkeys)
       ndfkey    = 1
       defkey(1) = 'file'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'file')  then
             file = values(i)
          elseif (keys(i).eq.'group')  then
             igr = igr + 1
             if (igr.le.max_groups) groups(igr) = values(i)
          elseif ((keys(i).eq.'npad').or.(keys(i).eq.'npack')) then
             ier = iff_eval_in(values(i),npack)
          elseif (keys(i).eq.'no_strings')  then
             s_str = .false.
          elseif (keys(i).eq.'with_strings')  then
             s_str = .true.
          elseif (keys(i).eq.'no_scalars')  then
             s_sca = .false.
          elseif (keys(i).eq.'with_scalars')  then
             s_sca = .true.
          elseif (keys(i).eq.'pad_scalars')  then
             s_psc = .true.
          elseif (keys(i).eq.'no_pad_scalars')  then
             s_psc = .false.
          elseif (keys(i).eq.'no_arrays')  then
             s_arr = .false.
          elseif (keys(i).eq.'with_arrays')  then
             s_arr = .true.
          elseif (keys(i).eq.'no_sys')  then
             s_sys = .false.
          elseif (keys(i).eq.'with_sys')  then
             s_sys = .true.
          elseif (keys(i).eq.'arrays_only')  then
             s_sca = .false.
             s_str = .false.
             s_arr = .true.
          elseif (keys(i).eq.'scalars_only')  then
             s_sca = .true.
             s_str = .false.
             s_arr = .false.
          elseif (keys(i).eq.'strings_only')  then
             s_sca = .false.
             s_str = .true.
             s_arr = .false.
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** save: unknown keyword " '//messg)
          end if
 100   continue 
       call undels(file)
       iex  = 0
       ier  = 0
       lun  = 3
       call openfl(lun, file, stat, iex, ier)
       if ((ier.lt.0).or.(iex.lt.0)) then
          call warn(2,' *** save: error opening file ')
          return
       end if
       write(lun,'(3a,i3)') '#:IFEFFIT SAVE File: v',vers,
     $      '  npad =',npack
       ilen = istrln(build)
       write(lun,'(2a)') '#:build ', build(1:ilen)
       write(lun,'(a)')  '#:strings'
       if (s_str) then
          do 210 i = 1, maxtxt
             if ((txtnam(i).ne.' ').and. (text(i).ne.' ') .and.
     $            (txtnam(i)(1:1).ne.'&')) then
                isn = max(1,istrln(txtnam(i)))
                isf = max(1,istrln(text(i)))
                write(lun,'(4a)') '#= ',txtnam(i)(1:isn),
     $               '= ',text(i)(1:isf)
             endif
 210      continue 
       end if
c
       write(lun,'(a)') '#:system'
       if (s_sys) then 
          do 220 i = 1, maxsca
             if ((scanam(i).ne.' ').and.(scanam(i)(1:1).eq.'&')) then
                call pad(scalar(i),npack,spad)
                isn = max(1,istrln(scanam(i)))
                s2  = scafrm(i)
                isf = istrln(s2)
                if (icdsca(1,i).eq.-1) then
                   write(lun,'(4a)') '#? ', scanam(i)(1:isn), ' ',
     $                  spad(1:npack)
                elseif ((s2.eq.' ').or.(isf.eq.0)) then
                   write(lun,'(4a)') '#% ', scanam(i)(1:isn), ' ',
     $                  spad(1:npack)
                else
                   write(lun,'(4a)') '#= ', scanam(i)(1:isn), ' = ',
     $                  s2(1:isf)
                end if
             end if
 220      continue 
       end if

       if (s_psc) then
          write(lun,'(a)') '#:scalars (pad)'
       else
          write(lun,'(a)') '#:scalars (nopad)'
       endif
       if (s_sca) then 
          do 230 i = 1, maxsca
             if ((scanam(i).ne.' ').and.(scanam(i)(1:1).ne.'&')) then
                call pad(scalar(i),npack,spad)
                spad(npack+1:)= ' '
                if (.not.s_psc) write(spad, '(g19.13)') scalar(i)
                isn = max(1,istrln(scanam(i)))
                s2  = scafrm(i)
                isf = istrln(s2)
                if (icdsca(1,i).eq.-1) then
                   write(lun,'(4a)') '#? ', scanam(i)(1:isn),' ',spad
                elseif ((s2.eq.' ').or.(isf.eq.0)) then
                   write(lun,'(4a)') '#% ', scanam(i)(1:isn),' ',spad
                else
                   write(lun,'(4a)') '#= ', scanam(i)(1:isn), ' = ',
     $                  s2(1:isf)
                end if
             end if
 230      continue 
       end if
c arrays      
       write(lun,'(a)') '#:arrays'
       if (s_arr) then 
          do 340 i = 1, maxarr-1
             if ((arrnam(i).ne.blank) .and. (arrnam(i).ne.undef)) then
                dsave = .true.
                if (igr.ge.1) then
                   dsave = .false.
                   j     = index(arrnam(i),'.')
                   do 305 k = 1, igr
                      jl = istrln(groups(k))
                      if (arrnam(i)(1:j-1).eq.groups(k)(1:jl)) then
                         dsave = .true.
                         goto 307
                      endif
 305               continue 
 307               continue 
                endif
                if (dsave) then
                   isn = max(1,istrln(arrnam(i)))
                   s2  = arrfrm(i)
                   isf = istrln(arrfrm(i))
                   if ((s2.eq.' ').or.(isf.eq.0)) then
                      inn  = get_array(arrnam(i),'',0,tmparr)
                      write(lun,'(a,i6,2a)') '#% [', inn, '] ',
     $                     arrnam(i)(1:isn)
                      call wrpadd(lun,npack,tmparr,inn)
                   else
                      write(lun,'(a,i6,4a)') '#= [', narray(i), '] ', 
     $                     arrnam(i)(1:isn), ' = ', s2(1:isf)
                   end if
                end if 
             endif
 340      continue 
       end if
       if (lun.gt.0) close(lun)
       return
       end
c
       subroutine iff_restore(string)
c
c  restore session from a  PAD save file
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       save
       integer   i, j, k, istrln,  ndfkey, ierr, in1, in2
       integer   npack, iex, ier, lun, nwords, ntmp, iread_ky
       integer   iofstr, iofsca, ilen, i_sync
       character*256    defkey(2)*64, file, s1, s2, string*(*)
       character*10     stat, pre*2, vers, words(2)*(20), str*256
       double precision unpad, xvers, getsca
       logical      sc_pad
       parameter (stat = 'old')
       external unpad, istrln, iofstr, iofsca, iread_ky, getsca
       file = 'ifeffit.sav'
c  interpret any and all keyword/value pairs for setting options
       call bkeys(string, mkeys, keys, values, nkeys)
cc       print*, ' iff_restore : ', string(1:70)
cc       print*, ' iff_restore : ', file(1:40)
       ndfkey    = 1
       defkey(1) = 'file'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'file')  then
             file = values(i)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** restore: unknown keyword " '//messg)
          end if
 100   continue 
c 
c note that the sync_level is stored here (otherwise we'd "restore" it!)
       i_sync = int(getsca('&sync_level',0))
       if (i_sync.ge.3)  call iff_sync

       call undels(file)
       iex  = 0
       ier  = 0
       lun  = -1
       call openfl(lun, file, stat, iex, ier)
       if ((ier.lt.0).or.(iex.lt.0).or.(lun.le.0)) then
          ilen  = istrln(file)
          messg = ' *** restore: cannot open file '//file(1:ilen)
          call warn(2,messg)
          if (lun.gt.0) close(lun)
          return
       end if
c top line
       ilen = iread_ky(lun, pre, str)
       vers  = 'null'
       npack = 0
       if ((pre.eq.'#:').and.(str(1:20).eq.'IFEFFIT SAVE File: v')) then
          vers = str(21:25)
          call triml(vers)
          call lower(vers)
          call str2dp(vers,xvers,ier)
          s2   = str(26:)
          call lower(s2)
          nwords = 2
          call bwords(s2,nwords,words)
          if (words(1).eq.'npad') call str2in(words(2),npack,ierr)
       endif
       if ((npack.le.0).or.(npack.ge.16).or.(vers.eq.'null')) goto 1010
c next line must be 'build'
       if (xvers.ge.1.01) then
          ilen = iread_ky(lun, pre, str)
          if ((pre.ne.'#:').or.(str(1:5).ne.'build')) goto 1010
       endif
c next line must be 'strings'
       ilen = iread_ky(lun, pre, str)
       if ((pre.ne.'#:').or.(str(1:3).ne.'str')) goto 1010
c read strings
cc       print*,' strings:'
 150   continue 
         ilen = iread_ky(lun, pre, str)
         if ((pre.eq.'#:').and.(str(1:3).eq.'sys')) goto 200
         if (pre.ne.'#=') goto 1010
         nwords   = 2
         words(1) = ' '
         words(2) = ' '
         call bwords(str,nwords,words)
         i         = iofstr(words(1),1)
         txtnam(i) = words(1)
         call strclp(str, words(1), words(2), text(i))
       go to 150
c scalars
 200   continue 

 250   continue 
       nwords = 2
       words(1) = ' '
       words(2) = ' '
       ilen = iread_ky(lun, pre, str)
cc       print*, ' pre, str = ', pre, ',  ', str(1:30)
       if ((pre.eq.'#:').and.(str(1:3).eq.'sca')) goto 300
       call bwords(str, nwords,words)
       i         = iofsca( words(1), 1)
cc       print*, ' iofsca = ', i
       scanam(i) = words(1)
       scafrm(i) = ' '
       if (pre.eq.'#?') then
          scalar(i)   = unpad(words(2), npack)
          icdsca(1,i) = -1
       elseif (pre.eq.'#%') then
          scalar(i)   = unpad(words(2), npack)
          icdsca(1,i) = i + jscale
       elseif (pre.eq.'#=') then
          call iff_set('def',str,.false.)
       else
          goto 1010
       endif
       goto 250
 300   continue 
       sc_pad = .true.
       if ( (xvers.ge.1.015)  .and.
     $      (index(str(4:),'(nopad)').ne.0) ) then
          sc_pad = .false.
       endif
 350   continue 
       nwords = 2
       words(1) = ' '
       words(2) = ' '
       ilen = iread_ky(lun, pre, str)
       if ((pre.eq.'#:').and.(str(1:3).eq.'arr')) goto 400
       call bwords(str, nwords,words)
       i         = iofsca( words(1), 1)
cc       print*, ' iofsca = ', i
       scanam(i) = words(1)
       scafrm(i) = ' '
       if (pre.eq.'#?') then
          if (sc_pad) then
             scalar(i)   = unpad(words(2), npack)
          else
             call str2dp(words(2), scalar(i), ier)
          endif
          icdsca(1,i) = -1
       elseif (pre.eq.'#%') then
          if (sc_pad) then
             scalar(i)   = unpad(words(2), npack)
          else
             call str2dp(words(2), scalar(i), ier)
          endif
          icdsca(1,i) = i + jscale
       elseif (pre.eq.'#=') then
          call iff_set('def',str,.false.)
       else
          goto 1010
       endif
       goto 350
 400   continue 
c arrays
cc       print*,' arrays:'
 650   continue 
       ilen = iread_ky(lun, pre,str)
cc       print*,' pre, ilen ', pre, ' ', ilen
       if (ilen.lt.0) goto 800
       in1 = index(str,'[')
       in2 = index(str,']')
       call str2in(str(in1+1:in2-1),ntmp, ierr)
       str = str(in2+1:)
       call triml(str)
       if (pre.eq.'#=') then
c define array by formula
          call iff_set('def',str,.false.)
       elseif (pre.eq.'#%') then
c
c read array data
          j  = index(str,'.')
          s1 = str(1:j-1)
          s2 = str(j+1:)
          call triml(s1)
          call triml(s2)
          call rdpadd(lun,npack,tmparr, ntmp)
          call set_array(s2,s1,tmparr,ntmp,1)
       else
          goto 1010
       endif
       go to 650

 800   continue 
cc       print*, ' line 800'
c
c arrays      
       if (lun.gt.0) close(lun)
       if (i_sync.ge.1)  call iff_sync
       return
 1010  continue 
       call warn(2,' *** restore: not a valid save file')
       return
       end

       subroutine iff_erase(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c  erase an array or scalar values for ifeffit
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'feffit.h'
       save

       character*(*) str, s*256
       integer nwrds, iw, i, j, k, istrln, ilen, id,np, ip
       integer ipths(max_pathindex), ier
       double precision getsca
       external istrln, getsca

       nkeys = mkeys
       do 5 i = 1, nkeys
          keys(i) = blank
 5     continue 
       call bwords(str, nkeys, keys)
cc       do i = 1, nkeys
cc          print*, keys(i)(1:30)
cc       enddo
c check if this is a vector or scalar
       iw  = 0
 10    continue 
       iw = iw + 1
       if (iw.gt.nkeys)  then
          call iff_sync
          return
       endif
       k = istrln(keys(iw))
       s = keys(iw)(1:k)
       call lower(s)
       if (s.eq.'@arrays') then 
          call erase_array(-1,.false.)
       elseif (s.eq.'@scalars') then 
cc          print*, ' erasing scalars'
          do 40 i = 1, maxsca
             call erase_scalar( i )
 40       continue 
       elseif (s.eq.'@strings') then 
          do 50 i = 1, maxtxt
             txtnam(i) = ' '
             text(i)   = ' '
 50       continue 
       elseif (s.eq.'@group') then 
          iw    = iw + 1
          tmpstr= keys(iw)
          ilen  = istrln(tmpstr)
cc
cc note that erase_array will move arrays around, and will
cc drop them down by 1, so a simple loop would miss some
cc this loop counts up to maxarr, backstepping for each
cc erased array.
          i = 0
 65       continue 
             i = i + 1
             if (i.ge.maxarr) go to 70
cc             print*,' i = ', i
cc             call isharr(i)
             j = index(arrnam(i),'.')
             if (j.gt.0) then
                if(tmpstr(1:ilen) .eq. arrnam(i)(1:j-1)) then
                   call erase_array(i,.false.)
                   i = max(0,i-1)
                endif
             endif
             go to 65
 70       continue 
       elseif (s.eq.'@paths') then 
          call str2il('all', max_pathindex,np,ipths,ier)
cc          print*, ' erasing ', np
          do 120 ip = 1, np
             call erase_path(ipths(ip))
 120      continue 
       elseif (s.eq.'@path') then 
          s    = blank
          ilen = 1
          id   = int(getsca('data_set',1))
          if (id.le.0) id = 1
          do 160 i = iw+1, nkeys
             k  = istrln(keys(i))
             s  = s(1:ilen)//keys(i)(1:k)//','
             ilen = ilen + k + 1
 160      continue 
          call str2il(s(1:ilen), max_pathindex,np,ipths,ier)
          do 180 ip = 1, np
             call erase_path(ipths(ip))
 180      continue 
          iw = iw + nkeys
c
c
c single array or scalar
       elseif (index(s,'.').eq.0) then
          if (s(1:1).eq.'$') then
             do 840 i = 1, maxtxt
                if (s(2:).eq.txtnam(i)) call erase_string(i)
 840         continue           
          else 
             do 850 i = 1, maxsca
                if (s.eq.scanam(i)) call erase_scalar(i)
 850         continue 
          end if
       else
          do 890 i = 1, maxarr-1
             if (s.eq.arrnam(i)) call erase_array(i,.false.)
 890      continue 
       end if
       go to 10
c  re-sync    
       call iff_sync
       return
       end

       subroutine erase_array(index,dosync)
c
c erase an array by index
c  giving index<0 will erase all arrays
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       integer  i, k, npdiff, np, nd, npx,nn,n, index
       logical dosync
       save
c
       i = index
       if (i .lt. 0) then
          do 5 i = 1, maxarr
             arrnam(i)  = blank
             arrfrm(i)  = blank
             arrmax(i)  = 0
             arrmin(i)  = 0
             icdarr(1,i)= 0
             icdarr(2,i)= 0
             narray(i)  = 0
             nparr(i)   = -1
 5        continue 
          npnext= 1
          return
       endif

cc       print*, ' erase array ', i, ' ' , arrnam(i)(1:20), nparr(i)
c      
c find the next array pointer and save the pointer difference 
c so the other arrays can be dropped down the stack
       npx   = nparr(i)
       n     = npx + narray(i)
       nd    = maxheap_array
       do 10 k = 1, maxarr
          if ((narray(k).gt.0).and.(nparr(k).ge.n)) then
             nd = min(nd, nparr(k))
          endif
 10    continue 
       npdiff = nd - npx
c
c the actual erase of the current array
       arrnam(i)  = blank
       arrfrm(i)  = blank
       arrmax(i)  = 0
       arrmin(i)  = 0
       icdarr(1,i)= 0
       icdarr(2,i)= 0
       narray(i)  = 0
       nparr(i)   = -1
c
c drop all other array pointers by this difference 
c to reclaim space in array heap 
cc       print*, ' drop  nparrs greater than ', npx, ' by ', npdiff
       if (npdiff .gt. 0) then
          do 280 k = 1, maxarr
             np = nparr(k)
             nd = np - npdiff
             if ((np.gt.npx)) then 
                do 220 i = 0, narray(k) - 1
                   array(nd+i) = array(np+i)
 220            continue 
                nparr(k) = nd
             endif
 280      continue 
       endif
c
c re-determine position of npnext: the next array pointer
       npnext= 1
       do 320 i = 1, maxarr
          if (arrnam(i).ne.blank)  then
             np     = (1+((nparr(i) + narray(i))/2))*2
             npnext = max(1,max(npnext, np))
          endif
 320   continue 
cc       print*, 'end of erase_array: npnext: ', npnext, dosync
       if (dosync) then 
          call iff_sync
       endif
       return
       end
       
       subroutine erase_scalar(i)
c erase a scalar by index
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       integer i
       character*96 sname
       save
       
       sname  =  scanam(i)
       if ((sname .ne. 'pi').and.(sname .ne. 'etok').and.
     $      (sname(1:1).ne.'&')) then
          scanam(i) = blank
          scafrm(i) = blank
       endif
       return
       end

       subroutine erase_string(i)
c erase a string
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       integer i
       character*96 sname
       save
       sname  = txtnam(i)
       if (sname(1:1).ne.'&') then
          txtnam(i) = blank
          text(i)   = blank
       endif
       return
       end

       subroutine erase_path(iup)
c erase a path
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       include 'fefdat.h'
       include 'feffit.h'
       include 'pthpar.h'
       save
       integer  iup, id, inpath, u2ipth, jfeff, i
       integer  ntmp, ilen,  istrln
       logical erase_fefffile
       external istrln, u2ipth

       inpath = u2ipth(iup)
       jfeff  = jpthff(inpath)

       if (inpath .le. 0) return
       pthlab(inpath) = ''
       do 50 i = 1, mpthpr
          icdpar(1,i,inpath) = 0
          icdpar(2,i,inpath) = 0
 50    continue 

c
c delete feff index, saving a temporary copy
       jpthff(inpath) = 0

c sets whether this feff file is used for another path
       erase_fefffile = .true.

       do 70 i = 0, mpaths
          if (iup .eq. jdtusr(i)) jdtpth(i) = 0
          if (jfeff.eq.jpthff(i)) erase_fefffile = .false.
 70    continue 

       if (erase_fefffile) then
          refpth(jfeff) = zero
          degpth(jfeff) = zero
          feffil(jfeff) = blank
          fpthid(jfeff) = blank
          lffred(jfeff) = .false.
          iffrec(jfeff) = 0
          do 90 i = 1, mffpts 
             theamp(i,jfeff) = zero
             thepha(i,jfeff) = zero
             qfeff(i,jfeff) = zero
             realp(i,jfeff) = zero
             thcaps(i,jfeff) = zero
 90       continue 
          do 95 i = 1, nlgpth(jfeff)
             ratpth(1,0,i) = 0
             ratpth(2,0,i) = 0
             ratpth(3,0,i) = 0
 95       continue 
          nlgpth(jfeff) = 0
       end if

       return
       end

       subroutine setval(n1, n2, icdval, mvals, micode, consts,
     $      mconst, vals, icloc, mloc, md,  ixlocl,  id)
c simple loop through resetting values using eval.
       implicit none
       integer  mconst, mvals, micode, mloc, md
       integer  ixlocl, i, id, n1, n2
       double precision  consts(mconst), vals(mvals), old, eval
       integer  icdval(micode, mvals), icloc(micode,mloc,md)
       external eval
       do 10 i = n1, n2
          old   = vals(i)
          vals(i) = eval(icdval, mvals, micode, consts,
     $         mconst, vals, old, icloc,
     $         mloc, md,  ixlocl,  id, i )
 10    continue
       return
       end

       subroutine autlog(iofl)
c
c   a bunch of write statements to the log file (unit=iofl)
c   this should fully account what went on in the background removal.
c   please feel free to alter it in any way.
c
        include 'autobk.h'
       integer   iofl, ilen, ix, icom, istrln
       double precision  e0
       external  istrln
c
c if first time through, open log file
c begin writing results
       write(iofl,425) 
       icom = max(1, istrln(commnt))
       if (icom.ne.0) then
          write(iofl,400) ' '//commnt(:icom)
       write(iofl,426) 
       end if
       ilen = max(1, istrln(xmuf))
       write(iofl,410) ' input xmu data file name and skey: ',
     $                   xmuf(:ilen + 2),skeyxm
       write(iofl,405) '    first document line: ',
     $                   xmudoc(1)(:50)
       if (theory) then
         write(iofl,426)
         ilen = max(1, istrln(theorf))
         write(iofl,410) ' input theory chi file name and skey: ',
     $                   theorf(:ilen + 2),skeyth
         write(iofl,405) '    first document line: ',
     $                   thedoc(1)(:50)
       end if
       write(iofl,426)
       ix = min(55, max(1, istrln(chif)) )
       write(iofl,405) ' output chi file : ',chif(1:ix)
       write(iofl,426)
       write(iofl,400) ' --------fitting parameters---------'
       e0 = ee + e0shft
       if (theory.and.eevary) then
          write(iofl,460) ' initial value of e0        =  ',ee
          write(iofl,460) ' final value of e0          =  ',e0
       else
          write(iofl,460) '  e0 fixed at               =  ',ee
       end if
       write(iofl,470)    ' pre-edge range             =  ',
     $                                               predg1,predg2
       write(iofl,490)    ' pre-edge line              = ', slopre , 
     $                    ' * Energy + ', bpre
       write(iofl,460)    ' edge step                  =  ',step
       write(iofl,493)    ' post-edge curve for edge_step = ', 
     $      cnorm(1),  ' + ', cnorm(2), ' * Energy '
       write(iofl,494)    '                    + ', cnorm(2) ,
     $      '  * Energy^2'

       if (funnrm) then 
          write(iofl,405) ' note: chi(k) was normalized by the',
     $                    ' background function : '
          write(iofl,400) '       chi(k) = ( xmu(e) / bkg(e) ) - 1'
       end if 
       write(iofl,470)    ' energy range               =  ',
     $                                                    emin,emax
       qmax = qgrid*int( sqrt((emax - e0) * etok) / qgrid )
       if (emin.gt.e0) then
          qmin = qgrid*int( sqrt((emin - e0) * etok) / qgrid )
       else
          qmin = zero 
       end if
       write(iofl,470)    ' k range                    =  ',qmin,qmax
       write(iofl,460)    ' k weight                   =  ',qweigh
       write(iofl,400)    '   fourier transform window: '
       if (iwindo.eq.1) then
          write(iofl,460) ' hanning fraction           =  ',windo1
       elseif (iwindo.eq.2) then
          write(iofl,460) ' gaussian: dk               =  ',windo1
       elseif (iwindo.eq.3) then
          write(iofl,460) ' lorentzian: dk             =  ',windo1
       elseif (iwindo.eq.4) then
          write(iofl,470) ' parzen: dk1, dk2           =  ',
     $                                       windo1,windo2
       elseif (iwindo.eq.5) then
          write(iofl,470) ' welch: dk1, dk2            =  ',
     $                                       windo1,windo2
       else
          write(iofl,470) ' sills: dk1, dk2            =  ',
     $                                       windo1,windo2
       endif
       write(iofl,480)    ' # of knots in spline       =  ',nsplin
       write(iofl,470)    ' background r range         =  ',zero,rbkg
       if (theory) then
          write(iofl,460) ' the theory was scaled by   =  ',theamp
          write(iofl,470) ' 1st shell r range          =  ',rbkg,r1st
       end if
       write(iofl,425)

 400   format(2x,a)
 405   format(2x,2a)
 410   format(2x,3a)
 422   format(9x,'(1/2) + Amp * atan( (Energy - Emid) / Ewid )')
 425   format(3x,70('-'))
 426   format(3x,35('-'))
 460   format(2x,a,f15.6)
 470   format(2x,a,f15.6,1x,f15.6)
 480   format(2x,a,i4)
 490   format(2x,a,e13.6,a,e13.6)
 493   format(2x,a,e13.6,a,e13.6,a)
 494   format(2x,a,e13.6,a)

       return
c     end subroutine autlog
       end

       subroutine  dkfit
c     part of diffkk
c  match the externally supplied mu(E) to f'' from CL, allowing
c  a band-limited differential KK transform to be done.  here, we
c  set up for, and call to lmdif1, for a non-linear least-squares 
c  fit using subroutine dkfcn.
       include "dkcom.f"
       integer   lenwrk, lenfvc, lminfo, nofx, i, iwork(mvarys)
       parameter(lenwrk = 2*mpts*(mvarys + 1)  + 20*mvarys )
       parameter(lenfvc = mpts)
       double precision  work(lenwrk), fvect(lenfvc), toler, etmp
       parameter (toler = 1.d-5)
       external  nofx, dkfcn

c make sure e0 is set
       if (e0.le.0) call findee(npts, energy, expdat, e0)
c find useful indices in the energy array
       nelo   = 1 
       nehi   = npts
       ne0    = min(npts, max(1, nofx( e0  , energy, npts)) )
       ne0ish = ne0 - 5
       ne0dif = 200
c initialize variables
       do 10 i = 1, mvarys
          xvarys(i) = 0.d0
 10    continue
c xvarys(3) should be ~1
       xvarys(3) = 1.0
       numvar = 4
       lminfo = 0
c  call lmdif1

       call lmdif1 (dkfcn, npts, numvar, xvarys, fvect,
     $      toler, lminfo, iwork, work, lenwrk)
c done!
       return
       end

c -*-fortran-*-
       subroutine iff_pre_edge(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: ifeffit pre-edge removal, normalization of xafs data
c          and guessing e0  
c
c arguments:
c      str     command line to performd                 [in]
c
c notes:
c   1. driver for preedg
c
c requires: istrln, getsca, gettxt, setsca, settxt, bkeys,  
c           echo, lower, str2re, str2lg, preedg
c 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'spline.h'
       save
       character*(*)  str, defkey(3)*64
       character*256     xmuarr, en_arr, prearr, norarr, name1
       double precision  pre1, pre2, enor1, enor2
       double precision slope, offset, cnorm(3), xn
       double precision  arr_e(maxpts), arr_x(maxpts), getsca
       double precision tmpar2(maxpts)
       logical   stfind, eefind, is_kev
       integer   jen, jpre, jxmu, ier, i, k, istrln, jdot
       integer   ndfkey, npts_e, npts_x, nnorm
       integer  iff_eval, iff_eval_dp, iff_eval_in, sort_xy
       external iff_eval, iff_eval_dp, iff_eval_in, sort_xy
       external  getsca, istrln
c
c get default values for pre-edge parameters from current scalar values
       call iff_sync
       eefind = .false.
       stfind = .true.
       e0     = 0 ! getsca('e0',1)
       step   = 0 ! getsca('edge_step',1)
       pre1   = 0 ! getsca('pre1',1)
       pre2   = 0 ! getsca('pre2',1)
       enor1  = 0 ! getsca('norm1',1)
       enor2  = 0 ! getsca('norm2',1)
       slope  = 0 ! getsca('pre_slope',1)
       offset = 0 ! getsca('pre_offset',1)
       nnorm  = 3 
       name1  = undef
       call bkeys(str, mkeys, keys, values, nkeys)

c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
       ndfkey    = 2
       defkey(1) = 'energy'
       defkey(2) = 'xmu'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'ee').or.(keys(i).eq.'e0'))  then
             ier = iff_eval_dp(values(i),e0)
             eefind = eefind .or. (values(i)(1:1).eq.'?')
          elseif (keys(i).eq.'group') then
             name1 = values(i)
          elseif (keys(i).eq.'pre1') then
             ier = iff_eval_dp(values(i),pre1)
          elseif (keys(i).eq.'pre2') then
             ier = iff_eval_dp(values(i),pre2)
          elseif (keys(i).eq.'norm1') then
             ier = iff_eval_dp(values(i),enor1)
          elseif (keys(i).eq.'norm2') then
             ier = iff_eval_dp(values(i),enor2)
          elseif (keys(i).eq.'norm_order') then
             ier = iff_eval_in(values(i), nnorm)
          elseif (keys(i).eq.'edge_step') then
             ier = iff_eval_dp(values(i),step)
             stfind = .false.
          elseif (keys(i).eq.'is_kev') then
             call str2lg(values(i),is_kev, ier)
          elseif ((keys(i).eq.'find_e0').or.
     $            (keys(i).eq.'e0find')) then
             call str2lg(values(i),eefind,ier) 
          elseif (keys(i).eq.'energy') then
             en_arr = values(i)
             call lower(en_arr)
          elseif (keys(i).eq.'xmu') then
             xmuarr = values(i)
             call lower(xmuarr)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** pre_edge: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names
       if (name1.eq.undef) then
          jdot = index(xmuarr,'.')
          if (jdot.ne.0) name1 = xmuarr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(en_arr,'.')
          if (jdot.ne.0) name1 = en_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2, ' pre_edge: can''t determine group name')
          return             
       endif
       call fixnam(name1,1)
       call lower(name1)
       jdot = istrln(name1)
       jen   = iff_eval(en_arr, name1, arr_e, npts_e)
       jxmu  = iff_eval(xmuarr, name1, arr_x, npts_x)
       if (jen.le.0) then
          call warn(2, ' pre_edge: no energy array?')
          return
       elseif(jxmu.le.0) then
          call warn(2, ' pre_edge: no xmu array?')
          return
       end if

c require that endat be monotonically increasing: if not, sort it
       ier =  sort_xy(arr_e, arr_x, npts_e, tiny)
       if (ier .eq. 1) then 
          call warn(1,' pre_edge: energy data appears out of order')
       endif

       if (is_kev .or.
     $      ((arr_e(1).le.90).and.(arr_e(npts_e).le.90))) then
          call warn(1,' pre_edge: energy data appears to be in keV')
          call kev2ev(arr_e, npts_e)
       endif
c
c  do real call to pre-edge
cc      print*,  ' in pre_edge before preedg call: ', eefind, e0
       call preedg(eefind, stfind, npts_x, arr_e, arr_x,
     $      e0, pre1, pre2, enor1, enor2, nnorm,
     $      step,slope,offset,cnorm)
cc       print*,  ' after preedg call: ',e0,step,slope,offset,cnorm
c
c  make array of pre-edge subtracted data
c  $group.pre: output (ensuring that it doesn't overwrite xmu!)
       prearr = name1(1:jdot)//'.pre'
       norarr = name1(1:jdot)//'.norm'
       if (prearr.eq.xmuarr) then
          prearr = name1(1:jdot)//'.pre_edge'
          norarr = name1(1:jdot)//'.norm_1'
       endif

       do 200 i = 1, npts_x
          tmparr(i) = arr_x(i) - offset - slope * arr_e(i)
          tmpar2(i) = tmparr(i)/step
 200   continue 
       call set_array(prearr, name1, tmparr, npts_x, 1)
       call set_array(norarr, name1, tmpar2, npts_x, 1)
c
c reset the program variables
       call setsca('e0',         e0)
       call setsca('edge_step',  step)
       call setsca('pre1',       pre1)
       call setsca('pre2',       pre2)
       call setsca('norm1',      enor1)
       call setsca('norm2',      enor2)
       call setsca('pre_slope',  slope)
       call setsca('pre_offset', offset)
       call setsca('norm_c0',    cnorm(1))
       call setsca('norm_c1',    cnorm(2))
       call setsca('norm_c2',    cnorm(3))
       call settxt('group',      name1)
       return
c end  subroutine iff_pre_edge
       end

       subroutine iff_getpath(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: convert feff path to accessible program data
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fefdat.h'
       include 'feffit.h'
       include 'pthpar.h'

       save
       character*(*)  str
       character*256   name1, defkey(2)*64, s
       character*8   suffix(mpthpr)
       double precision  tmpr(maxpts), tmpi(maxpts), r1, getsca, rx
       integer   ipath, idata, ier, i ,k, istrln, ndfkey, il
       integer   iff_eval, jx,jy, u2ipth, inpath, jfeff
       integer   xafs_path, ret, nx
       logical   do_arrs
       external  iff_eval, u2ipth, xafs_path
       external  getsca, istrln
       data suffix  /'s02', 'e0', 'ei', 'delr', 'sigma2', 'third',
     $      'fourth', 'degen' , 'k', 'amp', 'phase', 'file',
     $      ' ', ' ', ' ' , ' '/

c
c get default values for pre-edge parameters from current scalar values
       do_arrs = .false.
       call iff_sync
       call bkeys(str, mkeys, keys, values, nkeys)
       ipath = -1
       idata =  1 
       name1 = undef
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'

       ndfkey    = 2
       defkey(1) = 'path'
       defkey(2) = 'prefix'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ( (keys(i).eq.'prefix') .or.
     $         (keys(i).eq.'group')) then
             name1 = values(i)
          elseif (keys(i).eq.'path') then
             call str2in(values(i), ipath, ier)
          elseif (keys(i).eq.'do_arrays') then
             call str2lg(values(i), do_arrs, ier)
          elseif (keys(i).eq.'data_set') then
             call str2in(values(i), idata, ier)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** get_path: unknown keyword " '//messg)
          end if
 100   continue
c
       if (ipath .le.0) return
       call fefinp
       ret    = xafs_path(ipath, tmpr, tmpi, rx)
       inpath = u2ipth(ipath)
       jfeff  = jpthff(inpath)

       call undels(name1)
       if (name1.eq.undef) then
          write(name1,'(a,i3.3)') 'path', ipath
       endif
       il = istrln(name1)
       s  = name1(1:il)//'_s02'
       call setsca(s, param(jfps02))
       s  = name1(1:il)//'_e0'
       call setsca(s, param(jfpe0))
       s  = name1(1:il)//'_ei'
       call setsca(s, param(jfpei))
       s  = name1(1:il)//'_delr'
       call setsca(s, param(jfpdr))
       s  = name1(1:il)//'_sigma2'
       call setsca(s, param(jfpss2))
       s  = name1(1:il)//'_third'
       call setsca(s, param(jfp3rd))
       s  = name1(1:il)//'_fourth'
       call setsca(s, param(jfp4th))
       s  = name1(1:il)//'_degen'
       call setsca(s, param(jfpdeg))
       s  = name1(1:il)//'_reff'
       r1 = getsca('reff',1)
       call setsca(s, r1)

       s  = name1(1:il)//'_lab'
       call settxt(s, pthlab(inpath))
       s  = name1(1:il)//'_id'
       call settxt(s, fpthid(jfeff))
       s  = name1(1:il)//'_file'
       call settxt(s, feffil(jfeff))

c
c generate ifeffit arrays from feff.dat columns
       if (do_arrs) then
          nx  = nffpts(jfeff)
          call set_array('k',     name1, qfeff(1,jfeff), nx, 1)
          call set_array('amp',   name1, theamp(1,jfeff), nx, 1)
          call set_array('phase', name1, thepha(1,jfeff), nx, 1)
          call set_array('caps',  name1, thcaps(1,jfeff), nx, 1)
          call set_array('rep',   name1, realp(1,jfeff), nx, 1)
          call set_array('lambda',name1, xlamb(1,jfeff), nx, 1)
       endif

       return
c end  subroutine iff_test
       end

       subroutine decod(icode, micode, consts, scalar, array, 
     $       narray, nparr, mvpts, maxarr, nvout, outval)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: decodes icode array (created by encod), returning real vector
c          outval, containing results of performing the math expression
c          described by the icode array.
c
c arguments:
c      icode    integer array -- coded math expression  [in]
c      micode   dimension of icode                      [in]
c      consts   array of constants                      [in]
c      scalar   array of scalar values                  [in]
c      arrays   array of vector values (mvpts,maxarr)   [in]
c      narray    integer array : npts for each array     [in]
c      mvpts    max # of array elements in arrays       [in]
c      maxarr   max # of arrays                         [in]
c      nvout    number of points in outval          [in/out]
c      outval   array of output values  (mvpts)     [in/out]
c               default values on input
c notes:
c   1. mvpts cannot exceed maxpts
c   2. this decodes the icode array, inserting constants,scalars,arrays,
c      and performing math operations, to return the calulation to outval.
c   3. outval will be returned if icode is empty.
c   4. see also encod
c
c requires:  encod.h, f1mth, f2mth, v1mth, stack, echo, eins
c
       implicit none
       include 'maxpts.h'
       include 'encod.h'
       integer    micode, mvpts, maxarr, nvout, mstack
       parameter(mstack=12)
       integer  icode(micode), narray(maxarr), nparr(maxarr)
       double precision  consts(*), scalar(*), array(*)
       double precision  outval(mvpts), x(maxpts, mstack)
       double precision  xtmp(maxpts) , xs_tmp, xx0, dx, tiny, small
       parameter   (tiny = 1.d-9, small = 1.d-4)
       integer  nx(mstack), ierr, istack, ic, i, j, iplace, iarx, npx
       integer  nofxa, itmp1, itmp2
       character mtherr*14, death*21
       parameter(mtherr = ' * math error ')
       parameter(death  = ' * math parser died: ')
       external nofxa
c
c-- return default if the icode is empty
cc       print*, ' decod: ', icode(1), icode(2), icode(3)
       ierr   = 0
       iplace = 0
       istack = 0
       if (mvpts.gt.maxpts) then
          ierr = 5
          go to 1000
       endif
       if (nvout.le.0) nvout = 1
       if ((icode(1).eq.0) .or. (icode(1).eq.-1))  return
c-- initialize stack
       do 50 i = 1, mstack
          nx(i)  = 0
          x(1,i) = 0
          x(2,i) = 0
 50    continue
c--    interpret next object, do operations, and manage stack
c      hold place in icode array with iplace

 100   continue
       iplace = iplace + 1
       if (iplace.gt.micode)   ierr = 2
       ic = icode(iplace)
       if ((ic.eq.0).or.(ic.eq.-1)) then
          nvout = nx(1)
          do 104 i = 1, nx(1)
             outval(i) = x(i,1)
 104      continue
          return
c if number, then push everything in stack and fill in the first element
       elseif (ic.ge.1) then
c   push stack:
          istack = istack + 1
          if (istack.ge.mstack)  ierr = 1
          do 150 i = istack, 2, -1
             nx(i) = nx(i-1)
             do 140 j = 1, nx(i)
                x(j,i)  = x(j,i-1)
 140         continue
 150      continue 
c   fill with constant
          if (ic.gt.jconst) then
             x(1,1)  = consts(ic - jconst)
             nx(1)   = 1
c   fill with scalar
          elseif ((ic.gt.jscale).and.(ic.le.jconst)) then
             x(1,1)  = scalar(ic - jscale)
             nx(1)   = 1
c   fill with array
          else 
             nx(1)   = max(1, min(maxpts, narray(ic)))
             iarx = ic
             if (iarx.eq.0) then
                do 248 j = 1, nx(1)
                   x(j,1)  = 0
 248            continue
             else
cc                print*, 'DECOD iarr = ', iarx, nparr(iarx), narray(iarx)
cc                print*, 'DECOD arr:',array(nparr(iarx)),
cc     $               array(nparr(iarx)+1)
                npx = nparr(iarx)-1
                do 250 j = 1, nx(1)
                   x(j,1)  = array(npx+j)
 250            continue
             endif
          endif
c  1-component math: overwrite x(1)
c  iop range: -128 to -4096
       elseif ( (ic.le.-1000).and.(ic.ge.-3000) ) then
          call f1mth(x(1,1),nx(1),ic,ierr)
c  2-component math: overwrite x(1), drop x(2), pop stack, update nx(1)
c  iop range: -5000 to -6000
       elseif ( (ic.le.-5000).and.(ic.ge.-8000) ) then
          call f2mth( x(1,1), nx(1), x(1,2), nx(2), ic, ierr)
          call stack(x,maxpts,mstack,nx,istack,1)
c  1-component vector operations: floor, ceil value of an array,
c         sum or product of all elements in a single array
c  iop range: -30000 to -32000
       elseif ((ic.le.-30000).and.(ic.ge.-32000)) then
          call v1mth(x(1,1),nx(1),ic,ierr)
c  special math operations:
c  iop range: -8000 to -10000
       elseif (ic.eq.jdebye) then
          call cordby(x(1,1),nx(1),x(1,2),nx(2),ierr)
          call stack(x,maxpts,mstack,nx,istack,1)
       elseif (ic.eq.jeins) then
          call eins(x(1,1),nx(1),x(1,2),nx(2),ierr)
          call stack(x,maxpts,mstack,nx,istack,1)
       elseif (ic.eq.jkktf) then
          call w_kkf(x(1,1),nx(1),x(1,2),nx(2),ierr)
          call stack(x,maxpts,mstack,nx,istack,1)
       elseif (ic.eq.jkktr) then
          call w_kkr(x(1,1),nx(1),x(1,2),nx(2),ierr)
          call stack(x,maxpts,mstack,nx,istack,1)
       elseif (ic.eq.jfftf) then
          call w_fftf(x(1,1),nx(1),ierr)
       elseif (ic.eq.jfftr) then
          call w_fftr(x(1,1),nx(1),ierr)

       elseif (ic.eq.jpenl1) then
          call res_penalty(x(1,1),nx(1),x(1,2),nx(2),x(1,3),nx(3))
          call stack(x,maxpts,mstack,nx,istack,2)

       elseif (ic.eq.jpenl2) then
          xtmp(1) = - exp(85.d0)
          call res_penalty(x(1,1),nx(1),xtmp,1,x(1,2),nx(2))
          call stack(x,maxpts,mstack,nx,istack,1)

       elseif (ic.eq.jpenl3) then
          xtmp(1) = exp(85.d0)
          call res_penalty(xtmp, 1, x(1,1),nx(1),x(1,2),nx(2))
          x(1,1) = xtmp(1)
          call stack(x,maxpts,mstack,nx,istack,1)

       elseif ((ic.eq.jterpl).or.(ic.eq.jterpq).or.
     $         (ic.eq.jterps).or.(ic.eq.jterpa) ) then
          j = jterpl - ic
          call xterp(x(1,1),nx(1),x(1,2),nx(2),x(1,3),nx(3),j,ierr)
          call stack(x,maxpts,mstack,nx,istack,2)
       elseif (ic.eq.jrebin) then
          call rebin_interp(x(1,1),nx(1),x(1,2),nx(2),x(1,3),nx(3))
          call stack(x,maxpts,mstack,nx,istack,2)
       elseif (ic.eq.jlconv) then
c                       gamma,       x        y   yout
cc          print*, ' convolve: gamma = ', x(1,1), nx(2), nx(3)
cc          print*, ' convolve: x     = ', x(1,3), x(2,3), x(3,3)
cc          print*, ' convolve: y     = ', x(1,2), x(2,2), x(3,2)
          xx0 = 0.d0
          call conv_lor(x(1,1),nx(2),x(1,3),x(1,2),xx0,xtmp)
          nx(1) = nx(2)
          do 320 j = 1, nx(1)
             x(j,1)  = xtmp(j)
 320      continue
cc          print*, 'done'
          call stack(x,maxpts,mstack,nx,istack,2)
       elseif (ic.eq.jgconv) then
c                       gamma,       x        y   yout
cc          print*, ' convolve: gamma = ', x(1,1), nx(2), nx(3)
cc          print*, ' convolve: x     = ', x(1,3), x(2,3), x(3,3)
cc          print*, ' convolve: y     = ', x(1,2), x(2,2), x(3,2)
          xx0 = 0.d0
          call conv_gau(x(1,1),nx(2),x(1,3),x(1,2),xx0,xtmp)
          nx(1) = nx(2)
          do 370 j = 1, nx(1)
             x(j,1)  = xtmp(j)
 370      continue
          call stack(x,maxpts,mstack,nx,istack,2)
c range:   start stop step
       elseif (ic.eq.jrngar) then
          xx0   = x(1,3)
          dx    = x(1,1)
          if (abs(dx) .le.tiny) dx = tiny
          nx(1) = int((abs(x(1,2)-x(1,3)) + small*abs(dx))/ abs(dx))+1
          nx(1) = max(1, min(maxpts, nx(1)))
          do 390 j = 1, nx(1)
             x(j,1)  = xx0 + (j-1)*dx
 390      continue
          call stack(x,maxpts,mstack,nx,istack,2)
       elseif (ic.eq.jndarr) then
          nx(1) = max(1, min(maxpts, int(x(1,1))))
          do 420 j = 1, nx(1)
             x(j,1)  = j
 420      continue
       elseif (ic.eq.j1sarr) then
          nx(1) = max(1, min(maxpts, int(x(1,1))))
          do 440 j = 1, nx(1)
             x(j,1)  = 1
 440      continue
       elseif (ic.eq.j0sarr) then
          nx(1) = max(1, min(maxpts, int(x(1,1))))
          do 450 j = 1, nx(1)
             x(j,1)  = 0
 450      continue
       elseif (ic.eq.jxgaus) then
          call do_gauss(x(1,3),nx(3),x(1,2),x(1,1),xtmp)
          nx(1) = nx(3)
          do 502 j = 1, nx(1)
             x(j,1)  = xtmp(j)
 502      continue
          call stack(x,maxpts,mstack,nx,istack,2)
       elseif (ic.eq.jxlore) then
          call do_loren(x(1,3),nx(3),x(1,2),x(1,1),xtmp)
          nx(1) = nx(3)
          do 505 j = 1, nx(1)
             x(j,1)  = xtmp(j)
 505      continue
          call stack(x,maxpts,mstack,nx,istack,2)
       elseif (ic.eq.jxvoit) then
          call do_pvoight(x(1,4),nx(4),x(1,3),x(1,2),x(1,1),xtmp)
          nx(1) = nx(4)
          do 510 j = 1, nx(1)
             x(j,1)  = xtmp(j)
 510      continue
          call stack(x,maxpts,mstack,nx,istack,3)
       elseif (ic.eq.jnofxa) then
cc          print*, ' nofx !'
          j = nofxa(x(1,1),x(1,2),nx(2))
          nx(1) = 1 
          x(1,1) = j
          call stack(x,maxpts,mstack,nx,istack,1)
       elseif (ic.eq.jjoina) then
          j = nx(2)
          itmp1 = min(nx(1)+nx(2), maxpts)-nx(2)
          do 515 i = 1,nx(2)
             xtmp(i) = x(i,2)
 515      continue 
          do 516 i  = 1,itmp1
             xtmp(j+i) = x(i,1)
 516      continue 
          nx(1) = max(1,itmp1+nx(2))
          do 517 i  = 1,nx(1)
             x(i,1) = xtmp(i) 
 517      continue 
          call stack(x,maxpts,mstack,nx,istack,1)
       elseif (ic.eq.jslica) then
          itmp1 = min(int(x(1,1)),nx(3))
          itmp2 = max(int(x(1,2)),1)
          nx(1) = itmp1-itmp2+1
          do 530 i  = 1, nx(1)
             xtmp(i) = x(i+itmp2-1,3)
 530      continue
          do 532 i  = 1, nx(1)
             x(i,1) = xtmp(i)
 532      continue
          call stack(x,maxpts,mstack,nx,istack,2)
       else
          ierr = 9999
       end if
c  done : if no errors, then update param and go to next object
       if (ierr.eq.0) go to 100
c error handling
 1000  continue 
       if (ierr.eq.ilog) then
          call warn(2,mtherr//'-- log(x) needs  x > 0')
       elseif (ierr.eq.ilog10) then
          call warn(2,mtherr//'-- log10(x) needs  x > 0')
       elseif (ierr.eq.isqrt) then
          call warn(2,mtherr//'-- sqrt(x) needs x >= 0')
       elseif (ierr.eq.iasin) then
          call warn(2,mtherr//'-- asin(x) needs (-1< x <1)')
       elseif (ierr.eq.iacos) then
          call warn(2,mtherr//'-- acos(x) needs (-1< x <1)')
       elseif (ierr.eq.idiv) then
          call warn(2,mtherr//'-- divide by 0 ')
       elseif (ierr.eq.iy2x) then
          call warn(2,mtherr//'-- invalid exponentiation ')
       elseif (ierr.eq.jdebye) then
          call warn(2,mtherr//' using "debye" function ')
          call warn(2,' *     could not find a path index to use!')
       elseif (ierr.eq.jeins) then
          call warn(2,mtherr//' using "eins" function')
          call warn(2,' *     could not find a path index to use!')
       elseif (ierr.eq.1) then
          call warn(2,death//'exceeded stack size')
       elseif (ierr.eq.2) then
          call warn(2,death//'too many objects')
       elseif (ierr.eq.5) then
          call warn(2,death//'mvpts .gt. maxpts')
       elseif (ierr.eq.9999) then
          call warn(2,death//' unknown operation')
       else
          call warn(2,death//' i am truly confused')
       end if
       if (ierr.gt.0) then
          call set_status(3)
       endif
c end subroutine decod
       end
       subroutine f1mth( x, nx, iop, ierr)
c
c one component math. if any tests are failed, x is returned.
c iop is an integer indication of which operation to perform.
c
c  copyright (c) 1998  matt newville
       implicit  none
       include 'maxpts.h'
       include 'encod.h'
       integer  iop, ierr, nx, i
       double precision    x(*), xtmp(maxpts)
       double precision tmp, zero, one, half, quartr
       parameter(zero= 0.d0, one= 1.d0,half= 0.5d0,quartr=2.5d-1)
       double precision dgamma, dlgama, erf_xx
       external dgamma, dlgama, erf_xx
c
       ierr  = 0
       if (iop.eq.iexp) then
          do 20 i = 1, nx
             tmp  = max(-expmax, min(x(i), expmax) )
             x(i) = exp(tmp)
 20       continue
       elseif (iop.eq.ilog) then
          do 40 i = 1, nx
             if  ( x(i).gt.zero ) then
                x(i) = log(x(i))
             else
                ierr  = iop
                x(i) = zero
             end if
 40       continue
       elseif (iop.eq.ilog10) then
          do 42 i = 1, nx
             if  ( x(i).gt.zero ) then
                x(i) = log10(x(i))
             else
                ierr  = iop
                x(i) = zero
             end if
 42       continue
       elseif (iop.eq.isqrt) then
          do 60 i = 1, nx
             if  ( x(i).ge.zero ) then
                x(i) = sqrt(x(i))
             else
                ierr  = iop
                x(i) = zero
             end if
 60       continue
       elseif (iop.eq.iabs)  then
          do  80 i = 1, nx
             x(i) = abs(x(i))
 80       continue
       elseif (iop.eq.ineg)  then
          do 100 i = 1, nx
             x(i) = - x(i)
 100      continue
       elseif (iop.eq.isin)  then
          do 120 i = 1, nx
             x(i) = sin(x(i))
 120      continue
       elseif (iop.eq.icos)  then
          do 140 i = 1, nx
             x(i) = cos(x(i))
 140      continue
       elseif (iop.eq.itan)  then
          do 160 i = 1, nx
             x(i) = tan(x(i))
 160      continue
       elseif (iop.eq.iasin) then
          do 180 i = 1, nx
             if (abs(x(i)).le.one) then
                x(i) = asin(x(i))
             else
                ierr  = iop
                x(i) = zero
             end if
 180      continue
       elseif (iop.eq.iacos) then
          do 200 i = 1, nx
             if (abs(x(i)).le.one) then
                x(i) = acos(x(i))
             else
                ierr  = iop
                x(i) = zero
             end if
 200      continue
       elseif (iop.eq.iatan) then
          do 220 i = 1, nx
             x(i) = atan(x(i))
 220      continue
       elseif (iop.eq.itanh) then
          do 240 i = 1, nx
             x(i) = tanh(x(i))
 240      continue
       elseif (iop.eq.icoth) then
          do 242 i = 1, nx
             x(i) = one/tanh(x(i))
 242      continue
       elseif (iop.eq.icosh) then
          do 260 i = 1, nx
             x(i) = cosh(max(-expmax, min(x(i), expmax)))
 260      continue
       elseif (iop.eq.isinh) then
          do 280 i = 1, nx
             x(i) = sinh(max(-expmax, min(x(i), expmax)))
 280      continue
       elseif (iop.eq.jderiv) then
          xtmp(1) = x(2)  - x(1)
          do 300 i = 2, nx-1
             xtmp(i) = (x(i+1) - x(i-1))*half
 300      continue
          xtmp(nx) = x(nx)  - x(nx-1)
          do 305 i = 1, nx
             x(i) = xtmp(i)
 305      continue 
       elseif (iop.eq.jsmoo) then
          xtmp(1) =3*x(1)*quartr + x(2)*quartr
          do 320 i = 2, nx-1
             xtmp(i) = (x(i) + (x(i+1) + x(i-1))*half)*half
 320      continue
          xtmp(nx) = 3*x(nx)*quartr + x(nx-1)*quartr
          do 325 i = 1, nx
             x(i) = xtmp(i)
 325      continue 
       elseif (iop.eq.jasign)  then
          do 360 i = 1, nx
             tmp = abs(x(i))
             if (tmp.eq.zero) then
                x(i) =  zero
             elseif (tmp.eq.x(i)) then
                x(i) =  one
             else
                x(i) = -one
             end if
 360      continue
c external special functions
       elseif (iop.eq.jgamma)  then
          do  502 i = 1, nx
             tmp  = x(i)
             x(i) = dgamma(tmp)
 502      continue
       elseif (iop.eq.jlgamm)  then
          do  503 i = 1, nx
             tmp  = x(i)
             x(i) = dlgama(tmp)
 503      continue
       elseif (iop.eq.jerf)  then
          do  510 i = 1, nx
             tmp  = x(i)
             x(i) = erf_xx(tmp,0)
 510      continue
       elseif (iop.eq.jerfc)  then
          do  511 i = 1, nx
             tmp  = x(i)
             x(i) = erf_xx(tmp,1)
 511      continue
       elseif (iop.eq.jerfcx)  then
          do  512 i = 1, nx
             tmp  = x(i)
             x(i) = erf_xx(tmp,2)
 512      continue

       end if
       return
c end subroutine f1mth
       end
       subroutine f2mth( x, nx, y, ny, iop, ierr)
c
c two component math: x is overwritten by operator(x,y).
c if ( (negative number)**(fraction) ) is requested, x is unchanged.
c
c iop is an integer indication of which operation to perform.
c if iop = 0, then x is returned.
c
c  copyright (c) 1998  matt newville
       implicit none
       include 'maxpts.h'
       include 'encod.h'
       integer  ix, iy, i, newx
       double precision      x(*), y(*), xout(maxpts)
       double precision      xtmp, test
       integer   nx, ny, iop, ierr, nx1, ny1, nptstk
       external   nptstk
       ierr = 0
c decide number of points to write out
c     npstk = smaller of nx1, ny1 unless either of them is 1,
c             in which case it is the larger of the two.
c             (n = 1 implies a scalar )
       nx1  = nx
       ny1  = ny
       nx   = nptstk (nx1, ny1)
       if ((iop.eq.iadd).or.(iop.eq.jadd)) then
          do 20 i = 1, nx
             ix = min(nx1, i)
             iy = min(ny1, i)
             xout(i) = y(iy) + x(ix)
 20       continue
       elseif ((iop.eq.isub).or.(iop.eq.jsub)) then
          do 40 i = 1, nx
             ix = min(nx1, i)
             iy = min(ny1, i)
             xout(i) = y(iy) - x(ix)
 40       continue
       elseif (iop.eq.imul) then
          do 60 i = 1, nx
             ix = min(nx1, i)
             iy = min(ny1, i)
             xout(i) = y(iy) * x(ix)
 60       continue
       elseif (iop.eq.idiv) then
          do 80 i = 1, nx
             ix = min(nx1, i)
             iy = min(ny1, i)
             if (x(ix).eq.0)  then
                xout(i) = 0
                ierr  = iop
             else
                xout(i) = y(iy) / x(ix)
             end if
 80       continue
       elseif (iop.eq.iy2x) then
          do 100 i = 1, nx
             ix   = min(nx1, i)
             iy   = min(ny1, i)
             newx = int(x(ix))
             xtmp = newx
             if (x(ix).eq.0)  then
                xout(i) = 1
             elseif ( (y(iy).eq.0).and.(x(ix).gt.0) ) then
                xout(i) = 0
             elseif (y(iy).gt.0)  then
                test  = x(ix) * log(y(iy))
                if (test.gt.expmax) then
                   xout(i) = exp(expmax)
                elseif (test.lt.(-expmax)) then
                   xout(i) = exp(-expmax)
                else
                   xout(i) = y(iy)**x(ix)
                end if
             elseif ( (y(iy).lt.0) ) then
                test  = xtmp * log(-y(iy))
                if (test.gt.expmax) then
                   xout(i) = exp(expmax)
                elseif (test.lt.(-expmax)) then
                   xout(i) = exp(-expmax)
                else
                   xout(i) = y(iy)**newx
                end if
             end if
 100      continue
       elseif (iop.eq.jmin) then
cc          print*, ' f2mth jmin ' 
          do 120 i = 1, nx
             ix = min(nx1, i)
             iy = min(ny1, i)
             xout(i) = min(y(iy) , x(ix))
 120      continue
       elseif (iop.eq.jmax) then
cc          print*, ' f2mth jmax ' , nx, nx1, ny1
          do 140 i = 1, nx
             ix = min(nx1, i)
             iy = min(ny1, i)
             xout(i) = max(y(iy) , x(ix))
 140      continue
cc          print*, ' f2mth jmax: ', xout(1), xout(2)
       end if
c now overwrite x
       do 300 i = 1, nx
          x(i) = xout(i)
 300   continue
       return
c end subroutine f2mth
       end
       subroutine v1mth(x, nx, iop, ierr)
c
c one component math on a vector.  if any tests are failed, x is 
c returned.    iop indicates what operation to perform.
c
c copyright (c) 1998  matt newville
       include 'encod.h'
       double precision    x(*), xtmp
       integer iop, ierr, nx, i
       ierr = 0
       xtmp = 0
       if (nx.le.0) nx = 1
       if (iop.eq.jnpts) then
          xtmp = nx
       elseif (iop.eq.jceil) then
          xtmp  = x(1)
          do 20 i = 2, nx
             xtmp = max(xtmp, x(i))
 20       continue
       elseif (iop.eq.jfloor)  then
          xtmp  = x(1)
          do 40 i = 2, nx
             xtmp = min(xtmp, x(i))
 40       continue
       elseif (iop.eq.jvsum)  then
          xtmp  = 0
          do 60 i = 1, nx
             xtmp = xtmp + x(i)
 60       continue
       elseif (iop.eq.jvprod)  then
          xtmp  = 1
          do 80 i = 1, nx
             xtmp = xtmp * x(i)
 80       continue
       end if
c final array
       do 200 i = 2, nx
          x(i) = 0
 200   continue
       x(1) = xtmp
       nx   = 1
       return
c end subroutine v1tmh
       end

       subroutine fitfft(chiq, mpts, mfft, wfftc, qgrid,
     $      qwin, qweigh, rwin, rweigh, ifft, mode, xlow, xhigh,
     $      nout, chifit)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c    calculate a fft of a function to be minimized in either r or
c    backtransformed k-space to use as a fitting function, as in 
c    ifeffit.  calls routine xafsft which uses the routine cfftf.
c
c    ** cffti must be called prior to this routine **
c
c inputs:
c   chiq    array containing chi(q), on grid with spacing qgrid, 
c           and first point at chi(q = 0.).
c   mpts    dimension of chiq, qwin, and rwin
c   mfft    number of points to use for fft 
c   wfftc   work array for fft initialized by cffti, which must
c           be called prior to this routine.
c   qgrid   grid size for chiq.
c   qwin    q-space fft window array 
c   qweigh  q-weight in  k->r fft.
c   rwin    r-space fft window array
c   rweigh  r-weight in  r->q fft.
c   ifft    integer flag for number of fft's to do:
c             0    chifit is in original k-space 
c             1    chifit is in r-space 
c             2    chifit is in back-transformed k-space 
c   mode    integer flag for output mode for complex data:
c             0    real/imag pair  (default)
c             1    real/mag  pair
c   xlow    low-x range for output chifit (either r or k)
c   xhigh   high-x range for output chifit (either r or k)
c   nout    number of points in output : useful length of chifit
c outputs:
c   chifit  real array representation of the complex result from 
c           0, 1, or 2 fft of the input chi(k).
c           output between xlow and xhigh in real-imag pairs
c           (if ifft=0, all imag parts are 0.) 
c
c mxmpts is the largest expected value for mpts
c
        implicit none
        integer   mpts, mfft, ifft, nout, mxmpts, nfft, i, ipos,jft,mode
        double precision  pi, zero, xlow, xhigh, xgrid
        parameter (mxmpts = 4096, zero=0.d0, pi = 3.141592653589793d0)
        double precision chiq(mpts), chifit(mpts),qwin(mpts),rwin(mpts)
        double precision qweigh, rweigh, qgrid, rgrid, q, pha
        double precision  wfftc(*)
        complex*16  cchiq(mxmpts), tmpft(mxmpts), coni
        parameter (coni=(0d0,1d0))

c  check that ifft is valid
       if ((ifft.lt.0).or.(ifft.ge.3)) then 
          call warn(3,'fitfft: ifft out of range.')
          return
       endif
cc       if (mxmpts.ne.mfft) then 
cc          call echo('fitfft warning: weird number of points')
cc          print*, mxmpts, mfft
cc       endif

c
c  nfft will be the actual length of the fft arrays. 
c  it is expected that nfft = mfft, but just in case...
       nfft   =  min(mxmpts, min(mfft, mpts) )
       rgrid  =  pi / (qgrid * nfft)
c
c  copy input data into complex data array.
       do 130 i = 1, nfft
          cchiq(i) = dcmplx(chiq(i), zero)
 130   continue
c
c  do ifft (= 0, 1, 2)  number of fourier transforms
c  ifft: 
c     0   just get k-weighted chi(k)
c     1   k->r
c     2   k->r then r->q

       jft = 1
       if (ifft.eq.0) jft = 0

       xgrid = qgrid
       if (ifft.eq.1) xgrid = rgrid

       call xafsft(nfft,cchiq,qwin,qgrid,qweigh,wfftc, jft, tmpft)

       if (ifft.eq.2) then
          call xafsft(nfft,tmpft,rwin,rgrid,rweigh,wfftc,-1, cchiq)
          call fftout(mxmpts,mode,cchiq,qgrid,xlow,xhigh,
     $         nout,mpts,chifit)
       else
          call fftout(mxmpts,mode,tmpft,xgrid,xlow,xhigh,
     $         nout,mpts,chifit)
       endif
cc       if (ifft.eq.0) nout = nout/2
       return
c  end subroutine fitfft
       end

       subroutine fftout(mpts, mode, xdat, dx, xlo, xhi,nout,npts,xout)
c convert complex data xdat to a real array, using only
c that part of the complex array between [xlow, xhi].
c mode=0 : return real/imag pair
c mode=1 : return real/mag pair

       integer  mpts, npts, nout, nmin, npairs, i, mode
       complex*16  xdat(mpts)
       double precision xout(npts), dx, dxi, xlo, xhi, small, tiny
       double precision dxxr, dxxi
       parameter (tiny = 1.d-9, small = 1.d-2)
c
       dxi    = 1 / max(tiny, dx)
       nmin   = max(0, int(xlo * dxi + small ))
       npairs = max(1, int(xhi * dxi + small )) - nmin + 1
       nout   = min(npts, 2 * npairs)
       do 50 i= 1, npairs
          dxxr = dble (xdat( nmin + i ))
          dxxi = dimag(xdat( nmin + i ))
          xout(2*i-1) = dxxr
          if (mode.eq.1) then
             dxxi = dxxr*dxxr + dxxi*dxxi
          endif
          xout(2*i  ) = dxxi
 50    continue
       return
c end subroutine fftout
       end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2001 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
       integer function copyr
       call echo(' Copyright (c) 1997-2005 Matthew Newville,'//
     $      ' The University of Chicago')
       copyr = 1
       return
       end

       subroutine enchk(strout, itemp, ieqn, ierr)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c   some syntax checking for encod routine
       include 'encod.h'
       character*2048 strout, emsg*256
       character synerr*22
       integer   itemp(*), ieqn, ilen, istrln, iparen
       integer   ierr, i, ibfr, iaft, it, j, jt, jstack, jcomma
       integer   jcoms(100), jsstak
       logical   strok
       external  istrln
       data synerr /' syntax error: '/


       ierr = 1
       ilen = istrln(strout)
c--
c-- check that one component math functions are followed by "("
c-- and that parentheses are not left hanging
       iparen = 0
       jsstak = 0
       do 4400 i = 1, ieqn + 2
          if (i.eq.1) then
             ibfr = ileft
          else
             ibfr = itemp(i-1)
          end if
          iaft = itemp(i+1)
          it   = itemp(i)
          if (it.eq.ileft)  iparen = iparen + 1
          if (it.eq.iright) iparen = iparen - 1
cc          print*, '   ibfr, it, iaft = ', ibfr, it, iaft
cc          print*, (ibfr.ge.jconst), (it.ge.jconst), (iaft.ge.jconst)
c-- check that iparen is never negative (that is left parens
c   before right parens)
          if ((iparen.lt.0).or.((it.eq.ileft).and.(ibfr.gt. 0)).or.
     $         ((it.eq.ileft).and.(iaft.eq.iright)).or.
     $         ((it.eq.iright).and.(iaft.eq.ileft)).or.
     $         ((it.eq.iright).and.(iaft.gt. 0)) ) then
             call echo( synerr//strout(1:ilen) )
             call warn(2, ' parentheses not used properly')
             return
          end if
c-- check that "(," and ",)" are not in string
          if ( (it.eq.icomma).and.((iaft.eq.iright).or.
     $         (ibfr.eq.ileft).or.(ibfr.eq.icomma)) ) then
             call echo( synerr//strout(1:ilen) )
             call warn(2,'  ",,", "(," and ",)" are not allowed')
             return
          end if
c--   check that one-component math operators are followed by "("
          if ( (it.le.-1000).and.(it.ge.-3000) ) then
             if (iaft.ne.ileft) then
                call echo( synerr//strout(1:ilen) )
                call warn(2,' unary math functions must be '//
     $               'followed by "("')
                return
             end if
             if ( (i.gt.1).and.(ibfr.ge.-3000).and.(ibfr.lt.0)
     $            .and.(ibfr.ne.ileft).and.(ibfr.ne.icomma) )  then
                call echo( synerr//strout(1:ilen) )
                call warn(2,' a number is preceded by a '//
     $               'unary math function without using "(" ')
                return
             end if
          end if
c--   look for a real number preceded or followed by a
c     either a real number or a variable
          if ( (it.ge.jscale).and.
     $        ((iaft.ge.jscale).or.(ibfr.ge.jscale)) )then
             call echo( synerr//strout(1:ilen) )
             if (iaft.ge.0) then
                call warn(2,' a real number is followed by '//
     $               'a real number, variable or fixed value')
             else
                call warn(2,' a real number is preceded by '//
     $               'a real number, variable or fixed value')
             endif
             return
          end if
          if ((it.ge.1).and.(iaft.ge.-3000).and.(iaft.le.-1000)) then
             call echo( synerr//strout(1:ilen) )
             call warn(2,'  a number is followed by a'//
     $            ' unary math function')
             return
          end if
c
c  the sepcial functions debye(,) and eins(,), etc, require
c  a certain number of commas (usually 1 or 2)
          if (it.le.-9000)  then
             jsstak = 0
             jcomma = 0
             do  4200 j = i+1, ieqn
                jt   = itemp(j)
                if (jt.eq.iright) then
                   jsstak = jsstak - 1
                   if (jsstak.eq.0) goto 4210
                endif
                if (jt.eq.ileft ) jsstak = jsstak + 1
                if ((jsstak.eq.1).and.(jt.eq.icomma))
     $               jcomma = jcomma + 1
 4200        continue
 4210        continue 
             if (jsstak.ne.0)   jcomma = -jsstak
             emsg = ''
             if ((it.eq.jdebye).and.(jcomma.ne.1)) then
                emsg = ' debye(temp, theta)'
             elseif ((it.eq.jeins).and.(jcomma.ne.1)) then
                emsg = ' eins(temp, theta)'
             elseif ((it.eq.jmin).and.(jcomma.ne.1)) then
                emsg = ' min(x,y)'
             elseif ((it.eq.jmax).and.(jcomma.ne.1)) then
                emsg = ' max(x,y)'

             elseif ((it.eq.jpenl3).and.(jcomma.ne.1)) then
                emsg = ' penalty_hi(x,hi_val)'
             elseif ((it.eq.jpenl2).and.(jcomma.ne.1)) then
                emsg = ' penalty_lo(x,lo_val)'
             elseif ((it.eq.jpenl1).and.(jcomma.ne.2)) then
                emsg = ' penalty(x,lo_val,hi_val)'
             elseif ((it.eq.jlconv).and.(jcomma.ne.2)) then
                emsg = ' lconvolve(x,y,gamma)'
             elseif ((it.eq.jgconv).and.(jcomma.ne.2)) then
                emsg = ' gconvolve(x,y,gamma)'
             elseif ((it.eq.jterpl).and.(jcomma.ne.2)) then
                emsg = ' linterp(xin,yin,xout)'
             elseif ((it.eq.jterpq).and.(jcomma.ne.2)) then
                emsg = ' qinterp(xin,yin,xout)'
             elseif ((it.eq.jterps).and.(jcomma.ne.2)) then
                emsg = ' splint(xin,yin,xout)'
             elseif ((it.eq.jterpa).and.(jcomma.ne.2)) then
                emsg = ' ainterp(xin,yin,xout)'
             elseif ((it.eq.jrebin).and.(jcomma.ne.2)) then
                emsg = ' rebin(xin,yin,xout)'
             elseif ((it.eq.jkktf).and.(jcomma.ne.1)) then
                emsg = ' kkf(e,f1)'
             elseif ((it.eq.jkktr).and.(jcomma.ne.1)) then
                emsg = ' kkr(e,f2)'
             elseif ((it.eq.jrngar).and.(jcomma.ne.2)) then
                emsg = ' range(start,stop,step)'
             elseif ((it.eq.jslica).and.(jcomma.ne.2)) then
                emsg = ' slice(array,istart,istop)'
             elseif ((it.eq.jjoina).and.(jcomma.ne.1)) then
                emsg = ' join(array1,array2)'
             elseif ((it.eq.jnofxa).and.(jcomma.ne.1)) then
                emsg = ' nofx(array,val)'
             elseif ((it.eq.jrngar).and.(jcomma.ne.2)) then
                emsg = ' range(start,stop,step)'
             elseif ((it.eq.jxgaus).and.(jcomma.ne.2)) then
                emsg = ' gauss(x,center,gamma)'
             elseif ((it.eq.jxlore).and.(jcomma.ne.2)) then
                emsg = ' loren(x,center,gamma)'
             elseif ((it.eq.jxstep).and.(jcomma.ne.2)) then
                emsg = ' step(x,center,width)'
             elseif ((it.eq.jxvoit).and.(jcomma.ne.3)) then
                emsg = ' pvoight(x,center,fwhm,eta)'
             elseif ((it.eq.jxcube).and.(jcomma.ne.4)) then
                emsg = ' cube(x,a0,a1,a2,a3)'
             endif
             if (emsg.ne.'') then
                call echo( synerr//strout(1:ilen) )
                call warn(2,'      use   '// emsg)
                return
             end if
          end if
 4400  continue
       ierr = 0
       return
       end
       subroutine engrpn(input,icode)
c
c  convert infix encoded math expression to reverse polish /postfix.
c  works well when part of encod, but has not been well-tested.
c
c strategy:
c    first assign class of operation to each argument in icode.
c    then convert unary minus signs to a one-component operator. 
c    next, two component function are put after their two arguments. 
c    one component operators are then put after their argument.   
c    finally,  parentheses and  commas are dropped.
c
c  copyright (c) 1998  matt newville
c
       include 'encod.h'
       integer   ibfr, istack, maxlen
       parameter(maxlen= 256)
       integer   icode(*),  input(*), itemp(maxlen) , idone(maxlen)
       integer   iclass(maxlen), icltmp(maxlen), idtemp(maxlen)
       integer   iclo(6), i, ic, ichi, icn, id, j, j0, k, ksave
       integer   idebug
       logical   opera
c-- initialize itemp, and assign class to objects and operators
       
c
       idebug = 0
       do 70 j = 1, maxlen
          icode(j) = input(j)
 70    continue 
       do 90 j = 1, maxlen
           i = icode(j)
           if (i.eq.0)                        iclass(j) = 0
           if (i.gt.0)                        iclass(j) = 1
           if ((i.le.-1000).and.(i.ge.-3000)) iclass(j) = 2
           if ((i.eq.iadd) .or.(i.le.isub))   iclass(j) = 3
           if ((i.eq.imul) .or.(i.le.idiv))   iclass(j) = 4
           if (i.eq.iy2x)                     iclass(j) = 5
           if (i.lt.-6000)                    iclass(j) = 6
           if (i.eq.ileft)                    iclass(j) = 7
           if (i.eq.iright)                   iclass(j) = 8
           if (i.eq.icomma)                   iclass(j) = 9
           itemp(j) = icode(j)
           icltmp(j) = iclass(j)
  90    continue
c--
c unary minus and plus --> unitary operators
c minus signs are hard: find next operator at this level,
c and convert  "- x1" to  "neg ( x1 )", which will then be
c converted down below to "x1 neg".
c--
       do 500 j0 = 1, maxlen
          j = j0
 100      continue
          i  = itemp(j)
          ic = icltmp(j)
          if(ic.eq.0) go to 510
          ibfr = 0
          if (j.gt.1)      ibfr = iclass(j-1)
c-- unary plus sign
          if ( ((j.eq.1).or.(ibfr.eq.7).or.(ibfr.eq.4).or.(ibfr.eq.5)
     $         .or.(ibfr.eq.9))    .and.(i.eq.iadd)  )  then
             do 120  k = j, maxlen-1
                icode(k)  = itemp(k+1)
                iclass(k) = icltmp(k+1)
 120         continue
             icode(maxlen)  = 0
             iclass(maxlen) = 0
             do 130  k = j, maxlen
                itemp(k)  = icode(k)
                icltmp(k) = iclass(k)
 130         continue
             go to 100
c-- unary minus sign
c--  change minus sign to unary operator
c--     if next object is (, then we're done.
c--     otherwise, ... - x ... -> ... neg ( x ) ...
          elseif ( ((j.eq.1).or.(ibfr.eq.7).or.(ibfr.eq.9).or.
     $            (ibfr.eq.4).or.(ibfr.eq.5)).and.(i.eq.isub)) then
c  replace '-' with 'neg'
             icode(j)  = ineg
             iclass(j) = 2
c neg number : find next +-,) or end of line, and insert parentheses.
             if (iclass(j+1).eq.1) then
                icn   =  icltmp(j+1)
                opera = (icn.eq.9).or.(icn.eq.8).or.(icn.eq.0)
     $               .or.(icn.eq.3)
c
                if (.not.opera) then
                   istack = 0
                   k      = j
 140               continue
                   k = k + 1
                   if (k.ge.maxlen) go to 150
                   icn   =  icltmp(k)
                   opera =  (icn.eq.9).or.(icn.eq.8).or.(icn.eq.0)
     $                  .or.(icn.eq.3)
                   if ( (istack.eq.0) .and.opera) go to 150
                   if (icn.eq.7) istack = istack + 1
                   if (icn.eq.8) istack = istack - 1
                   go to 140
 150               continue
                   ksave = k -1
c  insert left paren
                   icode(j+1)  = ileft
                   iclass(j+1) = 7
c  bump everything after left paren up by 1
                   do 170  k = j+2, ksave + 1
                      icode(k)  = itemp(k-1)
                      iclass(k) = icltmp(k-1)
 170               continue
c  insert right paren
                   icode(ksave+2)  = iright
                   iclass(ksave+2) = 8
c  bump everything after right paren up by 2
                   do 180  k = ksave+3, maxlen-2
                      icode(k)  = itemp(k-2)
                      iclass(k) = icltmp(k-2)
 180               continue
                end if
c
c neg unary operator : need to find end of argument of operator.
c       then change '-' -> neg and insert parens.
             elseif (((iclass(j+1).eq.2).or.(iclass(j+1).eq.6))
     $               .and.(iclass(j+2).eq.7)) then
c  find end of argument
                istack = 1
                do 200 k = j+3, maxlen
                   if (icltmp(k).eq.7) istack = istack + 1
                   if (icltmp(k).eq.8) istack = istack - 1
                   if (istack.eq.0) go to 220
 200            continue
 220            continue
                ksave = k
c  insert left paren
                icode(j+1)  = ileft
                iclass(j+1) = 7
c  bump everything after left paren up by 1
                do 250  k = j+2, ksave + 1
                   icode(k)  = itemp(k-1)
                   iclass(k) = icltmp(k-1)
 250            continue
c  insert right paren
                icode(ksave+2)  = iright
                iclass(ksave+2) = 8
c  bump everything after right paren up by 2
                do 280  k = ksave+3, maxlen-2
                   icode(k)  = itemp(k-2)
                   iclass(k) = icltmp(k-2)
 280            continue
             end if
             do 380 k = 1, maxlen
                itemp(k) = icode(k)
                icltmp(k) = iclass(k)
 380         continue
             j = j - 1
             if (j.eq.0) j = 1
             go to 100
          end if
c reset itemp and icltmp and go back to beginning
 500   continue
 510   continue
c
       do 600 i = 1, maxlen
          icode(i) = itemp(i)
          iclass(i) = icltmp(i)
 600   continue
c---------------------------------------------------------------------
c-- convert class 5 operators (^ only):
c   x1 ^ x2  -> x1 x2 ^
c    if operator is '^', and is not already followed by ',)+-*/^',
c    then find next place with stack=0 (that is on the current level),
c    that contains an ',)+-*/^'
       ichi = 5
       iclo(1) =  9
       iclo(2) =  8
       iclo(3) =  0
       iclo(4) =  3
       iclo(5) =  4
       iclo(6) =  5
       call pclass(icode, iclass, ichi, iclo)
c---------------------------------------------------------------------
c-- convert class 4 operators (* and / only):
c   x1 * x2  -> x1 x2 *
c    if operator is '*/', and is not already followed by ',)+-*/',
c    then find next place with stack=0 (that is on the current level),
c    that contains an ',)+-*/'
c  undo iclo(6) = '^' to a repeat of iclo(3) = 0
       ichi    =  4
       iclo(6) =  0
       call pclass(icode, iclass, ichi, iclo)
c---------------------------------------------------------------------
c-- convert class 3 operators (+ and - only):
c   x1 + x2  -> x1 x2 +
c    if operator is '+-', and is not already followed by ',)+-',
c    then find next place with stack=0 (that is on the current level),
c    that contains an ',)+-'
c  undo iclo(5) = '*/' to a repeat of iclo(3) = 0
       ichi    =  3
       iclo(5) =  0
       call pclass(icode, iclass, ichi, iclo)
c
       do 900 i = 1, maxlen
          itemp(i) = icode(i)
          icltmp(i) = iclass(i)
 900   continue
c
c---------------------------------------------------------------------
c-- convert class 2 and class 6 operators.
c   all unary operators and special functions have the syntax:
c        f(x1, x2, x3, ...) -> (x1, x2, x3, ...) f
       do 6900 j = 1, maxlen
          idone(j) = 0
          idtemp(j) = 0
 6900  continue
       do 8000 j0 = 1, maxlen - 1
          j  =  j0
 7000     continue
          i  =  itemp(j)
          ic =  icltmp(j)
          id =  idtemp(j)
          if(ic.eq.0) go to 8010
          if ( (id.eq.0).and.
     $         ( (ic.eq.2).or.(ic.eq.6)).and.(iclass(j+1).eq.7)) then
             istack = 1
             do 7200 k = j+2, maxlen
                if (icltmp(k).eq.7) istack = istack + 1
                if (icltmp(k).eq.8) istack = istack - 1
                if (istack.eq.0) go to 7300
 7200        continue
 7300        continue
             ksave = k
             icode(ksave)   = itemp(j)
             iclass(ksave)  = icltmp(j)
             idone(ksave)   = 1
             do 7500  k = j, ksave-1
                icode(k)  = itemp(k+1)
                iclass(k) = icltmp(k+1)
                idone(k)  = idtemp(k+1)
 7500        continue
c     reset itemp and start over again at the same place
             icode(maxlen-1) = 0
             icode(maxlen)   = 0
             idone(maxlen-1) = 0
             idone(maxlen)   = 0
             do 7800 k = 1, maxlen
                itemp(k)  = icode(k)
                icltmp(k) = iclass(k)
                idtemp(k) = idone(k)
 7800        continue
             go to 7000
          end if
 8000  continue
 8010  continue
c---------------------------------------------------------------------
c-- finally, remove all parentheses and commas for icode
cc       print*, 'engrpn: step N-1'
       j = 0
       k = 0
       do 8900 i = 1, maxlen
          itemp(i)  = icode(i)
          icltmp(i) = iclass(i)
          icode(i)  = 0
          iclass(i) = 0
 8900  continue
 9000  continue
       j = j + 1
       if (j.gt.maxlen) go to 9100
       ic = icltmp(j)
       if (ic.eq.0) go to 9100
       if ( (ic.ne.7).and.(ic.ne.8).and.(ic.ne.9)) then
          k = k + 1
          icode(k)  = itemp(j)
          iclass(k) = icltmp(j)
       end if
       go to 9000
 9100  continue
       return
c end subroutine engrpn
       end
       subroutine pclass(icode, iclass, ichi, iclo)
c
c    this is called by engrpn. operators are moved around
c    to convert english math to reverse polish.
c    if operator is of class icin, and is not already followed by
c    an operator with class in iclo,  then find next place with
c    stack=0 (that is on the current level), that contains an
c    operator with class in iclo
c
c  copyright (c) 1998  matt newville
c
       implicit none
       integer i, maxlen, j0, ksave, ic, icn, j, k, istack
       parameter(maxlen = 256)
       integer icode(maxlen), iclass(maxlen), ichi, iclo(6)
       integer itemp(maxlen), icltmp(maxlen)
       logical opera

       do 100 i = 1, maxlen
          itemp(i)  = icode(i)
          icltmp(i) = iclass(i)
 100   continue
       do 2000 j0 = 1, maxlen - 1
          j  =  j0
 500      continue
          ic =  icltmp(j)
cc          print*, '500<< ', j, itemp(j), icltmp(j), ic, ichi, '>>'
          if (ic.eq.0) go to 2010
          if (ic.eq.ichi) then
             icn   =  icltmp(j+1)
             opera = (icn.eq.iclo(1)).or.(icn.eq.iclo(2)).or.
     $            (icn.eq.iclo(3)).or.(icn.eq.iclo(4)).or.
     $            (icn.eq.iclo(5)).or.(icn.eq.iclo(6))
cc             print*, 'opera =', opera
             if (.not.opera) then
                istack = 0
                k      = j
 600            continue
                k = k + 1
                if (k.lt.maxlen) then
                   icn   =  icltmp(k)
                   opera = (icn.eq.iclo(1)).or.(icn.eq.iclo(2)).or.
     $                  (icn.eq.iclo(3)).or.(icn.eq.iclo(4)).or.
     $                  (icn.eq.iclo(5)).or.(icn.eq.iclo(6)) 
cc                   print*, k, icn, ichi, opera
                   if ((istack.ne.0) .or. .not.opera) then
                      if (icn.eq.7) istack = istack + 1
                      if (icn.eq.8) istack = istack - 1
cc                      print*, ' set stack', istack
                      go to 600
                   end if
                end if
                ksave          = k -1
                icode(ksave)   = itemp(j)
                iclass(ksave)  = icltmp(j)
                do 1000  k = j, ksave-1
                   icode(k)  = itemp(k+1)
                   iclass(k) = icltmp(k+1)
 1000           continue
c     reset itemp and start over again at the same place
                icode(maxlen-1) = 0
                icode(maxlen)   = 0
                do 1200 k = 1, maxlen
                   itemp(k) = icode(k)
                   icltmp(k) = iclass(k)
 1200           continue
cc                print*, ' going 500'
                go to 500
             end if
          end if
 2000  continue
 2010  continue
c finish it up
       do 3000 i = 1, maxlen
          icode(i)  = itemp(i)
          iclass(i) = icltmp(i)
 3000  continue
c
       return
c end subroutine class
       end
      subroutine parens(string)
c
c  insert parentheses in a string for a fortran math expression
c  to give the normal math precedence :
c   ^   before   *,/,+,-          and  *,/    before   +,-
c  also:  ** is replaced by ^
c
c  this calls parins, which does the real work of inserting parens.
c
c  copyright (c) 1998  matt newville
c
       character*(*) string, strtmp*2048
       integer       i, ilen,istrln
       external      istrln
c
c  first replace '**' with '^ '
       strtmp = string
       ilen = max(2, istrln(strtmp))
       do 10 i = 1, ilen-1
          if (strtmp(i:i+1).eq.'**')  strtmp(i:i+1) = '^ '
 10    continue
       call unblnk(strtmp)
       ilen = istrln(strtmp)
       if ((strtmp.ne.' ').and.(ilen.gt.0)) then
c
c then put parentheses in to make sure that exponentiation is
c done before multiplication, division, addition, or subtraction.
          if (index(strtmp,'^').ne.0)
     $         call parins(strtmp,ilen,'^','*/+-')
c
c then put parentheses in to make sure that multiplication and
c division are done before addition and subtraction.
          if ((index(strtmp,'*').ne.0).or.(index(strtmp,'/').ne.0))
     $         call parins(strtmp,ilen,'*/','+-')
c
c   put new string into output and return
       endif
       string = strtmp
       return
c end subroutine parens
       end
       subroutine parins(strin, ilen , sopt1, sopt2)
c
c  insert parentheses in a string for a fortran math expression
c  to give the normal math precedence :
c          "sopt1" is more important than "sopt2"
c  this gets kind of ugly but appears to never fail.
c
c  copyright (c) 1998  matt newville
c
       integer     mstack,i, ilen, j, istart, istack, iopt, ioptst
       parameter (mstack = 40)
       character*(*) strin, sopt1, sopt2
       character*2048 string, dummy, str1*1, operas*4, digits*10
       logical       paren(mstack)
       integer       idiff, jstk, i1, i2, io, ieon, nbrstr
       integer       iopen(mstack), istrln
       external      istrln, nbrstr
       data operas, digits / '*/+-', '0123456789'/
c insert a leading blank, initialize stack control and parentheses
       iopt = 0
       dummy = ' '
       dummy(2:ilen+1 ) = strin(1:ilen)
       string = dummy
       istart = 1
       istack = 1
       do 50 i = 1, mstack
          iopen(i)  = 1
          paren(i)  = .false.
 50    continue
 100   continue
       ilen = istrln(string) + 2
       ieon = istart - 1
       do 200 i = istart, ilen
c get current character
c check for exponentiation or parens, update stack index
c and insert parens if they aren't there already
c  note that numbers (found with nbrstr) are skipped over
         str1 = string(i:i)
          if (i.le.ieon) go to 199
          if (index( digits, str1 ).ne.0 ) then
             ieon = i + nbrstr(string(i:))
          elseif (index(sopt1,str1).ne.0) then
             iopt = i
             paren(istack) = .true.
          elseif (str1.eq.'(') then
             istack = istack + 1
             if (istack.gt.mstack) istack = mstack
             iopen(istack) = i
          elseif (str1.eq.')') then
             istack = istack - 1
             if (istack.lt.1) istack = 1
          elseif (index(sopt2, str1 ).ne.0 ) then
             ioptst = i - iopt
             if ( paren(istack)) then
                paren(istack) = .false.
c     normal case: find a far away operation
                if (ioptst.gt.1) then
                   istart = i + 2
                   io = iopen(istack)
                   idiff = i - io
                   if (idiff.gt.1) then
                      dummy = ' '
                      dummy = string(1:io)//'('//
     $                        string(io+1 :i-1)//')'//string(i:)
                      string = dummy
                   end if
c     non-normal case: operation immediately after '^'
                else
                   jstk = 0
                   do 170 j = i + 1, ilen - 2
                      str1 = string(j:j)
                      if (str1.eq.'(') then
                         jstk = jstk + 1
                      elseif (str1.eq.')') then
                         jstk = jstk - 1
                      elseif ( (jstk.eq.0) .and.
     $                        (index(operas,str1).ne.0)) then
                         go to 180
                      end if
 170               continue
 180               continue
                   dummy = ' '
                   dummy = string(:i-1)//'('//string(i: j-1)
     $                  //')'//string(j:)
                   string = dummy
                end if
                go to 100
             else
                iopen(istack) = i
             end if
          end if
 199      continue
 200   continue
c     if needed, insert a last set of parens at the end
       if ( paren(1).and.(iopen(1).ne.1)) then
          i1 = iopen(istack)
          i2 = istrln(string) + 1
          dummy  = ' '
          dummy  = string(1:i1)//'('//
     $         string(i1+1:i2-1)//')'//string(i2:)
          string = dummy
       end if
       call triml(string)
       strin = string
       ilen  = istrln(string)
300    continue
       return
c end soubroutine parins
       end
      integer function nbrstr(string)
c
c  find a number in a string
c  given a string that is known to begin with a digit or sign.
c  return the position of the end of the number.
c  nbrstr : position of end of number
c
c  copyright (c) 1998  matt newville
c
      integer   istrln, i, ilen, iback
      character*(*)  string
      character*1    digit*10, plus, minus, d, e, decml, s, sp
      logical     lexp, ldecml
      data digit  /'1234567890'/
      data minus,plus,d,e,decml /'-','+','d','e','.'/
c------
      ldecml = .false.
      lexp   = .false.
      ilen   = istrln(string)
      nbrstr = ilen
cc      print*, '<nbrstr>{', string(:ilen),'}'
      if (ilen.gt.1) then
         iback  = 1
c find end of number :  digits are always ok.
c stop at second d, e, decml, or sign that's not preceded by (d,e)
         do 200 i = 2, ilen
            sp = string(i-1:i-1)
            s  = string(i:i)
            if (index(digit,s).eq.0) then
               if ( ( (s.ne.plus).and.(s.ne.minus).and.(s.ne.d)
     $                 .and.(s.ne.e).and.(s.ne.decml) )
     $          .or.( lexp.and.((s.eq.d).or.(s.eq.e)) )
     $          .or.( ldecml.and.(s.eq.decml) )
     $          .or.( ( (s.eq.plus).or.(s.eq.minus) ).and.
     $                (sp.ne.d).and.(sp.ne.e) ) )     go to 210
               lexp   = lexp.or.(s.eq.d).or.(s.eq.e)
               ldecml = ldecml.or.(s.eq.decml)
            end if
 200     continue
         iback = 0
 210     continue
         nbrstr = i - 1 - iback
      end if
       return
c  end function nbrstr
       end
       subroutine rpndmp(icode)
c
c purpose: decodes icode array to dump the infix (rpn) description
c          of an encoded formula
c
c copyright (c) 1998  matt newville
       include 'consts.h'
       include 'encod.h'
       include 'arrays.h'
       save
       integer        icode(*), i, ic, ilen, iw, istrln
       character*2048 line, word*32, fword*32
       external       istrln

cc       print*, 'welcome to rpndmp   '
       line = ' '
       ilen = 1
       i    = 0
 10    continue
 20    format (g15.7)
       i    = i + 1
       ic   = icode(i)
       word = ' '
       ic   = icode(i)
       write(word,'(i6)') icode(i)
cc         if (ic.gt.jconst) then
cc            write(word,20) consts(ic - jconst)
cc         elseif ((ic.gt.jscale).and.(ic.le.jconst)) then
cc  cc          print*, i, ic, jscale, ic-jscale
cc  cc          print*, scanam(ic -jscale)
cc            word = scanam(ic - jscale)
cc         elseif (ic.ge.1) then
cc            word = arrnam(ic)
cc         elseif (ic.eq.ileft) then
cc            word = '('
cc         elseif (ic.eq.iright) then
cc            word = ')'
cc         elseif (ic.eq.icomma) then
cc            word = ','
cc         elseif (ic.eq.iexp) then
cc            word = 'exp'
cc         elseif (ic.eq.ilog) then
cc            word = 'ln'
cc         elseif (ic.eq.ilog10) then
cc            word = 'log10'
cc         elseif (ic.eq.isqrt) then
cc            word = 'sqrt'
cc         elseif (ic.eq.isin) then
cc            word = 'sin'
cc         elseif (ic.eq.icos) then
cc            word = 'cos'
cc         elseif (ic.eq.itan) then
cc            word = 'tan'
cc         elseif (ic.eq.iasin) then
cc            word = 'asin'
cc         elseif (ic.eq.iacos) then
cc            word = 'acos'
cc         elseif (ic.eq.iatan) then
cc            word = 'atan'
cc         elseif (ic.eq.iabs) then
cc            word = 'abs'
cc         elseif (ic.eq.ineg) then
cc            word = '-'
cc         elseif (ic.eq.isinh) then
cc            word = 'sinh'
cc         elseif (ic.eq.icosh) then
cc            word = 'cosh'
cc         elseif (ic.eq.itanh) then
cc            word = 'tanh'
cc         elseif (ic.eq.icoth) then
cc            word = 'coth'
cc         elseif (ic.eq.iadd) then
cc            word = '+'
cc         elseif (ic.eq.isub) then
cc            word = '-'
cc         elseif (ic.eq.imul) then
cc            word = '*'
cc         elseif (ic.eq.idiv) then
cc            word = '/'
cc         elseif (ic.eq.iy2x) then
cc            word = '^'
cc         elseif (ic.eq.jadd) then
cc            word = 'add'
cc         elseif (ic.eq.jsub) then
cc            word = 'sub'
cc         elseif (ic.eq.jmin) then
cc            word = 'min'
cc         elseif (ic.eq.jmax) then
cc            word = 'max'
cc         elseif (ic.eq.jkktf) then
cc            word = 'kkf'
cc         elseif (ic.eq.jkktr) then
cc            word = 'kkr'
cc         elseif (ic.eq.jfftf) then
cc            word = 'ftf'
cc         elseif (ic.eq.jfftr) then
cc            word = 'ftr'
cc         elseif (ic.eq.jpenl1) then
cc            word = 'penalty'
cc         elseif (ic.eq.jpenl2) then
cc            word = 'penalty_lo'
cc         elseif (ic.eq.jpenl3) then
cc            word = 'penalty_hi'
cc         elseif (ic.eq.jdebye) then
cc            word = 'debye'
cc         elseif (ic.eq.jeins) then
cc            word = 'eins'
cc         elseif (ic.eq.jgamma) then
cc            word = 'gamma' 
cc         elseif (ic.eq.jlgamm) then
cc            word = 'loggamma' 
cc         elseif (ic.eq.jerf) then
cc            word = 'erf'
cc         elseif (ic.eq.jerfc) then
cc            word = 'erfc'
cc         elseif (ic.eq.jerfcx) then
cc            word = 'erfcx'
cc         elseif (ic.eq.jlconv) then
cc            word = 'lconvolve'
cc         elseif (ic.eq.jgconv) then
cc            word = 'gconvolve'
cc         elseif (ic.eq.jterpl) then
cc            word = 'linterp'
cc         elseif (ic.eq.jterpq) then
cc            word = 'qinterp'
cc         elseif (ic.eq.jterps) then
cc            word = 'splint'
cc         elseif (ic.eq.jterpa) then
cc            word = 'ainterp'
cc         elseif (ic.eq.jrebin) then
cc            word = 'rebin'
cc         elseif (ic.eq.jrngar) then
cc            word = 'range'
cc         elseif (ic.eq.jndarr) then
cc            word = 'indarr'
cc         elseif (ic.eq.j1sarr) then
cc            word = 'ones'
cc         elseif (ic.eq.j0sarr) then
cc            word = 'zeros'
cc         elseif (ic.eq.jasign) then
cc            word = 'sign'
cc         elseif (ic.eq.jceil) then
cc            word = 'ceil'
cc         elseif (ic.eq.jfloor) then
cc            word = 'floor'
cc         elseif (ic.eq.jnpts) then
cc            word = 'npts'
cc         elseif (ic.eq.jvsum) then
cc            word = 'vsum'
cc         elseif (ic.eq.jvprod) then
cc            word = 'vprod'
cc         elseif (ic.eq.jjoina) then
cc            word = 'join'
cc         elseif (ic.eq.jslica) then
cc            word = 'slice'
cc         elseif (ic.eq.jnofxa) then
cc            word = 'nofx'
cc         elseif (ic.eq.-1) then
cc            word = '*variable*'
cc         else 
cc            word = ' '
cc         end if
cc 
cc       fword  = word
       if (ic.ne.0) then
          iw =  istrln(word)
cc          write(fword, '(1x,a,i7,a)')  '(', ic, ') '//word(1:iw)
          write(fword, '(1x,a)')  word(:iw)
          line = line(1:ilen)//' '//fword
       end if
       ilen = max(1,istrln(line))
       if ((i.ge.micode).or.(ic.eq.0).or.(ilen.ge.65)) then
          call triml(line)
          call echo( '     [ '// line(:ilen)//' ]')
          line = ' '
          ilen = 1
          if (i.ge.micode)  call warn(3, ' [ ran out of memory ]')
       endif
       if ((i.lt.micode).and.(ic.ne.0)) go to 10
       
       return
       end
       integer function ienfcn(str)
c convert function name into encod token
       include 'encod.h'
       character*(*) str
       ienfcn = 0

       if (str.eq.'ln') then
          ienfcn = ilog
       elseif (str.eq.'add')  then
          ienfcn = jadd
       elseif (str.eq.'sub')  then
          ienfcn = jsub
       elseif (str.eq.'min')  then
          ienfcn = jmin
       elseif (str.eq.'max')  then
          ienfcn = jmax
       elseif (str.eq.'log')  then
          ienfcn = ilog
       elseif (str.eq.'log10')  then
          ienfcn = ilog10
       elseif (str.eq.'exp')  then
          ienfcn = iexp
       elseif (str.eq.'abs')  then
          ienfcn = iabs
       elseif (str.eq.'sin')  then
          ienfcn = isin
       elseif (str.eq.'cos')  then
          ienfcn = icos
       elseif (str.eq.'tan')  then
          ienfcn = itan
       elseif (str.eq.'npts')  then
          ienfcn = jnpts
       elseif (str.eq.'ceil')  then
          ienfcn = jceil
       elseif (str.eq.'vsum')  then
          ienfcn = jvsum
       elseif (str.eq.'kkf')  then
          ienfcn = jkktf
       elseif (str.eq.'kkr')  then
          ienfcn = jkktr
       elseif (str.eq.'ftf')  then
          ienfcn = jfftf
       elseif (str.eq.'gauss')  then
          ienfcn = jxgaus
       elseif (str.eq.'loren')  then
          ienfcn = jxlore
       elseif (str.eq.'pvoight')  then
          ienfcn = jxvoit
       elseif (str.eq.'cubic')  then
          ienfcn = jxcube
       elseif (str.eq.'step')  then
          ienfcn = jxstep
       elseif (str.eq.'ftr')  then
          ienfcn = jfftr
       elseif (str.eq.'eins')  then
          ienfcn = jeins
       elseif (str.eq.'gamma')  then
          ienfcn = jgamma
       elseif (str.eq.'loggamma') then
          ienfcn = jlgamm
       elseif (str.eq.'erf') then
          ienfcn = jerf
       elseif (str.eq.'erfc') then
          ienfcn = jerfc
       elseif (str.eq.'erfcx') then
          ienfcn = jerfcx
       elseif (str.eq.'sqrt')  then
          ienfcn = isqrt
       elseif (str.eq.'asin')  then
          ienfcn = iasin
       elseif (str.eq.'acos')  then
          ienfcn = iacos
       elseif (str.eq.'atan')  then
          ienfcn = iatan
       elseif (str.eq.'sinh')  then
          ienfcn = isinh
       elseif (str.eq.'cosh')  then
          ienfcn = icosh
       elseif (str.eq.'coth')  then
          ienfcn = icoth
       elseif (str.eq.'tanh')  then
          ienfcn = itanh
       elseif (str.eq.'penalty')  then
          ienfcn = jpenl1
       elseif (str.eq.'penalty_lo')  then
          ienfcn = jpenl2
       elseif (str.eq.'penalty_hi')  then
          ienfcn = jpenl3
       elseif (str.eq.'debye')  then
          ienfcn = jdebye
       elseif (str.eq.'deriv')  then
          ienfcn = jderiv
       elseif (str.eq.'smooth')  then
          ienfcn = jsmoo
       elseif (str.eq.'floor')  then
          ienfcn = jfloor
       elseif (str.eq.'vprod')  then
          ienfcn = jvprod
       elseif (str.eq.'interp')  then
          ienfcn = jterpl
       elseif (str.eq.'lconvolve') then
          ienfcn = jlconv
       elseif (str.eq.'gconvolve') then
          ienfcn = jgconv
       elseif (str.eq.'indarr')  then
          ienfcn = jndarr
       elseif (str.eq.'zeros')  then
          ienfcn = j0sarr
       elseif (str.eq.'range')  then
          ienfcn = jrngar
       elseif (str.eq.'ones')  then
          ienfcn = j1sarr
       elseif (str.eq.'sign')  then
          ienfcn = jasign
       elseif (str.eq.'linterp')  then
          ienfcn = jterpl
       elseif (str.eq.'qinterp')  then
          ienfcn = jterpq
       elseif (str.eq.'ainterp')  then
          ienfcn = jterpa
       elseif (str.eq.'splint')  then
          ienfcn = jterps
       elseif (str.eq.'rebin')  then
          ienfcn = jrebin
       elseif (str.eq.'join')  then
          ienfcn = jjoina
       elseif (str.eq.'slice')  then
          ienfcn = jslica
       elseif (str.eq.'nofx')  then
          ienfcn = jnofxa
       end if
       return
       end
       logical function ic_is_arr(icode, micode)
c decide if an icode returns an array
       include 'encod.h'
       integer j, micode, icode(*)
       ic_is_arr = .false.
       do 10 j = 1,  micode
          ic_is_arr = (((icode(j).gt.0).and.(icode(j).le.jscale))
     $         .or. (icode(j).eq.jndarr)
     $         .or. (icode(j).eq.jrngar)
     $         .or. (icode(j).eq.j1sarr)
     $         .or. (icode(j).eq.jjoina)
     $         .or. (icode(j).eq.j0sarr)  )
          if (ic_is_arr.or.(icode(j).eq.0)) go to 20
 10    continue
 20    continue
       return
       end
       subroutine stack(x,mpts,mstack,npts,istack,ipop)
c
c purpose: part of encod/decod: stack management for decod
c
c arguments:
c      x        stack array  (2d)                    [in/out]
c      mpts     dimension of x (number of points)    [in]
c      mstack   dimension of x (length of stack)     [in]
c      npts     array of number of points for each   [in/out]
c               stack element
c      istack   current length of real stack         [in/out]
c      ipop     number of elements to pop of stack   [in]
c
c notes:
c   1. the stack help in array x is dropped by ipop components
c       ipop = 1 for 2 component math
c
c requires:  none
c
c copyright 1997  matt newville
       integer  mpts, mstack, istack, ipop, i, j
       integer  npts(mstack)
       double precision x(mpts, mstack)
       istack = istack - ipop
       do 30 i = 2, istack
          npts(i) = max(1, min(mpts,npts(i+ipop)))
          do 20 j = 1, npts(i)
             x(j, i)  = x(j, i + ipop)
 20       continue
 30    continue
       do 60 i = istack + 1, istack + ipop
          npts(i) = max(1, min(mpts,npts(i+ipop)))
          do 50 j = 1, npts(i)
             x(j, i)  = 0
 50       continue
 60   continue
       return
c end subroutine stack
       end
       integer function nptstk( n1, n2 )
c   number of vector points for a two-component math operation:
c   n1 = min(n1, n2) unless either n1 or n2 = 1, which
c   means one of the components is a constant, and
c   should be applied to all elements of vector 2
c
c  copyright (c) 1998  matt newville
c
       integer n1, n2
       nptstk = min ( n1, n2 )
       if ( (n1.le.1).or.(n2.le.1) ) nptstk = max ( n1, n2 )
       return
c  end function nptstk
       end

       subroutine iff_print(string)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c generalized print
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       save
       character*(*)  string, str*256, s*256, sout*2048
       double precision getsca
       integer iw, i, j, k, istrln, ntmp
       integer  ilsout, isarr, iff_eval
       logical  istext, islit, needcr
       external istrln, iff_eval, getsca

       if (int(getsca('&sync_level',0)).ge.2)  call iff_sync
       str = string
       needcr = .false.
c  interpret any and all keyword/value pairs for setting options
       nkeys = mkeys
       call print_arg(str, '''','''', 1, nkeys, keys)
c
       messg  = blank
       sout   = blank
       ilsout = 1
       do 900 iw = 1, nkeys  
          k = istrln(keys(iw))
          s = keys(iw)(1:k)
          call lower(s)
          call triml(s)
          k = istrln(s)
          istext = (s(1:1).eq.'$')
          islit  = ((s(1:1).eq.'''') .and.(s(k:k).eq.''''))
c     $         .or. ((s(1:1).eq.'''').and.(s(k:k).eq.'''')))
c
c literal string
          if (islit) then
             write(messg,'(1x,a,1x)') s(2:k-1)
             call ipr_app(sout,messg,ilsout,0)
             needcr = .true.
c
c text string
          elseif (istext) then
             do 120 j = 1, maxtxt
                if (s(2:).eq.txtnam(j)) then
                   i = istrln(text(j))
                   write(messg,'(1x,a,1x)') text(j)(:i)
                   call ipr_app(sout,messg,ilsout,0)
                   needcr = .true.
                   go to 125
                end if
 120         continue 
 125         continue 
c
c numerical variable: evaluate
          else 
             isarr = iff_eval(s(1:k), undef, tmparr, ntmp)
             if (isarr.eq.1) then 
                do 780  j =1,ntmp
                   write(messg,'(1x,g17.9)') tmparr(j)
                   call ipr_app(sout,messg,ilsout,0)
                   needcr = .true.
 780            continue 
             else
                write(messg,'(1x,g17.9)') tmparr(1)
                call ipr_app(sout,messg,ilsout,0)
                needcr = .true.
             end if 
          end if
c
 900   continue 
       if (needcr)  call ipr_app(sout," ",ilsout,1)
       return
       end


       subroutine ipr_app(str, s2, ilen,iflush)
c
c
       character*(*) str, s2
       integer  istrln, ilen, iflush
       external istrln

       str  = str(1:ilen)//s2
cc       call triml(str)
       ilen = istrln(str)
       if ((iflush.eq.1).or.(ilen.ge.128)) then
          if (ilen.ge.1) call echo(str)
          str  = ' '
          ilen = 1
       endif
       return 
       end

       subroutine print_arg(str,s1,s2,iblank,nwords, words)
c
c   breaks string into arguments =  words are separated by one or
c   more whitespace, unless "protected" by quotes, braces, or parens. 
c   the protecting characters are stripped off
c
c     args        i/o      description
c     ----        ---      -----------
c     s            i       char*(*) string to be broken up
c     s1           i       open  delimiters to preserve on output
c     s2           i       close delimiters to preserve on output
c     iblank       i       flag for whether to break words on whitespace
c                          (1 yes, 0 comma-only)       
c     nwords      i/o      input:  maximum number of words to get
c                          output: number of words found
c     words(nwords) o      char*(*) words(nwords)
c                          contains words found.  words(j), where j is
c                          greater then nwords found, are undefined on
c                          output.

       integer  i, ibeg, ilen, istrln, icount, iblank
       character*(*) str, s1, s2, words(nwords)
       character s, blank, comma, op*4, cl*4, st1, st2
       logical   comfnd, delims, isquot, border
       parameter (blank = ' ', comma = ',')
       external istrln
       data op, cl / '[{"''',  ']}"'''/

       delims = (s1.ne.blank).or.(s2.ne.blank)
cc       if (s1.ne.blank)  op = s1
cc       if (s2.ne.blank)  cl = s2
       mwords = nwords
       nwords = 0
       call untab (str)
       call triml (str)
       ilen   = istrln (str) + 1
       str    = str//' '
c  check for blank string
       if (ilen .eq. 1) return
       ibeg   = 1
       iprot  = 0
       comfnd = .true.
       isquot = .false.
       i = 0
 100   continue 
       i  = i + 1
       s  = str(i:i)
       if (nwords .ge. mwords)  return
c
c
       border =(s.eq.comma).or.((iblank.eq.1).and.(s.eq.blank))
c if the string is protected, march on til end of protection
       if (index(op,s).ge.1) then
          comfnd = .false.
          ibeg   = i 
          iprot  = index(op,s)
          icount = 0
          if (iprot.gt.0) then
             icount = 1
             st1    = op(iprot:iprot)
             st2    = cl(iprot:iprot)
             isquot = st1.eq.st2
          endif
 120      continue 
          i = i + 1
          s  = str(i:i)
          if (isquot) then 
             if (s.eq.st1) icount = 0
          else
             if (s.eq.st1) icount = icount + 1 
             if (s.eq.st2) icount = icount - 1
          end if
          if ((i.le.ilen).and.(icount.ge.1)) go to 120
          nwords = nwords + 1
          words (nwords) = str (ibeg: i)
cc          print*, ':: nwords ', nwords, ' = ', str(ibeg:i)
          
c  if 'protected delimiters' was not used, strip off first and
c  last characters
          if (.not.delims) words(nwords) = str(ibeg+1:i-1)
          go to 100
c
c if not a comma or blank, we have a word: continue til next blank or comma
c
       elseif (.not.border) then
          comfnd = .false.
          ibeg  = i
 160      continue 
          i = i + 1
          s  = str(i:i) 
          if ((i.le.ilen).and.(s.ne.comma).and.(s.ne.blank)) go to 160
          nwords = nwords + 1
          words (nwords) = str (ibeg: i-1)
          go to 100
c
c keep track of double commas -- count as a blank word
c
       elseif (s.eq.comma) then
          if (comfnd) then
             nwords = nwords + 1
             words (nwords) = blank
          endif
          comfnd = .true.
       end if
       if (i.le.ilen) go to 100
c
       return
c end subroutine gtarg
       end

       subroutine chipth(ampfef, phafef, qfeff, xlamb, realp, nffpts,
     $      reff, degen, s02, e0shft, e0imag, delpha, deltar, sigma2,
     $      third, fourth, tranq, rm2flg,
     $      nqvals, mchiq, chiqr, chiqi)
c
c  evaluate the theoretical chi(k) for a scattering path given:
c   1. feff information          (ampfef - degen)
c   2. the xafs path parameters  (s02 - fourth)
c
c     copyright 1993 university of washington        matt newville
c
c input:
c    ampfef   amplitude from feff for the path
c    phafef   phase shift from feff (w/o 2*k*r term) for the path
c    qfeff    k-values from feff for the other feff arrays
c    xlamb    mean-free-path from feff
c    realp    real part of p (momentum) from feff
c    nffpts   number of data points in the feff arrays
c    reff     half path length for the path
c    degen    path degeneracy (# of equivalent paths)
c    s02      constant multiplicitive amplitude factor for the path
c    e0shft   e0 shift to use for the path
c    e0imag   imaginary e0 shift / broadening for the path
c    delpha   constant phase shift (delta phase )
c    deltar   delta r to add to reff for the path
c    sigma2   debye-waller factor for the path
c    third    third cumulant for the path
c    fourth   fourth cumulant for the path
c    tranq    real paramter giving coefficient in tranquada correction
c    rm2flg   flag for using (reff)^{-2} instead of (reff+delr)^{-2}
c    nqvals   index of highest q value to calculate
c             (no greater than 512, no less than 20)
c    mchiq    array dimension for chiqr and chiqi
c output:
c    chiqr    real part \   of complex chi(k) for this path
c    chiqi    imag part /   with all path parameters applied
c **note measured chi(k) data corresponds to  chiqi **
c------------------------------------------------------------------
       integer izero, ipos, i, nqvals, nffpts, nqdata, mchiq, nqffmx
       complex*16 coni, cp, cp2, cphshf, cdwf, cargu, cchi, ciei
       double precision chiqr(mchiq), chiqi(mchiq)
       double precision e0eff, s02r2n, degen, reff, sigma2, third
       double precision s02, e0shft, e0imag, delpha, deltar
       double precision first, fourth, r2m2, qgrid, energy, q, tranq
       double precision expmax, expmin, small, etok, one
       double precision rep, xlam, cxlam, pha, amp, car
       double precision ampfef(nffpts), phafef(nffpts)
       double precision qfeff(nffpts), xlamb(nffpts),  realp(nffpts)
       logical rm2flg, le0big
       parameter (coni = (0., 1.) , one = 1.)
       parameter (small=0.0001, etok = 0.26246 82917 )
       parameter (expmax = 30., expmin = -expmax, qgrid = 1./20.)
c------------------------------------------------------------------
c  combine path parameters and feff data to get theory chi
c  note: feff writes out the feffnnnn.dat files such that
c    phase = 2*q*r + phase_shifts. additional phase shifts and
c    all amplitude reduction terms use p, the complex momentum.
c    q is used only to reproduce chi(k) from feff
       nqffmx = int(qfeff(nffpts) / qgrid) + 5
       nqdata = min(512, min(nqvals, min(nqffmx, mchiq)))
       if (nqdata.lt.25)  nqdata = 400
c tranquada correction
       first = deltar - tranq * sigma2 / reff
       r2m2  = 1 / ( (reff + deltar) * (reff + deltar) )
       if (rm2flg)  r2m2   = 1 / ( reff * reff )
       le0big  = (abs(e0shft).ge.small)
c ipos is a place holder for the routine lintrp
c izero stores the index of the q = 0. location.
       ipos   = 1
       izero  = 0
c store some multiplications before the main loopa
       e0eff  = e0shft * etok
       ciei   = coni * e0imag * etok
       s02r2n = degen * s02 * r2m2
c the official xafs calculation loop:
       do 500 i = 1, nqdata
c  e0-shift the value of q
          q   = (i - 1) * qgrid
          if (le0big) then
             energy =  q*q - e0eff
             q      = sign(one,energy) * sqrt(abs(energy))
          end if
c  q = zero is special, and will be dealt with below
          if (abs(q).le.small) then
             izero = i
          else
c  interpolate amplitude, phase, realp and xlamb of feff chi
             call lintrp(qfeff,  realp, nffpts, q, ipos,  rep)
             call lintrp(qfeff,  xlamb, nffpts, q, ipos, xlam)
             call lintrp(qfeff, phafef, nffpts, q, ipos,  pha)
             call lintrp(qfeff, ampfef, nffpts, q, ipos,  amp)
c  evaluate complex momemtum
             cp2    =  (rep + coni/max(xlam,small))**2 + ciei
             cp     =  sqrt(cp2)
c  mean free path, complex debye-waller factor and phase shift
             cxlam  =  -2*reff* dimag(cp)
             cdwf   =  -2*cp2 * (sigma2 -    cp2 * fourth/3)
             cphshf =   2*cp  * (first  - (2*cp2)* third /3) + delpha
c  create complex chi, first checking that the exponential won't crash
             cargu  =  cxlam + cdwf + coni*(2*q*reff + pha + cphshf)
             car    =  max(expmin, min(expmax, dble(cargu)))
             cchi   =  (amp * s02r2n / abs(q)) *
     $                     exp(cmplx(car, dimag(cargu)))
c  save real and imag chi for this value of q
             chiqi(i) = dimag(cchi)
             chiqr(i) = -dble(cchi)
cc             print*, i, q, rep, xlam,  pha, amp, cchi
          end if
 500   continue
c  fill in guess for data at q = zero if needed
       if (izero.eq.1)  then
          chiqr(1) = 2*chiqr(2) - chiqr(3)
          chiqi(1) = 2*chiqi(2) - chiqi(3)
       elseif (izero.ge.2) then
          chiqr(izero) = (chiqr(izero-1) + chiqr(izero+1))/2
          chiqi(izero) = (chiqi(izero-1) + chiqi(izero+1))/2
       end if
       return
c end subroutine chipth
       end

      subroutine fitchk
c
c      this routine does some error checking of the math expressions
c      for feffit.  the expressions have already been encoded in
c      fitinp, and the math syntax has been checked in encod, but not
c      all the checks could be done until all the input files have been
c      read in. done here are checks so that:
c        1.  all variables named in the math expresions must
c            be defined as either variables or functions.
c        2.  all defined variables and functions are used, or a
c            warning will be given.
c        3.  all encoded math expressions can be reliably decoded.
c            all math expressions are actually evaluated here.
c
c      also done here is the use of the zeroth (0th) path as the default
c      expression for the various path parameters. the 0th path will be
c      used here to overwrite those path parameters that were not
c      explicitly given in the input file.
c
c      copyright 1993 university of washington         matt newville
c
c----------------------------------------------------------------
       include 'fitcom.h'
c  from encod!
       integer   jconst, io2n(maxval)
       integer  iv, id, i, j, ip, jv, ilcl, inpath, jpar
       integer  idata, inpth0, idpath, ipar, nvar
       parameter (jconst = 8192)
c----------------------------------------------------------------------
c
c fix integer codes to put variables first, then constants, then
c ordered math expressions, so that a single pass will correctly
c evaluate all "set" values
c notes:  puts "local" variables  after constants
c         doesn't check for pathological recursion
       nvar = numvar
       call fixicd(icdval, maxval, micode, jconst, ixlocl,
     $      vnames, values, nvar, nconst, nmathx, io2n)
       if (nvar.ne.numvar)  call finmsg(3200,' ',' ',0)
c update xguess to reordered values!
       do 150 iv = 1, numvar
          xguess(iv) = values(iv)
 150      continue
c
       do 360 id = 1, ndata
          do 340 j = 1, mlocal
             do 320 i = 1, micode
                if (icdloc(i,j,id).eq.0) go to 325
                if ((icdloc(i,j,id).gt.0).and.
     $               (icdloc(i,j,id).le.nmathx) )
     $               icdloc(i,j,id) = io2n(icdloc(i,j,id))
 320         continue
 325         continue
 340      continue
 360   continue
c
       do 860 ip = 1, mpaths
          do 840 j = 1, mpthpr
             do 820 i = 1, micode
                if (icdpar(i,j,ip).eq.0) go to 825
                if ((icdpar(i,j,ip).gt.0).and.
     $               (icdpar(i,j,ip).le.nmathx))
     $               icdpar(i,j,ip) = io2n(icdpar(i,j,ip))
 820         continue
 825         continue
 840      continue
 860   continue
c
c  check that variables named in math expressions are defined
       do 1000 iv = 1, nmathx
          if ( (vnames(iv).ne.' ').and.(icdval(1,iv).eq.0) )
     $         call finmsg(3220,vnames(iv),' ',0)
 1000  continue
c
c  check that the variables and user-defined functions are used.
c  expection for '_bkg_#' - these won't show up in other user-def fun's
       do 2000 iv = 1, nmathx
          if ( vnames(iv)(1:6).ne.'_bkg_#' ) then
c     check other user-defined functions and local values
             do 1600  jv = 1, nmathx
                if ((icdval(1,jv).gt.0).and.
     $               (icdval(1,jv).le.ixlocl)) then
                   do 1500 i = 1, micode
                      if (icdval(i,jv).eq.iv) go to 1990
 1500              continue
                elseif(icdval(1,jv).gt.ixlocl) then
                   ilcl = icdval(1,jv) -ixlocl
                   do 1560 id = 1, ndata
                      do 1530 i = 1, micode
                         if (icdloc(i,ilcl,id).eq.iv) go to 1990
 1530                 continue
 1560              continue
                endif
 1600        continue
c     check path parameters
             do 1850  inpath = 1, mpaths
                do 1820  jpar = 1, mpthpr
                   do 1800 i   = 1, micode
                      if (icdpar(i,jpar,inpath).eq.iv) go to 1990
 1800              continue
 1820           continue
 1850        continue
             call finmsg(3240,vnames(iv),' ',-1)
          end if
 1990     continue
 2000  continue
c
c  load default path params from the Oth  path.  copy 0th path param
c  to all non-explicitily given path params for that data set.
       do 4200 idata = 1, ndata
          inpth0  = jdtpth(0,idata)
c   if a 0th path is given for this data set...
          if (inpth0.le.0)  go to 4190
c   check all paths for this data set ...
          do 4150 idpath = 1, mdpths
             inpath = jdtpth(idpath, idata)
             if (inpath.gt.0) then
c   that if a zeroth path param was given ***and***
c   an explicit path param was ***not*** given ...
                do 4100 ipar = 1, mpthpr
                   if ((icdpar(1,ipar,inpath).eq.0).and.
     $                  (icdpar(1,ipar,inpth0).ne.0))   then
c   that the zeroth path expression be copied.
                      do 4050 j = 1, micode
                         icdpar(j,ipar,inpath) = icdpar(j,ipar,inpth0)
 4050                 continue
                   endif
 4100           continue
             endif
 4150        continue
 4190     continue
 4200  continue
c
c  check the newly encoded expressions by evaluating them.
c  evaluate the user defined values
       id  = 1
       call setval(1,nmathx,icdval,maxval,micode,
     $      consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
       return
c  end subroutine fitchk
       end

       subroutine iff_rename(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c  rename an array or scalar values for ifeffit
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       save

       character*(*) str, s1*256,  s2*256
       integer nwrds, iw, i, k1, k2, istrln
       external istrln

       nwrds = mkeys
       call bwords(str,nwrds,keys)

c check if this is a vector or scalar
       do 300 iw = 1, nwrds, 2
          k1 = istrln(keys(iw  ))
          k2 = istrln(keys(iw+1))
          s1 = keys(iw  )(1:k1)
          s2 = keys(iw+1)(1:k2)
          call lower(s1)
          call lower(s2)
          if (index(s1,'.').eq.0) then
             do 130 i = 1, maxsca
                if (s1.eq.scanam(i)) scanam(i) = s2
 130         continue 
          else
             do 150 i = 1, maxarr-1
                if (s1.eq.arrnam(i)) arrnam(i) = s2
 150         continue 
          end if
 300   continue 
c      
       return
       end

       subroutine fplog
c
c write log of diffkk.  note that diffkk.log *can* be used as diffkk.inp
       include "dkcom.f"
       integer   istrln, ilog, ier, iex, ilen, i
       character*70    stat*10, logfil, str, atsym*2
       external   istrln, atsym
       data stat   /'unknown'/
c----------------------------------------------------------------------
c  determine log file name (usually trivial)
c  but if not, find the *last* "."
       logfil = 'deltaf.log'
c  open log file
       ilog   = 0
       ier    = 0
       iex    = 0
       call openfl(ilog, logfil, stat, iex, ier)
       if (ier.lt.0) go to 5000
c
c write version number
       write(str,10) versn
 10   format(' --  deltaf version ',a, '--')
       ilen = istrln(str)
       write(ilog,900) str(1:ilen)
       write(ilog,900)   ' program inputs or default values used:' 
       if (ntitle.le.0) then 
          write (ilog, 910)  'title',
     $         'deltaf: no title lines specified'
       else
          do 100 i = 1, ntitle
             ilen = max(1, istrln(title(i)))
             write (ilog, 910)  'title', title(i)(1:ilen)
 100      continue 
       end if
       ilen = max(15, istrln(outfil))
       write (ilog, 930)  'iz', iatz, 'atomic number of core atom'
       write (ilog, 920)  'out', outfil(1:ilen), 'output file name'
c
       write (ilog, 950)  'elow', elow,
     $      'low-energy of calculation range'
       write (ilog, 950)  'ehigh', ehigh,
     $      'high-energy of calculation range'
       write (ilog, 950)  'egrid', egrid,'energy grid for calculation'
       write (ilog, 950)  'ewidth', ewidth,'for broadening CL data'
c
       write(ilog,905) ' end % '//
     $      'all remaining lines will be ignored on input'
       write(ilog,905) ' -- end deltaf log file --'
c
       close(ilog)
       return
 900   format(1x,'# ',a)
 905   format(1x, a)
 910   format(1x, a8, ' = ', a)
 920   format(1x, a8, ' = ', a    ,  1x,'% ',a)
 930   format(1x, a8, ' = ', i4   , 12x,'% ',a)
 950   format(1x, a8, ' = ', f11.4,  5x,'% ',a)
 955   format(6x, a10, ' = ', g15.6)
 5000  continue 
       call messag(' weird, fatal error trying to open input file')
       stop
       end

       subroutine fitint
c
c      initialize the common blocks in feffit at runtime.
c      see also fitbdt, which does this as block data
c
c      copyright 1993 university of washington         matt newville
c----------------------------------------------------------------------
       include 'fitcom.h'
c  temporary parameters for legths of multiple-dimensioned arrays
       integer lwfft, i, j, k
       parameter (lwfft  = (4*maxpts+15)   )
c
c  single values
       frminp = ' '
       frmout = ' '
       asccmt = '# '
       if (vaxflg) asccmt = '##'
       inpfil = 'feffit.inp'
       mdocxx =  0
       xnidp  =  zero
       inform =  0
       ndata  =  0
       rlast  =  10.d0
       cormin =  0.25d0
       rwght1 =  15.d0
       rwght2 =  25.d0
       tranq  =  2.d0
       allout = .true.
       final  = .false.
       rm2flg = .false.
       dphflg = .false.
       kspcmp = .false.
       kspout = .true.
       rspout = .true.
       bkgout = .true.
       qspout = .true.
       pcout  = .false.
       chkdat = .true.
       prmout = .true.
       noout  = .false.
       nofit  = .false.
       degflg = .true.
       iprint = 0
       chisqr = zero
       usrtol = one
       numvar = 0
       nvuser = 0
       ifxvar = 0
       ierbar = 0
       nerstp = 1
       ixpath = 0
       nmathx = 0
       nconst = 0
c
c loop over mdata
       do 300 i = 1, mdata
          skey(i)   = ' '
          outfil(i) = '_fit'
          chifil(i) = ' '
          bkgfil(i) = ' '
          skeyb(i)  = ' '
          do 30 j = 1, maxdoc
             doc(j,i) = ' '
 30       continue
          do 40 j = 1, mtitle
             titles(j,i) = ' '
 40       continue
          qweigh(i) = zero
          rweigh(i) = zero
          qwin1(i)  = zero
          qwin2(i)  = zero
          rwin1(i)  = zero
          rwin2(i)  = zero
          qmin(i)   = zero
          qmax(i)   = zero
          rmin(i)   = zero
          rmax(i)   = zero
          nqfit(i)  = 0
          nqpts(i)  = 0
          nrpts(i)  = 0
          sqwin(i)  = 'hanning'
          srwin(i)  = 'hanning'
          ifft(i)   = 1
          jffphs(i) = 0
          q1st(i)   = zero
          qlast(i)  = zero
          sigdtr(i) = zero
          sigdtk(i) = zero
          sigdtq(i) = zero
          sigwgt(i) = zero
          weight(i) = zero
          rfactr(i) = zero
          xinfo(i)  = zero
          ndoc(i)   = 0
          nkey(i)   = 0
          nkeyb(i)  = 0
          nchi(i)   = 0
          bkgfit(i) = .false.
          bkgdat(i) = .false.
          nbkg(i)   = 0
          datain(i) = .false.
          rbkg(i)   = zero
          do 70 j = 1, mtknot
             qknot(j,i) = zero
 70       continue
          chi2dt(i) = zero
          do 100 j = 1, maxpts
             chifit(j,i) = zero
             qwindo(j,i) = zero
             rwindo(j,i) = zero
             bkgq(j,i) = zero
             chiq(j,i) = zero
             thiq(j,i) = zero
 100      continue
          do 200 j = 0, mdpths
             jdtpth(j,i) = 0
             jdtusr(j,i) = 0
 200      continue
          do 240 j = 1, mlocal
             icdloc(1,j,i) = 0
 240      continue
 300   continue

c
c  loop over mvarys
       do 350 i = 1, mvarys
          xguess(i) = zero
          xfinal(i) = zero
          delta(i) = zero
          do 320 j = 1, mvarys
             correl(j,i) = zero
 320      continue
 350   continue

c
       do 500 i = 1, mfffil
          feffil(i) = ' '
          do 410 j =  1, mffttl
             fefttl(j,i) = '  '
 410      continue
          degpth(i) = one
          refpth(i) = zero
          rwgpth(i) = zero
          nlgpth(i) = 0
          iffrec(i) = 0
          do 420 j = 1, mffpts
             qfeff(j,i)  = zero
             theamp(j,i) = zero
             thepha(j,i) = zero
             realp(j,i)  = zero
             xlamb(j,i)  = zero
 420      continue
          do 460 j = 0, maxleg
             izpth(j,i)  = 0
             iptpth(j,i) = 0
             do 440 k = 1, 3
                ratpth(k,j,i) = zero
 440         continue
 460      continue
 500   continue

       do 700 i = 1, maxval
          values(i) = zero
          vnames(i) = ' '
          icdval(1,i) = 0
 700   continue
       do 750 i = 1, mpaths
          pthlab(i) = ' '
          jpthff(i) = 0
          do 720 j = 1, mpthpr
             icdpar(1,j,i) = 0
 720      continue
 750   continue
c
       do 780 i = 1, mpthpr
          defalt(i) = zero
 780   continue
       defalt(jps02) = one
       parnam(jps02) = 's02'
       parnam(jpe0)  = 'e0'
       parnam(jpei)  = 'ei'
       parnam(jpdpha)= 'dphase'
       parnam(jpdelr)= 'delr'
       parnam(jpsig2)= 'sigma2'
       parnam(jp3rd) = 'third'
       parnam(jp4th) = 'fourth'
       do 800 i = 1, mconst
          consts(i) = zero
 800   continue

       do 900 i = 1,   lwfft
          wfftc(i) = zero
 900   continue
c
c end subroutine fitint
       end

       subroutine encod(string,vnames,nv,consts,nc,icode,ni,ierr)
c
c   copyright 1993  university of washington      matt newville
c
c   this encodes the integer array 'icode' from an equation in the
c   character string 'string'. the companion function *decod* will
c   decode this integer array, returning the proper number.
c   decod is called by:
c             decod(icode, consts, values, defval)
c   the values of 'values' should correspond to the variables named
c   in 'vnames'.  encod and decod are designed for many repeated
c   evaluations. the encoding is slow and slightly redundant and the
c   decoding is as efficient as possible. icode is a small number of
c   integers representing the rpn notation for the math expression,
c   with special integer values specifing all operations and values.
c
c   the character string contains a fortran-like math expression.
c   variables can be used. their names will be held in the character
c   array 'vnames', and their numerical values will be held in the
c   real array 'values'. variables do not need to be explicitly
c   declared before encoding. if a variable is found that has not
c   already been identified, it will be added to the list. the link
c   between variable name and value, and the actual values used are
c   expected to be managed by the routine(s) calling encod and decod.
c
c  input:
c    string  character string containing fortran-like math expression
c    vnames  character array containing variable names
c    nv      dimension of array vnames          (maximum = 8192)
c    consts  real array of numerical constants in math expressions
c    nc      dimension of array consts
c    ni      dimension of icode consts          (maximum = 512)
c  output:
c    string  math expression as to be evaluated (with parens added)
c    vnames  character array containing variable names
c    consts  real array of numerical constants in math expressions
c    icode   integer array containing code for the math expression
c    ierr    error/warning code - routine will not stop !
c           -2     a new variable was added to the list
c           -1     string empty
c            0     no errors or warnings messages at all
c            1     too many constants
c            2     incorrect dimension of vnames
c            3     improper/ambiguous arithmetic
c            5     one-component math syntax error
c            7     parentheses syntax error
c                             ( unmatched or in improper place)
c            9     too many objects in math expresion
c----------------------------------------------------------------------
c    the real array consts contains all the real numbers used as
c    constants. the first 10 values of consts are set aside for
c    "common" real values: 0, 1, 2, pi, etc. these ten constants
c    can be used for accessing internal parameters. the calling
c    routine can associate any values it likes with the first ten
c    numbers, and by rewriting some of this routine, names can be
c    associated with the values. 'pi', and 'reff' are handled in
c    this way. (though it's not expected that anyone will want to
c    overwrite the value of pi, the same is not true for reff).
c
c----------coding parameters for the math operations------------------
c   icode value             meaning
c  -299 to -100     special functions { add(x,y), debye(temp,theta) }
c   -99 to  -50     two-element math operations (x+y, x**y)
c   -49 to  -10     one-element math operations (1/x, sin(x), et c.)
c    -9 to   -6     control operations (open and close parens, comma)
c    -5 or   -1     not possible! (useful for  overwriting/disabling)
c             0     null string
c     1  to jconst  variables corresponding to vnames strings
c jconst to  xxx    constants (numbers in corresponding to consts)
c---------------------------------------------------------------------
c passed variables
       implicit none
       integer       nv, ni, nc, ierr, icode(ni)
       character*(*) string, vnames(nv)
       double precision    consts(nc),   pi, one, zero
       integer    maxlen, jconst, ileft, iright, icomma
       parameter(one = 1.d0, zero = 0.d0, pi = 3.141592653589793d0)
       parameter(maxlen = 1024, jconst = 8192)
       parameter(ileft =  -6, iright =  -7, icomma = -8   )
       integer  iexp, ilog, isqrt, isin, icos, itan, iabs
       integer  iasin, iacos, iatan, isinh, icosh, itanh, icoth
       parameter(iexp  = -10, ilog  = -11, isqrt = -12,
     $             isin  = -13, icos  = -14, itan  = -15,
     $             iasin = -16, iacos = -17, iatan = -18,
     $             iabs  = -19, isinh = -23, icosh = -24,
     $             itanh = -25, icoth = -26  )
       integer     iadd, isub, imul, idiv, iy2x
       parameter(iadd  = -50, isub   = -51, imul   = -52,
     $             idiv  = -53, iy2x   = -54                )
       integer     jadd, jsub, jmin, jmax, jdebye, jeins, jeins2
       parameter(jadd =-111, jsub  =-112, jmin  =-85,
     $      jmax =-86, jdebye=-120, jeins =-121, jeins2=-122)
c
c internal variables
       character*2048  str, strnum, strtmp, errmsg, strout, opera*9
       character*1  str1, straft, strbfr, stri3*3, stri4*4, stri5*5
       character    mtherr*22, synerr*34, encerr*33, number*12
       logical      found, strok
       integer      itemp(maxlen), ntemp, ilen, istr, ieqn
       integer      iparen, iexcla, iperct, ieolc, isave, maxeol
       integer      ibfr, iaft, ibefr, iaftr, ivarln, istrln
       integer      j, jt, jstack, jcomma, ii, it, i, nbrstr
       double precision     xreal
       parameter (number = '1234567890 .' , opera = '+-*/^(), ')
       parameter (mtherr =' math encoding error: ')
       parameter (synerr =' math encoding error: syntax error')
       parameter (encerr =' math encoding error: encod error')
       external     istrln, nbrstr

c-----------------------------------------------------------------------
c  initial error checking of input dimensions
       if (nv.gt.jconst) then
          call echo(mtherr//'incorrect dimension!')
          write (errmsg,'(4x,a,i4,a)') ' more than', jconst,
     $         ' variables are requested '
          ii  = max(1, istrln(errmsg))
          call echo('  '// errmsg(1:ii))
          ierr = 2
          return
       end if
c  initialization
       ierr   = 0
       strtmp = ' '
       str    = ' '
       str1   = ' '
       strnum = ' '
       straft = ' '
       strbfr = ' '
       found  = .false.
c  remove interior blanks from string
       strtmp = string
       ilen   = istrln(strtmp)

       call triml(strtmp)
       call unblnk(strtmp)

       ilen   = istrln(strtmp)
cc       print*, 'UBER #2: ', ilen, ':: ', strtmp(1:ilen)
       maxeol = len(strtmp)
c  remove end-of-line comments:  '!','%'  signify end of line comments
       iexcla = index(strtmp,'!')
       if (iexcla.eq.0) iexcla = maxeol
       iperct = index(strtmp,'%')
       if (iperct.eq.0) iperct = maxeol
       ieolc  = min(iperct,iexcla)
       if (ieolc.eq.1) strtmp = ' '
       if ( (ieolc.ge.2).and.(ieolc.le.maxeol)) then
          str        = strtmp(:ieolc-1)
          str(ieolc:) = ' '
          strtmp     = str
       end if
       ilen   = istrln(strtmp)
cc       print*, 'ENCOD HERE: ', ilen, ':: ', strtmp(1:ilen)
c
c  if string is blank, return
       if ( (strtmp.eq.' ').or.(ilen.le.0).or.(ieolc.eq.1)) then
          icode(1) = 0
          ierr     = -1
          return
       end if
c
c  convert string to the case of this routine :
c    the variable 'case' controls the case of the routine, so it
c    must be the same case as the strings tested for in strtmp.
       call smcase(strtmp, 'c')
       do 40 i = 1, nv
          call smcase(vnames(i), 'c')
 40    continue
c
c  initialized integer arrys to 0
       do 50 i = 1, ni
          icode(i) = 0
 50    continue
       do 60 i=1,maxlen
          itemp(i)  = 0
 60    continue
c
c  set the first values in consts:
c     be careful when changing consts(1) from zero, because the rest
c     of the first ten constants are set to zero also, even though a
c     calling routine may want to overwrite some of them !!!
       consts(1) = zero
       consts(2) = one
       consts(3) = pi
       consts(4) = zero
       consts(5) = zero
       consts(6) = zero
       consts(7) = zero
       consts(8) = zero
       consts(9) = zero
c  initialization done.
c-------------------------------------------------------------------
c  now start dealing with strtmp as a math expression
c  fix multiple "unitary" operations: ++, -- -> +; -+, +- -> -
       do 120 i = 1, ilen-1
          str = strtmp(i:i+1)
          if ((str.eq.'--').or.(str.eq.'++')) strtmp(i:i+1) = ' +'
          if ((str.eq.'-+').or.(str.eq.'+-')) strtmp(i:i+1) = ' -'
 120   continue
       call unblnk(strtmp)
c-----------------------------------------------------------------------
c  insert parens to ensure normal math precedence.
c    note that this is not entirely necessary, but it is convenient
c    to rewrite the string in the way it is intended to be evaluated.
       string = strtmp
       call parens(string)
       call triml(string)
       ilen = max(1, istrln(string))
       string(ilen+1:) = ' '
       strout          = string
       strtmp          = ' '
c-----------------------------------------------------------------------
c  with the string well behaved (parens inserted so there are no
c   ambiguities in the math), let's dechiper it and encode icode
c
c  decipher string into integers
       isave  = 0
       istr   = 0
       ieqn   = 0
       iparen = 0
c  advance string postion, check for end of string
 300   continue
       ieqn = ieqn + 1
 320   continue
       istr = istr + 1
       ibfr = istr - 1
       iaft = istr + 1
       if (ibfr.lt.1) ibfr = 1
       if (istr.gt.ilen) go to 4000
       str1   = string(istr:istr)
       stri3  = string(istr:istr+2)
       stri4  = string(istr:istr+3)
       stri5  = string(istr:istr+4)
       strbfr = string(ibfr:ibfr)
       straft = string(iaft:iaft)
c  ignore blank spaces
       if (str1.eq.' ') go to 320
c-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
c  parse string
c  # constant real number : find length of real number, read it,
c                store it, and advance string to end of number
       if (index(number,str1).ne.0) then
          isave  = istr + nbrstr(string(istr:ilen))
          strnum = string(istr:isave)
          call str2dp(string(istr:isave), xreal, ierr)
          
          if (ierr.ne.0) then
             call echo(mtherr//'cannot read number from string')
             errmsg =  '  >> '//string(istr:isave)//' << '
             call echo(errmsg(1:(isave - istr + 10)))
             ierr = 3
             return
          endif
c       check if constant is already stored. don't start adding more
c       until consts(10), to preserve the stored internal constants
          do 450 i = 1, nc
             if (xreal.eq.consts(i)) then
                itemp(ieqn)  = jconst + i
                go to 500
             elseif ((consts(i).eq.0).and.(i.ge.10)) then
                itemp(ieqn)  = jconst + i
                consts(i) = xreal
                go to 500
             end if
 450      continue
 500      continue
c     error : too many constants!
          if (i.ge.nc) then
             call echo(encerr)
             call echo( ' too many real numbers entered.')
             write (errmsg,'(14x,2a,i4,a)') 'the current',
     $            ' limit is ', nc,' unique numbers.'
             call echo( errmsg )
             ierr = 1
             return
          end if
          istr = isave
c     internally stored constants
c
c     'pi' followed by an operation (or a blank or paren)
c     means use the constant stored in address #(jconst + 3).
       elseif ( (string(istr:istr+1).eq.'pi').and.
     $         (index(opera,string(istr+2:istr+2)).ne.0)  ) then
          itemp(ieqn)  = jconst + 3
          istr         = istr + 1
c
c     'reff' followed by an operation (or a blank or paren)
c     means use the constant stored in address #(jconst + 4).
c             (this is useful for feffit)
       elseif ( (stri4.eq.'reff').and.
     $         (index(opera,string(istr+4:istr+4)).ne.0)  ) then
          itemp(ieqn)  = jconst + 4
          istr         = istr + 3
c
c     'ndegen' followed by an operation (or a blank or paren)
c     means use the constant stored in address #(jconst + 5).
c             (this is useful for feffit)
       elseif ( (string(istr:istr+5).eq.'ndegen').and.
     $         (index(opera,string(istr+6:istr+6)).ne.0)  ) then
          itemp(ieqn)  = jconst + 5
          istr         = istr + 5
c
c      '_k_' followed by an operation (or a blank or paren)
c            means use the constant stored in adress #(jconst + 6).
c            (this is useful for feffit)
c       elseif ( (stri3.eq.'_k_').and.
c     $     (index(opera,string(istr+3:istr+3)).ne.0)  ) then
c             itemp(ieqn)  = jconst + 6
c             istr         = istr + 2
c
c  # end constants
c  # math operations
c   parens and comma
       elseif (str1.eq.'(') then
          itemp(ieqn)  = ileft
          iparen = iparen + 1
       elseif (str1.eq.')') then
          itemp(ieqn)  = iright
          iparen = iparen - 1
       elseif (str1.eq.',') then
          itemp(ieqn)  = icomma
c   two component math
       elseif ((str1.eq.'+').or.(str1.eq.'-')) then
          if ( (straft.eq.')')) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             call echo('  "+)"  and "-)" are not correct syntax.')
             ierr = 3
             return
          else
             if (str1.eq.'+') itemp(ieqn) = iadd
             if (str1.eq.'-') itemp(ieqn) = isub
          end if
       elseif ((str1.eq.'/').or.(str1.eq.'*')) then
          ibefr = index('(+-/*^,',strbfr)
          iaftr = index(')*/^,',straft)
          if ( (istr.eq.1).or.(istr.eq.ilen).or.(iaftr.ne.0)
     $         .or.(ibefr.ne.0)) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             if (ibefr.ne.0) then
                errmsg = '  "/" or "*" preceded by one of "+-/*^,("'
             elseif (iaftr.ne.0) then
                errmsg = '  "/" or "*" followed by one of "/*^,)"'
             elseif (istr.eq.1) then
                errmsg = '  "/" or "*" occurs first'
             elseif (istr.eq.ilen) then
                errmsg = '  "/" or "*" occurs last'
             end if
             ii  = max(1, istrln(errmsg))
             call echo('    '//errmsg(1:ii))
             ierr = 3
             return
          else
             if (str1.eq.'*') itemp(ieqn) = imul
             if (str1.eq.'/') itemp(ieqn) = idiv
          end if
       elseif (str1.eq.'^') then
          ibefr = index('(+-/*^,',strbfr)
          iaftr = index(')*/^,',straft)
          if ( (istr.eq.1).or.(istr.eq.ilen).or.(iaftr.ne.0)
     $         .or.(ibefr.ne.0)) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             if (ibefr.ne.0) then
                errmsg = '  "^" preceded by one of "+-/*^,("'
             elseif (iaftr.ne.0) then
                errmsg = '  "^" followed by one of "/*^,)"'
             elseif (istr.eq.1) then
                errmsg = '  "^" occurs first'
             elseif (istr.eq.ilen) then
                errmsg = '  "^" occurs last'
             end if
             ii  = max(1, istrln(errmsg))
             call echo('    '//errmsg(1:ii))
             ierr = 3
             return
          else
             itemp(ieqn) = iy2x
          end if
c
c   special math functions:
       elseif ((stri4.eq.'add(').or.(stri4.eq.'sub(').or.
     $         (stri4.eq.'min(').or.(stri4.eq.'max(')) then
          if (stri4.eq.'add(')   itemp(ieqn)  = jadd
          if (stri4.eq.'sub(')   itemp(ieqn)  = jsub
          if (stri4.eq.'min(')   itemp(ieqn)  = jmin
          if (stri4.eq.'max(')   itemp(ieqn)  = jmax
          istr   = istr + 2
       elseif (string(istr:istr+5).eq.'debye(') then
          itemp(ieqn)  = jdebye
          istr = istr + 4
       elseif (string(istr:istr+5).eq.'eins2(') then
          itemp(ieqn)  = jeins2
          istr = istr + 4
c
c  one component math :
c    the operator must be followed by '(', or the expression will
c    be a variable name:   ln2 is a variable !
       elseif (stri3.eq.'ln(') then
          itemp(ieqn)  = ilog
          istr = istr + 1
       elseif ((stri4.eq.'log(').or.(stri4.eq.'exp(').or.
     $         (stri4.eq.'abs(').or.(stri4.eq.'sin(').or.
     $         (stri4.eq.'cos(').or.(stri4.eq.'tan(')) then
          if (stri4.eq.'log(')   itemp(ieqn)  = ilog
          if (stri4.eq.'exp(')   itemp(ieqn)  = iexp
          if (stri4.eq.'abs(')   itemp(ieqn)  = iabs
          if (stri4.eq.'sin(')   itemp(ieqn)  = isin
          if (stri4.eq.'cos(')   itemp(ieqn)  = icos
          if (stri4.eq.'tan(')   itemp(ieqn)  = itan
          istr = istr + 2
       elseif ((stri5.eq.'sqrt(').or.(stri5.eq.'asin(').or.
     $         (stri5.eq.'acos(').or.(stri5.eq.'atan(').or.
     $         (stri5.eq.'sinh(').or.(stri5.eq.'cosh(').or.
     $         (stri5.eq.'tanh(').or.(stri5.eq.'coth(').or.
     $         (stri5.eq.'eins(')            ) then
          if (stri5.eq.'sqrt(')  itemp(ieqn)  = isqrt
          if (stri5.eq.'asin(')  itemp(ieqn)  = iasin
          if (stri5.eq.'acos(')  itemp(ieqn)  = iacos
          if (stri5.eq.'atan(')  itemp(ieqn)  = iatan
          if (stri5.eq.'sinh(')  itemp(ieqn)  = isinh
          if (stri5.eq.'cosh(')  itemp(ieqn)  = icosh
          if (stri5.eq.'coth(')  itemp(ieqn)  = icoth
          if (stri5.eq.'tanh(')  itemp(ieqn)  = itanh
          if (stri5.eq.'eins(')  itemp(ieqn)  = jeins
          istr = istr + 3
c# end math operations
c# variables
c          end with blank or math symbol from character string opera
       else
          do 750 i = istr, len(string)
             str1 = string(i:i)
             if (index(opera,str1).ne.0) go to 760
 750      continue
 760      continue
c   find which variable it is:
          ivarln = i - 1
          found = .false.
          if (ivarln.le.istr) ivarln = istr
          do 800 i = 1, nv
             if ( string(istr:ivarln).eq.vnames(i)) then
                found = .true.
                itemp(ieqn)  = i
                istr = ivarln
                go to 810
             end if
 800      continue
 810      continue
c     if it isn't already in vnames, put it in first available slot
          if (.not.found) then
             do 830 i = 1, nv
                if ( vnames(i).eq.' ' ) then
                   vnames(i) = string(istr:ivarln)
                   itemp(ieqn)  = i
                   found = .true.
                   istr  = ivarln
                   go to 840
                end if
 830         continue
 840         continue
          end if
c     if found is still false, then vnames is full.
c     this is then a good time to hurl a warning message.
          if (.not.found) then
             call echo(encerr)
             call echo( ' too many variables declared.')
             write (errmsg,'(14x,2a,i4,a)') 'the current',
     $            ' limit is ', nv,' unique variables.'
             call echo( errmsg )
             ierr = 2
             return
          end if
c
c  # end parsing and encoding, go back to line 300 for more
       end if
       go to 300
c-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
c  some more error checking of string
c-- check that the number of parentheses is correct
 4000  continue
cc       print*, '4000: encod ', str(1:40)
cc       print*, ' code: '
cc       do i = 1, maxlen, 3
cc          if (itemp(i).ne.0) print*,itemp(i),itemp(i+1),itemp(i+2)
cc       end do
       if (iparen.ne.0) then
          call echo(synerr)
          call echo( '     '//strout(1:ilen))
          call echo( '  parentheses are not matched ')
          ierr = 7
          return
       end if
c--
c-- check that one component math functions are followed by "("
c-- and that parentheses are not left hanging
       iparen = 0
       do 4400 i = 1, ieqn + 2
          if (i.eq.1) then
             ibfr = ileft
          else
             ibfr = itemp(i-1)
          end if
          iaft = itemp(i+1)
          it   = itemp(i)
          if (it.eq.ileft)  iparen = iparen + 1
          if (it.eq.iright) iparen = iparen - 1
c-- check that iparen is never negative (that is left parens
c                                        before right parens)
          if (iparen.lt.0) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             call echo( '  parentheses not used properly')
             ierr = 7
             return
          end if
          if ( ( (it.eq.ileft).and.
     $         ( (iaft.eq.iright).or.(ibfr.gt.0) ) )
     $         .or.( (it.eq.iright).and.
     $         ( (iaft.eq.ileft) .or.(iaft.gt.0) ) ) ) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             call echo( '  parentheses not used properly')
             ierr = 7
             return
          end if
c-- check that "(," and ",)" are not in string
          if ( (it.eq.icomma).and.((iaft.eq.iright).or.
     $         (ibfr.eq.ileft).or.(ibfr.eq.icomma))) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             call echo('   ",,", "(," and ",)" are not allowed')
             ierr = 3
             return
          end if
c-- check that one-component math operators are followed by "("
          if ( (it.le.-10).and.(it.ge.-49)) then
             if (iaft.ne.ileft) then
                call echo(synerr)
                call echo( '     '//strout(1:ilen))
                call echo('  unary math functions must be '//
     $               'followed by "("')
                ierr = 5
                return
             end if
             if ( (i.gt.1).and.(ibfr.ge.-49).and.(ibfr.le.-1)
     $            .and.(ibfr.ne.ileft).and.(ibfr.ne.icomma))  then
                call echo(synerr)
                call echo( '     '//strout(1:ilen))
                call echo('  a number is preceded by a '//
     $               'unary math function without using "(" ')
                ierr = 5
                return
             end if
          end if
c--  look for a real number preceded or followed by a
c                    either a real number or a variable
          if ( ((it.ge.300).and.(it.le.600)).and.
     $         ((iaft.ge.1).or.(ibfr.ge.1))) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             if (iaft.ge.0) then
                call echo('  a real number is followed by '//
     $               'a real number, variable or fixed value')
             else
                call echo('  a real number is preceded by '//
     $               'a real number, variable or fixed value')
             end if
             ierr = 3
          end if
          if ((it.ge.1).and.(iaft.ge.-49).and.(iaft.le.-10)) then
             call echo(synerr)
             call echo( '     '//strout(1:ilen))
             call echo('   a number is followed by a'//
     $            ' unary math function')
             ierr = 5
             return
          end if
c
c  the special functions debye(,) and eins(,), etc, require
c  a certain number of commas (usually 1)
          if (it.le.-100)  then
             jstack = 1
             jcomma = 0
cc             print*, ' comma hunt ', i, ieqn, icomma
             do  4200 j = i+2, ieqn
                jt   = itemp(j)
                if (jt.eq.ileft ) jstack = jstack + 1
                if (jt.eq.iright) jstack = jstack - 1
                if ((jstack.eq.1).and.(jt.eq.icomma))
     $               jcomma = jcomma + 1
                strok = .true.
cc                print*, 'STACK:   ' , j, jt, jstack
                if (jstack.eq.0) then
                   strok = .false.
                   if ((it.eq.jdebye).and.(jcomma.ne.1)) then
                      errmsg = ' the function "debye" '//
     $                     'requires 2 arguments and 1 comma'
                      strtmp = ' the proper syntax is: '//
     $                     ' "debye(temp, theta)" '
                   elseif ((it.eq.jeins).and.(jcomma.ne.1)) then
                      errmsg = ' the function "eins" '//
     $                     'requires 2 arguments and 1 comma'
                      strtmp = ' the proper syntax is: '//
     $                     ' "eins(temp, theta)" '
                   elseif ((it.eq.jeins2).and.(jcomma.ne.2)) then
                      errmsg = ' the function "eins2" '//
     $                     'requires 3 arguments and 2 comma'
                      strtmp = ' the proper syntax is: '//
     $                     ' "eins2(temp, theta, mass)" '
                   elseif ((it.eq.jmin).and.(jcomma.ne.1)) then
                      errmsg = ' the function "min" '//
     $                     'requires 2 arguments and 1 comma'
                      strtmp = ' the proper syntax is: '//
     $                     ' "min(x,y)" '
                   elseif ((it.eq.jmax).and.(jcomma.ne.1)) then
                      errmsg = ' the function "max" '//
     $                     'requires 2 arguments and 1 comma'
                      strtmp = ' the proper syntax is: "max(x,y)" '
                   else
                      strok = .true.
                   endif
                   if (.not.strok) then
                      call echo(synerr)
                      call echo( '     '//strout(1:ilen))
                      ii = max(1, istrln(errmsg))
                      call echo('  '// errmsg(1:ii))
                      ii = max(1, istrln(strtmp))
                      call echo('  '// strtmp(1:ii))
                      ierr = 5
                      return
                   end if
                endif
 4200        continue
          end if
 4400  continue
c----------------------------------------------------------------------
c  rewrite itemp to reverse polish notation
c  (this allows easier decoding: see h-p calculator manuals on rpn.)
c  then load up icode, and we're all done.
       j = 0
c        ntemp  = min (ni, maxlen)
c        print*, 'ENCOD 1: ntemp = ', ntemp
c        call rpndmp(itemp,ntemp)

       call engrpn(itemp)
       
c        do i = 1, maxlen
c           if (itemp(i).ne.0) then
c              j = j+1
c              print*, i, j, itemp(i)
c           end if
c        end do
       ntemp  = min (ni, maxlen)
cc       call rpndmp(itemp,ntemp)
       if (itemp(ntemp).ne.0) then
          call echo(mtherr//'too many objects!')
          call echo( '     '//strout(1:ilen))
          write (errmsg,'(4x,a,i4,a)') 'there are more than', ntemp,
     $         ' objects in the math expression for the string: '
          ii  = max(1, istrln(errmsg))
          call echo('  '// errmsg(1:ii))
          call echo('   where objects = operations or numbers')
          call echo('   please break up expression, or contact matt')


          ierr = 9
       end if
       
       do 5000 i = 1, ntemp
          icode(i) = itemp(i)
 5000  continue
       return
c
c end subroutine encod
       end

       subroutine convl2(npts, x, y, gamma, xout, yout)
c  broaden the two arrays x and y with a lorentzian 
c  arrays are assumed to be on the same even grid
c
c  note: gamma is the lorentzian width in units of grid points!!
       implicit none
       integer npts, i, j
       double precision x(npts), y(npts), xout(npts), yout(npts)
       double precision gamma, sum, factr, zero, one, small
       double precision  tmpx, tmpy, gami2
       parameter  (zero = 0.d0, one = 1.d0, small = 1.d-20)

      gamma = max(small, gamma)
      gami2 = one /(gamma*gamma)
       do 100 i = 1, npts
          sum  = zero
          tmpx = zero
          tmpy = zero
          do 50 j = 1, npts
             factr = 1 / ( 1 + gami2 * (j-i) * (j-i) )
             sum   = sum  + factr
             tmpx  = tmpx + x(j) *  factr
             tmpy  = tmpy + y(j) *  factr
 50       continue 
          yout(i) = tmpy / max (small, sum)
          xout(i) = tmpx / max (small, sum)
 100   continue 
       return
       end

       double precision function cordby(temp, thetad, ierr)
c
c  copyright 1993  university of washington      matt newville
c
c  returns xafs sigma^2 from correlated debye model a la jj rehr
c  important note:   the path information is passed in the
c      common block /fefdat/, and the value ixpath  specifies
c      which path sigma^2 is to be calculated for.
c  temp    temperature       [k]      (in)
c  theta   debye temperature [k]      (in)
c  cordby  sigma^2           [aa^2]   (out)
c-
       include 'const.h'
       include 'fefdat.h'
       double precision temp, thetad, tk, theta, sig2
       double precision rat(3,0:maxleg)
       integer  ierr, iz(0:maxleg), i, j, ipth
c
       ierr   = 0
       cordby = zero
       ipth   = min( mfffil, max(1, ixpath))
c
       tk     = temp
       theta  = thetad
       if (tk   .le.one) tk    = one
       if (theta.le.one) theta = one
       do 50 i = 0, nlgpth(ipth)
          iz(i)   = izpth(i,ipth)
          do 40 j = 1,3
             rat(j,i)  = ratpth(j,i,ipth)
 40       continue
 50    continue
       call sigms (tk, theta, rwgpth(ipth), nlgpth(ipth),rat,iz,sig2)
       cordby = sig2
       return
c  end function cordby
       end
       double precision function einsdw(temp, theta, ierr)
c
c  copyright 1994  university of washington      matt newville
c
c  return sigma^2 factor from einstein model.
c  important note:   the path information is passed in the
c      common block /fefdat/, and the value ixpath  specifies
c      which path sigma^2 is to be calculated for.
c   temp    temperature           [k]      (in)
c   thetae  einstein temperature  [k]      (in)
c   einsdw  sigma^2               [aa^2]   (out)
c-
       double precision   small
       parameter (small = 1.d-4)
       include 'const.h'
       include 'fefdat.h'
       double precision temp, theta, rmass, rtemp, atwts, einval
       integer  ierr, ipth, i, natoms
       external atwts, einval
       ierr   = 0
       einsdw = zero
       ipth   = min( mfffil, max(1, ixpath))
c  construct reduced mass (in amu) using function atwts
       natoms = nlgpth(ipth)
       rtemp  = zero
       rmass  = zero
       do 50 i = 1, natoms
          rmass  = max(one, atwts( izpth(i, ipth)) )
          rtemp  = rtemp +  one / rmass
  50   continue
       rmass  = max(small, rtemp)
       rmass  = one / rmass
c  call einval to get sigma squared
       einsdw = einval(temp, theta, rmass)
       return
c  end function einsdw
       end
       double precision function einval(t,theta,rmass)
c
c  compute sigma^2 from the eisntein model
c    t       temperature          [K]    (in)
c    theta   einstein temperature [K]    (in)
c    rmass   reduced mass         [amu]  (in)
c    einval  sigma squared        [aa^2] (out)
       double precision  small, big, two, factor
       double precision  t, theta, rmass, x, t1, th1, rm1
       parameter (two    = 2.d0, small = 1.d-3, big = 1.d8   )
       parameter (factor = 24.25423371d0)
cc       parameter (hbarc  = 1973.270533d0, boltz = 8.617385d-5)
cc       parameter (amu2ev = 9.3149432d8          )
cc       parameter (factor = hbarc*hbarc/(two * boltz * amu2ev))
       th1  = max(small, theta)
       rm1  = max(small, rmass)
       t1   = max(small, t    )
       x    = max(small, min(big, th1 / (two * t1)))
       einval = factor / ( rm1 * th1 * tanh(x))
       return
c  end function einval
       end

       subroutine feff_table_array(zstrx, sarrx, mpts, x, y)

       implicit none
       include 'consts.h'
cc       include 'keywrd.h'
       integer          mff_arrs, mpts
       double precision x(maxpts), y(maxpts), small
       parameter       (small=1.d-6)
       parameter       (mff_arrs = 5)
       double precision fdat(mffpts,mff_arrs)
       double precision yk(mffpts), xk(mffpts), qp
       integer          iz, istrln, nwords, is, i, ipos, nfpts
       character*(*)    zstrx, sarrx
       character*(16)   words(3), sym*2, edge*2, sarr*16
       external         istrln
       

       sarr = sarrx
       call lower(sarr)
       call lower(zstrx)
       nwords = 2
       call bwords(zstrx, nwords, words)
       sym  = words(1)
       edge = words(2)
cc       print*, ' feff table: ',  sym, ' ', edge, ' ', sarr

c fdat: =  amp,pha,caps,rep,xlam
       call read_fefftab(sym,edge,mffpts,mff_arrs,xk,fdat,nfpts)
       is = 0
       if (sarr .eq. 'rep')    is = 1
       if (sarr .eq. 'lambda') is = 2
       if (sarr .eq. 'amp')    is = 3
       if (sarr .eq. 'phase')  is = 4
       if (sarr .eq. 'caps')   is = 5

c
c now interpolate feff's k/f(k) data onto input x-array:
       if (is .ge. 1) then
          ipos = 0
          do 500 i = 1, maxpts
             call lintrp(xk, fdat(1,is),nfpts,x(i),ipos,y(i))
 500      continue 
       endif
c  k-dependent path parameters
       return
       end

       subroutine read_fefftab(sym,edge,mffpts,marrs,xk,fdat,nout)
c
c read feff data from the Feff Tables for a given
c atomic symbol and edge 
c 
c output array xk, and fdat:  dimensioned (mffpts,5) 
c   1   rep
c   2   lambda
c   3   amp
c   4   phase
c   5   caps
c
       implicit none
       include 'maxpts.h'
       character*(*)   sym, edge
       character*256   file, path, messg, str, s1, s2,pre*2
       character*(32)  words(2), vers*10, pref*8
       integer         iz, iz_atom, istrln, mffpts, npack
       integer         ier, iex, ierr, nwords, in1, in2
       integer         ilen, lun, i, iread_ky,  j, ntmp
       integer         marrs, nout
       double precision  fdat(mffpts,marrs), xk(mffpts)
       double precision  tmparr(maxpts), xvers
       external iz_atom, istrln

       nout = 0

       iz   = iz_atom(sym)
       in1  = istrln(sym)
       in2  = istrln(edge)
       pref = sym(1:in1)//'_'//edge(1:in2)

       call gettxt('&install_dir', path)
       ilen  = istrln(path)
       write(file,'(a,a,i2.2,a)') path(:ilen),'/fefftab/', iz,'.dat'
       ilen  = istrln(file)
       lun   = -1
       call openfl(lun, file, 'old', iex, ier)
       if ((ier.lt.0).or.(iex.lt.0).or.(lun.le.0)) then
          messg = ' *** feff_tables: cannot open file '//file(1:ilen)
          call warn(3, messg)
          if (lun.gt.0) close(lun)
          return
       end if
c
       do 10 i = 1, mffpts
          xk(i)     = 0
          fdat(i,1) = 0
          fdat(i,2) = 0
          fdat(i,3) = 0
          fdat(i,4) = 0
          fdat(i,5) = 0
 10    continue 
       ilen = iread_ky(lun, pre, str)
       vers  = 'null'
       npack = 0
       if ((pre.eq.'#:').and.(str(1:20).eq.'IFEFFIT SAVE File: v')) then
          vers = str(21:25)
          call triml(vers)
          call lower(vers)
          call str2dp(vers,xvers,ier)
          s2   = str(26:)
          call lower(s2)
          nwords = 2
          call bwords(s2,nwords,words)
          if (words(1).eq.'npad') call str2in(words(2),npack,ierr)
       endif
       if ((npack.le.0).or.(npack.ge.16).or.(vers.eq.'null')) goto 1010
c next line must be 'build'
       if (xvers.ge.1.01) then
          ilen = iread_ky(lun, pre, str)
          if ((pre.ne.'#:').or.(str(1:5).ne.'build')) goto 1010
       endif
c skip over everything until arrays
 120   continue 
       ilen = iread_ky(lun, pre, str)
       if (ilen.lt.0)         goto 800
       if ((pre.ne.'#:').or.(str(1:6).ne.'arrays')) goto 120

 200   continue 
       ilen = iread_ky(lun, pre,str)
       if (ilen.lt.0) goto 800
       in1 = index(str,'[')
       in2 = index(str,']')
       call str2in(str(in1+1:in2-1),ntmp, ierr)
       str = str(in2+1:)
       call triml(str)
       if (pre.eq.'#%') then
c read array data
          j  = index(str,'.')
          s1 = str(1:j-1)
          s2 = str(j+1:)
          call triml(s1)
          call triml(s2)
          call rdpadd(lun,npack,tmparr, ntmp)
          if (s2 .eq. 'k') then
             nout = ntmp
             do 310 i = 1, ntmp
                xk(i) = tmparr(i)
 310         continue 
          elseif (s2 .eq. 'rep') then
             do 320 i = 1, ntmp
                fdat(i,1) = tmparr(i)
 320         continue 
          elseif (s2 .eq. 'lambda') then
             do 330 i = 1, ntmp
                fdat(i,2) = tmparr(i)
 330         continue 
          elseif ((s1 .eq. pref) .and. (s2 .eq. 'amp')) then
             do 340 i = 1, ntmp
                fdat(i,3) = tmparr(i)
 340         continue 
          elseif ((s1 .eq. pref) .and. (s2 .eq. 'phase')) then
             do 350 i = 1, ntmp
                fdat(i,4) = tmparr(i)
 350         continue 
          elseif ((s1 .eq. pref) .and. (s2 .eq. 'caps')) then
             do 360 i = 1, ntmp
                fdat(i,5) = tmparr(i)
 360         continue 
          endif

       else
          goto 1010
       endif
       go to 200

 800   continue 
c


       close(lun)
       return
 1010  continue 
       call warn(3,' *** bad data in feff tables')
       end


       integer function iz_atom(sym)
c
c  copyright 1993 university of washington     matt newville and bruce ravel
c---------------------------------------------------------------------------

c     returns z number given atomic symbol: default is 0
       character*2 symbol(103), sym, sy
c
       data (symbol(i),i=1,103) /'h','he','li','be','b','c','n','o',
     $      'f','ne','na','mg','al','si','p','s','cl','ar','k','ca',
     $      'sc','ti','v','cr','mn','fe','co','ni','cu','zn','ga',
     $      'ge','as','se','br','kr','rb','sr','y','zr','nb','mo',
     $      'tc','ru','rh','pd','ag','cd','in','sn','sb','te','i',
     $      'xe','cs','ba','la','ce','pr','nd','pm','sm','eu','gd',
     $      'tb','dy','ho','er','tm','yb','lu','hf','ta','w','re',
     $      'os','ir','pt','au','hg','tl','pb','bi','po','at','rn',
     $      'fr','ra','ac','th','pa','u','np','pu','am','cm','bk',
     $      'cf','es','fm','md','no','lr'/

       sy   = sym
       call lower(sy)
       iz_atom = 0
       do 110 i=1,103
          if (sy.eq.symbol(i)) then
             iz_atom = i
             goto 120
          end if
 110   continue
 120   return
c end integer function is2z
       end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
       integer function  nofxa(x,array,npts)
c
c   return index in array with value closest to scalar x.
c   arguments
c   x      value to find in array  
c   array  double precision array (not necessarily monotonically increasing)
c   npts   number of points in array
c
       implicit none
       integer npts,  i, it
       double precision array(npts), x, xit, xmin
c
c linear search
       xmin = abs(array(1) - x)
       it   = 1
       do 10 i = 2, npts
          xit = abs(array(i) - x)
          if (xit .lt. xmin) then
             xmin = xit
             it   = i
          endif
 10    continue
       nofxa = it
       return
c end function nofxa
       end
       integer function  nofx(x,array,npts)
c
c   return index in array with value closest to scalar x.
c   arguments
c   x      value to find in array  
c   array  double precision array (monotonically increasing)
c   npts   number of points in array
c
       implicit none
       integer npts, imin, imax, inc, it
       double precision array(npts), x, xit, xave
c
c hunt by bisection
       imin = 1
       imax = npts
       inc = ( imax - imin ) / 2
 10    continue
       it  = imin + inc
       xit = array(it)
       if ( x .lt. xit ) then
          imax = it
       else if ( x .gt. xit ) then
          imin = it
       else
          nofx = it
          return
       endif
       inc = ( imax - imin ) / 2
       if ( inc .gt. 0 ) go to 10
c x is between imin and imin+1
       xave = ( array(imin) + array(imin+1) ) / 2
       if ( x .lt. xave ) then
          nofx = imin
       else
          nofx = imin + 1
       endif
       return
c end function nofx
       end
       integer function  nofxsp(x,array,npts)
c
c   return index in array with value closest to scalar x.
c   arguments
c   x      value to find in array  
c   array  single precision array (monotonically increasing)
c   npts   number of points in array
c
       integer npts, imin, imax, inc, it
       real array(npts), x
c
c hunt by bisection
       imin = 1
       imax = npts
       inc = ( imax - imin ) / 2
 10    continue
       it  = imin + inc
       xit = array(it)
       if ( x .lt. xit ) then
          imax = it
       else if ( x .gt. xit ) then
          imin = it
       else
          nofxsp = it
          return
       endif
       inc = ( imax - imin ) / 2
       if ( inc .gt. 0 ) go to 10
c bisection
       xave = ( array(imin) + array(imin+1) ) / 2.
       if ( x .lt. xave ) then
          nofxsp = imin
       else
          nofxsp = imin + 1
      endif
       return
c end function nofxsp
       end
       subroutine hunt(xar, npts, xin, jlo)
c
c   return jlo=lower-bound index of a value xin in array xar(n)
c   such that xar(jlo) <= xin < xar(jlo+1). 
c arguments:
c   xar   monotonically increasing array     [in]
c   npts  length of xar                      [in]
c   xin   value to hunt for                  [in]
c   jlo   initial guess /  output index      [in/out]
c
       implicit none
       integer npts, jlo, jhi, inc, jm
       double precision  xar(npts), xin
       logical  dohunt

c  first, decide if we really need to do a hunt at all
c  or if the initial guess (jlo) was good enough: it often is!
cc       print*, '-> hunt ', npts, xin,jlo, xar(1), xar(2), xar(3)
       dohunt = .true.
       jlo    = min(npts-1,max(1,jlo))
       if ((xin.gt.xar(jlo)) .and. (xin.lt.xar(jlo+1))) then
          dohunt = .false.
       elseif (xin.le.xar(1)) then
          jlo     = 1
          dohunt = .false.
       elseif (xin.ge.xar(npts)) then
          jlo    = npts - 1
          dohunt = .false.
c
c check next interval -- often the right choice if the current
cc interval was not.
       elseif (jlo.le.npts-2) then
          if ((xin.gt.xar(jlo+1)) .and. (xin.le.xar(jlo+2))) then
             jlo    = jlo + 1
             dohunt = .false.
          end if
c      
       end if
c hunt the old-fashioned way:
       if (dohunt) then
cc          print*, 'hunt: real hunt ', jlo, xin, xar(jlo),xar(jlo+1)
cc     $         ,xar(jlo+2),xar(jlo+3)
          if (jlo.le.0.or.jlo.gt.npts) then
c the input jlo is not useful -- do bisection
             jlo = 0
             jhi = npts+1
             go to 30
          endif
          inc = 1
c  look ever further away to bracket value
c    hunting up from current guess
          if (xin.ge.xar(jlo)) then
 10          continue 
             jhi=jlo+inc
             if (jhi.gt.npts) then
                jhi=npts+1
             elseif (xin.ge.xar(jhi)) then
                jlo=jhi
                inc=inc+inc
                go to 10
             endif
          else
c    hunting down from current guess
             jhi=jlo
 20          continue 
             jlo=jhi-inc
             if (jlo.lt.1) then
                jlo=0
             elseif (xin.lt.xar(jlo)) then
                jhi=jlo
                inc=inc+inc
                go to 20
             endif
          endif
c   now use bisection to reduce
c   the bracket interval to 1
 30       continue
          if (jhi.ne.(jlo+1)) then
             jm = (jhi + jlo) / 2
             if (xin.gt.xar(jm)) then
                jlo=jm
             else
                jhi=jm
             endif
             go to 30
          end if
       end if
       jlo    = min(npts-1,max(1,jlo))
       return
c end subroutine hunt
       end
       subroutine xterp(xnew, nxnew, y, ny, x, nx, iterp, ierr)
c
c  interpolate yold(xold) to ynew(xnew)  using interpolation
c  scheme defined by iterp
c  arguments
c     xnew   xnew array on input         [in/out]
c            ynew array on output 
c     y      yold array                  [in]
c     x      xold array                  [in]
c     iterp  interpolation method
c
c  copyright (c) 1998  matt newville
       implicit none
       include 'maxpts.h'
       integer   nx, ny, nxnew, i, ierr, ip, iterp
       double precision x(*), y(*), xnew(*)
       double precision tmp(maxpts), coefs(maxpts)
       ierr = 0
       ip   = 1
c
ccc       print*, ' XTERP: ', iterp
       ny   = min(nx,ny)
       if (iterp .eq. 0) then 
          do 20 i = 1, nxnew
             call lintrp(x, y, ny, xnew(i), ip, tmp(i))
 20       continue 
       elseif (iterp .eq. 1) then
          do 30 i = 1, nxnew
             call qintrp(x, y, ny, xnew(i), ip, tmp(i))
 30       continue 
       elseif (iterp .eq. 2) then
          call splcoefs(x, y, ny, coefs, tmp)
          do 80 i = 1, nxnew
             call splint(x, y, coefs, ny, xnew(i), ip, tmp(i))
 80       continue 
       end if
c
       do 100 i = 1, nxnew
          xnew(i) = tmp(i)
 100   continue 
       return
c end subroutine xterp
       end


       subroutine splcoefs(x, y, npts, c, t)
c
c calculate simple (natural) cubic spline coefficients
c given a pair of arrays x, y
c
c c:  output array
c t:  temporary work array
       implicit none
       integer    npts, ip, i
       double precision  x(*), y(*), c(*), t(*)
       double precision  tiny, zero, xin, yout, one
       parameter (zero = 0.d0, one = 1.d0)
       double precision  s, p, dxp, dxm, dx2
       
cc       print*, '>> splcoefs '
       c(1)    = zero
       t(1)    = zero
       c(npts) = zero
       do 20 i = 2, npts - 1
          dx2  = one / ( x(i+1) - x(i-1) )
          dxp  = one / ( x(i+1) - x(i)   )
          dxm  = one / ( x(i)   - x(i-1) )
          s    = dx2 * ( x(i)   - x(i-1) )
          p    = one / (2 + s * c(i-1))
          c(i) = (s - one) * p
          t(i) = p * 
     $     (6*dx2*((y(i+1)-y(i))*dxp - (y(i)-y(i-1))*dxm) - s*t(i-1))
 20    continue 
       do 30 i = npts-1,1, -1
          c(i) = c(i)*c(i+1) + t(i)
 30    continue 
       return
       end

       subroutine splint(x, y, c, npts, xin, ip, yout)
c
c simple natural cubic spline interpolation using
c array of coefficients for splcoefs
c
       implicit none
       integer    npts, ip
       double precision x(*), y(*), c(*)
       double precision xin, yout, sixth, dx, dxi, a,b
       parameter (sixth = 1.d0 / 6.d0)

c  make sure ip is in range
c  find ip such that   x(ip) <= xin <= x(ip+1)
       call hunt(x, npts, xin, ip)
       dx  =  x(ip+1) - x(ip)
       dxi = 1.d0 / dx
       a   = (x(ip+1) - xin  ) * dxi
       b   = (xin     - x(ip)) * dxi
       yout= a*y(ip) + b*y(ip+1)  +  dx*dx* sixth * 
     $      (a*(a*a-1)*c(ip) + b*(b*b-1)*c(ip+1)) 
       
       return
       end
       subroutine lintrp(x, y, npts, xin, ip, yout)
c
c    linear interpolation for use in loops where xin increases 
c    steadily through the monotonically increasing array x. 
c  arguments:
c     x      array of ordinate values                   [in]
c     y      array of abscissa values                   [in]
c     npts   length of arrays x and y                   [in]
c     xin    value of x at which to interpolate         [in]
c     ip     index such that x(ip) <= xin <= x(ip+1)    [in/out]
c     y      interpolated abscissa at xin               [out]
c  note: this routine is called extremely often 
c        -- anything to improve efficiency should be done
       implicit none
       integer    npts, ip
       double precision   x(*), y(*), tiny, xin, yout
       parameter  (tiny = 1.d-9)
c  find ip such that   x(ip) <= xin < x(ip+1)
       call hunt(x, npts, xin, ip)
       yout = y(ip) 
       if ((x(ip+1)-x(ip)) .gt. tiny)  yout = yout +
     $     (y(ip+1)-y(ip)) * (xin-x(ip)) / (x(ip+1)-x(ip))
       return
c  end subroutine lintrp
       end
       subroutine qintrp(x, y, npts, xin, ip, yout)
c
c     this does a crude quadratic interpolation for repeated loops 
c     where xin is increasing steadily through the values in x. 
c   inputs:
c     x      array of ordinate values
c     y      array of abscissa values
c     npts   length of arrays x and y
c     xin    value of x at which to interpolate 
c     ip     guess of index in x array to use 
c  outputs: 
c     ip     index in x array used in interpolation
c     yout    interpolated abscissa at xin
c----------------------------------------------------------------
       implicit none
       integer    npts, ip, i1, i2, i3a, i3b, imin, imax
       double precision  x(npts), y(npts), tiny, xin, yout
       double precision dxi3a, dxi3b, dx12, dx13b, dx23a, dx23b
       double precision youta, youtb, dxi1, dxi2, dx13a
       parameter  (tiny = 1.d-9)

c  find ip such that   x(ip) <= xin <= x(ip+1)
c   most likely candidate is the current value of ip, or ip+1
c   otherwise use routine hunt to find ip

c  find ip such that   x(ip) <= xin < x(ip+1)
       call hunt(x, npts, xin, ip)
       yout  = y(ip)
c
       if ((x(ip+1)-x(ip)).gt.tiny) then
c find two closest x values and the two further neighbors
          i1 = ip
          i2 = ip + 1
          if (xin.lt.x(ip))    i2 = ip - 1
          i3a = max(i1,i2) + 1
          i3b = min(i1,i2) - 1
          imin = min(i1,i2,i3a,i3b)
          imax = max(i1,i2,i3a,i3b)
          if ((imin.gt.3).and.(imax.lt.npts-2)) then
c construct differences
             dxi1  =  xin   - x(i1)
             dxi2  =  xin   - x(i2)
             dxi3a =  xin   - x(i3a)
             dxi3b =  xin   - x(i3b)
             dx12  =  x(i1) - x(i2)
             dx13a =  x(i1) - x(i3a)
             dx13b =  x(i1) - x(i3b)
             dx23a =  x(i2) - x(i3a)
             dx23b =  x(i2) - x(i3b)
             youta = dxi2 * dxi3a * y(i1)  / ( dx12  * dx13a )
     $             - dxi1 * dxi3a * y(i2)  / ( dx12  * dx23a )
     $             + dxi1 * dxi2  * y(i3a) / ( dx13a * dx23a )
             youtb = dxi2 * dxi3b * y(i1)  / ( dx12  * dx13b )
     $             - dxi1 * dxi3b * y(i2)  / ( dx12  * dx23b )
     $             + dxi1 * dxi2  * y(i3b) / ( dx13b * dx23b )
             yout  = (youta * dxi3b - youtb * dxi3a)/(x(i3a) - x(i3b))
          else
             call lintrp(x, y, npts, xin, ip, yout)
          end if
       end if
       return
c  end subroutine qintrp
       end
       integer function iff_get_interp(s)
       character*(*) s, t*16
       integer  i, istrln
       external istrln
       t = s
       call triml(t)
       i = istrln(t)
       j = 2
       if (t(1:4) .eq. 'line')   j = 1
       if (t(1:4) .eq. 'quad')   j = 2
       if (t(1:5) .eq. 'cubic')  j = 3
       if (t(1:6) .eq. 'spline') j = 3
       iff_get_interp = j
       end

      double precision function determ(array,nord,nrows)
c
c  calculate determinate of a square matrix
c
c  arguments  (all strictly input): 
c     array   matrix to be analyzed
c     nord    order of matrix
c     nrows   first dimension of matrix in calling routine
c 
c  copyright (c) 1998  matt newville
c
c  base on bevington "data reduction and error analysis
c  for the physical sciences" pg 294
c
       implicit double precision (a-h,o-z) 
       integer nord, nrows,  i, j, k
       double precision array(nrows,nrows)
       logical      iszero
       determ = 1
       do 150 k=1,nord
c
          if (array(k,k).eq.0) then
             iszero = .true.
             do 120 j=k,nord
                if (array(k,j).ne.0) then 
                   iszero =.false.
                   do 100 i=k,nord
                      saved = array(i,j)
                      array(i,j) = array(i,k)
                      array(i,k) = saved
 100               continue 
                   determ = -determ
                end if
 120         continue
             if (iszero) then 
                determ = 0
                return
             end if
c
          end if
          determ = determ*array(k,k)
          if (k.lt.nord) then
             k1 = k+1
             do 140 i=k1,nord
                do 130 j=k1,nord
                   array(i,j) = array(i,j)-
     $                  array(i,k)*array(k,j)/array(k,k)
 130            continue 
 140         continue 
          end if
 150   continue
c end double precision function determ 
       end
       double precision function bessi0(x)
c
c zero-ordered modified Bessel function I_0(x) for real x
c from abramowitz and stegun p 378 
       double precision x, v, y, c
       double precision a1,a2,a3,a4,a5,a6
       double precision b1,b2,b3,b4,b5,b6,b7,b8,b9
       parameter(a1 = 3.5156229d0  , a2 = 3.0899424d0  )
       parameter(a3 = 1.2067492d0  , a4 = 0.2659732d0  )
       parameter(a5 = 0.360768d-1  , a6 = 0.45813d-2   )
       parameter(b1 = 0.39894228d0 , b2 = 0.1328592d-1 )
       parameter(b3 = 0.225319d-2  , b4 =-0.157565d-2  )
       parameter(b5 = 0.916281d-2  , b6 =-0.2057706d-1 )
       parameter(b7 = 0.2635537d-1 , b8 =-0.1647633d-1 )
       parameter(b9 = 0.392377d-2  ,  c = 3.75d0)
c
       v = abs(x)
       if(v.lt.c) then
          y=(x/c)**2
          bessi0= 1 + y*(a1+y*(a2+y*(a3+y*(a4+y*(a5+y*a6)))))
       else
          y=c/v
          bessi0=(exp(v)/sqrt(v)) *
     $    (b1+y*(b2+y*(b3+y*(b4+y*(b5+y*(b6+y*(b7+y*(b8+y*b9))))))))
       endif
      return
      end
       double precision  function sumsqr(array, narray)
c  returns sum of squares of an array with dimension narray
       double precision  array(*),  big, zero
       parameter( big = 1.d17, zero = 0d0)
       sumsqr  = zero
       do 50 i = 1, narray
          if (abs(array(i)).lt.big) then
             sumsqr = sumsqr + array(i)*array(i)
          else
             sumsqr = sumsqr + big*big
          end if
 50    continue
       return
c  end real function sumsqr
       end
      subroutine pijump (ph, old)
c
c     removes jumps of 2*pi in phases
c     ph = current value of phase (may be modified on output, but
c          only by multiples of 2*pi)
c     old = previous value of phase
       integer isave, jump, i
       double precision xph(3), pi, twopi, old, xphmin, ph
       parameter (pi = 3.14159 26535 89793 23846 26433d0)
       parameter (twopi = 2 * pi)

       isave  = 1
       xph(1) = ph - old
       jump   = int( (abs(xph(1))+ pi) / twopi)
       xph(2) = xph(1) - jump*twopi
       xph(3) = xph(1) + jump*twopi
       
       xphmin = min (abs(xph(1)), abs(xph(2)), abs(xph(3)))
       do 10  i = 1, 3
          if (abs (xphmin - abs(xph(i))) .le. 1.d-2)  isave = i
 10    continue

       ph = old + xph(isave)
       
       return
c end subroutine pijump
       end
       
       subroutine polyft(xfit1,xfit2,xdata,ydata,ndata,nterms,aout)
c
c  get coefficients for polynomial fit :
c      ydata = aout(1) + aout(2)*xdata  + aout(3) *xdata^2 + ...
c  the fit is done between xdata = [xfit1, xfit2]
c
c  arguments:
c   xfit1   lower bound of fitting range       (single precision) (in)
c   xfit2   upper bound of fitting range       (single precision) (in)
c   xdata   array of abscissa values for data  (single precision) (in)
c   ydata   array of ordinate values for data  (single precision) (in)
c   ndata   length of data arrays                                 (in)
c   nterms  number of terms in polynomial                         (in)
c   aout    coefficients of fitted polynomial  (single precision) (out)
c
c  requires functions nofx and determ.
c  note that double and single precision are mixed here. 
c  most internal, working arrays use dp (as does routine determ)
c  
c
c  copyright (c) 1998  matt newville
c
c  see bevington pg 104 for details
c
       implicit none
       integer max, max2m1, ndata, nterms, i, j, l, k, n, ntemp
       integer nfit1, nfit2, nmax, nofx
       double precision xdata(ndata), ydata(ndata), aout(nterms)
       double precision zero, one, xi, yi, xterm, yterm, xfit1, xfit2
       parameter (max= 5, max2m1 = 2*max-1, zero = 0.d0,one=1.d0)
       double precision  sumx(max2m1), sumy(max)
       double precision  array(max,max), ain(max), delta, determ
       external          determ, nofx
c
c     initialize internal arrays
       nmax   = 2 * nterms - 1
       do 100 i=1, nmax
          sumx(i) = zero
 100   continue
       do 120 i = 1, nterms
          ain(i) = zero
          sumy(i) = zero
          do 110 j = 1,  nterms
             array(i,j) = zero       
 110      continue
 120   continue
c     
c     find points closest to endpoints of fitting range
       nfit1 = nofx(xfit1,xdata,ndata)
       nfit2 = nofx(xfit2,xdata,ndata)
       if (nfit1.gt.nfit2) then
          ntemp = nfit1
          nfit1 = nfit2
          nfit2 = ntemp
       end if
       if(nfit1.eq.nfit2) go to 300
c     
c     collect sums of data, sum of squares of data, etc.
       do 200 i = nfit1, nfit2 
          xi = xdata(i)
          yi = ydata(i)
          xterm = one
          do 180 n=1, nmax
             sumx(n) = sumx(n) + xterm
             xterm   = xterm * xi
 180      continue
          yterm = yi
          do 190 n=1,nterms
             sumy(n) = sumy(n) + yterm
             yterm   = yterm * xi
 190      continue 
 200   continue
c     
c     construct matrices and evaluate coefficients
       do 220 j=1,nterms
          do 210 k=1,nterms
             array(j,k) = sumx(j + k - 1)
 210      continue 
 220   continue 
c
c     take determinant, get coefficients  
       delta = determ(array,nterms,max)
       if (delta.ne.zero) then
          do 260 l=1,nterms
             do 250 j=1,nterms
                do 240 k=1,nterms
                   array(j,k) = sumx(j+k-1)
 240            continue
                array(j,l) = sumy(j)
 250         continue
             ain(l) = determ(array,nterms,max)/delta
 260      continue
       end if
c
c     convert coefficients to single precision, leave
 300   continue
       do 400 i = 1, nterms
          aout(i) = ain(i)
 400   continue
       return
c end  subroutine polyft
       end

       subroutine gaussj(a, n, ma, ierr)
c
c gauss-jordan elimination to invert a matrix.
c arguments:
c   a        matrix to invert / solution on output     [in/out]
c   n        number of elements in a to use            [in]
c               (i.e. that aren't zero) 
c   ma       dimension of a                            [in]
c   ierr     0 on success / 1  on error 
c notes:
c    if matrix cannot be inverted, a  contains garbage
c
c copyright (c) 1998 matt newville
c
       implicit none
       include 'consts.h'
       integer  n, ma, i, j,k,l,m, irow, icol, ierr
       integer  ipiv(mvarys), indrow(mvarys), indcol(mvarys)
       double precision a(ma,ma),  abig, tmp, piv
c
       ierr  = 1
       irow  = 0
       icol  = 0
c initialize pivot array
       do 30 i = 1, n
          ipiv(i) = 0
 30    continue
c
c  main loop over the columns to be reduced
       do 300 i = 1, n
          abig = zero
c linear search for a pivot element
          do 120 j = 1, n
             if (ipiv(j).ne.1) then
                do 100 k = 1, n
                   if (ipiv(k).eq.0) then
                      if ( abs(a(j,k)) .ge. abig) then
                         abig = abs(a(j,k))
                         irow = j
                         icol = k
                      endif
                   endif
 100            continue
             endif
 120      continue
          ipiv(icol) = ipiv(icol) + 1
c a pivot has been found
          if (irow.ne.icol) then
             do 160 l = 1, n
                tmp        = a(irow, l)
                a(irow, l) = a(icol, l)
                a(icol, l) = tmp
 160         continue
          endif
c divide the pivot row by the pivot element
          indrow(i) = irow
          indcol(i) = icol
          if (a(icol, icol).eq.zero) return
          piv          = one / a(icol, icol)
          a(icol,icol) = one
          do 200 l = 1, n
             a(icol, l) = a(icol, l) * piv
 200      continue
c reduce non-pviot rows
          do 250 m = 1, n
             if (m.ne.icol) then
                tmp        = a(m, icol)
                a(m,icol) = zero
                do 220 l = 1, n
                   a(m,l) = a(m,l) - a(icol,l) * tmp
 220            continue
             endif
 250      continue
 300   continue
c
c   unravel the solution: interchange column pairs
c   in the reverse order of the permutation 
       ierr = 0
       do 400 i = n, 1, -1
          if (indrow(i) .ne. indcol(i)) then
             do 350 j = 1, n
                tmp            = a(j,indrow(i))
                a(j,indrow(i)) = a(j,indcol(i))
                a(j,indcol(i)) = tmp
 350         continue
          endif
 400   continue
c
       return
c  end subroutine gaussj
       end
       double precision function rfact(xdata, theory, ndata)
c
c      compute an xafs reliability factor as a measure of the
c      goodness of fit between arrays for data and theory.
c input:
c    xdata   (real,imag) pairs for data   over fit range
c    theory  (real,imag) pairs for theory over fit range
c    ndata   number of data points to use
c output:
c
c            sum{ [re(xdata) - re(theory)]^2 + [im(xdata) - im(theory)]^2 }
c    rfact =  ------------------------------------------------------------
c            sum{ [re(xdata)]^2 + [im(xdata)]^2 }
c
c      copyright 1999 matt newville
c
       double precision  xdata(*), theory(*), ampl, small
       integer  ndata, i
       parameter(small = 1.d-08)
c initialize
       ampl   = 0
       rfact  = 0
c  construct sums of squares
       do 100 i = 1, ndata
          ampl  = ampl  +  xdata(i)**2 
          rfact = rfact + (xdata(i)  - theory(i))**2
 100   continue
       rfact =  rfact  / max(small, ampl)
       return
c end function rfact
       end


       subroutine kev2ev(e, ne)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////

c
c  test and (if needed) convert an energy array in KeV to eV 
       implicit none
       integer ne, i
       double precision e(ne), de
       
       if ((e(1).le.50).and.(e(ne).le.50)) then
          de = e(2) - e(1)
          do 300 i = 2, ne
             de = min(de, (e(i) - e(i-1)))
 300      continue 
          if (de .le. 0.01) then 
             do 310 i = 1, ne
                e(i) = e(i) * 1000
 310         continue 
          endif
       endif
       return
       end
c
       subroutine grid_interp(x, y, nx, tmin, dt, nout, yout)
c
c  convert x,y data on a non-uniform grid to be
c  on a uniform (defined by tmin, nt, and dt)
c 
c  at each t=tmin + (i-1)*dt (i: 1 to nout)
c    if 1 or more x value lies in the range (t-dt/2,t+dt/2)
c       all the available y points are averaged (constant weight)
c    if 0 x values lie in the range (t-dt/2,t+dt/2),
c       a quadratic interpolation of the closest upper and lower
c       (x,y) points is used.
c   inputs:
c     x      array of ordinate values
c     y      array of abscissa values
c     nx     length of arrays x and y
c     tmin   first x value of output y array
c     dt     grid spacing for gridded x values
c     nout   number of points to calculate, length of yout
c  outputs: 
c     yout   interpolated abscissa on supplied x grid
c  notes:
c     using lorenztian weighting with gamma=dt would seem
c     reasonable, but is commented-out for now...
c----------------------------------------------------------------
       implicit none
       integer    nx, nout, i, j, ilo, ihi, iqt,  npts, jjj
       double precision  x(*), y(*), yout(*), tmin, dt
       double precision x0, xlo, xhi, sum, weight, gam2
       double precision tiny,  onem, half, zero, one
       parameter  (tiny = 1.d-9, half=0.5d0,zero=0.d0)
       parameter  (one  = 1.d0,  onem = 1.d0 - tiny)

c  find ip such that   x(ip) <= xin <= x(ip+1)
c   most likely candidate is the current value of ip, or ip+1
c   otherwise use routine hunt to find ip
       ihi  = -1
       ilo  = -1
       iqt  =  0
       gam2 =  dt*dt

       do 100 i = 1, nout
          x0  = tmin + dt*(i-1)
          xlo = x0   - dt*half
          xhi = xlo  + dt*onem
c first point, or if for some other reason, 
c we haven't found a low endpoint, find it now
          ilo = ihi + 1
          if (ilo.le.0)  call hunt(x, nx, xlo, ilo)
c find high end of grid range
          call hunt(x, nx, xhi, ihi)
c
c if we have more than 1 point in this region, do a 
c weighted average of the points in the region
          if ((ihi-ilo).ge.1)  then
             sum     = zero
             yout(i) = zero
             weight  = one
             do 50 j = ilo, ihi 
cc                this would provide a lorenztian weighting....
cc                weight = one /(((x(j)-x0)*(x(j)-x0)) + gam2)
                sum    = sum     +      weight
                yout(i)= yout(i) + y(j)*weight
 50          continue 
             yout(i)   = yout(i) / max(tiny,sum)
          else 
c if we have no input data points in this region, 
c use quadratic interpolation of available data
             iqt = ilo
             call qintrp(x,y,nx,x0,iqt,yout(i))
             if (yout(i).ne.yout(i)) then 
                call warn(3,' bad data point in interpolation!')
cc                print*, ' Grid ', i, '  bad qintrp '
cc                print*, ' iqt = ', iqt
cc                do jjj  = -2,2 
cc                   print*, jjj+iqt, x(jjj+iqt), y(jjj+iqt)
cc                end do
             endif
          endif
 100   continue 
       return
c  end subroutine grid_interp
       end
c
       subroutine rebin_interp(xout, nxout, yin, nyin, xin, nxin)
c
c  similar to grid_interp above: converts input x,y data to 
c  provided output x array, using boxcar average:
c 
c  at each x=xout (i: 1 to nxout)
c    if 1 or more xin value lies in the range 
c          [(xout(i)+xout(i-1))/2:(x(i+1)+x(i))/2]
c       all the available y points are averaged (constant weight)
c    if 0 xin values lie in the range 
c          [(xout(i)+xout(i-1))/2:(x(i+1)+x(i))/2]
c       a linear interpolation of the closest upper and lower
c       (x,y) points is used.
c   inputs:
c     xin     array of input ordinate values
c     yin     array of input abscissa values
c     nxin    length of arrays xin and yin
c     xout    array of output ordinates
c     nxout   length of xout
c  outputs: 
c     xout    interpolated abscissa on supplied xout
c  notes:
c    - using lorenztian weighting with gamma=dt would seem
c      reasonable....
c    - weird call structure due to decod (see xterp above) 
c----------------------------------------------------------------
       implicit none
       include 'maxpts.h'
       integer    nxin, nxout, i, j, ilo, ihi, iqt,  npts, nyin
       double precision  xin(*), yin(*), xout(*), yout(maxpts)
       double precision x0, xlo, xhi, sum, weight, gam2
       double precision tiny,  onem, half, zero, one
       parameter  (tiny = 1.d-9, half=0.5d0,zero=0.d0)
       parameter  (one  = 1.d0,  onem = 1.d0 - tiny)

c  find ip such that   x(ip) <= xin <= x(ip+1)
c   most likely candidate is the current value of ip, or ip+1
c   otherwise use routine hunt to find ip
       ihi  = -1
       ilo  = -1
       iqt  =  0
       nxin = min(nxin,nyin)
       do 100 i = 1, nxout
          x0  = xout(i)
          xlo = x0
          xhi = x0
          if (i.gt.1)     xlo = (x0 + xout(i-1))*half
          if (i.lt.nxout) xhi = (x0 + xout(i+1)-tiny)*half

c first point, or if for some other reason, 
c we haven't found a low endpoint, find it now
          ilo = ihi + 1
          if (ilo.le.0)  call hunt(xin, nxin, xlo, ilo)
c find high end of grid range
          call hunt(xin, nxin, xhi, ihi)
c
c if we have more than 1 point in this region, do a 
c weighted average of the points in the region
cc          print*, ' ' , i, x0, xlo, xhi, ilo, ihi, xin(ilo), xin(ihi)
          if ((ihi-ilo).ge.1)  then
             sum     = zero
             yout(i) = zero
             weight  = one
             do 50 j = ilo, ihi 
cc                this would provide a lorenztian weighting....
cc                weight = one /(((x(j)-x0)*(x(j)-x0)) + gam2)
                sum    = sum     +        weight
                yout(i)= yout(i) + yin(j)*weight
 50          continue 
             yout(i)   = yout(i) / max(tiny,sum)
          else 
c if we have no input data points in this region, 
c use quadratic interpolation of available data
             iqt = ilo
             call qintrp(xin,yin,nxin,x0,iqt,yout(i))
          endif
 100   continue 
       do 200 i = 1, nxout
          xout(i) = yout(i)
 200   continue 
       return
c  end subroutine boxcar_interp
       end

       subroutine res_penalty(x0, nx0, x1, nx1, x2, nx2)

       include 'maxpts.h'
       integer    nx0, nx1, nx2
       double precision  x0(*), x1(*), x2(*)
       double precision xlo, xhi

       xlo = x1(1)
       xhi = x0(1)
       
cc       print*, 'bound  xlo, xhi = [ ', xlo, ' : ', xhi, ' ]'
cc       print*, 'bound  x = ', x2(1)

       if ((x2(1).ge.xlo) .and. (x2(1).le.xhi)) then
          x0(1) = 0
       elseif (x2(1).gt.xlo) then
          x0(1) = abs(x2(1) - xhi)
       elseif (x2(1).lt.xlo) then
          x0(1) = abs(x2(1) - xlo)
       endif

cc     print*, 'bound  penalty = ', x0(1)
       return
       end

     

       logical function isamac(str,jmac)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c determine if string can be a current macro name
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       save
       integer  i, jmac
       character*(*) str, s*32
       jmac   = 0
       isamac = .false.
       s = str
       call triml(s)
       call lower(s)
       do 10 i =1, macmax
          if (s.eq.macnam(i)) then
             isamac = .true.
             jmac = i
          end if
 10    continue 
       return
       end

       subroutine str2at(str,iz)
c  given a string str that contains either an atomic number or
c  an atomic symbol, return the atomic number to iz.
c
       character*(*) str 
       integer  iz, ierr, iatsym
       logical  isnum
       external isnum, iatsym
       if (isnum(str))   then
          call str2in(str,iz,ierr)
          if (ierr.ne.0) iz = 0
       else
          iz = iatsym(str)
       end if
       return
c      end subroutine str2at
       end

       subroutine dklog
c
c write log of diffkk.  note that diffkk.log *can* be used as diffkk.inp
       include "dkcom.f"
       integer   istrln, ilog, ier, iex, ilen, i
       character*70    stat*10, logfil, str, atsym*2
       external   istrln, atsym
       data stat   /'unknown'/
c----------------------------------------------------------------------
c  determine log file name (usually trivial)
c  but if not, find the *last* "."
       logfil = 'diffkk.log'
c  open log file
       ilog   = 0
       ier    = 0
       iex    = 0
       call openfl(ilog, logfil, stat, iex, ier)
       if (ier.lt.0) go to 5000
c
c write version number
       write(str,10) versn
 10   format(' --  diffkk version ',a, '--')
       ilen = istrln(str)
       write(ilog,900) str(1:ilen)
       write(ilog,900)   ' program inputs or default values used:' 
       if (ntitle.le.0) then 
          write (ilog, 910)  'title',
     $         'diffkk: no title lines specified'
       else
          do 100 i = 1, ntitle
             ilen = max(1, istrln(title(i)))
             write (ilog, 910)  'title', title(i)(1:ilen)
 100      continue 
       end if
       ilen = max(15, istrln(outfil))
       write (ilog, 920)  'out', outfil(1:ilen), 'output file name'
c
       ilen = max(15, istrln(xmufil))
       write (ilog, 920)  'xmu', xmufil(1:ilen),
     $      'file name for xmu data'
c
       if (isfeff) then
          write (ilog, 981)'isfeff','file is a feff xmu.dat file'
       else 
          write (ilog, 980)'isfeff','file is not a feff xmu.dat file'
       end if
       if (f2tof1) then
          write (ilog, 981)'f2_to_f1', 'transform f2-like data to f1'
       else 
          write (ilog, 980)'f2_to_f1', 'transform f1-like data to f2'
       end if
       write (ilog, 930) 'encol',iencol,'column to read energy from'
       write (ilog, 930) 'mucol',imucol,'column to read mu(E) from'
       write (ilog, 930)  'iz', iatz, 'atomic number of core atom'
       write (ilog, 950)  'e0', e0 , 'edge energy (used as reference)'
c
       write (ilog, 950)  'egrid', egrid,'energy grid for calculation'
       write (ilog, 950)  'ewidth', ewidth,'for broadening CL data'

       write (ilog, 950)  'elow', elow,
     $      'how far below data range to calculate'
       write (ilog, 950)  'ehigh', ehigh,
     $      'how far above data range to calculate'
       if (isfeff) then
          write(ilog,900) 'the following are for padding '//
     $         'data from feff''s xmu.dat below e0'
          write (ilog, 950) 'epad', epad, 'energy grid for pre-padding'
          write (ilog, 930) 'npad', npad,
     $         'number of points for pre-padding'
       end if
c
       write(ilog,905) ' end  % '//
     $      'all remaining lines will be ignored on input'
       write(ilog,905) ' -- diffkk program summary --'
       write(ilog,905) ' '
       write(ilog,905) '   f''''(E) was set to be'
       write(ilog,905) '        f''''(E)  = f''''_CL(E) '//
     $      ' for E > e0+ehigh and  E < e0-elow.'
       write(ilog,906) '   within the range E = [e0-elow, e0+ehigh],',
     $      ' f'''' was set to'
       write(ilog,905) '        f''''(E)  = f''''_CL(E) + a0 '//
     $      '+ a1 *  mu(E'') * ( E'' /  e0)'
       write(ilog,905) '                + a2 * (E'' - e0) '//
     $      '+ a3 * (E'' - e0)**2 '
       ilen = max(1,istrln(xmufil))
       write(ilog,907) '   where mu(E) was read from ',
     $      xmufil(1:ilen),','
       write(ilog,907) '   f''''_CL(E) was found for ',
     $      atsym(iatz), ', and E'' = E + e0_shift.'
       write(ilog,905) ' '
       write(ilog,905) '   the values of e0_shift, a0, a1, a2, '//
     $      'and a3 were determined to be:'
       write(ilog,955) 'e0_shift', xvarys(1)
       write(ilog,955) 'a0', xvarys(2)
       write(ilog,955) 'a1', xvarys(3)
       write(ilog,955) 'a2', xvarys(4)
       write(ilog,955) 'a3', xvarys(5)
       write(ilog,905) '   so as to best match f''''_CL(E)'//
     $  ' between E = [e0-elow, e0+ehigh]'
       write(ilog,905) ' '
       write(ilog,905) ' -- end diffkk log file --'
c
       close(ilog)
       return
 900   format(1x,'# ',a)
 905   format(1x, a)
 906   format(1x, 2a)
 907   format(1x, 3a)
 910   format(1x, a8, ' = ', a)
 920   format(1x, a8, ' = ', a    ,  1x,'% ',a)
 930   format(1x, a8, ' = ', i4   , 12x,'% ',a)
 950   format(1x, a8, ' = ', f11.4,  5x,'% ',a)
 955   format(6x, a10, ' = ', g15.6)
 980   format(1x, a8, ' = false',   11x,'% ',a)
 981   format(1x, a8, ' = true',    12x,'% ',a)
 5000  continue 
       call messag(' weird, fatal error trying to open input file')
       stop
       end

c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2001 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  routines for the c interface to ifeffit data elements
       integer function IFFEXECF(str)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFEXECF
!DEC$ END IF
c
c this provides a cleaner interface for calling from C
       character*(*) str
       integer ifeffit, istrln, ilen
       external ifeffit, istrln
       call sclean(str)
       ilen = istrln(str)
       iffexecf = ifeffit(str)
       return
       end

       integer function IFFGETSTR(inp, out)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFGETSTR
!DEC$ END IF
c
c  purpose: wrapper to gettxt
       character*(*) inp, out, str*256
       integer  ilen, istrln
       external istrln
       iffgetstr = 1
       str    = inp
       call sclean(str)
       ilen   = istrln(str)
       if (str(1:1).eq.'$') then
          str  = str(2:ilen)
          ilen = ilen - 1
       end if
       call gettxt(str, out)
       iffgetstr = max(1, istrln(out))
c  end function iffgetstr
       return
       end

       integer function IFFPUTSTR(inam, istr)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFPUTSTR
!DEC$ END IF

c
c  purpose: put a string
c
c  copyright (c) 1998  matt newville
       character*(*) inam, istr
       character*256  nam, str
       iffputstr = 0
       str   = istr
       nam   = inam
       call sclean(nam)
       call sclean(str)
       call settxt(nam,str)
c  end function iffputsca
       return
       end


       integer function IFFGETSCA(inp, dx)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFGETSCA
!DEC$ END IF
c
c  purpose: wrapper to getsca
c
c  copyright (c) 1998  matt newville
       character*(*) inp, str*256
       double precision dx, getsca
       external getsca
       if (int(getsca('&sync_level',0)).ge.1)  call iff_sync
       iffgetsca = 0
       str    = inp
       call sclean(str)
       dx     = dble( getsca(str,0) )
c  end function iffgetsca
       return
       end
       integer function IFFPUTSCA(inp, dx)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFPUTSCA
!DEC$ END IF
c
c  purpose: wrapper to setsca
c
c  copyright (c) 1998  matt newville
       character*(*) inp, str*256
       double precision dx, xx, getsca
       external getsca
       iffputsca = 0
       str   = inp
       xx    = dx
       call sclean(str)
       call setsca(str,xx)
       if (int(getsca('&sync_level',0)).ge.1)  call iff_sync
c  end function iffputsca
       return
       end
       integer function IFFGETARR(inp, dx)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFGETARR
!DEC$ END IF
c
c  purpose:  look up and return array by name
       implicit none
       character*(*) inp, str*256
       integer       get_array
       double precision dx(*), getsca
       external  get_array, getsca
       if (int(getsca('&sync_level',0)).ge.1)  call iff_sync
       str       = inp
       call sclean(str)
       iffgetarr = get_array(str,' ', 0, dx)
c  end function iffgetarr
       return
       end
       integer function IFFPUTARR(inp, inpts, dx)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFPUTARR
!DEC$ END IF
c
c  purpose: wrapper to put array in ifeffit data
       implicit none
       character*(*) inp, str*256
       integer   k,  j, inpts
       double precision dx(*), getsca
       external getsca
       iffputarr = 0
       str  = inp
       call sclean(str)
       call set_array(str, ' ', dx, inpts, 1)
       if (int(getsca('&sync_level',0)).ge.1)  call iff_sync
c  end function iffputarr
       return
       end
       integer function IFFGETECHO(str)
!DEC$ IF DEFINED (_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: IFFGETECHO
!DEC$ END IF
c
c  purpose: wrapper to echo_pop in ifeffit
       implicit none
       include 'consts.h'
       include 'echo.h'
       save
       character*(*) str, s*512
       integer   i,  istrln
       external  istrln
       iffgetecho = 0
       s   = ' '
       str = ' '
       call sclean(str)
       if (n_echo .ge. 1)  call echo_pop(s)
       str = s
       iffgetecho = max(1, istrln(str))
c  end function iffgetecho
       return
       end

       subroutine iff_plotraise(i)
c  grwin specific: raise to top
       integer i, j
       j = i
       call gwshowfr(j,11)
       call gwshowfr(j,12)
       return
       end

       subroutine iff_random(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 2004 Matthew Newville, The University of Chicago
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: ifeffit test function
c 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       save
       character*(*)  str
       character*128 oname, name1, name2, defkey(3)*64, rdist*16
       integer  ier, i, k, istrln, npts, jdot, ndfkey, iseed
       integer  iff_eval, iff_eval_in, iff_eval_dp
       double precision randmt, gauss_rand, normal_rand
       double precision sigma
       external iff_eval, iff_eval_in, iff_eval_dp
       external randmt, gauss_rand, normal_rand
       external istrln
c
       rdist  = 'uniform'
       oname  = undef
       npts   =   0
       sigma  = one
       call iff_sync
       call bkeys(str, mkeys, keys, values, nkeys)

c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
       ndfkey    = 2
       defkey(1) = 'output'
       defkey(2) = 'npts'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'npts') then
             ier = iff_eval_in(values(i), npts)
          elseif (keys(i).eq.'output') then
             oname = values(i)
             call lower(oname)
          elseif (keys(i).eq.'dist') then
             rdist = values(i)
             call lower(rdist)
          elseif (keys(i).eq.'sigma') then
             ier = iff_eval_dp(values(i), sigma)
          elseif (keys(i).eq.'seed') then
             ier = iff_eval_in(values(i), iseed)
             if (ier.eq.0) then
                if (iseed.eq.0) ier = 4357
                call seed_randmt(iseed)
             endif
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** random: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names
       jdot = index(oname,'.')
       if ((jdot.eq.0).or.(oname.eq.undef)) then
          call warn(2, ' random: no output array named')
          return             
       endif
       name1 = oname(1:jdot-1)
       name2 = oname(jdot+1:)

       call lower(name1)
       call lower(name2)
       call fixnam(name1,1)
       call fixnam(name2,2)
       jdot = istrln(name1)

       npts = min(npts,maxpts)

       call lower(rdist)
       do 200 i = 1, npts
          tmparr(i) = zero
 200   continue 

cc       print*, ' use distribution ', rdist(:12)
       if (rdist(:5).eq.'gauss') then
          do 300 i = 1, npts
             tmparr(i) = sigma*gauss_rand()
 300      continue 
       elseif (rdist(:6).eq.'normal') then
          do 400 i = 1, npts
             tmparr(i) = sigma*normal_rand()
 400      continue 
       else
          do 900 i = 1, npts
             tmparr(i) = sigma*randmt()
 900      continue 
       endif

       call set_array(name2,name1, tmparr,npts,1)

       return
c end  subroutine iff_random
       end

       subroutine preedg(e0find, stfind, nxmu, energy, xmu, e0,
     $      predg1, predg2, enor1, enor2, nnorm,
     $      step, slopre, bpre, cnorm)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c     pre-edge subtraction and normalization of exafs data.
c
c arguments:
c   e0find   flag for finding e0                    [in]
c   stfind   logical flag to finding edge step      [in]
c   nxmu     length of array energy and xmu         [in]
c   energy   array of energy points                 [in]
c   xmu      array of raw absorption points         [in]
c   e0       e0,  energy origin of data             [in/out]
c   predg1   region for picking pre-edge line       [in/out]
c   predg2   region for picking pre-edge line       [in/out]
c   enor1    region for picking normalization       [in/out]
c   enor2    region for picking normalization       [in/out]
c   nnorm    polynomial order of norm.  curve       [in/out]
c   step     edge step for normalization            [in/out]
c             ( found if zero on input )
c   slopre   slope of pre-edge line                 [out]
c   bpre     intercept of pre-edge line             [out]
c   cnorm    coefficients of normalization curve    [out]
c            (dimension 3:  quadratic polynomial)
c   uses subroutine polyft
c
       implicit none
       integer  nxmu,  npstp, nxmin,npoly, ne0, nofx,nnorm
       integer  ier, sort_xy
       logical  e0find, stfind
       parameter (npoly=4, nxmin = 5)
       double precision energy(nxmu), xmu(nxmu), coef(npoly)
       double precision tiny, edfmin, slopre, bpre, xenlo, xenhi
       double precision e0, predg1, predg2, enor1, enor2, step
       double precision e1def, e2def, p1def, p2def, tmp, cnorm(*)
       parameter (tiny = 1.d-9,  edfmin= 100.d0)
       parameter (e1def= 1d2, e2def= 4d2, p1def= -50d0, p2def= -2d2)
       external nofx, sort_xy
c
c   if e0 was not specified, or is out of range,
c   it is found as the point of maximum deriv, with check that
c   it is at least the third positive deriv in a row
       if (nxmu.le.nxmin)  return
       ier  = sort_xy(energy, xmu, nxmu, tiny)

       if ( e0find .or. e0.le.energy(1) .or. e0.ge.energy(nxmu) )
     $      call findee(nxmu, energy, xmu, e0)
c
c  linear fit to pre-edge
       if ((abs(predg1).le.tiny).and.(abs(predg2).le.tiny))  then
          predg1 = p1def
          predg2 = p2def
       end if
       if (predg1.gt.predg2) then
          tmp    = predg1
          predg1 = predg2
          predg2 = tmp
       endif
       xenlo  = e0 + predg1
       xenhi  = e0 + predg2
cc       print*, ' pre-edge: ', predg1, predg2, e0
cc       print*, ' pre-edge: ', xenlo , xenhi, energy(1)
       if (xenlo.lt.energy(1))   xenlo = energy(1)
       if (xenhi.lt.energy(1))   xenhi = (e0 + xenlo) /2
       call polyft(xenlo, xenhi, energy, xmu, nxmu, 2, coef)
       bpre   = coef(1)
       slopre = coef(2)
c
c  normalization : make pre-edge 0.0 and post-edge 1.0
c    if step size wasn't given, get it by extracting to e0 a
c    line that best fits the data on the range (e0+enor1,e0+enor2)
       if (stfind) then
          cnorm(1) = 0
          cnorm(2) = 0
          cnorm(3) = 0
          step     = 0
          if ((abs(enor1).le.tiny).and.(abs(enor2).le.tiny))  then
             enor1 = e1def
             enor2 = e2def
          end if
          xenlo  = e0 + enor1
          xenhi  = e0 + enor2
          if (xenhi.gt.energy(nxmu))   xenhi = energy(nxmu)
          if (xenlo.gt.energy(nxmu))   xenlo = xenhi /2
          npstp =  nnorm
          if ((npstp.ge.3).and.
     $         (abs(xenhi - xenlo).le.edfmin)) npstp = 2
          call polyft(xenlo, xenhi, energy, xmu, nxmu, npstp, cnorm)
          nnorm = npstp
cc          ne0   = nofx(e0, energy, nxmu)
          step  = (cnorm(1) -  bpre) + (cnorm(2) - slopre)*e0
          if (npstp.eq.3) step = step + cnorm(3)*e0*e0
          if (abs(step).lt.tiny) step = 1
       end if
cc       print*, ' preedge: ', e0, step
       return
c end subroutine preedg
       end
       subroutine findee(nxmu, energy, xmu, ee)
c
c   find ee of x-ray absorption data 
c   (maximum deriv, with check that it is at least
c    the third positive deriv in a row)
c inputs:
c   nxmu     length of array energy, xmu, and xmuout
c   energy   array of energy points
c   xmu      array of raw absorption points
c outputs:
c   ee       energy origin of data
      integer    nxmu, ninc, ntry, i, j
      parameter  (ninc = 3)
      logical    inc(ninc), incall
      double precision energy(nxmu), xmu(nxmu), ee, dxde, demx, deltae
      double precision  zero, tiny, onepls
      parameter (zero = 0, tiny = 1.d-9, onepls = 1.00001d0)
c
      ee  = zero
      if (nxmu.le.8)  return
      do 100 i = 1, ninc
         inc(i) = .false.
 100  continue
      dxde  = zero
      demx  = zero
      ntry  = max(2, int(nxmu/2)) + 3
      do 150 i = 2, ntry
         deltae  = energy(i) - energy(i-1)
         if (deltae.gt.tiny) then
            dxde   = (xmu(i) - xmu(i-1))/deltae
            inc(1) = dxde.gt.zero
            incall = inc(3).and.inc(2).and.inc(1)
            if (incall. and. (dxde.gt.demx) ) then
               ee   = energy(i)
               demx = dxde * onepls
            end if
            do 130 j  = ninc, 2, -1
               inc(j) = inc(j - 1)
 130        continue
         end if
 150  continue
      return
      end
       integer function guess_iz(en,mu,npts,e0)
c  given a spectra of mu(e), guess the atomic number based on
c  edge position as found by findee
c  only k and l shells are considered, though it could be expanded.
c  data used is taken from mcmaster.
c  args:
c       en    array of energy      [in]
c       mu    array of xmu         [in]
c       npts  size of energy,xmu   [in]
c       e0    guessed e0 value     [out]
c returns:   
c      iz     atomic number
c
       implicit none
       integer  npts, nedges, iz, nofx, i
       parameter  (nedges= 315)
       double precision  en(npts), mu(npts), e0,ex,edges(nedges)
       integer  iedge(nedges)
       external nofx
       data (edges(i),i = 1, 196) / 0.014,0.025,0.049,0.050,0.055,0.063,
     $      0.072,0.073,0.087,0.099,0.100,0.112,0.118,0.135,0.136,0.153,
     $      0.162,0.164,0.188,0.193,0.200,0.202,0.238,0.248,0.251,0.284,
     $      0.287,0.295,0.297,0.341,0.346,0.350,0.399,0.400,0.402,0.404,
     $      0.454,0.461,0.463,0.512,0.520,0.531,0.537,0.574,0.584,0.604,
     $      0.639,0.650,0.682,0.686,0.707,0.720,0.754,0.778,0.793,0.842,
     $      0.855,0.867,0.872,0.929,0.932,0.952,1.012,1.021,1.044,1.072,
     $      1.100,1.115,1.142,1.196,1.218,1.249,1.302,1.305,1.325,1.360,
     $      1.414,1.436,1.477,1.530,1.550,1.560,1.596,1.653,1.675,1.726,
     $      1.782,1.805,1.839,1.863,1.920,1.940,2.007,2.065,2.080,2.149,
     $      2.156,2.216,2.223,2.307,2.371,2.373,2.465,2.472,2.520,2.532,
     $      2.625,2.677,2.698,2.793,2.822,2.838,2.866,2.967,3.003,3.043,
     $      3.146,3.173,3.202,3.224,3.330,3.351,3.412,3.524,3.537,3.605,
     $      3.607,3.727,3.730,3.806,3.929,3.938,4.018,4.038,4.132,4.156,
     $      4.238,4.341,4.381,4.465,4.493,4.557,4.612,4.698,4.781,4.852,
     $      4.939,4.965,5.012,5.100,5.188,5.247,5.359,5.452,5.465,5.483,
     $      5.624,5.713,5.724,5.891,5.965,5.987,5.989,6.165,6.208,6.267,
     $      6.441,6.460,6.540,6.549,6.717,6.722,6.835,6.977,7.013,7.112,
     $      7.126,7.243,7.312,7.428,7.515,7.618,7.709,7.737,7.790,7.931,
     $      8.052,8.071,8.252,8.333,8.358,8.376,8.581,8.648,8.708,8.919/
       data (edges(i),i = 197,315) / 8.943,8.979,9.047,9.244,9.265,
     $      9.395,9.561,9.618,9.659,9.752,9.881,9.978,10.116,10.204,
     $      10.349,10.367,10.488,10.534,10.739,10.870,10.871,11.104,
     $      11.136,11.215,11.272,11.542,11.564,11.680,11.868,11.918,
     $      11.957,12.098,12.284,12.384,12.525,12.657,12.658,12.824,
     $      12.964,13.035,13.273,13.418,13.424,13.474,13.733,13.892,
     $      14.209,14.322,14.353,14.612,14.698,14.846,15.198,15.200,
     $      15.344,15.708,15.860,16.105,16.300,16.385,17.080,17.167,
     $      17.334,17.998,18.053,18.055,18.986,19.692,19.999,20.470,
     $      20.947,21.045,21.756,22.117,22.263,23.095,23.220,24.350,
     $      25.514,26.711,27.940,29.200,30.491,31.813,33.169,34.582,
     $      35.985,37.441,38.925,40.444,41.991,43.569,45.184,46.835,
     $      48.520,50.240,51.996,53.789,55.618,57.486,59.390,61.332,
     $      63.314,65.351,67.414,69.524,71.676,73.872,76.112,78.395,
     $      80.723,83.103,85.528,88.006,90.527,98.417,109.649,115.603,
     $      121.760/

       data (iedge(i), i=1,315) / 1,2,12,12,3,12,13,13,13,14,14,4,14,
     $  15,15,15,16,16,5,16,17,17,17,18,18,6,18,19,19,19,20,20,21,20,
     $  7,21,22,22,21,23,23,22,8,24,24,23,25,25,24,9,26,26,25,27,27,
     $  26,28,10,28,27,29,29,28,30,30,11,29,31,31,30,32,32,31,12,33,
     $  33,32,34,34,33,35,13,35,34,36,36,35,37,14,37,36,38,38,37,39,
     $  15,39,38,40,40,41,39,41,16,42,40,42,43,41,43,17,44,42,44,45,
     $  43,45,46,18,44,46,47,45,47,48,46,19,48,49,47,50,49,48,20,51,
     $  50,49,52,51,50,21,53,52,51,54,53,52,22,55,54,53,56,55,54,23,
     $  57,56,55,58,57,59,56,24,58,60,57,59,61,25,58,62,60,59,63,61,
     $  26,60,64,62,61,65,63,27,62,66,64,63,67,65,28,68,64,66,69,65,
     $  67,70,29,66,71,68,67,72,69,30,68,73,70,69,74,71,31,70,75,72,
     $  71,76,32,73,77,72,74,78,73,33,79,75,74,80,76,75,81,34,77,76,
     $  82,78,83,77,35,79,78,80,36,79,86,81,80,82,37,81,83,82,38,90,
     $  83,39,92,86,40,94,86,41,90,42,90,92,43,92,44,94,94,45,46,47,
     $  48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,
     $  68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,86,90,92,94/

c  guess e0 from spectra 
       guess_iz = 0
       call findee(npts,en,mu,e0)
c  find closest energy in table
       ex = e0/1000.d0
       guess_iz = iedge(nofx(ex,edges,nedges))
       return
       end

      subroutine fitlog
c
c      write log file to summarize fitting run for feffit.
c      the layout here is hoped to be user-friendly.
c      feel free to change any of this at any time.
c
c      copyright 1993 university of washington         matt newville
c
c----------------------------------------------------------------------
       include 'fitcom.h'

       character*40     logfil, stat*7, outstr*128
       double precision par(mdpths, mpthpr), rfmin, rfave
       double precision redchi, sqrchi, order, small, ten
       double precision tmp1(mvarys**2), tmp2(mvarys**2)
       double precision decod, reff,corr, xnu
       integer      ilog, i, istrln, nstart,id,ilo,inpath
       integer idpath,im,ipath,juser,jfeff,ind, nvr1, nvr2
       integer jlen, ntmp, n, nv, ilen, iex, ierr, idot
       parameter ( rfmin =0.05d0, small = 1.d-5, ten = 10.d0)
       external decod, istrln
c----------------------------------------------------------------------
c       winstr(1) =  'hanning window sills'
c       winstr(2) =  'hanning window fraction'
c       winstr(3) =  'gaussian window'
c       winstr(4) =  'lorentzian window'
c       winstr(5) =  'parzen window '
c       winstr(6) =  'welch window '
c       winstr(7) =  'sine window '
c       winstr(8) =  'gaussian window (2nd form)'

       stat      = 'unknown'
       if (vaxflg)  stat = 'new'
c  determine log file name (usually trivial)
c  but if not, find the *last* "."
       logfil = 'feffit.log'
       if (inpfil.ne.'feffit.inp') then
          call triml(inpfil)
          idot  = max(1,istrln(inpfil))
          if (index(inpfil(1:idot),'.').ne.0) then
 15          continue
             if (index(inpfil(idot:idot),'.').eq.0) then
                idot = idot - 1
                go to 15
             end if
          end if
          logfil = inpfil(1:idot) //'log'
       end if
c  open log file
       ilog   = 0
       ierr   = 0
       iex    = 0
       call openfl(ilog, logfil, stat, iex, ierr)
       if (ierr.lt.0) call finmsg(1002,' ',logfil,0)
c
c  write preliminary messages:
       ilen   = max(1, istrln(versn))
       write(ilog,9002) '   '//versn(1:ilen)
       write(ilog,9904)
c  list input data sets, titles for each
c  also, compute average r-factor
       if (ndata.eq.0) then
          write(ilog,9003) 'no input data files.'
       else
          if (ndata.eq.1) then
             write(ilog,9003) 'input data file:'
          else
             write(ilog,9003) 'input data files:'
          endif
          rfave  = zero
          do 80 n = 1, ndata
             rfave = rfave + rfactr(n)
             if (ndata.gt.1)  write(ilog,9055) '-> data set ',n
             if (datain(n)) then
                ilen = max(1, istrln(chifil(n)))
                outstr = 'input data chi file = '
     $               //chifil(n)(:ilen)//', skey = '//skey(n)
             else
                outstr = ' no input data file given'
             endif
             ilen = max(1,istrln(outstr))
             write(ilog,9005) outstr(1:ilen)
c##<bkg
             if (bkgdat(n)) then
                ilen = max(1, istrln(bkgfil(n)))
                outstr = 'used bkg(k) from file = '
     $               //bkgfil(n)(:ilen)//', skey = '//skeyb(n)
                ilen = max(1,istrln(outstr))
                write(ilog,9005) outstr(1:ilen)
             end if
             if (bkgfit(n)) then
                write(ilog,9005) '  fitted background spline to data'
                write(ilog,9015) '  with rbkg = ', rbkg(n),
     $               '  and n_knots = ',nbkg(n)
             end if
c##bkg>
 80       continue
       end if
       write(ilog,9902)
c----------------------------------------------------------------
c  preliminary : list data sets, weight for each
c     full fit : total indep. points, fit parameters, chi-square, reduced
c     full fit : variables, uncertainties, correlations, init. guesses
c     full fit : user-defined functions
c
       xnu    = xnidp - numvar
       outstr = 'fit results, goodness of fit, and error analysis:'
       ilen = max(1,istrln(outstr))
       write(ilog,9003) outstr(1:ilen)
       if (dabs(tranq-2).gt.small) then
          write(ilog,9910) 'used tranquada correction = ', tranq
       end if
       if (rm2flg) write(ilog,9903) 'used {reff}^{-2} in XAFS Eqn'
       if (ndata.gt.1)
     $      write(ilog,9055) 'number of data sets           = ',ndata
       write(ilog,9060) 'independent points in data    = ',xnidp
       write(ilog,9055) 'number of variables in fit    = ',numvar
       write(ilog,9060) 'degrees of freedom in fit     = ',xnu
       rfave = rfave / ndata
       write(ilog,9035) 'r-factor of fit               = ',rfave
       if (rfave.gt.rfmin)  write(ilog,9903)
     $     ' warning: this r-factor is too big.  the fit might be bad.'
       if (chisqr.lt. 999 999) then
          write(ilog,9035) 'chi-square                    = ',chisqr
       else
          write(ilog,9036) 'chi-square                    = ',chisqr
       end if
       redchi =  chisqr
       if (xnu.gt.0) then
          redchi =  chisqr / xnu
          if (redchi.lt. 999 999) then
           write(ilog,9035) 'reduced chi-square            = ',redchi
          else
           write(ilog,9036) 'reduced chi-square            = ',redchi
          end if
       elseif (xnu.eq.0) then
          write(ilog,9005) 'questionable fit: all independent ',
     $         'points were used in fit!'
       else
          write(ilog,9005) 'invalid fit: more variables than',
     $         ' independent points !'
       end if
       write(ilog,9003) ' '
c
c---------------------------------------------------------------
c  write out the variables and uncertainties, and correlations
c
       if (numvar.le.0) then
          write(ilog,9005) 'no variables were used in feffit'
       else
          outstr = 'feffit found the following values for '//
     $             'the variables:'
          ilen = max(1,istrln(outstr))
          write(ilog,9005) outstr(1:ilen)
          outstr = 'variable            best fit value    '//
     $             'uncertainty  initial guess'
          ilen = max(1,istrln(outstr))
          write(ilog,9002) '      '//outstr(1:ilen)
c
c    go through all values, deciding which were variables, and
c    if any "set" values (user-defined functions) were used.
          sqrchi =   sqrt(dabs(redchi))
          do 140 i = 1, numvar
             ilen = max(15,  istrln(vnames(i)))
             write(ilog,9070) vnames(i)(1:ilen),'=', xfinal(i),
     $            sqrchi * delta(i), xguess(i)
 140      continue
          write(ilog,9003) '    '
c    if successfully calculated, report error bars,
c    otherwise report which variables might be the problem ones
          if (ierbar.lt.0) then
             write(ilog,9002)
     $     '       uncertainties could not be estimated. at least'
             write(ilog,9002)
     $     '       one of the variables does not affect the fit.'
             do 180 nv = 1, numvar
                   ilen = max(25, istrln(vnames(nv) ))
                   if (dabs(xfinal(nv) - xguess(nv)).le.small) then
                      write(ilog,9007)  '      check  '
     $                     //vnames(nv)(1:ilen)
                   end if
 180         continue
          else
c
c write out correlation matrix, sorted so that most highly correlated
c pairs of variables are printed first.
c       first load array with abs(correl) and with j*numvar + i
             write(ilog,9005) 'correlation between variables '
             outstr = 'variable #1    variable #2         correlation'
             ilen = max(1,istrln(outstr))
             write(ilog,9007) outstr(1:ilen)
             ntmp = 0
             if (numvar.eq.2) then
                 ilen = max(15, istrln(vnames(1)))
                 jlen = max(15, istrln(vnames(2)))
                 write(ilog,9080) vnames(1)(:ilen),
     $                            vnames(2)(:jlen), correl(1,2)
             elseif (numvar.gt.2) then
                do 230 nvr1 = 1, numvar
                   do 220 nvr2 = nvr1+1, numvar
                      ntmp       = ntmp + 1
                      tmp1(ntmp) = dabs(correl(nvr1, nvr2))
                      tmp2(ntmp) = nvr2 * numvar + nvr1
 220               continue
 230            continue
                call sort2(ntmp,tmp1,tmp2)
                do 270 n  = ntmp, 1, -1
                   ind = int(tmp2(n))
                   if (ind.gt.0) then
                      nvr1 = mod(ind, numvar)
                      nvr2 = ind / numvar
                      corr = dabs( correl(nvr1,nvr2) )
                      if (corr.ge.cormin) then
                         ilen = max(15, istrln(vnames(nvr1)))
                         jlen = max(15, istrln(vnames(nvr2)))
                         write(ilog,9080) vnames(nvr1)(:ilen),
     $                     vnames(nvr2)(:jlen), correl(nvr1,nvr2)
                      else
                         outstr='all other correlations are less than'
                         ilen   = max(1, istrln(outstr))
                         write(ilog,9030) outstr(1:ilen+1), cormin
                         go to 275
                      endif
                   endif
 270            continue
 275            continue

c
             end if
cc             write(ilog,9903)
cc     $'--------------------------------------------------------------'
cc             write(ilog,9903)
cc     $'the uncertainties and correlations listed above are estimated '
cc             write(ilog,9903)
cc     $'under the assumption that the errors are normally distributed.'
cc             write(ilog,9903)
cc     $'                                                              '
cc             write(ilog,9903)
cc     $'the uncertainties given are estimated to increase the best-fit'
cc             write(ilog,9903)
cc     $'value of chi-square by the value of reduced chi-square.       '
cc             write(ilog,9903)
cc     $'     this assumes the fit is "good" and that the value of     '
cc             write(ilog,9903)
cc     $'     the measurement uncertainty was poorly estimated.        '
cc             write(ilog,9903)
cc     $'--------------------------------------------------------------'
          end if
       end if
c
c--------------------------------------------------------------
c  for each data set :
c     titles, fft, indep. points, measure uncertainty, chi-square
c     feff paths, with path parameters
c
       id = 1
 500   continue
       if (ndata.gt.1)  then
         write(ilog,9904)
         write(ilog,9055) 'data set ',id
         write(ilog,9003) 'measurements for this data set only:'
       end if
c data file name
       if (datain(id)) then
          ilen = max(1, istrln(chifil(id)))
          outstr = 'input data chi file = '
     $             //chifil(id)(:ilen)//', skey = '//skey(id)
          write(ilog,9005) 'user titles:'
          do 540 i = 1, mtitle
             call triml(titles(i,id))
             ilen = istrln(titles(i,id))
             if (ilen.gt.0) write(ilog,9007) titles(i,id)(:ilen)
 540      continue
c
       else
          outstr = ' no input data used'
       endif
       ilo = max(1,istrln(outstr))
       write(ilog,9005) outstr(1:ilo)
c
c information content and uncertainty information for this data
       write(ilog,9005) 'measurement uncertainty of data:'
       write(ilog,9035) '             ... in k-space     = ',sigdtk(id)
       write(ilog,9035) '             ... in r-space     = ',sigdtr(id)
       write(ilog,9035) '             ... in q-space     = ',sigdtq(id)
       write(ilog,9035) 'user-chosen weight for data     = ',sigwgt(id)
       write(ilog,9035) 'weight used for chi-square      = ',weight(id)
       write(ilog,9035) 'independent points in data      = ',xinfo(id)
       if (ndata.gt.1) then
          write(ilog,9035) 'partial chi-square for data set = ',
     $         chi2dt(id)
          write(ilog,9035) 'r-factor for data set           = ',
     $         rfactr(id)
       else
          write(ilog,9035) 'chi-square                      = ',
     $         chi2dt(id)
          write(ilog,9035) 'r-factor                        = ',
     $         rfactr(id)
       end if
c fitting range, fft details
       if (ifft(id).eq.0) then
          write(ilog,9005) 'fitting was done in original k-space'
          write(ilog,9902)
          write(ilog,9020) 'k range    = [',qmin(id),',',qmax(id),' ]'
       elseif (ifft(id).eq.1) then
          write(ilog,9005) 'fitting was done in r-space'
          write(ilog,9020) 'r range    = [',rmin(id),',',rmax(id),' ]'
          write(ilog,9902)
          write(ilog,9003) 'fourier transform information:'
          write(ilog,9020) 'k range    = [',qmin(id),',',qmax(id),' ]'
          write(ilog,9030) 'k weight   =  ', qweigh(id)
          write(ilog,9020) 'dk1, dk2   =  ',qwin1(id),',',qwin2(id),' '
          write(ilog,9005) 'window type= '//sqwin(id)
       elseif (ifft(id).eq.2) then
          write(ilog,9005) 'fitting was done in '//
     $         'backtransformed k-space'
          write(ilog,9020) 'k range    = [',qmin(id),',',qmax(id),' ]'
          write(ilog,9902)
          write(ilog,9003) 'fourier transform information (k->r):'
          write(ilog,9020) 'k range    = [',qmin(id),',',qmax(id),' ]'
          write(ilog,9030) 'k weight   =  ', qweigh(id)
          write(ilog,9020) 'dk1, dk2   =  ',qwin1(id),',',qwin2(id),' '
          write(ilog,9005) 'window type= '//sqwin(id)
          write(ilog,9003) 'fourier transform information (r->k):'
          write(ilog,9020) 'r range    = [',rmin(id),',',rmax(id),' ]'
          write(ilog,9030) 'r weight   =  ', rweigh(id)
          write(ilog,9020) 'dr1, dr2   =  ',rwin1(id),',',rwin2(id),' '
          write(ilog,9005) 'window type= '//srwin(id)
       endif
       write(ilog,9055) 'number of points in fft for fitting = ',mftfit
       write(ilog,9055) 'number of points in fft for outputs = ',mftfit
       write(ilog,9902)
c--------------------------------------------------------------
c  write out the "set" values of user defined functions
       if (nmathx.eq.numvar) then
          outstr = 'no "set" values were used in feffit'
          write(ilog,9005) outstr
       else
          outstr = 'feffit found the following values '//
     $             'for the "fixed" values:'
          ilo = max(1,istrln(outstr))
          write(ilog,9005) outstr(1:ilo)
c     ----------------------------------------
c     first evaluate the set values for this data set
          inpath    = max(1, jdtpth(1,id))
          jfeff     = max(1, jpthff(inpath))
          reff      = max(small, refpth(jfeff))
          ixpath    = jfeff
          consts(4) = reff
          call setval(numvar+1,nmathx,icdval,maxval,micode,
     $          consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
          do 700 i = numvar+1, nmathx
             ilen      = max(20, istrln(vnames(i)))
             order     = dabs(log(dabs( values(i)) + small ))
             if (order.lt.ten) then
                write(outstr,9310) vnames(i)(1:ilen), values(i)
             else
                write(outstr,9320) vnames(i)(1:ilen), values(i)
             end if
             if (icdval(1,i).gt.ixlocl)
     $            call append(outstr,'          (local) ',im)
             ilo = max(1,istrln(outstr))
             write(ilog,9005) outstr(1:ilo)
 700      continue
          write(ilog,9902)
       end if
c     ----------------------------------------
c     for each path, write out the index and label, and
c     calculate and save the numerical path parameters.
c
c write out names of feff.dat files
       write(ilog,9003) 'path   feff file name'
c
c    iuser    "user path index" written in feffit.inp
c    inpath   "internal path index"  for the path parameters [mpaths]
c    ifeff    "feff path index"  for the feff files          [mfffil]
c    idpath   "data path index"  for each data set  [0:mdpths, mdata]
c    pointers held in common:
c            jdtpth(idpath,idata) = inpath
c            jdtusr(idpath,idata) = iuser
c            jpthff(inpath)       = ifeff
       do 1500 ipath = 1, mdpths
          inpath = jdtpth(ipath,id)
          if (inpath.gt.0) then
             jfeff  = jpthff(inpath)
             ixpath = jfeff
             juser  = jdtusr(ipath, id)
             call triml(feffil(jfeff))
             ilen = max(1, istrln(feffil(jfeff)))
             if (iffrec(jfeff).eq.0) then
                write(ilog,9100) juser, feffil(jfeff)(1:ilen)
             else
                write(ilog,9105) juser, feffil(jfeff)(1:ilen),
     $               iffrec(jfeff)
             endif
          end if
 1500  continue
c write out user id's
       write(ilog,9902)
       write(ilog,9003) 'path   identification '
       do 1600 ipath = 1, mdpths
          inpath = jdtpth(ipath,id)
          if (inpath.gt.0) then
             jfeff  = jpthff(inpath)
             juser  = jdtusr(ipath, id)
             call triml(pthlab(inpath))
             ilen = min(70, istrln(pthlab(inpath)) )
             if (ilen.le.0) then
                ilen = min(70, max(1, istrln(feffil(jfeff))))
                if (iffrec(jfeff).eq.0) then
                   write(pthlab(inpath),9450)
     $                  feffil(jfeff)(1:ilen), refpth(jfeff),
     $                  degpth(jfeff), nlgpth(jfeff)
                else
                   write(pthlab(inpath),9455)
     $                  feffil(jfeff)(1:ilen), iffrec(jfeff),
     $     refpth(jfeff), degpth(jfeff), nlgpth(jfeff)
                end if
             endif
             ilen = min(70, max(1, istrln(pthlab(inpath))))
             write(ilog,9100) juser, pthlab(inpath)(1:ilen)
          end if
 1600  continue
c--------------------------------------------------------------
c path parameters
c  evaluate the path parameters from the values and defaults
       do 2000 idpath = 1, mdpths
          inpath    = jdtpth(idpath,id)
          if (inpath.eq.0)    go to 1990
          jfeff     = jpthff(inpath)
          reff      = refpth(jfeff)
          ixpath    = jfeff
          consts(4) = reff
c     evaluate the non-variable values
c  evaluate the non-variable values
c     in case they depend on reff, local values to data set, etc
c##          if (numvar.gt.0) then
             nstart = nconst + numvar + 1
             call setval(nstart,nmathx,icdval,maxval,micode,
     $          consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
c##          end if
c     evaluate the path parameters from the values and defaults
c     (these were found in fitfun before this routine was called)
          do 1950 i = 1, mpthpr
             par(idpath,i) = decod(icdpar(1, i, inpath), micode,
     $                             consts, values, defalt(i))
 1950     continue
c
 1990     continue
 2000  continue
c     write out first set of numerical path parameters
       write(ilog,9902)
       outstr = 'path    degen     amp        e0'//
     $          '    {reff + delr}   delr        sigma2'
       ilo = max(1,istrln(outstr))
       write(ilog,9003) outstr(1:ilo)
       do 3500 idpath = 1, mdpths
          inpath = jdtpth(idpath,id)
          if (inpath.gt.0) then
             jfeff     = jpthff(inpath)
             write(ilog,9150) jdtusr(idpath, id), degpth(jfeff),
     $            par(idpath, jps02), par(idpath, jpe0),
     $            refpth(jfeff) + par(idpath, jpdelr),
     $            par(idpath, jpdelr), par(idpath, jpsig2)
          end if
 3500  continue
c
c   e_imag, third and fourth cumulants, phase shift
       write(ilog,9902)
       outstr = 'path      ei        third      fourth'
       if (dphflg) call append(outstr,'     dphase',im)
       ilo = istrln(outstr)
       write(ilog,9003) outstr(1:ilo)
c
       do 3600 idpath = 1, mdpths
          inpath = jdtpth(idpath,id)
          if (inpath.gt.0) then
             jfeff  = jpthff(inpath)
             if (.not.dphflg) then
                write (ilog,9253) jdtusr(idpath, id),
     $               par(idpath, jpei ), par(idpath, jp3rd),
     $               par(idpath, jp4th)
             else
                write (ilog,9254) jdtusr(idpath, id),
     $               par(idpath, jpei ), par(idpath, jp3rd),
     $               par(idpath, jp4th), par(idpath, jpdpha)
             end if
          end if
 3600  continue
c
c  continue to next data set
c
       id = id + 1
       if (id.le.ndata) go to 500
c   finished
       write(ilog,9902)
       close(unit=ilog)
       return
c
c     formats
 9002  format(2x,a)
 9003  format(3x,a)
 9005  format(5x,a)
 9007  format(7x,a)
 9015  format(5x, a, f6.3, 1x, a, i3)
 9020  format(5x,2(a,f10.5),a)
 9030  format(5x,a,f10.5)
 9035  format(5x,a,f14.6)
 9036  format(5x,a,e14.6)
 9055  format(5x,a,2x,i5)
 9060  format(5x,a,f11.3)
 9070  format(7x,2a,3(2x,f14.6))
 9080  format(7x,2a,2x,f14.6)
 9100  format(2x,i5,3x,a)
 9105  format(2x,i5,3x,a,1x,',',1x,i5)
 9150  format(4x,i3,3x,f6.2,3x,f7.4,2x,f9.5,3x,f8.4,2x,f9.5,3x,f10.6)
 9253  format(4x,i5,3(1x,f10.6))
 9254  format(4x,i5,4(1x,f10.6))
 9255  format(4x,i5,5(1x,f10.6))
 9256  format(4x,i5,6(1x,f10.6))
 9310  format(2x,a,' = ',f14.6)
 9320  format(2x,a,' = ',e14.6)
 9450  format(a,': r=',f6.3,'; n=',f6.2,'; nlegs=',i3)
 9455  format(a,' ,',i5,': r=',f6.3,'; n=',f6.2,'; nlegs=',i3)
 9903  format(3x,'>> ',a,' <<')
 9910  format(3x,'>> ',a,f9.4,' <<')
 9902  format(2x,70('-'))
 9904  format(2x,70('='))
c
c end subroutine fitlog
       end

       subroutine iff_init
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c initialize ifeffit
       implicit none
       include 'consts.h'
       include 'arrays.h'
       include 'encod.h'
       include 'fefdat.h'
       include 'fft.h'
       include 'keywrd.h'
       include 'pthpar.h'
       include 'spline.h'
       include 'echo.h'
       include 'feffit.h'
       save
       integer i, j, k, istrln
       character*64  pltdev, dstr*128, d1str*16, desc
       integer index,  ii, ndevx, inter,  tlen, dlen
       logical exist
       external istrln
c
c write tab delimited outputs (as opposed to space delimited)
       tabdel = .false.
c consts for encoding/decoding: set the first few anyway!
       do 110 i = 10, mconst
          consts(i) = zero
 110   continue 
       do 120 i = 1, 11
          consts(i) = i - 1 
 120   continue 
c
c scalars
       do 630 i = 1, maxsca
          scanam(i) = blank
          scafrm(i) = blank
          scalar(i) = 0
          do 610 j = 1, 2
             icdsca(j,i) = 0
 610      continue 
 630   continue 
c text strings
       do 640 i = 1, maxtxt
          txtnam(i) = blank
          text(i)   = blank
 640   continue 
c arrays
       do 650 j = 1, 8*maxsize_array
          array(j) = zero
 650   continue 
       do 653 j = 1, maxsize_array
          tmparr(j) = zero
 653   continue 
       
       npnext      = 1
       do 680 i = 1, maxarr
          arrnam(i) = blank
          arrfrm(i) = blank
          narray(i) = 0
          nparr(i)  = -1
c         do 650 j = 1, maxpts
c             array(j,i) = 0
c 650      continue 

          do 660 j = 1, 2
             icdarr(j,i) = 0
 660      continue 

 680   continue 
       arrnam(maxarr) = undef_array
c
c default i/o file unit numbers 
c
c /bkgdat/ spline.h initialization
       nsplin = 0
       nautbk = 0
       nrbkg  = 0
       nxmu   = 0
       nr1st  = 0
       theory = .false.
       eevary = .true.
       thefix = .false.
       final  = .false.
       funnrm = .false.
       de0    = 0
       e0     = 0
       emin   = 0
       emax   = 0
       rbkg   = 0
       thessq = one
       thebkg = one
       step   = 0
       do 2100 i = 1, maxpts
          chie(i)   = zero
          endat(i)  = zero
          xmudat(i) = zero
 2100  continue 
c
c /pthpar/ 
       itfeff = 0
       inpthx = 0
       do 2130 i = 1, mpthpr
          defalt(i) = zero
 2130  continue 
       defalt(jfps02) = one
       do 2150 i = 1, mfffil
          lffred(i)  = .false.
          iffrec(i)  = 0
          iffused(i) = 0
          degpth(i)  = zero
          feffil(i)  = blank
 2150  continue 
c
c /fft/ fft.h initialization
       call cffti(maxfft, wfftc)
       wftset = .true.
c
c      /feffit/
       do 2388 i = 1, 10
          restraint(i,1) = undef
 2388  continue 
       fit_macro = undef
       ifit_mac  = 0
       do 2400 i = 1, mpaths
          iulist(i,1) = 0
 2400  continue 
       do 2450 i = 1, mvarys
           xguess(i) = zero
           xfinal(i) = zero
           delta(i)  = zero
           correl(i,i) = zero
           chisqr = zero
 2450   continue 

c
c
c history file
       iohist = 0
       histry = .false.
c macros
       do 3020 i = 1, mcline
          macstr(i) = undef
          imcptr(i) = 0
 3020  continue
       do 3040 i = 1, macmax
          macnam(i) = blank
          mcdesc(i) = blank
          imacro(i) = 0
 3040  continue
       do 3051 i = 1, mcdeep
          imac_save(i) = -1
 3051  continue 
       ioinp  = 0
       nfiles = 0
       do 3060 i = 1, mfiles
          lfiles(i) = blank
          iunit(i) = 10 + i
 3060  continue 
       do 3090 i = 1, mmcarg
          do 3085 j = 1, mcdeep
             mcargs(j,i)  =  blank
 3085     continue 
          do 3087 j = 1, macmax
             mcargd(j,i)  =  blank
 3087     continue 
 3090  continue 
c
c command keys
       mac_define(1) = 0
       mac_define(2) = 0
       mac_define(3) = 0
       mac_define(4) = 0
       mac_exec      = 0
       nmacro        = 0
       nmac_stop     = 0
       do 8020 i = 1, mckeys
          ckeys(i) = undef
          chint(i) = blank
 8020  continue
c
       call seed_randmt(4359)
c
       def_command = 'def'
       call pgqndt(ndevx)
       dstr = ' '
       k    = 1
       do 800 i = 1, ndevx
          call pgqdt(i,d1str,tlen,desc,dlen,inter)
          call triml(d1str)
          call lower(d1str)
          j    = istrln(d1str)
          dstr = dstr(1:k)//' '//d1str(1:j) 
          k    = istrln(dstr)
 800   continue 
       call triml (dstr)
       call settxt('plot_devices', dstr)       
       call setsca('&plot_key_x',0.90d0)
       call setsca('&plot_key_y0',0.90d0)
       call setsca('&plot_key_dy',0.07d0)
       call fstop_init('ifeffit.err')
       return
       end

       subroutine iff_wrdata(str)
c     
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c  write data for ifeffit
c
c fields:
c   file  =  file to write data to
c   pref   =  file prefix to use if not supplied
c   npts  =  max number of points to write out
c   col#n =  full name of array to write out in slot #n in the
c            "pref"."suff" form.
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       save

       integer    maxtit, max_outsca
       parameter (maxtit=64, max_outsca=128)
       integer       mpts, iout(max_outarr), lun, is, ilen, idot, lx
       integer       il, ic, jcol, ncol, ntit, nsca, i, j, k, istrln
       integer       iofarr, ier, iex, nmatch, iff_eval_in, ndfkey
       character*(*) str, stat*10, delim*2, comchr*2
       character*2048 sout
       character*256 file, pref,  type, defkey(2)
       character*256 arrout(max_outarr), scaout(max_outsca)
       character*256 titout(maxtit), strarr(maxtxt), labstr*512
       character*32  uform, fform
       double precision   getsca, xval
       logical       l_titles, isvnam
       parameter (stat = 'unknown')
       external  iofarr, istrln, iff_eval_in, getsca, isvnam
cc       print*, ' iff_wrdata 0' 
       delim = '  '
       labstr   = undef
       l_titles = .true.
       uform =  'g15.8'
       if (tabdel) delim = char(9)

       call gettxt('group', pref)
       file = ' '
cc       call gettxt('filename', file)
cc       call gettxt('filetype', type)
       call gettxt('commentchar', comchr)
       mpts = maxpts
       ncol = 0
       nsca = 0
       ntit = 0
       do 10 i = 1, max_outarr
          arrout(i) = blank
 10    continue 
       do 11 i = 1, max_outsca
          scaout(i) = blank
 11    continue 
       do 12 i = 1, maxtit
          titout(i) = blank
 12    continue 
c  interpret any and all keyword/value pairs for setting options
       call bkeys(str, mkeys, keys, values, nkeys)
       ndfkey    = 1
       defkey(1) = 'file'

       do 100 i = 1, nkeys
          if (keys(i).eq.'group') then 
             pref = values(i)
             call smcase(pref,'a')
          elseif (keys(i).eq.'file') then 
             file = values(i)
          elseif (keys(i).eq.'commentchar') then 
             comchr = values(i)
          elseif (keys(i).eq.'label') then 
             labstr = values(i)
          elseif (keys(i).eq.'no_headers') then 
             call str2lg(values(i), l_titles, ier)
             l_titles = .not. l_titles
          elseif (keys(i).eq.'l_titles') then 
             call str2lg(values(i), l_titles, ier)
          elseif (keys(i).eq.'npts') then 
             ier = iff_eval_in(values(i), mpts)
          else
c fill lists of strings, scalars, arrays according to name
             if (isvnam(keys(i),0)) then
                ncol = ncol + 1
                if (ncol.le.max_outarr)  arrout(ncol) = keys(i)
cc                print*, 'arr: ', keys(i)(1:20)
             elseif (isvnam(keys(i),1)) then
                nsca = nsca + 1
                if (nsca.le.max_outsca)  scaout(nsca) = keys(i)
             elseif ((isvnam(keys(i),3)) .or.
     $               ((keys(i)(1:1).eq.'$').and.
     $               (index(keys(i),'*').ne.0))) then
                ntit = ntit + 1
                if (ntit.le.maxtit)  titout(ntit) = keys(i)(2:)
cc                print*, 'tit: ', titout(ntit)(1:20)
             else
                k = istrln( keys(i) )
                messg = keys(i)(1:k)//' " will not be written'
                call warn(1,
     $               ' *** write_data: unknown variable " '//messg)
             endif
          end if
 100   continue 
c
c now make sure we have the full name and that this array is defined
c
       iex  = 0
       ier  = 0
       lun  = 3
       call openfl(lun, file, stat, iex, ier)
       if ((ier.lt.0).or.(iex.lt.0)) then
          call warn(3,' *** write_data: error opening file ')
          return
       end if
c determine format string: 
       call triml(uform)
       il = istrln(uform)
       lx = 17
       fform = '(1x,'//uform(1:il)//')'
cc       print*, 'fform = ', fform

c
c get array names (for sure)
       jcol = 0
cc       print*, ' nsca, ntit, ncol = ', nsca, ntit, ncol
       ncol = min(ncol, max_outarr)
       if (ncol.eq.0) then
          call warn(2, ' *** write_data:  no data to write out!')
          return
       end if
       do 180 i = 1, ncol
          call glob(arrout(i),arrnam,maxarr,strarr,maxtxt,nmatch)
          do 160 j = 1, nmatch
             k = iofarr(strarr(j),pref,0,0)
             if (k.le.0) then 
                call echo(' *** write_data: couldn''t find array:')
                call warn(1,'     '//strarr(j))
             else
                jcol = jcol + 1
                if (jcol.le.max_outarr) then
                   iout(jcol) = k
                   mpts = min(mpts, narray(k))
                else
                   call echo(' *** write_data: too many arrays'//
     $                  ' requested for write')
                   write(tmpstr,'(5x,a,i3)') 'current limit is ',
     $                  max_outarr
                   call warn(2,tmpstr)
                   return
                endif
             end if
 160      continue
 180   continue
       ncol = min(jcol, max_outarr)
c
c write title lines
       if (l_titles) then 
          ntit = min(ntit, maxtit)
          ic = istrln(comchr)
          if (ntit.eq.0) then
             write(lun,'(3a)') comchr(1:ic),' ','data from ifeffit'
          else
             do 250 i = 1, ntit
cc                print*, ' TITLE ', i,  titout(i)(1:30)
                call glob(titout(i),txtnam,maxtxt,
     $               strarr,maxtxt,nmatch)
                do 200 j = 1, nmatch
                   call gettxt(strarr(j), tmpstr)
                   call triml(tmpstr)
                   k  = istrln(tmpstr)
                   if (k.gt.0) write(lun,'(3a)')
     $                  comchr(1:ic),' ', tmpstr(1:k)
 200            continue 
 250         continue 
          end if
          nsca = min(nsca, max_outsca)
          do 280 i = 1, nsca
             xval = getsca(scaout(i),0)
             write(tmpstr,fform) xval
             k    = istrln(scaout(i))
             write(lun,'(5a)') comchr(1:ic), ' ', scaout(i)(1:k),
     $            ' = ',tmpstr(1:lx)
cc             print*, 'sca: ', i,  scaout(i)(1:k), '  ', tmpstr(1:lx)
 280      continue 
c
c      write label line:  suffixes only!!!
          write(lun,'(2a)') comchr(1:ic),'------------------------'
          sout = comchr(1:ic)//' '
          ilen = istrln(sout) + 1
          do 350 k = 1, ncol 
             il   = max(8, istrln(arrnam(iout(k))))
             idot = index( arrnam(iout(k)), '.')
             sout = sout(1:ilen)//delim//arrnam(iout(k))(idot+1:il)
             ilen = ilen + il + 2
 350      continue 
          ilen = istrln(sout)
          if (labstr .ne.undef) then
             call triml(labstr)
             ilen = istrln(labstr)
             sout = comchr(1:ic)//'  '//labstr(1:ilen)
             ilen = ilen + ic + 2
          endif
          write(lun,'(a)') sout(1:ilen)
       endif          
       if (jcol.ne.ncol) then
          call warn(2,' *** write_data: wrong number of vectors??')
          return
       end if
c write vectors
       do 500 i = 1, mpts
          sout = ' '
          do 470 k = 1, ncol
cc            write(sout(1-lx+k*lx:k*lx),fform) array(i,iout(k))
              write(sout(1+(k-1)*17:k*17),fform)
     $            array(nparr(iout(k))+i-1)
 470      continue
          call triml(sout)
          is = istrln(sout)
          write(lun,'(2x,a)') sout(1:is)
 500   continue
       if (lun.gt.0) close(lun)
c finally, set program variables
       call settxt('group',    pref)
cc       call settxt('filetype', type)
       call settxt('commentchar', comchr)
c
       return
       end

       subroutine txpath
       include 'fitcom.h'
       integer nstart, id, ipath, i, il, inpath, jfeff, juser

       id = 1
c       print*, ' tx 1'
       do ipath = 1, 4
          inpath    = jdtpth(ipath,id)
c          print*, '  path ', inpath, ipath, id
          if (inpath.gt.0) then
             jfeff  = jpthff(inpath)
c             print*, ' JFEFF  = ', jfeff, inpath, ipath,
c     $            refpth(jfeff)
          endif
       enddo

       return 
       end

       integer function iff_eval(string,prefix,arr,narr)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c  evaluate a string as an array, 
c  return values: 
c     -1    string = undef (ie, no array specified)
c      0    string given, but didn't evaluate as an array (ie, is a scalar)
c      1    string given, evaluated as array
c  arguments:
c      string   string to evaluate in array context        [in]
c      prefix   group name to use for simple array names   [in]
c      arr      array of numerical values                 [out]
c      narr     length of arr                             [out]
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'encod.h'
       save
       character*(*) string, prefix, str*2048, pre*256
       logical  isarr, ic_is_arr, isnum
       double precision arr(*)
       integer  icode(micode), jcode(micode), get_array
       integer  j, i, narr, ier, encod, istrln
       external get_array, ic_is_arr, encod, isnum, istrln

c initialization
       iff_eval = -1
       narr  = 0
       arr(1)= zero
       arr(2)= zero
c
c test string
       str = string
       call sclean(str)
       if ((str.eq.' ').or.(str.eq.undef)) return
       call undels(str)
       call lower(str)
       call triml(str)
       iff_eval  = 0    
c first check if number is a constant
       if (isnum(str)) then
          call str2dp(str,arr(1), ier)
          narr      = 1
          return
       endif
c next check for a named array
       pre = prefix
       call triml(pre)
       call lower(pre)
       if ((pre.ne.undef).and.(pre.ne.'')) then
          narr  = get_array(str, pre, 0, arr)
cc          print*, '  iff_eval get_arry :', narr, ' ' , str(1:30)
          if (narr .gt. 1) then
             iff_eval = 1
             return
          endif
       endif
c last resort:  encod/decod string
       ier = encod(str, jcode, icode)
       call decod (icode, micode, consts, scalar, array,
     $      narray, nparr, maxsize_array,  maxarr,  narr, arr)
       isarr = ic_is_arr(icode,micode).and.(narr .gt. 1)
       if (isarr) iff_eval = 1
       return
       end
c
       integer function iff_eval_dp(str,dpval)
c  evaluate a string as a double precision number
c  if str cannot be a number, ier < 0 is returned.
       implicit none
       include 'consts.h'
       character*(*) str
       double precision arr(maxsize_array), dpval
       integer  narr,  ix, iff_eval
       external iff_eval

       iff_eval_dp = -1
       dpval = zero
       ix =  iff_eval(str,'',arr,narr)
       if (ix .ge. 0) then
          iff_eval_dp   = 0
          dpval = arr(1)
       endif
       return
       end
       integer function iff_eval_in(str,inval)
c
       character*(*) str
       double precision dpval
       integer  iff_eval_dp, inval
       external iff_eval_dp
       inval       = 0
       iff_eval_in = iff_eval_dp(str,dpval)
       if (iff_eval_in.eq.0)   inval = int(dpval)
       return
       end
       integer function iff_eval_re(str,val)
c
       character*(*) str
       double precision dpval
       real     val
       integer  iff_eval_dp
       external iff_eval_dp
       val       = 0
       iff_eval_re = iff_eval_dp(str,dpval)
       if (iff_eval_re.eq.0)   val = dpval
       return
       end

       subroutine fitfun(mvec, nvar, xvar, fvec, iend)
c
c  evaluate function to minimize in the least squares sense by lmdif.
c  the function fvec is the difference between chi(r) for data and
c  modelled theory on the fit range [rmin, rmax]. the variables
c  modify the theory chi(k), evaluated as a sum over paths, using
c  routine chipth for the chi(k) for each path.
c
c     copyright 1993   university of washington    matthew newville
c
c arguments:
c   mvec    number of evaluations of fvec ( = 2*nrpts )    (in)
c   nvar    number of variables xvar      ( = numvar  )    (in)
c   xvar    array of variables                             (in)
c   fvec    function of the variables to minimize          (out)
c   iend    integer stopping flag (not currently used)     (in)
c
c note: since this routine (and the routines it calls) is called
c       so often by lmdif (and fdjac2) efficiency and speed are
c       important. (usually clarity is more important than speed.).
c       so this routine is a bit terse.
c----------------------------------------------------------------------
       include 'fitcom.h'

c  local variables
c  warning: do not dimension the array xvar as "xvar(nvar)" !
c           this routine may be called with nvar = 0,
c           and an array dimension 0 is not allowed.
       integer   lenfvc, mvec, nvar, iend, id, i
       integer   nstart, jfit, nfit, nfit1, ixmode
       integer   j0, nqdata, ibscf, jdd, inpath, idpath, jfeff
       parameter(lenfvc = mdata * maxpts)
       double precision reff, degen, xolow, xohigh
       double precision tchiqi(maxpts), tchiqr(maxpts)
       double precision thifit(maxpts)
       double precision xvar(mvarys), fvec(lenfvc), par(mpthpr)
       double precision rfact, bvalue, decod
       external  rfact, bvalue, decod
       j0  =  0
c----------------------------------------------------------------------
cc       print*, ' fitfun   :: final = ', final
c  use the values of the variables to evaluate all the "values"
c  for both the variables and the user-defined functions
c  note: values(i) is a variable       if  icdval(1,i) < 0
c        values(i) is a user function  if  icdval(1,i) > 0
c        values(i) is unused           if  icdval(1,i) = 0
       id    = 1
       do 20 i = 1, nvar
          values(i) = xvar(i)
 20    continue
cc       print*, ' vars: ', xvar(1), xvar(2), xvar(3), nvar

c don't need to evaluate the obvious constants, so we can start the
c looping here at nconst+nvar (see fitchk and fixicd)
       nstart = nconst + nvar + 1
       
       call setval(nstart,nmathx,icdval,maxval,micode,
     $      consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
c
c  sum function to minimize over data sets
c   jfit is the counter (through all the data sets)
c   for the total number of fitting points
       jfit = 0
       do 3000 id = 1, ndata
          nqdata = min(maxpts, max(2, nqfit(id)) + 10)
          if (ifft(id).eq.1) then
             xolow  = rmin(id)
             xohigh = rmax(id)
             nfit   = 2 * max (1, nrpts(id))
          elseif (ifft(id).eq.2) then
             xolow  = qmin(id)
             xohigh = qmax(id)
             nfit   = 2 * max (1, nqpts(id))
          else
             xolow  = qmin(id)
             xohigh = qmax(id)
             nfit   = 2 * max (1, nqpts(id))
          endif
          do 200 i = 1, nfit
             thifit(i)   = zero
 200      continue
c  re-initialize array for theoretical chi(k)
c  by assigning this to the background function
cc          print*, 'FITFUN B ', id, xolow, xohigh, nfit
          do 300 i = 1, nqdata
             thiq(i, id) = zero
             tchiqi(i)   = zero
             tchiqr(i)   = zero
             if (final) thiqr(i, id) = zero
             if ( bkgfit(id))  then
c  ibscf holds place in xvar list of where the
c  spline coefs for the current data set are kept.
                ibscf  = nvuser+1
                if (id.gt.1) then
                   do 290 jdd = 2, id
                      ibscf = ibscf + nbkg(jdd-1)
 290               continue
                endif
                thiq(i, id) = thiq(i, id) +
     $               bvalue(qknot(1,id), xvar(ibscf),
     $               nbkg(id),korder,qgrid*(i-1),j0)
             end if
 300      continue
c
c   sum over paths for theory chi for this data set
          do 1000 idpath = 1, mdpths
             inpath    = jdtpth(idpath,id)
             if (inpath.le.0)    go to 990
             jfeff     = jpthff(inpath)
             reff      = refpth(jfeff)
             degen     = degpth(jfeff)
             ixpath    = jfeff
             consts(4) = reff
             consts(5) = degen
cc             print*, ' FITFUN: path ', idpath, jfeff, reff, degen
c  evaluate the non-variable values
             call setval(nstart,nmathx,icdval,maxval,micode,
     $            consts,mconst,values,icdloc,mlocal,mdata,ixlocl,id)
c  evaluate the path parameters from "values"
             do 500 i = 1, mpthpr
                par(i) = decod(icdpar(1, i, inpath), micode,
     $                         consts, values, defalt(i))
 500         continue
c  get chi(k) for this path from feff and path parameters
             if ( (inpath.gt.0).and.(jfeff.gt.0))  then
                if (iprint.ge.3) then
                   write(ifxvar,*) 'calling chipth:'
                   write(ifxvar,*) 'nfit, jfeff = ',nfit, jfeff
                   write(ifxvar,*) 'nqdata, maxpts = ',nqdata, maxpts
                   write(ifxvar,*) 'reff, mffpts = ', reff, mffpts
                   write(ifxvar,*) ' theamp(28,jfeff),thepha(28,jfeff)'
                   write(ifxvar,*) theamp(28,jfeff), thepha(28,jfeff)
                   write(ifxvar,*) ' qfeff(28,jfeff) =',qfeff(28,jfeff)
                   write(ifxvar,*) ' xlamb(28,jfeff), realp(28,jfeff)'
                   write(ifxvar,*) xlamb(28,jfeff), realp(28,jfeff)
                   write(ifxvar,*) ' reff, degen = ', reff, degen
                end if
cc                print*, ' id e0 ', id, par(jpe0)
                call chipth(theamp(1,jfeff), thepha(1,jfeff),
     $  qfeff(1,jfeff), xlamb(1,jfeff), realp(1,jfeff), mffpts,
     $  reff, degen, par(jps02),  par(jpe0),  par(jpei), par(jpdpha),
     $  par(jpdelr), par(jpsig2), par(jp3rd), par(jp4th), tranq, 
     $  rm2flg, nqdata, maxpts, tchiqr, tchiqi)

                if (iprint.ge.3) then
                   write(ifxvar,*) 'called chipth: jfeff, id = ',
     $                  jfeff,id
                   write(ifxvar,*) ' degen, s02, e0, ei = ',degen,
     $                  par(jps02),par(jpe0),par(jpei)
                   write(ifxvar,*) ' dphas,delr, sig2 = ',
     $                  par(jpdpha),par(jpdelr),par(jpsig2)
                   write(ifxvar,*) 'nqdata, maxpts = ',nqdata, maxpts
                   write(ifxvar,*) 'tchiqr(1),tchiqi(1)'
                   write(ifxvar,*)  tchiqr(1),tchiqi(1)
                   write(ifxvar,*) 'tchiqr(8),tchiqi(8)'
                   write(ifxvar,*)  tchiqr(8),tchiqi(8)
                end if
c
c  add this to the other paths
                do 850 i = 1, nqdata
                   thiq(i, id) = thiq(i, id) + tchiqi(i)
                   if (final) thiqr(i, id) = thiqr(i, id) + tchiqr(i)
 850            continue
             end if
 990         continue
 1000     continue
c   take fft of theory chi (exactly as for data chi)
          if (iprint.ge.2) then
             write(ifxvar,*) ' call fitfft: id = ', id
             write(ifxvar,*) ' xolow , xohigh ', xolow , xohigh
             write(ifxvar,*) ' maxpts, mftfit ', maxpts, mftfit
             write(ifxvar,*) ' qgrid =  ', qgrid
          endif
          ixmode = 0
          call fitfft(thiq(1,id), maxpts, mftfit, wfftc, qgrid,
     $         qwindo(1,id), qweigh(id), rwindo(1,id), rweigh(id),
     $         ifft(id), ixmode, xolow,xohigh, nfit1, thifit)
c
          if (nfit1.ne.nfit) then
             if (iprint.ge.1) then
                write(ifxvar,*) '*********************'
                write(ifxvar,*) 'fitfun error after fitfft: id = ',id
                write(ifxvar,*) 'nfit,  nfit1 = ', nfit, nfit1
                write(ifxvar,*) 'these should be equal !!'
                write(ifxvar,*) '*********************'
             end if
cc             print*, 'nfit,  nfit1 = ', nfit, nfit1
             call finmsg(3590,' ',' ',nfit1)
          endif
c  evaluate the contribution to fvec for this data set.  weight scales
c  chi-square properly to the number of independent points. this is
c  important for error analysis (if chi-square is to increase by one,
c  it  must be scaled correctly.), but only in the final pass, when
c  chi-square and r-factors will be calculated.
          if (final.and.iprint.ge.2) then
             write(ifxvar,*) ' in fitfun (final): id = ', id
             write(ifxvar,*) ' xolow , xohigh ', xolow , xohigh
             write(ifxvar,*) ' maxpts, mftfit ', maxpts, mftfit
             write(ifxvar,*) ' nfit, nfit1,jfit = ', nfit, nfit1,jfit
             write(ifxvar,*) ' rfactr(id)  = ', rfactr(id)
             if (iprint.ge.5)
     $            write(ifxvar,*) ' i, chifit,thifit,fvec: '
          end if
          do 2400 i =  1, nfit
             fvec(jfit+i) = (thifit(i) - chifit(i,id))/weight(id)
             if (final.and.iprint.ge.5) write(ifxvar,*) jfit+i,
     $            chifit(i,id), thifit(i),  fvec(jfit+i)
 2400     continue
          jfit  = nfit + jfit
          if (final.and.datain(id))
     $         rfactr(id) = rfact(chifit(1,id), thifit, nfit)
 3000  continue
       return
c  end subroutine fitfun
       end

       subroutine iff_color(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c  update the color table 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save

       character*(*) str, s*256
       integer nwrds,  i, j, ier, jcol, istrln, iff_eval_in
       external istrln, iff_eval_in

       s = str
       nwrds = mkeys
       call bwords(s,nwrds,keys)
c 
cc       print*, "  bg/fg/gr = ", mcolbg, mcolfg, mcolgr
cc       print*, "  bg/fg/gr = ", pltcol(mcolbg), pltcol(mcolfg),
cc     $      pltcol(mcolgr)
       call rmquot(keys(1)) 
       if (keys(1).eq.'show') then
          call echo(' plot color table: ')
          call echo('    bg   = '//pltcol(mcolbg) )
          call echo('    fg   = '//pltcol(mcolfg) )
          call echo('    grid = '//pltcol(mcolgr) )
          do 100 j = 1, mctabl-3
             if (pltcol(j).ne.undef) then
                write(messg,'(3x,i5,2a)') j,' = ',pltcol(j)
                call echo(messg)
             end if
 100      continue 
       else 
          do 300 i = 1, nwrds, 2
             ier = 0
             call str2in(keys(i),jcol,ier)
             call rmquot(keys(i+1))
             if (ier.eq.0) then 
                call setcol(jcol, keys(i+1) )
             elseif ((keys(i).eq.'bg') .or.
     $               (keys(i).eq.'background')) then
                call setcol(mcolbg, keys(i+1) )
             elseif ((keys(i).eq.'fg') .or.
     $               (keys(i).eq.'foreground')) then
                call setcol(mcolfg, keys(i+1) )
             elseif (keys(i)(1:2).eq.'gr') then
                call setcol(mcolgr, keys(i+1) )
             end if
 300      continue 
       endif
c      
       return
       end

       subroutine iff_pstyle(str)
c
c  update the linestyle table 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save
       character*(*) str, s*256
       integer nwrds,  i, j, ier, jcol, istrln, iff_eval_in
       external istrln, iff_eval_in
       s     = str
       nwrds = mkeys
       call bwords(s,nwrds,keys)
c 
       call rmquot(keys(1))       
       if (keys(1).eq.'show') then
          call echo(' plot style table: ')
          do 100 j = 1, maxplt
             if (pltsty(j).ne.undef) then
                write(messg,'(3x,i5,2a)') j,' = ',pltsty(j)
                call echo(messg)
             end if
 100      continue 
       else 
          do 300 i = 1, nwrds, 2
             ier = 0
             call str2in(keys(i),jcol,ier)
             call rmquot(keys(i+1))
             call set_plsty(keys(i+1), isty(jcol), pltsty(jcol))
 300      continue 
       endif
c      
       return
       end

       subroutine set_plsty(style, index, out)
c
c purpose: set PGPLOT lines style based on style name

c arguments:
c      style   string                       [in]
c      index   style index to use           [out]
c      out     'normalized style string'    [out]
c
c  copyright (c) 2000  matt newville
       character*(*) style, sty*32, out*32
       integer  index, itmp, ier

       index = 1
       out   = 'solid'
       sty   = style
       call triml(sty)
       call lower(sty)
       if ((sty.eq.'solid').or.(sty.eq.'lines')) then
          index = 1
          out   = 'solid'
       elseif ((sty(1:4).eq.'dash')) then
          index = 2
          out   = 'dashed'
       elseif (sty(1:6).eq.'dot-da') then
          index = 3
          out   = 'dot-dashed'
       elseif ((sty.eq.'dotted').or.(sty.eq.'dot')) then
          index = 4
          out   = 'dotted'
       elseif (sty(1:11).eq.'linespoints') then
          call str2in(sty(12:), itmp, ier)
          if (itmp.lt.0) itmp = 1
          index = itmp + 5
          out   = style
       elseif (sty(1:6).eq.'points') then
          call str2in(sty(7:), itmp, ier)
          if (itmp.lt.0) itmp = 1
          index = -itmp
          out   = style
       end if
       return
       end
c
      
       subroutine setcol(jcol, string)
c
c purpose: set color in the color table to a named color
c
c arguments:
c      jcol    color index to set                       [in]
c      string  string to interpret as color             [in]
c
c notes:
c   1.  string can either be a valid colorname from rgb.txt
c       or begin with '#', and then be interpreted as a 
c       hexadecimal rgb specification
c
c requires:  hexcol, pgscrn
c
c  copyright (c) 1998  matt newville
c
       include 'consts.h'
       include 'ifplot.h'
       save
       character*(*) string, s*32
       integer jcol, ier
       if ((jcol.le.mctabl).and.(jcol.ge.0)) then
          ier = 0
          s = string
          call lower(s)
cc          print*, ' setcol: ', jcol, s
         if (s(1:1).eq.'#') then
             call hexcol(jcol, s(2:))
          else
             call pgscrn(jcol, s, ier)
          end if
          if (ier.eq.0) then
             pltcol(jcol) = s
          else
             call pgscrn(jcol, pltcol(1), ier)
          end if
       end if
       if (jcol .eq. mcolbg) then
           pltcol(0) = pltcol(mcolbg)
          call pgscrn(0, pltcol(0), ier)
       endif
       return
       end
       subroutine getcol(string,jcol)
c
c purpose: lookup a named color in the color table.  if not found, and 
c          there's room, add to color table
c
c arguments:
c      string  string to interpret as color             [in]
c      jcol    color index to set                       [out]
c
c notes:
c   1.  string can either be a valid colorname from rgb.txt
c       or begin with '#', and then be interpreted as a 
c       hexadecimal rgb specification
c
c requires:  hexcol, pgscrn
c
c  copyright (c) 1998  matt newville
c
       include 'consts.h'
       include 'ifplot.h'
       save
       character*(*) string, s*32
       integer jcol,  j

       s = string
       call lower(s)
       jcol = 0
       do 10 j = 0, mctabl
          if (pltcol(j).eq.s) then 
             jcol = j
             return
          elseif (pltcol(j).eq.undef) then
             jcol = j
             call setcol(j,s)
             return
          elseif (j.eq.mctabl) then
             call echo(' ** ifeffit plot: color table full ')
             call warn(1,
     $            ' **    redefine some colors with color command')
          end if
 10    continue 
       return
       end
       subroutine hexcol(jcol, string)
c
c purpose: set pgplot color from a hexdecimal string
c
c arguments:
c      string  string to interpret as color             [in]
c
c
c  copyright (c) 1998  matt newville
       integer i, jcol, ilen, istrln, fact
c  note:  uses single precision!
       real    r, g, b, total, zero
       character*(*) string, s*32, digs*16
       parameter (digs = '0123456789abcdef',fact=16, zero=0)
       total = 1
       s = string
       if (s(1:1) .eq. '#') s = s(2:)
       ilen = istrln(s)
       call lower(s)
       r    = zero
       g    = zero
       b    = zero
       idig = ilen / 3
       do 10  i = 1, idig
          total = total * fact
          r  = fact * r -1 + max(1, index(digs, s(i:i)))
          g  = fact * g -1 + max(1, index(digs, s(i+idig:i+idig)))
          b  = fact * b -1 + max(1, index(digs, s(i+2*idig:i+2*idig)))
 10    continue 
       r = r / total
       g = g / total
       b = b / total
cc       print*, ' hexcol : pgscr ( ', jcol, r, g, b, ' ) '
       call pgscr(jcol,r,g,b)
       return
       end

       subroutine iff_cursor(argu)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c  get cursor position of plot:
c  uses pgpplot routine pgband
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save

       character c*1, str*32, argu*(*)
c note: pgcurs uses single precision!
       real      rx, ry, ox, oy
       double precision d_x, d_y, getsca
       logical   do_show
       integer   iff_eval_in, i, ier, k
       integer   pgband, iret, ilen, istrln, mode, iposn
       external  pgband, istrln, getsca, iff_eval_in
       c     = ' '

       str = argu
       call bkeys(str, mkeys, keys, values, nkeys)
       mode = 0
       iposn= 0
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if (keys(i).eq.'show') then
             do_show = .true.
          elseif (keys(i).eq.'mode') then
             ier = iff_eval_in(values(i),mode)
          elseif (keys(i).eq.'last_pos') then
             ier = iff_eval_in(values(i),iposn)
          elseif ((keys(i).eq.'cross-hair') .or.
     $            (keys(i).eq.'cross_hair') .or.
     $            (keys(i).eq.'crosshair') ) then
             mode = 7
          elseif (keys(i).eq.'vert') then
             mode = 6  
          elseif (keys(i).eq.'horiz') then
             mode = 5
          elseif (keys(i).eq.'xrange') then
             mode = 4
          elseif (keys(i).eq.'yrange') then
             mode = 3
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** cursor: unknown keyword " '//messg)
          end if
 100   continue
c  grwin specific: raise to top
       call iff_plotraise(1)
       ox   = real(getsca('cursor_x',1))
       oy   = real(getsca('cursor_y',1))
       call echo(' select cursor position')
       iret = pgband(mode, iposn, ox, oy, rx, ry, c)
       if (iret.eq.1) then
          call setsca('cursor_x', dble(rx))
          call setsca('cursor_y', dble(ry))
       end if

       if (do_show) then
          write(tmpstr,'(1x,a,g15.6,a,g15.6)') 'cursor: x = ', rx,
     $         ', y = ', ry
          call echo('  '//tmpstr)
       endif
       return
c  end subroutine cursor
       end

       subroutine iff_zoom(argu)
c
c zoom in on plot
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save
       integer  i, ilen, istrln, k
       integer  pgband, iret, mode1, mode2
       logical  do_show
       real      rx1, rx2, ry1, ry2 
       double precision  getsca
       character*32 str, s, argu*(*), c*1
       external istrln, pgband, getsca
c
       mode1 = 7
       mode2 = 2
       str = argu

       call bkeys(str, mkeys, keys, values, nkeys)

       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if (keys(i).eq.'show') then
             do_show = .true.
          elseif (keys(i).eq.'nobox') then
             mode1 = 0
             mode2 = 0
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** zoom: unknown keyword " '//messg)
          end if
 100   continue


c  get first point with pgband mode=0
       rx2  = real(getsca('cursor_x',1))
       ry2  = real(getsca('cursor_y',1))
c  grwin specific: raise to top
       call iff_plotraise(1)

       call echo(' select cursor position')
       iret = pgband(mode1, 0, rx2, ry2, rx1, ry1, c)
       rx2  = rx1
       ry2  = ry1
c  now use specified mode
       iret = pgband(mode2, 0, rx1, ry2, rx2, ry2, c)
       call setsca('cursor_x', dble(rx2))
       call setsca('cursor_y', dble(ry2))

       xlim(1) = dble(min(rx1,rx2))
       xlim(2) = dble(max(rx1,rx2))
       xlim(3) = dble(min(ry1,ry2))
       xlim(4) = dble(max(ry1,ry2))
       do 200 i = 1, 4
          limits(i) = .true.
 200   continue 
       write(tmpstr,'(1x,a,g15.6)') 'xmin= ', xlim(1)
       call iff_plot(tmpstr)
c
       if (do_show) then
          write(tmpstr,'(1x,a,g15.6,a,g15.6)') 'cursor: x = ', xlim(1),
     $         ', y = ', xlim(3)
          call echo('  '//tmpstr)
          write(tmpstr,'(1x,a,g15.6,a,g15.6)') 'cursor: x = ', xlim(2),
     $         ', y = ', xlim(4)
          call echo('  '//tmpstr)
       endif
c      
       return
       end

       subroutine iff_plotmarker(str)
c
c  plot a single marker point at an x/y position
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save
       character c*1, str*(*)
c note: pgcurs uses single precision!
       real      rx, ry,xx,yy
       character*64  defkey(3), color
       double precision  getsca
       integer   iff_eval_re, iff_eval_in, i, ier, k, ij
       integer   idfkey, ndfkey,j, jtcol
       integer   iret, ilen, istrln, mode, iposn
       external  istrln, getsca, iff_eval_re, iff_eval_in

       call bkeys(str, mkeys, keys, values, nkeys)

       defkey(1) = 'x'
       defkey(2) = 'y'
       defkey(3) = 'marker'
       idfkey    = 1
       ndfkey    = 3
       tmpstr    = undef
       color     = pltcol(mcolfg)

       ij        = -1001
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if (keys(i).eq.'clear') then
             npmark = 0
             do 88 j = 1, mpmark
                imarker(j) = -13000
 88          continue 
          else if ((values(i).eq.undef).and.
     $         (idfkey.le.ndfkey).and.(i.le.5)) then
             values(i) = keys(i)
             keys(i)   = defkey(idfkey)
             idfkey    = idfkey + 1
          end if
          if (keys(i).eq.'x') then
             ier = iff_eval_re(values(i),xx)
          elseif (keys(i).eq.'y') then
             ier = iff_eval_re(values(i),yy)
          elseif (keys(i).eq.'marker') then
             ier = iff_eval_in(values(i),ij)
          elseif (keys(i).eq.'clear') then
             npmark = 0
          elseif (keys(i).eq.'color') then
             color = values(i)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** plot_marker: unknown keyword " '//messg)
          end if
 100   continue

       if (ij .ge. -1000) then 
          npmark = npmark + 1
          imarker(npmark) = ij
          xmarks(npmark)  = xx
          ymarks(npmark)  = yy
          call getcol(color,jtcol)
          mrkcol(npmark) = jtcol
       end if
       call iff_plot(' ')

       return
c  end subroutine plot_marker
       end

       subroutine iff_plotarrow(str)
c
c  plot an arrow
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save
       character c*1, str*(*)
c note: pgcurs uses single precision!
       real      x1,x2,y1,y2, barb,angle, size, xx(2),yy(2)
       character*64  defkey(5),color
       integer   iff_eval_re, i, ier, k, ij, j, jtcol
       integer   idfkey, ndfkey, ixarr
       integer   iret, ilen, istrln, mode, iposn
       external  istrln, iff_eval_re

       call bkeys(str, mkeys, keys, values, nkeys)

       defkey(1) = 'x1'
       defkey(2) = 'y1'
       defkey(3) = 'x2'
       defkey(4) = 'y2'
       angle     = 45
       barb      = 0.4
       size      = 2
       idfkey    = 1
       ndfkey    = 4
       ixarr     = 1
       color = pltcol(mcolfg)
       
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if (keys(i).eq.'clear') then
             nparro = 0
             do 88 j = 1, mparro
                iarrow(i) = -1
 88          continue 
          elseif ((values(i).eq.undef).and.
     $         (idfkey.le.ndfkey).and.(i.le.5)) then
             values(i) = keys(i)
             keys(i)   = defkey(idfkey)
             idfkey    = idfkey + 1
          end if
          if (keys(i).eq.'x1') then
             ier = iff_eval_re(values(i),x1)
          elseif (keys(i).eq.'y1') then
             ier = iff_eval_re(values(i),y1)
          elseif (keys(i).eq.'x2') then
             ier = iff_eval_re(values(i),x2)
          elseif (keys(i).eq.'y2') then
             ier = iff_eval_re(values(i),y2)
          elseif (keys(i).eq.'y2') then
             ier = iff_eval_re(values(i),y2)
          elseif (keys(i).eq.'barb') then
             ier = iff_eval_re(values(i),barb)
          elseif (keys(i).eq.'angle') then
             ier = iff_eval_re(values(i),angle)
          elseif (keys(i).eq.'color') then
             color = values(i)
          elseif (keys(i).eq.'size') then
             ier = iff_eval_re(values(i),size)
          elseif (keys(i).eq.'no_head') then
             ixarr= -1
          elseif (keys(i).eq.'fill') then
             ixarr= 1
          elseif (keys(i).eq.'outline') then
             ixarr= 2
          elseif (keys(i).eq.'clear') then
             nparro = 0
             ixarr = -100
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** plot_arrow: unknown keyword " '//messg)
          end if
 100   continue

       if (ixarr .ge. -10) then 
          nparro = nparro + 1
          iarrow(nparro)   = ixarr
          xarros(nparro,1) = x1
          xarros(nparro,2) = y1
          xarros(nparro,3) = x2
          xarros(nparro,4) = y2
          xarros(nparro,5) = angle
          xarros(nparro,6) = barb
          xarros(nparro,7) = size
          call getcol(color,jtcol)
          xarros(nparro,8) = jtcol
       endif
       call iff_plot(' ')

       return
c  end subroutine plot_arrow
       end

       subroutine iff_plottext(str)
c
c  plot a single marker point at an x/y position
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'ifplot.h'
       save
       character c*1, str*(*)
c note: pgcurs uses single precision!
       real      xx, yy
       character*64  defkey(5)
       double precision  getsca
       integer   iff_eval_re, iff_eval_in, i, ier, k, ij
       integer   idfkey, ndfkey,j
       integer   iret, ilen, istrln, mode, iposn
       external  istrln, getsca, iff_eval_re, iff_eval_in
       

       call rmquot(str)
       call bkeys(str, mkeys, keys, values, nkeys)
       defkey(1) = 'x'
       defkey(2) = 'y'
       defkey(3) = 'text'
       idfkey    = 1
       ndfkey    = 3
       tmpstr    = undef

       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if (keys(i).eq.'clear') then
             do 88 j = 1, nplabs
                pltlab(j) = undef
 88          continue 
          endif
          if ((values(i).eq.undef).and.
     $         (idfkey.le.ndfkey).and.(i.le.5)) then
             values(i) = keys(i)
             keys(i)   = defkey(idfkey)
             idfkey    = idfkey + 1
          end if
          if (keys(i).eq.'x') then
             ier = iff_eval_re(values(i),xx)
          elseif (keys(i).eq.'y') then
             ier = iff_eval_re(values(i),yy)
          elseif (keys(i).eq.'text') then
             tmpstr = values(i)
          elseif (keys(i).eq.'clear') then
             nplabs = 0
          elseif (keys(i).eq.'size') then
             ier = iff_eval_re(values(i), txtsiz)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** plot_text: unknown keyword " '//messg)
          end if
 100   continue

c plot text 
       if (tmpstr .ne. undef) then
          nplabs = nplabs + 1
          call rmquot(tmpstr)
          pltlab(nplabs) = tmpstr
          xplabs(nplabs) = xx
          yplabs(nplabs) = yy
       end if
       call iff_plot(' ')
       return
c  end subroutine cursor
       end

       subroutine fixstr(string,str,ilen,words,wrdsor,mwords,nwords)
c  simple preparation of string for reading of keywords
       integer       ilen, mwords, nwords, i, lenp1
       integer       iexcla, iperct, ihash, ieolc, istrln
       character*(*) string, str, words(mwords), wrdsor(mwords)
c
c  fix-up string: untab, left-justify, make a lower-case version
       nwords = 0
       call untab(string)
       str   = string
       call triml(str)
       call smcase( str, 'case')
c  remove comments from str:
c   '!', '#', and '%' are end of line comments
c   '*' is a complete comment line if in col 1
       lenp1  = len(str) + 1
       iexcla = index(str,'!')
       if (iexcla.eq.0)  iexcla = lenp1
       iperct = index(str,'%')
       if (iperct.eq.0)  iperct = lenp1
       ihash  = index(str,'#')
       if (ihash.eq.0)  ihash = lenp1
       ieolc  = min(iperct,iexcla,ihash) - 1
       if ((ieolc.lt.1).or.(str(1:1).eq.'*')) ieolc = 1
       str    = str(1:ieolc)
       ilen   = max(1, istrln(str))
       if (ilen.le.2)  return
c  break string into words (up to mwords)
c  words is in lower case,   wrdsor is in original case
       do 120 i = 1, mwords
          words(i)   =  ' '
          wrdsor(i) =  ' '
 120   continue
       nwords = mwords
       call bwords(str   , nwords, words)
       call bwords(string, nwords, wrdsor)
c end  subroutine fixstr
       return
       end

       subroutine getcom(jinit, line)
c
c  return next "real" command line from input file(s)
c    -  allows use of "include file" or "load file" for reading
c       from other files, and manages the set of include files
c    -  checks for and ignores comment lines and blank lines.
c    -  opens and closes all input files, including initial file.
c
c   jinit  initialization flag              [in]
c   line   next command line to parse   [in/out]
c
c notes:
c   1. to initialize, set jinit<0 and line= input_file_name.
c      if line=' ', commands will be read from standard input
c      (unit 5).
c   2. returned line will be sent through triml and untab.
c   3. uses routine iscomm to test if line is a comment line.
c   4. uses routine openfl to open files (which include automatic
c      assignment of next available unit number)
c   5. special returned values:
c        'getcom_end'  = done reading all inputs
c        'getcom_error'= an error has occurred. the calling routine
c                        should probably stop
c        'getcom_nofile'= on initialization, the file named by "line"
c                         could not be found
c matt newville march 1997
       implicit none
       integer mwords, ilen, i, jinit, mfil, nfil
       character*(*) line, stat*8
       parameter (mwords=2, mfil=10, stat = 'old')
       character*128  files(mfil), errmsg, words(mwords)
       integer   iunit(mfil), istrln, nwords, ierr, iex
       integer   iret, iread
       logical   iscomm
       external  istrln, iscomm, iread
       save      files, iunit, nfil
c
       if ((jinit.lt.0)) then
          jinit  = 1
          do 10 i = 1, mfil
             iunit(i) = 0
             files(i) = ' '
 10       continue
          nfil     = 1
          files(1) = line
          call triml(files(1))
          if (files(1) .eq. ' ') then
             iunit(1) = 5
          else
             call openfl(iunit(1), files(1), stat, iex, ierr)
             if (iex.lt.0) then
                line = 'getcom_nofile'
                return
             elseif (ierr.ne.0) then
                line = 'getcom_error'
                return
             end if
          end if
       end if
c  read next line from current input file
 100   continue
       line   = ' '
       iret = iread(iunit(nfil), line)
       if (iret.eq.-1) goto  500
       if (iret.eq.-2) goto 1000
       if (iret.eq. 0) goto  100
c
c  check if command line is 'include filename'.
c  if so, open that file, and put it in the files stack

       call triml(line)
       if (iscomm(line)) go to 100
       nwords = mwords
       words(2) = ' '
       call bwords(line, nwords, words)
       call lower(words(1))
       if (((words(1) .eq. 'include').or.(words(1) .eq. 'load'))
     $      .and. (nwords .gt. 1)) then
          nfil = nfil + 1
          if (nfil .gt. mfil) go to 2000
          call getfln(words(2), files(nfil), ierr)
          if (ierr. ne. 0) go to 2400
c  test for recursion:
          do 400 i = 1, nfil - 1
             if (files(nfil) .eq. files(i)) go to 3000
 400      continue
          call openfl(iunit(nfil), files(nfil), stat, iex, ierr)
          if (iex .lt. 0) go to 2600
          if (ierr.lt. 0) go to 2800
          go to 100
       end if
       return
c
c  end-of-file for command line file: drop nfil by 1,
c  return to get another command line
 500   continue
       if (iunit(nfil) .ne. 5) close(iunit(nfil))
       iunit(nfil) = 0
       files(nfil) = ' '
       nfil = nfil - 1
       if (nfil.gt.0) go to 100
       line = 'getcom_end'
       return
c   error messages
 1000  continue
       call echo(' # getcom error: general read error')
       go to 4500
 2000  continue
       call echo(' # getcom error: too many nested "include"s')
       write(errmsg, '(1x,a,i3)') ' # current limit is ', mfil
       ilen  = istrln(errmsg)
       call echo(errmsg(1:ilen))
       go to 4500
 2400  continue
       call echo(' # getcom error: cannot determine "include" file')
       go to 4500
 2600  continue
       call echo(' # getcom error: cannot find "include"d file')
       go to 4500
 2800  continue
       call echo(' # getcom error: cannot open "include"d file')
       go to 4500
 3000  continue
       call echo(' # getcom error: recursive "include" of file')
       go to 4500
 4500  continue
       errmsg = ' # reading file: '//files(nfil)
       if (files(nfil) .eq. ' ')
     $      errmsg = ' # reading from standard input'
       ilen   = istrln(errmsg)
       call echo(errmsg(1:ilen) )
       line = 'getcom_error'
       return
c end subroutine getcom
       end

       subroutine clbfun(mf,nx,xv,fv,iend)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose:  minimization function for cromer-libermann bkg
c
c arguments:
c      mf       number of points in ffit                [in]
c      nx       number of points in xv                  [in]
c      xv       vector of variables                     [in]
c      ffit     output vector to be minimized           [out]
c      iend     information tag                         [out]
c
c notes:
c   heavily overrides values in spldat
c
c see documentation and code comments for more details
c
c requires  include files:  consts.h, spline.h

       implicit none
       include 'consts.h'
       include 'spline.h'
c
c local variables
       integer   nx, mf, iend, nvtmp, i, nrpts
       integer   nqmin, nqmax, nmaxx, ipos
       double precision st, a2, a1, a0 , ex
       double precision xv(nx), fv(mf), mod
       save
c
       a0 = xv(1)
       a1 = xv(2)
       a2 = xv(3)
       st = xv(4)
       do 100 i = 1, mf
          ex   = endat(i)
          mod  = a0 + ex * (a1 + a2 * ex) + spldat(i) * st
          fv(i) = (mod - xmudat(i)) * splfit(i)
 100   continue 
       return
c end subroutine clbfun
       end

       subroutine fitfun(mf, nx, xvar, fvec, iend)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose:  feffit fitting function for lmdif1 minimization 
c
c arguments:
c      mf       number of points in ffit             [in]
c      nx       number of points in xv               [in]
c      xv       vector of variables                  [in]
c      fvec     output vector to be minimized        [out]
c      iend     information tag                      [out]
       implicit none
       include 'consts.h'
       include 'arrays.h'
       include 'keywrd.h'
       include 'fft.h'
       include 'fefdat.h'
       include 'pthpar.h'
       include 'feffit.h'
c local variables
       integer    nx, mf, iend, i,  id, isp, nx1, iter
       integer    jfit, nqdata, nfit1, nkpar, npaths
       integer    iupath(mpaths), inxx, ixx, joff, jqw
       integer   ier, iff_eval_dp
       double precision xvar(nx), fvec(mf), xolow, xohigh, bvalue
       double precision getsca, xspl(mtknot), bx, qx, sum, tmpval
       double precision xsum, sumsqr
       character  arg*2 
       integer    isarg, ilen, istrln, j, nmx
       external   bvalue, getsca,  istrln, iff_eval_dp, sumsqr
       save
c
       nkpar = 0
       id    = 1
       if (nx.ne.nvarys) iend = 1
       if (mf.ne.mfit)   iend = 2
       nx1 = nx - nbkg(id)
cc       print*, 'FITFUN N_vars:',nx,mf,nfdats
       do 20 i = 1, nx
          scalar(i) = xvar(i)
 20    continue
       call synvar
cc       print*, 'VARS ', xvar(1), xvar(2), xvar(3), xvar(4)
       if (final) rfact_total = zero
c
c  sum function to minimize over data sets
c   jfit is the counter (through all the data sets)
c   for the total number of fitting points

       jfit = 0
       do 3000 id = 1, nfdats
          nqdata = min(maxpts, max(2, nqfit(id)) + 10)
          if (ifft(id).eq.1) then
             xolow  = rmin(id)
             xohigh = rmax(id)
          else
             xolow  = qmin(id)
             xohigh = qmax(id)
          endif
          do 200 i = 1, nfit(id)*nqwfs(id)
             thifit(i)   = zero
 200      continue
c  re-initialize array for theoretical chi(k)
c  by assigning this to the background function
          do 300 i = 1, nqdata
             thiq(i, id) = zero
             thiqr(i, id) = zero
 300      continue
c
c sum over paths for theory chi for this data set
          npaths = 0
          do 400 i = 1, mpaths
             iupath(i) = 0
             if (iulist(i,id).ne.0) then
                npaths = npaths + 1
                iupath(npaths) = iulist(i,id)
             end if
 400      continue 
          call sum_paths(id, iupath, npaths, nqdata,
     $         thiqr(1,id), thiq(1,id))
c
c if refining background, include that here
          if ( bkgfit(id))  then
             do 450 isp = 1, nbkg(id)
                write(tmpstr, '(a,i2.2,a,i2.2)') 'bkg',id,'_',isp
                xspl(isp) = getsca(tmpstr,0)
cc                print*, 'FITFUN i ' , isp, xspl(isp)
 450         continue
             do 470 i = 1, nqdata
                qx = qgrid*(i-1)
                thiq(i, id) = thiq(i, id) + 
     $               bvalue(qknot(1,id), xspl, nbkg(id),korder,qx,0)
 470         continue 
          end if
c
c subtract data from theory
          do 500 i = 1, nqdata
             thiq(i,id) = thiq(i,id)-chiq(i,id)
 500      continue 
c
c loop over k-weights for multiple k-weights
c    top down, so that the first k-weight listed is done last
c
          do 1000 jqw = nqwfs(id), 1, -1
             qweigh(id) = qwfs(jqw,id)

c   take fft of theory(+bkg) - data
c   note: imag part of theory chi(k) compares to real part of data!!!
c   see ff2chi as well
             call fitfft(thiq(1,id), maxpts, maxfft, wfftc, qgrid,
     $            qwindo(1,id), qwfs(jqw,id), rwindo(1,id), one,
     $            ifft(id),modeft(id),xolow,xohigh, nfit1, thifit)

             if (nfit1.ne.nfit(id)) then
                call warn(3,' fitfun fitfft failed internal test.')
                iend = -10
             end if
c
c  evaluate the contribution to fvec for this data set.  weight scales
c  chi-square properly to the number of independent points. this is
c  important for error analysis (if chi-square is to increase by one,
c  it  must be scaled correctly.), but only in the final pass, when
c  chi-square and r-factors will be calculated.
c             print*, 'fitfun ', jfit, jqw, id,
c     $            weight(jqw, id), nfit(id), thifit(1), thifit(2)
             do 700 i =  1, nfit(id)
                fvec(jfit+i) = (thifit(i))/weight(jqw,id)
 700         continue

             jfit = jfit + nfit(id)

c construct r-factor
             if (final) then 
                call fitfft(chiq(1,id), maxpts, maxfft, wfftc, qgrid,
     $               qwindo(1,id), qwfs(jqw,id), rwindo(1,id), one, 
     $               ifft(id),modeft(id),xolow,xohigh, nfit1, chifit)
                if (nfit1.ne.nfit(id)) then
                   call warn(3,' fitfun fitfft failed internal test.')
                   iend = -10
                end if

                sum        = zero
                rfactr(id) = zero
                do 800 i = 1, nfit(id)
                   sum        = sum        + chifit(i)*chifit(i)
                   rfactr(id) = rfactr(id) + thifit(i)*thifit(i)
 800            continue
                if (sum.le.tiny) sum = tiny
                rfactr(id)  =  rfactr(id) / (sum * nqwfs(id))
                rfact_total = rfact_total + rfactr(id) 
cc                print*, ' final ', sum, rfactr(id), id, rfact_total
             end if
c
c  restraints
             if (nrestraint(id).ge.1) then
cc                print*, ' RESTRAINT ', nrestraint(id), id, jfit
                do 900 i =  1, nrestraint(id)
                   if ( (restraint(i,id) .ne. undef).and.
     $                  (restraint(i,id) .ne. '')) then 
                      ier    = iff_eval_dp(restraint(i,id),tmpval)
                      if (ier.eq.0) then
                         jfit   = jfit + 1
                         fvec(jfit) = tmpval
cc                         print*, ' t: ', tmpval, jfit, ier
                      endif
                   endif
 900            continue
             endif
 1000     continue   ! end loop over k-weights
cc          print*, ' end of ndata loop  ', id, nfit(id), jfit
 3000  continue      ! end loop over data sets

       if (final) rfact_total = rfact_total / max(1,nfdats)

c
c execute user-defined macro
       iter  =  int(getsca('&fit_iteration',0))
       if (iter.gt.itera) then
          itera = iter
          xsum = sumsqr(fvec,jfit)
cc          print*, ' iteration ', iter, mf,mfit,jfit,nfdats, xsum
          if (ifit_mac.gt.0) then
             call iff_macro_do(ifit_mac, fit_m_arg, 0,.false.)
          end if

       end if
       return
c end subroutine fitfun
       end

       subroutine iff_bkg_cl(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: ifeffit pre-edge subtraction, normalization and exafs
c          extraction based on CL f'' data
c
c arguments:
c      str     command line to performd                 [in]
c
c 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'spline.h'
       save
       character*(*)   str, defkey(3)*64
       character*256   path, name1
       character*256   xmuarr, en_arr, prearr, norarr
       integer         lenwrk, lminfo, mxvars
       parameter  (mxvars=5)
       parameter  (lenwrk = (mxvars+1)*maxpts + 5*mxvars)
       double precision  work(lenwrk), fv(maxpts), varys(mxvars)
       double precision  arr_f1(maxpts),arr_f2(maxpts),tmpar2(maxpts)
       integer           iwork(mxvars), nvarys
       double precision  pre1, pre2, enor1, enor2, toler
       double precision  slope, offset, cnorm(3)
       double precision  ewid, a0, a1, a2, st,ex
       double precision  e0_dt, es_dt, ps_dt, po_dt, estep
       double precision  wgt_pre, wgt_xan, wgt_exa, qmax, xtmp
       logical   stfind, eefind, is_kev

       integer   jen, jxmu, ier, i, k, istrln, jdot, j
       integer   ndfkey, npts_e, npts_x, nnorm, iz, ilen
       integer   clcalc,  iret, npts_k, ipos, iterp
       integer   ne0, npts_t
       integer   iff_eval, iff_eval_dp, iff_eval_in, sort_xy
       external  iff_eval, iff_eval_dp, iff_eval_in, clcalc
       external  istrln, clbfun, sort_xy
c
c get default values for pre-edge parameters from current scalar values
       call iff_sync
       eefind = .false.
       stfind = .true.
       is_kev = .false.
       estep  = one
       iz     = 0 
       e0     = 0 
       step   = 0 
       pre1   = 0 
       pre2   = 0 
       enor1  = 0 
       enor2  = 0 
       slope  = 0 
       offset = 0 
       nnorm  = 3
       ewid   = 5.d-1
       wgt_pre= 1.d1
       wgt_exa= 1.d0
       wgt_xan= 1.d-4
       iterp  = 2
       name1  = undef
       call gettxt('group', name1)
       call bkeys(str, mkeys, keys, values, nkeys)
       
c set default keywords for "undefined" sets
c ie: the first two unkeyed values will take keys 'energy', 'xmu'
       ndfkey    = 3
       defkey(1) = 'energy'
       defkey(2) = 'xmu'
       defkey(3) = 'z'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if ((keys(i).eq.'iz').or.(keys(i).eq.'z'))  then
             ier = iff_eval_in(values(i),iz)
          elseif ((keys(i).eq.'ee').or.(keys(i).eq.'e0'))  then
             ier = iff_eval_dp(values(i),e0)
             eefind = eefind .or. (values(i)(1:1).eq.'?')
          elseif (keys(i).eq.'width') then
             call str2dp(values(i),ewid, ier)
          elseif (keys(i).eq.'group') then
             name1 = values(i)
          elseif (keys(i).eq.'pre1') then
             ier = iff_eval_dp(values(i),pre1)
          elseif (keys(i).eq.'pre2') then
             ier = iff_eval_dp(values(i),pre2)
          elseif (keys(i).eq.'norm1') then
             ier = iff_eval_dp(values(i),enor1)
          elseif (keys(i).eq.'norm2') then
             ier = iff_eval_dp(values(i),enor2)
          elseif (keys(i).eq.'norm_order') then
             ier = iff_eval_in(values(i), nnorm)
          elseif (keys(i).eq.'interp') then
             iterp = 2
          elseif (keys(i).eq.'edge_step') then
             ier = iff_eval_dp(values(i),step)
             stfind = .false.
          elseif (keys(i).eq.'is_kev') then
             call str2lg(values(i),is_kev, ier)
          elseif ((keys(i).eq.'find_e0').or.
     $            (keys(i).eq.'e0find')) then
             call str2lg(values(i),eefind,ier) 
          elseif (keys(i).eq.'energy') then
             en_arr = values(i)
             call lower(en_arr)
          elseif (keys(i).eq.'xmu') then
             xmuarr = values(i)
             call lower(xmuarr)
          else
             messg = keys(i)(1:k)//' " will be ignored'
             call warn(1,' *** bkg_cl: unknown keyword " '//messg)
          end if
 100   continue
c
c get/resolve array names
       if (name1.eq.undef) then
          jdot = index(xmuarr,'.')
          if (jdot.ne.0) name1 = xmuarr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          jdot = index(en_arr,'.')
          if (jdot.ne.0) name1 = en_arr(1:jdot-1)
       endif
       if (name1.eq.undef) then
          call warn(2,' bkg_cl: can''t determine group name')
          return             
       endif
       call fixnam(name1,1)
       call lower(name1)
       npts_e = maxpts
       npts_x = maxpts
       jdot   = istrln(name1)
       jen    = iff_eval(en_arr, name1, endat,  npts_e)
       jxmu   = iff_eval(xmuarr, name1, xmudat, npts_x)

       if (jen.le.0) then
          call warn(2,' bkg_cl: no energy array?')
          return
       elseif(jxmu.le.0) then
          call warn(2,' bkg_cl: no xmu array?')
          return
       end if
c
       do 25 i = 1, npts_e
          arr_f1(i) = zero
          arr_f2(i) = zero
 25    continue 
c
c require that endat be monotonically increasing: if not, sort it
       ier =  sort_xy(endat, xmudat, npts_e, tiny)
       if (ier .eq. 1) then 
          call warn(1,' bkg_cl:   energy data appears out of order')
       endif
c if obvious, or explicitly stated, switch KeV to eV:
       if (is_kev .or.
     $      ((endat(1).le.90).and.(endat(npts_e).le.90))) then
          call warn(1,' bkg_cl:   energy data appears to be in keV')
          call kev2ev(endat, npts_e)
       endif

c call preedg for data, just to get internal e0 value
cc       print*,  ' in bkg_cl before preedg call: ', eefind, e0
       eefind = .true.
       call preedg(eefind, stfind, npts_x, endat, xmudat,
     $      e0, pre1, pre2, enor1, enor2, nnorm,
     $      step,slope,offset,cnorm)
       e0_dt = e0
       es_dt = step
       ps_dt = slope
       po_dt = offset
c
c call clcalc
       call gettxt('&install_dir', path)
       ilen = istrln(path)
       path = path(1:ilen)//'/cldata/'
       iret = clcalc(iz, path, npts_e, endat, arr_f1, arr_f2)
       estep= one
       call conv_lor(ewid, npts_e, endat, arr_f2, estep, spldat)
       eefind = .true.
       call preedg(eefind, stfind, npts_x, endat, spldat,
     $      e0, pre1, pre2, enor1, enor2, nnorm,
     $      step,slope,offset,cnorm)
       varys(1) = zero
       varys(2) = zero
       varys(3) = zero
       varys(4) = es_dt/(step+0.01d0)
c
c  make weighting factor
       do 200 i = 1, npts_x
          a0   = wgt_exa
          if (endat(i) .lt. e0_dt)           a0 = wgt_pre
          if (abs(endat(i) - e0_dt).le.50d0) a0 = wgt_xan
          splfit(i) = a0
 200   continue 
       
       nvarys   = 4
       lminfo   = 0
       do 210 i = 1, npts_e
          fv(i) = zero
 210   continue
       do 220 i = 1, lenwrk
          work(i) = zero
 220   continue
       do 230 i = 1, mxvars
          iwork(i) = 0
 230   continue 
       toler = 1.d-5
       call lmdif1 (clbfun, npts_e, nvarys, varys, fv,
     $      toler, lminfo, iwork, work, lenwrk)

c
c  make array of pre-edge subtracted data
c  $group.pre: output (ensuring that it doesn't overwrite xmu!)
       a0 = varys(1)
       a1 = varys(2)
       a2 = varys(3)
       st = varys(4)
       do 730 i = 1, npts_x
          tmparr(i) = a0 + endat(i)*(a1 + a2*endat(i)) + spldat(i)*st
 730   continue 
c
c  finally, call preedg on modified f" data, extending
c  the normalization range out in energy
       eefind = .true.
       a0     = -e0 + (enor2 + e0 + endat(npts_x)) / 2

       call preedg(eefind, stfind, npts_x, endat, tmparr,
     $      e0, pre1, pre2, enor1, a0, nnorm,
     $      step,slope,offset,cnorm)

c  make pre-edge subtracted data and pre-edge subtracted f"
       do 760 i = 1, npts_x
          ex        = po_dt + endat(i) * ps_dt
          xmudat(i) = xmudat(i) - ex 
          tmpar2(i) = xmudat(i)/step
          spldat(i) = tmparr(i) - ex
          splfit(i) = spldat(i)/step
 760   continue 

       prearr = name1(1:jdot)//'.pre'
       norarr = name1(1:jdot)//'.norm'
       call set_array(prearr, name1, xmudat, npts_x, 1)
       call set_array(norarr, name1, tmpar2, npts_x, 1)

       prearr = name1(1:jdot)//'.f2'
       call set_array(prearr, name1, tmparr, npts_x, 1)
       prearr = name1(1:jdot)//'.f2pre'
       norarr = name1(1:jdot)//'.f2norm'
       call set_array(prearr, name1, spldat, npts_x, 1)
       call set_array(norarr, name1, splfit, npts_x, 1)

c
c create chi(k) from this background
c
c tmparr holds q(E_i), tmpar2 holds chi(E_i)
       do 900 i = 1, npts_x
          tmpar2(i) =(xmudat(i) - spldat(i)) / step
 900   continue 

       call chie2k(endat, tmpar2, npts_x, e0_dt, 
     $      npts_k, arr_f1, arr_f2)

       call set_array('k',   name1, arr_f1,  npts_k, 1)
       call set_array('chi', name1, arr_f2,  npts_k, 1)

c reset the program variables
       call setsca('e0',         e0_dt)
       call setsca('edge_step',  step)
       call setsca('pre1',       pre1)
       call setsca('pre2',       pre2)
       call setsca('norm1',      enor1)
       call setsca('norm2',      enor2)
       call setsca('pre_slope',  slope)
       call setsca('pre_offset', offset)
       call setsca('norm_c0',    cnorm(1))
       call setsca('norm_c1',    cnorm(2))
       call setsca('norm_c2',    cnorm(3))
       call settxt('group',      name1)
       return
c end  subroutine iff_bkg_cl
       end

       subroutine chie2k(en, chie, ne, e0,  nk,xk,chik)
c
       include 'consts.h'
       integer          ne, nkmax, nk, i, j, ne0, nt
       double precision en(*), chie(*), xk(*), chik(*)
       double precision e0,  qmax
       double precision tx(maxpts), ty(maxpts)
       integer   nofxa
       external  nofxa
       ne0 = nofxa(e0, en, ne)

c       print*, 'chie2k ne, ne0 ', ne, ne0
       j = 0
       do 10 i = ne0, ne
          if (en(i) .ge. e0) then
             j = j + 1
             tx(j)  = sqrt(etok * abs(en(i)-e0))
             ty(j)  = chie(i)
          endif
 10   continue 
       nt   = j
       qmax = tx(nt)
       nk   = min(maxpts, int((qmax + 1.d-2) /qgrid))
c       print*, 'chie2k x,y ', tx(1), tx(2), ty(1), ty(2)
c       print*, 'chie2k nk = ',nk
       do 20 i = 1, nk
          xk(i) = (i-1) * qgrid
 20    continue
       call grid_interp(tx, ty, nt, zero, qgrid, nk, chik)
       return
       end

       subroutine iff_config
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c initialize ifeffit
       implicit none
       include 'consts.h'
       include 'arrays.h'
       include 'encod.h'
       include 'fefdat.h'
       include 'fft.h'
       include 'keywrd.h'
       include 'pthpar.h'
       include 'spline.h'
       include 'echo.h'
       include 'feffit.h'
       save
       integer i, j, ilen, istrln, nwords
       character*128 build, envvar*32, pgdev*16, words(2)
       character*256 envval, sysdir
       character*512 inifile, sfile
       double precision x
       logical exist
       external istrln
c
       envval = ''
       sysdir = ''
       sfile  = ''
       build  = ''

       include 'com.h'
       include 'sys.h'
c
c----------------------------------------------------------------
c system build information, and setting of 'environmental variables'
c
c pre-load a few general floating point scalars
       x = maxpts * 1.d0
       call setsca( '&maxpts',   x)
       x = maxheap_array * 1.d0
       call setsca( '&heap_free',  x)

       call setsca( '&max_scalars',   maxsca*1.d0)
       call setsca( '&max_arrays',    maxarr*1.d0)
       call setsca( '&max_strings',   maxtxt*1.d0)
       call setsca( '&max_paths',     mpaths*1.d0)
       call setsca( '&max_varys',     mvarys*1.d0)
       call setsca( '&max_data_sets', mdata*1.d0)
       call setsca( '&max_output_cols', max_outarr*1.d0)
       call setsca( '&max_iteration', 250.d0)

       call setsca( '&n_scalars',     zero)
       call setsca( '&n_arrays',      zero)
       call setsca( '&n_strings ',    zero)
       call setsca( '&n_guess',       zero)
       call setsca( '&n_scalars_set', zero)
       call setsca( '&n_scalars_def', zero)
       call setsca( '&n_arrays_set',  zero)
       call setsca( '&n_arrays_def',  zero)
       call setsca( '&print_level',   zero)
       call setsca( '&pause_ignore',  zero)
       call setsca( '&echo_lines',    zero)
       call setsca( '&screen_echo',   zero)
       call setsca( '&sync_level',    4.d0)
       call setsca( '&status', zero )

       call setsca( 'pi', pi)
       call setsca( 'etok', etok)
       call setsca( 'correl_min',  0.05d0)


       call settxt('plot_xlabel', ' ')
       call settxt('plot_ylabel', ' ')
       call settxt('plot_label', ' ')
       call settxt('plot_title', ' ')
c
c default file and array names
       call settxt( 'group',       'my')
       call settxt( 'commentchar', '#')

       call settxt( '&build ', build)
c
c Environmental Variable IFEFFIT_DIR -> Program Variable &install_dir 
c which can overwrite location of data and startup files
       envvar = 'IFEFFIT_DIR'
       ilen   = istrln(envvar)
       call getenv(envvar(1:ilen), envval)
       call triml(envval)
       call sclean(envval)
       ilen   = istrln(envval)
       if (ilen.gt.1)  sysdir = envval
       call settxt('&install_dir', sysdir)

       envvar = 'PGPLOT_DEV'
       ilen   = istrln(envvar)
       call getenv(envvar(1:ilen), envval)
       call triml(envval)
       call sclean(envval)
       ilen   = istrln(envval)
       if (ilen.gt.1)  pgdev = envval
       call settxt('plot_device', pgdev)
c
c load system and personal startup files, if found
       nwords = 2
       words(1)=''
       words(2)=''
       call bwords(inifile, nwords, words)

       if ((sysdir.ne.'').and.(istrln(words(1)).ge.2)) then
          i = istrln(sysdir)
          j = istrln(words(1))
          sfile  = sysdir(1:i)//'/'//words(1)(:j)
          inquire(file = sfile, exist=exist)
          if (exist)  then
             i = istrln(sfile)
             sfile = '"'//sfile(1:i)//'"'
             call iff_load(sfile)
          endif
       endif
c
c load user startup file, if found
       envvar = 'HOME'
       ilen = istrln(envvar)
       call getenv(envvar(1:ilen), sysdir)
       if (sysdir.eq.'') then
          call gettxt('&install_dir', sysdir)
       endif

       if ((sysdir.ne.'').and.(istrln(words(2)).ge.2)) then
          i = istrln(sysdir)
          j = istrln(words(2))
          sfile = sysdir(1:i)//'/'//words(2)(:j)
          inquire(file = sfile, exist=exist)
          if (exist)  then
             i = istrln(sfile)
             sfile = '"'//sfile(1:i)//'"'
             call iff_load(sfile)
          endif
       endif
       return
       end

       subroutine splfun(mf,nx,xv,ffit,iend)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose:  evaluate spline function for lmdif1 minimization a la autobk
c
c arguments:
c      mf       number of points in ffit                [in]
c      nx       number of points in xv                  [in]
c      xv       vector of variables                     [in]
c      ffit     output vector to be minimized           [out]
c      iend     information tag                         [out]
c
c notes:
c   1. see subroutine lmdif1
c   1. see subroutine spline 
c   2. this evaluates the difference between the fft of theory and 
c      post-background-subtraction chi data for changing b-spline
c      coefficients, e0, and possibly multi-electron stuff.
c   3. based on/related to suroutine autnls from autobk
c
c see documentation and code comments for more details
c
c requires  include files:  consts.h, spline.h, fft.h
c           qintrp, lintrp, fitfft, bvalue, sumsqr
c
       implicit none
       include 'consts.h'
       include 'spline.h'
       include 'fft.h'
c
c local variables
       integer   nx, mf, iend, nvtmp, i, nrpts, ifit, j
       integer   nqmin, nqmax, nmaxx, ipos, nofx
       double precision   small, half, widmin
       parameter (half = 0.5d0, small = 1.d-10, widmin = 0.5d0)
       double precision xv(nx), ffit(mf), qtmp(maxpts), tmpfit(maxpts)
       double precision chiq(maxpts), qtt, e0t, bvalue
       double precision resid, tresid, sumsqr, t, fclamp
       external  bvalue, sumsqr,nofx
       save
c
       if (nx.ne.nautbk) iend = 1
       if (theory.and.(mf.ne.nr1st)) iend = 2
       if (.not.theory.and.(mf.ne.nrbkg))  iend = 3
       ifit   = 0
       nvtmp  = nx
       e0t    = e0
cc       print*, 'SPLFUN ', mf, nrbkg, nx, nsplin
cc       print*, xv
c
c  unwrap list of possible variables:
c     the last on the list from autnls is the first off
       if (theory.and.eevary) then
          thebkg = xv(nvtmp)
          de0    = xv(nvtmp)
          nvtmp  = nvtmp - 2
       end if
       if (nvtmp.ne.nsplin) iend = 3
c
c  e0 shift to temporary q-array for interpolation, evaluate the spline 
c  and calculate chi(E).
c         if normalizing by the functional form of the 
c        spline, make sure you're not dividing by zero.  
       e0t   = e0 + de0
cc       print*, ' splfun:  ', mf, e0, e0t, de0, nxmu
       do 200 i = 1, nxmu
          qtmp(i)   =  sqrt(etok * abs(endat(i)-e0t) )
          if (endat(i).lt.e0t)   qtmp(i) = - qtmp(i)
          if ( (endat(i).le.emax).and.(endat(i).ge.emin) ) then
             spldat(i)=bvalue(eknot,xv,nsplin,korder,endat(i),0)
             chie(i)   = ( xmudat(i) - spldat(i) ) / step
             if (funnrm)
     $            chie(i) = ( xmudat(i) /max(spldat(i), small)) - one
          else
             chie(i)   = zero
          end if
 200   continue
c  get qmax and qmin
       nqmin = int( sqrt( etok* abs(emin - e0t) ) / qgrid )
       nqmax = int( sqrt( etok* abs(emax - e0t) ) / qgrid )
       if ((emin.lt.e0t).or.(nqmin.lt.1))     nqmin = 1
c  interpolate chiq to q grid, evaluate data chi(k) [chiq]
       nmaxx  = min(maxpts, nqmax + 20)
       ipos   = 1
       call grid_interp(qtmp, chie, nxmu, zero, qgrid, nmaxx, chiq)
c
c get real and imaginary parts of the fft of chiq, put them in tmpfit
       call fitfft(chiq, maxpts, maxfft, wfftc, qgrid,
     $      splwin, splqw, spldat, one, 1, 0, zero, r1st,
     $      nrpts, tmpfit)
c
       if (theory.and.(.not.thefix))
     $      thebkg = sumsqr(tmpfit(nrbkg),nr1st) / thessq
       do 550 i = 1, nrbkg
          ffit(i) = tmpfit(i) - splfit(i) * thebkg
 550   continue
       ifit = nrbkg
       if (theory.and.eevary) then
          do 560 i = nrbkg+1, nr1st
             ffit(i) = (tmpfit(i) - splfit(i)*thebkg) / 10.0
 560      continue 
          ifit = nr1st
       endif
c
c clamp first 4 chie() data points towards zero
       tresid = sumsqr(ffit,ifit)
cc       print*, 'end of splfun ' ,  tresid
       if (clamp(1)) then
          j = max(1,nofx(emin,endat,nxmu))
c
c scale clamp strength to residual, so that clamp strength is
c roughly 'percent importance' in fit.
c note '1+int(tresid)' here. this is to assure the scale is
c not zero, but also should make the scale factor settle down
c to a single number so that it does not affect the fitting
c time too much.
          fclamp = sclamp(1)*(1+int(tresid*100.d0)/nrbkg)/nclamp
          do 620 i = 1, nclamp
             ffit(i+ifit) = chie(i+j-1) * fclamp
cc             print*, i, ffit(i+ifit)
 620      continue 
          ifit = ifit + nclamp
       endif
c clamp last 4 chie() data points towards zero
       if (clamp(2)) then
          j = min(nxmu,max(1,nofx(emax,endat,nxmu)))
          fclamp = sclamp(2)*(1+int(tresid*100.d0)/nrbkg)/nclamp
c          print*, ' splfun clamp 2 at j=',j, endat(j),
c     $         emax, sclamp(2), fclamp
          do 630 i = 1, nclamp
             ffit(i+ifit) = chie(j + 1 - i) * fclamp
 630      continue 
          ifit = ifit + nclamp
       endif
cc       t= sumsqr(ffit,ifit)
cc       print*, 'end of splfun ' ,  tresid, t, ifit, nrbkg
       return
c end subroutine splfun
       end

       subroutine iff_echo(string,ipause)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: print string, optionally waiting for user input
c
c arguments:
c      string  line to write as message               [in]
c      ipause  integer flag for pausing (1=pause)     [in]
c
c   1. for 'pause' mode, the default message (ie when string='')
c          is ' -- hit return to continue -- '
c   2. uses  non-standard format(1x,a,$) statement
c
c requires: istrln, undels, echo, chrdmp
       implicit none
       character*(*)  string, str*256, c*1, msgdef*64
       parameter (msgdef = ' --  hit return to continue -- ')
       double precision getsca
       integer ilen, istrln, ipause, i_ec, i_pa
       external istrln,  getsca
c
       c   = ' '
       str = string
       call undels(str)
       call triml(str)
       i_ec = int(getsca('&screen_echo',0))
       i_pa = int(getsca('&pause_ignore',0))
       if ((i_ec.eq.1).and.(i_pa.eq.0).and.(ipause.eq.1)) then 
          if (str.eq.' ') str = msgdef
          ilen = istrln(str)
          call chrdmp(str(1:ilen))
          read(*,'(a)') c
       else
          ilen = max(1,istrln(str))
          call echo(' '//str(1:ilen))
       end if
       return
       end

       subroutine iff_ff2chi(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c given a list of paths, create a chi(k) 
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fefdat.h'
       include 'feffit.h'
       include 'pthpar.h'
       save
       
       character*(*) str
       character*256  name1, namex, list*1024
       integer  idata, irec, istrln, k, j, i, ier, illen
       integer  nxpath,  jk, iupath(mpaths), u2ipth
       integer  nkpts, nkmin, nkmax, nlqpts, iup
       integer  ipath_tmp(max_pathindex)
       double precision  xkmin, xkmax, s02, sigma2
       double precision  aix(maxpts),  arx(maxpts)
       logical  do_pha, do_mag, do_re, isnum
       integer  iff_eval, iff_eval_dp, iff_eval_in
       external iff_eval, iff_eval_dp, iff_eval_in

       external istrln, u2ipth, isnum

       do 10 i = 1, mpthpr
          param(i) = zero
 10    continue

c  interpret any and all keyword/value pairs for setting options
       call bkeys(str, mkeys, keys, values, nkeys)
       idata  =  1
       irec   =  0
       nxpath =  0
       illen  =  1
       list   =  ' '
       name1  =  'feff'
       xkmin  = zero
       xkmax  = 20 * one
       do_re  = .false.
       do_mag = .false.
       do_pha = .false.
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((keys(i).eq.'prefix').or.(keys(i).eq.'group')) then 
             name1 = values(i)
             call smcase(name1,'a')
          elseif ((keys(i).eq.'kmax')) then
             ier = iff_eval_dp(values(i), xkmax)
          elseif ((keys(i).eq.'kmin')) then
             ier = iff_eval_dp(values(i), xkmin)
          elseif ((keys(i).eq.'s02')) then
             ier = iff_eval_dp(values(i), s02)
          elseif ((keys(i).eq.'sigma2')) then
             ier = iff_eval_dp(values(i), sigma2)
          elseif ((keys(i).eq.'data_set')) then
             ier = iff_eval_in(values(i), idata)
          elseif ((keys(i).eq.'do_real')) then
             call str2lg(values(i), do_re, ier)
          elseif ((keys(i).eq.'do_mag')) then
             call str2lg(values(i), do_mag, ier)
          elseif ((keys(i).eq.'no_mag')) then
             call str2lg(values(i), do_mag, ier)
             do_mag = .not. do_mag
          elseif ((keys(i).eq.'do_phase')) then
             call str2lg(values(i), do_pha, ier)
          elseif ((keys(i).eq.'no_phase')) then
             call str2lg(values(i), do_pha, ier)
             do_pha = .not. do_pha
          elseif ((keys(i).eq.'do_all')) then
             call str2lg(values(i), do_re, ier)
             do_mag = do_re
             do_pha = do_re
          elseif (values(i).eq.undef) then
             call str2il(keys(i), max_pathindex, nxpath,ipath_tmp,ier)
             if (ier.eq.0) then 
                jk    = istrln(keys(i))
                list  = list(1:illen)//keys(i)(1:jk)//','
                illen = illen+jk+1
             else
                call warn(2,' *** ff2chi: error generating path list')
                call warn(2, keys(i)(1:k))
             end if
          else
             call warn(1,' *** ff2chi: unknown key: '//keys(i)(1:k))
          end if
 100   continue 
c
c convert list of indices to l_paths
       call str2il(list(1:illen), max_pathindex,nxpath,ipath_tmp,ier)
       do i = 1, mpaths
          iupath(i) = 0
       enddo
       iup= 0

       do 120 i = 1, nxpath
          if (u2ipth(ipath_tmp(i)).ge.1) then
             iup=iup+1
             iupath(iup) = ipath_tmp(i)
          endif
 120   continue 
       nxpath= iup

c read the needed feff arrays
       call fefinp
c
c synchronize the math expressions
       call iff_sync
c
c calculate number of k-points

       nkmin = (xkmin / qgrid)
       nkmax = (xkmax / qgrid)
       nkpts = nkmax - nkmin + 1
       nlqpts= nkmax + 10

cc       print*, 'ff2chi: nkmin,nkmax, nkpts, nlqpts'
cc       print*, nkmin,nkmax, nkpts, nlqpts
c
c  do sum over paths (note : iupath is held in common /fitint/)

       call sum_paths(idata, iupath, nxpath, nlqpts, arx, aix)
c       
c done with sum over paths
c save arrays to Program Variables
c--k
       do 200 i = 1, nlqpts
          tmparr(i) = qgrid * (i + nkmin - 1)
 200   continue 
       call set_array('k',   name1, tmparr(1+nkmin), nkpts, 1)
       call set_array('chi', name1, aix(1+nkmin),  nkpts, 1)
c
c--chi_real
       if (do_re) then
          call set_array('chi_real', name1, arx(1+nkmin), nkpts, 1)
       end if
c--chi_mag
       if (do_mag) then
          do 240 i = 1, nlqpts
             tmparr(i) = sqrt ( arx(i)**2 + aix(i)**2 )
 240      continue 
         call set_array('chi_mag', name1, tmparr(1+nkmin), nkpts, 1)
       end if
c--chi_phase
       if (do_pha) then
          do 280 i = 1, nlqpts
             tmparr(i) =  atan2( aix(i), arx(i))
             if (i.gt.1)  call pijump( tmparr(i), tmparr(i-1))
 280      continue 
          call set_array('chi_phase', name1, tmparr(1+nkmin),nkpts,1)
       end if
c
c done
       return
       end

       subroutine iff_history(str)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c manage history of commands for ifeffit
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       save
       character*(*) str, argu*256, defkey(2)*64
       integer  i, ndfkey, k, istrln
       external istrln
       argu = str
c
       call bkeys(str, mkeys, keys, values, nkeys)
       ndfkey    = 1
       defkey(1) = 'file'
       do 100 i = 1, nkeys
          k = istrln( keys(i))
          if ((values(i).eq.undef).and.(keys(i).ne.'off')
     $         .and.(i.le.ndfkey)) then
             values(i) = keys(i)
             keys(i)   = defkey(i)
          end if
          if (keys(i).eq.'off') then
             close(iohist)
             histry = .false.
             call settxt('historyfile',' ')
          elseif (keys(i).eq.'file') then
             tmpstr = values(i)
             call settxt('historyfile',tmpstr)
             call newfil(tmpstr, iohist)
             histry = .true.
             if (iohist.le.0) then
                call warn(3,'bad open of history file')
                histry = .false.
             end if
          elseif (histry)  then
             call gettxt('historyfile',tmpstr)
             messg = ' history file = ' // tmpstr
             call echo(messg)
          else
             call echo(' history is off')
          end if
 100   continue 
       tmpstr = ' '
       return
       end

       program feffit
c
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c ---  program feffit
c
c  author   Matthew Newville
c  post     GSECARS, Bldg 434A
c           APS, Argonne National Laboratory
c           Argonne, IL 64309 USA
c  voice    (630) 252-0431
c  fax      (630) 252-0443
c  e-mail   newville@cars.uchicago.edu
c  web      http://cars.uchicago.edu/~newville/feffit/
c
c  version  feffit 2.981
c  update   25-apr-2003
c
c --- copyright 2002,2003  matt newville
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
c  feffit will fit the results of a feff (5 and higher) calculation
c  to xafs chi(k) data, allowing parameters in the xafs equation to
c  vary until the least-squares difference between data and theory
c  is minimized.  principle features of feffit are:
c    -  fitting can be done in r-space or backtransformed k-space.
c    -  the xafs equation is evaluated as a sum over paths.
c    -  physical parameters for each path can be easily constrained.
c       the user writes math expressions for these parameters in
c       terms of user-chosen variables which are used in the fit.
c    -  error analysis is done, giving an estimate for the
c       uncertainties in the fit variables, the correlations
c       between these variables, and the goodness-of-fit.
c
c  feffit uses the following inputs:
c      1. an input file named feffit.inp.
c      2. a set of feffnnnn.dat files from feff (5 or higher),
c         for the xafs contribution from a scattering path.
c      3. chi(k) data, which can be in either a uwxafs 'chi' file
c         or an ascii column file.
c  see documentation for further details.
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c version notes:
c     vax versions differ from standard versions by:
c     1. irecl = 128 (standard irecl = 512) for uwxafs binary files
c     2. output log files are opened with status = 'new'
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c major revisions (for a complete revision record, contact matt) :
c    feffit 2.01 july 28 1993 (fit multiple data sets)
c    feffit 2.05 jan  19 1994 ("local"s added, many minor fixes)
c    feffit 2.10 may  15 1994 (added bkg spline option)
c    feffit 2.20 june  1 1994 (fixed bug in uncertainties)
c    feffit 2.30 nov  17 1994 (added fitting in q-space)
c    feffit 2.31 dec   4 1994
c    feffit 2.32 dec  12 1994 (added routine testrf)
c    feffit 2.33 may  10 1995 (added flag for tranquada correction)
c       - minor debugging for g77
c       - fixed rfact
c    feffit 2.34 june  3 1995 (altered inpdat, inpcol, and testrf)
c       - made to accept less strict formatting of ascii data
c    feffit 2.35 june  4 1995 (add constant phase shift)
c       - altered all path parameter handling, using "pointers"
c    feffit 2.36 june 16 1995 (add rm2fg flag)
c       -  to use {reff}^{-2} in xafs eq. instead of {reff+delr}^{-2}
c    feffit 2.37 june 22 1995 (added fixicd, rearranged decoding)
c       -  added routine fixicd to sort integer icodes, so that
c          variables come first, then trivial constants, then locals,
c          and finally the user-defined functions, ordered so that
c          they can be stably determined in one pass.  also altered the
c          handling of local "set" values so that the icdval array
c          holds the pointer to which expression to evaluate.
c   2.38 june 22 1995 (adding derived uncertainties in
c                        used defined functions and path params)
c        .f july 10  changed tranquada correction to integer flag
c        .g july 18  changed tranquada correction to real factor
c   2.39a 31-july-95 altered calculation of the number of
c                    independent points.  now considers amount of
c                    information to be a non-integer, and uses
c                    simple (2/pi) * dk * dr + 2 .
c       b 03-aug-95  fixed serious problem of not resetting
c                    values of xguess after reordering the
c                    variables and "set" values.  easy fix.
c   2.40a 17-aug-95  changed chipth, so that now, as in feff,
c                        p = Re(p) + i / lambda
c                    (was using a "-" before!).
c                    this turned out to be very important for
c                    large disorder!!!!
c       b 27-aug     changed default rm2flag to .false.
c   2.41a 04-oct-95  changed bkgfile to subtract bkg from data
c   2.41b 06-oct-95  altered fftfit to prevent access violation
c                    of qgrid on call to fftout
c   2.42  08-oct-95  added flag "kfull" to write out the full
c                    complex chi(k) (real and imag) for the
c                    theory, without doing 2 fourier tranforms
c                    (not well tested with uwxafs files yet)
c   2.42b 07-may-96  altered outcol & outdat (and xfsout) to
c                    allow arbirtary comment character and
c                    a fixed number of doc lines
c   2.45  31-may-96  added logical flags "pcfit" and "pcout" to
c                    fit and write outputs for phase corrected
c                    FT.  This will use the phase dependence of
c                    the first feffnnnn.dat file,  to alter the
c                    complex chi(k) to be
c                       chi(k)_pc = chi(k) * exp(-i * phase(k))
c                    where phase(k) is the total phase from the
c                    feffnnnn.dat file (col 2 + col 4).
c   2.45b 07-Jun-96  several minor cosmetic changes, including
c                    commenting out all "dafs" references, and
c                    improving and moving around some error
c                    checking and messages.
c   2.45c 18-Jul-96  altered output statements in fitck2
c   2.45d 05-Aug-96  use juser for output path file name,
c                    added routine setsys to set system flags
c   2.45e 07-Aug-96  fixed error in q-space fitting
c                    (number of fit points was incorrect!!)
c   2.46  02-oct-96  chipth made more efficient, dafs removed 
c   2.46b 10-oct-96  added routine fixstr for strings in fitinp,
c                    removed all traces of dafs, changed some 
c                    error messages, and changed toler
c   2.46c 11-oct-96  added routine finmsg to
c                    deal with error messages from fitinp
c   2.50   11-dec-96 added support for feff.bin files written by
c                    feff702m (matt's asci feff.bin file)
c   2.51   16-may-97 ft window arrays now calculated once (in fitdat) 
c                    and stored for use in xafsft. altered routines 
c                    fitfft, xafsft, xfsout, fitout, fitnls, fitfun
c   2.52   20-aug-97 several minor changes for ifeffit compatibility
c       b  16-dec-97 re-implemented "min" and "max" functions!
c       c  17-dec-97 increased sizes for math parsing:
c                       maxval in encod.f   ->  128
c                       micode in const.h   ->   50
c                       strings in fitinp.f -> *128
c       d  06-jan-98 fixed initialization of iunit array in getcom, 
c                    which was preventing include files from working
c       e  13-mar-98 fixed bug introduced in 2.52 for determining feff
c                    path to use for phase-correction. "pcout=t,pcfit=f"
c                    now verified to work.
c       f  25-jun-98 fixed bug in xafsft allowing 0**0.
c       g  26-jun-98 increased line lengths to 128 characters many places, 
c                    and to 256 in others.  128 char lines in feffit.inp
c                    should now always work.  Also increased micode 
c                    and several other params in encod and friends to
c                    allow many more math  expressions. Increased max 
c                    number of paths (mpaths and mdpths) to 512.  
c       h  03-mar-99 fixed bug in fitout naming scheme that could cause
c                    outputs to be written to standard output.
c   2.53   10-mar-99 altered 'nfit' in fitfun for k-space fits to be 
c                    2x number of points.  This effectively makes the 
c                    'real' component of chi(k) 0.00.
c                    -- added 'fit_space' keyword which takes the values
c                       'k', 'r', or 'q'.
c   2.54   06-apr-99 made several alteration to encod and friends to
c                    allow 256-element math expressions (possibly more)
c                    added (but commented out) rpndmp to dump the rpn 
c                    code to screen.
c   2.54   06-apr-99 made several alteration to encod and friends to
c   2.55   07-feb-02 fix parse error for min() and max() functions. 
c   2.97   05-mar-02 included in ifeffit
c   2.98   18-sep-02 fixed bug in fixicd making 'debye(20,20)' look like
c                    a constant so that set parameters and path params
c                    depending on this value were not always updated.
c   2.983  08-oct-03 use get_inpfile for command-line input file name
c----------------------------------------------------------------------
       include 'fitcom.h'
c  local variables
       character*10 systm
       integer    il, istrln
       external   istrln
cc       data systm /'unix'/
       data systm /'unix'/
c system options:  'unix','vax','dos','mac'
       call sca_init
       call echo_init
       call open_echofile('feffit.run')
       call fstop_init('feffit.err')

       call setsys(systm,vaxflg,dosflg,macflg)
c version & date
       il    = max (1,istrln(systm))
       versn = '  feffit 2.984 10-Jan-2004'
       il    = istrln(versn)
       call echo(versn(1:il))
c initialize
       call fitint
c read input file
       call echo('  - reading inputs ' )
       call fitinp
c read data files
       call echo('  - reading input data files ' )
       call fitdat
c check integer coding of math formulas
       call echo('  - checking math expressions ')
       call fitchk
c read feff files
       call echo('  - reading feff data files')
       call fefsrt( mfffil, mpaths, feffil, iffrec, jpthff)
       call fefinp( mffpts, mfffil, mffttl, maxleg, fefttl, feffil,
     $      iffrec, degflg, degpth, refpth, rwgpth, ratpth, theamp, 
     $      thepha, qfeff, cphase, sphase,
     $      realp,  xlamb, nlgpth,  izpth, iptpth)
       
c check that initial guesses for path parameters are "reasonable"
       call fitck2
c do non-linear-least-squares fit to determine best-fit values and
c uncertainties in fitted parameters
       call echo('  - finding best-fit values for the variables')
       call fitnls
c write results to log file and parameter file
       messg = '  - writing results to log file '
       il    = istrln(messg)
       if (prmout) call append(messg,' and parameter file',il)
       call echo (messg(1:il))
       call fitlog
       if (prmout) call fitprm
c write results to data files:
       if (noout) then
          call echo('  - *not* writing output data files')
       else
          call echo('  - writing output data files')
          call fitout
       endif
c finished
       call echo('  feffit is finished.  have a nice day.')
       call close_echofile()
c end program feffit
       end

       subroutine fefinp

c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////

c    read path information from feff files:
c    reads either feffnnnn.dat files (feff5 or higher) or the
c    ascii feff.bin files from feff8
c
c    copyright 1998       matt newville
       implicit none
       include 'consts.h'
       include 'fefdat.h'
cc       implicit double precision (a-h,o-z)

       integer  mlegx, mptsx, mwords, nwords, j, iunit, l0
       integer  itmp, nleg, nepts, iex, ierr, ndoc, npot, npts
       integer  mpts, mfil, mtitle, mleg, npack
       integer  mdocx, ipth, ilen, i, ntitle, istrln

       double precision  rf2b, archi, aichi, arck, aick, rnrmav, xlmin
       logical        exist
       parameter (xlmin = 1.d-8)
       parameter(mlegx = 10, mptsx= 128, mwords = 32, mdocx=16)
       character*64  filnam*256, stat*10, str*128, words(mwords)
       character*128 doc(mdocx), messg, tmpstr*256
       character*2 at_symbol
       integer          izpot(0:mlegx)
       complex*16       phc(mptsx), ck(mptsx)
       double precision xk(mptsx), achi(mptsx), phchi(mptsx)
       double precision beta(mlegx)
       double precision eps, phff, phffo, xlam, reff, bohr
       parameter (eps = 1.d-12, bohr = 0.529 177 249d0)
       parameter (stat = 'old')
       integer  iread
       external iread, at_symbol
       npack = 8
c  feff.dat data extraction
c  loop to get data from at most maxpth paths
       ipth = 0
cc       print*, " FEFINP " 
  50   continue
       ipth = ipth + 1
c   skip unused paths
       if ((ipth.le.mfffil).and.(feffil(ipth).ne.blank)) then
cc          print*, ' fefinp: ipth = ', ipth, ' : ', feffil(ipth)(1:30)
cc          print*,  ipth, iffrec(ipth), lffred(ipth)
c   get next file name from feffil, check that it exists
          exist  = .false.
          filnam = feffil(ipth)
          call triml (filnam)
          ilen = max(1, istrln(filnam))
          inquire(file = filnam,  exist = exist)
c  failed to find this file: stop with warning message
          if (.not.exist) then
             call warn(3,'  warning: could not find FEFF file: '
     $            //filnam)

             feffil(ipth) = blank
c  read data from file
          elseif (iffrec(ipth).eq.0) then
             if (.not.lffred(ipth)) then
c      feff5-style feffnnnn.dat file
c      initialize this path
                nlgpth(ipth) = 2
                refpth(ipth) = zero 
                rwgpth(ipth) = zero
                degpth(ipth) = zero
                do 70 i = 0, maxleg
                   ratpth(1,i,ipth) = zero
                   iptpth(i,ipth)  = 0
                   izpth(i,ipth)  = 0
 70             continue 
                do 80 i = 1, mffpts
                   qfeff(i,ipth)  = zero
                   theamp(i,ipth) = zero
                   thepha(i,ipth) = zero
                   xlamb(i,ipth)  = 1
                   realp(i,ipth)  = zero
 80             continue 
                call echo( '  reading  '//filnam(1:ilen))
cc                print*, ' for ipth = ', ipth
                call rdffdt(filnam,mffttl,maxleg,mffpts,
     $               ntitle,nlgpth(ipth),
     $               npts,fefttl(1,ipth), refpth(ipth), rwgpth(ipth),
     $               degpth(ipth), ratpth(1,0,ipth), iptpth(0,ipth),
     $               izpth(0,ipth), qfeff(1,ipth),theamp(1,ipth),
     $               thepha(1,ipth), thcaps(1,ipth), thsaps(1,ipth), 
     $               xlamb(1,ipth), realp(1,ipth))
                lffred(ipth) = .true.

                nffpts(ipth) = npts
c                print*, 'chipth',  qfeff(1,1),   qfeff(10,1)
c                print*, 'chipth',  mffpts, npts
c                print*, qfeff(npts-1,1),qfeff(npts,1)
c                print*, qfeff(mffpts-1,1),qfeff(mffpts,1)

             end if
          elseif (iffrec(ipth).ne.0) then
c feff8-style feff.bin
             iunit = 0
             call openfl(iunit,filnam,stat,iex,ierr)
             if ((iex.lt.0).or.(ierr.lt.0))
     $            call warn(3,'  error reading file: '//filnam)
c read top of feff.bin for all the records from this file
             call rdfb1(filnam,iunit,mdocx,maxleg,mffpts,npack,
     $            ndoc,npot,
     $            npts, rnrmav, l0, doc,izpot,phc,ck,xk)
c skip to next record within this file
 200         continue
             ilen = iread(iunit, str)
             if (ilen.lt.0) goto 500
             if (str(1:2).ne.'##')   go to 200
             nwords = 1
             call bwords(str(3:),nwords,words)
             call str2in(words(1) , itmp, ierr)
c  skip this record (and go to next) if this isn't the record we want
             if (itmp.ne.iffrec(ipth)) go to 200
c we found the right record:  read in path information
             ilen = istrln(filnam)
             write(messg,'(a,1x,a,1x,i5)')
     $            filnam(1:ilen), ',', iffrec(ipth)
             ilen = istrln(messg)
             call echo( '              '//messg(1:ilen))
             rwgpth(ipth) = rnrmav
             do 305 i = 1, ndoc
                fefttl(i,ipth) =  doc(i)
 305         continue
             nwords = mwords
             call bwords(str(3:),nwords,words)
             call str2in(words(2), nleg, ierr)
             nlgpth(ipth) = nleg
             call str2dp(words(3), degpth(ipth), ierr)
             call str2in(words(4), nepts, ierr)
             call str2dp(words(5), refpth(ipth), ierr)
             reff  = refpth(ipth) / bohr
             do 320 j = 1, nleg
                call str2in(words(6+j),i,ierr)
                iptpth(j,ipth) = i
                izpth(j,ipth) = izpot(i)
 320         continue
             iptpth(0,ipth) = 0
             izpth(0,ipth)  = izpot(0)
             call rdpadd(iunit,npack, ratpth(1,1,ipth),3*nleg)
             do 340 i = 0, nleg
                do 335 j = 1, 3
                   ratpth(j,i,ipth) = ratpth(j,i,ipth) * bohr
 335            continue
 340         continue
c  note that we really don't care about beta, eta, ri arrays, so we'll
c  just skip them here:
             call rdpadd(iunit,npack,beta,nleg)
             call rdpadd(iunit,npack,beta,nleg)
             call rdpadd(iunit,npack,beta,nleg)
c but we really want these arrays (amplitude and phase)
c
c note that this version of feff.bin does not save 
c central-atom and scattering-atom phase-shifts separately.
             call rdpadd(iunit,npack,achi,nepts)
             call rdpadd(iunit,npack,phchi,nepts)
c
             do 390 j = nepts+1, mptsx
                achi(j)  = zero
                phchi(j) = zero
 390         continue
c now convert this into same info as in feff.dat file
             npts = min(mptsx,npts)
             phffo = zero
             rf2b  =  reff*reff*bohr
             do 420 i = 1, npts
                archi = achi(i) * cos(phchi(i))
                aichi = achi(i) * sin(phchi(i))
                arck  = dble(ck(i))
                aick  = dimag(ck(i))
                xlam  = 1.d10
                phff  = zero
                if (abs(aick).gt.eps) xlam= 1/aick
                if (achi(i).ge.eps) phff = atan2(aichi, archi)
c  remove 2 pi jumps in phases
                call pijump (phff, phffo)
                phffo  = phff
c  save values to arrays
                qfeff(i,ipth) = xk(i)/ bohr
                realp(i,ipth) = arck / bohr 
                xlamb(i,ipth) = max(xlmin, xlam) * bohr
                thepha(i,ipth)= phff
                thcaps(i,ipth)= 2 * dble(phc(i)) + l0*pi
                thsaps(i,ipth)= phff - thcaps(i,ipth)
                theamp(i,ipth)= achi(i)*xk(i)*rf2b*exp(2*reff/xlam)
 420         continue
c
c fill in the rest of qfeff so that it is monotonically increasing
             do 450  i = npts+1, mffpts
                if(qfeff(i,ipth).lt.qfeff(i-1,ipth)) then
                   qfeff(i,ipth) = 2*qfeff(i-1,ipth)-qfeff(i-2,ipth)
                   theamp(i,ipth)= zero
                end if
 450         continue
c
c if the next {feffil,iffrec} set has the same file name,
c read the next record
             if ((ipth.lt.mfffil) .and.
     $            (feffil(ipth+1).eq.feffil(ipth))) then
                ipth = ipth + 1
                go to  200
             end if
 500         continue
             close(iunit)
c  done reading feff.bin entry
          end if
c construct path id
          tmpstr = ''
 2505     format('reff=', f7.4, ', nlegs=',i2)
          write(tmpstr,2505) refpth(ipth),nlgpth(ipth)
          ilen  = istrln(tmpstr)
          tmpstr= tmpstr(1:ilen)//', path= '//at_symbol(izpth(0,ipth))

          ilen  = istrln(tmpstr)
          if (nlgpth(ipth) .eq. 2) then 
             tmpstr= tmpstr(1:ilen)//'<->'//at_symbol(izpth(1,ipth))
          else 
             do 2600 i = 1,  nlgpth(ipth)-1
                tmpstr= tmpstr(1:ilen)//'->'//at_symbol(izpth(i,ipth))
                ilen  = istrln(tmpstr)
 2600        continue 
             tmpstr= tmpstr(1:ilen)//'->'//at_symbol(izpth(0,ipth))
          endif
          ilen  = istrln(tmpstr)
          fpthid(ipth) = tmpstr(1:ilen)
c
          go to 50
       end if
       return
c end subroutine fefinp
       end

       subroutine sum_paths(idata, iupath, nxpath, nqmax,
     $      ckreal, ckimag)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c 
c  sum-over-paths for a particular data set, returning 
c      real and imaginary parts of chi(k)
c     used by iff_ff2chi and fitfun
c
       implicit none
       include 'consts.h'
       integer       idata, i, ip, nqmax, xafs_path, ret
       integer       nxpath, iupath(mpaths)
       double precision  xdsave, xtmp, getsca, reff
       double precision  ckreal(maxpts), ckimag(maxpts) 
       double precision  tmpi(maxpts), tmpr(maxpts)
       external    getsca, xafs_path

       do 100 i = 1, maxpts
          ckreal(i)  = zero
          ckimag(i)  = zero
 100   continue
       xdsave = getsca('data_set',0)
       xtmp   = one*max(1,min(mdata,idata))
       call setsca('data_set',  xtmp)
cc       print*, 'sum paths data_set', xtmp
       do 1000 ip = 1, nxpath
          ret = xafs_path(iupath(ip), tmpr, tmpi, reff)
cc          print*, ' path ', ip, iupath(ip), ret, reff
          if (ret .eq. 1) then
c  add this to the other paths
             do 850 i = 1, nqmax
                ckreal(i) = ckreal(i) + tmpr(i)
                ckimag(i) = ckimag(i) + tmpi(i)
 850         continue
c          else 
c             print*, 'sum over paths: path not used: ',
c     $            ip, iupath(ip)
          endif
 1000  continue
c now return previous the previous 'user variables'
       call setsca('data_set',  xdsave)
       return
       end

       integer function xafs_path(ipath,chi_r, chi_i,reff)
c
c  calculate xafs for a single path 
c  ipath =  'user path index' 
c  idata =  'data set'
c  reff <= 0. on output means path isn't defined.
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       include 'arrays.h'
       include 'fefdat.h'
       include 'feffit.h'
       include 'pthpar.h'
       save
       integer ipath, i, j, k, inpath, nqmax, jfeff
       integer u2ipth, ntmp, nkpar, icode(micode)
       double precision reff, degen, xtmp, getsca
       double precision chi_r(maxpts),chi_i(maxpts)
       double precision tpakar(maxpts),tpaamp(maxpts),tpapha(maxpts)
       external         u2ipth, getsca

       reff      = -one
       xafs_path = 0
       inpath    = u2ipth(ipath)
cc       print*, ' xafs path ', ipath, u2ipth(ipath)
       if (inpath.le.0) return
       if (jpthff(inpath).le.0) then
          write(tmpstr,'(1x,a,i5)') ' no FEFF file for path ', ipath
          call warn(2,tmpstr)
          return
       else
          jfeff = jpthff(inpath)
          reff  = refpth(jfeff)
          degen = degpth(jfeff)
          xtmp  = ipath
          call setsca('path_index', xtmp)
          call setsca('degen', degen)
          call setsca('reff',  reff)
       endif
       call synvar
c      
c path OK to use
       xafs_path = 1
       nkpar     = 0

       do 340 i = 1, maxpts
          tpakar(i) = (i-1)* qgrid
          tpaamp(i) = one
          tpapha(i) = zero
 340   continue 
          
c loop over path parameters to evaluate
       do 500 i = 1, mpthpr
c
c set default path params here
          tmparr(1) = zero
          if (i.eq.jfps02)  then
             tmparr(1) = one
          elseif (i.eq.jfpdeg) then
             tmparr(1) = degpth(jfeff)
          endif
          ntmp = 0
          do 420 k = 1, micode
             icode(k)  = icdpar(k,i,inpath)
 420      continue 
          if (iprint.ge.12)
     $          call rpndmp(icode)
c  evaluate parameter if it was defined
          if (icode(1).ne.0) then
             call decod(icode, micode, 
     $            consts, scalar, array, narray, nparr, 
     $            maxsize_array, maxarr,  ntmp, tmparr)
          end if
c
c set the param value from tmparr:
          param(i) = tmparr(1)
          if (i.eq.jfpkar) then
             if (nkpar.gt.0)  nkpar = min(nkpar, ntmp)
             if (nkpar.eq.0)  nkpar = ntmp
             do 470 j = 1, ntmp
                tpakar(j) = tmparr(j)
 470         continue 
          elseif (i.eq.jfpaar) then
             if (nkpar.gt.0)  nkpar = min(nkpar, ntmp)
             if (nkpar.eq.0)  nkpar = ntmp
             do 480 j = 1, ntmp
                tpaamp(j) = tmparr(j)
 480         continue 
          elseif (i.eq.jfppar) then
             if (nkpar.gt.0)  nkpar = min(nkpar, ntmp)
             if (nkpar.eq.0)  nkpar = ntmp
             do 490 j = 1, ntmp
                tpapha(j) = tmparr(j)
 490         continue 
          endif
 500   continue

c
c   get chi(k) for this path from feff and path parameters
c
       if ( (inpath.gt.0).and.(jfeff.gt.0))  then
          if (iprint.ge.9) then
             call echo('calling chipth:')
c      c             print*, '   jfeff, maxpts   =', jfeff, maxpts, mffpts
c      c             print*, '   reff, degen     =', reff, degen
c      c          print*, 'sum_paths: jfeff, nffpts   =',
c      c     $         jfeff,nffpts(jfeff)
          end if

cc       print*, 'Phase array: ', nkpar, tpapha(1), tpapha(3)

          call chipth(theamp(1,jfeff), thepha(1,jfeff),
     $         qfeff(1,jfeff), xlamb(1,jfeff), realp(1,jfeff),
     $         nffpts(jfeff), reff, nkpar, tpakar, tpaamp, tpapha,
     $         maxpts, chi_r, chi_i)
          
cc          print*, ' path ', ipath, inpath, param(jfpdeg)
c          print*, 'degen,s02,e0,ei =',degen,
c     $         param(jfps02), param(jfpe0), param(jfpei)
c          print*, 'dphas,delr,sig2 =',
c     $         param(jfppha),param(jfpdr),param(jfpss2)
c          print*, 'theamp(28,jfeff)=', theamp(28,jfeff)
c          print*, 'qfeff(28,jfeff) =',  qfeff(28,jfeff)


cc          print*, chi_r(1), chi_i(1), chi_r(3), chi_i(3)

       end if
       return
       end
             

       subroutine iff_getline(str, key, val, arg, ilen)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose:  manange a single full command line from multi-line
c           inputs, and parse input line to do the following:
c           -1-  determine keyword, value, argument:
c                if the first word is in the list _ckeys_, then
c                _key_ is set to that, _arg_ is the rest of the
c                line, and _val_ is the first word of _arg_.
c                if the first word is not in _ckeys_, then 
c                _key_ = 'def' and _arg_ = whole line.
c                ckeys held in common /comkey/
c           -2-  manage a long command, over multiple input lines:
c                if a _key_ is followed by '(', the command line
c                will not terminate until an "unprotected" ')'.
c           -3-  remove end-of-line comments.
c
c arguments:
c      str      next input line                         [in]
c      key      keyword (1st word)                      [out]
c      val      1st word of arg                         [out]
c      arg      argument (everything except 1st word)   [out]
c      ilen     length of output line                   [in/out]
c               on output, ilen<0 if line is to be continued
c
c notes:
c   1. handling multi-line commands:
c      a) a line will be continued to the next line if the
c         full line contains unmatched (unprotected) parens.
c      b) if a line is too be continued, ilen is set to -ilen
c
c   2.  '!', '#', and '%'  are end-of-line comments, but can be
c       protected by matching " ", ' ', or { }.
c
c   3. setting ilen=0 will initialize a bunch of stuff, and
c      is probably desirable on first call.
c
c     If on arriving at Trude I had not read the city's name written
c     in big letters, I would have thought I was landing at the same
c     airport from which I had taken off. ... Why come to Trude?  I
c     asked myself. And I already wanted to leave.
c
       implicit none
       include 'consts.h'
       include 'keywrd.h'
       character*(*)   str, val, arg, key
       character*2048  line, tmp, words(2), tmpkey
       character       s*1, copen*3, cclos*3, ceol*3
       integer         itmp, istrln, ilen, i, iprot
       integer         iparen,ikey,nwords, ip
       logical         newlin, do_final_trim
       common /icomnd/ iprot, iparen, itmp, newlin
       common /ccomnd/ tmp, tmpkey, copen, cclos, ceol
       save
       external istrln
c  initialization
       arg = blank
       key = blank
       val = blank
       if (ilen.eq.0) then
          newlin = .true.
          iprot  = 0
          iparen = 0
          ilen   = 0
          tmp    = blank
          tmpkey = blank
          copen  = '{''"'
          cclos  = '}''"'
          ceol   = '!#%'
       end if
c
c  clean up input line
       line = str
       call sclean(line)
       call triml(line)
       ilen = istrln(line)
       if (ilen.lt.0) then
          ilen = -itmp
          return
       end if
c
c if we're getting a new line :
       if (newlin) then
          tmpkey = blank
          tmp    = blank
          iprot  = 0
          iparen = 0
          itmp   = 1
c      get the candidate keyword, and determine if the line is
c      a "single-line" or "multi-line" command
          ikey  = 0
          do 20 i = 1, ilen
             s = line(i:i)
             if (s.eq.'(') then
                ikey  = i - 1
                go to 22
             elseif ((s.eq.blank).and.(ikey.eq.0) ) then
                ikey = i - 1
             elseif ((s.ne.blank).and.(ikey.ne.0)) then
                go to 22
             end if
 20       continue
          ikey = ilen
 22       continue
c      now check the candidate keyword against the known list
c      if not found, key is set to 'def', and the whole line is kept
          key = line(1:ikey)
          call lower(key)
          do 30 i = 1, mckeys
             if (key.eq.ckeys(i))  go to 65
 30       continue
          do 40 i = 1, macmax
             if (key.eq.macnam(i)) go to 65
 40       continue
          key   = undef
          ikey  = 0
 65       continue
          tmpkey= key
          line  = line(ikey+1:ilen)
          call triml(line)
          ilen  = istrln(line)
       end if
c
c remove unprotected end-of-line comments, update paren count
       do 150 i = 1, ilen
          s = line(i:i)
c      keep track of whether this part of the string is "protected"
          if (iprot.eq.0) then
             iprot = index(copen,s)
          elseif (iprot.le.3)  then
             if (s.eq.cclos(iprot:iprot)) iprot = 0
          end if
c     look for end-of-line comments
          if ((iprot.eq.0).and.(index(ceol,s).ne.0)) then
             line = line(1:i-1)
             call triml(line)
             go to 160
          end if
          if (s.eq.'(') iparen = iparen + 1
          if (s.eq.')') iparen = iparen - 1
 150   continue
 160   continue
       ilen = istrln(line)
c  if multi-line, check for final ')'.
c  and if it's found, peel of the enclosing ( ... )
c
c  the line is not complete:
       if (iparen.gt.0) then
          tmp   = tmp(1:itmp)//line(1:ilen)
          call triml(tmp)
          itmp  = istrln(tmp) + 1
          ilen  = -itmp
          newlin= .false.
c  the line is complete:
       else
          arg    = tmp(1:itmp)//line(1:ilen)
          call triml(arg)
          ilen   = max(1, istrln(arg))
          if ((arg(1:1).eq.'(').and.(arg(ilen:ilen).eq.')')) then
             ip  = 0
             do_final_trim = .true.
             do 350 i = 2, ilen-1
                s = arg(i:i)
                if (s.eq.'(') ip = ip + 1
                if (s.eq.')') ip = ip - 1
                if (ip.lt.0)  do_final_trim = .false.
 350         continue 
             if (do_final_trim) then
cc                print*, ' getline removing surrounding  parens'
                arg = arg(2:ilen-1)
                call triml(arg)
                ilen = max(1, istrln(arg))
             endif
          end if
          newlin = .true.
          key    = tmpkey
          if ((key.eq.blank).or.(key.eq.undef)) key = def_command
          nwords = 2
          call bwords(arg,nwords,words)
          val    = words(1)
       end if
c
c  end subroutine iff_getline
       return
       end

       subroutine fftout(mpts, mode, xdat, step, xlo, xhi, nout, npts, xout)
c convert complex data xdat to a real array, using only
c      that part of the complex array between [xlow, xhi].
       implicit none
       integer  mpts, npts, nout, nmin, npairs, i, mode
       complex*16  xdat(mpts)
       double precision xout(npts), step, dxi, xlo, xhi, small, tiny
       parameter (tiny = 1.d-4, small = 1.d-2)
c      
       dxi    = 1 / max(tiny, step)
       nmin   = max(0, int(xlo * dxi + small ))
       npairs = max(1, int(xhi * dxi + small )) - nmin + 1
       nout   = min(npts, 2 * npairs)
       do 50 i= 1, npairs
          xout(2*i-1) = dble (xdat( nmin + i ))
          xout(2*i  ) = dimag(xdat( nmin + i ))
 50    continue
       return
c end subroutine fftout
       end

       subroutine sigms (tk, theta, rs, nleg, rat, iz, sig2)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  the following routines calculate the debye-waller factor for a
c  path based on the temperature, debye temperature, average
c  norman radius, atoms in the path, and their positions.
c  these routines come courtesy of jj rehr and si zabinsky.
c  i changed them a bit.   matt n
c-------------------------------------------------------------------
c
c  from s i zabinsky.
c  inputs:
c       tk      temperature in degrees k
c       theta   debye temp in degrees k
c       rs      average wigner seitz or norman radius in bohr
c                     averaged over entire problem:
c                     (4pi/3)*rs**3 = sum( (4pi/3)rnrm**3 ) / n
c                     (sum is over all atoms in the problem)
c       nleg    nlegs in path
c       rat     positions of each atom in path (in bohr)
c       iz      atomic number of each atom in path
c output:
c       sig2    debye waller factor
c  notes:
c     all units of distance in this routine are angstroms
c     there are nleg atoms including the central atom.
c     index 0 and index nleg both refer to central atom.
       implicit none
       integer          i, j, nleg, nlegx
       double precision tk, theta, rs, sig2, zero, two
       double precision rij, rimjm, rimj, riim, rjjm, ridotj, corrfn
       double precision  dist, cij, cimjm, cijm, cimj, sig2ij, rijm
       parameter (nlegx = 7, zero = 0.d0, two = 2.d0)
       double precision  rat(3,0:nlegx)
       integer iz(0:nlegx)
       external dist, corrfn
c
       sig2   = zero
       do 800 i  = 1, nleg
         do 800 j = i, nleg
c
c  calculate r_i-r_i-1 and r_j-r_j-1 and the rest of the
c  distances, and get the partial cosine term:
c       cosine(i,j) = r_i.r_j / ((r_i - r_i-1) * (r_j - r_j-1))
           rij    = dist ( rat(1,i)  , rat(1,j)   )
           rimjm  = dist ( rat(1,i-1), rat(1,j-1))
           rijm   = dist ( rat(1,i)  , rat(1,j-1))
           rimj   = dist ( rat(1,i-1), rat(1,j)   )
           riim   = dist ( rat(1,i)  , rat(1,i-1))
           rjjm   = dist ( rat(1,j)  , rat(1,j-1))
           ridotj = (rat(1,i)-rat(1,i-1)) * (rat(1,j)-rat(1,j-1))
     $            + (rat(2,i)-rat(2,i-1)) * (rat(2,j)-rat(2,j-1))
     $            + (rat(3,i)-rat(3,i-1)) * (rat(3,j)-rat(3,j-1))
c
c  call corrfn to get the correlations between atom pairs
           cij   = corrfn (rij  , theta, tk, iz(i)  , iz(j)  , rs)
           cimjm = corrfn (rimjm, theta, tk, iz(i-1), iz(j-1), rs)
           cijm  = corrfn (rijm , theta, tk, iz(i)  , iz(j-1), rs)
           cimj  = corrfn (rimj , theta, tk, iz(i-1), iz(j)  , rs)
c
c  combine outputs of corrfn to give the debye-waller factor for
c    this atom pair.   !!! note: don't double count (i.eq.j) terms !!!
           sig2ij = (cij + cimjm - cijm - cimj)*ridotj/(riim * rjjm)
           if (j.eq.i) sig2ij = sig2ij / two
           sig2 = sig2 + sig2ij
 800   continue
       sig2 = sig2/2
       return
c  end subroutine sigms
       end
       double precision function corrfn(rij, theta, tk,iz1,iz2,rs)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  subroutine calculates correlation function
c  c(ri, rj) = <xi xj> in the debye approximation
c
c            = (1/n)sum_k exp(ik.(ri-rj)) (1/sqrt(mi*mj))*
c                              (hbar/2w_k)*coth(beta hbar w_k/2)
c
c            = (3kt/mu w_d**2) * sqrt(mu**2/mi*mj) * int
c  where :
c       x        k_d*r (distance parameter)  r distance in angstroms
c       theta    debye temp in degrees k
c       tk       temperature in degrees k
c       temper   theta / tk = hbar omegad/kt
c       k_d      debye wave number = (6*pi**2 n/v)
c       n/v      free electron number density = 1/(4pi/3rs**3)
c       rs       wigner seitz or norman radius in bohr
c       ami      atomic mass at sites i in amu
c       amj      atomic mass at sites j in amu
c       int      int_0^1 (temper/x) dw sin(wx)coth(w*temper/2)
c
c  solution by numerical integration
c
c  parameters pi, bohr, con
c  con=hbar**2/kb*amu)*10**20   in ang**2 units
c  hbar=1.0549x10**-34 amu=1.65979x10-27kg kb=1.3807x10-23
       implicit none
       integer  iz1, iz2
       double precision rs, theta, tk,  rij, rx, tx
       double precision conr, conh, rmass, debint, at_weight
       parameter (conh = 72.8385d0, conr = 4.5693346333d0)
       external at_weight, debint
c
c  theta in degrees k, t temperature in degrees k
       rx     = conr  * rij / rs
       tx     = theta / tk
       rmass  = theta * sqrt( at_weight(iz1) *  at_weight(iz2))
       corrfn = conh  * debint (rx,tx) / rmass
       return
c  end subroutine corrfn
       end
       double precision function debfun(w,rx,tx)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  debfun = (sin(w*rx)/rx) * coth(w*tx/2)
c
       implicit none
       double precision  wmin, argmax, w, emwt
       parameter (wmin = 1.d-20, argmax = 50.d0)
       double precision rx, tx

c  allow t = 0 without bombing
       debfun = 2 / tx
       if (w.gt.wmin) then
          debfun = w
          if (rx.gt.0) debfun = sin(w*rx) / rx
          emwt   = exp(-min(w*tx,argmax))
          debfun = debfun * (1 + emwt) / (1 - emwt)
       end if
       return
c  end function debfun
       end
       double precision function debint (rx,tx)
c
c  copyright 1993  university of washington
c                  john rehr, steve zabinsky, matt newville
c
c  subroutine calculates integrals between [0,1]  b = int_0^1 f(z) dz
c  by trapezoidal rule and binary refinement  (romberg integration)
c  coded by j rehr (10 feb 92)   see, e.g., numerical recipes
c  for discussion and a much fancier version
c-----------------------------------------------
c     del=dz  itn=2**n tol=1.e-5
c     starting values
c      implicit double precision (a-h,o-z)
c     error is approximately 2**(-2n) ~ 10**(-.6n)
c     so nmax=10 implies an error of 1.e-6
c
       implicit none
       integer  nmax, n, itn, i
       double precision tol, zero, one, two, three, debfun
       double precision rx, tx
       parameter(nmax = 12, tol = 1.d-9)
       parameter(zero=0.d0, one=1.d0, two=2.d0, three=3.d0)
       double precision del, bn, bo, zi, sum, bnp1
       external debfun
c
       itn = 1
       del  = one
       debint = zero
       bn   = (debfun(zero,rx,tx) + debfun(one,rx,tx)) /2
       bo   = bn
       do 40 n = 1, nmax
c  nth iteration
c  b_n+1=(b_n)/2+deln*sum_0^2**n f([2n-1]deln)
         del = del / two
         sum = zero
         do 20 i= 1, itn
            zi  = (two * i - 1) * del
            sum = sum + debfun(zi,rx,tx)
 20      continue
c     bnp1=b_n+1 is current value of integral
c     cancel leading error terms b=[4b-bn]/3
c     note: this is the first term in the neville table - remaining
c           errors were found too small to justify the added code
         bnp1   = del * sum + (bn / two)
         debint = (4 * bnp1 - bn)/three
         if (abs( (debint - bo) / debint).lt.tol) goto 45
         bn   = bnp1
         bo   = debint
         itn  = itn * 2
 40    continue
 45    continue 
       return
c end function debint
       end
       double precision function dist (r0, r1)
c  find distance between cartesian points r0 and r1
       double precision   r0(3), r1(3)
       dist = 0.d0
       do 10  i = 1, 3
          dist = dist + (r0(i) - r1(i))**2
 10    continue
       dist = sqrt(dist)
       return
c  end function dist
       end
       subroutine cordby(x, nx, y, ny, ierr)
c
c  copyright 1993  university of washington      matt newville
c  copyright 1999  university of chicago         matt newville
c
c  calculate xafs sigma^2 from correlated debye model ala jj rehr
c  important note:   the path information is looked up in the
c      common block /fefdat/, using the path held in scalar 'path_index'
c
c     x  = theta on input, sigma2 on output
c     y =  temperature
c-
       include 'consts.h'
       include 'arrays.h'
       include 'feffit.h'
       include 'fefdat.h'
       include 'pthpar.h'
       double precision x(*), y(*),  getsca, out(maxpts)
       double precision tk, theta, sig2, rat(3,0:maxleg)
       double precision small, big
       parameter(small =1.d-5, big =1.d10)

       integer  ierr, iz(0:maxleg), i, j, ipth, jfeff
       integer  u2ipth, inpath, nx1, ny1, nptstk, ipt, ix, iy
       external getsca, u2ipth, nptstk
c      
       ierr = 0
       nx1  = nx
       ny1  = ny
       nx   = nptstk (nx1, ny1)

       ipth = max(1, int ( getsca('path_index',0)))
cc       print*, '  cordby: ', nx1, ny1, nx , ipth
       jfeff  = -1
       if (ipth.ge.1) then
          inpath = u2ipth(max(1, ipth))
          jfeff  = jpthff(inpath)
cc          print*, ' cordby: ', ipth, inpath, jfeff
          do 50 i = 0, nlgpth(jfeff)
             iz(i)   = izpth(i,jfeff)
             do 40 j = 1,3
                rat(j,i)  = ratpth(j,i,jfeff)
 40          continue
 50       continue
       end if
cc       print*, '  cordby 100   nx = ', nx
       do 100 ipt = 1, nx 
          ix     = min(nx1, ipt)
          iy     = min(ny1, ipt)
          theta  = max(small, min(big, x(ix)))
          tk     = max(small, min(big, y(iy)))
          sig2  = zero
          if (jfeff.ge.1) then
             call sigms(tk,theta,rwgpth(jfeff),
     $            nlgpth(jfeff),rat,iz,sig2)
          endif
          out(ipt) = sig2 
cc          print*, ' debye: ipt ' , ipt, tk, theta, sig2
 100   continue 
       do 120 ipt = 1, nx
          x(ipt) = out(ipt)
 120   continue 
       return
c  end subroutine cordby
       end
       subroutine eins(x, nx, y, ny, ierr)
c
c calculate debye waller in einstein model 
c  inputs
c     x  = theta on input, sigma2 on output
c     y  = temp
c
c  calculate sigma^2 in the eisntein model inputs:
c  returned:
c    x      sigma squared [AA^2] 
c                = factor / (theta*rmass*tanh(theta/2t))
c    with factor = hbarc*hbarc/(two * boltz * amu2ev)
c
c  copyright (c) 1998  matt newville
       include 'consts.h'
       include 'arrays.h'
       include 'fefdat.h'
       include 'pthpar.h'
       integer   nx, ny, ierr, i, ipth, nx1, ny1, nptstk, ipt
       integer  u2ipth, inpath, jfeff
       double precision  x(*), y(*), tmp, getsca, theta, tk
       double precision  out(maxpts), a
       double precision small, big, factor, rminv, at_weight
       parameter(factor = 24.25423371d0, small =1.d-5, big =1.d10)
       external  getsca, at_weight, nptstk, u2ipth
       ierr  = -1

       nx1  = nx
       ny1  = ny
       nx   = nptstk (nx1, ny1)
       ipth = max(1, int ( getsca('path_index',0)))
c  construct reduced mass (in amu) using function at_weight
       inpath = u2ipth(max(1, ipth))
       rminv  = zero
       jfeff  = jpthff(inpath)
       do 50 i = 1, nlgpth(jfeff)
          a     = at_weight( izpth(i, jfeff))
          rminv = rminv +  one /max(one, a)
  50   continue
       rminv  = factor*max(small, min(big, rminv))
c
c       print*, ' eins: ', rminv, nx, ipth, x(1), y(1), y(2)
c       print*,  inpath, jfeff, nlgpth(jfeff), 1./rminv
       do 100 ipt = 1, nx
          ix     = min(nx1, ipt)
          iy     = min(ny1, ipt)
          theta  = max(small, min(big, x(ix)))
          tk     = max(small, min(big, y(iy)))
          out(ipt) = zero
          ierr   = 0
c evaluate sigma2 in einstein model, and overwrite x
          if (ipth.ne.0) then
             out(ipt)= rminv/(tanh(theta/(2*tk))*theta)
          endif
 100   continue 
       do 120 ipt = 1, nx
          x(ipt) = out(ipt)
 120   continue 
       return
c end subroutine eins
       end

      logical function iscomm(str)
c true if str is a comment line or blank line, false otherwise
      character*(*) str
      iscomm = ((str.eq.' ') .or. (index('*%#',str(1:1)).ne.0))
      return
      end


       subroutine sort2i(n, ira1, ira2)
c
c      sort an array ira1 of length n into ascending order,
c      while making the corresponding rearrangement to rb.
c      the sorting is done by the heapsort algorithm
c
       integer  ira1(n), ira2(n)
       l  = n / 2 + 1
       ir = n
c
c   index l will be decremented from its initial value down to 1
c   during the hiring phase (heap creation). Once l reaches 1, the
c   index ir will be decremented from its initial value to to 1
c   during the retirement-and-promotion (heap selection) phase.
c
 10    continue
c                                           heap creation phase
          if (l.gt.1) then
               l      = l - 1
               ia1    = ira1(l)
               ia2    = ira2(l)
c                                           heap selection phase
          else
               ia1    = ira1(ir)
               ia2    = ira2(ir)
               ira1(ir) = ira1(1)
               ira2(ir) = ira2(1)
               ir     = ir - 1
               if (ir.eq.1) then
                    ira1(1) = ia1
                    ira2(1) = ia2
                    go to 50
               end if
          end if
c                                           set up to sift down ia1.
          i = l
          j = l + l
c                                           do while j.le.ir
 20       continue
          if (j.le.ir) then
c                                           better low element
              if (j.lt.ir) then
                    if ( ira1(j).lt.ira1(j+1) )j = j + 1
              end if
c                                           demote ia1
              if (ia1.lt.ira1(j)) then
                    ira1(i) = ira1(j)
                    ira2(i) = ira2(j)
                    i     = j
                    j     = j + j
c                                           terminate the sift-down
              else
                    j     = ir + 1
              end if
              go to 20
          end if
c                                           put ia1, ia2 into slots
          ira1(i) = ia1
          ira2(i) = ia2
          go to 10
c  return
 50    continue
       return
c  end subroutine sort2i
       end

       integer function encod(string, jcode, icode)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: converts a math expression into an integer array (icode)
c          for fast evaluation by routine adecod
c
c arguments:
c      string   string for math expression              [in/out]
c      mconst   dimension of array of constants         [in]
c      consts   array of constants                      [in/out]
c      mxicod   dimension of icode      (maximum = 128) [in]
c      jcode    int array of infix   math expression    [out]
c      icode    int array of postfix math expression    [out]
c
c returns
c      encod    error/warning code - see notes          [out]
c
c notes:
c   1. icode will contain a post-fix (rpn) representation of the
c      fortran-like  math expression in string, with special ranges
c      of integers describing different classes of operators and values.
c      see note 6 for a list of integer ranges and meaning.
c   2. encod and adecod are designed for many repeated evaluations.
c      encoding is slow (and slightly redundant) so that decoding is as
c      efficient as possible.
c   3. variables do not need to be explicitly declared before encoding.
c      if a variable is found that has not already been identified, it
c      will be added to the appropriate list (see note 4).  the link
c      between variable names and values should be managed outside.
c   4. array and scalar names are strings that do not begin with
c      a number and do not contain any of '+-*/^(), '.  Case is not
c      important.  Arrays are distinguished from scalars by the present
c       of a '.' in the name:  'A.b' is an array, 'A_b' is a scalar.
c   5. consts contains the real numbers used in the expressions.  no
c      values are internally set  -- they should be set in the
c      calling routine (including the value of pi!!!).
c   6. icode legend: see
c      icode range       meaning
c    -16385: -10  math functions (see encod.h)
c       -9:   -6   control operations (open and close parens, comma)
c       -5:   -1   not possible! (useful for overwriting/disabling/resetting)
c        0         null string
c        1:  8192  arrays:    values in array  array
c     8193: 16384  scalars:   values in scalar array
c    16385:        constants: values in consts array
c
c requires:  encod.h, istrln, triml, echo, lower, unblnk, uncomm,
c            parens, nbrstr, str2dp, enchk, engrpn
c
c parameters
       implicit none
       include 'consts.h'
       include 'encod.h'
       include 'arrays.h'
       save
c passed variables
       character*(*) string
c internal variables
       character*2048 str,  strtmp, strout
       character*256 prefix, errmsg, strnum
       character*1  str1, straft, strbfr, opera*9
       character    str3*3,str4*4, str5*5, str6*6, str7*7, str8*8
       character*32 mtherr, synerr, encerr, number*11, strfcn
       logical   isvect, isvnam, dotrim
       integer   mxicod, ilen, istr, i, isafcn, ienfcn, nxfcn
       integer   itemp(micode), icode(micode), jcode(micode)
       integer   ibfr, iaft, ibefr, iaftr, ivarln, istrln
       integer   iofarr, iofsca, ierr, ieqn, iparen, isave
       integer   ipar, ntest, nscomm, nspow, nssub, nsadd, nsdiv, nsmul
       integer   nsopen, nsclos, nsnum, nbrstr
       double precision    xreal
       external  istrln, isvnam, iofarr, iofsca, ienfcn, nbrstr
       parameter(number = '.0123456789', opera = '+-*/^(), ')
       parameter(mtherr = ' math error: ')
       parameter(synerr = ' math syntax error: ')
       parameter(encerr = ' math encoder out of memory: ')
c
       call gettxt('group', prefix)
c
c  initial error checking of input dimensions
 10    format (i4,a)
c  initialization
       encod  = 0
       strtmp = ' '
       str    = ' '
       str1   = ' '
       strnum = ' '
       straft = ' '
       strbfr = ' '
       strfcn  = ' '
c  remove interior blanks and end-of-line comments:  '!','%','#'
       strtmp = string
       call triml(strtmp)
       call unblnk(strtmp)
       call uncomm(strtmp)
       ilen   = istrln(strtmp)
cc       print*,  'encod 1'
c  if string is blank, return
       icode(1) = 0
       if ( (strtmp.eq.' ').or.(ilen.le.0))  return
cc       print*,  'encod 2:', strtmp(1:ilen), ':', ilen
c
c  convert string to the case of this routine :
c    the variable 'case' controls the case of the routine, so it
c    must be the same case as the strings tested for in strtmp.
       call lower(strtmp)
c
c  initialize integer arrays to 0
       do 50 i = 1, micode
          icode(i) = 0
          jcode(i) = 0
          itemp(i) = 0
 50    continue
c  initialization done.
c-------------------------------------------------------------------
c  now start dealing with strtmp as a math expression
c  fix multiple "unitary" operations: ++, -- -> +; -+, +- -> -
       do 120 i = 1, ilen-1
          str = strtmp(i:i+1)
          if ((str.eq.'--').or.(str.eq.'++')) strtmp(i:i+1) = ' +'
          if ((str.eq.'-+').or.(str.eq.'+-')) strtmp(i:i+1) = ' -'
 120   continue
       call unblnk(strtmp)
c-----------------------------------------------------------------------
c  insert parens to ensure normal math precedence.
c    note that this is not entirely necessary, but it is convenient
c    to rewrite the string in the way it is intended to be evaluated.
       string = strtmp
       call parens(string)
       call triml(string)
       ilen = max(1, istrln(string))
       string(ilen+1:) = ' '
       strout          = string
c
c  translate special cases:
c   note that debye and eins need path index, which is automagically
c    updated from path_index:
       ilen = max(1, istrln(string))
       string(ilen+1:) = ' '
       strtmp          = ' '
cc       print*, ' ENCOD: ', string(1:50)
c-----------------------------------------------------------------------
c  with the string well behaved (parens inserted so there are no
c   ambiguities in the math), let's dechiper it and encode icode
c
c  decipher string into integers
       isave  = 0
       istr   = 0
       ieqn   = 0
       iparen = 0
cc       print*,  'encod 3:', string(1:ilen), ':', ilen
c  advance string postion, check for end of string
 300   continue
       ieqn = ieqn + 1
 320   continue
       istr = istr + 1
       ibfr = istr - 1
       iaft = istr + 1
       if (ibfr.lt.1) ibfr = 1
       if (istr.gt.ilen) go to 4000
cc---------------------------
       strtmp = string(istr:)
       str1   = strtmp(:istr)
c  ignore blank spaces
       if (str1.eq.' ') go to 320

       str3  = strtmp(1:istr+2)
       str4  = strtmp(1:istr+3)
       str5  = strtmp(1:istr+4)
       str6  = strtmp(1:istr+5)
       str7  = strtmp(1:istr+6)
       str8  = strtmp(1:istr+7)
       strbfr = string(ibfr:ibfr)
       straft = string(iaft:iaft)

       nsnum   = index(number,str1)
       nsopen  = index(strtmp(1:),'(')
       nsclos  = index(strtmp(1:),')')
       nsmul   = index(strtmp(1:),'*')
       nsdiv   = index(strtmp(1:),'/')
       nsadd   = index(strtmp(1:),'+')
       nssub   = index(strtmp(1:),'-')
       nspow   = index(strtmp(1:),'^')
       nscomm  = index(strtmp(1:),',')

       if (nsopen.eq.0) nsopen = 999999
       if (nsclos.eq.0) nsclos = 999999
       if (nsmul .eq.0) nsmul  = 999999
       if (nsdiv .eq.0) nsdiv  = 999999
       if (nsadd .eq.0) nsadd  = 999999
       if (nssub .eq.0) nssub  = 999999
       if (nspow .eq.0) nspow  = 999999
       if (nscomm.eq.0) nscomm = 999999
       ntest = min(nsclos,nsmul,nsdiv,nsadd,nssub,nspow,nscomm)
cc       print*, string(1:20),': ',istr,   nsopen, ntest
       isafcn = 0
       if ((nsopen.gt.1).and.(nsopen.lt.ntest)) then
          isafcn = 1
          nxfcn  = nsopen - 1
          strfcn  = strtmp(1:nsopen-1)
cc          print*, "is a function:", strtmp(:nsopen-1),":", nsopen, nxfcn
       end if


c-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --
c  parse string
cc       print*, '<encod>', str1
c  # constant real number : find length of real number, read it,
c                store it, and advance string to end of number
       if (index(number,str1).ne.0) then
          isave  = istr + nbrstr(string(istr:ilen))
          strnum = string(istr:isave)
          call str2dp(strnum, xreal, ierr)
          if (ierr.ne.0) then
             call echo(mtherr//'cannot read number from string')
             errmsg = ' << '//string(istr:isave)//' >>'
             call warn(2,errmsg)
             return
          endif
c       check if constant is already stored --
          do 450 i = 1, mconst
             if (xreal.eq.consts(i)) then
                itemp(ieqn)  = jconst + i
                go to 500
             elseif ((consts(i).eq.0).and.(i.gt.1)) then
                itemp(ieqn)  = jconst + i
cc                print*, ' adding constant ', i, xreal
                consts(i) = xreal
                go to 500
             end if
 450      continue
 500      continue
c     error : too many constants!
          if (i.ge.mconst) then
             call warn(3,encerr //' too many constants.')
             return
          end if
          istr = isave
c
c# end constants
c# math operations
c   parens and comma
       elseif (str1.eq.'(') then
          itemp(ieqn)  = ileft
          iparen = iparen + 1
       elseif (str1.eq.')') then
          itemp(ieqn)  = iright
          iparen = iparen - 1
       elseif (str1.eq.',') then
          itemp(ieqn)  = icomma
c two component math
       elseif ((str1.eq.'+').or.(str1.eq.'-')) then
          itemp(ieqn) = iadd
          if (str1.eq.'-') itemp(ieqn) = isub
          if ( (straft.eq.')')) then
             call echo(synerr//strout)
             call warn(2,
     $            '  "+)"  and "-)" are not correct syntax.')
             return
          end if
       elseif ((str1.eq.'/').or.(str1.eq.'*')) then
          itemp(ieqn) = imul
          if (str1.eq.'/') itemp(ieqn) = idiv
          ibefr = index('(+-/*^,',strbfr)
          iaftr = index(')*/^,',straft)

          if ( (istr.eq.1).or.(istr.eq.ilen).or.(iaftr.ne.0)
     $         .or.(ibefr.ne.0)) then
             call echo(synerr//strout)
             if (ibefr.ne.0)  errmsg = 'preceded by one of "+-/*^,("'
             if (iaftr.ne.0)  errmsg = 'followed by one of "/*^,)"'
             if (istr.eq.1)   errmsg = 'occurs first'
             if (istr.eq.ilen) errmsg = 'occurs last'
             call warn(2,'      "/" or "*" '//errmsg)
             return
          end if
       elseif (str1.eq.'^') then
          ibefr = index('(+-/*^,',strbfr)
          iaftr = index(')*/^,',straft)
          itemp(ieqn) = iy2x
          if ( (istr.eq.1).or.(istr.eq.ilen).or.(iaftr.ne.0)
     $         .or.(ibefr.ne.0)) then
             call echo(synerr//strout)
             if (ibefr.ne.0) errmsg = 'preceded by one of "+-/*^,("'
             if (iaftr.ne.0) errmsg = 'followed by one of "/*^,)"'
             if (istr.eq.1)  errmsg = 'occurs first'
             if (istr.eq.ilen) errmsg = 'occurs last'
             call warn(2,'      "^" '//errmsg)
             return
          end if
c
c math functions (one-, and two-component, and special functions)
c    the operator must be followed by '(', or the expression will
c    be a variable name:  ln2 is a variable !
       elseif ((strfcn.ne.' ').and.(isafcn.eq.1)) then
          itemp(ieqn) = ienfcn(strfcn)
          if (itemp(ieqn).eq.0) then
             ilen = istrln(strfcn)
             errmsg = 'unknown function: '//strfcn(1:ilen)//
     $            ' : cannot parse expression'
             call warn(2,errmsg)
             return
          endif
          istr        = istr + nxfcn
          ieqn        = ieqn + 1
          itemp(ieqn) = ileft
          iparen      = iparen + 1
c# end math operations
c# variables
c  end with blank or math symbol from character string opera
       else
          do 750 i = istr, ilen
             str1 = string(i:i)
             if (index(opera,str1).ne.0) go to 760
 750      continue
 760      continue
c find which variable it is:
          ivarln = i - 1
          if (ivarln.le.istr) ivarln = istr
c check if variable name is valid
          if (isvnam(string(istr:ivarln),-1)) then
             isvect = (index(string(istr:ivarln),'.').gt.0)
c if it's array name, find out which array it is
             if (isvect) then
                itemp(ieqn) = iofarr(string(istr:ivarln),prefix,0,1)
             else
                itemp(ieqn) = iofsca(string(istr:ivarln),1) + jscale
             end if
             if (itemp(ieqn).le.0)  then
                call echo(encerr)
                call warn(3,' too many variables declared.')
                return
             end if
             istr = ivarln
          else
             call echo(synerr  //'invalid variable name')
             call warn(2,' --> '// strout(istr:ivarln) )
             return
          endif
c# end parsing and encoding, go back to line 300 for more
       end if
       go to 300
c
 4000  continue
c
c  more error checking :
c  paren count
       if (iparen.ne.0) then
          call echo(synerr//strout(1:ilen))
          call warn(2,' parentheses are not matched ')
          return
       end if

c       call rpndmp(itemp)
c       do i = 1, micode
c          if (itemp(i).ne.0) print*, itemp(i)
c       enddo
       call enchk(strout, itemp, ieqn, ierr)
       encod = ierr
       if (ierr.gt.0) then
          call set_status(2)
          return
       endif

c----
c  rewrite itemp to reverse polish notation
c  then load up icode, and we're all done.
       do 4700 i = 1, micode
          jcode(i) = itemp(i)
 4700  continue 
       call engrpn(jcode, itemp)

       if (itemp(micode).ne.0) then
          call echo(mtherr//'too many objects in math expression!')
          call echo( '     '//strout(1:ilen))
          call warn(3,'   please break up expression.')
       else 
          do 4900 i = 1, micode
             icode(i) =  itemp(i)
 4900     continue
       end if
c prepare output :
c   if we have extra closing parens (and the paren never goes to zero)
c   trim off the outer parens before returning string
       string = strout
       ilen  = istrln(string)
       if ((string(1:1).eq.'(').and.(string(ilen:ilen).eq.')')) then
          ipar = 1
          dotrim = .true.
          do 5300 i = 2, ilen-2
             str1 = string(i:i)
             if (str1.eq.'(')  ipar = ipar + 1
             if (str1.eq.')')  ipar = ipar - 1
             if (ipar.le.0) goto 5350
 5300     continue 
          string = string(2:ilen-1)
 5350     continue 
       endif
c end subroutine encod
       end

       subroutine finmsg(ikey, str1, str2, i1)
c  error messages from feffit
       integer        ikey, i1, ilen
       character*(*)  str1, str2,lblnk*12,messg*80,s1tmp*90,s2tmp*90
       character*35   inperr, fterr, callme, warn, daterr,fferr,chkerr
       parameter (inperr = '>>error reading input file')
       parameter (chkerr = '>>error in math expressions')
       parameter (daterr = '>>error reading data file')
       parameter (fferr  = '>>error reading feff file')
       parameter (fterr  = '>>feffit error')
       parameter (warn   = '>>feffit warning')
       parameter (callme = 'program error: contact matt')
       parameter (lblnk  = '      ')

       s1tmp = ' '
       s2tmp = ' '
       if (str1.ne.' ') s1tmp = str1
       ilen1 = min(65,max(1,istrln(s1tmp)))
       if (str2.ne.' ') s2tmp = str2
       ilen2 = min(65,max(1,istrln(s2tmp)))

 11    format(a,i4)
 12    format(2a,i4)

       if (i1.lt.0) then
          call echo(lblnk//warn)
       else
          messg = fterr
          if ((ikey.ge.2000).and.(ikey.lt.3000)) messg = inperr
          if ((ikey.ge.3000).and.(ikey.lt.3200)) messg = daterr
          if ((ikey.ge.3200).and.(ikey.lt.3500)) messg = chkerr
          if ((ikey.ge.7000).and.(ikey.lt.8000)) messg = fferr
          call echo(lblnk//messg(1:65))
       end if
       if (ikey.eq.0) then
          call echo(lblnk//'feffit died')
       elseif (ikey.eq.1001) then
          call echo(lblnk//'could not find file: '//s1tmp(:ilen1))
       elseif (ikey.eq.1002) then
          call echo(lblnk//'error opening file: '//s1tmp(:ilen1))
       elseif (ikey.eq.1003) then
          call echo(lblnk//'error reading file: '//s1tmp(:ilen1))
c from fitinp (all fatal)
       elseif (ikey.eq.2100) then
          write(messg,11) 'too many named values! current limit is',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.2105) then
          write(messg, 12) 'too many "local" ',
     $      'user-defined values! current limit is ', i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.2110) then
          call echo('this named value '//
     $      'was assigned as both "local" and "global":')
          call echo(lblnk//s2tmp(1:ilen2))
       elseif (ikey.eq.2120) then
          call echo(lblnk//'error encoding the math expression :')
          call echo(lblnk//'  --> '//s2tmp(:ilen2))
       elseif (ikey.eq.2130) then
          write(messg,12) 'too many variables! ',
     $         'current limit is ', i1
          ilen = istrln(messg)
          call echo( '       '//messg(1:ilen))
       elseif (ikey.eq.2140) then
          write(messg,12) 'too many paths for a ',
     $         'data file! current limit is ',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
          messg = 'for data file: '//s2tmp(:ilen2)
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.2150) then
          write(messg,11) 'too many paths used. current limit is',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.2170) then
          write(messg,12) 'too many feffnnnn.dat ',
     $          'files used! current limit is ',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
          messg = 'file requested was '//s2tmp
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif(ikey.eq.2200) then
          call echo(lblnk//'a Path Index larger than '//
     $      '999 or less than 0 was found! ')
       elseif (ikey.eq.2220) then
          write(messg,11) 'too many data sets. current limit is',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.2300) then
          call echo(lblnk//'too many unknonwn keywords!')
          call echo(lblnk//'something wrong with the input file?')
       elseif (ikey.eq.2330) then
          messg = 'unknown keyword : "'//s2tmp(:ilen2)//
     $         '" at this line '
          ilen  = istrln(messg)
          call echo(lblnk//messg(1:ilen))
          call echo(lblnk//'line:  '//s1tmp(:ilen1))
          call echo(lblnk//'the rest of this line will be ignored')
c from fitdat
       elseif (ikey.eq.3010) then
          call echo(lblnk//'data appears to not be chi(k) data')
          call echo(lblnk//'check data file and consult manual')
       elseif (ikey.eq.3020) then
          call echo(lblnk//'too many variables while adding')
          call echo(lblnk//'adding background spline to fit')
          write(messg,11) 'current limit is',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.3040) then
          call echo(lblnk//'too many named values while adding')
          call echo(lblnk//'adding background spline to fit')
          write(messg,11) 'current limit is',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
c from fitchk
       elseif (ikey.eq.3200) then
          call echo(lblnk//'inconsistent number of variables')
          call echo(lblnk//'some variable is probably both'//
     $         ' "guessed" and "set".')
       elseif (ikey.eq.3220) then
          call echo(lblnk//'this variable name was used but '//
     $             'was not defined:' )
          call echo(lblnk//'  --> '//s1tmp(:ilen1))
       elseif (ikey.eq.3240) then
          call echo(lblnk//'the following value was defined but is')
          call echo(lblnk//'not used in any math expressions:')
          call echo(lblnk//'  --> '//s1tmp(:ilen1))
          call echo(lblnk//'this may cause problems with the fit.')
       elseif (ikey.eq.3300) then
          call echo(lblnk//'bad initial value for an XAFS parameter!')
          call echo(lblnk//'   for '//s1tmp(1:ilen1))
          call echo(lblnk//'       '//s2tmp(1:ilen2))
c from fitnls
       elseif (ikey.eq.3510) then
          call echo(lblnk//'more variables than measurements')
          call echo(lblnk//s1tmp(:ilen1))
       elseif (ikey.eq.3530) then
          call echo(lblnk//'fit gave an impossible error message.')
          call echo(lblnk//callme)
c from fitfun
       elseif (ikey.eq.3590) then
          call echo('routine fitfft failed internal test.')
          call echo(lblnk//callme)
c from fefinp
       elseif (ikey.eq.7010) then
          call echo(lblnk//s1tmp(:ilen1))
          call echo(lblnk//'bad data in feffnnnn.dat file')
       elseif (ikey.eq.7020) then
          write(messg,11) 'too many legs in path. current limit is',i1
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
          call echo(lblnk//s1tmp(:ilen1))
       elseif (ikey.eq.7050) then
          call echo(lblnk//'not enough room '//
     $         'to read all the data from this feff file')
          write(messg,'(a,i3,a)') 'results above k = ',
     $         -i1, ' will not be reliable'
          ilen = istrln(messg)
          call echo(lblnk//messg(1:ilen))
       elseif (ikey.eq.7510) then
          call echo(lblnk//s1tmp(:ilen1))
          call echo(lblnk//'bad data in feff.bin file')
c ??
       else
          write(messg,11) 'unknown error ',ikey
          ilen      = max(1, istrln(messg))
          call echo(lblnk//messg(1:ilen))
       endif
c for fitinp messages, write out last line from feffit.inp
       if ((ikey.ge.2100).and.(ikey.le.3000).and.(i1.ge.0)) then
          call echo(lblnk//'last line read successfully:')
          call echo(lblnk//s1tmp(:ilen1))
       endif
       if ((ikey.le.9999).and.(i1.ge.0))
     $      call fstop('feffit error')
       return
       end

       subroutine spline(energy, xmu, mxmu, xkstd, chistd, mstd,
     $      e0_in, rbkgin, r1stin, toler, nknots, 
     $      qmin, qmax, xkw, dk1, dk2, winnam, 
     $      stfind, fnorm, enor1, enor2, pre1, pre2, estep,
     $      lclmp1, xclmp1, lclmp2, xclmp2, nclmp,
     $      cnorm, fixstd, usestd, varye0, spstep,
     $      dofit, bkg, mxk, xk, chi)
c
c//////////////////////////////////////////////////////////////////////
c Copyright (c) 1997--2000 Matthew Newville, The University of Chicago
c Copyright (c) 1992--1996 Matthew Newville, University of Washington
c
c Permission to use and redistribute the source code or binary forms of
c this software and its documentation, with or without modification is
c hereby granted provided that the above notice of copyright, these
c terms of use, and the disclaimer of warranty below appear in the
c source code and documentation, and that none of the names of The
c University of Chicago, The University of Washington, or the authors
c appear in advertising or endorsement of works derived from this
c software without specific prior written permission from all parties.
c
c THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
c EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
c MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
c IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
c CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
c TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
c SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
c//////////////////////////////////////////////////////////////////////
c
c purpose: automated xafs background spline (the autobk algorithm)
c
c arguments:
c      energy   array of energy values                  [in]
c      xmu      array of xmu values                     [in]
c      mxmu     maximum array length of energy/xmu      [in]
c      xkstd    array of k values for standard          [in]
c      chistd   array of chi values for standard        [in]
c      mstd     maximum array length of xkstd/chistd    [in]
c      fixstd   l=flag for fixing amp of standard       [in]
c      usestd   l=flag for using standard at all        [in]
c      rbkgin   rbkg value (nyquist value)              [in/out]
c      toler    fitting tolerance                       [in/out]
c      nknots   number of knots in spline               [in/out]
c      qmin     low-k value for fft window              [in/out]
c      qmax     high-k value for fft window             [in/out]
c      xkw      k-weight for fft                        [in]
c      dk1      low-k value for fft window              [in]
c      dk2      low-k value for fft window              [in]
c      winnam   fft window type                         [in]
c      varye0   l=flag for varying e0 in fit            [in]
c      e0_in    energy origin                           [in/out]
c      stfind   l=flag for redefining estep             [in]
c      fnorm    l=flag for functional normalization     [in]
c      enor1    low-energy  range for post-step         [in]
c      enor2    high-energy range for post-step         [in]
c      pre1     low-energy  range for pre-edge          [in]
c      pre2     high-energy range for pre-edge          [in]
c      estep    edge-step, aka delta_xmu                [in/out]
c      dofit    l=flag for doing fit at all             [in]
c      bkg      array of mu0 values   (mxmu points)     [out]
c      mxk      maximum array length of xk/chi          [out]
c      xk       array of k values                       [out]
c      chi      array of chi values                     [out]
c
c notes:
c   1. for use in ifeffit: uses ifeffit include files
c   2. based on/related to suroutine autnls from autobk
c   3. not well tested with standard chi(k) data
c
c see documentation and code comments for more details
c
c requires:  include files  consts.h, spline.h, fft.h
c            splfun, lmdif1, cffti, qintrp, lintrp, polyft,
c            fitfft, window, sumsqr, nofx, echo, chrdmp
c
c
       implicit none
       double precision  energy(*), xmu(*), bkg(*), xkstd(*), chistd(*)
       double precision  xk(*), chi(*), enor1, enor2, e0_in, estep
       double precision  rbkgin, toler,qmin,qmax
       double precision  xkw,dk1,dk2, pre1, pre2, cnorm(*)
       integer mxmu, mxk, mstd, nknots, nx1
       logical fnorm, fixstd, usestd, varye0, stfind, dofit
       logical           lclmp1, lclmp2
       double precision  xclmp1, xclmp2
c
       include 'consts.h'
       include 'spline.h'
       include 'fft.h'
c
       integer lenwrk, loop, lminfo, iup, ilo, nnorm , iterp
       integer iwork(mtknot), nemin, nemax, nofx, nrfit, nclmp
       integer i, nr, iend,  ntest, ipos, nqmax, j
       parameter(lenwrk = 2*maxpts*mtknot + 20*mtknot + 2*maxpts   )
       character*80  messg, winnam*32
       double precision   work(lenwrk), fvect(2*maxpts), varys(mtknot)
       double precision   esplin(mtknot), bscoef(mtknot), thiq(maxpts)
       double precision   small, toldef, spstep, r1stin
       double precision   sumsqr, qmn, qmx, qknot, slope, offset
       double precision  e0tst, qmntst, qmxtst,  xtmp, qtmp, e0t, tmp
       parameter (small  = 1.d-10, toldef = 1.d-5)
       external splfun, nofx, sumsqr
       save
c
       nnorm  = 3
       if (toler .le. zero) toler = toldef
       spstep = min(20.d0, max(1.d-6, spstep))
       loop   = 0

       if (.not.wftset) then
          call cffti(maxfft, wfftc)
          wftset = .true.
       end if

       rbkg   = rbkgin
       r1st   = rbkg + r1stin
       if (rbkg .le. small) rbkg = one
       nrbkg  = 2 * int(1d-2 + (rbkg /rgrid))+ 2
       nr1st  = 2 * int(1d-2 + (r1st /rgrid))+ 2
       if (qmax .le. small) qmax = 0
c
c initialize bkgdat common block
       splqw = xkw
       nsplin = nknots
       nautbk = 0
       thefix = fixstd
       theory = usestd
       eevary = varye0 .and. theory
cc       print*, ' spline:  eevary, = ', eevary, theory
       step   = estep
       e0     = e0_in
       emin   = e0 + qmin**2 / etok
       emax   = e0 + qmax**2 / etok
       e0t    = e0
       de0    = 0
       thessq = one
       thebkg = one
       nxmu   = mxmu
       do 10 i = 1, maxpts
          endat(i)  = zero
          xmudat(i) = zero
          spldat(i) = zero
          chie(i)   = zero
          splfit(i) = zero
          splwin(i) = zero
 10    continue
       do 20 i = 1, nxmu
          endat(i)  = energy(i)
          xmudat(i) = xmu(i)
          spldat(i) = xmu(i)
 20    continue

c do xafsft window
c put standard chi(k) on an absolute q-grid, and do fft
       if (mstd.gt.0) then
          nqmax = int( xkstd(mstd) / qgrid)
          ipos  = 1
          do 30 i = 1, nqmax
             qtmp = qgrid * (i-1)
             call qintrp(xkstd, chistd, mstd, qtmp, ipos, thiq(i))
 30       continue
       end if
c
 100   continue
       lminfo = 0
       loop   = loop + 1
c
c----start fitting:
       do 120 i = 1, nxmu
          bkg(i) = spldat(i)
 120   continue
c
       clamp(1)  = lclmp1
       clamp(2)  = lclmp2
       sclamp(1) = xclmp1
       sclamp(2) = xclmp2
       nclamp    = nclmp
cc       print*,' clamps: ', clamp, sclamp, nclamp
c
c  initialize fvect and work arrays for lmdif1

       nrfit = nrbkg
       if (theory)   nrfit = nr1st
       if (clamp(1)) nrfit = nrfit + nclamp
       if (clamp(2)) nrfit = nrfit + nclamp
       do 210 i =1, nrfit
          fvect(i) = zero
 210   continue
       do 220 i =1, lenwrk
          work(i) = zero
 220   continue
       do 240 i =1, mtknot
          iwork(i)  = 0
          varys(i)  = zero
          esplin(i) = zero
          bscoef(i) = zero
 240   continue
c
c  e0-shift:  e0, emin, and emax
       if (abs(de0).gt.1d-3) then
          e0t  = e0t  + de0
          emin = emin + de0
          emax = emax + de0
       end if
c
       if (emax.le.emin) emax = energy(nxmu)
       nemin = nofx(emin,energy,nxmu)
       nemax = nofx(emax,energy,nxmu)
       emin  = max(e0t, energy(nemin))
       emax  = max(emin, energy(nemax))
c
c  evaluate energies for the spline variables:
c  - emin and emax are not relative to the edge
c  - energy contains the input energy values, not relative to the edge.
       qmin   = sqrt(etok* abs(emin - e0t) )
       qmax   = sqrt(etok* (emax - e0t) )
c
c calculate number of independent points in r-space
       if (nsplin.le.1)
     $      nsplin = 2 * int(rbkg * (qmax - qmin)/ pi)  +  1
       nsplin = min(mtknot-5, max(5,nsplin))
       nknots = nsplin
cc       print*, ' SPLINE ', rbkg, nsplin

c  initialize energy values through which the first guess for the
c  spline must go (evenly spaced in q), and get the initial value
c  for the spline value at this point. we'll also get the initial
c  guesses for the variables (the b-spline coefficients) from this
c  initial spline.
       do 300 i = 1, nsplin
          qtmp      = qmin + (i-1)*(qmax-qmin)/(nsplin - 1)
          xtmp      = e0t + ( qtmp**2 / etok )
          j         = nofx(xtmp,energy,nxmu)
          esplin(i) = energy(j)
          iup       = min(nxmu, j + 5)
          ilo       = max(1,    j - 5)
          bscoef(i) = (2*spldat(j)+ spldat(iup)+spldat(ilo))/4
300    continue
       esplin(nsplin) = one + esplin(nsplin)
c the first and last korder knots in the b-spline are nearly degenerate at
c the endpoints. spstep sets the spacing between these points.  the
c default is one -- this may help eliminate "spikes" at the endpoints.
c since each knot represents a place where a derivative can break,
c  having all four of these at one place allows a complete break from
c at this point. by moving a few of the knots just off the ends, the
c spline is a little bit stiffer at the endpoints.
cc       print*, ' spline : ', spstep, korder
       do 310 i = 1, korder
           eknot(i)        = esplin(1)      - spstep * (korder-i-1)
           eknot(nsplin+i) = esplin(nsplin) + spstep * i
310    continue
       qmn       = sqrt( etok* abs(esplin(1) - e0t) )
       if (e0.lt.esplin(1))  qmn = zero
       qmx = sqrt( etok* (esplin(nsplin) - e0t) )
       do 320 i = korder+1, nsplin
           qknot    = (i-korder)*(qmx - qmn)/(nsplin-korder+1)
           eknot(i) = esplin(1) + qknot**2/etok
320    continue
c
c    determine the knots for the spline:
c    knots are points at which the spline has extra freedom.
       if ( (korder.lt.3).or.(nsplin.lt.korder) ) then
          call warn(2,
     $         ' spline error: not enough data to create spline.')
          return
       end if
c  the b-spline coefficients will be the variables in the fit,
c  the above estimates for the elements of bscoef are good enough
c  especially when the spline values are smoothed for the initial
c  guesses in the fit, as below.
       varys(1) = (3*bscoef(1) + bscoef(2))/ 4
       varys(nsplin) = (3*bscoef(nsplin) + bscoef(nsplin-1))/ 4
       do 380 i = 2, nsplin-1
          varys(i) =  (bscoef(i-1) + 2*bscoef(i) + bscoef(i+1) )/4
 380   continue
       nautbk = nsplin
c
c set up window function
       call window(winnam,dk1,dk2,qmin,qmax,qgrid,maxpts,splwin)
c  if a theory file is used, do its fft now
c  and add another variable if e0 is to be shifted
       if (theory) then
          if (eevary) then
             nautbk        = nautbk + 1
             varys(nautbk) = de0
          end if
          nr  = nrbkg
          call fitfft(thiq, maxpts, maxfft, wfftc, qgrid,
     $         splwin, splqw, bkg, zero, 1, 0, zero, r1st,
     $         nr, splfit)
          thessq = max(small, sumsqr(splfit(nrbkg),nr1st))
          thebkg = thessq
cc          print*, ' spline.f: thebkg = ', thebkg
cc          print*, '   nrbkg, nr1st   = ', nrbkg, nr1st, nr
          nautbk        = nautbk + 1
          varys(nautbk) = thessq
cc
          if (nr.ne.nr1st)  then
             call warn(3,' spline error: fitfft is broken' )
             return
          end if
       end if
c
       if (eevary) then
          call chrdmp(' spline: fitting background and e0 ... ')
       else
          call chrdmp(' spline: fitting background ... ')
       end if
c
       lminfo = 1
       if (dofit) then
          call lmdif1 (splfun, nrfit, nautbk, varys, fvect,
     $         toler, lminfo, iwork, work, lenwrk)
          call echo(' done.')
          call lm_err(lminfo,toler)
       end if
c
c  if an energy shift was done, the q values may be slightly off, so that
c  the number of independent points changes.  if so, re-do the fit until
c  e0 is stable to 0.5 eV, up to 5 times
       e0tst   = e0 + de0
       qmntst  = sqrt(etok* abs(emin - e0tst ) )
       qmxtst  = sqrt(etok* abs(emax - e0tst ) )
       if (e0tst.le.emin)    qmntst   = zero
       ntest   = 2 * int ( rbkg * abs(qmxtst - qmntst) / pi)  + 1
       ntest   = min(mtknot-5, max(5,ntest))
c
       if ((loop.le.5).and.eevary.and.(ntest.ne.nsplin) ) then
          call echo(' spline warning:  e0 was shifted enough that')
          call warn(1, ' the # of knots in the spline changed'//
     $         ' and the fit should be re-done.')
          go to 100
       end if
c
c  now that we have a good spline, we may want to improve the estimate
c  of the edge-step. so do a parabolic extrapolation of the background
c  spline to the edge energy value, which is probably better than
c  getting the edge step from a linear extrapolation of the xmu data.
c redo function evaluation with the final values for everything.
       call splfun(nrfit, nautbk, varys, fvect, iend)
       if (stfind.and.(.not.fnorm)) then
          call echo(' spline: finding edge_step from bkg(E)')
          call preedg(.false.,.true.,nxmu, endat, bkg, e0,
     $         pre1, pre2, enor1, enor2, nnorm,
     $         step, slope, offset,cnorm)
          estep = step
       end if
c redo function evaluation with the final values for everything.
       call splfun(nrfit, nautbk, varys, fvect, iend)
       if (eevary)  then
          e0    = e0_in + de0
          e0_in = e0
       end if
       do 830 i = 1, nxmu
          bkg(i) = spldat(i)
 830   continue

c set chi array
       call chie2k(endat,chie,nxmu,e0, mxk,xk,chi)
c       print*, 'MM end of spline ', endat(1), endat(2),
c     $      chie(1), chie(2), xk(1), xk(2),
c     $      chi(1), chi(2), nxmu, e0, mxk 
c end  subroutine spline
       return
       end

       double precision function decod(icode, ni,
     $      consts, values, defval)
c
c  copyright 1993 .. 1997 matt newville
c
c   this decodes the icode array, inserting the values in consts,
c   and values when necessary, and returns the real value of the
c   calulated pararmeter.
c   the default value, defval, will be returned if icode is empty.
c
c  input:
c    icode    integer array containing code for the math expression
c    ni       length of icode
c    consts   real array of the constant numerical values
c    values   real array containing the variable values
c    defval   default value for the parameter
c  output:
c    decod    real number calculated from integer code in icode
c---------------------------------------------------------------------
       integer  mstack, ierr, iplace, istack, ic, i, ni
       double precision f1mth, f2mth, zero, cordby, einsdw, einval
       integer  jconst, icode(ni)
       parameter(mstack=  32, jconst = 8192, zero = 0.)
       double precision  consts(*), values(*), x(mstack), defval
       integer  iexp, ilog, isqrt, isin, icos, itan, iabs, ineg
       integer  iasin, iacos, iatan, isinh, icosh, itanh, icoth
       integer  iadd, isub, imul, idiv, iy2x
       integer  jadd, jsub, jmin, jmax, jdebye, jeins, jeins2
       parameter(iexp  = -10, ilog  = -11, isqrt = -12,
     $           isin  = -13, icos  = -14, itan  = -15,
     $           iasin = -16, iacos = -17, iatan = -18,
     $           iabs  = -19, ineg  = -20, isinh = -23,
     $           icosh = -24, itanh = -25, icoth = -26,
     $           iadd  = -50, isub  = -51, imul  = -52,
     $           idiv  = -53, iy2x  = -54, jadd  =-111,
     $           jsub  =-112, jmin  = -85, jmax  = -86,
     $           jdebye=-120, jeins =-121, jeins2=-122)
       external  f1mth, f2mth, cordby, einsdw, einval
c
c  return default value if icode is empty
       decod = defval
       if (icode(1).eq.0)  return
c  initialize stack
       do 20 i = 1, mstack
          x(i) = zero
 20    continue
       ierr   = 0
       iplace = 0
       istack = 0
c  interpret next object, do operations, and manage stack
c                hold place in icode array with iplace
 100   continue
       iplace = iplace + 1
       if (iplace.gt.ni) ierr = 2
       ic = icode(iplace)
       if (ic.eq.0) return
c  if number, then push everything in stack
       if (ic.ge.1) then
          istack = istack + 1
          if (istack.ge.mstack) ierr = 1
          do 200 i = istack, 2, -1
             x(i) = x(i-1)
 200      continue
          if (ic.le.jconst) x(1) = values(ic)
          if (ic.gt.jconst) x(1) = consts(ic - jconst)
c  one-component math:  overwrite x(1), no change to rest of the stack
       elseif ( (ic.le.-10).and.(ic.ge.-49)) then
          x(1) = f1mth(x(1),ic,ierr)
c  two-component math:  overwrite x(1), drop x(2), drop stack by 1
       elseif ( (ic.le.-50).and.(ic.ge.-99)) then
          x(1) =  f2mth( x(1),x(2),ic,ierr)
          call stack(x,istack,1)
c  special math operations:
c    each has its own external function call, and stack size.
c      : debye( x(2), x(1))
       elseif (ic.eq.jdebye) then
          x(1) =  cordby(x(2), x(1), ierr)
          call stack(x,istack,1)
c      : eins( x(2), x(1))
       elseif (ic.eq.jeins) then
          x(1) =  einsdw(x(2), x(1), ierr)
          call stack(x,istack,1)
c      : eins2( x(3), x(2), x(1))
       elseif (ic.eq.jeins2) then
          x(1) =  einval(x(3), x(2), x(1))
          call stack(x,istack,2)
       else
          ierr = 3
       end if
c  done: if there were no errors, update decod and go to next object
       if (ierr.eq.0) then
          decod = x(1)
          go to 100
       end if
c  error handling: can only get here if (ierr.ne.0)
       decod  = zero
       if (ierr.eq.ilog) then
          call echo(' math error: log(x) must have x > 0')
       elseif (ierr.eq.isqrt) then
          call echo(' math error: sqrt(x) cannot have x < 0')
       elseif (ierr.eq.iasin) then
          call echo(' math error: asin(x) must have (-1 < x < 1)')
       elseif (ierr.eq.iacos) then
          call echo(' math error: acos(x) must have (-1 < x < 1)')
       elseif (ierr.eq.idiv) then
          call echo(' math error: divide by 0')
       elseif (ierr.eq.iy2x) then
          call echo(' math error: invalid exponentiation')
       elseif (ierr.eq.jdebye) then
          call echo(' math error: error using "debye" function')
          call echo('      could not find a path index to use!')
       elseif (ierr.eq.jeins) then
          call echo(' math error: error using "eins" function')
          call echo('      could not find a path index to use!')
       elseif (ierr.eq.1) then
          call echo(' decoding error: exceeded stack size!')
       elseif (ierr.eq.2) then
          call echo(' decoding error: too many objects!')
       elseif (ierr.eq.3) then
          call echo(' decoding error: unknown operation!')
       else
          call echo(' decoding error: unknown error!')
       end if
       if (ierr.gt.0) call fstop(' decoding error')
       return
c  end function decod
       end
       double precision function f1mth( x, iop, ierr)
c
c  copyright 1993  university of washington      matt newville
c
c one component math. if any tests are failed, x is returned.
c iop is an integer indication of which operation to perform.
c
       double precision   x, zero, one, expmax
       logical     error
       integer     iop, ierr
       integer     iexp, ilog, isqrt, isin, icos, itan, iabs, ineg
       integer     iasin, iacos, iatan, isinh, icosh, itanh, icoth
       parameter ( iexp  = -10, ilog  = -11, isqrt = -12,
     $             isin  = -13, icos  = -14, itan  = -15,
     $             iasin = -16, iacos = -17, iatan = -18,
     $             iabs  = -19, ineg  = -20, isinh = -23,
     $             icosh = -24, itanh = -25, icoth = -26  )
       parameter (zero = 0.d0, one = 1.d0, expmax = 50.d0)
       ierr  = 0
       error = .false.
       f1mth = zero
       if (iop.eq.iexp) then
          f1mth = exp( max( -expmax, min(x, expmax) ) )
       elseif (iop.eq.ilog) then
          if  ( x.gt.zero ) then
             f1mth = log(x)
          else
             error = .true.
          end if
       elseif (iop.eq.isqrt) then
          if  ( x.ge.zero) then
             f1mth = sqrt(x)
          else
             error = .true.
          end if
       elseif (iop.eq.iabs)  then
          f1mth = abs(x)
       elseif (iop.eq.ineg)  then
          f1mth = - x
       elseif (iop.eq.isin)  then
          f1mth = sin(x)
       elseif (iop.eq.icos)  then
          f1mth = cos(x)
       elseif (iop.eq.itan)  then
          f1mth = tan(x)
cc       elseif (iop.eq.icot)  then
cc          f1mth = one / max( small, tan(x) )
       elseif (iop.eq.iasin) then
          if (dabs(x).le.one) then
             f1mth = asin(x)
          else
             error = .true.
          end if
       elseif (iop.eq.iacos) then
          if (dabs(x).le.one) then
             f1mth = acos(x)
          else
             error = .true.
          end if
       elseif (iop.eq.iatan) then
          f1mth = atan(x)
       elseif (iop.eq.itanh) then
          f1mth = tanh(  max(-expmax, min(x, expmax)) )
       elseif (iop.eq.icoth) then
          f1mth = one / tanh(  max(-expmax, min(x, expmax)) )
       elseif (iop.eq.icosh) then
          f1mth = cosh(  max(-expmax, min(x, expmax)) )
       elseif (iop.eq.isinh) then
          f1mth = sinh(  max(-expmax, min(x, expmax)) )
       else
          f1mth = x
       end if
       if (error) ierr = iop
       return
c end function f1mth
       end
       double precision  function f2mth( x, y, iop, ierr)
c
c  copyright 1993  university of washington      matt newville
c
c two component math.
c if ( (negative number)**(fraction)) is requested, x is returned.
c
c iop is an integer indication of which operation to perform.
c if iop = 0, then x is returned.
       double precision x, y, zero, one, fifty, xtmp, test
       integer   ierr, iadd, isub, imul, idiv, iy2x, iop, newx
       integer   jmin, jmax
       parameter ( iadd = -50, isub = -51, imul  = -52)
       parameter ( idiv = -53, iy2x  = -54 )
       parameter ( jmin  = -85, jmax  = -86)
       parameter ( zero = 0.d0, one = 1.d0, fifty = 50.d0)
       ierr  = 0
       f2mth = zero
       if (iop.eq.0) then
          f2mth = x
       elseif (iop.eq.iadd) then
          f2mth = y + x
       elseif (iop.eq.isub) then
          f2mth = y - x
       elseif (iop.eq.imul) then
          f2mth = y * x
       elseif (iop.eq.jmin) then
          f2mth = min(y, x)
       elseif (iop.eq.jmax) then
          f2mth = max(y, x)
       elseif (iop.eq.idiv) then
          if (x.eq.zero)  then
             f2mth = zero
             ierr  = iop
          else
             f2mth = y / x
          end if
       elseif (iop.eq.iy2x) then
          newx = int(x)
          xtmp = float(newx)
          if (x.eq.zero)  then
             f2mth = one
          elseif ( (y.eq.zero).and.(x.gt.zero))  then
             f2mth = zero
          elseif (y.gt.zero)  then
             test  = x * log(y)
             if (test.gt.fifty) then
                f2mth = exp(fifty)
             elseif (test.lt.(-fifty)) then
                f2mth = exp(-fifty)
             else
                f2mth = y**x
             end if
          elseif ( (y.lt.zero).and.(xtmp.eq.x)) then
             test  = xtmp * log(-y)
             if (test.gt.fifty) then
                f2mth = exp(fifty)
             elseif (test.lt.(-fifty)) then
                f2mth = exp(-fifty)
             else
                f2mth = y**newx
             end if
          else
             f2mth = zero
             ierr  = iop
          end if
       end if
       return
c end function f2mth
       end
       subroutine stack(xstack,istack,ipop)
c
c   copyright 1993  university of washington      matt newville
c   drop the stack held in x by idrop. (ipop = 1 for 2 component math)
       double precision   xstack(*)
       integer istack, ipop, i
       istack   = istack - ipop
       do 100 i = 2, istack
          xstack(i)  = xstack(i + ipop)
 100   continue
       do 120 i = istack + 1, istack + ipop
          xstack(i)  = 0.d0
 120   continue
       return
c  end subroutine stack
       end

@echo off
REM
REM  set this to point to your installation directory
SET IFEFFIT_DIR=C:\IFEFFIT


REM  Should be no need to edit past this line:

SET IFEFFIT_EXE=ifeffit10.exe
SET PATH=%PATH%;%IFEFFIT_DIR%
SET PGPLOT_DIR=%IFEFFIT_DIR%
SET PGPLOT_DEV=/GW

CD %IFEFFIT_DIR%
%IFEFFIT_DIR%\%IFEFFIT_EXE%

gcc  -Wl,-framework -Wl,Foundation -bundle -framework Python \
build/temp.darwin-7.3.0-Power_Macintosh-2.3/ifeffit_wrap.o \
-o build/lib.darwin-7.3.0-Power_Macintosh-2.3/_ifeffit_1.so \
-L/Applications/Ifeffit/lib -lifeffit -lpgplot_iff  -lpng_iff -lz_iff -laquaterm \
-L/usr/X11R6/lib -lX11 -L/sw/lib -L/usr/lib  -lfrtbegin -lg2c -lgcc -lSystem


gcc  -Wl,-framework -Wl,Foundation  -bundle -framework Python \
build/temp.darwin-7.3.0-Power_Macintosh-2.3/ifeffit_wrap.o \
-L/Applications/Ifeffit/lib -L/Applications/Ifeffit/pgplot \
-L/sw/lib -L/usr/lib -L/usr/X11R6/lib -lifeffit -lpgplot_iff \
-lpng_iff -lz_iff -laquaterm -lg2c -lgcc -lX11 -lfrtbegin -lg2c -lgcc -lSystem \
-o build/lib.darwin-7.3.0-Power_Macintosh-2.3/_ifeffit.so
